//
//	Pelistina on Cocoa - PoCo -
//	Application 
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

//  class 
@class PoCoPreferencesPanel;
@class PoCoNewDocumentPanel;

@class PoCoSubViewWindow;
@class PoCoToolbarWindow;
@class PoCoPaletteWindow;
@class PoCoColorPatternWindow;
@class PoCoLayerWindow;
@class PoCoPenStyleWindow;
@class PoCoInformationWindow;

@class PoCoControllerFactory;
@class PoCoGlobalObserver;
@class PoCoEditInfo;
@class PoCoPenStyle;
@class PoCoPenSteadyStyle;
@class PoCoTilePattern;
@class PoCoTileSteadyPattern;

// ----------------------------------------------------------------------------
@interface PoCoAppController : NSObject {
    BOOL willFinish_;                   // λ椫

    // ѥͥδ instance ѿ
    PoCoPreferencesPanel *preferencesPanel_;  // Ķ
    PoCoNewDocumentPanel *newDocumentPanel_;  // 

    // ƥɥδ instance ѿ
    PoCoSubViewWindow *subViewWindow_;            // 
    PoCoToolbarWindow *toolbarWindow_;            // ġС
    PoCoPaletteWindow *paletteWindow_;            // ѥå
    PoCoColorPatternWindow *colorPatternWindow_;  // 顼ѥ
    PoCoLayerWindow *layerWindow_;                // 쥤䡼
    PoCoPenStyleWindow *penStyleWindow_;          // ڥ
    PoCoInformationWindow *informationWindow_;    // Խ

    // Խ
    PoCoControllerFactory *factory_;

    // μ
    PoCoGlobalObserver *observer_;

    // Խ(application )
    PoCoEditInfo *editInfo_;

    // ڥ(application )
    PoCoPenStyle *penStyle_;
    PoCoPenSteadyStyle *penSteadyStyle_;

    // ѥ(application )
    PoCoTilePattern *tilePattern_;
    PoCoTileSteadyPattern *tileSteadyPattern_;
}

// 
+(void)initialize;

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// untitled window ޻
-(BOOL)applicationShouldOpenUntitledFile:(NSApplication *)sender;

// nib ɤ߹ޤ줿
-(void)awakeFromNib;

// ץꥱ󤬽λ
-(void)applicationWillTerminate:(NSNotification *)note;

// ˥塼򹹿
-(BOOL)validateMenuItem:(NSMenuItem *)menu;

// ġС
-(PoCoToolbarWindow *)toolbarWindow;

// 
-(IBAction)newWindowForTab:(id)sender;

// ץꥱζ̾μ
-(BOOL)noFinishProc;                          // λǤϤʤ
-(PoCoControllerFactory *)factory;            // Խμ
-(PoCoEditInfo *)editInfo;                    // Խμ
-(PoCoPenStyle *)penStyle;                    // ڥμ
-(PoCoPenSteadyStyle *)penSteadyStyle;        // ڥμ
-(PoCoTilePattern *)tilePattern;              // ѥμ
-(PoCoTileSteadyPattern *)tileSteadyPattern;  // 勵ѥμ

// ƥɥγ
-(IBAction)showPreferencesPanel:(id)sender;
-(IBAction)showNewDocumentPanel:(id)sender;
-(IBAction)showSubViewWindow:(id)sender;
-(IBAction)showPaletteWindow:(id)sender;
-(IBAction)showPenStyleWindow:(id)sender;
-(IBAction)showLayerWindow:(id)sender;
-(IBAction)showInformationWindow:(id)sender;
-(IBAction)showToolbarWindow:(id)sender;
-(IBAction)showColorPatternWindow:(id)sender;
-(void)closedSubViewWindow;
-(void)closedPaletteWindow;
-(void)closedPenStyleWindow;
-(void)closedLayerWindow;
-(void)closedInformationWindow;
-(void)closedToolbarWindow;
-(void)closedColorPatternWindow;
-(void)subWindowHold:(BOOL)type;

// Խǽڤؤ
-(IBAction)changeFunction:(id)sender;
-(IBAction)changeDrawing:(id)sender;

// Խǽڤؤ
-(IBAction)continuesLine:(id)sender;
-(IBAction)flipPattern:(id)sender;
-(IBAction)useHandle:(id)sender;
-(IBAction)changePointMove:(id)sender;
-(IBAction)changePenSizeProp:(id)sender;
-(IBAction)changeDensityProp:(id)sender;
-(IBAction)normalTone:(id)sender;
-(IBAction)halfTone:(id)sender;
-(IBAction)changeAtomizerSkip:(id)sender;

// ڥ/ѥڤؤ
-(IBAction)nextPenStyle:(id)sender;
-(IBAction)prevPenStyle:(id)sender;
-(IBAction)nextPenSize:(id)sender;
-(IBAction)prevPenSize:(id)sender;
-(IBAction)nextTilePattern:(id)sender;
-(IBAction)prevTilePattern:(id)sender;
-(IBAction)changeDensity:(id)sender;

// ѥåԽ
-(IBAction)lockPalette:(id)sender;
-(IBAction)paletteDisclose:(id)sender;
-(IBAction)colorMixingRGB:(id)sender;
-(IBAction)colorMixingHLS:(id)sender;
-(IBAction)alternateColorSetting:(id)sender;
-(IBAction)createGradation:(id)sender;
-(IBAction)exchangeColor:(id)sender;
-(IBAction)pastePalette:(id)sender;

// 쥤䡼Խ
-(IBAction)addBitmapLayer:(id)sender;
-(IBAction)addStringLayer:(id)sender;
-(IBAction)deleteLayer:(id)sender;
-(IBAction)unificateLayer:(id)sender;

// 顼ѥϿ
-(IBAction)registorColorPattern:(id)sender;

// إ
-(IBAction)visitPoCoHomepage:(id)sender;
-(IBAction)visitPoCoManualPage:(id)sender;

@end
