//
//	Pelistina on Cocoa - PoCo -
//	Խ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

// ----------------------------------------------------------------------------
@interface PoCoEditInfo : NSObject {
    PoCoSelColor *selColor_;            // ο
    PoCoSelColor *oldColor_;            // ο

    PoCoColorMode colorMode_;           // 黻⡼
    BOOL lockPalette_;                  // ѥåȸ

    unsigned int penNumber_;            // ڥֹ
    unsigned int penSize_;              // ɮΥڥ礭(dot ñ)
    unsigned int tileNumber_;           // ѥֹ
    unsigned int density_;              // ǻپ(0.1% ñ)
    unsigned int pressure_;             // ݥ󥿥ץ쥹ɮ(0.1% ñ)

    PoCoPoint *pdPos_;                  // PD ()
    PoCoPoint *lastPos_;                // ǽ PD ()
    PoCoRect *pictureRect_;             // ()
    PoCoRect *viewRect_;                // ɽϰ()
    PoCoRect *pdRect_;                  // PD ϰ()
    PoCoRect *selRect_;                 // ϰ()

    PoCoDrawModeType  drawModeType_;    // 赡ǽ
    BOOL continuationType_;             // Ϣ³/Ϣ³
    BOOL flipType_;                     // ǻȿž
    PoCoPointModeType pointModeType_;   // 
    PoCoPenStyleType  penStyleType_;    // ڥ()
    BOOL enableUndo_;                   // ä(ä)
    BOOL enableEraser_;                 // äͭ
    BOOL eraserType_;                   // ä
    int undoMaxLevel_;                  // ä
    BOOL enableLiveResize_;             // LiveResize
    BOOL enableColorBuffer_;            // ݻ
    PoCoProportionalType sizePropType_; // ɮ
    PoCoProportionalType densityPropType_;  // ǻ٤ɮ
    PoCoAtomizerSkipType atomizerSkip_; // ̸᤭ΰưˡ
    BOOL atomizerType_;                 // ̸᤭μ
    BOOL selectionFill_;                // ΰɤĤ֤ɽ
    BOOL liveEditSelection_;            // ϰϤԽɽ
    BOOL withHandleSelection_;          // ϰϤΥϥɥ̵ͭ
    BOOL saveDocWindowPos_;             // 祦ɥ¸
    BOOL holdSubWindowPos_;             // ɥָ
    BOOL noOpenNewDocPanel_;            // ɥȥѥͥ򳫤ʤ
    PoCoScrollerType showScrollerView_; // view  scroller ɽ
    PoCoMainViewSupplement *supplement_;// 祦ɥɽ
    unsigned int previewQuality_;       // ץӥ塼ʼ
    unsigned int previewSize_;          // ץӥ塼礭
    BOOL grayToAlpha_;                  // Grascale Ʃ٤Ȥ
    PoCoInterpolationGuideView interGuide_; // ֶΥɥ饤ɽ
    PoCoCurveWithPointsType interType_; // ֶμ
    unsigned int interFreq_;            // ֶ
    int colorRange_;                    // ϰ
    BOOL syncSubView_;                  // ɽɥȤƱ
    BOOL syncPalette_;                  // 򿧤ȤƱ
}

// 
+(void)initialize;

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// ο
-(PoCoSelColor *)selColor;
-(PoCoSelColor *)oldColor;
-(BOOL)useUnderPattern;
-(void)setSelColor:(int)num;
-(void)setSelPattern:(int)num;
-(void)toggleUseUnderPattern;

// 黻⡼
-(PoCoColorMode)colorMode;
-(void)setColorMode:(PoCoColorMode)mode;
-(BOOL)lockPalette;
-(void)setLockPalette:(BOOL)type;

// ڥ
-(unsigned int)penNumber;
-(unsigned int)penSize;
-(void)setPenNumber:(unsigned int)num;
-(void)setPenSize:(unsigned int)size;

// ѥ/ǻ
-(unsigned int)tileNumber;
-(unsigned int)density;
-(void)setTileNumber:(unsigned int)num;
-(void)setDensity:(unsigned int)val;

// ɮϢ
-(unsigned int)pressure;
-(void)setPressure:(unsigned int)press;

// ɽִϢ
-(PoCoRect *)pictureRect;
-(PoCoRect *)pictureView;
-(void)setPictureRect:(PoCoRect *)r;
-(void)setPictureView:(PoCoRect *)r;

// PD ؼִϢ
-(PoCoPoint *)pdPos;
-(PoCoRect *)pdRect;
-(PoCoPoint *)lastPos;
-(void)setPDPos:(PoCoPoint *)p;
-(void)setPDRect:(PoCoRect *)r;
-(void)setLastPos:(PoCoPoint *)p;

// ϰϴϢ
-(PoCoRect *)selRect;
-(void)setSelRect:(PoCoRect *)r;

// ɽϢ
-(PoCoMainViewSupplement *)supplement;
-(void)setBackgroundColor:(unsigned int)col;
-(void)setPattern:(BOOL)flag;
-(void)setGridStep:(unsigned int)step;

// ֶϢ
-(PoCoInterpolationGuideView)interGuide;
-(PoCoCurveWithPointsType)interType;
-(unsigned int)interFreq;
-(void)setInterGuide:(PoCoInterpolationGuideView)type;
-(void)setInterType:(PoCoCurveWithPointsType)type;
-(void)setInterFreq:(unsigned int)val;

// ԽǽϢ
-(PoCoDrawModeType)drawModeType;
-(BOOL)continuationType;
-(BOOL)flipType;
-(PoCoPointModeType)pointModeType;
-(PoCoPenStyleType)penStyleType;
-(BOOL)enableUndo;
-(BOOL)enableEraser;
-(BOOL)eraserType;
-(int)undoMaxLevel;
-(BOOL)enableLiveResize;
-(BOOL)enableColorBuffer;
-(PoCoProportionalType)sizePropType;
-(PoCoProportionalType)densityPropType;
-(PoCoAtomizerSkipType)atomizerSkip;
-(BOOL)atomizerType;
-(BOOL)selectionFill;
-(BOOL)liveEditSelection;
-(BOOL)useHandle;
-(BOOL)saveDocWindowPos;
-(BOOL)holdSubWindowPos;
-(BOOL)noOpenNewDocPanel;
-(PoCoScrollerType)showScrollerView;
-(unsigned int)previewQuality;
-(unsigned int)previewSize;
-(BOOL)grayToAlpha;
-(int)colorRange;
-(BOOL)syncSubView;
-(BOOL)syncPalette;
-(void)setDrawModeType:(PoCoDrawModeType)type;
-(void)setContinuationType:(BOOL)type;
-(void)setFlipType:(BOOL)type;
-(void)setPointModeType:(PoCoPointModeType)type;
-(void)setPenStyleType:(PoCoPenStyleType)type;
-(void)setEnableUndo:(BOOL)type;
-(void)setEnableEraser:(BOOL)type;
-(void)setEraserType:(BOOL)type;
-(void)setUndoMaxLevel:(int)type;
-(void)setEnableLiveResize:(BOOL)type;
-(void)setEnableColorBuffer:(BOOL)type;
-(void)setSizePropType:(PoCoProportionalType)type;
-(void)setDensityPropType:(PoCoProportionalType)type;
-(void)setAtomizerSkip:(PoCoAtomizerSkipType)type;
-(void)setAtomizerType:(BOOL)type;
-(void)setSelectionFill:(BOOL)type;
-(void)setLiveEditSelection:(BOOL)type;
-(void)setUseHandle:(BOOL)type;
-(void)setSaveDocWindowPos:(BOOL)type;
-(void)setHoldSubWindowPos:(BOOL)type;
-(void)setNoOpenNewDocPanel:(BOOL)type;
-(void)setShowScrollerView:(PoCoScrollerType)type;
-(void)setPreviewQuality:(unsigned int)val;
-(void)setPreviewSize:(unsigned int)val;
-(void)setGrayToAlpha:(BOOL)flag;
-(void)setColorRange:(int)val;
-(void)setSyncSubView:(BOOL)flag;
-(void)setSyncPalette:(BOOL)flag;

@end
