//
//	Pelistina on Cocoa - PoCo -
//	Խ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoEditInfo.h"

#import "PoCoPalette.h"

// ѿ
static NSString *COLOR_MODE_NAME = @"PoCoSelectedColorModeType";
static NSString *PEN_NUMBER_NAME = @"PoCoSelectedPenNumber";
static NSString *PEN_SIZE_NAME = @"PoCoSetPenSize";
static NSString *TILE_PATTERN_NAME = @"PoCoSelectedTilePattern";
static NSString *DENSITY_NAME = @"PoCoSetDensityValue";
static NSString *DRAWMODE_NAME = @"PoCoDrawModeType";
static NSString *CONTINUATION_NAME = @"PoCoContinuationType";
static NSString *FLIP_NAME = @"PoCoFlipType";
static NSString *POINTMODE_NAME = @"PoCoPointModeType";
static NSString *DRAWPENSTYLE_NAME = @"PoCoPenStyleType";
static NSString *ENABLEUNDO_NAME = @"PoCoEnableUndo";
static NSString *ENABLEERASER_NAME = @"PoCoEnableEraser";
static NSString *UNDOMAXLEVEL_NAME = @"PoCoUndoMaxLevel";
static NSString *ENABLELIVERESIZE_NAME = @"PoCoEnableLiveResize";
static NSString *ENABLECOLORBUFFER_NAME = @"PoCoEnableColorBuffer";
static NSString *SIZEPROPTYPE_NAME = @"PoCoProportionalTypePenSize";
static NSString *DENSITYPROPTYPE_NAME = @"PoCoProportionalTypeDensity";
static NSString *ATOMIZERSKIPTYPE_NAME = @"PoCoAtomizerSkipType";
static NSString *ATOMIZERTYPE_NAME = @"PoCoAtomizerType";
static NSString *SELECTIONFILL_NAME = @"PoCoSelectionFillType";
static NSString *LIVEEDITSELECTION_NAME = @"PoCoLiveEditSelectionType";
static NSString *PALETTELOCK_NAME = @"PoCoPaletteLockType";
static NSString *WITHHANDLESELECTION_NAME = @"PoCoWithHandleSelectionType";
static NSString *SAVEDOCWINDOWPOS_NAME = @"PoCoSaveDocWindowPosType";
static NSString *HOLDDOCWINDOWPOS_NAME = @"PoCoHoldSubWindowPosType";
static NSString *NOOPENNEWDOCPANEL_NAME = @"PoCoNoOpenNewDocPanelType";
static NSString *SHOWSCROLLERVIEW_NAME = @"PoCoShowScrollerView";
static NSString *BACKGROUNDCOLOR_NAME = @"PoCoBackgroundColor";
static NSString *BACKGROUNDPATTERN_NAME = @"PoCoBackgroundPattern";
static NSString *PIXELGRIDSTEP_NAME = @"PoCoPixelGridStep";
static NSString *PREVIEWQUALITY_NAME = @"PoCoPreviewQuality";
static NSString *PREVIEWSIZE_NAME = @"PoCoPreviewSize";
static NSString *GRAYSCALETOALPHA_NAME = @"PoCoGrayscaleToAlpha";
static NSString *INTERGUIDE_VIEW_NAME = @"PoCoInterpolationGuideView";
static NSString *INTERPOLATION_TYPE_NAME = @"PoCoCurveWithPointsType";
static NSString *INTERPOLATION_FREQ_NAME = @"PoCoInterpolationFrequency";
static NSString *RANGEOFCOLOR_NAME = @"PoCoRangeOfColorNumber";
static NSString *SYNCSUBVIEW_NAME = @"PoCoSyncSubView";
static NSString *SYNCPALETTE_NAME = @"PoCoSyncPalette";

// ============================================================================
@implementation PoCoEditInfo

// ------------------------------------------------------------ class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    NSMutableDictionary *dic;

    dic = [NSMutableDictionary dictionary];

    // ƽͤ
    [dic setObject:[NSNumber numberWithInt:0]
            forKey:COLOR_MODE_NAME];
    [dic setObject:[NSNumber numberWithInt:0]
            forKey:PEN_NUMBER_NAME];
    [dic setObject:[NSNumber numberWithInt:16]
            forKey:PEN_SIZE_NAME];
    [dic setObject:[NSNumber numberWithInt:7]
            forKey:TILE_PATTERN_NAME];
    [dic setObject:[NSNumber numberWithInt:(100 * 10)]
            forKey:DENSITY_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoDrawModeType_FreeLine]
            forKey:DRAWMODE_NAME];
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:CONTINUATION_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:FLIP_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoPointModeType_PointHold]
            forKey:POINTMODE_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoPenStyleType_Normal]
            forKey:DRAWPENSTYLE_NAME];
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:ENABLEUNDO_NAME];
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:ENABLEERASER_NAME];
    [dic setObject:[NSNumber numberWithInt:100]
            forKey:UNDOMAXLEVEL_NAME];
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:ENABLELIVERESIZE_NAME];
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:ENABLECOLORBUFFER_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoProportionalType_Relation]
            forKey:SIZEPROPTYPE_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoProportionalType_Relation]
            forKey:DENSITYPROPTYPE_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoAtomizerSkipType_Always]
            forKey:ATOMIZERSKIPTYPE_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:ATOMIZERTYPE_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:SELECTIONFILL_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:LIVEEDITSELECTION_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:PALETTELOCK_NAME];
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:WITHHANDLESELECTION_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:SAVEDOCWINDOWPOS_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:HOLDDOCWINDOWPOS_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:NOOPENNEWDOCPANEL_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoScrollerType_default]
            forKey:SHOWSCROLLERVIEW_NAME];
    [dic setObject:[NSNumber numberWithInt:0xffcccccc]
            forKey:BACKGROUNDCOLOR_NAME];
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:BACKGROUNDPATTERN_NAME];
    [dic setObject:[NSNumber numberWithInt:0]
            forKey:PIXELGRIDSTEP_NAME];
    [dic setObject:[NSNumber numberWithInt:4]
            forKey:PREVIEWQUALITY_NAME];
    [dic setObject:[NSNumber numberWithInt:48]
            forKey:PREVIEWSIZE_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:GRAYSCALETOALPHA_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoInterpolationGuideView_Line]
            forKey:INTERGUIDE_VIEW_NAME];
    [dic setObject:[NSNumber numberWithInt:PoCoCurveWithPoints_Lagrange]
            forKey:INTERPOLATION_TYPE_NAME];
    [dic setObject:[NSNumber numberWithInt:2]
            forKey:INTERPOLATION_FREQ_NAME];
    [dic setObject:[NSNumber numberWithInt:0]
            forKey:RANGEOFCOLOR_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:SYNCSUBVIEW_NAME];
    [dic setObject:[NSNumber numberWithBool:NO]
            forKey:SYNCPALETTE_NAME];

    // default 
    [[NSUserDefaults standardUserDefaults] registerDefaults:dic];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function             : 
//    selColor_            : ο(instance ѿ)
//    oldColor_            : ο(instance ѿ)
//    colorMode_           : 黻⡼(instance ѿ)
//    lockPalette_         : ѥåȸ(instance ѿ)
//    penNumber_           : ڥֹ(instance ѿ)
//    penSize_             : ɮΥڥ(instance ѿ)
//    tileNumber_          : ѥ(instance ѿ)
//    density_             : ǻپ(instance ѿ)
//    pressure_            : ɮ(instance ѿ)
//    pdPos_               : PD ()(instance ѿ)
//    lastPos_             : ǽ PD ()(instance ѿ)
//    pictureRect_         : ()(instance ѿ)
//    viewRect_            : ɽϰ()(instance ѿ)
//    pdRect_              : PD ϰ()(instance ѿ)
//    selRect_             : ϰ()(instance ѿ)
//    drawModeType_        : 赡ǽ(instance ѿ)
//    continuationType_    : Ϣ³/Ϣ³(instance ѿ)
//    flipType_            : ǻȿž(instance ѿ)
//    pointModeType_       : (instance ѿ)
//    penStyleType_        : ڥ()(instance ѿ)
//    enableUndo_          : ä(instance ѿ)
//    enableEraser_        : äͭ(instance ѿ)
//    eraserType_          : ä(instance ѿ)
//    undoMaxLevel_        : ä(instance ѿ)
//    enableLiveResize_    : LiveResize(instance ѿ)
//    enableColorBuffer_   : ݻ(instance ѿ)
//    sizePropType_        : ɮ(instance ѿ)
//    densityPropType_     : ǻ٤ɮ(instance ѿ)
//    atomizerSkip_        : ̸᤭ΰưˡ(instance ѿ)
//    atomizerType_        : ̸᤭μ(instance ѿ)
//    selectionFill_       : ΰɤĤ֤ɽ(instance ѿ)
//    liveEditSelection_   : ϰϤԽɽ(instance ѿ)
//    withHandleSelection_ : ϰϤΥϥɥ̵ͭ(instance ѿ)
//    saveDocWindowPos_    : 祦ɥ¸(instance ѿ)
//    holdSubWindowPos_    : ɥָ(instance ѿ)
//    noOpenNewDocPanel_   : ɥȥѥͥ򳫤ʤ(instance ѿ)
//    showScrollerView_    : view  scroller ɽ(instance ѿ)
//    supplement_          : 祦ɥɽ(instance ѿ)
//    previewQuality_      : ץӥ塼ʼ(instance ѿ)
//    previewSize_         : ץӥ塼礭(instance ѿ)
//    grayToAlpha_         : Grascale Ʃ٤Ȥ(instance ѿ)
//    interGuide_          : ֶΥɥ饤ɽ(instance ѿ)
//    interType_           : ֶμ(instance ѿ)
//    interFreq_           : ֶ(instance ѿ)
//    colorRange_          : ϰ(instance ѿ)
//    syncSubView_         : ɽɥȤƱ(instance ѿ)
//    syncPalette_         : 򿧤ȤƱ(instance ѿ)
//
-(id)init
{
    NSUserDefaults *def;

    DPRINT((@"[PoCoEditInfo init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->selColor_ = nil;
        self->oldColor_ = nil;
        self->pdPos_ = nil;
        self->lastPos_ = nil;
        self->pictureRect_ = nil;
        self->viewRect_ = nil;
        self->pdRect_ = nil;
        self->selRect_ = nil;
        self->supplement_ = nil;

        // 祦ɥɽ
        self->supplement_ = [[PoCoMainViewSupplement alloc] init];

        // ͤ
        def = [NSUserDefaults standardUserDefaults];
        self->lockPalette_ = [def integerForKey:PALETTELOCK_NAME];
        self->penNumber_ = (unsigned int)([def integerForKey:PEN_NUMBER_NAME]);
        self->penSize_ = (unsigned int)([def integerForKey:PEN_SIZE_NAME]);
        self->tileNumber_ = (unsigned int)([def integerForKey:TILE_PATTERN_NAME]);
        self->density_ = (unsigned int)([def integerForKey:DENSITY_NAME]);
        self->drawModeType_ = (PoCoDrawModeType)([def integerForKey:DRAWMODE_NAME]);
        self->continuationType_ = [def boolForKey:CONTINUATION_NAME];
        self->flipType_ = [def boolForKey:FLIP_NAME];
        self->pointModeType_ = (PoCoPointModeType)([def integerForKey:POINTMODE_NAME]);
        self->penStyleType_ = (PoCoPenStyleType)([def integerForKey:DRAWPENSTYLE_NAME]);
        self->enableUndo_ = [def boolForKey:ENABLEUNDO_NAME];
        self->enableEraser_ = [def boolForKey:ENABLEERASER_NAME];
        self->undoMaxLevel_ = (int)([def integerForKey:UNDOMAXLEVEL_NAME]);
        self->enableLiveResize_ = [def boolForKey:ENABLELIVERESIZE_NAME];
        self->enableColorBuffer_ = [def boolForKey:ENABLECOLORBUFFER_NAME];
        self->sizePropType_ = (PoCoProportionalType)([def integerForKey:SIZEPROPTYPE_NAME]);
        self->densityPropType_ = (PoCoProportionalType)([def integerForKey:DENSITYPROPTYPE_NAME]);
        self->atomizerSkip_ = (PoCoAtomizerSkipType)([def integerForKey:ATOMIZERSKIPTYPE_NAME]);
        self->atomizerType_ = [def boolForKey:ATOMIZERTYPE_NAME];
        self->selectionFill_ = [def boolForKey:SELECTIONFILL_NAME];
        self->liveEditSelection_ = [def boolForKey:LIVEEDITSELECTION_NAME];
        self->withHandleSelection_ = [def boolForKey:WITHHANDLESELECTION_NAME];
        self->saveDocWindowPos_ = [def boolForKey:SAVEDOCWINDOWPOS_NAME];
        self->holdSubWindowPos_ = [def boolForKey:HOLDDOCWINDOWPOS_NAME];
        self->noOpenNewDocPanel_ = [def boolForKey:NOOPENNEWDOCPANEL_NAME];
        self->showScrollerView_ = (PoCoScrollerType)([def integerForKey:SHOWSCROLLERVIEW_NAME]);
        self->previewQuality_ = (unsigned int)([def integerForKey:PREVIEWQUALITY_NAME]);
        self->previewSize_ = (unsigned int)([def integerForKey:PREVIEWSIZE_NAME]);
        self->grayToAlpha_ = [def boolForKey:GRAYSCALETOALPHA_NAME];
        self->interFreq_ = (unsigned int)([def integerForKey:INTERPOLATION_FREQ_NAME]);
        self->colorRange_ = (int)([def integerForKey:RANGEOFCOLOR_NAME]);
        [self->supplement_ setBackgroundColor:(unsigned int)([def integerForKey:BACKGROUNDCOLOR_NAME])];
        [self->supplement_ setPattern:[def boolForKey:BACKGROUNDPATTERN_NAME]];
        [self->supplement_ setGridStep:(unsigned int)([def integerForKey:PIXELGRIDSTEP_NAME])];
        self->syncSubView_ = [def boolForKey:SYNCSUBVIEW_NAME];
        self->syncPalette_ = [def boolForKey:SYNCPALETTE_NAME];
        switch ([def integerForKey:COLOR_MODE_NAME]) {
            case 0:
            default:
                self->colorMode_ = PoCoColorMode_RGB;
                break;
            case 1:
                self->colorMode_ = PoCoColorMode_HLS;
                break;
        }
        switch ([def integerForKey:INTERGUIDE_VIEW_NAME]) {
            default:
            case 0:
                self->interGuide_ = PoCoInterpolationGuideView_Line;
                break;
            case 1:
                self->interGuide_ = PoCoInterpolationGuideView_Curve;
                break;
            case 2:
                self->interGuide_ = PoCoInterpolationGuideView_CurveLine;
                break;
        }
        switch ([def integerForKey:INTERPOLATION_TYPE_NAME]) {
            default:
            case 0:
                self->interType_ = PoCoCurveWithPoints_Lagrange;
                break;
            case 1:
                self->interType_ = PoCoCurveWithPoints_Spline;
                break;
        }

        // NSUserDefaults ˤʤʬν
        self->eraserType_ = NO;
        self->pressure_ = 1000;

        // 񸻤
        self->selColor_ = [[PoCoSelColor alloc] initWithColorNum:0];
        if (self->selColor_ == nil) {
            DPRINT((@"can't alloc selColor.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
        self->oldColor_ = [[PoCoSelColor alloc] initWithColorNum:-1];
        if (self->oldColor_ == nil) {
            DPRINT((@"can't alloc oldColor.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }

        // ƺɸν
        self->pdPos_ = [[PoCoPoint alloc] init];
        self->lastPos_ = [[PoCoPoint alloc] init];
        self->pictureRect_ = [[PoCoRect alloc] init];
        self->viewRect_ = [[PoCoRect alloc] init];
        self->pdRect_ = [[PoCoRect alloc] init];
        self->selRect_ = [[PoCoRect alloc] init];
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    selColor_    : ο(instance ѿ)
//    oldColor_    : ο(instance ѿ)
//    pdPos_       : PD ()(instance ѿ)
//    lastPos_     : ǽ PD ()(instance ѿ)
//    pictureRect_ : ()(instance ѿ)
//    viewRect_    : ɽϰ()(instance ѿ)
//    pdRect_      : PD ϰ()(instance ѿ)
//    selRect_     : ϰ()(instance ѿ)
//    supplement_  : 祦ɥɽ(instance ѿ)
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditInfo dealloc]\n"));

    // 񸻤β
    [self->supplement_ release];
    [self->selRect_ release];
    [self->pdRect_ release];
    [self->viewRect_ release];
    [self->pictureRect_ release];
    [self->pdPos_ release];
    [self->oldColor_ release];
    [self->selColor_ release];

    self->selColor_ = nil;
    self->oldColor_ = nil;
    self->pdPos_ = nil;
    self->lastPos_ = nil;
    self->pictureRect_ = nil;
    self->viewRect_ = nil;
    self->pdRect_ = nil;
    self->selRect_ = nil;
    self->supplement_ = nil;

    // super class β
    [super dealloc];

    return;
}


// ----------------------------------------- instance - public - οϢ
//
// ομ
//
//  Call
//    selColor_ : ο(instance ѿ)
//
//  Return
//    function : 򿧾
//
-(PoCoSelColor *)selColor
{
    return self->selColor_;
}


//
// ομ
//
//  Call
//    oldColor_ : ο(instance ѿ)
//
//  Return
//    function : 򿧾
//
-(PoCoSelColor *)oldColor
{
    return self->oldColor_;
}


//
// ο
//
//  Call
//    num : ֹ
//
//  Return
//    selColor_ : ο(instance ѿ)
//    oldColor_ : ο(instance ѿ)
//
-(void)setSelColor:(int)num
{
    // ϰϳǤꤷʤ
    if ((num >= 0) && (num < COLOR_MAX)) {
        // οФ
        if ([self->selColor_ isColor]) {
            [self->oldColor_ setColor:[self->selColor_ num]];
        } else {
            [self->oldColor_ setPattern:[self->selColor_ num]];
        }

        // 꿧Ф
        [self->selColor_ setColor:num];
    }

    return;
}


//
// Υѥ
//
//  Call
//    num : ѥֹ
//
//  Return
//    selColor_ : ο(instance ѿ)
//    oldColor_ : ο(instance ѿ)
//
-(void)setSelPattern:(int)num
{
    // ϰϳǤꤷʤ
    if ((num >= 0) && (num < 16)) {
        // οФ
        if ([self->selColor_ isColor]) {
            [self->oldColor_ setColor:[self->selColor_ num]];
        } else {
            [self->oldColor_ setPattern:[self->selColor_ num]];
        }

        // 꿧Ф
        [self->selColor_ setPattern:num];
    }

    return;
}


//
// 顼ѥλѤμ
//
//  Call
//    selColor_ : ο(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)useUnderPattern
{
    return [self->selColor_ isUnder];
}


//
// 顼ѥλѤڤؤ
//
//  Call
//    selColor_ : ο(instance ѿ)
//
//  Return
//    None
//
-(void)toggleUseUnderPattern
{
    [self->selColor_ toggleUnder];

    return;
}


// --------------------------------------- instance - public - 黻⡼ɴϢ
//
// 黻⡼ɤμ
//
//  Call
//    colorMode_ : 黻⡼(instance ѿ
//
//  Return
//    function : 
//
-(PoCoColorMode)colorMode
{
    return self->colorMode_;
}


//
// 黻⡼ɤ
//
//  Call
//    mode : 
//
//  Return
//    colorMode_ : 黻⡼(instance ѿ
//
-(void)setColorMode:(PoCoColorMode)mode
{
    NSUserDefaults *def;

    self->colorMode_ = mode;

    def = [NSUserDefaults standardUserDefaults];
    switch (self->colorMode_) {
        case PoCoColorMode_RGB:
        default:
            [def setInteger:0 forKey:COLOR_MODE_NAME];
            break;
        case PoCoColorMode_HLS:
            [def setInteger:1 forKey:COLOR_MODE_NAME];
            break;
    }

    return;
}


//
// ѥåȸμ
//
//  Call
//    lockPalette_ : ѥåȸ(instance ѿ)
//
//  Return
//    funtion : 
//
-(BOOL)lockPalette
{
    return self->lockPalette_;
}


//
// ѥåȸ
//
//  Call
//    type : 
//
//  Return
//    lockPalette_ : ѥåȸ(instance ѿ)
//
-(void)setLockPalette:(BOOL)type
{
    self->lockPalette_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->lockPalette_
                                            forKey:PALETTELOCK_NAME];

    return;
}


// --------------------------------------------- instance - public - ڥϢ
//
// ڥֹμ
//
//  Call
//    penNumber_ : ڥֹ(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)penNumber
{
    return self->penNumber_;
}


//
// ڥ礭μ
//
//  Call
//    penSize_ : ɮΥڥ礭(dotñ)(instance ѿ)
//
//  Return
//    function : (dot ñ)
//
-(unsigned int)penSize
{
    return self->penSize_;
}


//
// ڥֹ
//
//  Call
//    num : ֹ
//
//  Return
//    penNumber_ : ڥֹ(instance ѿ)
//
-(void)setPenNumber:(unsigned int)num
{
    if (/* (num >= 0) && */(num < PEN_STYLE_NUM)) {
        self->penNumber_ = num;
        [[NSUserDefaults standardUserDefaults] setInteger:self->penNumber_
                                                   forKey:PEN_NUMBER_NAME];
    }

    return;
}


//
// ڥ礭
//
//  Call
//    size : 礭(dot ñ)
//
//  Return
//    penSize_ : ɮΥڥ礭(dotñ)(instance ѿ)
//
-(void)setPenSize:(unsigned int)size
{
    if ((size > 0) && (size <= PEN_STYLE_SIZE)) {
        self->penSize_ = size;
        [[NSUserDefaults standardUserDefaults] setInteger:self->penSize_
                                                   forKey:PEN_SIZE_NAME];
    }

    return;
}


// --------------------------- instance ؿ - public - ѥ/ǻٴϢ
//
// ѥֹμ
//
//  Call
//    tileNumber_ : ѥֹ(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)tileNumber
{
    return self->tileNumber_;
}


//
// ǻ٤μ
//
//  Call
//    density_ : ǻپ(0.1% ñ)(instance ѿ)
//
//  Return
//    function : (0.1% ñ)
//
-(unsigned int)density
{
    return self->density_;
}


//
// ѥֹ
//
//  Call
//    num : ֹ
//
//  Return
//    tileNumber_ : ѥֹ(instance ѿ)
//
-(void)setTileNumber:(unsigned int)num
{
    if (/* (num >= 0) && */(num < TILE_PATTERN_NUM)) {
        self->tileNumber_ = num;
        [[NSUserDefaults standardUserDefaults] setInteger:self->tileNumber_
                                                   forKey:TILE_PATTERN_NAME];
    }

    return;
}


//
// ǻ٤
//
//  Call
//    val : (0.1% ñ)
//
//  Return
//    density_ : ǻپ(0.1% ñ)(instance ѿ)
//
-(void)setDensity:(unsigned int)val
{
    if (/* (val >= 0) && */(val <= (100 * 10))) {
        self->density_ = val;
        [[NSUserDefaults standardUserDefaults] setInteger:self->density_
                                                   forKey:DENSITY_NAME];
    }

    return;
}


// ----------------------------- instance - public - ݥ󥿥ץ쥹ɮϢ
//
// ɮ
//
//  Call
//    pressure_ : ݥ󥿥ץ쥹ɮ(0.1%ñ)(instance ѿ)
//
//  Return
//    function : (0.1% ñ)
//
-(unsigned int)pressure
{
    return self->pressure_;
}


//
// ɮ
//
//  Call
//    press : (0.1% ñ)
//
//  Return
//    pressure_ : ݥ󥿥ץ쥹ɮ(0.1%ñ)(instance ѿ)
//
-(void)setPressure:(unsigned int)press
{
    self->pressure_ = press;

    return;
}


// ------------------------------------------- instance - public - ɽִϢ
//
// μ
//
//  Call
//    pictureRect_ : ()(instance ѿ)
//
//  Return
//    function : ϰ
//
-(PoCoRect *)pictureRect
{
    return self->pictureRect_;
}


//
// ɽμ
//  祦ɥǤΨȿǤɽϰ
//
//  Call
//    viewRect_ : ɽϰ()(instance ѿ)
//
//  Return
//    function : ϰ
//
-(PoCoRect *)pictureView
{
    return self->viewRect_;
}


//
// 
//
//  Call
//    r : ϰ
//
//  Return
//    pictureRect_ : ()(instance ѿ)
//
-(void)setPictureRect:(PoCoRect *)r
{
    if (!([self->pictureRect_ isEqualRect:r])) {
        [self->pictureRect_   setLeft:[r   left]];
        [self->pictureRect_    setTop:[r    top]];
        [self->pictureRect_  setRight:[r  right]];
        [self->pictureRect_ setBottom:[r bottom]];

        // ѹ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditInfoChangePos
                          object:[NSNumber numberWithInt:PoCoEditInfoPos_pictureRect]];
    }

    return;
}


//
// ɽ
//  祦ɥǤΨȿǤɽϰ
//
//  Call
//    r            : ϰ
//    pictureRect_ : ()(instance ѿ)
//
//  Return
//    viewRect_ : ɽϰ()(instance ѿ)
//
-(void)setPictureView:(PoCoRect *)r
{
    if (!([self->viewRect_ isEqualRect:r])) {
        [self->viewRect_   setLeft:[r   left]];
        [self->viewRect_    setTop:[r    top]];
        [self->viewRect_  setRight:[r  right]];
        [self->viewRect_ setBottom:[r bottom]];

        // ͤ
        if ([self->viewRect_ left] < [self->pictureRect_ left]) {
            [self->viewRect_ setLeft:[self->pictureRect_ left]];
        }
        if ([self->viewRect_ top] < [self->pictureRect_ top]) {
            [self->viewRect_ setTop:[self->pictureRect_ top]];
        }
        if ([self->viewRect_ right] >= [self->pictureRect_ right]) {
            [self->viewRect_ setRight:([self->pictureRect_ right] - 1)];
        }
        if ([self->viewRect_ bottom] >= [self->pictureRect_ bottom]) {
            [self->viewRect_ setBottom:([self->pictureRect_ bottom] - 1)];
        }

        // ɽϰϤѹ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditInfoChangePos
                          object:[NSNumber numberWithInt:PoCoEditInfoPos_viewRect]];
    }

    return;
}


// ---------------------------------------- instance - public - PD ؼִϢ
//
// PD ֤μ
//
//  Call
//    pdPos_ : PD ()(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)pdPos
{
    return self->pdPos_;
}


//
// ǽ PD ֤μ
//
//  Call
//    lastPos_ : ǽ PD ()(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)lastPos
{
    return self->lastPos_;
}


//
// ϰϤμ
//  ϰϤǤϤʤ(̾ԽѤ)ΰμ
//
//  Call
//    pdRect_ : PD ϰ()(instance ѿ)
//
//  Return
//    function : ϰ
//
-(PoCoRect *)pdRect
{
    return self->pdRect_;
}


//
// PD ֤
//
//  Call
//    p : 
//
//  Return
//    pdPos_ : PD ()(instance ѿ)
//
-(void)setPDPos:(PoCoPoint *)p
{
    if (!([self->pdPos_ isEqualPos:p])) {
        [self->pdPos_ setX:[p x]];
        [self->pdPos_ setY:[p y]];

        // PD ֤ΰư
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditInfoChangePos
                          object:[NSNumber numberWithInt:PoCoEditInfoPos_pdPos]];
    }

    return;
}


//
// ǽ PD ֤
//
//  Call
//    p : 
//
//  Return
//    lastPos_ : ǽ PD ()(instance ѿ)
//
-(void)setLastPos:(PoCoPoint *)p
{
    [self->lastPos_ setX:[p x]];
    [self->lastPos_ setY:[p y]];

    return;
}


//
// ϰϤ
//  ϰϤǤϤʤ(̾ԽѤ)ΰ
//
//  Call
//    r : ϰ
//
//  Return
//    pdRect_ : PD ϰ()(instance ѿ)
//
-(void)setPDRect:(PoCoRect *)r
{
    if (!([self->pdRect_ isEqualRect:r])) {
        [self->pdRect_   setLeft:[r   left]];
        [self->pdRect_    setTop:[r    top]];
        [self->pdRect_  setRight:[r  right]];
        [self->pdRect_ setBottom:[r bottom]];

        // ϰϤѹ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditInfoChangePos
                          object:[NSNumber numberWithInt:PoCoEditInfoPos_pdRect]];
    }

    return;
}


// ------------------------------------------- instance - public - ϰϴϢ
//
// ϰϤμ
//
//  Call
//    selRect_ : ϰ()(instance ѿ)
//
//  Return
//    function : ϰ
//
-(PoCoRect *)selRect
{
    return self->selRect_;
}


//
// ϰϤ
//
//  Call
//    r : ϰ
//
//  Return
//    selRect_ : ϰ()(instance ѿ)
//
-(void)setSelRect:(PoCoRect *)r
{
    if (!([self->selRect_ isEqualRect:r])) {
        [self->selRect_   setLeft:[r   left]];
        [self->selRect_    setTop:[r    top]];
        [self->selRect_  setRight:[r  right]];
        [self->selRect_ setBottom:[r bottom]];

        // ϰϤѹ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditInfoChangePos
                          object:[NSNumber numberWithInt:PoCoEditInfoPos_selRect]];
    }

    return;
}


// ------------------------------------------- instance - public - ɽϢ
//
// 祦ɥɽ
//
//  Call
//    supplement_ : 祦ɥɽ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoMainViewSupplement *)supplement
{
    return self->supplement_;
}


//
// طʿ
//
//  Call
//    col : 
//
//  Return
//    supplement_ : 祦ɥɽ(instance ѿ)
//
-(void)setBackgroundColor:(unsigned int)col
{
    [self->supplement_ setBackgroundColor:col];
    [[NSUserDefaults standardUserDefaults] setInteger:[self->supplement_ backgroundColor]
                                               forKey:BACKGROUNDCOLOR_NAME];

    return;
}


//
// طʼ
//
//  Call
//    flag : 
//
//  Return
//    supplement_ : 祦ɥɽ(instance ѿ)
//
-(void)setPattern:(BOOL)flag
{
    [self->supplement_ setPattern:flag];
    [[NSUserDefaults standardUserDefaults] setBool:[self->supplement_ isPattern]
                                            forKey:BACKGROUNDPATTERN_NAME];

    return;
}


//
// ԥ륰åɼƥå
//
//  Call
//    step : 
//
//  Return
//    supplement_ : 祦ɥɽ(instance ѿ)
//
-(void)setGridStep:(unsigned int)step
{
    [self->supplement_ setGridStep:step];
    [[NSUserDefaults standardUserDefaults] setInteger:[self->supplement_ gridStep]
                                               forKey:PIXELGRIDSTEP_NAME];

    return;
}


// ------------------------------------------- instance - public - ֶϢ
//
// ֶɤɽˡ
//
//  Call
//    interGuide_ : ֶΥɥ饤ɽ(instance ѿ)
//
//  Return
//    function 
//
-(PoCoInterpolationGuideView)interGuide
{
    return self->interGuide_;
}


//
// ֶμ
//
//  Call
//    interType_ : ֶμ(instance ѿ)
//
//  Return
//    function 
//
-(PoCoCurveWithPointsType)interType
{
    return self->interType_;
}


//
// ֶټ
//
//  Call
//    interFreq_ : ֶ(instance ѿ)
//
//  Return
//    function 
//
-(unsigned int)interFreq
{
    return self->interFreq_;
}


//
// ֶɤɽˡ
//
//  Call
//    type : 
//
//  Return
//    interGuide_ : ֶΥɥ饤ɽ(instance ѿ)
//
-(void)setInterGuide:(PoCoInterpolationGuideView)type
{
    self->interGuide_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->interGuide_
                                               forKey:INTERGUIDE_VIEW_NAME];

    return;
}


//
// ֶμ
//
//  Call
//    type : 
//
//  Return
//    interType_ : ֶμ(instance ѿ)
//
-(void)setInterType:(PoCoCurveWithPointsType)type
{
    self->interType_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->interType_
                                               forKey:INTERPOLATION_TYPE_NAME];

    return;
}


//
// ֶ
//
//  Call
//    val : 
//
//  Return
//    interFreq_ : ֶ(instance ѿ)
//
-(void)setInterFreq:(unsigned int)val
{
    self->interFreq_ = val;
    [[NSUserDefaults standardUserDefaults] setInteger:self->interFreq_
                                               forKey:INTERPOLATION_FREQ_NAME];

    return;
}


// ------------------------------------------- instance - public - ԽǽϢ
//
// 赡ǽ
//
//  Call
//    drawModeType_ : 赡ǽ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoDrawModeType)drawModeType
{
    return self->drawModeType_;
}


//
// Ϣ³
//
//  Call
//    continuationType_ : Ϣ³/Ϣ³(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)continuationType
{
    return self->continuationType_;
}


//
// ǻȿž
//
//  Call
//    flipType_ : ǻȿž(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)flipType
{
    return self->flipType_;
}


//
// 
//
//  Call
//    pointModeType_ : (instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPointModeType)pointModeType
{
    return self->pointModeType_;
}


//
// ڥ
//
//  Call
//    penStyleType_ : ڥ()(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPenStyleType)penStyleType
{
    return self->penStyleType_;
}


//
// äݤ
//
//  Call
//    enableUndo_ : ä(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)enableUndo
{
    return self->enableUndo_;
}


//
// äͭݤ
//
//  Call
//    enableEraser_ : äͭ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)enableEraser
{
    return self->enableEraser_;
}


//
// ä
//
//  Call
//    eraserType_ : ä(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)eraserType
{
    return self->eraserType_;
}


//
// ä
//
//  Call
//    undoMaxLevel_ : ä(instance ѿ)
//
//  Return
//    function : 
//
-(int)undoMaxLevel
{
    return self->undoMaxLevel_;
}


//
// LiveResize ݤ
//
//  Call
//    enableLiveResize_ : LiveResize (instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)enableLiveResize
{
    return self->enableLiveResize_;
}


//
// ݻݤ
//
//  Call
//    enableColorBuffer_ : ݻ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)enableColorBuffer
{
    return self->enableColorBuffer_;
}


//
// ɮ
//
//  Call
//    sizePropType_ : ɮ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoProportionalType)sizePropType
{
    return self->sizePropType_;
}


//
// ǻ٤ɮ
//
//  Call
//    densityPropType_ : ǻ٤ɮ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoProportionalType)densityPropType
{
    return self->densityPropType_;
}


//
// ̸᤭ΰưˡ
//
//  Call
//    atomizerSkip_ : ̸᤭ΰưˡ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoAtomizerSkipType)atomizerSkip
{
    return self->atomizerSkip_;
}


//
// ̸᤭μ
//
//  Call
//    atomizerType_ : ̸᤭μ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)atomizerType
{
    return self->atomizerType_;
}


//
// ΰɤĤ֤ɽ
//
//  Call
//    selectionFill_ : ΰɤĤ֤ɽ(instance ѿ)
//
//  Return
//    funtion : 
//
-(BOOL)selectionFill
{
    return self->selectionFill_;
}


//
// ϰϤԽɽ
//
//  Call
//    liveEditSelection_ : ϰϤԽɽ(instance ѿ)
//
//  Return
//    funtion : 
//
-(BOOL)liveEditSelection
{
    return self->liveEditSelection_;
}


//
// ϰϤΥϥɥ̵ͭ
//
//  Call
//    withHandleSelection_ : ϰϤΥϥɥ̵ͭ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)useHandle
{
    return self->withHandleSelection_;
}


//
// 祦ɥ¸
//
//  Call
//    saveDocWindowPos_ : 祦ɥ¸(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)saveDocWindowPos
{
    return self->saveDocWindowPos_;
}


//
// ɥָ
//
//  Call
//    holdSubWindowPos_ : ɥָ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)holdSubWindowPos
{
    return self->holdSubWindowPos_;
}


//
// ɥȥѥͥ򳫤ʤ
//
//  Call
//    noOpenNewDocPanel_ : ɥȥѥͥ򳫤ʤ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)noOpenNewDocPanel
{
    return self->noOpenNewDocPanel_;
}


//
// view  scroller ɽ
//
//  Call
//    showScrollerView_ : view  scroller ɽ(instance ѿ)
//
//  Return
//    function: 
//
-(PoCoScrollerType)showScrollerView
{
    return self->showScrollerView_;
}


//
// ץӥ塼ʼ
//
//  Call
//    previewQuality_ : ץӥ塼ʼ(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)previewQuality
{
    return self->previewQuality_;
}


//
// ץӥ塼礭
//
//  Call
//    previewSize_ : ץӥ塼礭(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)previewSize
{
    return self->previewSize_;
}


//
// Grascale Ʃ٤Ȥ
//
//  Call
//    grayToAlpha_ : Grascale Ʃ٤Ȥ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)grayToAlpha
{
    return self->grayToAlpha_;
}


//
// ϰϤ
// 
//  Call
//    colorRange_ : ϰ(instance ѿ)
//
//  Return
//    function : 
//
-(int)colorRange
{
    return self->colorRange_;
}


//
// ɽɥȤƱ
//
//  Call
//    syncSubView_ : ɽɥȤƱ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)syncSubView
{
    return self->syncSubView_;
}


//
// 򿧤ȤƱ
//
//  Call
//    syncPalette_ : 򿧤ȤƱ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)syncPalette
{
    return self->syncPalette_;
}


//
// 赡ǽ
//
//  Call
//    type : 
//
//  Return
//    drawModeType_ : 赡ǽ(instance ѿ)
//
-(void)setDrawModeType:(PoCoDrawModeType)type
{
    self->drawModeType_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->drawModeType_
                                               forKey:DRAWMODE_NAME];

    return;
}


//
// Ϣ³
//
//  Call
//    type : 
//
//  Return
//    continuationType_ : Ϣ³/Ϣ³(instance ѿ)
//
-(void)setContinuationType:(BOOL)type
{
    self->continuationType_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->continuationType_
                                            forKey:CONTINUATION_NAME];

    return;
}


//
// ǻȿž
//
//  Call
//    type : 
//
//  Return
//    flipType_ : ǻȿž(instance ѿ)
//
-(void)setFlipType:(BOOL)type
{
    self->flipType_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->flipType_
                                            forKey:FLIP_NAME];

    return;
}


//
// 
//
//  Call
//    type : 
//
//  Return
//    pointModeType_ : (instance ѿ)
//
-(void)setPointModeType:(PoCoPointModeType)type
{
    self->pointModeType_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->pointModeType_
                                               forKey:POINTMODE_NAME];

    return;
}


//
// ڥ
//
//  Call
//    type : 
//
//  Return
//    penStyleType_ : ڥ()(instance ѿ)
//
-(void)setPenStyleType:(PoCoPenStyleType)type
{
    self->penStyleType_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->penStyleType_
                                               forKey:DRAWPENSTYLE_NAME];

    return;
}


//
// äݤ
//
//  Call
//    type : 
//
//  Return
//    enableUndo_ : ä(instance ѿ)
//
-(void)setEnableUndo:(BOOL)type
{
    self->enableUndo_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->enableUndo_
                                            forKey:ENABLEUNDO_NAME];

    return;
}


//
// äͭݤ
//
//  Call
//    type : 
//
//  Return
//    enableEraser_ : äͭ(instance ѿ)
//
-(void)setEnableEraser:(BOOL)type
{
    self->enableEraser_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->enableEraser_
                                            forKey:ENABLEERASER_NAME];

    return;
}


//
// ä
//
//  Call
//    type : 
//
//  Return
//    eraserType_ : ä(instance ѿ)
//
-(void)setEraserType:(BOOL)type
{
    self->eraserType_ = type;

    return;
}


//
// ä
//
//  Call
//    type : 
//
//  Return
//    undoMaxLevel_ : ä(instance ѿ)
//
-(void)setUndoMaxLevel:(int)type
{
    self->undoMaxLevel_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->undoMaxLevel_
                                               forKey:UNDOMAXLEVEL_NAME];

    // current document ȿǤ
    [[[[NSDocumentController sharedDocumentController] currentDocument] undoManager] setLevelsOfUndo:self->undoMaxLevel_];


    return;
}


//
// LiveResize ݤ
//
//  Call
//    type : 
//
//  Return
//    enableLiveResize_ : LiveResize (instance ѿ)
//
-(void)setEnableLiveResize:(BOOL)type
{
    self->enableLiveResize_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->enableLiveResize_
                                            forKey:ENABLELIVERESIZE_NAME];

    return;
}


//
// ݻݤ
//
//  Call
//    type : 
//
//  Return
//    enableColorBuffer_ : ݻ(instance ѿ)
//
-(void)setEnableColorBuffer:(BOOL)type
{
    self->enableColorBuffer_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->enableColorBuffer_
                                            forKey:ENABLECOLORBUFFER_NAME];

    return;
}


//
// ɮ
//
//  Call
//    type : 
//
//  Return
//    sizePropType_ : ɮ(instance ѿ)
//
-(void)setSizePropType:(PoCoProportionalType)type
{
    self->sizePropType_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->sizePropType_
                                               forKey:SIZEPROPTYPE_NAME];

    return;
}


//
// ǻ٤ɮ
//
//  Call
//    type : 
//
//  Return
//    densityPropType_ : ǻ٤ɮ(instance ѿ)
//
-(void)setDensityPropType:(PoCoProportionalType)type
{
    self->densityPropType_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->densityPropType_
                                               forKey:DENSITYPROPTYPE_NAME];

    return;
}


//
// ̸᤭ΰưˡ
//
//  Call
//    type : 
//
//  Return
//    atomizerSkip_ : ̸᤭ΰưˡ(instance ѿ)
//
-(void)setAtomizerSkip:(PoCoAtomizerSkipType)type
{
    self->atomizerSkip_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->atomizerSkip_
                                               forKey:ATOMIZERSKIPTYPE_NAME];

    return;
}


//
// ̸᤭μ
//
//  Call
//    type : 
//
//  Return
//    atomizerType_ : ̸᤭μinstance ѿ)
//
-(void)setAtomizerType:(BOOL)type
{
    self->atomizerType_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->atomizerType_
                                            forKey:ATOMIZERTYPE_NAME];

    return;
}


//
// ΰɤĤ֤ɽ
//
//  Call
//    type : 
//
//  Return
//    selectionFill_ : ΰɤĤ֤ɽ(instance ѿ)
//
-(void)setSelectionFill:(BOOL)type
{
    self->selectionFill_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->selectionFill_
                                            forKey:SELECTIONFILL_NAME];

    return;
}


//
// ϰϤԽɽ
//
//  Call
//    type : 
//
//  Return
//    liveEditSelection_ : ϰϤԽɽ(instance ѿ)
//
-(void)setLiveEditSelection:(BOOL)type
{
    self->liveEditSelection_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->liveEditSelection_
                                            forKey:LIVEEDITSELECTION_NAME];

    return;
}


//
// ϰϤΥϥɥ̵ͭ
//
//  Call
//    type : 
//
//  Return
//    withHandleSelection_ : ϰϤΥϥɥ̵ͭ(instance ѿ)
//
-(void)setUseHandle:(BOOL)type
{
    self->withHandleSelection_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->withHandleSelection_
                                            forKey:WITHHANDLESELECTION_NAME];

    return;
}


//
// 祦ɥ¸
//
//  Call
//    type : 
//
//  Return
//    saveDocWindowPos_ : 祦ɥ¸(instance ѿ)
//
-(void)setSaveDocWindowPos:(BOOL)type
{
    self->saveDocWindowPos_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->saveDocWindowPos_
                                            forKey:SAVEDOCWINDOWPOS_NAME];

    return;
}


//
// ɥָ
//
//  Call
//    type : 
//
//  Return
//    holdSubWindowPos_ : ɥָ(instance ѿ)
//
-(void)setHoldSubWindowPos:(BOOL)type
{
    self->holdSubWindowPos_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->holdSubWindowPos_
                                            forKey:HOLDDOCWINDOWPOS_NAME];

    return;
}


//
// ɥȥѥͥ򳫤ʤ
//
//  Call
//    type : 
//
//  Return
//    noOpenNewDocPanel_ : ɥȥѥͥ򳫤ʤ(instance ѿ)
//
-(void)setNoOpenNewDocPanel:(BOOL)type
{
    self->noOpenNewDocPanel_ = type;
    [[NSUserDefaults standardUserDefaults] setBool:self->noOpenNewDocPanel_ 
                                            forKey:NOOPENNEWDOCPANEL_NAME];

    return;
}


//
// view  scroller ɽ
//
//  Call
//    type : 
//
//  Return
//    showScrollerView_ : view  scroller ɽ(instance ѿ)
//
-(void)setShowScrollerView:(PoCoScrollerType)type
{
    self->showScrollerView_ = type;
    [[NSUserDefaults standardUserDefaults] setInteger:self->showScrollerView_
                                               forKey:SHOWSCROLLERVIEW_NAME];

    return;
}


//
// ץӥ塼ʼ
//
//  Call
//    val : 
//
//  Return
//    previewQuality_ : ץӥ塼ʼ(instance ѿ)
//
-(void)setPreviewQuality:(unsigned int)val
{
    self->previewQuality_ = val;
    [[NSUserDefaults standardUserDefaults] setInteger:self->previewQuality_
                                               forKey:PREVIEWQUALITY_NAME];

    return;
}


//
// ץӥ塼礭
//
//  Call
//    val : 
//
//  Return
//    previewSize_ : ץӥ塼礭(instance ѿ)
//
-(void)setPreviewSize:(unsigned int)val
{
    self->previewSize_ = val;
    [[NSUserDefaults standardUserDefaults] setInteger:self->previewSize_
                                               forKey:PREVIEWSIZE_NAME];

    return;
}


//
// Grascale Ʃ٤Ȥ
//
//  Call
//    flag : 
//
//  Return
//    grayToAlpha_ : Grascale Ʃ٤Ȥ(instance ѿ)
//
-(void)setGrayToAlpha:(BOOL)flag
{
    self->grayToAlpha_ = flag;
    [[NSUserDefaults standardUserDefaults] setBool:self->grayToAlpha_
                                            forKey:GRAYSCALETOALPHA_NAME];

    return;
}


//
// ϰϤ
// 
//  Call
//    val : 
//
//  Return
//    colorRange_ : ϰ(instance ѿ)
//
-(void)setColorRange:(int)val
{
    self->colorRange_ = val;
    [[NSUserDefaults standardUserDefaults] setInteger:self->colorRange_
                                               forKey:RANGEOFCOLOR_NAME];

    return;
}


//
// ɽɥȤƱ
//
//  Call
//    flag : 
//
//  Return
//    syncSubView_ : ɽɥȤƱ(instance ѿ)
//
-(void)setSyncSubView:(BOOL)flag
{
    self->syncSubView_ = flag;
    [[NSUserDefaults standardUserDefaults] setBool:self->syncSubView_
                                            forKey:SYNCSUBVIEW_NAME];

    return;
}


//
// 򿧤ȤƱ
//
//  Call
//    flag : 
//
//  Return
//    syncPalette_ : 򿧤ȤƱ(instance ѿ)
//
-(void)setSyncPalette:(BOOL)flag
{
    self->syncPalette_ = flag;
    [[NSUserDefaults standardUserDefaults] setBool:self->syncPalette_
                                            forKey:SYNCPALETTE_NAME];
}

@end
