//
//	Pelistina on Cocoa - PoCo -
//	μ
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoGlobalObserver.h"

#import "PoCoMyDocument.h"

// ============================================================================
@implementation PoCoGlobalObserver

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    fucntion : 
//    docCntl_ : document controller(instance ѿ)
//    notes_   : notification center(instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoGlobalObserver init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        // observer Ͽ
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        self->notes_ = [NSNotificationCenter defaultCenter];

        // Խоѹ
        [self->notes_ addObserver:self
                         selector:@selector(changePicture:)
                             name:PoCoChangePicture
                           object:nil];

        // ѹ
        [self->notes_ addObserver:self
                         selector:@selector(changeColor:)
                             name:PoCoChangeColor
                           object:nil];

        // ѥåȹ
        [self->notes_ addObserver:self
                         selector:@selector(changePalette:)
                             name:PoCoChangePalette
                           object:nil];

        // ѥå°
        [self->notes_ addObserver:self
                         selector:@selector(changePaletteAttr:)
                             name:PoCoChangePaletteAttr
                           object:nil];

        // 쥤䡼¤Խ
        [self->notes_ addObserver:self
                         selector:@selector(editLayer:)
                             name:PoCoEditLayer
                           object:nil];

        // ѹ
        [self->notes_ addObserver:self
                         selector:@selector(resizeCanvas:)
                             name:PoCoCanvasResize
                           object:nil];

        // ڤȴ
        [self->notes_ addObserver:self
                         selector:@selector(clipImage:)
                             name:PoCoImageClip
                           object:nil];

        // Խ
        [self->notes_ addObserver:self
                         selector:@selector(editPicture:)
                             name:PoCoEditPicture
                           object:nil];

        // ȯ
        [self->notes_ addObserver:self
                         selector:@selector(redrawPicture:)
                             name:PoCoRedrawPicture
                           object:nil];

        // ɸι
        [self->notes_ addObserver:self
                         selector:@selector(editInfoChangePos:)
                             name:PoCoEditInfoChangePos
                           object:nil];

        // 赡ǽѹ
        [self->notes_ addObserver:self
                         selector:@selector(changeDrawTool:)
                             name:PoCoChangeDrawTool
                           object:nil];

        // ϥɥ
        [self->notes_ addObserver:self
                         selector:@selector(redrawHandle:)
                             name:PoCoRedrawGuideLine
                           object:nil];

        // 쥤䡼ѹ
        [self->notes_ addObserver:self
                         selector:@selector(changeSelLayer:)
                             name:PoCoSelLayerChange
                           object:nil];

        // ڡ٥
        [self->notes_ addObserver:self
                         selector:@selector(spaceKeyEvent:)
                             name:PoCoSpaceKeyEvent
                           object:nil];

        // ɽɥ֥륯å
        [self->notes_ addObserver:self
                         selector:@selector(dclickOnSubView:)
                             name:PoCoDClickOnSubView
                           object:nil];
    }

    return self;
}


//
// deallocate
//
//  Call
//    notes_ : notification center(instance ѿ)
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoGlobalObserver dealloc]\n"));

    // observer Ͽ
    [self->notes_ removeObserver:self];

    // super class β
    [super dealloc];

    return;
}


// -------------------------------------------- instance - public -  observer
//
// Խоѹ
//  祦ɥΤѤ¾ɥѹؼ뤳Ȥ⤢
//  ΤǡGlobalObserver ǤΤ̵뤹뤳
//  (Τ祦ɥ˲ۤɬפʤ)
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePicture:(NSNotification *)note
{
    // ⤷ʤ
    ;

    return;
}


//
// ѹ
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changeColor:(NSNotification *)note
{
    // ⤷ʤ
    ;

    return;
}


//
// ѥåȹ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)changePalette:(NSNotification *)note
{
    // ѥåȤѹã
    [[self->docCntl_ currentDocument] didUpdatePalette];

    // Ѥߤڤؤ
    [[self->docCntl_ currentDocument] setUpdateState:NSChangeDone];

    return;
}


//
// ѥå°
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)changePaletteAttr:(NSNotification *)note
{
    int i;

    // 祦ɥκ
    if ([note object] == nil) {
        [[self->docCntl_ currentDocument] didUpdatePicture:nil];
    } else {
        i = [[note object] intValue];
        if (i & 0x00040000) {
            [[self->docCntl_ currentDocument] didUpdatePicture:nil];
        }
    }

    // Ѥߤڤؤ
    [[self->docCntl_ currentDocument] setUpdateState:NSChangeDone];

    return;
}


//
// 쥤䡼¤Խ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)editLayer:(NSNotification *)note
{
    // 祦ɥκ
    if ([[note object] boolValue]) {
        [[self->docCntl_ currentDocument] didUpdatePicture:nil];
    }

    // Ѥߤڤؤ
    [[self->docCntl_ currentDocument] setUpdateState:NSChangeDone];

    return;
}


//
// ѹ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)resizeCanvas:(NSNotification *)note
{
    // ѹã
    [[self->docCntl_ currentDocument] didLayerResize];

    // Ѥߤڤؤ
    [[self->docCntl_ currentDocument] setUpdateState:NSChangeDone];

    return;
}


//
// ڤȴѹ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)clipImage:(NSNotification *)note
{
    // ѹã
    [[self->docCntl_ currentDocument] didLayerResize];

    // Ѥߤڤؤ
    [[self->docCntl_ currentDocument] setUpdateState:NSChangeDone];

    return;
}


//
// Խ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)editPicture:(NSNotification *)note
{
    PoCoEditPictureNotification *obj;

    obj = [note object];

    // 祦ɥκ
    if (obj != nil) {
        [[self->docCntl_ currentDocument] didUpdatePicture:[obj rect]];
    } else {
        [[self->docCntl_ currentDocument] didUpdatePicture:nil];
    }

    // Ѥߤڤؤ
    [[self->docCntl_ currentDocument] setUpdateState:NSChangeDone];

    return;
}


//
// ȯ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)redrawPicture:(NSNotification *)note
{
    PoCoEditPictureNotification *obj;

    obj = [note object];

    // 祦ɥκ
    if (obj != nil) {
        [[self->docCntl_ currentDocument] didUpdatePicture:[obj rect]];
    } else {
        [[self->docCntl_ currentDocument] didUpdatePicture:nil];
    }

    return;
}


//
// ɸι
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)editInfoChangePos:(NSNotification *)note
{
    // ⤷ʤ
    ;

    return;
}


//
// 赡ǽѹ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)changeDrawTool:(NSNotification *)note
{
    // 赡ǽѹΤ
    [[self->docCntl_ currentDocument] didChangeDrawTool];

    return;
}


//
// ϥɥ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)redrawHandle:(NSNotification *)note
{
    // ϥɥ
    [[self->docCntl_ currentDocument] drawGuideLine];

    return;
}


//
// 쥤䡼ѹ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)changeSelLayer:(NSNotification *)note
{
    // Խֲ
    [[self->docCntl_ currentDocument] cancelEdit];

    return;
}


//
// ڡ٥
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)spaceKeyEvent:(NSNotification *)note
{
    [[self->docCntl_ currentDocument] spaceKeyEvent:[[note object] boolValue]];

    return;
}


//
// ɽɥ֥륯å
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)dclickOnSubView:(NSNotification *)note
{
    [[self->docCntl_ currentDocument] dclickOnSubView:[note object]];

    return;
}

@end
