//
//	Pelistina on Cocoa - PoCo -
//	Խ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerBase.h"

#import "PoCoAppController.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//
//  Return
//    function     : 
//    picture_     : Խоݲ(instance ѿ)
//    editInfo_    : Խ(instance ѿ)
//    undoManager_ : ä(instance ѿ)
//    factory_     : Խ(instance ѿ)
//
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
{
//    DPRINT((@"[PoCoControllerBase init]\n"));

    // super class 
    self = [super init];

    // Ȥ
    if (self != nil) {
        self->picture_ = pict;
        self->editInfo_ = info;
        self->undoManager_ = undo;
        self->factory_ = [(PoCoAppController *)([NSApp delegate]) factory];

        // ƴ retain
        [self->picture_ retain];
        [self->editInfo_ retain];
        [self->undoManager_ retain];
        [self->factory_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    picture_     : Խоݲ(instance ѿ)
//    editInfo_    : Խ(instance ѿ
//    undoManager_ : ä(instance ѿ)
//    factory_     : Խ(instance ѿ)
//
//  Return
//    picture_     : Խоݲ(instance ѿ)
//    editInfo_    : Խ(instance ѿ
//    undoManager_ : ä(instance ѿ)
//    factory_     : Խ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerBase dealloc]\n"));

    // 񸻤
    [self->factory_ release];
    [self->undoManager_ release];
    [self->editInfo_ release];
    [self->picture_ release];
    self->picture_ = nil;
    self->editInfo_ = nil;
    self->undoManager_ = nil;
    self->factory_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ä̾Τ
//
//  Call
//    name         : ä̾
//    undoManager_ : ä(instance ѿ)
//
//  Return
//    undoManager_ : ä(instance ѿ)
//
-(void)setUndoName:(NSString *)name
{
    if ([self->undoManager_ isUndoing]) {
        [self->undoManager_ setActionName:[self->undoManager_ undoActionName]];
    } else if ([undoManager_ isRedoing]) {
        [self->undoManager_ setActionName:[self->undoManager_ redoActionName]];
    } else {
        [self->undoManager_ setActionName:name];
    }

    return;
}


//
// Խ¹
//  Խ YES ֤
//  (ϰϤ̵ͭȤ̵ط)
//
//  Call
//    None
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    // default Ǥϲ⤷ʤ
    ;

    // default Ǥ NO ֤
    return NO;
}


//
// ä
//
//  Call
//    undoManager_ : ä(instance ѿ)
//
//  Return
//    undoManager_ : ä(instance ѿ)
//
-(void)createUndo
{
    // default Ǥϲ⤷ʤ
    ;

    return;
}

@end
