//
//	Pelistina on Cocoa - PoCo -
//	Խ
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class 
@class PoCoBitmap;
@class PoCoLayerBase;
@class PoCoPalette;
@class PoCoColorPattern;
@class PoCoCalcRotation;

// ----------------------------------------------------------------------------
@interface PoCoControllerFactory : NSObject
{
}

// initialze
-(id)init;

// deallocate
-(void)dealloc;

// 쥤䡼¤̵Խ
-(id)createLayerNoEditter:(BOOL)exec
                     name:(NSString *)name
                   update:(BOOL)update;

// ѥåȹ̵Խ
-(id)createPaletteNoEditter:(BOOL)exec
                       name:(NSString *)name
                      index:(int)index;

// ѹ̵Խ
-(id)createResizeNoEditter:(BOOL)exec
                      name:(NSString *)name;

// ڤȴ̵Խ
-(id)createClipNoEditter:(BOOL)exec
                    name:(NSString *)name;

// ѥåȲû
-(id)createPaletteIncrementer:(BOOL)exec
                          num:(int)n
                          red:(BOOL)r
                        green:(BOOL)g
                         blue:(BOOL)b
                         step:(unsigned int)step;

// ѥåȸ
-(id)createPaletteDecrementer:(BOOL)exec
                          num:(int)n
                          red:(BOOL)r
                        green:(BOOL)g
                         blue:(BOOL)b
                         step:(unsigned int)step;

// ѥå°
-(id)createPaletteAttributeSetter:(BOOL)exec
                              num:(int)n
                          setType:(BOOL)s
                             mask:(BOOL)m
                          dropper:(BOOL)d
                            trans:(BOOL)t;
-(id)createPaletteAttributeSetter:(BOOL)exec
                            start:(int)s
                              end:(int)e
                             mask:(const BOOL *)m
                          dropper:(const BOOL *)d
                            trans:(const BOOL *)t;

// ѥåȥǡ
-(id)createPaletteGradationMaker:(BOOL)exec
                           start:(int)s
                             end:(int)e;

// ѥå
-(id)createPaletteElementSetter:(BOOL)exec
                        palette:(PoCoPalette *)palette;

// ñѥå
-(id)createPaletteSingleSetter:(BOOL)exec
                           num:(int)num
                           red:(unsigned char)red
                         green:(unsigned char)green
                          blue:(unsigned char)blue
                        isMask:(BOOL)mask
                        noDrop:(BOOL)drop
                       isTrans:(BOOL)trans
                          name:(NSString *)name;

// ѥåȼ(ڡȥܡɤʣ)
-(id)createPaletteImporter:(BOOL)exec
             targetPalette:(PoCoPalette *)target
                 withFlags:(const BOOL *)flags;

// ѥåؤ()
-(id)createPictureColorExchanger:(BOOL)exec
                             src:(int)s
                             dst:(int)d;
-(id)createPictureColorExchangerPassive:(BOOL)exec
                                    src:(int)s
                                    dst:(int)d;

// ѥåʣ(ʣ)
-(id)createPictureColorPaster:(BOOL)exec
                             src:(int)s
                             dst:(int)d;
-(id)createPictureColorPasterPassive:(BOOL)exec
                                    src:(int)s
                                    dst:(int)d;

// 쥤䡼ɲ
-(id)createLayerBitmapAdder:(BOOL)exec
                      color:(unsigned char)c;

// ʸ쥤䡼ɲ
-(id)createLayerStringAdder:(BOOL)exec
                      color:(unsigned char)c;

// 쥤䡼
-(id)createLayerDeleter:(BOOL)exec
                  index:(int)index;
-(id)createLayerDeleterPassive:(BOOL)exec
                         index:(int)index;

// 쥤䡼
-(id)createLayerInserter:(BOOL)exec
                   layer:(PoCoLayerBase *)layer
                   index:(int)index;
-(id)createLayerInserterPassive:(BOOL)exec
                          layer:(PoCoLayerBase *)layer
                          index:(int)index;

// 쥤䡼ư
-(id)createLayerMover:(BOOL)exec
                  src:(int)src
               target:(int)dst
                 copy:(BOOL)copy;

// 쥤䡼ɽ
-(id)createLayerDisplaySetter:(BOOL)exec
                         disp:(BOOL)disp
                        index:(int)index;

// 쥤䡼޻
-(id)createLayerLockSetter:(BOOL)exec
                      lock:(BOOL)lock
                     index:(int)index;

// 쥤䡼̾
-(id)createLayerNameSetter:(BOOL)exec
                      name:(NSString *)name
                     index:(int)index;

// 쥤䡼
-(id)createPictureLayerUnificater:(BOOL)exec;

// ѹ
-(id)createCanvasResizer:(BOOL)exec
                   isFit:(BOOL)fit
                   width:(int)width
                  height:(int)height;

// ڤȴ
-(id)createImageClipper:(BOOL)exec
                   rect:(PoCoRect *)rect;

// ִ
-(id)createPictureBitmapReplacer:(BOOL)exec
                           layer:(int)index
                            rect:(PoCoRect *)rect
                          bitmap:(PoCoBitmap *)bitmap
                            name:(NSString *)name;

// 顼ѥ
-(id)createColorPatternSetter:(BOOL)exec
                          num:(int)num
                        layer:(int)index
                         rect:(PoCoRect *)rect;
-(id)createColorPatternSetter:(BOOL)exec
                          num:(int)num
                      pattern:(PoCoColorPattern *)pat;

// ͳ
-(id)createNormalFreeLineEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                        undoName:(NSString *)name;
-(id)createUniformedDensityFreeLineEditter:(BOOL)exec
                                     layer:(int)index
                                     start:(PoCoPoint *)start
                                       end:(PoCoPoint *)end
                                  undoName:(NSString *)name;
-(id)createDensityFreeLineEditter:(BOOL)exec
                            layer:(int)index
                            start:(PoCoPoint *)start
                              end:(PoCoPoint *)end
                         undoName:(NSString *)name;
-(id)createAtomizerFreeLineEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                          undoName:(NSString *)name;
-(id)createGradationFreeLineEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                           undoName:(NSString *)name;
-(id)createRandomFreeLineEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                        undoName:(NSString *)name;
-(id)createWaterDropFreeLineEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                           undoName:(NSString *)name;

// ľ
-(id)createInvertLineEditter:(BOOL)exec
                       layer:(int)index
                       start:(PoCoPoint *)start
                         end:(PoCoPoint *)end;

// ľ
-(id)createInvertPolylineEditter:(BOOL)exec
                           layer:(int)index
                            poly:(NSMutableArray *)points;
-(id)createInvertPolygonEditter:(BOOL)exec
                          layer:(int)index
                           poly:(NSMutableArray *)points;

// ľ()
-(id)createInvertCurveWithPointsEditter:(BOOL)exec
                                  layer:(int)index
                                 points:(NSMutableArray *)points
                                   type:(PoCoCurveWithPointsType)type
                                   freq:(unsigned int)freq;
-(id)createNormalCurveWithPointsEditter:(BOOL)exec
                                  layer:(int)index
                                 points:(NSMutableArray *)points
                                   type:(PoCoCurveWithPointsType)type
                                   freq:(unsigned int)freq;
-(id)createUniformedDensityCurveWithPointsEditter:(BOOL)exec
                                            layer:(int)index
                                           points:(NSMutableArray *)points
                                             type:(PoCoCurveWithPointsType)type
                                             freq:(unsigned int)freq;
-(id)createDensityCurveWithPointsEditter:(BOOL)exec
                                   layer:(int)index
                                  points:(NSMutableArray *)points
                                    type:(PoCoCurveWithPointsType)type
                                    freq:(unsigned int)freq;
-(id)createAtomizerCurveWithPointsEditter:(BOOL)exec
                                    layer:(int)index
                                   points:(NSMutableArray *)points
                                     type:(PoCoCurveWithPointsType)type
                                     freq:(unsigned int)freq;
-(id)createGradationCurveWithPointsEditter:(BOOL)exec
                                     layer:(int)index
                                    points:(NSMutableArray *)points
                                      type:(PoCoCurveWithPointsType)type
                                      freq:(unsigned int)freq;
-(id)createRandomCurveWithPointsEditter:(BOOL)exec
                                  layer:(int)index
                                 points:(NSMutableArray *)points
                                   type:(PoCoCurveWithPointsType)type
                                   freq:(unsigned int)freq;
-(id)createWaterDropCurveWithPointsEditter:(BOOL)exec
                                     layer:(int)index
                                    points:(NSMutableArray *)points
                                      type:(PoCoCurveWithPointsType)type
                                      freq:(unsigned int)freq;

// 
-(id)createInvertBoxEditter:(BOOL)exec
                      layer:(int)index
                      start:(PoCoPoint *)start
                        end:(PoCoPoint *)end
                orientation:(PoCoPoint *)ort;
-(id)createNormalBoxEditter:(BOOL)exec
                      layer:(int)index
                      start:(PoCoPoint *)start
                        end:(PoCoPoint *)end
                orientation:(PoCoPoint *)ort;
-(id)createUniformedDensityBoxEditter:(BOOL)exec
                                layer:(int)index
                                start:(PoCoPoint *)start
                                  end:(PoCoPoint *)end
                          orientation:(PoCoPoint *)ort;
-(id)createDensityBoxEditter:(BOOL)exec
                       layer:(int)index
                       start:(PoCoPoint *)start
                         end:(PoCoPoint *)end
                 orientation:(PoCoPoint *)ort;
-(id)createAtomizerBoxEditter:(BOOL)exec
                        layer:(int)index
                        start:(PoCoPoint *)start
                          end:(PoCoPoint *)end
                  orientation:(PoCoPoint *)ort;
-(id)createGradationBoxEditter:(BOOL)exec
                         layer:(int)index
                         start:(PoCoPoint *)start
                           end:(PoCoPoint *)end
                   orientation:(PoCoPoint *)ort;
-(id)createRandomBoxEditter:(BOOL)exec
                      layer:(int)index
                      start:(PoCoPoint *)start
                        end:(PoCoPoint *)end
                orientation:(PoCoPoint *)ort;
-(id)createWaterDropBoxEditter:(BOOL)exec
                         layer:(int)index
                         start:(PoCoPoint *)start
                           end:(PoCoPoint *)end
                   orientation:(PoCoPoint *)ort;

// /ʱ
-(id)createInvertEllipseEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort;
-(id)createNormalEllipseEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort;
-(id)createUniformedDensityEllipseEditter:(BOOL)exec
                                    layer:(int)index
                                    start:(PoCoPoint *)start
                                      end:(PoCoPoint *)end
                              orientation:(PoCoPoint *)ort;
-(id)createDensityEllipseEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                     orientation:(PoCoPoint *)ort;
-(id)createAtomizerEllipseEditter:(BOOL)exec
                            layer:(int)index
                            start:(PoCoPoint *)start
                              end:(PoCoPoint *)end
                      orientation:(PoCoPoint *)ort;
-(id)createGradationEllipseEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort;
-(id)createRandomEllipseEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort;
-(id)createWaterDropEllipseEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort;

// ʿԻշ
-(id)createInvertParallelogramEditter:(BOOL)exec
                                layer:(int)index
                                first:(PoCoPoint *)first
                               second:(PoCoPoint *)second
                                third:(PoCoPoint *)third;
-(id)createNormalParallelogramEditter:(BOOL)exec
                                layer:(int)index
                                first:(PoCoPoint *)first
                               second:(PoCoPoint *)second
                                third:(PoCoPoint *)third;
-(id)createUniformedDensityParallelogramEditter:(BOOL)exec
                                          layer:(int)index
                                          first:(PoCoPoint *)first
                                         second:(PoCoPoint *)second
                                          third:(PoCoPoint *)third;
-(id)createDensityParallelogramEditter:(BOOL)exec
                                 layer:(int)index
                                 first:(PoCoPoint *)first
                                second:(PoCoPoint *)second
                                 third:(PoCoPoint *)third;
-(id)createAtomizerParallelogramEditter:(BOOL)exec
                                  layer:(int)index
                                  first:(PoCoPoint *)first
                                 second:(PoCoPoint *)second
                                  third:(PoCoPoint *)third;
-(id)createGradationParallelogramEditter:(BOOL)exec
                                   layer:(int)index
                                   first:(PoCoPoint *)first
                                  second:(PoCoPoint *)second
                                   third:(PoCoPoint *)third;
-(id)createRandomParallelogramEditter:(BOOL)exec
                                layer:(int)index
                                first:(PoCoPoint *)first
                               second:(PoCoPoint *)second
                                third:(PoCoPoint *)third;
-(id)createWaterDropParallelogramEditter:(BOOL)exec
                                   layer:(int)index
                                   first:(PoCoPoint *)first
                                  second:(PoCoPoint *)second
                                   third:(PoCoPoint *)third;

// ɤĤ֤
-(id)createNormalBoxFillEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort;
-(id)createUniformedDensityBoxFillEditter:(BOOL)exec
                                    layer:(int)index
                                    start:(PoCoPoint *)start
                                      end:(PoCoPoint *)end
                              orientation:(PoCoPoint *)ort;
-(id)createDensityBoxFillEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                     orientation:(PoCoPoint *)ort;
-(id)createAtomizerBoxFillEditter:(BOOL)exec
                            layer:(int)index
                            start:(PoCoPoint *)start
                              end:(PoCoPoint *)end
                      orientation:(PoCoPoint *)ort;
-(id)createGradationBoxFillEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort;
-(id)createRandomBoxFillEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort;
-(id)createWaterDropBoxFillEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort;

// ɤĤ֤/ʱ
-(id)createNormalEllipseFillEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                        orientation:(PoCoPoint *)ort;
-(id)createUniformedDensityEllipseFillEditter:(BOOL)exec
                                        layer:(int)index
                                        start:(PoCoPoint *)start
                                          end:(PoCoPoint *)end
                                  orientation:(PoCoPoint *)ort;
-(id)createDensityEllipseFillEditter:(BOOL)exec
                               layer:(int)index
                               start:(PoCoPoint *)start
                                 end:(PoCoPoint *)end
                         orientation:(PoCoPoint *)ort;
-(id)createAtomizerEllipseFillEditter:(BOOL)exec
                                layer:(int)index
                                start:(PoCoPoint *)start
                                  end:(PoCoPoint *)end
                          orientation:(PoCoPoint *)ort;
-(id)createGradationEllipseFillEditter:(BOOL)exec
                                 layer:(int)index
                                 start:(PoCoPoint *)start
                                   end:(PoCoPoint *)end
                           orientation:(PoCoPoint *)ort;
-(id)createRandomEllipseFillEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                        orientation:(PoCoPoint *)ort;
-(id)createWaterDropEllipseFillEditter:(BOOL)exec
                                 layer:(int)index
                                 start:(PoCoPoint *)start
                                   end:(PoCoPoint *)end
                           orientation:(PoCoPoint *)ort;

// ɤĤ֤ʿԻշ
-(id)createNormalParallelogramFillEditter:(BOOL)exec
                                    layer:(int)index
                                    first:(PoCoPoint *)first
                                   second:(PoCoPoint *)second
                                    third:(PoCoPoint *)third;
-(id)createUniformedDensityParallelogramFillEditter:(BOOL)exec
                                              layer:(int)index
                                              first:(PoCoPoint *)first
                                             second:(PoCoPoint *)second
                                              third:(PoCoPoint *)third;
-(id)createDensityParallelogramFillEditter:(BOOL)exec
                                     layer:(int)index
                                     first:(PoCoPoint *)first
                                    second:(PoCoPoint *)second
                                     third:(PoCoPoint *)third;
-(id)createAtomizerParallelogramFillEditter:(BOOL)exec
                                      layer:(int)index
                                      first:(PoCoPoint *)first
                                     second:(PoCoPoint *)second
                                      third:(PoCoPoint *)third;
-(id)createGradationParallelogramFillEditter:(BOOL)exec
                                       layer:(int)index
                                       first:(PoCoPoint *)first
                                      second:(PoCoPoint *)second
                                       third:(PoCoPoint *)third;
-(id)createRandomParallelogramFillEditter:(BOOL)exec
                                    layer:(int)index
                                    first:(PoCoPoint *)first
                                   second:(PoCoPoint *)second
                                    third:(PoCoPoint *)third;
-(id)createWaterDropParallelogramFillEditter:(BOOL)exec
                                       layer:(int)index
                                       first:(PoCoPoint *)first
                                      second:(PoCoPoint *)second
                                       third:(PoCoPoint *)third;

// ɮ㼫ͳ
-(id)createNormalProportionalFreeLineEditter:(BOOL)exec
                                       layer:(int)index
                                       start:(PoCoPoint *)start
                                         end:(PoCoPoint *)end
                                    undoName:(NSString *)name;
-(id)createUniformedDensityProportionalFreeLineEditter:(BOOL)exec
                                                 layer:(int)index
                                                 start:(PoCoPoint *)start
                                                   end:(PoCoPoint *)end
                                              undoName:(NSString *)name;
-(id)createDensityProportionalFreeLineEditter:(BOOL)exec
                                        layer:(int)index
                                        start:(PoCoPoint *)start
                                          end:(PoCoPoint *)end
                                      undoName:(NSString *)name;
-(id)createAtomizerProportionalFreeLineEditter:(BOOL)exec
                                         layer:(int)index
                                         start:(PoCoPoint *)start
                                           end:(PoCoPoint *)end
                                      undoName:(NSString *)name;
-(id)createGradationProportionalFreeLineEditter:(BOOL)exec
                                          layer:(int)index
                                          start:(PoCoPoint *)start
                                            end:(PoCoPoint *)end
                                       undoName:(NSString *)name;
-(id)createRandomProportionalFreeLineEditter:(BOOL)exec
                                       layer:(int)index
                                       start:(PoCoPoint *)start
                                         end:(PoCoPoint *)end
                                    undoName:(NSString *)name;
-(id)createWaterDropProportionalFreeLineEditter:(BOOL)exec
                                          layer:(int)index
                                          start:(PoCoPoint *)start
                                            end:(PoCoPoint *)end
                                       undoName:(NSString *)name;

// ɤĤ֤
-(id)createInvertRegionFillEditter:(BOOL)exec
                             layer:(int)index
                              rect:(PoCoRect *)r
                              mask:(PoCoBitmap *)mask;
-(id)createInvertRegionBorderEditter:(BOOL)exec
                               layer:(int)index
                                rect:(PoCoRect *)r
                                mask:(PoCoBitmap *)mask;
-(id)createNormalPaintEditter:(BOOL)exec
                        layer:(int)index
                          pos:(PoCoPoint *)pos;

// Žդ
-(id)createNormalPasteImageEditter:(BOOL)exec
                             layer:(int)index
                              rect:(PoCoRect *)r
                            bitmap:(PoCoBitmap *)bmp
                            region:(PoCoBitmap *)mask
                          prevRect:(PoCoRect *)pr
                        prevBitmap:(PoCoBitmap *)pbmp
                           undoName:(NSString *)name;

@end
