//
//	Pelistina on Cocoa - PoCo -
//	Խ
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoControllerFactory.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"
#import "PoCoLayer.h"
#import "PoCoColorBuffer.h"
#import "PoCoCalcRotation.h"

//  controller
#import "PoCoControllerLayerNoEditter.h"
#import "PoCoControllerPaletteNoEditter.h"
#import "PoCoControllerResizeNoEditter.h"
#import "PoCoControllerClipNoEditter.h"

#import "PoCoControllerPaletteIncrementer.h"
#import "PoCoControllerPaletteDecrementer.h"
#import "PoCoControllerPaletteAttributeSetter.h"
#import "PoCoControllerPaletteGradationMaker.h"
#import "PoCoControllerPaletteElementSetter.h"
#import "PoCoControllerPaletteImporter.h"
#import "PoCoControllerPaletteSingleSetter.h"

#import "PoCoControllerPictureColorExchanger.h"
#import "PoCoControllerPictureColorPaster.h"
#import "PoCoControllerPictureLayerUnificater.h"
#import "PoCoControllerPictureCanvasResizer.h"
#import "PoCoControllerPictureImageClipper.h"
#import "PoCoControllerPictureBitmapReplacer.h"

#import "PoCoControllerLayerBitmapAdder.h"
#import "PoCoControllerLayerStringAdder.h"
#import "PoCoControllerLayerDeleter.h"
#import "PoCoControllerLayerInserter.h"
#import "PoCoControllerLayerMover.h"
#import "PoCoControllerLayerDisplaySetter.h"
#import "PoCoControllerLayerLockSetter.h"
#import "PoCoControllerLayerNameSetter.h"

#import "PoCoControllerColorPatternSetter.h"

#import "PoCoControllerInvertLineEditter.h"
#import "PoCoControllerInvertPolylineEditter.h"
#import "PoCoControllerInvertPolygonFrameEditter.h"

#import "PoCoControllerInvertCurveWithPointsEditter.h"
#import "PoCoControllerNormalCurveWithPointsEditter.h"
#import "PoCoControllerUniformedDensityCurveWithPointsEditter.h"
#import "PoCoControllerDensityCurveWithPointsEditter.h"
#import "PoCoControllerAtomizerCurveWithPointsEditter.h"
#import "PoCoControllerGradationCurveWithPointsEditter.h"
#import "PoCoControllerRandomCurveWithPointsEditter.h"
#import "PoCoControllerWaterDropCurveWithPointsEditter.h"

#import "PoCoControllerInvertBoxFrameEditter.h"
#import "PoCoControllerNormalBoxFrameEditter.h"
#import "PoCoControllerUniformedDensityBoxFrameEditter.h"
#import "PoCoControllerDensityBoxFrameEditter.h"
#import "PoCoControllerAtomizerBoxFrameEditter.h"
#import "PoCoControllerGradationBoxFrameEditter.h"
#import "PoCoControllerRandomBoxFrameEditter.h"
#import "PoCoControllerWaterDropBoxFrameEditter.h"

#import "PoCoControllerInvertEllipseFrameEditter.h"
#import "PoCoControllerNormalEllipseFrameEditter.h"
#import "PoCoControllerUniformedDensityEllipseFrameEditter.h"
#import "PoCoControllerDensityEllipseFrameEditter.h"
#import "PoCoControllerAtomizerEllipseFrameEditter.h"
#import "PoCoControllerGradationEllipseFrameEditter.h"
#import "PoCoControllerRandomEllipseFrameEditter.h"
#import "PoCoControllerWaterDropEllipseFrameEditter.h"

#import "PoCoControllerInvertParallelogramFrameEditter.h"
#import "PoCoControllerNormalParallelogramFrameEditter.h"
#import "PoCoControllerUniformedDensityParallelogramFrameEditter.h"
#import "PoCoControllerDensityParallelogramFrameEditter.h"
#import "PoCoControllerAtomizerParallelogramFrameEditter.h"
#import "PoCoControllerGradationParallelogramFrameEditter.h"
#import "PoCoControllerRandomParallelogramFrameEditter.h"
#import "PoCoControllerWaterDropParallelogramFrameEditter.h"

#import "PoCoControllerNormalBoxFillEditter.h"
#import "PoCoControllerUniformedDensityBoxFillEditter.h"
#import "PoCoControllerDensityBoxFillEditter.h"
#import "PoCoControllerAtomizerBoxFillEditter.h"
#import "PoCoControllerGradationBoxFillEditter.h"
#import "PoCoControllerRandomBoxFillEditter.h"
#import "PoCoControllerWaterDropBoxFillEditter.h"

#import "PoCoControllerNormalEllipseFillEditter.h"
#import "PoCoControllerUniformedDensityEllipseFillEditter.h"
#import "PoCoControllerDensityEllipseFillEditter.h"
#import "PoCoControllerAtomizerEllipseFillEditter.h"
#import "PoCoControllerGradationEllipseFillEditter.h"
#import "PoCoControllerRandomEllipseFillEditter.h"
#import "PoCoControllerWaterDropEllipseFillEditter.h"

#import "PoCoControllerNormalParallelogramFillEditter.h"
#import "PoCoControllerUniformedDensityParallelogramFillEditter.h"
#import "PoCoControllerDensityParallelogramFillEditter.h"
#import "PoCoControllerAtomizerParallelogramFillEditter.h"
#import "PoCoControllerGradationParallelogramFillEditter.h"
#import "PoCoControllerRandomParallelogramFillEditter.h"
#import "PoCoControllerWaterDropParallelogramFillEditter.h"

#import "PoCoControllerNormalProportionalFreeLineEditter.h"
#import "PoCoControllerUniformedDensityProportionalFreeLineEditter.h"
#import "PoCoControllerDensityProportionalFreeLineEditter.h"
#import "PoCoControllerAtomizerProportionalFreeLineEditter.h"
#import "PoCoControllerGradationProportionalFreeLineEditter.h"
#import "PoCoControllerRandomProportionalFreeLineEditter.h"
#import "PoCoControllerWaterDropProportionalFreeLineEditter.h"

#import "PoCoControllerInvertRegionFillEditter.h"
#import "PoCoControllerInvertRegionBorderEditter.h"
#import "PoCoControllerNormalPaintEditter.h"
#import "PoCoControllerNormalPasteImageEditter.h"

// ============================================================================
@implementation PoCoControllerFactory

// --------------------------------------------------------- instance - private
//
// Խоݲ
//
//  Call
//    None
//
//  Return
//    function : Խоݲ
//
-(id)getPict
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] picture];
}


//
// Խ
//
//  Call
//    None
//
//  Return
//    function : Խ
//
-(id)getInfo
{
    return [(PoCoAppController *)([NSApp delegate]) editInfo];
}


//
// ä
//
//  Call
//    None
//
//  Return
//    function : ä
//
-(id)getUndo
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] undoManager];
}


//
// ݻ
//
//  Call
//    None
//
//  Return
//    function : ݻ
//
-(id)getColorBuffer
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] colorBuffer];
}


//
// äѲ
//
//  Call
//    None
//
//  Return
//    function : äѲ
//
-(id)getEraser
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] eraser];
}


//
// ڥ
//
//  Call
//    None
//
//  Return
//    function : ڥ
//
-(id)getPen
{
    return [(PoCoAppController *)([NSApp delegate]) penStyle];
}


//
// ѥ
//
//  Call
//    None
//
//  Return
//    function : ѥ
//
-(id)getTile
{
    return [(PoCoAppController *)([NSApp delegate]) tilePattern];
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//
-(id)init
{
    DPRINT((@"[PoCoControllerFactory init]\n"));

    // super class ν
    self = [super init];

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerFactory dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// 쥤䡼¤̵Խ
//  controller  passive ǸƤˡǸΤꤲ٤Τ
//
//  Call
//    exec   : ¹
//    name   : ä̾
//    update : 쥤䡼¤ι
//
//  Return
//    function : Խμ
//
-(id)createLayerNoEditter:(BOOL)exec
                     name:(NSString *)name
                   update:(BOOL)update
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerNoEditter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
               name:name
             update:update];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerNoEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåȹ̵Խ
//  controller  passive ǸƤˡǸΤꤲ٤Τ
//
//  Call
//    exec  : ¹
//    name  : ä̾
//    index : оݥѥåֹ
//
//  Return
//    function : Խμ
//
-(id)createPaletteNoEditter:(BOOL)exec
                       name:(NSString *)name
                      index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteNoEditter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
               name:name
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteNoEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѹ̵Խ
//  controller  passive ǸƤˡǸΤꤲ٤Τ
//
//  Call
//    exec : ¹
//    name : ä̾
//
//  Return
//    function : Խμ
//
-(id)createResizeNoEditter:(BOOL)exec
                      name:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerResizeNoEditter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
               name:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerResizeNoEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ڤȴ̵Խ
//  controller  passive ǸƤˡǸΤꤲ٤Τ
//
//  Call
//    exec : ¹
//    name : ä̾
//
//  Return
//    function : Խμ
//
-(id)createClipNoEditter:(BOOL)exec
                    name:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerClipNoEditter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
               name:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerClipNoEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåͤβû
//
//  Call
//    exec : ¹
//    n    : оݿֹ
//    r    : Ǥоݤˤ뤫
//    g    : Ǥоݤˤ뤫
//    b    : Ǥоݤˤ뤫
//    s    : 
//
//  Return
//    function : Խμ
//
-(id)createPaletteIncrementer:(BOOL)exec
                          num:(int)n
                          red:(BOOL)r
                        green:(BOOL)g
                         blue:(BOOL)b
                         step:(unsigned int)s
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteIncrementer alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
                num:n
                red:r
              green:g
               blue:b
               step:s];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteIncrementer.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåͤθ
//
//  Call
//    exec : ¹
//    n    : оݿֹ
//    r    : Ǥоݤˤ뤫
//    g    : Ǥоݤˤ뤫
//    b    : Ǥоݤˤ뤫
//    s    : 
//
//  Return
//    function : Խμ
//
-(id)createPaletteDecrementer:(BOOL)exec
                          num:(int)n
                          red:(BOOL)r
                        green:(BOOL)g
                         blue:(BOOL)b
                         step:(unsigned int)s
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteDecrementer alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
                num:n
                red:r
              green:g
               blue:b
               step:s];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteDecrementer.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥå°(1Ȥ)
//
//  Call
//    exec : ¹
//    n    : оݿֹ
//    s    : (flag ξ夲)
//    m    : ɤػߤоݤȤ뤫
//    d    : ۤػߤоݤȤ뤫
//    t    : ƩоݤȤ뤫
//
//  Return
//    function : Խμ
//
-(id)createPaletteAttributeSetter:(BOOL)exec
                              num:(int)n
                          setType:(BOOL)s
                             mask:(BOOL)m
                          dropper:(BOOL)d
                            trans:(BOOL)t
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteAttributeSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
            withNum:n
            setType:s
               mask:m
            dropper:d
              trans:t];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteAttributeSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥå°()
//
//  Call
//    exec : ¹
//    s    : оݿֹ
//    e    : оݿֹ潪
//    m    : ɤػߤ()
//    d    : ۤػߤ()
//    t    : Ʃ()
//
//  Return
//    function : Խμ
//
-(id)createPaletteAttributeSetter:(BOOL)exec
                            start:(int)s
                              end:(int)e
                             mask:(const BOOL *)m
                          dropper:(const BOOL *)d
                            trans:(const BOOL *)t
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteAttributeSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
          withStart:s
            withEnd:e
               mask:m
            dropper:d
              trans:t];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteAttributeSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåȥǡ
//
//  Call
//    exec : ¹
//    s    : ֹ
//    e    : ֹ
//
//  Return
//    function : Խμ
//
-(id)createPaletteGradationMaker:(BOOL)exec
                           start:(int)s
                             end:(int)e
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteGradationMaker alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
           startNum:s
             endNum:e];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteGradationMaker.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥå
//
//  Call
//    exec    : ¹
//    palette : 
//
//  Return
//    function : Խμ
//
-(id)createPaletteElementSetter:(BOOL)exec
                        palette:(PoCoPalette *)palette
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteElementSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
            palette:palette];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteElementSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ñѥå
//
//  Call
//    exec  : ¹
//    num   : оݿֹ
//    red   : 
//    green : 
//    blue  : 
//    mask  : ɤػ
//    drop  : ۤػ
//    trans : Ʃ
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createPaletteSingleSetter:(BOOL)exec
                           num:(int)num
                           red:(unsigned char)red
                         green:(unsigned char)green
                          blue:(unsigned char)blue
                        isMask:(BOOL)mask
                        noDrop:(BOOL)drop
                       isTrans:(BOOL)trans
                          name:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteSingleSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
                num:num
                red:red
              green:green
               blue:blue
             isMask:mask
             noDrop:drop
            isTrans:trans
               name:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteSingleSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåȼ(ڡȥܡɤʣ)
//
//  Call
//    exec    : ¹
//    palette : 
//    flags   : о
//
//  Return
//    function : Խμ
//
-(id)createPaletteImporter:(BOOL)exec
             targetPalette:(PoCoPalette *)target
                 withFlags:(const BOOL *)flags
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPaletteImporter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
      targetPalette:target
          withFlags:flags];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPaletteImporter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåؤ
//
//  Call
//    exec : ¹
//    s    : 򴹸ֹ
//    d    : 迧ֹ
//
//  Return
//    function : Խμ
//
-(id)createPictureColorExchanger:(BOOL)exec
                             src:(int)s
                             dst:(int)d
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureColorExchanger alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
             active:YES
                src:s
                dst:d];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureColorExchanger.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåؤ(̤Τʤ)
//
//  Call
//    exec : ¹
//    s    : 򴹸ֹ
//    d    : 迧ֹ
//
//  Return
//    function : Խμ
//
-(id)createPictureColorExchangerPassive:(BOOL)exec
                                    src:(int)s
                                    dst:(int)d
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureColorExchanger alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
             active:NO
                src:s
                dst:d];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureColorExchanger.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåʣ
//
//  Call
//    exec : ¹
//    s    : ʣ̸ֹ
//    d    : ʣ迧ֹ
//
//  Return
//    function : Խμ
//
-(id)createPictureColorPaster:(BOOL)exec
                          src:(int)s
                          dst:(int)d
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureColorPaster alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
             active:YES
                src:s
                dst:d];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureColorPaster.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѥåʣ(̤Τʤ)
//
//  Call
//    exec : ¹
//    s    : ʣ̸ֹ
//    d    : ʣ迧ֹ
//
//  Return
//    function : Խμ
//
-(id)createPictureColorPasterPassive:(BOOL)exec
                                 src:(int)s
                                 dst:(int)d
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureColorPaster alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             buffer:[self getColorBuffer]
             active:NO
                src:s
                dst:d];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureColorPaster.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼ɲ
//
//  Call
//    exec : ¹
//    c    : 
//
//  Return
//    function : Խμ
//
-(id)createLayerBitmapAdder:(BOOL)exec
                      color:(unsigned char)c
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerBitmapAdder alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
              color:c];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerBitmapAdder.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʸ쥤䡼ɲ
//
//  Call
//    exec : ¹
//    c    : 
//
//  Return
//    function : Խμ
//
-(id)createLayerStringAdder:(BOOL)exec
                      color:(unsigned char)c
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerStringAdder alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
              color:c];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerStringAdder.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼
//
//  Call
//    exec  : ¹
//    index : о
//
//  Return
//    function : Խμ
//
-(id)createLayerDeleter:(BOOL)exec
                  index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerDeleter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             active:YES
            atIndex:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerDeleter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼(̤Τʤ)
//
//  Call
//    exec  : ¹
//    index : о
//
//  Return
//    function : Խμ
//
-(id)createLayerDeleterPassive:(BOOL)exec
                         index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerDeleter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             active:NO
            atIndex:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerDeleter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼
//
//  Call
//    exec  : ¹
//    layer : 쥤䡼
//    index : 
//
//  Return
//    function : Խμ
//
-(id)createLayerInserter:(BOOL)exec
                   layer:(PoCoLayerBase *)layer
                   index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerInserter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             active:YES
              layer:layer
            atIndex:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerInserter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼(̤Τʤ)
//
//  Call
//    exec  : ¹
//    layer : 쥤䡼
//    index : 
//
//  Return
//    function : Խμ
//
-(id)createLayerInserterPassive:(BOOL)exec
                          layer:(PoCoLayerBase *)layer
                          index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerInserter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
             active:NO
              layer:layer
            atIndex:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerInserter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼ư
//
//  Call
//    exec : ¹
//    src  : ư쥤䡼ֹ
//    dst  : ư쥤䡼ֹ
//    copy : YES : ư
//           NO  : ʣ
//
//  Return
//    function : Խμ
//
-(id)createLayerMover:(BOOL)exec
                  src:(int)src
               target:(int)dst
                 copy:(BOOL)copy
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerMover alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
          fromIndex:src
            toIndex:dst
             isCopy:copy];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerMover.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼ɽ
//
//  Call
//    exec  : ¹
//    disp  : 
//    index : о
//
//  Return
//    function : Խμ
//
-(id)createLayerDisplaySetter:(BOOL)exec
                         disp:(BOOL)disp
                        index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerDisplaySetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
          isDisplay:disp
            atIndex:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerDisplaySetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼޻
//
//  Call
//    exec  : ¹
//    lock  : 
//    index : о
//
//  Return
//    function : Խμ
//
-(id)createLayerLockSetter:(BOOL)exec
                      lock:(BOOL)lock
                     index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerLockSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
           drawLock:lock
            atIndex:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerLockSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼̾
//
//  Call
//    exec  : ¹
//    name  : ̾
//    index : о
//
//  Return
//    function : Խμ
//
-(id)createLayerNameSetter:(BOOL)exec
                      name:(NSString *)name
                     index:(int)index
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerLayerNameSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
               name:name
            atIndex:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerLayerNameSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 쥤䡼
//
//  Call
//    exec : ¹
//
//  Return
//    function : Խμ
//
-(id)createPictureLayerUnificater:(BOOL)exec
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureLayerUnificater alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureLayerUnificator.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ѹ
//
//  Call
//    exec   : ¹
//    fit    : YES : 
//             NO  : clip
//    width  : (pixel ñ)
//    height : ⤵(pixel ñ)
//
//  Return
//    function : Խμ
//
-(id)createCanvasResizer:(BOOL)exec
                   isFit:(BOOL)fit
                   width:(int)width
                  height:(int)height
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureCanvasResizer alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
              isFit:fit
              width:width
             height:height];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureCanvasResizer.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ڤȴ
//
//  Call
//    exec : ¹
//    rect : ڤȴΰ
//
//  Return
//    function : Խμ
//
-(id)createImageClipper:(BOOL)exec
                   rect:(PoCoRect *)rect
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureImageClipper alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
               rect:rect];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureImageClipper.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ִ
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    rect   : ִΰ
//    bitmap : ִ
//    name   : ä̾
//
//  Return
//    function : Խμ
//
-(id)createPictureBitmapReplacer:(BOOL)exec
                           layer:(int)index
                            rect:(PoCoRect *)rect
                          bitmap:(PoCoBitmap *)bitmap
                            name:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerPictureBitmapReplacer alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
              layer:index
               rect:rect
             bitmap:bitmap
               name:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerPictureBitmapReplacer.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 顼ѥ(쥤䡼)
//
//  Call
//    exec  : ¹
//    num   : оݥ顼ѥֹ
//    layer : 쥤䡼ֹ
//    rect  : 
//
//  Return
//    function : Խμ
//
-(id)createColorPatternSetter:(BOOL)exec
                          num:(int)num
                        layer:(int)index
                         rect:(PoCoRect *)rect
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerColorPatternSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
                num:num
              layer:index
               rect:rect];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerColorPatternSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// 顼ѥ(ѥ)
//
//  Call
//    exec : ¹
//    num  : оݥ顼ѥֹ
//    pat  : ѥ
//
//  Return
//    function : Խμ
//
-(id)createColorPatternSetter:(BOOL)exec
                          num:(int)num
                      pattern:(PoCoColorPattern *)pat
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerColorPatternSetter alloc]
               init:[self getPict]
               info:[self getInfo]
               undo:[self getUndo]
                num:num
            pattern:pat];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerColorPatternSetter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ͳ(̾)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createNormalFreeLineEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                        undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
                pen:[self getPen]
               tile:[self getTile]
              start:start
                end:end
              index:index
               prop:NO
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ͳ(Ѱǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityFreeLineEditter:(BOOL)exec
                                     layer:(int)index
                                     start:(PoCoPoint *)start
                                       end:(PoCoPoint *)end
                                  undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:NO
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ͳ(ǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createDensityFreeLineEditter:(BOOL)exec
                            layer:(int)index
                            start:(PoCoPoint *)start
                              end:(PoCoPoint *)end
                         undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:NO
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ͳ(̸᤭)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createAtomizerFreeLineEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                          undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              start:start
                end:end
              index:index
               prop:NO
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ͳ(ǡ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createGradationFreeLineEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                           undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:NO
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ͳ(Ȼ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createRandomFreeLineEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                        undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              start:start
                end:end
              index:index
               prop:NO
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ͳ(ܤ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createWaterDropFreeLineEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                           undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:NO
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ(ɥ饤)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//
//  Return
//    function : Խμ
//
-(id)createInvertLineEditter:(BOOL)exec
                       layer:(int)index
                       start:(PoCoPoint *)start
                         end:(PoCoPoint *)end
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertLineEditter alloc]
               init:[self getPict]
              start:start
                end:end
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ(ϩ)(ɥ饤)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//
//  Return
//    function : Խμ
//
-(id)createInvertPolylineEditter:(BOOL)exec
                           layer:(int)index
                            poly:(NSMutableArray *)points
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertPolylineEditter alloc]
               init:[self getPict]
               poly:points
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertPolylineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ(ϩ)(ɥ饤)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//
//  Return
//    function : Խμ
//
-(id)createInvertPolygonEditter:(BOOL)exec
                          layer:(int)index
                           poly:(NSMutableArray *)points
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertPolygonFrameEditter alloc]
               init:[self getPict]
               poly:points
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertPolygonFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(ɥ饤)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createInvertCurveWithPointsEditter:(BOOL)exec
                                  layer:(int)index
                                 points:(NSMutableArray *)points
                                   type:(PoCoCurveWithPointsType)type
                                   freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertCurveWithPointsEditter alloc]
               init:[self getPict]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(̾)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createNormalCurveWithPointsEditter:(BOOL)exec
                                  layer:(int)index
                                 points:(NSMutableArray *)points
                                   type:(PoCoCurveWithPointsType)type
                                   freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalCurveWithPointsEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
                pen:[self getPen]
               tile:[self getTile]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(Ѱǻ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityCurveWithPointsEditter:(BOOL)exec
                                            layer:(int)index
                                           points:(NSMutableArray *)points
                                             type:(PoCoCurveWithPointsType)type
                                             freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityCurveWithPointsEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(ǻ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createDensityCurveWithPointsEditter:(BOOL)exec
                                   layer:(int)index
                                  points:(NSMutableArray *)points
                                    type:(PoCoCurveWithPointsType)type
                                    freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityCurveWithPointsEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(̸᤭)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createAtomizerCurveWithPointsEditter:(BOOL)exec
                                    layer:(int)index
                                   points:(NSMutableArray *)points
                                     type:(PoCoCurveWithPointsType)type
                                     freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerCurveWithPointsEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(ǡ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createGradationCurveWithPointsEditter:(BOOL)exec
                                     layer:(int)index
                                    points:(NSMutableArray *)points
                                      type:(PoCoCurveWithPointsType)type
                                      freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationCurveWithPointsEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(Ȼ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createRandomCurveWithPointsEditter:(BOOL)exec
                                  layer:(int)index
                                 points:(NSMutableArray *)points
                                   type:(PoCoCurveWithPointsType)type
                                   freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomCurveWithPointsEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ľ()(ܤ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    points : 
//    type   : ֶμ
//    freq   : ֶ
//
//  Return
//    function : Խμ
//
-(id)createWaterDropCurveWithPointsEditter:(BOOL)exec
                                     layer:(int)index
                                    points:(NSMutableArray *)points
                                      type:(PoCoCurveWithPointsType)type
                                      freq:(unsigned int)freq
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropCurveWithPointsEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
             points:points
               type:type
               freq:freq
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropCurveWithPointsEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (ɥ饤)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createInvertBoxEditter:(BOOL)exec
                      layer:(int)index
                      start:(PoCoPoint *)start
                        end:(PoCoPoint *)end
                orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertBoxFrameEditter alloc]
               init:[self getPict]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (̾)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createNormalBoxEditter:(BOOL)exec
                      layer:(int)index
                      start:(PoCoPoint *)start
                        end:(PoCoPoint *)end
                orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalBoxFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
                pen:[self getPen]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (Ѱǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityBoxEditter:(BOOL)exec
                                layer:(int)index
                                start:(PoCoPoint *)start
                                  end:(PoCoPoint *)end
                          orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityBoxFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (ǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createDensityBoxEditter:(BOOL)exec
                       layer:(int)index
                       start:(PoCoPoint *)start
                         end:(PoCoPoint *)end
                 orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityBoxFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (̸᤭)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createAtomizerBoxEditter:(BOOL)exec
                        layer:(int)index
                        start:(PoCoPoint *)start
                          end:(PoCoPoint *)end
                  orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerBoxFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (ǡ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createGradationBoxEditter:(BOOL)exec
                         layer:(int)index
                         start:(PoCoPoint *)start
                           end:(PoCoPoint *)end
                   orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationBoxFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (Ȼ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createRandomBoxEditter:(BOOL)exec
                      layer:(int)index
                      start:(PoCoPoint *)start
                        end:(PoCoPoint *)end
                orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomBoxFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// (ܤ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createWaterDropBoxEditter:(BOOL)exec
                         layer:(int)index
                         start:(PoCoPoint *)start
                           end:(PoCoPoint *)end
                   orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropBoxFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropBoxFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(ɥ饤)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createInvertEllipseEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertEllipseFrameEditter alloc]
               init:[self getPict]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(̾)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createNormalEllipseEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalEllipseFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
                pen:[self getPen]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(Ѱǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityEllipseEditter:(BOOL)exec
                                    layer:(int)index
                                    start:(PoCoPoint *)start
                                      end:(PoCoPoint *)end
                              orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityEllipseFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(ǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createDensityEllipseEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                     orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityEllipseFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(̸᤭)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createAtomizerEllipseEditter:(BOOL)exec
                            layer:(int)index
                            start:(PoCoPoint *)start
                              end:(PoCoPoint *)end
                      orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerEllipseFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(ǡ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createGradationEllipseEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationEllipseFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(Ȼ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createRandomEllipseEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomEllipseFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// /ʱ(ܤ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createWaterDropEllipseEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropEllipseFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropEllipseFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(ɥ饤)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createInvertParallelogramEditter:(BOOL)exec
                                layer:(int)index
                                first:(PoCoPoint *)first
                               second:(PoCoPoint *)second
                                third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertParallelogramFrameEditter alloc]
               init:[self getPict]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(̾)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createNormalParallelogramEditter:(BOOL)exec
                                layer:(int)index
                                first:(PoCoPoint *)first
                               second:(PoCoPoint *)second
                                third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalParallelogramFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
                pen:[self getPen]
               tile:[self getTile]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(Ѱǻ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityParallelogramEditter:(BOOL)exec
                                          layer:(int)index
                                          first:(PoCoPoint *)first
                                         second:(PoCoPoint *)second
                                          third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityParallelogramFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(ǻ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createDensityParallelogramEditter:(BOOL)exec
                                 layer:(int)index
                                 first:(PoCoPoint *)first
                                second:(PoCoPoint *)second
                                 third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityParallelogramFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(̸᤭)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createAtomizerParallelogramEditter:(BOOL)exec
                                  layer:(int)index
                                  first:(PoCoPoint *)first
                                 second:(PoCoPoint *)second
                                  third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerParallelogramFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(ǡ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createGradationParallelogramEditter:(BOOL)exec
                                   layer:(int)index
                                   first:(PoCoPoint *)first
                                  second:(PoCoPoint *)second
                                   third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationParallelogramFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(Ȼ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createRandomParallelogramEditter:(BOOL)exec
                                layer:(int)index
                                first:(PoCoPoint *)first
                               second:(PoCoPoint *)second
                                third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomParallelogramFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ʿԻշ(ܤ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createWaterDropParallelogramEditter:(BOOL)exec
                                   layer:(int)index
                                   first:(PoCoPoint *)first
                                  second:(PoCoPoint *)second
                                   third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropParallelogramFrameEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropParallelogramFrameEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(̾)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createNormalBoxFillEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalBoxFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalBoxFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(ñǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityBoxFillEditter:(BOOL)exec
                                    layer:(int)index
                                    start:(PoCoPoint *)start
                                      end:(PoCoPoint *)end
                              orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityBoxFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityBoxFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(ǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createDensityBoxFillEditter:(BOOL)exec
                           layer:(int)index
                           start:(PoCoPoint *)start
                             end:(PoCoPoint *)end
                     orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityBoxFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityBoxFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(̸᤭)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createAtomizerBoxFillEditter:(BOOL)exec
                            layer:(int)index
                            start:(PoCoPoint *)start
                              end:(PoCoPoint *)end
                      orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerBoxFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerBoxFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(ǡ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createGradationBoxFillEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationBoxFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationBoxFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(Ȼ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createRandomBoxFillEditter:(BOOL)exec
                          layer:(int)index
                          start:(PoCoPoint *)start
                            end:(PoCoPoint *)end
                    orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomBoxFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomBoxFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(ܤ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createWaterDropBoxFillEditter:(BOOL)exec
                             layer:(int)index
                             start:(PoCoPoint *)start
                               end:(PoCoPoint *)end
                       orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropBoxFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropBoxFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤/ʱ(̾)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createNormalEllipseFillEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                        orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalEllipseFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalEllipseFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤/ʱ(ñǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityEllipseFillEditter:(BOOL)exec
                                        layer:(int)index
                                        start:(PoCoPoint *)start
                                          end:(PoCoPoint *)end
                                  orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityEllipseFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityEllipseFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤/ʱ(ǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createDensityEllipseFillEditter:(BOOL)exec
                               layer:(int)index
                               start:(PoCoPoint *)start
                                 end:(PoCoPoint *)end
                         orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityEllipseFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityEllipseFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤/ʱ(̸᤭)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createAtomizerEllipseFillEditter:(BOOL)exec
                                layer:(int)index
                                start:(PoCoPoint *)start
                                  end:(PoCoPoint *)end
                          orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerEllipseFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerEllipseFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤/ʱ(ǡ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createGradationEllipseFillEditter:(BOOL)exec
                                 layer:(int)index
                                 start:(PoCoPoint *)start
                                   end:(PoCoPoint *)end
                           orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationEllipseFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationEllipseFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤/ʱ(Ȼ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createRandomEllipseFillEditter:(BOOL)exec
                              layer:(int)index
                              start:(PoCoPoint *)start
                                end:(PoCoPoint *)end
                        orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomEllipseFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomEllipseFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤/ʱ(ܤ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : 
//    end   : 
//    ort   : 
//
//  Return
//    function : Խμ
//
-(id)createWaterDropEllipseFillEditter:(BOOL)exec
                                 layer:(int)index
                                 start:(PoCoPoint *)start
                                   end:(PoCoPoint *)end
                           orientation:(PoCoPoint *)ort
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropEllipseFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              start:start
                end:end
        orientation:ort
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropEllipseFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤ʿԻշ(̾)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createNormalParallelogramFillEditter:(BOOL)exec
                                    layer:(int)index
                                    first:(PoCoPoint *)first
                                   second:(PoCoPoint *)second
                                    third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalParallelogramFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
               tile:[self getTile]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalParallelogramFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤ʿԻշ(ñǻ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityParallelogramFillEditter:(BOOL)exec
                                              layer:(int)index
                                              first:(PoCoPoint *)first
                                             second:(PoCoPoint *)second
                                              third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityParallelogramFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityParallelogramFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤ʿԻշ(ǻ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createDensityParallelogramFillEditter:(BOOL)exec
                                     layer:(int)index
                                     first:(PoCoPoint *)first
                                    second:(PoCoPoint *)second
                                     third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityParallelogramFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityParallelogramFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤ʿԻշ(̸᤭)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createAtomizerParallelogramFillEditter:(BOOL)exec
                                      layer:(int)index
                                      first:(PoCoPoint *)first
                                     second:(PoCoPoint *)second
                                      third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerParallelogramFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerParallelogramFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤ʿԻշ(ǡ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createGradationParallelogramFillEditter:(BOOL)exec
                                       layer:(int)index
                                       first:(PoCoPoint *)first
                                      second:(PoCoPoint *)second
                                       third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationParallelogramFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationParallelogramFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤ʿԻշ(Ȼ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createRandomParallelogramFillEditter:(BOOL)exec
                                    layer:(int)index
                                    first:(PoCoPoint *)first
                                   second:(PoCoPoint *)second
                                    third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomParallelogramFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomParallelogramFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤ʿԻշ(ܤ)
//
//  Call
//    exec   : ¹
//    index  : оݥ쥤䡼ֹ
//    first  : 1
//    second : 2
//    third  : 3
//
//  Return
//    function : Խμ
//
-(id)createWaterDropParallelogramFillEditter:(BOOL)exec
                                       layer:(int)index
                                       first:(PoCoPoint *)first
                                      second:(PoCoPoint *)second
                                       third:(PoCoPoint *)third
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropParallelogramFillEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              first:first
             second:second
              third:third
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropParallelogramFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɮ㼫ͳ(̾)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createNormalProportionalFreeLineEditter:(BOOL)exec
                                       layer:(int)index
                                       start:(PoCoPoint *)start
                                         end:(PoCoPoint *)end
                                    undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
                pen:[self getPen]
               tile:[self getTile]
              start:start
                end:end
              index:index
               prop:YES
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɮ㼫ͳ(Ѱǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createUniformedDensityProportionalFreeLineEditter:(BOOL)exec
                                                 layer:(int)index
                                                 start:(PoCoPoint *)start
                                                   end:(PoCoPoint *)end
                                              undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerUniformedDensityProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:YES
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerUniformedDensityProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɮ㼫ͳ(ǻ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createDensityProportionalFreeLineEditter:(BOOL)exec
                                        layer:(int)index
                                        start:(PoCoPoint *)start
                                          end:(PoCoPoint *)end
                                     undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerDensityProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:YES
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerDensityProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɮ㼫ͳ(̸᤭)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createAtomizerProportionalFreeLineEditter:(BOOL)exec
                                         layer:(int)index
                                         start:(PoCoPoint *)start
                                           end:(PoCoPoint *)end
                                      undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerAtomizerProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
              start:start
                end:end
              index:index
               prop:YES
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerAtomizerProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɮ㼫ͳ(ǡ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createGradationProportionalFreeLineEditter:(BOOL)exec
                                          layer:(int)index
                                          start:(PoCoPoint *)start
                                            end:(PoCoPoint *)end
                                       undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerGradationProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:YES
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerGradationProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɮ㼫ͳ(Ȼ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createRandomProportionalFreeLineEditter:(BOOL)exec
                                       layer:(int)index
                                       start:(PoCoPoint *)start
                                         end:(PoCoPoint *)end
                                    undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerRandomProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
              start:start
                end:end
              index:index
               prop:YES
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerRandomProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɮ㼫ͳ(ܤ)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    start : ()
//    end   : ()
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createWaterDropProportionalFreeLineEditter:(BOOL)exec
                                          layer:(int)index
                                          start:(PoCoPoint *)start
                                            end:(PoCoPoint *)end
                                       undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerWaterDropProportionalFreeLineEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             buffer:[self getColorBuffer]
              start:start
                end:end
              index:index
               prop:YES
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerWaterDropProportionalFreeLineEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(Ǥշ)(ɥ饤)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    r     : 
//    mask  : ޥ
//
//  Return
//    function : Խμ
//
-(id)createInvertRegionFillEditter:(BOOL)exec
                             layer:(int)index
                              rect:(PoCoRect *)r
                              mask:(PoCoBitmap *)mask
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertRegionFillEditter alloc]
               init:[self getPict]
               mask:mask
               rect:r
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertRegionFillEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(Ǥշ)(ɥ饤)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    r     : 
//    mask  : ޥ
//
//  Return
//    function : Խμ
//
-(id)createInvertRegionBorderEditter:(BOOL)exec
                               layer:(int)index
                                rect:(PoCoRect *)r
                                mask:(PoCoBitmap *)mask
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerInvertRegionBorderEditter alloc]
               init:[self getPict]
               mask:mask
               rect:r
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerInvertRegionBorderEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// ɤĤ֤(seed paint)
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    pos   : 
//
//  Return
//    function : Խμ
//
-(id)createNormalPaintEditter:(BOOL)exec
                        layer:(int)index
                          pos:(PoCoPoint *)pos
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalPaintEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
             eraser:[self getEraser]
               tile:[self getTile]
                pos:pos
              index:index];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalPaintEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}


//
// Žդ
//
//  Call
//    exec  : ¹
//    index : оݥ쥤䡼ֹ
//    r     : Žդ
//    bmp   : Žդ
//    mask  : Ǥΰη
//    pr    : ưζ
//    pbmp  : Խβ
//    name  : ä̾
//
//  Return
//    function : Խμ
//
-(id)createNormalPasteImageEditter:(BOOL)exec
                             layer:(int)index
                              rect:(PoCoRect *)r
                            bitmap:(PoCoBitmap *)bmp
                            region:(PoCoBitmap *)mask
                          prevRect:(PoCoRect *)pr
                        prevBitmap:(PoCoBitmap *)pbmp
                           undoName:(NSString *)name
{
    id cntl;

    cntl = nil;

    // controller 
    cntl = [[PoCoControllerNormalPasteImageEditter alloc]
               init:[self getPict]
               info:[self getInfo] 
               undo:[self getUndo]
               tile:[self getTile]
               rect:r
             bitmap:bmp
             region:mask
           prevRect:pr
         prevBitmap:pbmp
              index:index
           undoName:name];
    if (cntl == nil) {
        DPRINT((@"can't alloc PoCoControllerNormalPasteImageEditter.\n"));
    } else if (exec) {
        // ¹ԤƤ
        [cntl execute];
        [cntl release];
        cntl = nil;
    }

    return cntl;
}

@end
