//
//	Pelistina on Cocoa - PoCo -
//	
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerBase.h"

#import "PoCoLayer.h"
#import "PoCoPenStyle.h"
#import "PoCoTilePattern.h"
#import "PoCoColorPattern.h"
#import "PoCoColorBuffer.h"

// ----------------------------------------------------------------------------
@interface PoCoControllerEditterBase : PoCoControllerBase
{
    PoCoPenStyle *penStyle_;            // ڥ
    PoCoTilePattern *tilePattern_;      // ѥ
    PoCoColorPattern *eraserPattern_;   // äѲ
    PoCoColorBuffer *colorBuffer_;      // ݻ
    int index_;                         // оݥ쥤䡼ֹ
    PoCoLayerBase *layer_;              // оݥ쥤䡼
    PoCoRect *drawRect_;                // ΰ
    PoCoRect *undoRect_;                // äΰ
    PoCoBitmap *undoBitmap_;            // ä
    PoCoColorPattern* drawPattern_;     // ѥ
    PoCoMonochromePattern *drawPen_;    // ѥڥ
    PoCoMonochromePattern *drawTile_;   // ѥѥ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// ϰϤ(ϰ)
-(void)correctRect:(PoCoRect *)r;

// Խ
-(BOOL)startEdit:(PoCoRect *)dr
    withUndoRect:(PoCoRect *)ur;

// Խλ
-(void)endEdit:(NSString *)name;

// Խ
-(void)postNotify:(PoCoRect *)r;
-(void)postNotifyNoEdit:(PoCoRect *)r;

@end


// ----------------------------------------------------------------------------
// ȡɤĤ֤
@interface PoCoControllerBoxEditterBase : PoCoControllerEditterBase
{
    PoCoPoint *startPos_;               // (濴)
    PoCoPoint *endPos_;                 // 轪(濴)
    PoCoPoint *ortPos_;                 // 
    BOOL diagonal_;                     // žгѤ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// ͽΰλ
-(PoCoRect *)calcArea:(int)corr;

// Խ
-(BOOL)startEdit:(int)dc
    withUndoCorr:(int)uc;

// Խλ
-(void)endEdit:(NSString *)name;

@end


// ----------------------------------------------------------------------------
// /ʱߡɤĤ֤/ʱ
@interface PoCoControllerEllipseEditterBase : PoCoControllerEditterBase
{
    PoCoPoint *startPos_;               // (濴)
    PoCoPoint *endPos_;                 // 轪(濴)
    PoCoPoint *ortPos_;                 // 
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// ͽΰλ
-(PoCoRect *)calcArea:(int)corr;

// Խ
-(BOOL)startEdit:(int)dc
    withUndoCorr:(int)uc;

// Խλ
-(void)endEdit:(NSString *)name;

@end


// ----------------------------------------------------------------------------
// ʿԻշɤĤ֤ʿԻշ
@interface PoCoControllerParallelogramEditterBase : PoCoControllerEditterBase
{
    PoCoPoint *firstPos_;               // 1(濴)
    PoCoPoint *secondPos_;              // 2(濴)
    PoCoPoint *thirdPos_;               // 3(濴)
    PoCoPoint *fourthPos_;              // 4(濴)
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
    withFirst:(PoCoPoint *)f
   withSecond:(PoCoPoint *)s
    withThird:(PoCoPoint *)t
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// ͽΰλ
-(PoCoRect *)calcArea:(int)corr;

// Խ
-(BOOL)startEdit:(int)dc
    withUndoCorr:(int)uc;

// Խλ
-(void)endEdit:(NSString *)name;

@end


// ----------------------------------------------------------------------------
// ľ()
@interface PoCoControllerCurveEditterBase : PoCoControllerEditterBase
{
    NSMutableArray *points_;            // 
    PoCoCurveWithPointsType type_;      // ˡ
    unsigned int freq_;                 // 
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
   withPoints:(NSMutableArray *)points
     withType:(PoCoCurveWithPointsType)type
     withFreq:(unsigned int)freq
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// ͽΰλ
-(PoCoRect *)calcArea:(int)corr;

// Խ
-(BOOL)startEdit:(int)dc
    withUndoCorr:(int)uc;

// Խλ
-(void)endEdit:(NSString *)name;

@end
