//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerFillEditterBase.h"

#import "PoCoCreateStyleMask.h"

#import "PoCoEditNormalPasteImage.h"
#import "PoCoEditRegionFill.h"
#import "PoCoEditUniformedDensityFill.h"
#import "PoCoEditAtomizerFill.h"
#import "PoCoEditGradationFill.h"
#import "PoCoEditRandomFill.h"

// ============================================================================
@implementation PoCoControllerBoxFillEditterBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    buf    : ݻ
//    tile   : ѥ
//    s      : (濴)
//    e      : 轪(濴)
//    o      : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function   : 
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx
{
//    DPRINT((@"[PoCoControllerBoxFillEditterBase init]\n"));

    // super class 
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:buf
                   withPen:nil
                  withTile:tile
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥ
    if (self != nil) {
        self->trueRect_ = nil;
        self->mask_ = nil;
        self->orgRect_ = nil;
        self->orgBitmap_ = nil;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerBoxFillEditterBase dealloc]\n"));

    // 񸻤
    [self->trueRect_ release];
    [self->mask_ release];
    [self->orgRect_ release];
    [self->orgBitmap_ release];
    self->trueRect_ = nil;
    self->mask_ = nil;
    self->orgRect_ = nil;
    self->orgBitmap_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// Խ
//
//  Call
//    org       : Խ򵭲뤫
//                YES : (orgRect_orgBitmap_ )
//                NO  : ʤ
//    penSize   : ڥ礭
//                == 0 : ڥ礭Ѥʤ
//                != 0 : ڥ礭˱ͤ⻻Ф
//    dc        : ΰ
//    uc        : äΰ
//    picture_  : Խоݲ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    startPos_ : (濴)( instance ѿ)
//    endPos_   : 轪(濴)( instance ѿ)
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    xskip_     : ʿ(instance ѿ)
//    yskip_     : ľ(instance ѿ)
//    x_[]       : ʿɸ(instance ѿ)
//    y_[]       : ľɸ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(BOOL)startEdit:(BOOL)org
     withPenSize:(int)penSize
    withDrawCorr:(int)dc
    withUndoCorr:(int)uc
{
    // ϰ(ϰϳޤ)򻻽
    self->trueRect_ = [super calcArea:0];

    // ޥ
    self->mask_ = [[PoCoCreateStyleMask alloc] init];

    // ̤򻻽
    if (penSize != 0) {
        self->xskip_ = ((float)(([self->endPos_ x] - [self->startPos_ x]) >> 1) / (float)(penSize));
        self->yskip_ = ((float)(([self->endPos_ y] - [self->startPos_ y]) >> 1) / (float)(penSize));
        self->x_[0] =  (float)([self->startPos_ x]);
        self->y_[0] =  (float)([self->startPos_ y]);
        self->x_[1] = ((float)([self->endPos_   x]) + 0.9);
        self->y_[1] = ((float)([self->endPos_   y]) + 0.9);
    }

    // Խ򵭲
    if (org) {
        self->orgRect_ = [self->picture_ bitmapPoCoRect];
        self->orgBitmap_ = [[self->layer_ bitmap] getBitmap:self->orgRect_];
    }

    // super class ز
    return [super startEdit:dc
               withUndoCorr:uc];
}


//
// Խλ
//
//  Call
//    name : ä̾ʸ
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(void)endEdit:(NSString *)name
{
    // ϻ񸻤
    [self->trueRect_ release];
    [self->mask_ release];
    [self->orgRect_ release];
    [self->orgBitmap_ release];
    self->trueRect_ = nil;
    self->mask_ = nil;
    self->orgRect_ = nil;
    self->orgBitmap_ = nil;

    // super class ز
    [super endEdit:name];

    return;
}


//
// ɸư
//
//  Call
//    xskip_ : ʿ(instance ѿ)
//    yskip_ : ľ(instance ѿ)
//
//  Return
//    startPos_ : (濴)( instance ѿ)
//    endPos_   : 轪(濴)( instance ѿ)
//    trueRect_ : ϰ(ϰϳޤ)(instance ѿ)
//    x_[]      : ʿɸ(instance ѿ)
//    y_[]      : ľɸ(instance ѿ)
//
-(void)next
{
    // ɸ򹹿
    self->x_[0] += self->xskip_;
    self->y_[0] += self->yskip_;
    self->x_[1] -= self->xskip_;        
    self->y_[1] -= self->yskip_;
    [self->startPos_ setX:(int)(floor(self->x_[0] + 0.5))
                     setY:(int)(floor(self->y_[0] + 0.5))];
    [self->endPos_   setX:(int)(floor(self->x_[1] + 0.5))
                     setY:(int)(floor(self->y_[1] + 0.5))];

    // ϰϤ˺
    [self->trueRect_ release];
    self->trueRect_ = nil;

    // ϰϤƻ
    self->trueRect_ = [self calcArea:0];

    return;
}


//
// ɤĤ֤
//
//  Call
//    edit      : Խ
//    tile      : ѥ
//    startPos_ : (濴)( instance ѿ)
//    endPos_   : 轪(濴)( instance ѿ)
//    ortPos_   : ( instance ѿ)
//    diagonal_ : žгѤ( instance ѿ)
//    drawRect_ : ΰ( instance ѿ)
//    trueRect_ : ϰ(ϰϳޤ)(instance ѿ)
//    mask_     : ޥ(instance ѿ)
//
//  Return
//    None
//
-(void)drawFill:(id)edit
       withTile:(PoCoMonochromePattern *)tile
{
    if (!([self->trueRect_ empty])) {
        // ޥ
        if ([self->mask_ box:self->startPos_
                         end:self->endPos_
                 orientation:self->ortPos_
                  isDiagonal:self->diagonal_]) {
            // 
            [edit executeDraw:[self->mask_ mask]
                     withTile:tile
                 withTrueRect:self->trueRect_
                 withDrawRect:self->drawRect_];
        }
    }

    return;
}


//
// Խʣ
//  ؿ֤ͤˤϸƤӽФ release 뤳
//
//  Call
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
//  Return
//    function : μ
//
-(PoCoBitmap *)getWorkBitmap
{
    return [self->orgBitmap_ getBitmap:self->orgRect_];
}


//
// ʣ
//
//  Call
//    work      : ѥӥåȥޥå
//    picture_  : Խоݲ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    trueRect_ : ϰ(ϰϳޤ)(instance ѿ)
//    mask_     : ޥ(instance ѿ)
//
//  Return
//    None
//
-(void)pasteFromWork:(PoCoBitmap *)work
{
    PoCoEditNormalPasteImage *edit;
    PoCoBitmap *tmp;

    // žʣƤ
    tmp = [work getBitmap:self->trueRect_];

    // ԽϤ
    edit = [[PoCoEditNormalPasteImage alloc]
               initWithBitmap:[self->layer_ bitmap]
                      palette:[self->picture_ palette]
                         tile:nil
                         mask:[self->mask_ mask]
                  pasteBitmap:tmp];

    // ʣ
    [edit executeDraw:self->trueRect_];

    // 񸻤
    [edit release];
    [tmp release];

    return;
}

@end




// ============================================================================
@implementation PoCoControllerEllipseFillEditterBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    buf    : ݻ
//    tile   : ѥ
//    s      : (濴)
//    e      : 轪(濴)
//    o      : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function   : 
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx
{
//    DPRINT((@"[PoCoControllerEllipseFillEditterBase init]\n"));

    // super class 
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:buf
                   withPen:nil
                  withTile:tile
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥ
    if (self != nil) {
        self->trueRect_ = nil;
        self->mask_ = nil;
        self->orgRect_ = nil;
        self->orgBitmap_ = nil;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerEllipseFillEditterBase dealloc]\n"));

    // 񸻤
    [self->trueRect_ release];
    [self->mask_ release];
    [self->orgRect_ release];
    [self->orgBitmap_ release];
    self->trueRect_ = nil;
    self->mask_ = nil;
    self->orgRect_ = nil;
    self->orgBitmap_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// Խ
//
//  Call
//    org       : Խ򵭲뤫
//                YES : (orgRect_orgBitmap_ )
//                NO  : ʤ
//    penSize   : ڥ礭
//                == 0 : ڥ礭Ѥʤ
//                != 0 : ڥ礭˱ͤ⻻Ф
//    dc        : ΰ
//    uc        : äΰ
//    picture_  : Խоݲ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    startPos_ : (濴)( instance ѿ)
//    endPos_   : 轪(濴)( instance ѿ)
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    xskip_     : ʿ(instance ѿ)
//    yskip_     : ľ(instance ѿ)
//    x_         : ʿɸ(instance ѿ)
//    y_         : ľɸ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(BOOL)startEdit:(BOOL)org
     withPenSize:(int)penSize
    withDrawCorr:(int)dc
    withUndoCorr:(int)uc
{
    // ϰ(ϰϳޤ)򻻽
    self->trueRect_ = [super calcArea:0];

    // ޥ
    self->mask_ = [[PoCoCreateStyleMask alloc] init];

    // ̤򻻽
    if (penSize != 0) {
        self->xskip_ = ((float)([self->endPos_ x] - [self->startPos_ x]) / (float)(penSize));
        self->yskip_ = ((float)([self->endPos_ y] - [self->startPos_ y]) / (float)(penSize));

        self->x_ = (float)([self->endPos_ x]);   
        self->y_ = (float)([self->endPos_ y]);   
    }

    // Խ򵭲
    if (org) {
        self->orgRect_ = [self->picture_ bitmapPoCoRect];
        self->orgBitmap_ = [[self->layer_ bitmap] getBitmap:self->orgRect_];
    }

    // super class ز
    return [super startEdit:dc
               withUndoCorr:uc];

}


//
// Խλ
//
//  Call
//    name : ä̾ʸ
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(void)endEdit:(NSString *)name
{
    // ϻ񸻤
    [self->trueRect_ release];
    [self->mask_ release];
    [self->orgRect_ release];
    [self->orgBitmap_ release];
    self->trueRect_ = nil;
    self->mask_ = nil;
    self->orgRect_ = nil;
    self->orgBitmap_ = nil;

    // super class ز
    [super endEdit:name];

    return;
}


//
// ɸư
//
//  Call
//    xskip_ : ʿ(instance ѿ)
//    yskip_ : ľ(instance ѿ)
//
//  Return
//    endPos_   : 轪(濴)( instance ѿ)
//    trueRect_ : ϰ(ϰϳޤ)(instance ѿ)
//    x_        : ʿɸ(instance ѿ)
//    y_        : ľɸ(instance ѿ)
//
-(void)next
{
    // ɸ򹹿
    self->x_ -= self->xskip_;
    self->y_ -= self->yskip_;
    [self->endPos_ setX:(int)(floor(self->x_ + 0.5))
                   setY:(int)(floor(self->y_ + 0.5))];

    // ϰϤ˺
    [self->trueRect_ release];
    self->trueRect_ = nil;

    // ϰϤƻ
    self->trueRect_ = [self calcArea:0];

    return;
}


//
// ɤĤ֤/ʱߤ
//
//  Call
//    edit      : Խ
//    tile      : ѥ
//    startPos_ : (濴)( instance ѿ)
//    endPos_   : 轪(濴)( instance ѿ)
//    ortPos_   : ( instance ѿ)
//    drawRect_ : ΰ( instance ѿ)
//    trueRect_ : ϰ(ϰϳޤ)(instance ѿ)
//    mask_     : ޥ(instance ѿ)
//
//  Return
//    None
//
-(void)drawFill:(id)edit
       withTile:(PoCoMonochromePattern *)tile
{
    if (!([self->trueRect_ empty])) {
        // ޥ
        if ([self->mask_ ellipse:self->startPos_
                             end:self->endPos_
                     orientation:self->ortPos_]) {
            // 
            [edit executeDraw:[self->mask_ mask]
                     withTile:tile
                 withTrueRect:self->trueRect_
                 withDrawRect:self->drawRect_];
        }
    }

    return;
}


//
// Խʣ
//  ؿ֤ͤˤϸƤӽФ release 뤳
//
//  Call
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
//  Return
//    function : μ
//
-(PoCoBitmap *)getWorkBitmap
{
    return [self->orgBitmap_ getBitmap:self->orgRect_];
}


//
// ʣ
//
//  Call
//    work      : ѥӥåȥޥå
//    picture_  : Խоݲ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    trueRect_ : ϰ(ϰϳޤ)(instance ѿ)
//    mask_     : ޥ(instance ѿ)
//
//  Return
//    None
//
-(void)pasteFromWork:(PoCoBitmap *)work
{
    PoCoEditNormalPasteImage *edit;
    PoCoBitmap *tmp;

    // žʣƤ
    tmp = [work getBitmap:self->trueRect_];

    // ԽϤ
    edit = [[PoCoEditNormalPasteImage alloc]
               initWithBitmap:[self->layer_ bitmap]
                      palette:[self->picture_ palette]
                         tile:nil
                         mask:[self->mask_ mask]
                  pasteBitmap:tmp];

    // ʣ
    [edit executeDraw:self->trueRect_];

    // 񸻤
    [edit release];
    [tmp release];

    return;
}

@end




// ============================================================================
@implementation PoCoControllerParallelogramFillEditterBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    buf    : ݻ
//    tile   : ѥ
//    f      : 1(濴)
//    s      : 2(濴)
//    t      : 3(濴)
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function   : 
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
     withTile:(PoCoTilePattern *)tile
    withFirst:(PoCoPoint *)f
   withSecond:(PoCoPoint *)s
    withThird:(PoCoPoint *)t
      atIndex:(int)idx
{
//    DPRINT((@"[PoCoControllerParallelogramFillEditterBase init]\n"));

    // super class 
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:buf
                   withPen:nil
                  withTile:tile
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥ
    if (self != nil) {
        self->trueRect_ = nil;
        self->mask_ = nil;
        self->orgRect_ = nil;
        self->orgBitmap_ = nil;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerParallelogramFillEditterBase dealloc]\n"));

    // 񸻤
    [self->trueRect_ release];
    [self->mask_ release];
    [self->orgRect_ release];
    [self->orgBitmap_ release];
    self->trueRect_ = nil;
    self->mask_ = nil;
    self->orgRect_ = nil;
    self->orgBitmap_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// Խ
//
//  Call
//    org        : Խ򵭲뤫
//                 YES : (orgRect_orgBitmap_ )
//                 NO  : ʤ
//    penSize    : ڥ礭
//                 == 0 : ڥ礭Ѥʤ
//                 != 0 : ڥ礭˱ͤ⻻Ф
//    dc         : ΰ
//    uc         : äΰ
//    picture_   : Խоݲ( instance ѿ)
//    layer_     : оݥ쥤䡼( instance ѿ)
//    firstPos_  : 1(濴)( instance ѿ)
//    secondPos_ : 2(濴)( instance ѿ)
//    thirdPos_  : 3(濴)( instance ѿ)
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    xskip_     : ʿ(instance ѿ)
//    yskip_     : ľ(instance ѿ)
//    x_[]       : ʿɸ(instance ѿ)
//    y_[]       : ľɸ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(BOOL)startEdit:(BOOL)org
     withPenSize:(int)penSize
    withDrawCorr:(int)dc
    withUndoCorr:(int)uc
{
    // ϰ(ϰϳޤ)򻻽
    self->trueRect_ = [super calcArea:0];

    // ޥ
    self->mask_ = [[PoCoCreateStyleMask alloc] init];

    // ̤򻻽
    if (penSize != 0) {
        self->xskip_ = ((float)([self->thirdPos_ x] - [self->secondPos_ x]) / (float)(penSize));
        self->yskip_ = ((float)([self->thirdPos_ y] - [self->secondPos_ y]) / (float)(penSize));
        self->x_[0] = (float)([self->firstPos_  x]);
        self->y_[0] = (float)([self->firstPos_  y]);
        self->x_[1] = (float)([self->secondPos_ x]);
        self->y_[1] = (float)([self->secondPos_ y]);
    }

    // Խ򵭲
    if (org) {
        self->orgRect_ = [self->picture_ bitmapPoCoRect];
        self->orgBitmap_ = [[self->layer_ bitmap] getBitmap:self->orgRect_];
    }

    // super class ز
    return [super startEdit:dc
               withUndoCorr:uc];

}


//
// Խλ
//
//  Call
//    name : ä̾ʸ
//
//  Return
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
-(void)endEdit:(NSString *)name
{
    // ϻ񸻤
    [self->trueRect_ release];
    [self->mask_ release];
    [self->orgRect_ release];
    [self->orgBitmap_ release];
    self->trueRect_ = nil;
    self->mask_ = nil;
    self->orgRect_ = nil;
    self->orgBitmap_ = nil;

    // super class ز
    [super endEdit:name];

    return;
}


//
// ɸư
//
//  Call
//    xskip_ : ʿ(instance ѿ)
//    yskip_ : ľ(instance ѿ)
//
//  Return
//    firstPos_  : 1(濴)( instance ѿ)
//    secondPos_ : 2(濴)( instance ѿ)
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    x_[]       : ʿɸ(instance ѿ)
//    y_[]       : ľɸ(instance ѿ)
//
-(void)next
{
    // ɸ򹹿
    self->x_[0] += self->xskip_;
    self->y_[0] += self->yskip_;
    self->x_[1] += self->xskip_;
    self->y_[1] += self->yskip_;
    [self->firstPos_  setX:(int)(floor(self->x_[0] + 0.5))
                      setY:(int)(floor(self->y_[0] + 0.5))];
    [self->secondPos_ setX:(int)(floor(self->x_[1] + 0.5))
                      setY:(int)(floor(self->y_[1] + 0.5))];


    // ϰϤ˺
    [self->trueRect_ release];
    self->trueRect_ = nil;

    // ϰϤƻ
    self->trueRect_ = [self calcArea:0];

    return;
}


//
// ɤĤ֤ʿԻշ
//
//  Call
//    edit       : Խ
//    tile       : ѥ
//    firstPos_  : 1(濴)( instance ѿ)
//    secondPos_ : 2(濴)( instance ѿ)
//    thirdPos_  : 3(濴)( instance ѿ)
//    fourthPos_ : 4(濴)( instance ѿ)
//    trueRect_  : ϰ(ϰϳޤ)(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//
//  Return
//    None
//
-(void)drawFill:(id)edit
       withTile:(PoCoMonochromePattern *)tile
{
    if (!([self->trueRect_ empty])) {
        // ޥ
        if ([self->mask_ parallelogram:self->firstPos_
                                second:self->secondPos_
                                 third:self->thirdPos_
                                fourth:self->fourthPos_]) {
            // 
            [edit executeDraw:[self->mask_ mask]
                     withTile:tile
                 withTrueRect:self->trueRect_
                 withDrawRect:self->drawRect_];
        }
    }

    return;
}


//
// Խʣ
//  ؿ֤ͤˤϸƤӽФ release 뤳
//
//  Call
//    orgRect_   : Խϰ()(instance ѿ)
//    orgBitmap_ : Խ(instance ѿ)
//
//  Return
//    function : μ
//
-(PoCoBitmap *)getWorkBitmap
{
    return [self->orgBitmap_ getBitmap:self->orgRect_];
}


//
// ʣ
//
//  Call
//    work      : ѥӥåȥޥå
//    picture_  : Խоݲ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    trueRect_ : ϰ(ϰϳޤ)(instance ѿ)
//    mask_     : ޥ(instance ѿ)
//
//  Return
//    None
//
-(void)pasteFromWork:(PoCoBitmap *)work
{
    PoCoEditNormalPasteImage *edit;
    PoCoBitmap *tmp;

    // žʣƤ
    tmp = [work getBitmap:self->trueRect_];

    // ԽϤ
    edit = [[PoCoEditNormalPasteImage alloc]
               initWithBitmap:[self->layer_ bitmap]
                      palette:[self->picture_ palette]
                         tile:nil
                         mask:[self->mask_ mask]
                  pasteBitmap:tmp];

    // ʣ
    [edit executeDraw:self->trueRect_];

    // 񸻤
    [edit release];
    [tmp release];

    return;
}

@end
