//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤/ʱ - ̸᤭
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerAtomizerEllipseFillEditter.h"

#import "PoCoAppController.h"
#import "PoCoEditAtomizerFill.h"

// ============================================================================
@implementation PoCoControllerAtomizerEllipseFillEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    s      : (濴)
//    e      : 轪(濴)
//    o      : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
orientation:(PoCoPoint *)o
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerAtomizerEllipseFillEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:nil
                  withTile:nil
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerAtomizerEllipseFillEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)  
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditAtomizerFill *edit;
    int penSize;                        // 
    int ratio;                          // 
    int tnum;                           // ѥֹ
    int tend;                           // ѥ
    float t;
    float tskip;                        // ѥ

    result = NO;
    edit = nil;

    // 򻻽
    penSize = ([self->editInfo_ penSize] * 8);

    // ٤򻻽
    ratio = [self->editInfo_ density];
    if (ratio < 250) {
        ratio /= 75;
    } else if (ratio < 750) {
        ratio /= 2;
        ratio /= 50;
    } else if (ratio < 1000) {
        ratio /= 5;
        ratio /= 25;
    }
    if (ratio <= 0) {
        // ٤ 0 ʤ褷ʤ
        goto EXIT;
    }

    // ѥ̤򻻽
    tskip = (8.0 / (float)(penSize));
    if ([self->editInfo_ flipType]) {
        tnum = (([self->editInfo_ atomizerType]) ? 16 : 8);
    } else {
        tnum = 0;
    }
    tend = (tnum + 8);
    t = (float)(tnum);

    // Խ
    if ([super startEdit:NO
             withPenSize:penSize
            withDrawCorr:0
            withUndoCorr:(PEN_STYLE_SIZE / 2)]) {
        // ԽϤ
        edit = [[PoCoEditAtomizerFill alloc]
                      init:[self->layer_ bitmap]
                   palette:[self->picture_ palette]
                   pattern:self->drawPattern_
                     ratio:ratio];

        // Խ¹
        do {
            [super drawFill:edit
                   withTile:[[(PoCoAppController *)([NSApp delegate]) tileSteadyPattern] pattern:(tnum / ([self->editInfo_ atomizerType] ? 2 : 1))]];

            // 
            [super next];
            t += tskip; 
            tnum = (int)(floor(t));
        } while (tnum != tend);

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawEllipseFillShape"
                                           value:@"ellipse fill shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
