//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤ - ̾
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerNormalBoxFillEditter.h"

#import "PoCoEditRegionFill.h"
#import "PoCoCreateStyleMask.h"

// ============================================================================
@implementation PoCoControllerNormalBoxFillEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    tile   : ѥ
//    s      : (濴)
//    e      : 轪(濴)
//    o      : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
     tile:(PoCoTilePattern *)tile
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
orientation:(PoCoPoint *)o
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerNormalBoxFillEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:nil
                   withPen:nil
                  withTile:tile
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerNormalBoxFillEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    startPos_    : (濴)( instance ѿ)
//    endPos_      : 轪(濴)( instance ѿ)
//    ortPos_      : ( instance ѿ)
//    diagonal_    : žгѤ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)
//    drawTile_    : ѥѥ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditRegionFill *edit;
    PoCoRect *trueRect;
    PoCoCreateStyleMask *mask;

    result = NO;
    edit = nil;
    trueRect = nil;
    mask = nil;

    // Խ
    if ([super startEdit:0
            withUndoCorr:(PEN_STYLE_SIZE / 2)]) {
        trueRect = [super calcArea:0];

        // ޥ
        mask = [[PoCoCreateStyleMask alloc] init];
        if ([mask box:self->startPos_
                  end:self->endPos_
          orientation:self->ortPos_
           isDiagonal:self->diagonal_]){
            // ԽϤ
            edit = [[PoCoEditRegionFill alloc]
                       initWithPattern:[self->layer_ bitmap]
                               palette:[self->picture_ palette]
                                  tile:self->drawTile_
                               pattern:self->drawPattern_
                             checkDist:YES];

            // Խ¹
            [edit executeDraw:[mask mask]
                 withStartPos:[trueRect lefttop]
                   withEndPos:[trueRect rightbot]];

            // Խλ
            [super endEdit:[[NSBundle mainBundle]
                               localizedStringForKey:@"DrawBoxFillShape"
                                               value:@"box fill shape"
                                               table:nil]];

            // ԽϤ
            [edit release];
        }

        // ޥ
        [mask release];

        // ｪλ
        result = YES;
    }

    [trueRect release];
    return result;
}

@end
