//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤ʿԻշ - ̾
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerNormalParallelogramFillEditter.h"

#import "PoCoCreateStyleMask.h"
#import "PoCoEditRegionFill.h"

// ============================================================================
@implementation PoCoControllerNormalParallelogramFillEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    tile   : ѥ
//    f      : 1(濴)
//    s      : 2(濴)
//    t      : 3(濴)
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
     tile:(PoCoTilePattern *)tile
    first:(PoCoPoint *)f
   second:(PoCoPoint *)s
    third:(PoCoPoint *)t
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerNormalParallelogramFillEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:nil
                   withPen:nil
                  withTile:tile
                 withFirst:f
                withSecond:s
                 withThird:t
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerNormalParallelogramFillEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    firstPos_    : 1(濴)( instance ѿ)
//    secondPos_   : 2(濴)( instance ѿ)
//    thirdPos_    : 3(濴)( instance ѿ)
//    fourthPos_   : 4(濴)( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)
//    drawTile_    : ѥѥ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditRegionFill *edit;
    PoCoRect *trueRect;
    PoCoCreateStyleMask *mask;

    result = NO;
    edit = nil;
    trueRect = nil;
    mask = nil;

    // Խ
    if ([super startEdit:0
            withUndoCorr:(PEN_STYLE_SIZE / 2)]) {
        trueRect = [super calcArea:0];

        // ޥ
        mask = [[PoCoCreateStyleMask alloc] init];
        if ([mask parallelogram:self->firstPos_
                         second:self->secondPos_
                          third:self->thirdPos_
                         fourth:self->fourthPos_]) {
            // ԽϤ
            edit = [[PoCoEditRegionFill alloc]
                       initWithPattern:[self->layer_ bitmap]
                               palette:[self->picture_ palette]
                                  tile:self->drawTile_
                               pattern:self->drawPattern_
                             checkDist:YES];

            // Խ¹
            [edit executeDraw:[mask mask]
                 withStartPos:[trueRect lefttop]
                   withEndPos:[trueRect rightbot]];

            // Խλ
            [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawParallelogramFillShape"
                                           value:@"parallelogram fill shape"
                                           table:nil]];

            // ԽϤ
            [edit release];
        }

        // ޥ
        [mask release];

        // ｪλ
        result = YES;
    }

    [trueRect release];
    return result;
}

@end
