//
//	Pelistina on Cocoa - PoCo -
//	/
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerEditterBase.h"

// ----------------------------------------------------------------------------
// ͳɮ㼫ͳľ
@interface PoCoControllerLineEditterBase : PoCoControllerEditterBase
{
    PoCoPoint *startPos_;               // (濴)
    PoCoPoint *endPos_;                 // 轪(濴)
    BOOL prop_;                         // ɮ
    BOOL cont_;                         // Ϣ³ʬ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
       isProp:(BOOL)prop
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// ڥ
-(int)selectPenSize;

// ǻ٤
-(int)selectDensity;

// ͽΰλ
-(PoCoRect *)calcArea:(int)corr;

// Խ
-(BOOL)startEdit:(int)dc
    withUndoCorr:(int)uc;

// Ϣ³ʬ
-(void)setCont;

// ľ
-(void)drawFrame:(id)edit;

// Խλ
-(void)endEdit:(NSString *)name;

@end


// ----------------------------------------------------------------------------
// 
@interface PoCoControllerBoxFrameEditterBase : PoCoControllerBoxEditterBase
{
    BOOL cont_;                         // Ϣ³ʬ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// Ϣ³ʬ
-(void)setCont;

// Ȥ
-(void)drawFrame:(id)edit;

@end


// ----------------------------------------------------------------------------
// /ʱ
@interface PoCoControllerEllipseFrameEditterBase : PoCoControllerEllipseEditterBase
{
    BOOL cont_;                         // Ϣ³ʬ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
    withStart:(PoCoPoint *)s
      withEnd:(PoCoPoint *)e
  ifAnyOrient:(PoCoPoint *)o
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// Ϣ³ʬ
-(void)setCont;

// /ʱȤ
-(void)drawFrame:(id)edit;

@end


// ----------------------------------------------------------------------------
// ʿԻշ
@interface PoCoControllerParallelogramFrameEditterBase : PoCoControllerParallelogramEditterBase
{
    BOOL cont_;                         // Ϣ³ʬ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
    withFirst:(PoCoPoint *)f
   withSecond:(PoCoPoint *)s
    withThird:(PoCoPoint *)t
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// Ϣ³ʬ
-(void)setCont;

// ʿԻշȤ
-(void)drawFrame:(id)edit;

@end


// ----------------------------------------------------------------------------
// ľ()
@interface PoCoControllerCurveWithPointsEditterBase : PoCoControllerCurveEditterBase
{
    BOOL cont_;                         // Ϣ³ʬ
}

// initialize
-(id)initPict:(PoCoPicture *)pict
     withInfo:(PoCoEditInfo *)info
     withUndo:(NSUndoManager *)undo
   withEraser:(PoCoColorPattern *)eraser
   withBuffer:(PoCoColorBuffer *)buf
      withPen:(PoCoPenStyle *)pen
     withTile:(PoCoTilePattern *)tile
   withPoints:(NSMutableArray *)points
     withType:(PoCoCurveWithPointsType)type
     withFreq:(unsigned int)freq
      atIndex:(int)idx;

// deallocate
-(void)dealloc;

// Ϣ³ʬ
-(void)setCont;

// ľ() 
-(void)drawFrame:(id)edit;

@end
