//
//	Pelistina on Cocoa - PoCo -
//	ɮ㼫ͳ - ǻ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerDensityProportionalFreeLineEditter.h"

#import "PoCoEditDensityFactory.h"
#import "PoCoEditDensityDrawLineBase.h"

// ============================================================================
@implementation PoCoControllerDensityProportionalFreeLineEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    buf    : ݻ
//    s      : (濴)
//    e      : 轪(濴)
//    idx    : оݥ쥤䡼ֹ
//    p      : ɮ
//    name   : ä̾
//
//  Return
//    function  : 
//    undoName_ : ä̾(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
   buffer:(PoCoColorBuffer *)buf
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
    index:(int)idx
     prop:(BOOL)p
 undoName:(NSString *)name
{
//    DPRINT((@"[PoCoControllerDensityProportionalFreeLineEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:buf
                   withPen:nil
                  withTile:nil
                 withStart:s
                   withEnd:e
                    isProp:p
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->undoName_ = name;
        [self->undoName_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    undoName_ : ä̾(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerDensityProportionalFreeLineEditter dealloc]\n"));

    // 񸻤β
    [self->undoName_ release];
    self->undoName_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)
//    undoName_    : ä̾(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditDensityDrawLineBase *edit;
    int density;                        // ǻ

    result = NO;
    edit = nil;

    // ǻ٤򻻽
    density = [super selectDensity];
    if (density <= 0) {
        // ǻ٤ 0 ʤ褷ʤ
        goto EXIT;
    }

    // Խ
    if ([super startEdit:(PEN_STYLE_SIZE >> 1)
            withUndoCorr:(PEN_STYLE_SIZE >> 1)]) {
        // ԽϤ
        edit = [PoCoEditDensityDrawLineFactory
                    create:[self->layer_ bitmap]
                   colMode:[self->editInfo_ colorMode]
                   palette:[self->picture_ palette]
                   pattern:self->drawPattern_
                    buffer:self->colorBuffer_
                   penSize:[super selectPenSize]];

        // Խ¹
        [edit setDensity:density];
        [super drawFrame:edit];

        // Խλ
        [super endEdit:self->undoName_];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

EXIT:
    return result;
}

@end
