//
//	Pelistina on Cocoa - PoCo -
//	 - ̾
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerNormalBoxFrameEditter.h"

#import "PoCoEditNormalDrawPoint.h"
#import "PoCoEditNormalDrawLine.h"

// ============================================================================
@implementation PoCoControllerNormalBoxFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    pen    : ڥ
//    tile   : ѥ
//    s      : (濴)
//    e      : 轪(濴)
//    o      : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
      pen:(PoCoPenStyle *)pen
     tile:(PoCoTilePattern *)tile
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
orientation:(PoCoPoint *)o
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerNormalBoxFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:nil
                   withPen:pen
                  withTile:tile
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerNormalBoxFrameEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)
//    drawPen_     : ѥڥ( instance ѿ)
//    drawTile_    : ѥѥ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    id edit;

    result = NO;
    edit = nil;

    // Խ
    if ([super startEdit:(PEN_STYLE_SIZE >> 1)
            withUndoCorr:(PEN_STYLE_SIZE >> 1)]) {
        // ԽϤ
        if (([self->editInfo_ continuationType]) &&
            (!([self->startPos_ isEqualPos:self->endPos_]))) {
            // Ϣ³ʬ
            edit = [[PoCoEditNormalDrawLine alloc]
                       initWithPattern:[self->layer_ bitmap]
                               palette:[self->picture_ palette]
                                   pen:self->drawPen_
                                  tile:self->drawTile_
                               pattern:self->drawPattern_];
        } else {
            // Ϣ³ʬ
            edit = [[PoCoEditNormalDrawPoint alloc]
                       initWithPattern:[self->layer_ bitmap]
                               palette:[self->picture_ palette]
                                   pen:self->drawPen_
                                  tile:self->drawTile_
                               pattern:self->drawPattern_];
        }

        // Խ¹
        [super setCont];
        [super drawFrame:edit];

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawBoxShape"
                                           value:@"box shape"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

    return result;
}

@end
