//
//	Pelistina on Cocoa - PoCo -
//	ɮ㼫ͳ - ̾
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerNormalProportionalFreeLineEditter.h"

#import "PoCoAppController.h"
#import "PoCoEditNormalDrawPoint.h"
#import "PoCoEditNormalDrawLine.h"

// ============================================================================
@implementation PoCoControllerNormalProportionalFreeLineEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    pen    : ڥ
//    tile   : ѥ
//    s      : (濴)
//    e      : 轪(濴)
//    idx    : оݥ쥤䡼ֹ
//    p      : ɮ
//    name   : ä̾
//
//  Return
//    function  : 
//    undoName_ : ä̾(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
      pen:(PoCoPenStyle *)pen
     tile:(PoCoTilePattern *)tile
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
    index:(int)idx
     prop:(BOOL)p
 undoName:(NSString *)name
{
//    DPRINT((@"[PoCoControllerNormalProportionalFreeLineEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:nil
                   withPen:pen
                  withTile:tile
                 withStart:s
                   withEnd:e
                    isProp:p
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->undoName_ = name;
        [self->undoName_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    undoName_ : ä̾(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerNormalProportionalFreeLineEditter dealloc]\n"));

    // 񸻤β
    [self->undoName_ release];
    self->undoName_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    penStyle_    : ڥ( instance ѿ)
//    tilePattern_ : ѥ( instance ѿ)
//    colorBuffer_ : ݻ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)
//    drawPen_     : ѥڥ( instance ѿ)
//    drawTile_    : ѥѥ( instance ѿ)
//    prop_        : ɮ( instance ѿ)
//    undoName_    : ä̾(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    id edit;
    int pnum;                           // Фڥֹ
    int tnum;                           // Фǻ٤ֹ
    unsigned int press;                 // ɮ
    PoCoMonochromePattern *pen;
    PoCoMonochromePattern *tile;

    result = NO;
    edit = nil;
    pen = nil;
    tile = nil;

    // Խ
    if ([super startEdit:(PEN_STYLE_SIZE >> 1)
            withUndoCorr:(PEN_STYLE_SIZE >> 1)]) {
        // ڥ
        if (!(self->prop_) ||
             ([self->editInfo_ sizePropType] == PoCoProportionalType_Pattern)) {
            pen = self->drawPen_;
        } else {
            press = (([self->editInfo_ sizePropType] == PoCoProportionalType_Relation) ? [self->editInfo_ pressure] : 1000);
            pnum = MIN([self->editInfo_ penSize],
                       ((([self->editInfo_ penSize] * press) / 1000) + 1));
            pnum = (PEN_STYLE_NUM - pnum);
            pen = [[(PoCoAppController *)([NSApp delegate]) penSteadyStyle] pattern:pnum];
        }

        // ǻ٤
        if (!(self->prop_) ||
            ([self->editInfo_ densityPropType] == PoCoProportionalType_Pattern)) {
            tile = self->drawTile_;
        } else {
            press = (([self->editInfo_ densityPropType] == PoCoProportionalType_Relation) ? [self->editInfo_ pressure] : 1000);
            tnum = MIN([self->editInfo_ density],
                       (([self->editInfo_ density] * press) / 1000));
            tnum = ((tnum * (TILE_PATTERN_NUM >> 1)) / 1000);
            tnum = ((tnum == 0) ? 0 : (tnum - 1));
            tnum += (([self->editInfo_ flipType]) ? (TILE_PATTERN_NUM >> 1) : 0);
            tile = [[(PoCoAppController *)([NSApp delegate]) tileSteadyPattern] pattern:tnum];
        }

        // ԽϤ
        if (([self->editInfo_ continuationType]) &&
            (!([self->startPos_ isEqualPos:self->endPos_]))) {
            // Ϣ³ʬ
            edit = [[PoCoEditNormalDrawLine alloc]
                       initWithPattern:[self->layer_ bitmap]
                               palette:[self->picture_ palette]
                                   pen:pen
                                  tile:tile
                               pattern:self->drawPattern_];
        } else {
            // Ϣ³ʬ
            edit = [[PoCoEditNormalDrawPoint alloc]
                       initWithPattern:[self->layer_ bitmap]
                               palette:[self->picture_ palette]
                                   pen:pen
                                  tile:tile
                               pattern:self->drawPattern_];
        }

        // Խ¹
        [super setCont];
        [super drawFrame:edit];

        // Խλ
        [super endEdit:self->undoName_];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

    return result;
}

@end
