//
//	Pelistina on Cocoa - PoCo -
//	ľ() - ȿž
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerInvertCurveWithPointsEditter.h"

#import "PoCoEditInvertDrawLine.h"
#import "PoCoCalcCurveWithPoints.h"

// ============================================================================
@implementation PoCoControllerInvertCurveWithPointsEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    p    : 
//    idx  : оݥ쥤䡼ֹ
//    type : ˡ
//    freq : 
//
//  Return
//    function : 
//    points_  : (instance ѿ)
//    type_    : ˡ(instance ѿ)
//    freq_    : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
   points:(NSMutableArray *)p
     type:(PoCoCurveWithPointsType)type
     freq:(unsigned int)freq
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerInvertCurveWithPointsEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:nil
                  withUndo:nil
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:nil
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->points_ = p;
        self->type_ = type;
        self->freq_ = freq;
        [self->points_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_ : (instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerInvertCurveWithPointsEditter dealloc]\n"));

    // 񸻤β
    [self->points_ release];
    self->points_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    layer_  : оݥ쥤䡼( instance ѿ)
//    points_ : (instance ѿ)
//    type_   : ˡ(instance ѿ)
//    freq_   : (instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    PoCoEditInvertDrawLine *edit;
    PoCoRect *r;
    NSEnumerator *iter;
    PoCoPoint *p;
    PoCoCalcCurveWithPointsBase *calc;

    r = [[PoCoRect alloc] initLeft:INT_MAX
                           initTop:INT_MAX
                         initRight:INT_MIN
                        initBottom:INT_MIN];

    // ¹
    edit = [[PoCoEditInvertDrawLine alloc] initWithBitmap:[self->layer_ bitmap]
                                               isZeroOnly:NO];
    if (edit != nil) {
        // ֱ黻»
        switch (self->type_) {
            default:
            case PoCoCurveWithPoints_Lagrange:
                calc = [[PoCoCalcLagrange alloc] initWithPoints:self->points_];
                break;
            case PoCoCurveWithPoints_Spline:
                calc = [[PoCoCalcSpline alloc] initWithPoints:self->points_];
                break;
        }
        iter = [[calc exec:self->freq_] objectEnumerator];
        for (p = [iter nextObject]; p != nil; p = [iter nextObject]) {
            [edit addPoint:p];

            // ϰϻ
            if (([p x] - (PEN_STYLE_SIZE >> 1)) < [r left]) {
                [r setLeft:([p x] - (PEN_STYLE_SIZE >> 1))];
            }
            if (([p y] - (PEN_STYLE_SIZE >> 1)) < [r top]) {
                [r setTop:([p y] - (PEN_STYLE_SIZE >> 1))];
            }
            if (([p x] + (PEN_STYLE_SIZE >> 1)) > [r right]) {
                [r setRight:([p x] + (PEN_STYLE_SIZE >> 1))];
            }
            if (([p y] + (PEN_STYLE_SIZE >> 1)) > [r bottom]) {
                [r setBottom:([p y] + (PEN_STYLE_SIZE >> 1))];
            }
        }
        [edit executeDraw];
        [calc release];
    }
    [super correctRect:r];

    // ¹Ԥ
    [r expand:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];
    [super postNotifyNoEdit:r];

    // ｪλ
    [edit release];
    [r release];

    return YES;                         //  YES
}

@end
