//
//	Pelistina on Cocoa - PoCo -
//	/ʱ - ȿž
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoControllerInvertEllipseFrameEditter.h"

#import "PoCoCalcEllipse.h"
#if 1
#import "PoCoEditInvertBase.h"
#else   // 1
#import "PoCoEditInvertDrawLine.h"
#endif  // 1

// ============================================================================
@implementation PoCoControllerInvertEllipseFrameEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    s    : ()
//    e    : 轪()
//    o    : 
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
orientation:(PoCoPoint *)o
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerInvertEllipseFrameEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:nil
                  withUndo:nil
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:nil
                 withStart:s
                   withEnd:e
               ifAnyOrient:o
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerInvertEllipseFrameEditter dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    layer_    : оݥ쥤䡼( instance ѿ)
//    startPos_ : (濴)( instance ѿ)
//    endPos_   : 轪(濴)( instance ѿ)
//    ortPos_   : ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
#if 1
{
    PoCoEditInvertBase *edit;
    PoCoRect *r;
    PoCoCalcEllipse *calc;
    PoCoPoint *p;
    int fx;
    int fy;

    // ϰϻ
    r = [super calcArea:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];

    // ¹
    edit = [[PoCoEditInvertBase alloc] initWithBitmap:[self->layer_ bitmap]
                                           isZeroOnly:NO];
    if (edit != nil) {
        fx = -1;
        fy = -1;
        calc = [[PoCoCalcEllipse alloc] init];
        [calc calc:self->startPos_
            endPos:self->endPos_
       orientation:self->ortPos_];
        [calc points];                  // ǤΤǺǽФ
        for (p = [calc points]; p != nil; p = [calc points]) {
            if (([p x] != fx) || ([p y] != fy)) {
                [edit drawPoint:p];
                fx = [p x];
                fy = [p y];
                [r   setLeft:MIN(fx, [r   left])];
                [r    setTop:MIN(fy, [r    top])];
                [r  setRight:MAX(fx, [r  right])];
                [r setBottom:MAX(fy, [r bottom])];
            }
        }
        [calc release];
    }

    // 
    [r expand:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];
    [super postNotifyNoEdit:r];

    // ｪλ
    [edit release];
    [r release];

    return YES;                         //  YES
}
#else   // 1
{
    PoCoEditInvertDrawLine *edit;
    PoCoRect *r;
    PoCoPoint *p;
    PoCoCalcEllipse *calc;
    int fx;
    int fy;

    // ϰϻ
    r = [super calcArea:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];

    // ¹
    edit = [[PoCoEditInvertDrawLine alloc] initWithBitmap:[self->layer_ bitmap]
                                               isZeroOnly:NO];
    if (edit != nil) {
        fx = -1;
        fy = -1;
        calc = [[PoCoCalcEllipse alloc] init];
        [calc calc:self->startPos_
            endPos:self->endPos_
       orientation:self->ortPos_];
#if 0
        [calc points];                  // ǤΤǺǽФ
#endif  // 0
        for (p = [calc points]; p != nil; p = [calc points]) {
            if (([p x] != fx) || ([p y] != fy)) {
                [edit addPoint:p];
                fx = [p x];
                fy = [p y];
                [r   setLeft:MIN(fx, [r   left])];
                [r    setTop:MIN(fy, [r    top])];
                [r  setRight:MAX(fx, [r  right])];
                [r setBottom:MAX(fy, [r bottom])];
            }
        }
        [calc release];
        [edit executeDraw];
    }

    // 
    [r expand:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];
    [super postNotifyNoEdit:r];

    // ｪλ
    [edit release];
    [r release];

    return YES;                         //  YES
}
#endif  // 1

@end
