//
//	Pelistina on Cocoa - PoCo -
//	ľ - ȿž
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerInvertLineEditter.h"

#import "PoCoEditInvertDrawLine.h"

// ============================================================================
@implementation PoCoControllerInvertLineEditter

// --------------------------------------------------------- instance - private
//
// ͽΰλ
//
//  Call
//    corr      : 
//    picture_  : Խоݲ( instance ѿ)
//    startPos_ : (濴)(instance ѿ)
//    endPos_   : 轪(濴)(instance ѿ)
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcArea:(int)corr
{
    PoCoRect *r;

    r = [[PoCoRect alloc] init];

    // ʿλ
    if ([self->startPos_ x] < [self->endPos_ x]) {
        [r setLeft:([self->startPos_ x] - corr)];
        [r setRight:(([self->endPos_ x] + corr) + 1)];
    } else {
        [r setLeft:([self->endPos_ x] - corr)];
        [r setRight:(([self->startPos_ x] + corr) + 1)];
    }

    // ľλ
    if ([self->startPos_ y] < [self->endPos_ y]) {
        [r setTop:([self->startPos_ y] - corr)];
        [r setBottom:(([self->endPos_ y] + corr) + 1)];
    } else {
        [r setTop:([self->endPos_ y] - corr)];
        [r setBottom:(([self->startPos_ y] + corr) + 1)];
    }

    return r;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    s    : (濴)
//    e    : 轪(濴)
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function  : 
//    startPos_ : (濴)(instance ѿ)
//    endPos_   : 轪(濴)(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
    start:(PoCoPoint *)s
      end:(PoCoPoint *)e
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerInvertLineEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:nil
                  withUndo:nil
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:nil
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        // ʣ
        self->startPos_ = [[PoCoPoint alloc] initX:[s x] initY:[s y]];
        self->endPos_   = [[PoCoPoint alloc] initX:[e x] initY:[e y]];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    startPos_ : (濴)(instance ѿ)
//    endPos_   : 轪(濴)(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerInvertLineEditter dealloc]\n"));

    // 񸻤β
    [self->startPos_ release]; 
    [self->endPos_ release];
    self->startPos_ = nil;
    self->endPos_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    layer_    : оݥ쥤䡼( instance ѿ)
//    startPos_ : (濴)(instance ѿ)
//    endPos_   : 轪(濴)(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    PoCoEditInvertDrawLine *edit;
    PoCoRect *r;

    // ϰϻ
    r = [self calcArea:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];

    // ¹
    edit = [[PoCoEditInvertDrawLine alloc] initWithBitmap:[self->layer_ bitmap]
                                               isZeroOnly:NO];
    if (edit != nil) {
        [edit addPoint:self->startPos_];
        if ((self->endPos_ != nil) &&
           (!([self->startPos_ isEqualPos:self->endPos_]))) {
            [edit addPoint:self->endPos_];
        }
        [edit executeDraw];
    }

    // 
    [r expand:(PEN_STYLE_SIZE >> 1)];
    [super correctRect:r];
    [super postNotifyNoEdit:r];

    // ｪλ
    [edit release];
    [r release];

    return YES;                         //  YES
}

@end
