//
//	Pelistina on Cocoa - PoCo -
//	ɤĤ֤(seed paint) - ̾
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerNormalPaintEditter.h"

#import "PoCoEditNormalPaint.h"

// ============================================================================
@implementation PoCoControllerNormalPaintEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    eraser : äѲ
//    tile   : ѥ
//    p      : 
//    idx    : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//    pos_     : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   eraser:(PoCoColorPattern *)eraser
     tile:(PoCoTilePattern *)tile
      pos:(PoCoPoint *)p
    index:(int)idx
{
//    DPRINT((@"[PoCoControllerNormalPaintEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:eraser
                withBuffer:nil
                   withPen:nil
                  withTile:tile
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->pos_ = p;
        [self->pos_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pos_ : (instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerNormalPaintEditter dealloc]\n"));

    // 񸻤β
    [self->pos_ release];
    self->pos_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    layer_       : оݥ쥤䡼( instance ѿ)
//    drawPattern_ : ѥ( instance ѿ)
//    drawTile_    : ѥѥ( instance ѿ)
//    pos_         : (instance ѿ)
//
//  Return
//    function    : Խ
//    undoRect_   : äΰ( instance ѿ)
//    undoBitmap_ : ä( instance ѿ)
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditNormalPaint *edit;
    PoCoRect *dr;
    PoCoRect *ur;
    PoCoBitmap *tmp;

    result = NO;
    edit = nil;

    // ϰϤ
    dr = [self->picture_ bitmapPoCoRect];
    ur = [self->picture_ bitmapPoCoRect];

    // Խ
    if ([super startEdit:dr
            withUndoRect:ur]) {
        // ԽϤ
        edit = [[PoCoEditNormalPaint alloc]
                   initWithPattern:[self->layer_ bitmap]
                           palette:[self->picture_ palette]
                              tile:self->drawTile_
                           pattern:self->drawPattern_
                             range:0];

        // Խ¹
        [edit executeDraw:self->pos_];

        // ϰϤ
        if (!([[edit drect] empty])) {
            // äѲϰϤˤ
            [self->undoRect_    setLeft:[[edit drect]   left]];
            [self->undoRect_     setTop:[[edit drect]    top]];
            [self->undoRect_   setRight:[[edit drect]  right]];
            [self->undoRect_  setBottom:[[edit drect] bottom]];
            if (self->undoBitmap_ != nil) {
                tmp = [self->undoBitmap_ getBitmap:self->undoRect_];
                [self->undoBitmap_ release];
                self->undoBitmap_ = tmp;
            }
        }

        // Խλ
        [super endEdit:[[NSBundle mainBundle]
                           localizedStringForKey:@"DrawPaint"
                                           value:@"paint"
                                           table:nil]];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

    // ϰϤ
    [dr release];
    [ur release];

    return result;
}

@end
