//
//	Pelistina on Cocoa - PoCo -
//	Žդ - ̾
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerNormalPasteImageEditter.h"

#import "PoCoEditNormalPasteImage.h"

// ============================================================================
@implementation PoCoControllerNormalPasteImageEditter

// --------------------------------------------------------- instance - private
//
// ͽΰλ
//
//  Call
//    dstRect_  : Žդ(instance ѿ)
//    prevRect_ : Žդ(instance ѿ)
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcArea
{
    // Ȥ¤Ȥ
    return [[PoCoRect alloc]
                 initLeft:MIN([self->dstRect_   left], [self->prevRect_   left])
                  initTop:MIN([self->dstRect_    top], [self->prevRect_    top])
                initRight:MAX([self->dstRect_  right], [self->prevRect_  right])
               initBottom:MAX([self->dstRect_ bottom], [self->prevRect_ bottom])];
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    tile : ѥ
//    r    : Žդ
//    bmp  : Žդ
//    mask : Ǥΰη
//    pr   : Žդ
//    pbmp : Žդ
//    idx  : оݥ쥤䡼ֹ
//    name : ä̾
//
//  Return
//    function  : 
//    dstRect_  : Žդ(instance ѿ)
//    pasteBmp_ : Žդ(instance ѿ)
//    mask_     : Ǥΰη(instance ѿ)
//    prevRect_ : Žդ(instance ѿ)
//    prevBmp_  : Žդ(instance ѿ)
//    undoName_ : ä̾(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     tile:(PoCoTilePattern *)tile
     rect:(PoCoRect *)r
   bitmap:(PoCoBitmap *)bmp
   region:(PoCoBitmap *)mask
 prevRect:(PoCoRect *)pr
prevBitmap:(PoCoBitmap *)pbmp
    index:(int)idx
 undoName:(NSString *)name
{
//    DPRINT((@"[PoCoControllerNormalPasteImageEditter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo
                withEraser:nil
                withBuffer:nil
                   withPen:nil
                  withTile:tile
                   atIndex:idx];

    // Ȥν
    if (self != nil) {
        self->dstRect_ = r;
        self->pasteBmp_ = bmp;
        self->mask_ = mask;
        self->prevRect_ = pr;
        self->prevBmp_ = pbmp;
        self->undoName_ = name;
        [self->dstRect_ retain];
        [self->pasteBmp_ retain];
        [self->mask_ retain];
        [self->prevRect_ retain];
        [self->prevBmp_ retain];
        [self->undoName_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    dstRect_  : Žդ(instance ѿ)
//    pasteBmp_ : Žդ(instance ѿ)
//    mask_     : Ǥΰη(instance ѿ)
//    prevRect_ : Žդ(instance ѿ)
//    prevBmp_  : Žդ(instance ѿ)
//    undoName_ : ä̾(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerNormalPasteImageEditter dealloc]\n"));

    // 񸻤β
    [self->dstRect_ release];
    [self->pasteBmp_ release];
    [self->mask_ release];
    [self->prevRect_ release];
    [self->prevBmp_ release];
    [self->undoName_ release];
    self->dstRect_ = nil;
    self->pasteBmp_ = nil;
    self->mask_ = nil;
    self->prevRect_ = nil;
    self->prevBmp_ = nil;
    self->undoName_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    layer_    : оݥ쥤䡼( instance ѿ)
//    drawTile_ : ѥѥ( instance ѿ)
//    dstRect_  : Žդ(instance ѿ)
//    pasteBmp_ : Žդ(instance ѿ)
//    mask_     : Ǥΰη(instance ѿ)
//    prevRect_ : Žդ(instance ѿ)
//                != nil : ᤹
//                == nil : ᤵʤ
//    prevBmp_  : Žդ(instance ѿ)
//                != nil : ᤹
//                == nil : ᤵʤ
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoEditNormalPasteImage *edit;
    PoCoRect *dr;
    PoCoRect *ur;
    PoCoRect *prevAreaRect;             // ưΰ
    PoCoBitmap *prevAreaBmp;            // ư

    result = NO;
    edit = nil;

    // ϰϤ
    dr = [self calcArea];
    ur = [self calcArea];
    [super correctRect:dr];
    [super correctRect:ur];

    // Խ
    if ([super startEdit:dr
            withUndoRect:ur]) {
        // ư᤹
        if ((self->prevRect_ != nil) && (self->prevBmp_ != nil)) {
            prevAreaBmp = [self->prevBmp_ getBitmap:self->prevRect_];
            prevAreaRect = [[PoCoRect alloc]
                                 initLeft:MAX(0,
                                              [self->prevRect_ left])
                                  initTop:MAX(0,
                                              [self->prevRect_ top])
                                initRight:MIN([[self->layer_ bitmap] width],
                                              [self->prevRect_ right])
                               initBottom:MIN([[self->layer_ bitmap] height],
                                              [self->prevRect_ bottom])];
            [[self->layer_ bitmap] setBitmap:[prevAreaBmp pixelmap]
                                    withRect:prevAreaRect];
            [prevAreaRect release];
            [prevAreaBmp release];
        }

        // ԽϤ
        edit = [[PoCoEditNormalPasteImage alloc]
                   initWithBitmap:[self->layer_ bitmap]
                          palette:[self->picture_ palette]
                             tile:self->drawTile_
                             mask:self->mask_
                      pasteBitmap:self->pasteBmp_];

        // Խ¹
        [edit executeDraw:self->dstRect_];

        // Խλ
        [super endEdit:self->undoName_];

        // ԽϤ
        [edit release];

        // ｪλ
        result = YES;
    }

    // ϰϤ
    [dr release];
    [ur release];

    return result;
}

@end
