//
//	Pelistina on Cocoa - PoCo -
//	顼ѥϿ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerColorPatternSetter.h"

#import "PoCoLayer.h"
#import "PoCoColorPattern.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerColorPatternSetter

// ---------------------------------------------------------- instance - public
//
// initialize(ꥤ˥饤)
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    n    : оݥ顼ѥֹ
//    pat  : ѥ
//
//  Return
//    num_     : оݥ顼ѥֹ(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
      num:(int)n
  pattern:(PoCoColorPattern *)pat
{
    DPRINT((@"[PoCoControllerColorPatternSetter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->num_ = n;
        self->pattern_ = pat;
        [self->pattern_ retain];
    }

    return self;
}

//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    n    : оݥ顼ѥֹ
//    idx  : 쥤䡼ֹ
//    r    : 
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
      num:(int)n
    layer:(int)idx
     rect:(PoCoRect *)r
{
    id obj;
    PoCoColorPattern *pat;
    PoCoBitmap *bmp;

    bmp = [[[pict layer:idx] bitmap] getBitmap:r];
    pat = [[PoCoColorPattern alloc] initWithBitmap:bmp];
    obj = [self init:pict
                 info:info
                 undo:undo
                  num:n
              pattern:pat];
    [pat release];
    [bmp release];

    return obj;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pattern_ : ѥ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerColorPatternSetter dealloc]\n"));

    // 񸻤β
    [self->pattern_ release];
    self->pattern_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    editInfo_ : Խ( instance ѿ)
//    num_      : оݥ顼ѥֹ(instance ѿ)
//    pattern_  : ѥ(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    PoCoColorPattern *undoPat;

    DPRINT((@"[PoCoControllerColorPatternSetter execute]\n"));

    result = NO;

    // Υѥ
    undoPat = [self->picture_ colpat:self->num_];
    if (undoPat != nil) {
        // ä
        if ([self->editInfo_ enableUndo]) {
            [self createUndo:undoPat];
        }

        // ѥϿ
        [self->picture_ setColpat:self->num_
                          pattern:self->pattern_];

        // ѥϿ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoColorPatternSet
                          object:[NSNumber numberWithInt:self->num_]];

        // ｪλ
        result = YES;
    }

    return result;
}


//
// ä
//
//  Call
//    pat          : ѥ
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    num_         : оݥѥֹ(instance ѿ)
//
//  Return
//    None
//
-(void)createUndo:(PoCoColorPattern *)pat
{
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createColorPatternSetter:YES
                             num:self->num_
                         pattern:pat];

    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"ColorPatternSet"
                                           value:@"set color pattern"
                                           table:nil]];

    return;
}

@end
