//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼¤ñ(̵Խ)
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerNoEditter.h"

#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerLayerNoEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    nm   : ä̾
//    upd  : 쥤䡼¤Ѳ
//
//  Return
//    function     : 
//    name_        : ä̾(instance ѿ)
//    update_      : 쥤䡼¤Ѳ(instance ѿ)
//    deallocPost_ : dealloc (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     name:(NSString *)nm
   update:(BOOL)upd;
{
    DPRINT((@"[PoCoControllerLayerNoEditter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->deallocPost_ = NO;
        self->name_ = nm;
        self->update_ = upd;
        [self->name_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    deallocPost_ : dealloc (instance ѿ)
//
//  Return
//    name_ : ä̾(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerNoEditter dealloc]\n"));

    if (self->deallocPost_) {
        [self postNote];
    }

    // 񸻤β
    [self->name_ release];
    self->name_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    factory_     : Խ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    name_        : ä̾(instanceѿ)
//    update_      : 쥤䡼¤Ѳ(instanceѿ)
//
//  Return
//    function     : Խ
//    deallocPost_ : dealloc (instance ѿ)
//
-(BOOL)execute
{
    DPRINT((@"[PoCoControllerLayerNoEditter execute]\n"));

    // 
    if ([self->undoManager_ isUndoing]) {
        self->deallocPost_ = NO;
        [self postNote];
    } else {
        self->deallocPost_ = YES;
    }

    // äκϿ
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createLayerNoEditter:YES
                        name:self->name_
                      update:self->update_];

    // ä̾Τ
    [super setUndoName:self->name_];

    return YES;
}


//
// Τ
//
//  Call
//    update_ : 쥤䡼¤Ѳ(instance ѿ)
//
//  Return
//    None
//
-(void)postNote
{
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoEditLayer
                      object:[NSNumber numberWithBool:self->update_]];

    return;
}

@end
