//
//	Pelistina on Cocoa - PoCo -
//	ѥåȹñ(̵Խ)
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPaletteNoEditter.h"

#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerPaletteNoEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    nm   : ä̾
//    idx  : оݥѥåֹ
//
//  Return
//    function     : 
//    name_        : ä̾(instance ѿ)
//    index_       : оݥѥåֹ(instance ѿ)
//    deallocPost_ : dealloc (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     name:(NSString *)nm
    index:(int)idx;
{
    DPRINT((@"[PoCoControllerPaletteNoEditter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->deallocPost_ = NO;
        self->name_ = nm;
        self->index_ = idx;
        [self->name_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    deallocPost_ : dealloc (instance ѿ)
//
//  Return
//    name_ : ä̾(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerPaletteNoEditter dealloc]\n"));

    if (self->deallocPost_) {
        [self postNote];
    }

    // 񸻤β
    [self->name_ release];
    self->name_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    factory_     : Խ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    name_        : ä̾(instance ѿ)
//    index_       : оݥѥåֹ(instance ѿ)
//
//  Return
//    function     : Խ
//    deallocPost_ : dealloc (instance ѿ)
//
-(BOOL)execute
{
    DPRINT((@"[PoCoControllerPaletteNoEditter execute]\n"));

    // 
    if ([self->undoManager_ isUndoing]) {
        self->deallocPost_ = NO;
        [self postNote];
    } else {
        self->deallocPost_ = YES;
    }

    // äκϿ
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createPaletteNoEditter:YES
                          name:self->name_
                         index:self->index_];

    // ä̾Τ
    [super setUndoName:self->name_];

    return YES;
}


//
// Τ
//
//  Call
//    index_ : оݥѥåֹ(instance ѿ)
//
//  Return
//    None
//
-(void)postNote
{
    if ((self->index_ >= 0) && (self->index_ < COLOR_MAX)) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangePalette
                          object:[NSNumber numberWithInt:self->index_]];
    } else {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangePalette
                          object:nil];
    }

    return;
}

@end
