//
//	Pelistina on Cocoa - PoCo -
//	ѹñ(̵Խ)
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerResizeNoEditter.h"

#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerResizeNoEditter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    nm   : ä̾
//
//  Return
//    function     : 
//    name_        : ä̾(instance ѿ)
//    deallocPost_ : dealloc (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     name:(NSString *)nm
{
    DPRINT((@"[PoCoControllerResizeNoEditter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->deallocPost_ = NO;
        self->name_ = nm;
        [self->name_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    deallocPost_ : dealloc (instance ѿ)
//
//  Return
//    name_ : ä̾(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerResizeNoEditter dealloc]\n"));

    if (self->deallocPost_) {
        [self postNote];
    }

    // 񸻤β
    [self->name_ release];
    self->name_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    factory_     : Խ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    name_        : ä̾(instanceѿ)
//
//  Return
//    function     : Խ
//    deallocPost_ : dealloc (instance ѿ)
//
-(BOOL)execute
{
    DPRINT((@"[PoCoControllerResizeNoEditter execute]\n"));

    // 
    if ([self->undoManager_ isUndoing]) {
        self->deallocPost_ = NO;
        [self postNote];
    } else {
        self->deallocPost_ = YES;
    }

    // äκϿ
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createResizeNoEditter:YES
                         name:self->name_];

    // ä̾Τ
    [super setUndoName:self->name_];

    return YES;
}


//
// Τ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)postNote
{
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoCanvasResize
                      object:nil];

    return;
}

@end
