//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerDeleter.h"

#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerInserter.h"

// ============================================================================
@implementation PoCoControllerLayerDeleter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    act  : Τ̵ͭ
//    idx  : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//    active_  : Τ̵ͭ(instance ѿ)
//    index_   : оݥ쥤䡼ֹ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   active:(BOOL)act
  atIndex:(int)idx
{
    DPRINT((@"[PoCoControllerLayerDeleter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->index_ = idx;
        self->active_ = act;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerDeleter dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_ : Խоݲ( instance ѿ)
//    active_  : Τ̵ͭ(instance ѿ)
//    index_   : оݥ쥤䡼ֹ(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL  result;
    const int cnt = (int)([[self->picture_ layer] count]);

    DPRINT((@"[PoCoControllerLayerDeleter execute]\n"));

    result = NO;

    // 쥤䡼ֹ椬ξϺǾ̥쥤䡼оݤˤ
    self->index_ = ((self->index_ < 0) ? (cnt - 1) : self->index_);

    if ((self->index_ < 0) || (self->index_ >= cnt) || (cnt == 1)) {
        // ֹ椫ñ쥤䡼ξϺԲ
        ;
    } else {
        [self createUndo];
        [self->picture_ deleteLayer:self->index_];
        result = YES;

        // ԽΤ
        if (self->active_) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoEditLayer
                              object:[NSNumber numberWithBool:YES]];
        }
    }

    return result;
}


//
// ä
//
//  Call
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    picture_     : Խоݲ( instance ѿ)
//    active_      : Τ̵ͭ(instanceѿ)
//    index_       : оݥ쥤䡼ֹ(instanceѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    if (self->active_) {
        [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
            createLayerInserter:YES
                          layer:[[self->picture_ layer:self->index_] copy]
                          index:self->index_];
    } else {
        [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
            createLayerInserterPassive:YES
                                 layer:[[self->picture_ layer:self->index_] copy]
                                 index:self->index_];
    }
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"LayerDelete"
                                           value:@"delete layer"
                                           table:nil]];

    return;
}

@end
