//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼ɽ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerDisplaySetter.h"

#import "PoCoLayer.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerLayerDisplaySetter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    idx  : оݥ쥤䡼ֹ
//    disp : 
//
//  Return
//    function   : 
//    index_     : оݥ쥤䡼ֹ(instance ѿ)
//    isDisplay_ : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
isDisplay:(BOOL)disp
  atIndex:(int)idx
{
    DPRINT((@"[PoCoControllerLayerDisplaySetter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->index_ = idx;
        self->isDisplay_ = disp;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerDisplaySetter dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    index_       : оݥ쥤䡼ֹ(instance ѿ)
//    isDisplay_   : (instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    if (self->isDisplay_) {
        [[self->picture_ layer:self->index_] setIsDisplay];
    } else {
        [[self->picture_ layer:self->index_] clearIsDisplay];
    }

    // ä
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createLayerDisplaySetter:YES
                            disp:((self->isDisplay_) ? NO : YES)
                            index:self->index_];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"LayerDisplaySet"
                                           value:@"set layer display"
                                           table:nil]]; 

    // ԽΤ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoEditLayer
                      object:[NSNumber numberWithBool:YES]];

    return YES;
}

@end
