//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerInserter.h"

#import "PoCoLayer.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerDeleter.h"

// ============================================================================
@implementation PoCoControllerLayerInserter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    act  : Τ̵ͭ
//    lyr  : 쥤䡼
//    idx  : 
//
//  Return
//    function : 
//    active_  : Τ̵ͭ(instance ѿ)
//    index_   : (instance ѿ)
//    layer_   : 쥤䡼(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   active:(BOOL)act
    layer:(PoCoLayerBase *)lyr
  atIndex:(int)idx
{
    DPRINT((@"[PoCoControllerLayerInserter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->active_ = act;
        self->index_ = idx;
        self->layer_ = lyr;
        [self->layer_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    layer_ : 쥤䡼(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerInserter dealloc]\n"));

    // 񸻤β
    [self->layer_ release];
    self->layer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_ : Խоݲ( instance ѿ)
//    active_  : Τ̵ͭ(instance ѿ)
//    index_   : (instance ѿ)
//    layer_   : 쥤䡼(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    DPRINT((@"[PoCoControllerLayerInserter execute]\n"));

    self->index_ = ((self->index_ < 0) ? (int)([[self->picture_ layer] count]) : self->index_);

    [self->picture_ insertLayer:self->index_ layer:self->layer_];

    // ä
    [self createUndo];

    // ԽΤ
    if (self->active_) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditLayer
                          object:[NSNumber numberWithBool:YES]];
    }

    return YES;
}


//
// ä
//
//  Call
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    active_      : Τ̵ͭ(instanceѿ)
//    index_       : оݥ쥤䡼ֹ(instanceѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    if (self->active_) {
        [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
            createLayerDeleter:YES
                         index:self->index_];
    } else {
        [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
            createLayerDeleterPassive:YES
                                index:self->index_];
    }
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"LayerInsert"
                                           value:@"insert layer"
                                           table:nil]];

    return;
}

@end
