//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼޻
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerLockSetter.h"

#import "PoCoLayer.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerLayerLockSetter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    idx  : оݥ쥤䡼ֹ
//    lock : 
//
//  Return
//    function  : 
//    index_    : оݥ쥤䡼ֹ(instance ѿ)
//    drawLock_ : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
 drawLock:(BOOL)lock
  atIndex:(int)idx
{
    DPRINT((@"[PoCoControllerLayerLockSetter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->index_ = idx;
        self->drawLock_ = lock;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerLockSetter dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    index_       : оݥ쥤䡼ֹ(instance ѿ)
//    drawLock_    : (instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    if (self->drawLock_) {
        [[self->picture_ layer:self->index_] setDrawLock];
    } else {
        [[self->picture_ layer:self->index_] clearDrawLock];
    }

    // ä
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createLayerLockSetter:YES
                         lock:((self->drawLock_) ? NO : YES)
                        index:self->index_];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"LayerDrawLockSet"
                                           value:@"set layer drawlock"
                                           table:nil]]; 

    // ԽΤ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoEditLayer
                      object:[NSNumber numberWithBool:NO]];

    return YES;
}

@end
