//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼ư/ʣ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerMover.h"

#import "PoCoLayer.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerNoEditter.h"
#import "PoCoControllerLayerInserter.h"
#import "PoCoControllerLayerDeleter.h"

// ============================================================================
@implementation PoCoControllerLayerMover

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    s    : ư
//    d    : ư
//    copy : ư/ʣλ
//
//  Return
//    function : 
//    src_     : ư(instance ѿ)
//    dst_     : ư(instance ѿ)
//    isCopy_  : ư/ʣλ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
fromIndex:(int)s
  toIndex:(int)d
   isCopy:(BOOL)copy
{
    DPRINT((@"[PoCoControllerLayerMover init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->src_ = s;
        self->dst_ = d;
        self->isCopy_ = copy;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerMover dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_ : Խоݲ( instance ѿ)
//    factory_ : Խ( instance ѿ)
//    src_     : ư(instance ѿ)
//    dst_     : ư(instance ѿ)
//    isCopy_  : ư/ʣλ(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL  result;
    id  cntl;
    int  target;
    PoCoLayerBase *layer;

    DPRINT((@"[PoCoControllerLayerMover execute]\n"));

    result = NO;

    // ɸ򻻽
    target = self->dst_;
    if (self->isCopy_) {
        layer = [[self->picture_ layer:self->src_] copy];
        cntl = [self->factory_ createLayerInserter:NO
                                             layer:layer
                                             index:target];
        if ([cntl execute]) {
            result = YES;
            [self->undoManager_ setActionName:[[NSBundle mainBundle]
                                                  localizedStringForKey:@"LayerCopy"
                                                                  value:@"copy layer"
                                                                  table:nil]];
        }
        [cntl release];
        [layer release];
    } else {
        if (self->src_ == self->dst_) {
            goto EXIT;
        } else if (self->src_ > self->dst_) {
            ;
        } else if ((self->src_ + 1) == self->dst_) {
            goto EXIT;
        }

        // ̵ԽϿ
        [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
            createLayerNoEditter:YES
                            name:nil
                          update:YES];

        // ʣ
        layer = [[self->picture_ layer:self->src_] copy];
        cntl = [self->factory_ createLayerInserterPassive:NO
                                                    layer:layer
                                                    index:target];
        if ([cntl execute]) {
            result = YES;
            [cntl release];

            // ư
            cntl = [self->factory_ createLayerDeleterPassive:NO
                                                       index:((self->src_ < self->dst_) ? self->src_ : (self->src_ + 1))];
            [cntl execute];
            [self->undoManager_ setActionName:[[NSBundle mainBundle]
                                                  localizedStringForKey:@"LayerMove"
                                                                  value:@"move layer"
                                                                  table:nil]];

            // ԽΤ
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoEditLayer
                              object:[NSNumber numberWithBool:YES]];
        }
        [cntl release];
        [layer release];
    }

EXIT:
    return result;
}

@end
