//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼̾
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerNameSetter.h"

#import "PoCoLayer.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerLayerNameSetter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    idx  : оݥ쥤䡼ֹ
//    nm   : 
//
//  Return
//    function : 
//    index_   : оݥ쥤䡼ֹ(instance ѿ)
//    name_    : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     name:(NSString *)nm
  atIndex:(int)idx
{
    DPRINT((@"[PoCoControllerLayerNameSetter init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->index_ = idx;
        self->name_ = nm;
        [self->name_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    name_ : (instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerNameSetter dealloc]\n"));

    // 񸻤β
    [self->name_ release];
    self->name_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    index_       : оݥ쥤䡼ֹ(instance ѿ)
//    name_        : (instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    PoCoLayerBase *layer;
    NSString *old;

    layer = [self->picture_ layer:self->index_];
    old = [layer name];
    [layer setName:self->name_];

    // ä
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createLayerNameSetter:YES
                         name:old
                        index:self->index_];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"LayerNameSet"
                                           value:@"set layer name"
                                           table:nil]]; 

    // ԽΤ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoEditLayer
                      object:[NSNumber numberWithBool:NO]];

    return YES;
}

@end
