//
//	Pelistina on Cocoa - PoCo -
//	ʸ쥤䡼ɲ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerLayerStringAdder.h"

#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerDeleter.h"

// ============================================================================
@implementation PoCoControllerLayerStringAdder

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    c    : 
//
//  Return
//    function : 
//    color_   : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
    color:(unsigned char)c
{
    DPRINT((@"[PoCoControllerLayerStringAdder init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->color_ = c;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerLayerStringAdder dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_ : Խоݲ( instance ѿ)
//    color_   : (instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL  result;
    PoCoErr er;

    result = NO;

    // ˺Ǿ̤ɲä
    er = [self->picture_ addStringLayer:-1 color:self->color_];
    if (er < ER_OK) {
        DPRINT((@"can't create layer : %d", er));
    } else {
        result = YES;

        // ä
        [self createUndo];

        // ԽΤ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditLayer
                          object:[NSNumber numberWithBool:YES]];
    }

    return result;
}


//
// ä
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createLayerDeleter:YES
                     index:(int)([[self->picture_ layer] count] - 1)];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"LayerCreateString"
                                           value:@"create string layer"
                                           table:nil]]; 

    return;
}

@end
