//
//	Pelistina on Cocoa - PoCo -
//	ѥå°ڤؤ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPaletteAttributeSetter.h"

#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerPaletteElementSetter.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoControllerPaletteAttributeSetter

// ---------------------------------------------------------- instance - public
//
// initialize(ñ쿧)
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    num  : 꿧ֹ
//    s    : 
//    m    : ɤػߤоݤˤ뤫
//    d    : ۤػߤоݤˤ뤫
//    t    : Ʃоݤˤ뤫
//
//  Return
//    function      : 
//    startNum_     : 꿧ֹ(instance ѿ)
//    endNum_       : 꿧ֹ潪(instance ѿ)
//    setType_      : ñ쿧ξ(instance ѿ)
//    maskTable_    : ɤػߤ(instance ѿ)
//    dropperTable_ : ۤػߤ(instance ѿ)
//    transTable_   : Ʃ(instance ѿ)
//    colorBuffer_  : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
  withNum:(int)num
  setType:(BOOL)s
     mask:(BOOL)m
  dropper:(BOOL)d
    trans:(BOOL)t
{
//    DPRINT((@"[PoCoControllerPaletteAttributeSetter init]\n"));

    // super class 
    self = [super initPict:pict
                 withInfo:info
                 withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->startNum_ = num;
        self->endNum_ = -1;
        self->setType_ = s;
        self->maskTable_ = (const BOOL *)((m) ? self : NULL);
        self->dropperTable_ = (const BOOL *)((d) ? self : NULL);
        self->transTable_ = (const BOOL *)((t) ? self : NULL);
        self->colorBuffer_ = buf;
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// initialize()
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    s    : 꿧ֹ
//    e    : 꿧ֹ潪
//    m    : ɤػߤ
//    d    : ۤػߤ
//    t    : Ʃ
//
//  Return
//    function      : 
//    startNum_     : 꿧ֹ(instance ѿ)
//    endNum_       : 꿧ֹ潪(instance ѿ)
//    setType_      : ñ쿧ξ(instance ѿ)
//    maskTable_    : ɤػߤ(instance ѿ)
//    dropperTable_ : ۤػߤ(instance ѿ)
//    transTable_   : Ʃ(instance ѿ)
//    colorBuffer_  : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
withStart:(int)s
  withEnd:(int)e
     mask:(const BOOL *)m
  dropper:(const BOOL *)d
    trans:(const BOOL *)t
{
//    DPRINT((@"[PoCoControllerPaletteAttributeSetter init]\n"));

    // super class 
    self = [super initPict:pict
                 withInfo:info
                 withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->startNum_ = s;
        self->endNum_ = e;
        self->maskTable_ = m;
        self->dropperTable_ = d;
        self->transTable_ = t;
        self->colorBuffer_ = buf;
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerPaletteAttributeSetter dealloc]\n"));

    // 񸻤
    [self->colorBuffer_ release];
    self->colorBuffer_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    undoManager_  : ä( instance ѿ)
//    factory_      : Խ( instance ѿ)
//    picture_      : Խоݲ( instance ѿ)
//    startNum_     : 꿧ֹ(instance ѿ)
//    endNum_       : 꿧ֹ潪(instance ѿ)
//    setType_      : ñ쿧ξ(instance ѿ)
//    maskTable_    : ɤػߤ(instance ѿ)
//    dropperTable_ : ۤػߤ(instance ѿ)
//    transTable_   : Ʃ(instance ѿ)
//
//  Return
//    function     : Խ
//    colorBuffer_ : ݻ(instance ѿ)
//
-(BOOL)execute
{
    BOOL  result;
    int l;
    int note;
    PoCoColor *col;
    PoCoPalette *plt;

    result = NO;

    if (self->endNum_ < 0) {
        // ñ쿧
        col = [[self->picture_ palette] palette:self->startNum_];
        note = (self->startNum_ & 0x0000ffff);
        if ((self->maskTable_ != NULL) && ([col isMask] != self->setType_)) {
            [col setMask:self->setType_];
            result = YES;
            note |= 0x00010000;
        }
        if ((self->dropperTable_ != NULL) && ([col noDropper] != self->setType_)) {
            [col setDropper:self->setType_];
            result = YES;
            note |= 0x00020000;
        }
        if ((self->transTable_ != NULL) && ([col isTrans] != self->setType_)) {
            [col setTrans:self->setType_];
            result = YES;
            note |= 0x00040000;
        }

        // ä
        if (result) {
            [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
                createPaletteAttributeSetter:YES
                                         num:self->startNum_
                                     setType:((self->setType_) ? NO : YES)
                                        mask:(self->maskTable_ != nil)
                                     dropper:(self->dropperTable_ != nil)
                                       trans:(self->transTable_ != nil)];
        }
    } else {
        // 
        note = 0x0000ffff;
        plt = [[self->picture_ palette] copy];
        for (l = self->startNum_; l < self->endNum_; (l)++) {
            col = [[self->picture_ palette] palette:l];
            if ([col isMask] != self->maskTable_[l]) {
                [col setMask:self->maskTable_[l]];
                result = YES;
                note |= 0x00010000;
            }
            if ([col noDropper] != self->dropperTable_[l]) {
                [col setDropper:self->dropperTable_[l]];
                result = YES;
                note |= 0x00020000;
            }
            if ([col isTrans] != self->transTable_[l]) {
                [col setTrans:self->transTable_[l]];
                result = YES;
                note |= 0x00040000;
            }
        }
        if (result) {
            [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
                createPaletteElementSetter:YES
                                   palette:plt];
        } else {
            [plt release];
        }
    }

    // Խ줿
    if (result) {
        // ä̾Τ
        [super setUndoName:[[NSBundle mainBundle]
                              localizedStringForKey:@"PaletteAttributeSet"
                                              value:@"set palette attribute"
                                              table:nil]];

        // ѥåȤ°
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangePaletteAttr
                          object:[NSNumber numberWithInt:note]];

        // ݻ
        [self->colorBuffer_ reset:nil];
    }

    return result;
}

@end
