//
//	Pelistina on Cocoa - PoCo -
//	ѥå
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPaletteElementSetter.h"

#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoControllerPaletteElementSetter

// ---------------------------------------------------------- instance - public
//
// 
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    pal  : 
//
//  Return
//    function     : 
//    palette_     : (instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
  palette:(PoCoPalette *)pal
{
    DPRINT((@"PoCoControllerPaletteElementSetter init]\n"));

    // super class ν
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->palette_ = pal;
        self->colorBuffer_ = buf;
        [self->palette_ retain];
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// 
//
//  Call
//    None
//
//  Return
//    palette_ : (instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"PoCoControllerPaletteElementSetter dealloc]\n"));

    // 񸻤β
    [self->palette_ release];
    [self->colorBuffer_ release];
    self->palette_ = nil;
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}

//
// Խ¹
//
//  Call
//    picture_ : Խоݲ( instance ѿ)
//    palette_ : (instance ѿ)
//
//  Return
//    function     : Խ
//    colorBuffer_ : ݻ(instance ѿ)
//
-(BOOL)execute
{
    int l;
    PoCoColor *src;
    PoCoColor *dst;

    // ä
    [self createUndo];

    // Ƥ缡
    for (l = 0; l < COLOR_MAX; l++) {
        src = [self->palette_ palette:l];
        dst = [[self->picture_ palette] palette:l];
        [dst setRed:[src red]
           setGreen:[src green]
            setBlue:[src blue]];
        [dst setTrans:[src isTrans]];
        [dst setDropper:[src noDropper]];
        [dst setMask:[src isMask]];
    }

    // ѥåȤι
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoChangePalette
                      object:nil];

    // ݻ
    [self->colorBuffer_ reset:nil];

    return YES;
}


//
// ä
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createPaletteElementSetter:YES
                           palette:[[self->picture_ palette] copy]];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"PaletteElementSet"
                                           value:@"edit palette"
                                           table:nil]];

    return;
}

@end
