//
//	Pelistina on Cocoa - PoCo -
//	ѥåȥǡ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPaletteGradationMaker.h"

#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerPaletteElementSetter.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoControllerPaletteGradationMaker

// --------------------------------------------------------- instance - private
//
// RGB Ϥ
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    startNum_ : ֹ(instance ѿ)
//    endNum_   : ֹ(instance ѿ)
//
//  Return
//    None
//
-(void)createRGB
{
    int idx;                            // оݿֹ
    int num;                            // 
    int rstep;
    int gstep;
    int bstep;
    int st = (self->endNum_ - self->startNum_);
    PoCoPalette *palette = [self->picture_ palette];
    PoCoColor *sc = [palette palette:self->startNum_];
    PoCoColor *ec = [palette palette:self->endNum_];
    int r = (int)([sc red]);
    int g = (int)([sc green]);
    int b = (int)([sc blue]);

    // ̤򻻽
    rstep = ((((int)([ec red])   - (int)([sc red]))   << 8) / st);
    gstep = ((((int)([ec green]) - (int)([sc green])) << 8) / st);
    bstep = ((((int)([ec blue])  - (int)([sc blue]))  << 8) / st);

    // (startNum_, endNum_) ϰϤͤ
    for (idx = (self->startNum_ + 1), num = 1;
         idx < self->endNum_;
         (idx)++, (num)++) {
        [[palette palette:idx] setRed:(unsigned char)(r + ((rstep * num) >> 8))
                             setGreen:(unsigned char)(g + ((gstep * num) >> 8))
                              setBlue:(unsigned char)(b + ((bstep * num) >> 8))];
    }

    return;
}


//
// HLS Ϥ
//
//  Call
//    picture_  : Խоݲ( instance ѿ)
//    startNum_ : ֹ(instance ѿ)
//    endNum_   : ֹ(instance ѿ)
//
//  Return
//    None
//
-(void)createHLS
{
    int idx;                            // оݿֹ
    int num;                            // 
    int hs;
    int ls;
    int ss;
    int st = (self->endNum_ - self->startNum_);
    PoCoPalette *palette = [self->picture_ palette];
    PoCoColor *sc = [palette palette:self->startNum_];
    PoCoColor *ec = [palette palette:self->endNum_];
    int h = (int)([sc hue]);
    int l = (int)([sc lightness]);
    int s = (int)([sc saturation]);

    // ٤̤򻻽
    ls = ((((int)([ec lightness]) - (int)([sc lightness])) << 8) / st);

    if ([sc saturation] == 0) {
        // (startNum_, endNum_) ϰϤͤ(λ¦οǸ)
        for (idx = (self->startNum_ + 1), num = 1;
             idx < self->endNum_;
             (idx)++, (num)++) {
            [[palette palette:idx] setHue:[ec hue]
                             setLightness:(unsigned char)(l + ((ls * num) >> 8))
                            setSaturation:[ec saturation]];
        }
    } else if ([ec saturation] == 0) {
        // (startNum_, endNum_) ϰϤͤ(¦οǸ)
        for (idx = (self->startNum_ + 1), num = 1;
             idx < self->endNum_;
             (idx)++, (num)++) {
            [[palette palette:idx] setHue:[sc hue]
                             setLightness:(unsigned char)(l + ((ls * num) >> 8))
                            setSaturation:[sc saturation]];
        }
    } else {
        // ٤̤򻻽
        ss = ((((int)([ec saturation]) - (int)([sc saturation])) << 8) / st);

        // ̤򻻽
        hs = ((int)([ec hue]) - (int)([sc hue]));
        if(hs != 0){
            if (hs < -128) {
                hs = (255 - ((int)([sc hue]) - (int)([ec hue])));
            } else if (hs > 128) {
                hs = ((int)([ec hue]) - (int)([sc hue]) - 255);
            }
            hs = ((hs << 8) / st);
        }

        // (startNum_, endNum_) ϰϤͤ
        for (idx = (self->startNum_ + 1), num = 1;
             idx < self->endNum_;
             (idx)++, (num)++) {
            [[palette palette:idx] setHue:(unsigned char)(h + ((hs * num) >> 8))
                             setLightness:(unsigned char)(l + ((ls * num) >> 8))
                            setSaturation:(unsigned char)(s + ((ss * num) >> 8))];
        }
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    s    : ֹ
//    e    : ֹ
//
//  Return
//    function     : 
//    startNum_    : ֹ(instance ѿ)
//    endNum_      : ֹ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
 startNum:(int)s
   endNum:(int)e
{
//    DPRINT((@"[PoCoControllerPaletteGradationMaker init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->startNum_ = MIN(s, e);
        self->endNum_ = MAX(s, e);
        self->colorBuffer_ = buf;
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerPaletteGradationMaker dealloc]\n"));

    // 񸻤β
    [self->colorBuffer_ release];
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    editInfo_ : Խ( instance ѿ
//    startNum_ : ֹ(instance ѿ)
//    endNum_   : ֹ(instance ѿ)
//
//  Return
//    function     : Խ
//    colorBuffer_ : ݻ(instance ѿ)
//
-(BOOL)execute
{
    BOOL  result;

//    DPRINT((@"[PoCoControllerPaletteGradationMaker execute]\n"));

    result = NO;

    if (self->startNum_ >= self->endNum_) {
        // λ꤬
        ;
    } else {
        // ä
        [self createUndo];

        // 黻ˡʬ
        switch ([self->editInfo_ colorMode]) {
            case PoCoColorMode_RGB:
            default:
                // RGB ( RGB Ϥ)
                [self createRGB];
                break;
            case PoCoColorMode_HLS:
                // HLS 
                [self createHLS];
                break;
        }
        result = YES;

        // ѥåȤι
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangePalette
                          object:nil];

        // ݻ
        [self->colorBuffer_ reset:nil];
    }

    return result;
}


//
// ä
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createPaletteElementSetter:YES
                           palette:[[self->picture_ palette] copy]];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"PaletteGradation"
                                           value:@"make gradation palette"
                                           table:nil]];

    return;
}
  
@end
