//
//	Pelistina on Cocoa - PoCo -
//	ѥåȼ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPaletteImporter.h"

#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoControllerPaletteImporter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict   : Խоݲ
//    info   : Խ
//    undo   : ä
//    buf    : ݻ
//    target : 
//    flags  : о
//
//  Return
//    function       : 
//    targetPalette_ : (instance ѿ)
//    targetFlags_[] : о(instance ѿ)
//    colorBuffer_   : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
         info:(PoCoEditInfo *)info
         undo:(NSUndoManager *)undo
       buffer:(PoCoColorBuffer *)buf
targetPalette:(PoCoPalette *)target
    withFlags:(const BOOL *)flags
{
    DPRINT((@"PoCoControllerPaletteImporter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->targetPalette_ = target;
        memcpy(self->targetFlags_, flags, sizeof(BOOL) * COLOR_MAX);
        self->colorBuffer_ = buf;
        [self->targetPalette_ retain];
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    targetPalette_ : (instance ѿ)
//    colorBuffer_   : ݻ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"PoCoControllerPaletteImporter dealloc]\n"));

    // 񸻤β
    [self->targetPalette_ release];
    [self->colorBuffer_ release];
    self->targetPalette_ = nil;
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}

//
// Խ¹
//
//  Call
//    picture_       : Խоݲ( instance ѿ)
//    targetPalette_ : (instance ѿ)
//    targetFlags_[] : о(instance ѿ)
//
//  Return
//    function     : Խ
//    colorBuffer_ : ݻ(instance ѿ)
//
-(BOOL)execute
{
    int l;
    PoCoColor *col;

    // ä
    [self createUndo];

    // ѥåȤ򹹿
    for (l = 0; l < COLOR_MAX; (l)++) {
        if (self->targetFlags_[l]) {
            col = [self->targetPalette_ palette:l];
            [[[self->picture_ palette] palette:l] setRed:[col red]
                                               setGreen:[col green]
                                                setBlue:[col blue]];
        }
    }

    // ѥåȤι
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoChangePalette
                      object:nil];

    // ݻ
    [self->colorBuffer_ reset:nil];

    return YES;
}


//
// ä
//
//  Call
//    picture_       : Խоݲ(instanceѿ)
//    undoManager_   : ä(instanceѿ)
//    factory_       : Խ(instanceѿ)
//    targetFlags_[] : о(instance ѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createPaletteElementSetter:YES
                           palette:[[self->picture_ palette] copy]];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"PaletteImport"
                                           value:@"import palette"
                                           table:nil]];

    return;
}

@end
