//
//	Pelistina on Cocoa - PoCo -
//	ѥåǲû
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPaletteIncrementer.h"

#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerPaletteDecrementer.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoControllerPaletteIncrementer

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    n    : оݿֹ
//    r    : Ǥоݤˤ뤫
//    g    : Ǥоݤˤ뤫
//    b    : Ǥоݤˤ뤫
//    s    : 
//
//  Return
//    function     : 
//    num_         : оݿֹ(instance ѿ)
//    isRed_       : Ǥоݤˤ뤫(instance ѿ)
//    isGreen_     : Ǥоݤˤ뤫(instance ѿ)
//    isBlue_      : Ǥоݤˤ뤫(instance ѿ)
//    step_        : (instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
      num:(int)n
      red:(BOOL)r
    green:(BOOL)g
     blue:(BOOL)b
     step:(unsigned int)s
{
//    DPRINT((@"[PoCoControllerPaletteIncrementer init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->num_ = n;
        self->isRed_ = r;
        self->isGreen_ = g;
        self->isBlue_ = b;
        self->step_ = s;
        self->colorBuffer_ = buf;
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerPaletteIncrementer dealloc]\n"));

    // 񸻤β
    [self->colorBuffer_ release];
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_ : Խоݲ( instance ѿ)
//    num_     : оݿֹ(instance ѿ)
//    isRed_   : Ǥоݤˤ뤫(instance ѿ)
//    isGreen_ : Ǥоݤˤ뤫(instance ѿ)
//    isBlue_  : Ǥоݤˤ뤫(instance ѿ)
//    step_    : (instance ѿ)
//
//  Return
//    function     : Խ
//    prevElm_[]   : ѹο(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(BOOL)execute
{
    BOOL  result;
    int elm[3];
    PoCoColor *col = [[self->picture_ palette] palette:self->num_];

//    DPRINT((@"[PoCoControllerPaletteIncrementer execute]\n"));

    result = NO;

    // ͤѹ
    elm[0] = (int)([col red]);
    self->prevElm_[0] = elm[0];
    if (self->isRed_) {
        elm[0] = MIN(255, elm[0] + self->step_);
    }
    elm[1] = (int)([col green]);
    self->prevElm_[1] = elm[1];
    if (self->isGreen_) {
        elm[1] = MIN(255, elm[1] + self->step_);
    }
    elm[2] = (int)([col blue]);
    self->prevElm_[2] = elm[2];
    if (self->isBlue_) {
        elm[2] = MIN(255, elm[2] + self->step_);
    }

    // ѹͤȿ
    if ((elm[0] != self->prevElm_[0]) ||
        (elm[1] != self->prevElm_[1]) ||
        (elm[2] != self->prevElm_[2])) {
        [col setRed:(unsigned char)(elm[0])
           setGreen:(unsigned char)(elm[1])
            setBlue:(unsigned char)(elm[2])];

        result = YES;

        // ä
        [self createUndo];

        // ѥåȤι
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangePalette
                          object:[NSNumber numberWithInt:self->num_]];

        // ݻ
        [self->colorBuffer_ reset:nil];
    }

    return result;
}


//
// ä
//
//  Call
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    picture_     : Խоݲ( instance ѿ)
//    num_         : оݿֹ(instance ѿ)
//    prevElm_[]   : ѹο(instance ѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createPaletteSingleSetter:YES
                              num:self->num_
                              red:self->prevElm_[0]
                            green:self->prevElm_[1]
                             blue:self->prevElm_[2]
                           isMask:[[[self->picture_ palette] palette:self->num_] isMask]
                           noDrop:[[[self->picture_ palette] palette:self->num_] noDropper]
                          isTrans:[[[self->picture_ palette] palette:self->num_] isTrans]
                             name:[[NSBundle mainBundle]
                                      localizedStringForKey:@"PaletteIncrement"
                                                      value:@"increment palette"
                                                      table:nil]];
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"PaletteIncrement"
                                           value:@"increment palette"
                                           table:nil]];

    return;
}

@end
