//
//	Pelistina on Cocoa - PoCo -
//	ñѥå
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPaletteSingleSetter.h"

#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoControllerPaletteSingleSetter

// ---------------------------------------------------------- instance - public
//
// 
//
//  Call
//    pict  : Խоݲ
//    info  : Խ
//    undo  : ä
//    buf   : ݻ
//    num   : оݿֹ
//    r     : 
//    g     : 
//    b     : 
//    mask  : ɤػ
//    drop  : ۤػ
//    trans : Ʃ
//    name  : ä̾
//
//  Return
//    function     : 
//    paletteNum_  : оݿֹ(instance ѿ)
//    red_         : (instance ѿ)
//    green_       : (instance ѿ)
//    blue_        : (instance ѿ)
//    isMask_      : 񤭶ػ(instance ѿ)
//    noDrop_      : ۤػ(instance ѿ)
//    isTrans_     : Ʃ(instance ѿ)
//    undoName_    : ä̾(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
      num:(int)num
      red:(unsigned char)r
    green:(unsigned char)g
     blue:(unsigned char)b
   isMask:(BOOL)mask
   noDrop:(BOOL)drop
  isTrans:(BOOL)trans
     name:(NSString *)name
{
    DPRINT((@"PoCoControllerPaletteSingleSetter init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->paletteNum_ = num;
        self->red_ = r;
        self->green_ = g;
        self->blue_ = b;
        self->isMask_ = mask;
        self->noDrop_ = drop;
        self->isTrans_ = trans;
        self->undoName_ = name;
        self->colorBuffer_ = buf;
        [self->undoName_ retain];
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// 
//
//  Call
//    None
//
//  Return
//    undoName_    : ä̾(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"PoCoControllerPaletteSingleSetter dealloc]\n"));

    // 񸻤
    [self->undoName_ release];
    [self->colorBuffer_ release];
    self->undoName_ = nil;
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}

//
// Խ¹
//
//  Call
//    picture_    : Խоݲ( instance ѿ)
//    paletteNum_ : оݿֹ(instance ѿ)
//    red_        : (instance ѿ)
//    green_      : (instance ѿ)
//    blue_       : (instance ѿ)
//    isMask_     : 񤭶ػ(instance ѿ)
//    noDrop_     : ۤػ(instance ѿ)
//    isTrans_    : Ʃ(instance ѿ)
//
//  Return
//    function     : Խ
//    colorBuffer_ : ݻ(instance ѿ)
//
-(BOOL)execute
{
    PoCoColor *col = [[self->picture_ palette] palette:self->paletteNum_];

    // ä
    [self createUndo];

    // Ƥ缡
    [col setRed:self->red_
       setGreen:self->green_
        setBlue:self->blue_];
    [col setMask:self->isMask_];
    [col setDropper:self->noDrop_];
    [col setTrans:self->isTrans_];

    // ѥåȤι
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoChangePalette
                      object:[NSNumber numberWithInt:self->paletteNum_]];

    // ݻ
    [self->colorBuffer_ reset:nil];

    return YES;
}


//
// ä
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    paletteNum_  : оݿֹ(instance ѿ)
//    red_         : (instance ѿ)
//    green_       : (instance ѿ)
//    blue_        : (instance ѿ)
//    isMask_      : 񤭶ػ(instance ѿ)
//    noDrop_      : ۤػ(instance ѿ)
//    isTrans_     : Ʃ(instance ѿ)
//    undoName_    : ä̾(instance ѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    PoCoColor *col = [[self->picture_ palette] palette:self->paletteNum_];

    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createPaletteSingleSetter:YES
                              num:self->paletteNum_
                              red:[col red]
                            green:[col green]
                             blue:[col blue]
                           isMask:[col isMask]
                           noDrop:[col noDropper]
                          isTrans:[col isTrans]
                             name:self->undoName_];
    [super setUndoName:self->undoName_];

    return;
}

@end
