//
//	Pelistina on Cocoa - PoCo -
//	ִ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPictureBitmapReplacer.h"

#import "PoCoLayer.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoControllerPictureBitmapReplacer

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    idx  : оݥ쥤䡼ֹ
//    r    : ִΰ
//    bmp  : ִ
//    name : ä̾
//
//  Return
//    function  : 
//    index_    : оݥ쥤䡼ֹ(instance ѿ)
//    rect_     : ִΰ(instance ѿ)
//    bitmap_   : ִ(instance ѿ)
//    undoName_ : ä̾(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
    layer:(int)idx
     rect:(PoCoRect *)r
   bitmap:(PoCoBitmap *)bmp
     name:(NSString *)name
{
//    DPRINT((@"[PoCoControllerPictureBitmapReplacer init]\n"));

    // super class ν
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->index_ = idx;
        self->rect_ = r;
        self->bitmap_ = bmp;
        self->undoName_ = name;
        [self->rect_ retain];
        [self->bitmap_ retain];
        [self->undoName_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    rect_     : ִΰ(instance ѿ)
//    bitmap_   : ִ(instance ѿ)
//    undoName_ : ä̾(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerPictureBitmapReplacer dealloc]\n"));

    // 񸻤β
    [self->rect_ release];
    [self->bitmap_ release];
    [self->undoName_ release];
    self->rect_ = nil;
    self->bitmap_ = nil;
    self->undoName_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    index_       : оݥ쥤䡼ֹ(instance ѿ)
//    rect_        : ִΰ(instance ѿ)
//    bitmap_      : ִ(instance ѿ)
//    undoName_    : ä̾(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL  result;
    PoCoBitmap *bmp;
    PoCoLayerBase *layer;
    PoCoEditPictureNotification *note;

//    DPRINT((@"[PoCoControllerPictureBitmapReplacer execute]\n"));

    result = NO;
    bmp = nil;

    // оݥ쥤䡼μ
    layer = [self->picture_ layer:self->index_];
    if (layer != nil) {
        // μ
        bmp = [[layer bitmap] getBitmap:self->rect_];

        // ִ
        [[layer bitmap] setBitmap:[self->bitmap_ pixelmap]
                         withRect:self->rect_];

        // ä
        if (bmp != nil) {
            [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
                createPictureBitmapReplacer:YES
                                      layer:self->index_
                                       rect:self->rect_
                                     bitmap:bmp
                                       name:self->undoName_];
            [super setUndoName:self->undoName_];
        }

        // Խ
        result = YES;
        note = [[PoCoEditPictureNotification alloc] initWithRect:self->rect_
                                                         atIndex:self->index_];
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoEditPicture
                          object:note];
        [note release];
    }
    [bmp release];

    return result;
}

@end
