//
//	Pelistina on Cocoa - PoCo -
//	ѹ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPictureCanvasResizer.h"

#import "PoCoEditInfo.h"
#import "PoCoLayer.h"

#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerInserter.h"
#import "PoCoControllerLayerDeleter.h"

#import "PoCoEditResizeBitmap.h"

// ============================================================================
@implementation PoCoControllerPictureCanvasResizer

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    f              : 
//    w              : 
//    h              : ⤵
//
//  Return
//    isFit_  : (instance ѿ)
//    width_  : (instance ѿ)
//    height_ : ⤵(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
    isFit:(BOOL)f
    width:(int)w
   height:(int)h
{
    DPRINT((@"[PoCoControllerPictureCanvasResizer init]\n"));

    // super class ν
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->isFit_ = f;
        self->width_ = w;
        self->height_ = h;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerPictureCanvasResizer dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ) 
//    factory_     : Խ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    isFit_       : (instance ѿ)
//    width_       : (instance ѿ)
//    height_      : ⤵(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    int index;
    PoCoBitmap *bmp;
    PoCoRect *r;
    PoCoLayerBase *oldLayer;            // ѷ
    PoCoBitmapLayer *newLayer;          // ѷ
    PoCoEditResizeBitmap *edit;
    const int layerNum = (int)([[self->picture_ layer] count]);

    DPRINT((@"[PoCoControllerPictureCanvasResizer execute]\n"));

    result = NO;
    newLayer = nil;

    // Ʊʤ鲿⤷ʤ
    if (([[[self->picture_ layer:0] bitmap] width] == self->width_) &&
        ([[[self->picture_ layer:0] bitmap] height] == self->height_)) {
        goto EXIT;
    }

    // ̵ԽϿ
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createResizeNoEditter:YES
                         name:nil];

    // ѷ(ѷΥ쥤䡼ɲäƤ)
    for (index = 0; index < layerNum; (index)++) {
        oldLayer = [self->picture_ layer:index];
        if (oldLayer != nil) {
            // ѷ bitmap 
            newLayer = [[PoCoBitmapLayer alloc]
                           initWidth:self->width_
                          initHeight:self->height_
                        defaultColor:[[self->editInfo_ selColor] num]];

            // °ʣ
            if ([oldLayer drawLock]) {          // 
                [newLayer setDrawLock];
            }
            if (!([oldLayer isDisplay])) {      // ɽ
                [newLayer clearIsDisplay];
            }
            [newLayer setName:[oldLayer name]]; // ̾

            // ѷ
            if (self->isFit_) {
                // 
                edit = [[PoCoEditResizeBitmap alloc] initDst:[newLayer bitmap]
                                                     withSrc:[oldLayer bitmap]];
                [edit executeResize];
                [edit release];
            } else {
                // clip
                r = [self->picture_ bitmapPoCoRect];
                bmp = [[oldLayer bitmap] getBitmap:r];
                [[newLayer bitmap] setBitmap:[bmp pixelmap]
                                    withRect:r];
                [r release];
                [bmp release];
            }

            // ѷ layer ɲ
            [self->factory_ createLayerInserterPassive:YES
                                                 layer:newLayer
                                                 index:-1];
            [newLayer release];
        }
    }

    // ѷ˴(ѷΥ쥤䡼)
    for (index = (layerNum - 1); index >= 0; (index)--) {
        [self->factory_ createLayerDeleterPassive:YES
                                            index:index];
    }

    // ä̾Τ
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"CanvasResize"
                                           value:@"canvas resize"
                                           table:nil]];

    // Խ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoCanvasResize
                      object:nil];

    // ｪλ
    result = YES;

EXIT:
    return result;
}

@end
