//
//	Pelistina on Cocoa - PoCo -
//	ʣ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPictureColorPaster.h"

#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoControllerPictureColorPaster

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    buf  : ݻ
//    act  : Τ̵ͭ
//    s    : ʣ̸ֹ
//    d    : ʣ迧ֹ
//
//  Return
//    function     : 
//    active_      : Τ̵ͭ(instance ѿ)
//    srcNum_      : ʣ̸ֹ(instance ѿ)
//    dstNum_      : ʣ迧ֹ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
   buffer:(PoCoColorBuffer *)buf
   active:(BOOL)act
      src:(unsigned char)s
      dst:(unsigned char)d
{
//    DPRINT((@"[PoCoControllerPictureColorPaster init]\n"));

    // super class 
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo];

    // Ȥ
    if (self != nil) {
        self->active_ = act;
        self->srcNum_ = s;
        self->dstNum_ = d;
        self->colorBuffer_ = buf;
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoControllerPictureColorPaster dealloc]\n"));

    // 񸻤β
    [self->colorBuffer_ release];
    self->colorBuffer_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_ : Խоݲ( instance ѿ)
//    active_  : Τ̵ͭ(instance ѿ)
//    srcNum_  : ʣ̸ֹ(instance ѿ)
//    dstNum_  : ʣ迧ֹ(instance ѿ)
//
//  Return
//    function     : Խ
//    colorBuffer_ : ݻ(instance ѿ)
//
-(BOOL)execute
{
    BOOL  result;
    PoCoPalette *plt = [self->picture_ palette];

    result = NO;
    if (self->srcNum_ == self->dstNum_) {
        goto EXIT;
    }

    // ä
    [self createUndo];

    // ѥåȤʣ
    [[plt palette:self->dstNum_] setRed:[[plt palette:self->srcNum_] red]
                               setGreen:[[plt palette:self->srcNum_] green]
                                setBlue:[[plt palette:self->srcNum_] blue]];
    [[plt palette:self->dstNum_] setMask:[[plt palette:self->srcNum_] isMask]];
    [[plt palette:self->dstNum_] setDropper:[[plt palette:self->srcNum_] noDropper]];
    [[plt palette:self->dstNum_] setTrans:[[plt palette:self->srcNum_] isTrans]];

    // λ
    result = YES;

    // ݻ
    [self->colorBuffer_ reset:nil];

    // Խ
    if (self->active_) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangePalette
                          object:nil];
    }

EXIT:
    return result;
}


//
// ä
//
//  Call
//    undoManager_ : ä( instance ѿ)
//    factory_     : Խ( instance ѿ)
//    active_      : Τ̵ͭ(instance ѿ)
//    dstNum_      : ʣ迧ֹ(instance ѿ)
//
//  Return
//    None
//
-(void)createUndo
{
    PoCoColor *col = [[self->picture_ palette] palette:self->dstNum_];
    NSString *name;

    name = [[NSBundle mainBundle] localizedStringForKey:@"PalettePaste"
                                                  value:@"paste palette"
                                                  table:nil];

    if (self->active_) {
        [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
            createPaletteSingleSetter:YES
                                  num:self->dstNum_
                                  red:[col red]
                                green:[col green]
                                 blue:[col blue]
                               isMask:[col isMask]
                               noDrop:[col noDropper]
                              isTrans:[col isTrans]
                                 name:name];
    } else {
        [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
                   createPaletteSingleSetter:YES
                                         num:self->dstNum_
                                         red:[col red]
                                       green:[col green]
                                        blue:[col blue]
                                      isMask:[col isMask]
                                      noDrop:[col noDropper]
                                     isTrans:[col isTrans]
                                        name:name];
    }

    return;
}

@end
