//
//	Pelistina on Cocoa - PoCo -
//	ڤȴ
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoControllerPictureImageClipper.h"

#import "PoCoEditInfo.h"
#import "PoCoLayer.h"

#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerInserter.h"
#import "PoCoControllerLayerDeleter.h"

// ============================================================================
@implementation PoCoControllerPictureImageClipper

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//    r    : 
//
//  Return
//    rect_ : (instance ѿ)
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
     rect:(PoCoRect *)r
{
    DPRINT((@"[PoCoControllerPictureImageClipper init]\n"));

    // super class ν
    self = [super initPict:pict
                  withInfo:info
                  withUndo:undo];

    // Ȥν
    if (self != nil) {
        self->rect_ = r;
        [self->rect_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    rect_ : (instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerPictureImageClipper dealloc]\n"));

    // 񸻤β
    [self->rect_ release];
    self->rect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    picture_     : Խоݲ( instance ѿ)
//    undoManager_ : ä( instance ѿ) 
//    factory_     : Խ( instance ѿ)
//    editInfo_    : Խ( instance ѿ)
//    rect_        : (instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    int index;
    PoCoRect *r;
    PoCoBitmap *bmp;
    PoCoLayerBase *oldLayer;            // ѷ
    PoCoBitmapLayer *newLayer;          // ѷ
    const int layerNum = (int)([[self->picture_ layer] count]);
    const int width = [self->rect_ width];
    const int height = [self->rect_ height];

    DPRINT((@"[PoCoControllerPictureImageClipper execute]\n"));

    result = NO;
    newLayer = nil;
    r = nil;

    // Ʊʤ鲿⤷ʤ
    if (([self->rect_ left] == 0) &&
        ([self->rect_ top] == 0) &&
        (width == [[[self->picture_ layer:0] bitmap] width]) &&
        (height == [[[self->picture_ layer:0] bitmap] height])) {
        goto EXIT;
    }

    // ڤȴζȤ
    r = [[PoCoRect alloc] initPoCoRect:self->rect_];
    [r shiftX:-([self->rect_ left])
       shiftY:-([self->rect_  top])];

    // ̵ԽϿ
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createClipNoEditter:YES
                            name:nil];

    // ѷ(ѷΥ쥤䡼ɲäƤ)
    for (index = 0; index < layerNum; (index)++) {
        oldLayer = [self->picture_ layer:index];
        if (oldLayer != nil) {
            // ѷ bitmap 
            newLayer = [[PoCoBitmapLayer alloc]
                           initWidth:width
                          initHeight:height
                        defaultColor:[[self->editInfo_ selColor] num]];

            // °ʣ
            if ([oldLayer drawLock]) {          // 
                [newLayer setDrawLock];
            }
            if (!([oldLayer isDisplay])) {      // ɽ
                [newLayer clearIsDisplay];
            }
            [newLayer setName:[oldLayer name]]; // ̾

            // ڤȴ
            bmp = [[oldLayer bitmap] getBitmap:self->rect_];
            [[newLayer bitmap] setBitmap:[bmp pixelmap]
                                withRect:r];
            [bmp release];

            // ѷ layer ɲ
            [self->factory_ createLayerInserterPassive:YES
                                                 layer:newLayer
                                                 index:-1];
            [newLayer release];
        }
    }

    // ѷ˴(ѷΥ쥤䡼)
    for (index = (layerNum - 1); index >= 0; (index)--) {
        [self->factory_ createLayerDeleterPassive:YES
                                            index:index];
    }

    // ä̾Τ
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"ImageClip"
                                           value:@"clip image"
                                           table:nil]];

    // Խ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoImageClip
                      object:nil];

    // ｪλ
    result = YES;

EXIT:
    [r release];
    return result;
}

@end
