//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoControllerPictureLayerUnificater.h"

#import "PoCoLayer.h"
#import "PoCoPalette.h"

#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerInserter.h"
#import "PoCoControllerLayerDeleter.h"

// ============================================================================
@implementation PoCoControllerPictureLayerUnificater

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    pict  : Խоݲ
//    first : YES : ǽؤϾ
//            NO  : ǽؤǤƩ褷ʤ
//
//  Return
//    function : 礷
//
+(PoCoBitmapLayer *)createUnificatePicture:(PoCoPicture *)pict
                                   isFirst:(BOOL)first
{
    PoCoBitmapLayer *bmp;               // 쥤䡼
    unsigned int x;                     // ʿ
    unsigned int y;                     // ľ
    unsigned int idx;                   // index-reg.(SI/DI )
    unsigned int row;                   // row bytes
    unsigned char *src;                 // 쥤䡼
    unsigned char *dst;                 // 쥤䡼
    NSEnumerator *iter;                 // ƥ쥤䡼(iterator)
    PoCoLayerBase *layer;               // 쥤䡼
    PoCoPalette *palette;               // ѥå
    const unsigned int width = [[[pict layer:0] bitmap] width];
    const unsigned int height = [[[pict layer:0] bitmap] height];

    DPRINT((@"[PoCoControllerPictureLayerUnificater createUnificatePicture]\n"));

    bmp = nil;

    // 쥤䡼
    bmp = [[PoCoBitmapLayer alloc] initWidth:width
                                  initHeight:height
                                defaultColor:0];
    if (bmp == nil) {
        DPRINT((@"can't alloc PoCoBitmapLayer.\n"));
        goto EXIT;
    }
    dst = [[bmp bitmap] pixelmap];

    // 礷
    palette = [pict palette];
    row = (width + (width & 1));
    iter = [[pict layer] objectEnumerator];
    layer = [iter nextObject];
    for ( ; layer != nil; layer = [iter nextObject]) {
        if ([layer isDisplay]) {
            src = [[layer bitmap] pixelmap];
            for (y = 0; y < height; (y)++) {
                idx = (y * row);
                for (x = 0; x < width; (x)++, (idx)++) {
                    if ((first) || (!([[palette palette:src[idx]] isTrans]))) {
                        dst[idx] = src[idx];
                    }
                }
            }
            first = NO;
        }
    }

EXIT:
    return bmp;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    pict : Խоݲ
//    info : Խ
//    undo : ä
//
//  Return
//    function : 
//
-(id)init:(PoCoPicture *)pict
     info:(PoCoEditInfo *)info
     undo:(NSUndoManager *)undo
{
    DPRINT((@"[PoCoControllerPictureLayerUnificater init]\n"));

    // super class 
    self = [super initPict:pict withInfo:info withUndo:undo];

    // Ȥ
    if (self != nil) {
        // ⤷ʤ
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoControllerPictureLayerUnificater dealloc]\n"));

    // super class 
    [super dealloc];

    return;
}


//
// Խ¹
//
//  Call
//    undoManager_ : ä( instance ѿ)
//    picture_     : Խоݲ( instance ѿ)
//    factory_     : Խ( instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)execute
{
    BOOL result;
    int l;                              // μ¹
    PoCoBitmapLayer *bmp;               // 쥤䡼

    result = NO;
    bmp = nil;

    // 1ʤ鲿⤷ʤ
    if ([[self->picture_ layer] count] <= 1) {
        goto EXIT;
    }

    // 
    bmp = [PoCoControllerPictureLayerUnificater
              createUnificatePicture:self->picture_
                             isFirst:NO];
    if (bmp == nil) {
        DPRINT((@"can't create unificate picture.\n"));
        goto EXIT;
    }

    // ̵ԽϿ
    [[self->undoManager_ prepareWithInvocationTarget:self->factory_]
        createLayerNoEditter:YES
                        name:nil
                      update:YES];

    // 쥤䡼
    [self->factory_ createLayerInserterPassive:YES
                                         layer:bmp
                                         index:-1];

    // 礵줿쥤䡼
    l = 0;
    while (l < ([[self->picture_ layer] count] - 1)) {
        if ([[self->picture_ layer:l] isDisplay]) {
            [self->factory_ createLayerDeleterPassive:YES index:l];
        } else {
            (l)++;
        }
    }

    // ä̾Τ
    [super setUndoName:[[NSBundle mainBundle]
                           localizedStringForKey:@"LayerUnificate"
                                           value:@"unificate layer"
                                           table:nil]]; 

    // λ
    result = YES;

    // ԽΤ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoEditLayer
                      object:[NSNumber numberWithBool:YES]];

EXIT:
    [bmp release];
    return result;
}

@end
