//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ̸᤭ - ΰɤĤ֤
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditAtomizerFill.h"

#import "PoCoUtil.h"

// ============================================================================
@implementation PoCoEditAtomizerFill

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp : Խо
//    plt : ѥѥå
//    pat : ѥ顼ѥ
//    rat : 
//
//  Return
//    function : 
//    bitmap_  : Խо(instance ѿ)
//    palette_ : ѥѥå(instance ѿ)
//    pattern_ : ѥ顼ѥ(instance ѿ)
//    ratio_   : (0.1%ñ)(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
    ratio:(int)rat
{
    DPRINT((@"[PoCoEditAtomizerFill init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->palette_ = plt;
        self->pattern_ = pat;
        self->ratio_ = rat;

        // 줾 retain Ƥ
        [self->bitmap_ retain];
        [self->palette_ retain];
        [self->pattern_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_  : Խо(instance ѿ)
//    palette_ : ѥѥå(instance ѿ)
//    pattern_ : ѥ顼ѥ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditAtomizerFill dealloc]\n"));

    // 񸻤β
    [self->bitmap_ release];
    [self->palette_ release];
    [self->pattern_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;
    self->pattern_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    mask     : 
//    tile     : ѥ
//    trueRect : ϰ(ϰϳޤ)
//    drawRect : ϰ(ϰΤ)
//    bitmap_  : Խо(instance ѿ)
//    palette_ : ѥѥå(instance ѿ)
//    pattern_ : ѥ顼ѥ(instance ѿ)
//    ratio_   : (0.1%ñ)(instance ѿ)
//
//  Return
//    bitmap_ : Խо(instance ѿ)
//
-(void)executeDraw:(PoCoBitmap *)mask
          withTile:(PoCoMonochromePattern *)tile
      withTrueRect:(PoCoRect *)trueRect
      withDrawRect:(PoCoRect *)drawRect
{
    PoCoBitmap *patBitmap;              // 顼ѥ(ϰϤĴѤ)
    PoCoBitmap *tileBitmap;             // ѥ(ϰϤĴѤ)
    PoCoRect *tr;
    PoCoRect *nr;
    PoCoPoint *p;
    int brow;                           // оݤ rowbyets
    int prow;                           // 顼ѥ rowbytes
    int mrow;                           //  rowbytes
    int trow;                           // ѥ rowbytes
    int bskip;                          // оݤμιԤޤǤΥ
    int pskip;                          // 顼ѥμιԤޤǤΥ
    int mskip;                          // μιԤޤǤΥ
    int tskip;                          // ѥμιԤޤǤΥ
    unsigned char *bbmp;                // оݤ
    const unsigned char *pbmp;          // 顼ѥ
    const unsigned char *mbmp;          // 
    const unsigned char *tbmp;          // ѥ

    p = nil;
    tr = nil;
    nr = nil;
    patBitmap = nil;
    tileBitmap = nil;

    // ΰʤ
    if([drawRect empty]){
        goto EXIT;
    }

    // half-open property ˤΤǱ +1
    tr = [[PoCoRect alloc] initLeft:[trueRect left]
                            initTop:[trueRect top]
                          initRight:([trueRect right] + 1)
                         initBottom:([trueRect bottom] + 1)];
    nr = [[PoCoRect alloc] initLeft:([trueRect left] & 1)
                            initTop:([trueRect top] & 1)
                          initRight:([trueRect width] + 1 + ([trueRect left] & 1))
                         initBottom:([trueRect height] + 1 + ([trueRect top] & 1))];
    
    // 賫
    patBitmap = [self->pattern_ pixelmap:tr];
    tileBitmap = [tile getPixelmap:nr];

    // Ƽͤλ
    brow = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));
    prow = ([patBitmap width]     + ([patBitmap width]     & 1));
    mrow = ([mask width]          + ([mask width]          & 1));
    trow = ([tileBitmap width]    + ([tileBitmap width]    & 1));
    bskip = (brow - [tr width]);
    pskip = (prow - [tr width]);
    mskip = (mrow - [tr width]);
    tskip = (trow - [tr width]);

    // Ƽѥӥåȥޥåפ
    bbmp = [self->bitmap_ pixelmap] + (([tr top] * brow) + [tr left]);
    pbmp = [patBitmap pixelmap];
    mbmp = [mask pixelmap];
    tbmp = [tileBitmap pixelmap];

    // /
    p = [[PoCoPoint alloc] init];
    for ([p setY:[tr top]]; [p y] < [tr bottom]; [p moveY:1]) {
        for ([p setX:[tr left]]; [p x] < [tr right]; [p moveX:1]) {
            if (([PoCoUtil canDrawFromRatio:self->ratio_]) &&
                ([drawRect isPointInRect:p]) &&
                (*(mbmp) != 0) &&
                (*(tbmp) != 0) &&
                (!([[self->palette_ palette:*(bbmp)] isMask])) &&
                (!([[self->palette_ palette:*(pbmp)] noDropper]))) {
                *(bbmp) = *(pbmp);
            }

            // 
            (bbmp)++;
            (pbmp)++;
            (mbmp)++;
            (tbmp)++;
        }

        // 
        bbmp += bskip;
        pbmp += pskip;
        mbmp += mskip;
        tbmp += tskip;
    }

EXIT:
    // 轪λ
    [patBitmap release];
    [tileBitmap release];
    [tr release];
    [nr release];
    [p release];
    return;
}

@end
