//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ǡ - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditGradationDrawLine.h"

#import <stdlib.h>

#import "PoCoEditAtomizerPattern.h"
#import "PoCoColorMixer.h"

// ============================================================================
@implementation PoCoEditGradationDrawLine

// --------------------------------------------------------- instance - private
//
// ̸᤭Υѥ
//  ưˡ˹碌򤫤
//
//  Call
//    p        : 
//    size_    : 礭(instance ѿ)
//    flip_    : ȿž(instance ѿ)
//    posSkip_ : ưˡ(instance ѿ)
//
//  Return
//    function : ѥ
//
-(const unsigned char *)correctPattern:(PoCoPoint *)p
{
    const unsigned char *tbl = [PoCoEditAtomizerPattern normal:self->size_];
    const int x = [p x];
    const int y = [p y];

    // ưˡ
    if (self->posSkip_ == PoCoAtomizerSkipType_Always) {
        // ˰ư
        tbl += ((4 * ATOMIZER_TBL_ROW1) + 4);
    } else if (self->posSkip_ == PoCoAtomizerSkipType_Binary) {
        // ɸɸ˸
        tbl += (((4 - (y & 0x01)) * ATOMIZER_TBL_ROW1) + (4 - (x & 0x01)));
    } else {
        // ѥݻ
        tbl += (((y % ATOMIZER_TBL_CORR) * ATOMIZER_TBL_ROW1) + (x % ATOMIZER_TBL_CORR));
    }

    // ȿžϲ 1dot ư
    if (self->flip_) {
        (tbl)--;
    }

    return tbl;
}


// --------------------------------- PoCoEditGradationDrawLine  instance ؿ
//
// initialize
//
//  Call
//    bmp   : Խо
//    cmode : 黻⡼
//    plt   : ѥѥå
//    pat   : ѥ顼ѥ
//    buf   : ݻ
//    size  : 礭
//
//  Return
//    function     : 
//    bitmap_      : Խо(instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    pattern_     : ѥ顼ѥ(instance ѿ)
//    points_      : 褹(instance ѿ)
//    ratio_       : (0.1%ñ)(instance ѿ)
//    density_     : ǻ(0.1%ñ)(instance ѿ)
//    size_        : 礭(instance ѿ)
//    flip_        : ȿž(instance ѿ)
//    posSkip_     : ưˡ(instance ѿ)
//    drawRect_    : ϰ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
   buffer:(PoCoColorBuffer *)buf
  penSize:(int)size
{
    DPRINT((@"[PoCoEditGradationDrawLine init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->colMode_ = cmode;
        self->palette_ = plt;
        self->pattern_ = pat;
        self->ratio_ = 0;
        self->density_ = 0;
        self->size_ = size;
        self->posSkip_ = PoCoAtomizerSkipType_Always;
        self->flip_ = NO;
        self->colorBuffer_ = buf;

        // 줾 retain Ƥ
        [self->bitmap_ retain];
        [self->palette_ retain];
        [self->pattern_ retain];
        [self->colorBuffer_ retain];

        // 񸻤γ
        self->points_ = [[NSMutableArray alloc] init];
        self->drawRect_ = [[PoCoRect alloc] initLeft:[self->bitmap_ width]
                                             initTop:[self->bitmap_ height]
                                           initRight:0
                                          initBottom:0];  
        if ((self->points_ == nil) || (self->drawRect_ == nil)) {
            // 
            DPRINT((@"memory allocation error.\n"));
            [self release];
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_      : Խо(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    pattern_     : ѥ顼ѥ(instance ѿ)
//    points_      : 褹(instance ѿ)
//    drawRect_    : ϰ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditGradationDrawLine dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->bitmap_ release];
    [self->palette_ release];
    [self->pattern_ release];
    [self->points_ release];
    [self->drawRect_ release];
    [self->colorBuffer_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;
    self->pattern_ = nil;
    self->points_ = nil;
    self->drawRect_ = nil;
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Ͽ
//
//  Call
//    p : Ͽ
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)addPoint:(PoCoPoint *)p
{
    const int sz = (ATOMIZER_TBL_ROW / 2);
    PoCoPoint *tmp;

    tmp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    [self->points_ addObject:tmp];
    [tmp release];

    // ΰ򹹿(+1  half-open property Τ)
    if (([p x] - sz) < [self->drawRect_ left]) {
        [self->drawRect_ setLeft:MAX(([p x] - sz), 0)];
    }
    if (([p y] - sz) < [self->drawRect_ top]) {
        [self->drawRect_ setTop:MAX(([p y] - sz), 0)];
    }
    if (([p x] + sz + 1) > [self->drawRect_ right]) {
        [self->drawRect_ setRight:MIN(([p x] + sz + 1), [self->bitmap_ width])];
    }
    if (([p y] + sz + 1) > [self->drawRect_ bottom]) {  
        [self->drawRect_ setBottom:MIN(([p y] + sz + 1), [self->bitmap_ height])];
    }

    return;
}


//
// 
//
//  Call
//    bitmap_ : Խо(instance ѿ)
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)clearPoint
{
    [self->points_ removeAllObjects];

    // ϰϤ
    [self->drawRect_ setLeft:[self->bitmap_ width]];
    [self->drawRect_ setTop:[self->bitmap_ height]];
    [self->drawRect_ setRight:0];
    [self->drawRect_ setBottom:0];

    return;
}


//
// ٤Ͽ
//
//  Call
//    ratio : (0.1%ñ)
//    skip  : ưˡ
//    type  : 
//    flag  : ȿž
//
//  Return
//    ratio_   : (0.1%ñ)(instance ѿ)
//    density_ : ǻ(0.1%ñ)(instance ѿ)
//    flip_    : ȿž(instance ѿ)
//    posSkip_ : ưˡ(instance ѿ)
//
-(void)setRatio:(int)ratio
     setDensity:(int)density
      pointSkip:(PoCoAtomizerSkipType)skip
      isFlipped:(BOOL)flag
{
    self->ratio_ = ratio;
    self->density_ = density;
    self->flip_ = flag;
    self->posSkip_ = skip;

    return;
}


//
// 
//  Ƚ
//
//  Call
//    ratio_ : (0.1%ñ)(instance ѿ)
//
//  Return
//    function : Ƚ
//
-(BOOL)canDraw
{
    return ((int)(((double)(rand()) / (double)(RAND_MAX)) * 1000.0) < self->ratio_);
}


//
// ¹
//  ǤϺɸ黻Ū drawPoint: Ǽ
//
//  Call
//    bitmap_   : Խо(instance ѿ)
//    pattern_  : ѥ顼ѥ(instance ѿ)
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw
{
    NSEnumerator *iter;                 // points_ ȿ
    PoCoPoint *p1;                      // 
    PoCoPoint *p2;                      // 
    PoCoPoint *dp;                      // (濴)
    int i;                              // ɸ(ʿʤľ)
    int e;                              // 
    int dx;                             // ʿʬ
    int dy;                             // ľʬ
    int sx;                             // ʿ(ˡ1Τ)
    int sy;                             // ľ(ˡ1Τ)
    int ax;                             // ʿ
    int ay;                             // ľ
    int brow;                           // оݤ rowbyets
    unsigned char *bbmp;                // оݤ
    PoCoBitmap *patBitmap;              // 顼ѥ(ϰϤĴѤ)
    int prow;                           // 顼ѥ rowbytes
    unsigned char *pbmp;                // 顼ѥ

    patBitmap = nil;

    // ΰʤ
    if ([self->drawRect_ empty]) {
        goto EXIT;
    }

    // 賫
    patBitmap = [self->pattern_ pixelmap:self->drawRect_];

    // Ƽͤλ
    brow = [self->bitmap_ width] + ([self->bitmap_ width] & 1);
    prow = [patBitmap width] + ([patBitmap width] & 1);

    // ȿ
    iter = [self->points_ objectEnumerator];
    p1 = [iter nextObject];
    for (p2 = [iter nextObject]; p2 != nil; p2 = [iter nextObject]) {
        dp = p1;

        // Ѱ̻
        dx = abs([p2 x] - [dp x]);
        dy = abs([p2 y] - [dp y]);
        sx = ([p2 x] < [dp x]) ? -1 : 1;
        sy = ([p2 y] < [dp y]) ? -1 : 1;
        ax = (dx << 1);
        ay = (dy << 1);

        // 濴˹碌 pointer 
        bbmp = [self->bitmap_ pixelmap] + ([dp y] * brow) + [dp x];
        pbmp = [patBitmap pixelmap] + (([dp y] - [self->drawRect_ top]) * prow)
                                    + ([dp x] - [self->drawRect_ left]);

        // ΰư
        if ((dx == 0) && (dy == 0)) {
            // Ʊ
            [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                              pattern:pbmp patternRow:prow];
        } else if (dx == 0) {
            // ľ
            for ( ; !([dp isEqualPos:p2]); [dp moveY:sy]) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];
                bbmp += (sy * brow);
                pbmp += (sy * prow);
            }
        } else if (dy == 0) {
            // ʿ
            for ( ; !([dp isEqualPos:p2]); [dp moveX:sx]) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];
                bbmp += sx;
                pbmp += sx;
            }  
        } else if (dx < dy) {  
            // Ǥ(ľ̤礭)
            e = -(dy);
            for (i = 0; i < dy; i++) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];

                // ΰư
                e += ax;
                [dp moveY:sy];
                bbmp += (sy * brow);
                pbmp += (sy * prow);
                if (e >= 0) {
                    [dp moveX:sx];
                    bbmp += sx;
                    pbmp += sx;
                    e -= ay;
                }
            }
        } else {
            // Ǥ(ʿ̤礭)
            e = -(dx);
            for (i = 0; i < dx; i++) {
                [self drawPoint:dp bitmap:bbmp  bitmapRow:brow
                                  pattern:pbmp patternRow:prow];

                // ΰư
                e += ay;
                [dp moveX:sx];
                bbmp += sx;
                pbmp += sx;
                if (e >= 0) {
                    [dp moveY:sy];
                    bbmp += (sy * brow);
                    pbmp += (sy * prow);
                    e -= ax;
                }
            }
        }

        // ʣ
        p1 = p2;
    }

EXIT:
    [patBitmap release];
    return;
}


//
// 
//  ؼΤ濴¹
//   bmpplt ϸƤӽФ濴ؤ
//
//  Call
//    p            : 濴
//    bbmp         : о
//    brow         : bbmp  rowbytes
//    pbmp         : ѥ
//    prow         : pbmp  rowbytes
//    colMode_     : 黻⡼(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    density_     : ǻ(0.1%ñ)(instance ѿ)
//    drawRect_    : ϰ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
//  Return
//    bbmp : о()
//
-(void)drawPoint:(PoCoPoint *)p
          bitmap:(unsigned char *)bbmp
       bitmapRow:(const int)brow
         pattern:(const unsigned char *)pbmp
      patternRow:(const int)prow
{
    unsigned int cnt;
    unsigned int num;
    PoCoPoint *dp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    const unsigned char *abmp = [self correctPattern:dp];
    const int a1 = (ATOMIZER_TBL_ROW - 1);
    const int l2 = (ATOMIZER_TBL_LINE / 2);
    const int r2 = (ATOMIZER_TBL_ROW / 2);
    const int brow1 = (brow - a1);
    const int prow1 = (prow - a1);
    const int acorr = (ATOMIZER_TBL_CORR + 1);

    DPRINT((@"[PoCoEditGradationDrawLine drawPoint:]\n"));

    // 򺸾˹碌
    bbmp -= ((brow * l2) + r2);
    pbmp -= ((prow * l2) + r2);
    [dp moveX:-(r2) moveY:-(l2)];

    // Ĥ
    cnt = (ATOMIZER_TBL_ROW - 1);
    num = (ATOMIZER_TBL_ROW * ATOMIZER_TBL_LINE);
    do {
        if (([self canDraw]) &&
            (*(abmp) != 0) &&
            ([self->drawRect_ isPointInRect:dp]) &&
            (!([[self->palette_ palette:*(bbmp)] isMask]))) {
            *(bbmp) = [PoCoColorMixer calcColor:self->palette_
                                        colMode:self->colMode_
                                       density2:((*(abmp) * self->density_) /32)
                                         color1:*(bbmp)
                                         color2:*(pbmp)
                                         buffer:self->colorBuffer_];
        }
        if (cnt != 0) {
            // ʿ˰ư
            (bbmp)++;
            (pbmp)++;
            (abmp)++;
            [dp moveX:1];
        } else {
            // ʿϸäƿľư
            cnt = ATOMIZER_TBL_ROW;
            bbmp += brow1;
            pbmp += prow1;
            abmp += acorr;
            [dp moveX:-(a1) moveY:1];
        }
        (cnt)--;
        (num)--;
    } while (num != 0);
    [dp release];

    return;
}

@end
