//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ǡ - ΰɤĤ֤
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditGradationFill.h"

#import "PoCoUtil.h"
#import "PoCoColorMixer.h"

// ============================================================================
@implementation PoCoEditGradationFill

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp   : Խо
//    cmode : 黻⡼
//    plt   : ѥѥå
//    pat   : ѥ顼ѥ
//    buf   : ݻ
//    ratio : 
//
//  Return
//    function     : 
//    bitmap_      : Խо(instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    pattern_     : ѥ顼ѥ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//    density_     : ǻ(0.1%ñ)(instance ѿ)
//    ratio_       : (0.1%ñ)(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
   buffer:(PoCoColorBuffer *)buf
    ratio:(int)ratio
{
    DPRINT((@"[PoCoEditGradationFill init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->colMode_ = cmode;
        self->palette_ = plt;
        self->pattern_ = pat;
        self->density_ = 0;
        self->ratio_ = ratio;
        self->colorBuffer_ = buf;

        // 줾 retain Ƥ
        [self->bitmap_ retain];
        [self->palette_ retain];
        [self->pattern_ retain];
        [self->colorBuffer_ retain];

    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_      : Խо(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    pattern_     : ѥ顼ѥ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditGradationFill dealloc]\n"));

    // 񸻤β
    [self->bitmap_ release];
    [self->palette_ release];
    [self->pattern_ release];
    [self->colorBuffer_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;
    self->pattern_ = nil;
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    d   : (0.1%ñ)
//    bmp : Խо
//
//  Return
//    density_ : ǻ(0.1%ñ)(instance ѿ)
//    bitmap_  : Խо(instance ѿ)
//
-(void)replaceDensity:(int)d
           withBitmap:(PoCoBitmap *)bmp
{
    // ʬ˺
    [self->bitmap_ release];

    // ؤ
    self->density_ = d;
    self->bitmap_ = bmp;
    [self->bitmap_ retain];

    return;
}


//
// ¹
//
//  Call
//    mask         : 
//    tile         : ѥ
//    trueRect     : ϰ(ϰϳޤ)
//    drawRect     : ϰ(ϰΤ)
//    bitmap_      : Խо(instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    pattern_     : ѥ顼ѥ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//    density_     : ǻ(0.1%ñ)(instance ѿ)
//    ratio_       : (0.1%ñ)(instance ѿ)
//
//  Return
//    bitmap_ : Խо(instance ѿ)
//
-(void)executeDraw:(PoCoBitmap *)mask
          withTile:(PoCoMonochromePattern *)tile
      withTrueRect:(PoCoRect *)trueRect
      withDrawRect:(PoCoRect *)drawRect
{
    PoCoBitmap *patBitmap;              // 顼ѥ(ϰϤĴѤ)
    PoCoBitmap *tileBitmap;             // ѥ(ϰϤĴѤ)
    PoCoRect *tr;
    PoCoRect *dr;
    PoCoRect *nr;
    PoCoPoint *p;
    int brow;                           // оݤ rowbyets
    int prow;                           // 顼ѥ rowbytes
    int mrow;                           //  rowbytes
    int trow;                           // ѥ rowbytes
    int bskip;                          // оݤμιԤޤǤΥ
    int pskip;                          // 顼ѥμιԤޤǤΥ
    int mskip;                          // μιԤޤǤΥ
    int tskip;                          // ѥμιԤޤǤΥ
    unsigned char *bbmp;                // оݤ
    const unsigned char *pbmp;          // 顼ѥ
    const unsigned char *mbmp;          // 
    const unsigned char *tbmp;          // ѥ

    tr = nil;
    dr = nil;
    nr = nil;
    patBitmap = nil;
    tileBitmap = nil;

    // ΰʤ
    if ([drawRect empty]) {
        goto EXIT;
    }

    // half-open property ˤΤǱ +1
    tr = [[PoCoRect alloc] initLeft:[trueRect left]
                            initTop:[trueRect top]
                          initRight:([trueRect right] + 1)
                         initBottom:([trueRect bottom] + 1)];
    dr = [[PoCoRect alloc] initLeft:[drawRect left]
                            initTop:[drawRect top]
                          initRight:([drawRect right] + 1)
                         initBottom:([drawRect bottom] + 1)];
    nr = [[PoCoRect alloc] initLeft:([trueRect left] & 1)
                            initTop:([trueRect top] & 1)
                          initRight:([trueRect width] + 1 + ([trueRect left] & 1))
                         initBottom:([trueRect height] + 1 + ([trueRect top] & 1))];
    
    if ([self->bitmap_ width] < [dr right]) {
        [dr setRight:[self->bitmap_ width]];
    }
    if ([self->bitmap_ height] < [dr bottom]) {
        [dr setBottom:[self->bitmap_ height]];
    }

    // 賫
    patBitmap = [self->pattern_ pixelmap:tr];
    tileBitmap = [tile getPixelmap:nr];

    // Ƽͤλ
    brow = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));
    prow = ([patBitmap width]     + ([patBitmap width]     & 1));
    mrow = ([mask width]          + ([mask width]          & 1));
    trow = ([tileBitmap width]    + ([tileBitmap width]    & 1));
    bskip = (brow - [tr width]);
    pskip = (prow - [tr width]);
    mskip = (mrow - [tr width]);
    tskip = (trow - [tr width]);

    // Ƽѥӥåȥޥåפ
    bbmp = [self->bitmap_ pixelmap] + (([tr top] * brow) + [tr left]);
    pbmp = [patBitmap pixelmap];
    mbmp = [mask pixelmap];
    tbmp = [tileBitmap pixelmap];

    // /
    p = [[PoCoPoint alloc] init];
    for ([p setY:[tr top]]; [p y] < [tr bottom]; [p moveY:1]) {
        for ([p setX:[tr left]]; [p x] < [tr right]; [p moveX:1]) {
            if (([PoCoUtil canDrawFromRatio:self->ratio_]) &&
                ([dr isPointInRect:p]) &&
                (*(mbmp) != 0) &&
                (*(tbmp) != 0) &&
                (!([[self->palette_ palette:*(bbmp)] isMask]))) {
                *(bbmp) = [PoCoColorMixer calcColor:self->palette_
                                            colMode:self->colMode_
                                           density2:self->density_
                                             color1:*(bbmp)
                                             color2:*(pbmp)
                                             buffer:self->colorBuffer_];
            }

            // 
            (bbmp)++;
            (pbmp)++;
            (mbmp)++;
            (tbmp)++;
        }

        // 
        bbmp += bskip;
        pbmp += pskip;
        mbmp += mskip;
        tbmp += tskip;
    }
    [p release];

EXIT:
    // 轪λ
    [tr release];
    [dr release];
    [nr release];
    [patBitmap release];
    [tileBitmap release];
    return;
}

@end
