//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ȿž - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditInvertDrawLine.h"

// ============================================================================
@implementation PoCoEditInvertDrawLine

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp : о bitmap
//    z   : 0x00 ΤߤȿžоݤȤ
//
//  Return
//    function : 
//    points_  : (instance ѿ)
//
-(id)initWithBitmap:(PoCoBitmap *)bmp
         isZeroOnly:(BOOL)z
{
//    DPRINT((@"[PoCoEditInvertDrawLine initWithBitmap]\n"));

    // super class ν
    self = [super initWithBitmap:bmp
                      isZeroOnly:z];

    // Ȥν
    if (self != nil) {
        // ݻ
        self->points_ = [[NSMutableArray alloc] init];
        if (self->points_ == nil) {
            DPRINT((@"can't alloc NSMutableArray\n"));
            [self release];
            self = nil;
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_ : (instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditInvertDrawLine dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->points_ release];
    self->points_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Ͽ
//
//  Call
//    p : Ͽ
//
//  Return
//    points_ : (instance ѿ)
//
-(void)addPoint:(PoCoPoint *)p
{
    PoCoPoint *tmp;

    tmp = [[PoCoPoint alloc] initX:[p x]
                             initY:[p y]];
    [self->points_ addObject:tmp];
    [tmp release];

    return;
}


//
// ¹
//  ϩƤϽŤʤʤ褦ˤƤ
//
//  Call
//    points_ : (instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw
{
    NSEnumerator *iter;
    int i;
    int e;                              // 
    int ax;                             // ʿ
    int ay;                             // ľ
    int dx;                             // ʿʬ
    int dy;                             // ľʬ
    int sx;                             // ʿ
    int sy;                             // ľ
    int fx;                             // ľοʿ
    int fy;                             // ľοľ
    PoCoPoint *dp;                      // 
    PoCoPoint *p1;                      // ʬ
    PoCoPoint *p2;                      // ʬ
    PoCoPoint *sp;                      // ǽ

    if ([self->points_ count] > 1) {
        fx = -1;
        fy = -1;
        iter = [self->points_ objectEnumerator];
        p1 = [iter nextObject];
        sp = [[PoCoPoint alloc] initX:[p1 x]
                                initY:[p1 y]];
        for (p2 = [iter nextObject]; p2 != nil; p2 = [iter nextObject]) {
            // ʿͤλ
            dx = [p2 x] - [p1 x];
            if (dx < 0) {
                sx = -1;
                dx = -dx;
            } else {
                sx = 1;
            }
            ax = (dx << 1);

            // ľͤλ
            dy = [p2 y] - [p1 y];
            if (dy < 0) {
                sy = -1;
                dy = -(dy);
            } else {
                sy = 1;
            }
            ay = (dy << 1);

            // 
            if ((dx == 0) && (dy == 0)) {
                // Ʊ
                ;
            } else if (dx == 0) {
                // ľ
                for (dp = p1 ; !([dp isEqualPos:p2]); [dp moveY:sy]) {
                    if ((fx != [dp x]) || (fy != [dp y])) {
                        [super drawPoint:dp];
                    }
                    fx = [dp x];
                    fy = [dp y];
                }
            } else if (dy == 0) {
                // ʿ
                for (dp = p1; !([dp isEqualPos:p2]); [dp moveX:sx]) {
                    if ((fx != [dp x]) || (fy != [dp y])) {
                        [super drawPoint:dp];
                    }
                    fx = [dp x];
                    fy = [dp y];
                }
            } else if (dx < dy) {
                // Ǥ(ľ̤礭)
                dp = p1;
                e = -(dy);
                for (i = 0; i < dy; (i)++) {
                    if ((fx != [dp x]) || (fy != [dp y])) {
                        [super drawPoint:dp];
                    }
                    fx = [dp x];
                    fy = [dp y];

                    // ΰư
                    e += ax;
                    [dp moveY:sy];
                    if (e >= 0) {
                        [dp moveX:sx];
                        e -= ay;
                    }
                }
            } else {
                // Ǥ(ʿ̤礭)
                dp = p1;
                e = -dx;
                for (i = 0; i < dx; (i)++) {
                    if ((fx != [dp x]) || (fy != [dp y])) {
                        [super drawPoint:dp];
                    }
                    fx = [dp x];
                    fy = [dp y];

                    // ΰư
                    e += ay;
                    [dp moveX:sx];
                    if (e >= 0) {
                        [dp moveY:sy];
                        e -= ax;
                    }
                }
            }

            // ܤλȰ㤨
            if (!([p2 isEqualPos:sp])) {
                [super drawPoint:p2];
                fx = [p2 x];
                fy = [p2 y];
            }

            // ʣ
            p1 = p2;
        }
        [sp release];
    }

    return;
}

@end
