//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ȿž - Ĥľ(ɤĤ֤)
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditInvertPolygon.h"
#import "PoCoEditInvertDrawLine.h"

// ============================================================================
@implementation PoCoEditInvertPolygon

// --------------------------------------------------------- instance - private
//
// ʬ
//
//  Call
//    points_   : (instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//
//  Return
//    None
//
-(void)drawFrame
{
    PoCoEditInvertDrawLine *frame;
    NSEnumerator *iter;
    PoCoPoint *s;
    PoCoPoint *p;

    frame = [[PoCoEditInvertDrawLine alloc] initWithBitmap:self->bitmap_
                                                isZeroOnly:YES];
    iter = [self->points_ objectEnumerator];
    s = [iter nextObject];
    for (p = s; p != nil; p = [iter nextObject]) {
        [frame addPoint:p];
    }
    [frame addPoint:s];
    [frame executeDraw];
    [frame release];

    return;
}


//
// Ĥʬ
//
//  Call
//    points_   : (instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//    zeroOnly_ : 0x00 ΤߤȿžоݤȤ( instance ѿ)
//
//  Return
//    bitmap_ : о bitmap( instance ѿ)
//
-(void)drawFill
{
    int i;
    int j;
    PoCoPoint *p1;
    PoCoPoint *p2;
    int y;
    int cnt;
    int *pt;
    int row;
    unsigned char *pixmap;
    unsigned char *dp;
    unsigned char *ep;

    // ΰ
    pt = (int *)(malloc([self->points_ count] * sizeof(int)));
    if (pt == NULL) {
        goto EXIT;
    }

    // 
    row = ([self->bitmap_ width] + ([self->bitmap_ width] & 0x01));
    pixmap = [self->bitmap_ pixelmap];
    for (y = 0; y < [self->drawRect_ height]; (y)++) {
        cnt = 0;

        // ľθ򺹤õ
        j = (int)([self->points_ count] - 1);
        for (i = 0; i < [self->points_ count]; (i)++) {
            p1 = [self->points_ objectAtIndex:i];
            p2 = [self->points_ objectAtIndex:j];
            if ((([p1 y] < y) && ([p2 y] >= y)) ||
                (([p2 y] < y) && ([p1 y] >= y))) {
                pt[cnt] = (int)(((float)([p1 x]) + (float)(y - [p1 y]) / (float)([p2 y] - [p1 y]) * (float)([p2 x] - [p1 x])) + 0.5);
                (cnt)++;
            }
            j = i;
        }

        // ʿǥ 
        i = 0;
        while (i < (cnt - 1)) {
            if (pt[i] > pt[i + 1]) {
                pt[i    ] ^= pt[i + 1];
                pt[i + 1] ^= pt[i    ];
                pt[i    ] ^= pt[i + 1];
                if (i != 0) {
                    (i)--;
                }
            } else {
               (i)++;
            }
        }

        // ɤ
        for (i = 0; i < cnt; i += 2) {
            if (pt[i] >= [self->drawRect_ width]) {
                break;
            } else if (pt[i + 1] > 0) {
                ep = (pixmap + MIN(pt[i + 1], [self->drawRect_ width]));
                for (dp = (pixmap + MAX(pt[i], 0)); dp < ep; (dp)++) {
                    if ((!(self->zeroOnly_)) || (*(dp) == 0x00)) {
                        *(dp) ^= 0xff;
                    }
                }
            }
        }

        // 
        pixmap += row;
    }
    free(pt);

EXIT:
    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp : о bitmap
//    pts : (instance ѿ)
//    dr  : ΰ(instance ѿ)
//    z   : 0x00 ΤߤȿžоݤȤ
//
//  Return
//    function  : 
//    points_   : (instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//
-(id)initWithBitmap:(PoCoBitmap *)bmp
         withPoints:(NSArray *)pts
       withDrawRect:(PoCoRect *)dr
         isZeroOnly:(BOOL)z
{
//    DPRINT((@"[PoCoEditInvertPolygon initWithBitmap]\n"));

    // super class ν
    self = [super initWithBitmap:bmp
                      isZeroOnly:z];

    // Ȥν
    if (self != nil) {
        self->points_ = pts;
        self->drawRect_ = dr;
        [self->points_ retain];
        [self->drawRect_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_   : (instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditInvertPolygon dealloc]\n"));

    // 񸻤β
    [self->points_ release];
    [self->drawRect_ release];
    self->points_ = nil;
    self->drawRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    None
//
//  Return
//    None
//
-(void)executeDraw
{
    // ʬ
    [self drawFrame];

    // Ĥʬ
    [self drawFill];

#if 0
{
    int x;
    int y;
    unsigned char *p;

    printf("----------------\n");
    printf("width : %d, height: %d\n", [self->bitmap_ width], [self->bitmap_ height]);
    for (y = 0; y < [self->bitmap_ height]; (y)++) {
        p  = [self->bitmap_ pixelmap];
        p += (y * ([self->bitmap_ width] + ([self->bitmap_ width] & 0x01)));
        for (x = 0; x < [self->bitmap_ width]; (x)++) {
            printf("%c", ((*(p) != 0x00) ? '1' : '0'));
            (p)++;
        }
        printf("\n");
    }
}
#endif  // 0

    return;
}

@end
