//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ȿž - ǤΰɤĤ֤
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditInvertRegionFill.h"

// ============================================================================
@implementation PoCoEditInvertRegionFill

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    mask : ޥ(instance ѿ)
//    dr   : ΰ(instance ѿ)
//    z    : 0x00 ΤߤȿžоݤȤ
//
//  Return
//    function  : 
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//
-(id)initWithBitmap:(PoCoBitmap *)bmp
     withMaskBitmap:(PoCoBitmap *)mask
       withDrawRect:(PoCoRect *)dr
         isZeroOnly:(BOOL)z
{
//    DPRINT((@"[PoCoEditInvertRegionFill initWithBitmap]\n"));

    // super class ν
    self = [super initWithBitmap:bmp
                      isZeroOnly:z];

    // Ȥν
    if (self != nil) {
        self->mask_ = mask;
        self->drawRect_ = dr;
        [self->mask_ retain];
        [self->drawRect_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditInvertRegionFill dealloc]\n"));

    // 񸻤β
    [self->mask_ release];
    [self->drawRect_ release];
    self->mask_ = nil;
    self->drawRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    bitmap_   : о bitmap( instance ѿ)
//    zeroOnly_ : 0x00 ΤߤȿžоݤȤ( instance ѿ)
//    mask_     : ޥ(instance ѿ)
//    drawRect_ : ΰ(instance ѿ)
//
//  Return
//    bitmap_ : о bitmap( instance ѿ)
//
-(void)executeDraw
{
    PoCoRect *r;
    PoCoPoint *p;
    int brow;                           // оݤ rowbyets
    int mrow;                           //  rowbytes
    int bskip;                          // оݤμιԤޤǤΥ
    int mskip;                          // μιԤޤǤΥ
    unsigned char *bbmp;                // оݤ
    const unsigned char *mbmp;          // 

    r = [[PoCoRect alloc]
              initLeft:MAX(0, [self->drawRect_ left])
               initTop:MAX(0, [self->drawRect_ top])
             initRight:MIN([self->bitmap_ width], [self->drawRect_ right])
            initBottom:MIN([self->bitmap_ height], [self->drawRect_ bottom])];

    // Ƽͤλ
    brow = ([self->bitmap_ width] + ([self->bitmap_ width] & 0x01));
    mrow = ([self->mask_   width] + ([self->mask_   width] & 0x01));
    bskip = (brow - [self->drawRect_ width]);
    mskip = (mrow - [self->drawRect_ width]);

    // Ƽѥӥåȥޥåפ
    bbmp = [self->bitmap_ pixelmap] + (([self->drawRect_ top] * brow) + [self->drawRect_ left]);
    mbmp = [self->mask_ pixelmap];

    // /
    p = [[PoCoPoint alloc] init];
    for ([p setY:[self->drawRect_ top]];
         [p y] < [self->drawRect_ bottom];
         [p moveY:1]) {
        for ([p setX:[self->drawRect_ left]];
             [p x] < [self->drawRect_ right];
             [p moveX:1]) {
            if (([r isPointInRect:p]) &&
                (*(mbmp) != 0) &&
                ((!(self->zeroOnly_)) || (*(bbmp) == 0x00))) {
                *(bbmp) ^= 0xff;
            }

            // 
            (bbmp)++;
            (mbmp)++;
        }

        // 
        bbmp += bskip;
        mbmp += mskip;
    }
    [p release];
    [r release];

    return;
}

@end
