//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ưǡ(Ǥ)
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoEditAutoGradation.h"

#import "PoCoColorPattern.h"
#import "PoCoEditAtomizerDrawLine.h"

// ============================================================================
@implementation PoCoEditAutoGradation

// --------------------------------------------------------- instance - private
//
// Ⱦ̸᤭
//
//  Call
//    col        : 迧
//    size       : 礭(¥ɥåȿʤΤ 1-128 ϰ)
//    flip       : ȿž(YES: ȿž)
//    hori       : ʿ(YES: ʿ)
//    high       : 夫鲼οܤ(YES: 夫鲼NO: )
//                 (οֹ椫οֹؤܤ)
//    palette_   : ѥѥå(instance ѿ)
//    drawPoint_ : (instance ѿ)
//
//  Return
//    workDstBitmap_ : (instance ѿ)
//
-(void)executeHalfAtomizer:(unsigned char)col
                      size:(int)size
                    isFlip:(BOOL)flip
                    isHori:(BOOL)hori
                    isHigh:(BOOL)high
{
    PoCoEditAtomizerDrawLine *edit;
    PoCoColorPattern *pat;
    int s;
    PoCoPoint *p;

    pat = nil;
    edit = nil;
    s = (size / 8);                     // ̸᤭ѥѤϼ¥ / 8
    p = [[PoCoPoint alloc] initX:[self->drawPoint_ x]
                           initY:[self->drawPoint_ y]];

#if 0   // ⤽⤳ĴɬפʤΤ?
    // ξ˰Ĵ
    if (flip) {
        if (hori) {
            if (high) {
                // 夫鲼ڤؤʤΤǰ֤򱦤˰ư
                [p moveX:(s / 2)];
            } else {
                // ڤؤʤΤǰ֤򺸤˰ư
                [p moveX:-(s + (s / 2))];
            }
        } else {
            if (high) {
                // 夫鲼ڤؤʤΤǰ֤򲼤˰ư
                [p moveY:(s / 2)];
            } else {
                // ڤؤʤΤǰ֤˰ư
                [p moveY:-(s + (s / 2))];
            }
        }
    }
#endif  // 0

    // 顼ѥ
    pat = [[PoCoColorPattern alloc] initWidth:1
                                   initHeight:1
                                 defaultColor:col];

    // Ϥ
    edit = [[PoCoEditAtomizerDrawLine alloc]
                  init:self->workDstBitmap_
               palette:self->palette_
               pattern:pat
               penSize:s];
    [edit setRatio:1000
         pointSkip:PoCoAtomizerSkipType_Pattern
       patternType:YES
         isFlipped:flip];

    // ʬˤƱ
    [edit addPoint:p];
    [edit addPoint:p];

    // ¹
    [edit executeDraw];

    // 
    [edit release];
    [pat release];

    [p release];
    return;
}


//
// ¹
//
//  Call
//    isHori      : ʿ(YES: ʿ)
//    size_       : 礭(0: Ǥա1-128 ϰ)(instance ѿ)
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//
//  Return
//    None
//
-(void)draw:(BOOL)isHori
{
    int size;
    BOOL isFlip;
    BOOL isHigh;

    // طɤѤ
    if (self->leftColor_ < self->rightColor_) {
        // οֹ椫οֹؤ
        isFlip = NO;
        isHigh = YES;
    } else {
        // οֹ椫οֹؤ
        isFlip = YES;
        isHigh = NO;
    }

    // ο
    if (self->size_ == 0) {
        size = MIN(self->leftLen_, 128);
    } else {
        size = self->size_;
    }
    [self executeHalfAtomizer:self->leftColor_
                         size:size
                       isFlip:isFlip
                       isHori:isHori
                       isHigh:isHigh];

    // ο
    if (self->size_ == 0) {
        size = MIN(self->rightLen_, 128);
    } else {
        size = self->size_;
    }
    [self executeHalfAtomizer:self->rightColor_
                         size:size
                       isFlip:!(isFlip)
                       isHori:isHori
                       isHigh:isHigh];

    return;
}


//
// ã򸡾
//
//  Call
//    srcColor    : 踵ο
//    mask        : ޥ
//    x           : ʿ
//    y           : ľ
//    isHori      : ʿ(YES: ʿ)
//    matrix_     : оݿ(256 ĹYES: о)(instance ѿ)
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//    scanState_  : (instance ѿ)
//
//  Return
//    drawPoint_  : (instance ѿ)
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//    scanState_  : (instance ѿ)
//
-(void)inspectAttachedPoint:(unsigned char)srcColor
                   withMask:(unsigned char)mask
                    horiPos:(int)x
                    vertPos:(int)y
                 isHoriScan:(BOOL)isHori
{
    if (mask) {
        if (self->scanState_ == PoCoAutoGrad_NoneAttach) {
            // õƤ
            if (self->matrix_[srcColor]) {
                // оݿʤΤǻã
                self->leftLen_ = 1;
                self->leftColor_ = srcColor;

                // 
                self->scanState_ = PoCoAutoGrad_StartAttached;
            }
        } else if (self->scanState_ == PoCoAutoGrad_StartAttached) {
            // ˤã(õƤ)
            if (self->leftColor_ == srcColor) {
                // ƱΤޤޤʤΤǷ³
                (self->leftLen_)++;
            } else if (self->matrix_[srcColor]) {
                // Ȥϰ㤦оݿʤΤã
                self->rightLen_ = 1;
                self->rightColor_ = srcColor;

                // 
                [self->drawPoint_ setX:x
                                  setY:y];

                // 
                self->scanState_ = PoCoAutoGrad_MiddleAttached;
            } else {
                // оݿǤϤʤΤˤʤʤΤǲ⤷ʤ
                self->leftLen_ = 0;
                self->rightLen_ = 0;
                self->leftColor_ = 0;
                self->rightColor_ = 0;

                // 
                self->scanState_ = PoCoAutoGrad_NoneAttach;
            }
        } else if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            // ã(õƤ)
            if (self->rightColor_ == srcColor) {
                // ƱΤޤޤʤΤǷ³
                (self->rightLen_)++;
            } else {
                // ãΤɤ¹
                [self draw:isHori];

                // ³
                if (self->matrix_[srcColor]) {
                    // оݿʤΤãˤ
                    self->leftLen_ = self->rightLen_;
                    self->rightLen_ = 1;
                    self->leftColor_ = self->rightColor_;
                    self->rightColor_ = srcColor;

                    // Ȥʤ(֤ˤʤ)
                    [self->drawPoint_ setX:x
                                      setY:y];

                    // ܤϤʤǽõ
                    ;
                } else {
                    // оݿǤϤʤʬʤΤǺǽ
                    self->leftLen_ = 0;
                    self->rightLen_ = 0;
                    self->leftColor_ = 0;
                    self->rightColor_ = 0;

                    // 
                    self->scanState_ = PoCoAutoGrad_NoneAttach;
                }
            }
        }
    } else {
        // ˴ޤޤʤϰ
        if (self->scanState_ == PoCoAutoGrad_NoneAttach) {
            // ⤽ɤˤãƤʤ
            ;
        } else if (self->scanState_ == PoCoAutoGrad_StartAttached) {
            // ˤãƤ뤱ˤãƤʤ
            ;
        } else if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            // ˤãƤΤǽãȤɤ
            [self draw:isHori];
        }

        // ϰϤȴ
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;

        // 
        self->scanState_ = PoCoAutoGrad_NoneAttach;
    }

    return;
}


//
// ʿ
//
//  Call
//    workSrcBitmap_  : 踵(instance ѿ)
//    workMaskBitmap_ : ޥ(instance ѿ)
//
//  Return
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//    scanState_  : (instance ѿ)
//
-(void)scanHori
{
    const int w = [self->workSrcBitmap_ width];
    const int h = [self->workSrcBitmap_ height];
    const int row = (w + (w & 0x01));
    const int skip = (row - w);
    int x;
    int y;
    unsigned char *sp = [self->workSrcBitmap_ pixelmap];
    unsigned char *mp = [self->workMaskBitmap_ pixelmap];

    DPRINT((@"[PoCoEditAutoGradation scanHori]\n"));

    // ľ
    y = 0;
    do {
        // 饤󤴤Ȥ˾˽֤᤹
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;
        self->scanState_ = PoCoAutoGrad_NoneAttach;

        // ʿ
        x = 0;
        do {
            // ã򸡾
            [self inspectAttachedPoint:*(sp)
                              withMask:*(mp)
                               horiPos:x
                               vertPos:y
                            isHoriScan:YES];

            // 
            (x)++;
            (sp)++;
            (mp)++;
        } while (x < w);

        // ˤãƤ֤üãΤɤ
        if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            [self draw:YES];
        }

        // 
        (y)++;
        sp += skip;
        mp += skip;
    } while (y < h);

    return;
}


//
// ľ
//
//  Call
//    workSrcBitmap_  : 踵(instance ѿ)
//    workMaskBitmap_ : ޥ(instance ѿ)
//
//  Return
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//    scanState_  : (instance ѿ)
//
-(void)scanVert
{
    const int w = [self->workSrcBitmap_ width];
    const int h = [self->workSrcBitmap_ height];
    const int row = (w + (w & 0x01));
    int x;
    int y;
    unsigned char *sp = [self->workSrcBitmap_ pixelmap];
    unsigned char *mp = [self->workMaskBitmap_ pixelmap];

    DPRINT((@"[PoCoEditAutoGradation scanVert]\n"));

    // ʿ
    x = 0;
    do {
        // 饤󤴤Ȥ˾˽֤᤹
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;
        self->scanState_ = PoCoAutoGrad_NoneAttach;

        // ľ
        y = 0;
        do {
            // ã򸡾
            [self inspectAttachedPoint:*(sp)
                              withMask:*(mp)
                               horiPos:x
                               vertPos:y
                            isHoriScan:NO];

            // 
            (y)++;
            sp += row;
            mp += row;
        } while (y < h);

        // ˤãƤ֤üãΤɤ
        if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            [self draw:NO];
        }

        // 
        (x)++;
        sp = ([self->workSrcBitmap_ pixelmap] + x);
        mp = ([self->workMaskBitmap_ pixelmap] + x);
    } while (x < w);

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dbmp : 
//    sbmp : 踵
//    mbmp : ޥ
//    plt  : ѥѥå
//    size : 礭(0: Ǥա1-128 ϰ)
//    mtx  : оݿ(256 ĹYES: о)
//    r    : ϰ
//
//  Return
//    function        : 
//    srcBitmap_      : 踵(instance ѿ)
//    dstBitmap_      : (instance ѿ)
//    maskBitmap_     : ޥ(instance ѿ)
//    palette_        : ѥѥå(instance ѿ)
//    size_           : 礭(0: Ǥա1-128 ϰ)(instance ѿ)
//    matrix_         : оݿ(256 ĹYES: о)(instance ѿ)
//    rect_           : ϰ(instance ѿ)
//    workSrcBitmap_  : 踵(ΰ)(instance ѿ)
//    workDstBitmap_  : (ΰ)(instance ѿ)
//    workMaskBitmap_ : ޥ(ΰ)(instance ѿ)
//    drawPoint_      : (instance ѿ)
//    leftLen_        : Υɥåȿ(instance ѿ)
//    rightLen_       : Υɥåȿ(instance ѿ)
//    leftColor_      : ο(instance ѿ)
//    rightColor_     : ο(instance ѿ)
//    scanState_      : (instance ѿ)
//
-(id)initDst:(PoCoBitmap *)dbmp
     withSrc:(PoCoBitmap *)sbmp
    withMask:(PoCoBitmap *)mbmp
     palette:(PoCoPalette *)plt
     penSize:(int)size
      matrix:(const BOOL *)mtx
        rect:(PoCoRect *)r
{
    DPRINT((@"[PoCoEditAutoGradation init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = sbmp;
        self->dstBitmap_ = dbmp;
        self->maskBitmap_ = mbmp;
        self->palette_ = plt;
        self->size_ = size;
        self->matrix_ = mtx;
        self->rect_ = r;
        self->workSrcBitmap_ = nil;
        self->workDstBitmap_ = nil;
        self->workMaskBitmap_ = nil;

        // 줾 retain Ƥ
        [self->srcBitmap_ retain];
        [self->dstBitmap_ retain];
        [self->maskBitmap_ retain];
        [self->palette_ retain];
        [self->rect_ retain];

        // 
        self->drawPoint_ = [[PoCoPoint alloc] init];
        if (self->drawPoint_ == nil) {
            [self release];
            self = nil;
            goto EXIT;
        }

        // ֤ä˲ʤ
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;
        self->scanState_ = PoCoAutoGrad_NoneAttach;
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_      : 踵(instance ѿ)
//    dstBitmap_      : (instance ѿ)
//    maskBitmap_     : ޥ(instance ѿ)
//    palette_        : ѥѥå(instance ѿ)
//    rect_           : ϰ(instance ѿ)
//    workSrcBitmap_  : 踵(ΰ)(instance ѿ)
//    workDstBitmap_  : (ΰ)(instance ѿ)
//    workMaskBitmap_ : ޥ(ΰ)(instance ѿ)
//    drawPoint_      : (instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditAutoGradation dealloc]\n"));

    // 񸻤β
    [self->srcBitmap_ release];
    [self->dstBitmap_ release];
    [self->maskBitmap_ release];
    [self->palette_ release];
    [self->rect_ release];
    [self->workSrcBitmap_ release];
    [self->workDstBitmap_ release];
    [self->workMaskBitmap_ release];
    [self->drawPoint_ release];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;
    self->maskBitmap_ = nil;
    self->palette_ = nil;
    self->rect_ = nil;
    self->workSrcBitmap_ = nil;
    self->workDstBitmap_ = nil;
    self->workMaskBitmap_ = nil;
    self->drawPoint_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_  : 踵(instance ѿ)
//    dstBitmap_  : (instance ѿ)
//    maskBitmap_ : ޥ(instance ѿ)
//    rect_       : ϰ(instance ѿ)
//
//  Return
//    dstBitmap_      : (instance ѿ)
//    workSrcBitmap_  : 踵(ΰ)(instance ѿ)
//    workDstBitmap_  : (ΰ)(instance ѿ)
//    workMaskBitmap_ : ޥ(ΰ)(instance ѿ)
//
-(void)executeDraw
{
    PoCoRect *r;
    int x;
    int y;
    PoCoBitmap *tmp;

    // 踵򤽤Τޤʣ
    r = [[PoCoRect alloc] initLeft:0
                           initTop:0
                         initRight:[self->srcBitmap_ width]
                        initBottom:[self->srcBitmap_ height]];
    [self->dstBitmap_ setBitmap:[self->srcBitmap_ pixelmap]
                       withRect:r];
    [r release];

    // ΰʣ
    x = 0;
    y = 0;
    if (([self->rect_ left] % 4) != 0) {
        x = ([self->rect_ left] % 4);
    }
    if (([self->rect_ top] % 4) != 0) {
        y = ([self->rect_ top] % 4);
    }
    r = [[PoCoRect alloc] initLeft:0
                           initTop:0
                         initRight:([self->srcBitmap_ width] + x)
                        initBottom:([self->srcBitmap_ height] + y)];
    self->workSrcBitmap_ = [[PoCoBitmap alloc] initWidth:[r width]
                                              initHeight:[r height]
                                            defaultColor:0];
    self->workDstBitmap_ = [[PoCoBitmap alloc] initWidth:[r width]
                                              initHeight:[r height]
                                            defaultColor:0];
    self->workMaskBitmap_ = [[PoCoBitmap alloc] initWidth:[r width]
                                              initHeight:[r height]
                                            defaultColor:0];
    [r setLeft:x];
    [r setTop:y];
    [self->workSrcBitmap_ setBitmap:[self->srcBitmap_ pixelmap]
                           withRect:r];
    [self->workDstBitmap_ setBitmap:[self->dstBitmap_ pixelmap]
                           withRect:r];
    [self->workMaskBitmap_ setBitmap:[self->maskBitmap_ pixelmap]
                           withRect:r];
    [r release];

    // ʿ
    [self scanHori];

    // ľ
    [self scanVert];

    // ΰ褫ʣ(ƤΤ)
    r = [[PoCoRect alloc] initLeft:x
                           initTop:y
                         initRight:([self->dstBitmap_ width] + x)
                        initBottom:([self->dstBitmap_ height] + y)];
    tmp = [self->workDstBitmap_ getBitmap:r];
    [r release];
    r = [[PoCoRect alloc] initLeft:0
                           initTop:0
                         initRight:[tmp width]
                        initBottom:[tmp height]];
    [self->dstBitmap_ setBitmap:[tmp pixelmap]
                       withRect:r];
    [tmp release];
    [r release];

    return;
}

@end
