//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ưǡ()
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoEditAutoGradationAdjacent.h"

#import "PoCoColorPattern.h"
#import "PoCoEditAtomizerDrawLine.h"

#if 1
# define  __POCO_USE_THREAD_TO_IMPROVE_EFFICIENCY_OF_AUDOGRAD
#endif  // 1

// =========================================== PoCoAutoGradationAdjacentElement

// ------------------------------------------------------------------ interface
@interface PoCoAutoGradationAdjacentElement : NSObject
{
    PoCoPoint *pt_;                     // ɸ
    unsigned char firstColor_;          // 1
    unsigned char secondColor_;         // 2
    int firstSize_;                     // 1
    int secondSize_;                    // 2
    BOOL isHori_;                       // ʿˤΤ
}

// initialize
-(id)initWithPoint:(PoCoPoint *)dp
    withFirstColor:(unsigned char)firstColor
    andSecondColor:(unsigned char)secondColor
     withFirstSize:(int)firstSize
     andSecondSize:(int)secondSize
            isHori:(BOOL)isHori;

// deallocate
-(void)dealloc;

// property(get)
-(NSString *)name;
-(PoCoPoint *)point;
-(unsigned char)firstColor;
-(unsigned char)secondColor;
-(int)firstSize;
-(int)secondSize;
-(BOOL)isHori;

// property(set)
-(void)setFirstSize:(int)size;
-(void)setSecondSize:(int)size;

@end


// ------------------------------------------------------------------ implement
@implementation PoCoAutoGradationAdjacentElement

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//
//  Return
//    function     : 
//    pt_          : ɸ(instance ѿ)
//    firstColor_  : 1(instance ѿ)
//    secondColor_ : 2(instance ѿ)
//    firstSize_   : 1(instance ѿ)
//    secondSize_  : 2(instance ѿ)
//    isHori_      : ʿˤΤ(instance ѿ)
//
-(id)initWithPoint:(PoCoPoint *)dp
    withFirstColor:(unsigned char)firstColor
    andSecondColor:(unsigned char)secondColor
     withFirstSize:(int)firstSize
     andSecondSize:(int)secondSize
            isHori:(BOOL)isHori
{
    // super class ز
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->firstColor_ = firstColor;
        self->secondColor_ = secondColor;
        self->firstSize_ = firstSize;
        self->secondSize_ = secondSize;
        self->isHori_ = isHori;

        // ɸʣ
        self->pt_ = [[PoCoPoint alloc] initX:[dp x]
                                       initY:[dp y]];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pt_ : ɸ(instance ѿ)
//
-(void)dealloc
{
    // 񸻤β
    [self->pt_ release];
    self->pt_ = nil;

    // super class β
    [super dealloc];

    return;
}


// ------------------------------------------ instance - public - property(get)
//
// ̾
//
//  Call
//    pt_          : ɸ(instance ѿ)
//    firstColor_  : 1(instance ѿ)
//    secondColor_ : 2(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)name
{
    return [NSString stringWithFormat:@"%05d:%05d:%03d:%03d", [self->pt_ x], [self->pt_ y], self->firstColor_, self->secondColor_];
}


//
// ɸ
//
//  Call
//    pt_ : ɸ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)point
{
    return self->pt_;
}


//
// 1
//
//  Call
//    firstColor_ : 1(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned char)firstColor
{
    return self->firstColor_;
}


//
// 2
//
//  Call
//    secondColor_ : 2(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned char)secondColor
{
    return self->secondColor_;
}


//
// 1
//
//  Call
//    firstSize_ : 1(instance ѿ)
//
//  Return
//    function : 
//
-(int)firstSize
{
    return self->firstSize_;
}


//
// 2
//
//  Call
//    secondSize_ : 2(instance ѿ)
//
//  Return
//    function : 
//
-(int)secondSize
{
    return self->secondSize_;
}


//
// ʿˤΤ
//
//  Call
//    isHori_ : ʿˤΤ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isHori
{
    return self->isHori_;
}


// ------------------------------------------ instance - public - property(set)
//
// 1
//
//  Call
//    size : 
//
//  Return
//    firstSize_ : 1(instance ѿ)
//
-(void)setFirstSize:(int)size
{
    self->firstSize_ = size;

    return;
}


//
// 2
//
//  Call
//    size : 
//
//  Return
//    secondSize_ : 2(instance ѿ)
//
-(void)setSecondSize:(int)size
{
    self->secondSize_ = size;

    return;
}

@end




// ============================================== PoCoAutoGradationAdjacentPair

// ------------------------------------------------------------------ interface
@interface PoCoAutoGradationAdjacentPair : NSObject
{
    // 
    unsigned char firstColor_;          // 1
    unsigned char secondColor_;         // 2
    PoCoBitmap *workSrcBitmap_;         // 踵
    PoCoBitmap *workMaskBitmap_;        // ޥ
    int size_;                          // 礭(0: Ǥա1-128 ϰ)
    PoCoRect *rect_;                    // ϰ

    // 
    PoCoPoint *drawPoint_;              // 
    int leftLen_;                       // Υɥåȿ
    int rightLen_;                      // Υɥåȿ
    unsigned char leftColor_;           // ο
    unsigned char rightColor_;          // ο
    PoCoAutoGradState scanState_;       // 

    // 
    NSMutableDictionary *points_;       // о
}

// initialize
-(id)initWithFirstColor:(unsigned char)first
         andSecondColor:(unsigned char)second
                withSrc:(PoCoBitmap *)sbmp
               withMask:(PoCoBitmap *)mbmp
                penSize:(int)size
                   rect:(PoCoRect *)r;

// deallocate
-(void)dealloc;

// ¹
-(void)execute;

// property(get)
-(NSDictionary *)points;

@end


// ------------------------------------------------------------------ implement
@implementation PoCoAutoGradationAdjacentPair

// --------------------------------------------------------- instance - private
//
// Ͽ
//
//  Call
//    isHori      : ʿ(YES: ʿ)
//    size_       : 礭(0: Ǥա1-128 ϰ)(instance ѿ)
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//
//  Return
//    points_ : о(instance ѿ)
//
-(void)registerPoint:(BOOL)isHori
{
    int leftSize;
    int rightSize;
    PoCoAutoGradationAdjacentElement *elm;
    PoCoAutoGradationAdjacentElement *tmp;

    // 
    if (self->size_ == 0) {
        leftSize = MIN(self->leftLen_, 128);
        rightSize = MIN(self->rightLen_, 128);
    } else {
        leftSize = self->size_;
        rightSize = self->size_;
    }

    // Ǥ
    elm = [[PoCoAutoGradationAdjacentElement alloc]
              initWithPoint:self->drawPoint_
             withFirstColor:self->leftColor_
             andSecondColor:self->rightColor_
              withFirstSize:leftSize
              andSecondSize:rightSize
                     isHori:isHori];

    // ƱƤϿѤߤ
    tmp = [self->points_ valueForKey:[elm name]];
    if (tmp == nil) {
        // ʤϿ
        [self->points_ setValue:elm
                         forKey:[elm name]];
    } else {
        // о(礭Ĥ)
        if ([tmp firstSize] < [elm firstSize]) {
            [tmp setFirstSize:[elm firstSize]];
        }
        if ([tmp secondSize] < [elm secondSize]) {
            [tmp setSecondSize:[elm secondSize]];
        }
    }
    [elm release];

    return;
}


//
// ã򸡾
//
//  Call
//    srcColor     : 踵ο
//    mask         : ޥ
//    x            : ʿ
//    y            : ľ
//    isHori       : ʿ(YES: ʿ)
//    firstColor_  : 1(instance ѿ)
//    secondColor_ : 2(instance ѿ)
//    leftLen_     : Υɥåȿ(instance ѿ)
//    rightLen_    : Υɥåȿ(instance ѿ)
//    leftColor_   : ο(instance ѿ)
//    rightColor_  : ο(instance ѿ)
//    scanState_   : (instance ѿ)
//
//  Return
//    drawPoint_  : (instance ѿ)
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//    scanState_  : (instance ѿ)
//
-(void)inspectAttachedPoint:(unsigned char)srcColor
                   withMask:(unsigned char)mask
                    horiPos:(int)x
                    vertPos:(int)y
                 isHoriScan:(BOOL)isHori
{
    if (mask) {
        if (self->scanState_ == PoCoAutoGrad_NoneAttach) {
            // õƤ
            if ((srcColor == self->firstColor_) ||
                (srcColor == self->secondColor_)) {
                // оݿʤΤǻã
                self->leftLen_ = 1;
                self->leftColor_ = srcColor;

                // 
                self->scanState_ = PoCoAutoGrad_StartAttached;
            }
        } else if (self->scanState_ == PoCoAutoGrad_StartAttached) {
            // ˤã(õƤ)
            if (self->leftColor_ == srcColor) {
                // ƱΤޤޤʤΤǷ³
                (self->leftLen_)++;
            } else if ((srcColor == self->firstColor_) ||
                       (srcColor == self->secondColor_)) {
                // Ȥϰ㤦оݿʤΤã
                self->rightLen_ = 1;
                self->rightColor_ = srcColor;

                // 
                [self->drawPoint_ setX:x
                                  setY:y];

                // 
                self->scanState_ = PoCoAutoGrad_MiddleAttached;
            } else {
                // оݿǤϤʤΤˤʤʤΤǲ⤷ʤ
                self->leftLen_ = 0;
                self->rightLen_ = 0;
                self->leftColor_ = 0;
                self->rightColor_ = 0;

                // 
                self->scanState_ = PoCoAutoGrad_NoneAttach;
            }
        } else if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            // ã(õƤ)
            if (self->rightColor_ == srcColor) {
                // ƱΤޤޤʤΤǷ³
                (self->rightLen_)++;
            } else {
                // ãΤϿ
                [self registerPoint:isHori];

                // ³
                if ((srcColor == self->firstColor_) ||
                    (srcColor == self->secondColor_)) {
                    // оݿʤΤãˤ
                    self->leftLen_ = self->rightLen_;
                    self->rightLen_ = 1;
                    self->leftColor_ = self->rightColor_;
                    self->rightColor_ = srcColor;

                    // Ȥʤ(֤ˤʤ)
                    [self->drawPoint_ setX:x
                                      setY:y];

                    // ܤϤʤǽõ
                    ;
                } else {
                    // оݿǤϤʤʬʤΤǺǽ
                    self->leftLen_ = 0;
                    self->rightLen_ = 0;
                    self->leftColor_ = 0;
                    self->rightColor_ = 0;

                    // 
                    self->scanState_ = PoCoAutoGrad_NoneAttach;
                }
            }
        }
    } else {
        // ˴ޤޤʤϰ
        if (self->scanState_ == PoCoAutoGrad_NoneAttach) {
            // ⤽ɤˤãƤʤ
            ;
        } else if (self->scanState_ == PoCoAutoGrad_StartAttached) {
            // ˤãƤ뤱ˤãƤʤ
            ;
        } else if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            // ˤãƤΤǽãȤϿ
            [self registerPoint:isHori];
        }

        // ϰϤȴ
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;

        // 
        self->scanState_ = PoCoAutoGrad_NoneAttach;
    }

    return;
}


//
// ʿ
//
//  Call
//    workSrcBitmap_  : 踵(instance ѿ)
//    workMaskBitmap_ : ޥ(instance ѿ)
//
//  Return
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//    scanState_  : (instance ѿ)
//
-(void)scanHori
{
    const int w = [self->workSrcBitmap_ width];
    const int h = [self->workSrcBitmap_ height];
    const int row = (w + (w & 0x01));
    const int skip = (row - w);
    int x;
    int y;
    unsigned char *sp = [self->workSrcBitmap_ pixelmap];
    unsigned char *mp = [self->workMaskBitmap_ pixelmap];

    // ľ
    y = 0;
    do {
        // 饤󤴤Ȥ˾˽֤᤹
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;
        self->scanState_ = PoCoAutoGrad_NoneAttach;

        // ʿ
        x = 0;
        do {
            // ã򸡾
            [self inspectAttachedPoint:*(sp)
                              withMask:*(mp)
                               horiPos:x
                               vertPos:y
                            isHoriScan:YES];

            // 
            (x)++;
            (sp)++;
            (mp)++;
        } while (x < w);

        // ˤãƤ֤üãΤϿ
        if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            [self registerPoint:YES];
        }

        // 
        (y)++;
        sp += skip;
        mp += skip;
    } while (y < h);

    return;
}


//
// ľ
//
//  Call
//    workSrcBitmap_  : 踵(instance ѿ)
//    workMaskBitmap_ : ޥ(instance ѿ)
//
//  Return
//    leftLen_    : Υɥåȿ(instance ѿ)
//    rightLen_   : Υɥåȿ(instance ѿ)
//    leftColor_  : ο(instance ѿ)
//    rightColor_ : ο(instance ѿ)
//    scanState_  : (instance ѿ)
//
-(void)scanVert
{
    const int w = [self->workSrcBitmap_ width];
    const int h = [self->workSrcBitmap_ height];
    const int row = (w + (w & 0x01));
    int x;
    int y;
    unsigned char *sp = [self->workSrcBitmap_ pixelmap];
    unsigned char *mp = [self->workMaskBitmap_ pixelmap];

    // ʿ
    x = 0;
    do {
        // 饤󤴤Ȥ˾˽֤᤹
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;
        self->scanState_ = PoCoAutoGrad_NoneAttach;

        // ľ
        y = 0;
        do {
            // ã򸡾
            [self inspectAttachedPoint:*(sp)
                              withMask:*(mp)
                               horiPos:x
                               vertPos:y
                            isHoriScan:NO];

            // 
            (y)++;
            sp += row;
            mp += row;
        } while (y < h);

        // ˤãƤ֤üãΤϿ
        if (self->scanState_ == PoCoAutoGrad_MiddleAttached) {
            [self registerPoint:NO];
        }

        // 
        (x)++;
        sp = ([self->workSrcBitmap_ pixelmap] + x);
        mp = ([self->workMaskBitmap_ pixelmap] + x);
    } while (x < w);

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    first  : 1(instance ѿ)
//    second : 2(instance ѿ)
//    sbmp   : 踵
//    mbmp   : ޥ
//    size   : 礭(0: Ǥա1-128 ϰ)
//    r      : ϰ
//
//  Return
//    function        : 
//    firstColor_     : 1(instance ѿ)
//    secondColor_    : 2(instance ѿ)
//    workSrcBitmap_  : 踵(instance ѿ)
//    workMaskBitmap_ : ޥ(instance ѿ)
//    size_           : 礭(0: Ǥա1-128 ϰ)(instance ѿ)
//    rect_           : ϰ(instance ѿ)
//    drawPoint_      : (instance ѿ)
//    leftLen_        : Υɥåȿ(instance ѿ)
//    rightLen_       : Υɥåȿ(instance ѿ)
//    leftColor_      : ο(instance ѿ)
//    rightColor_     : ο(instance ѿ)
//    scanState_      : (instance ѿ)
//    points_         : о(instance ѿ)
//
-(id)initWithFirstColor:(unsigned char)first
         andSecondColor:(unsigned char)second
                withSrc:(PoCoBitmap *)sbmp
               withMask:(PoCoBitmap *)mbmp
                penSize:(int)size
                   rect:(PoCoRect *)r
{
    // super class ز
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->firstColor_ = first;
        self->secondColor_ = second;
        self->workSrcBitmap_ = sbmp;
        self->workMaskBitmap_ = mbmp;
        self->size_ = size;
        self->rect_ = r;
        self->drawPoint_ = nil;
        self->points_ = nil;

        // 줾 retain Ƥ
        [self->workSrcBitmap_ retain];
        [self->workMaskBitmap_ retain];
        [self->rect_ retain];

        // 
        self->drawPoint_ = [[PoCoPoint alloc] init];
        if (self->drawPoint_ == nil) {
            [self release];
            self = nil;
            goto EXIT;
        }

        // ֤ä˲ʤ
        self->leftLen_ = 0;
        self->rightLen_ = 0;
        self->leftColor_ = 0;
        self->rightColor_ = 0;
        self->scanState_ = PoCoAutoGrad_NoneAttach;

        // ݻ
        self->points_ = [[NSMutableDictionary alloc] init];
        if (self->points_ == nil) {
            [self release];
            self = nil;
            goto EXIT;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    workSrcBitmap_  : 踵(instance ѿ)
//    workMaskBitmap_ : ޥ(instance ѿ)
//    rect_           : ϰ(instance ѿ)
//    drawPoint_      : (instance ѿ)
//    points_         : о(instance ѿ)
//
-(void)dealloc
{
    // 񸻤β
    [self->workSrcBitmap_ release];
    [self->workMaskBitmap_ release];
    [self->rect_ release];
    [self->drawPoint_ release];
    [self->points_ release];
    self->workSrcBitmap_ = nil;
    self->workMaskBitmap_ = nil;
    self->rect_ = nil;
    self->drawPoint_ = nil;
    self->points_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    None
//
//  Return
//    None
//
-(void)execute
{
    // ʿ
    [self scanHori];

    // ľ
    [self scanVert];

#ifdef  __POCO_USE_THREAD_TO_IMPROVE_EFFICIENCY_OF_AUDOGRAD
    // λ
    [NSThread exit];
#endif  // __POCO_USE_THREAD_TO_IMPROVE_EFFICIENCY_OF_AUDOGRAD

    return;
}


//------------------------------------------- instance - public - property(get)
//
// 1
//
//  Call
//    firstColor_ : 1(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned char)firstColor
{
    return self->firstColor_;
}


//
// 2
//
//  Call
//    secondColor_ : 2(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned char)secondColor
{
    return self->secondColor_;
}


//
// о
//
//  Call
//    points_ : о(instance ѿ)
//
//  Return
//    function : о
//
-(NSDictionary *)points
{
    return self->points_;
}

@end




// ============================================================================
@implementation PoCoEditAutoGradationAdjacent

// --------------------------------------------------------- instance - private
//
// Ⱦ̸᤭
//
//  Call
//    dp       : ɸ
//    col      : 迧
//    size     : 礭(¥ɥåȿʤΤ 1-128 ϰ)
//    flip     : ȿž(YES: ȿž)
//    hori     : ʿ(YES: ʿ)
//    high     : 夫鲼οܤ(YES: 夫鲼NO: )
//               (οֹ椫οֹؤܤ)
//    palette_ : ѥѥå(instance ѿ)
//
//  Return
//    workDstBitmap_ : (instance ѿ)
//
-(void)executeHalfAtomizer:(PoCoPoint *)dp
                     color:(unsigned char)col
                      size:(int)size
                    isFlip:(BOOL)flip
                    isHori:(BOOL)hori
                    isHigh:(BOOL)high
{
    PoCoEditAtomizerDrawLine *edit;
    PoCoColorPattern *pat;
    int s;
    PoCoPoint *p;

    pat = nil;
    edit = nil;
    s = (size / 8);                     // ̸᤭ѥѤϼ¥ / 8
    p = [[PoCoPoint alloc] initX:[dp x]
                           initY:[dp y]];

#if 0   // ⤽⤳ĴɬפʤΤ?
    // ξ˰Ĵ
    if (flip) {
        if (hori) {
            if (high) {
                // 夫鲼ڤؤʤΤǰ֤򱦤˰ư
                [p moveX:(s / 2)];
            } else {
                // ڤؤʤΤǰ֤򺸤˰ư
                [p moveX:-(s + (s / 2))];
            }
        } else {
            if (high) {
                // 夫鲼ڤؤʤΤǰ֤򲼤˰ư
                [p moveY:(s / 2)];
            } else {
                // ڤؤʤΤǰ֤˰ư
                [p moveY:-(s + (s / 2))];
            }
        }
    }
#endif  // 0

    // 顼ѥ
    pat = [[PoCoColorPattern alloc] initWidth:1
                                   initHeight:1
                                 defaultColor:col];

    // Ϥ
    edit = [[PoCoEditAtomizerDrawLine alloc]
                  init:self->workDstBitmap_
               palette:self->palette_
               pattern:pat
               penSize:s];
    [edit setRatio:1000
         pointSkip:PoCoAtomizerSkipType_Pattern
       patternType:YES
         isFlipped:flip];

    // ʬˤƱ
    [edit addPoint:p];
    [edit addPoint:p];

    // ¹
    [edit executeDraw];

    // 
    [edit release];
    [pat release];

    [p release];
    return;
}


//
// ѥåȤ
//
//  Call
//    palette_ : ѥѥå(instance ѿ)
//
//  Return
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)pushPalette
{
    int l;

    for (l = 0; l < COLOR_MAX; (l)++) {
        self->colorBuffer_[l] = [[self->palette_ palette:l] noDropper];
        self->colorBuffer_[l + COLOR_MAX] = [[self->palette_ palette:l] isMask];
    }

    return;
}


//
// ѥåȤʽ
//
//  Call
//    colorBuffer_ : ݻ(instance ѿ)
//
//  Return
//    palette_ : ѥѥå(instance ѿ)
//
-(void)popPalette
{
    int l;

    for (l = 0; l < COLOR_MAX; (l)++) {
        [[self->palette_ palette:l] setDropper:self->colorBuffer_[l]];
        [[self->palette_ palette:l] setMask:self->colorBuffer_[l + COLOR_MAX]];
    }

    return;
}


//
// ѥåȤڤؤ
//
//  Call
//    pair         : оݤ
//    colorBuffer_ : ݻ(instance ѿ)
//
//  Return
//    palette_ : ѥѥå(instance ѿ)
//
-(void)overwritePalette:(PoCoAutoGradationAdjacentPair *)pair
{
    int l;

    // ƤΥѥåȤ(衦Ѥػߤ)
    for (l = 0; l < COLOR_MAX; (l)++) {
        [[self->palette_ palette:l] setDropper:YES];
        [[self->palette_ palette:l] setMask:YES];
    }

    // оݤο衦ѤĤ
    if ((self->colorBuffer_[[pair firstColor]            ]) ||
        (self->colorBuffer_[[pair firstColor] + COLOR_MAX])) {
        // ȤȻѤǤʤɤ꤬ػߤƤ
        ;
    } else {
        [[self->palette_ palette:[pair firstColor]] setDropper:NO];
        [[self->palette_ palette:[pair firstColor]] setMask:NO];
    }
    if ((self->colorBuffer_[[pair secondColor]            ]) ||
        (self->colorBuffer_[[pair secondColor] + COLOR_MAX])) {
        // ȤȻѤǤʤɤ꤬ػߤƤ
        ;
    } else {
        [[self->palette_ palette:[pair secondColor]] setDropper:NO];
        [[self->palette_ palette:[pair secondColor]] setMask:NO];
    }

    return;
}


//
// οȤ߹碌ɤ¹
//
//  Call
//    pair      : оݤ
//    sizePair_ : 礭ȿֹз(instance ѿ)
//
//  Return
//    None
//
-(void)drawBackwordColor:(PoCoAutoGradationAdjacentPair *)pair
{
    NSEnumerator *iter;
    PoCoAutoGradationAdjacentElement *elm;
    unsigned char col;
    int size;
    PoCoGradationPairInfo *tmp;

    // ѥåȤڤؤ
    [self overwritePalette:pair];

    // ФݻƤ
    iter = [[pair points] objectEnumerator];
    for (elm = [iter nextObject]; elm != nil; elm = [iter nextObject]) {
        // ɤʤΤǼοֹɤ
        if ([elm firstColor] < [elm secondColor]) {
            col = [elm firstColor];
            size = [elm firstSize];
            if (self->sizePair_ != nil) {
                tmp = [self->sizePair_ valueForKey:[PoCoGradationPairInfo pairString:[elm firstColor]
                                                                          withSecond:[elm secondColor]]];
                size = [tmp size];
            }
        } else {
            col = [elm secondColor];
            size = [elm secondSize];
            if (self->sizePair_ != nil) {
                tmp = [self->sizePair_ valueForKey:[PoCoGradationPairInfo pairString:[elm secondColor]
                                                                          withSecond:[elm firstColor]]];
                size = [tmp size];
            }
        }
        [self executeHalfAtomizer:[elm point]
                            color:col
                             size:size
                           isFlip:NO
                           isHori:[elm isHori]
                           isHigh:YES];
    }

    return;
}


//
// οȤ߹碌ɤ¹
//
//  Call
//    pair      : оݤ
//    sizePair_ : 礭ȿֹз(instance ѿ)
//
//  Return
//    None
//
-(void)drawForwardColor:(PoCoAutoGradationAdjacentPair *)pair
{
    NSEnumerator *iter;
    PoCoAutoGradationAdjacentElement *elm;
    unsigned char col;
    int size;
    BOOL flag;
    PoCoGradationPairInfo *tmp;

    // ѥåȤڤؤ
    [self overwritePalette:pair];

    // ФݻƤ
    iter = [[pair points] objectEnumerator];
    for (elm = [iter nextObject]; elm != nil; elm = [iter nextObject]) {
        // ɤʤΤǸοֹɤ
        flag = ([elm firstColor] < [elm secondColor]);
        if (flag) {
            col = [elm secondColor];
            size = [elm secondSize];
            if (self->sizePair_ != nil) {
                tmp = [self->sizePair_ valueForKey:[PoCoGradationPairInfo pairString:[elm secondColor]
                                                                          withSecond:[elm firstColor]]];
                size = [tmp size];
            }
        } else {
            col = [elm firstColor];
            size = [elm firstSize];
            if (self->sizePair_ != nil) {
                tmp = [self->sizePair_ valueForKey:[PoCoGradationPairInfo pairString:[elm firstColor]
                                                                          withSecond:[elm secondColor]]];
                size = [tmp size];
            }
        }
        [self executeHalfAtomizer:[elm point]
                            color:col
                             size:size
                           isFlip:YES
                           isHori:[elm isHori]
                           isHigh:flag];
    }

    return;
}


//
// Ϣ³򸡾
//
//  Call
//    matrix_ : оݿ(256 ĹYES: о)(instance ѿ)
//
//  Return
//    pairNum_ : Фο(instance ѿ)
//
-(void)verifyContinues
{
    int l;
    BOOL noAttach;
    BOOL isStart;

    self->pairNum_ = 0;
    noAttach = YES;
    isStart = NO;

    // Ƭ֤˷꤬ʤ򸡾
    for (l = 0; l < COLOR_MAX; (l)++) {
        if (noAttach) {
            // ̤ã(ƬõƤ)
            if (self->matrix_[l]) {
                // Ƭã
                noAttach = NO;
                isStart = YES;
            }
        } else if (isStart) {
            // ƬˤãƤ(õƤ)
            if (self->matrix_[l]) {
                // Ϣ³Ƥ׾ 
                (self->pairNum_)++;
            } else {
                // ã(Ϥ)
                noAttach = NO;
                isStart = NO;
            }
        } else {
            // ˤãƤ(Ϥ)(õƤ)
            if (self->matrix_[l]) {
                // ˤʤäƤΤϢ³Ƥʤ
                self->pairNum_ = 0;     // Ϣ³̵ˤ
                break;
            }
        }
    }

    return;
}


//
// Ȥ߹碌
//
//  Call
//    workSrcBitmap_  : 踵(instance ѿ)
//    workMaskBitmap_ : ޥ(instance ѿ)
//    size_           : 礭(0: Ǥա1-128 ϰ)(instance ѿ)
//    rect_           : ϰ(instance ѿ)
//    pairNum_        : Фο(instance ѿ)
//
//  Return
//    pair_ : Ѥ(instance ѿ)
//
-(void)createColorPair
{
    int l;
    int i;

    // 
    self->pair_ = (PoCoAutoGradationAdjacentPair **)(calloc(self->pairNum_, sizeof(PoCoAutoGradationAdjacentPair *)));
    if (self->pair_ != NULL) {
        // Фξ
        i = 0;
        for (l = 0; l < (COLOR_MAX - 1); (l)++) {
            if ((self->matrix_[l    ]) &&
                (self->matrix_[l + 1]) &&
                (i < self->pairNum_)) {
                self->pair_[i] = [[PoCoAutoGradationAdjacentPair alloc]
                                     initWithFirstColor:l
                                         andSecondColor:(l + 1)
                                                withSrc:self->workSrcBitmap_
                                               withMask:self->workMaskBitmap_
                                                penSize:self->size_
                                                   rect:self->rect_];
                (i)++;
            }
        }
    }

    return;
}


//
// оݺɸ򸡽
//
//  Call
//    pairNum_ : Фο(instance ѿ)
//    pair_    : Ѥ(instance ѿ)
//
//  Return
//    pair_ : Ѥ(instance ѿ)
//
-(void)scanTargetPoint
#ifdef  __POCO_USE_THREAD_TO_IMPROVE_EFFICIENCY_OF_AUDOGRAD
{
    int l;
    id *thread;
    BOOL flag;

    // ѤФ¹
    thread = (id *)(calloc(self->pairNum_, sizeof(id)));
    if (thread != NULL) {
        for (l = 0; l < self->pairNum_; (l)++) {
            thread[l] = [[NSThread alloc] initWithTarget:self->pair_[l]
                                                selector:@selector(execute)
                                                  object:nil];
            [thread[l] start];
        }

        // ٤Ƥ thread ΤԤ
        [NSThread sleepForTimeInterval:0.001];
        do {
            flag = NO;
            for (l = 0; l < self->pairNum_; (l)++) {
                if (thread[l] == nil) {
                    // ˽äƤ
                    ;
                } else if ([thread[l] isFinished]) {
                    // λΤǲ
                    [thread[l] release];
                    thread[l] = nil;
                } else {
                    // ¹
                    flag = YES;
                }
            }
            [NSThread sleepForTimeInterval:0.001];
        } while (flag);

        // 
        free(thread);
    }

    return;
}
#else   // __POCO_USE_THREAD_TO_IMPROVE_EFFICIENCY_OF_AUDOGRAD
{
    int l;

    // ѤФ¹
    for (l = 0; l < self->pairNum_; (l)++) {
        [self->pair_[l] execute];
    }

    return;
}
#endif  // __POCO_USE_THREAD_TO_IMPROVE_EFFICIENCY_OF_AUDOGRAD


//
// Ф
//
//  Call
//    pairNum_ : Фο(instance ѿ)
//    pair_    : Ѥ(instance ѿ)
//
//  Return
//    None
//
-(void)enumeratePair
{
    int l;

    // ѥåȤ
    [self pushPalette];

    // οȤ߹碌ɤ¹
    for (l = self->pairNum_; l != 0; (l)--) {
        [self drawBackwordColor:self->pair_[l - 1]];
    }

    // οȤ߹碌ɤ¹
    for (l = 0; l < self->pairNum_; (l)++) {
        [self drawForwardColor:self->pair_[l]];
    }

    // ѥåȤʽ
    [self popPalette];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dbmp     : 
//    sbmp     : 踵
//    mbmp     : ޥ
//    plt      : ѥѥå
//    size     : 礭(0: Ǥա1-128 ϰ)
//    mtx      : оݿ(256 ĹYES: о)
//    r        : ϰ
//    sizePair : 礭ȿֹз
//
//  Return
//    function        : 
//    srcBitmap_      : 踵(instance ѿ)
//    dstBitmap_      : (instance ѿ)
//    maskBitmap_     : ޥ(instance ѿ)
//    palette_        : ѥѥå(instance ѿ)
//    size_           : 礭(0: Ǥա1-128 ϰ)(instance ѿ)
//    matrix_         : оݿ(256 ĹYES: о)(instance ѿ)
//    rect_           : ϰ(instance ѿ)
//    sizePair_       : 礭ȿֹз(instance ѿ)
//    workSrcBitmap_  : 踵(ΰ)(instance ѿ)
//    workDstBitmap_  : (ΰ)(instance ѿ)
//    workMaskBitmap_ : ޥ(ΰ)(instance ѿ)
//    pairNum_        : Фο(instance ѿ)
//    pair_           : Ѥ(instance ѿ)
//
-(id)initDst:(PoCoBitmap *)dbmp
     withSrc:(PoCoBitmap *)sbmp
    withMask:(PoCoBitmap *)mbmp
     palette:(PoCoPalette *)plt
     penSize:(int)size
      matrix:(const BOOL *)mtx
        rect:(PoCoRect *)r
withSizePair:(NSDictionary *)sizePair
{
    DPRINT((@"[PoCoEditAutoGradationAdjacent init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = sbmp;
        self->dstBitmap_ = dbmp;
        self->maskBitmap_ = mbmp;
        self->palette_ = plt;
        self->size_ = size;
        self->matrix_ = mtx;
        self->rect_ = r;
        self->sizePair_ = sizePair;
        self->workSrcBitmap_ = nil;
        self->workDstBitmap_ = nil;
        self->workMaskBitmap_ = nil;
        self->pairNum_ = 0;
        self->pair_ = NULL;

        // 줾 retain Ƥ
        [self->srcBitmap_ retain];
        [self->dstBitmap_ retain];
        [self->maskBitmap_ retain];
        [self->palette_ retain];
        [self->rect_ retain];
        [self->sizePair_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    pairNum_ : Фο(instance ѿ)
//
//  Return
//    srcBitmap_      : 踵(instance ѿ)
//    dstBitmap_      : (instance ѿ)
//    maskBitmap_     : ޥ(instance ѿ)
//    palette_        : ѥѥå(instance ѿ)
//    rect_           : ϰ(instance ѿ)
//    sizePair_       : 礭ȿֹз(instance ѿ)
//    workSrcBitmap_  : 踵(ΰ)(instance ѿ)
//    workDstBitmap_  : (ΰ)(instance ѿ)
//    workMaskBitmap_ : ޥ(ΰ)(instance ѿ)
//    pair_           : Ѥ(instance ѿ)
//
-(void)dealloc
{
    int l;

    DPRINT((@"[PoCoEditAutoGradationAdjacent dealloc]\n"));

    // 񸻤β
    if (self->pair_ != NULL) {
        for (l = 0; l < self->pairNum_; (l)++) {
            [self->pair_[l] release];
        }
        free(self->pair_);
    }
    [self->srcBitmap_ release];
    [self->dstBitmap_ release];
    [self->maskBitmap_ release];
    [self->palette_ release];
    [self->rect_ release];
    [self->sizePair_ release];
    [self->workSrcBitmap_ release];
    [self->workDstBitmap_ release];
    [self->workMaskBitmap_ release];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;
    self->maskBitmap_ = nil;
    self->palette_ = nil;
    self->rect_ = nil;
    self->sizePair_ = nil;
    self->workSrcBitmap_ = nil;
    self->workDstBitmap_ = nil;
    self->workMaskBitmap_ = nil;
    self->pair_ = NULL;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_  : 踵(instance ѿ)
//    dstBitmap_  : (instance ѿ)
//    maskBitmap_ : ޥ(instance ѿ)
//    rect_       : ϰ(instance ѿ)
//
//  Return
//    dstBitmap_      : (instance ѿ)
//    workSrcBitmap_  : 踵(ΰ)(instance ѿ)
//    workDstBitmap_  : (ΰ)(instance ѿ)
//    workMaskBitmap_ : ޥ(ΰ)(instance ѿ)
//
-(void)executeDraw
{
    PoCoRect *r;
    int x;
    int y;
    PoCoBitmap *tmp;

    // 踵򤽤Τޤʣ
    r = [[PoCoRect alloc] initLeft:0
                           initTop:0
                         initRight:[self->srcBitmap_ width]
                        initBottom:[self->srcBitmap_ height]];
    [self->dstBitmap_ setBitmap:[self->srcBitmap_ pixelmap]
                       withRect:r];
    [r release];

    // ΰʣ
    x = 0;
    y = 0;
    if (([self->rect_ left] % 4) != 0) {
        x = ([self->rect_ left] % 4);
    }
    if (([self->rect_ top] % 4) != 0) {
        y = ([self->rect_ top] % 4);
    }
    r = [[PoCoRect alloc] initLeft:0
                           initTop:0
                         initRight:([self->srcBitmap_ width] + x)
                        initBottom:([self->srcBitmap_ height] + y)];
    self->workSrcBitmap_ = [[PoCoBitmap alloc] initWidth:[r width]
                                              initHeight:[r height]
                                            defaultColor:0];
    self->workDstBitmap_ = [[PoCoBitmap alloc] initWidth:[r width]
                                              initHeight:[r height]
                                            defaultColor:0];
    self->workMaskBitmap_ = [[PoCoBitmap alloc] initWidth:[r width]
                                              initHeight:[r height]
                                            defaultColor:0];
    [r setLeft:x];
    [r setTop:y];
    [self->workSrcBitmap_ setBitmap:[self->srcBitmap_ pixelmap]
                           withRect:r];
    [self->workDstBitmap_ setBitmap:[self->dstBitmap_ pixelmap]
                           withRect:r];
    [self->workMaskBitmap_ setBitmap:[self->maskBitmap_ pixelmap]
                           withRect:r];
    [r release];

    // Ϣ³򸡾
    [self verifyContinues];
    if (self->pairNum_ > 0) {
        // Ȥ߹碌
        [self createColorPair];

        // оݺɸ򸡽
        [self scanTargetPoint];

        // Ȥ߹碌
        [self enumeratePair];
    }

    // ΰ褫ʣ(ƤΤ)
    r = [[PoCoRect alloc] initLeft:x
                           initTop:y
                         initRight:([self->dstBitmap_ width] + x)
                        initBottom:([self->dstBitmap_ height] + y)];
    tmp = [self->workDstBitmap_ getBitmap:r];
    [r release];
    r = [[PoCoRect alloc] initLeft:0
                           initTop:0
                         initRight:[tmp width]
                        initBottom:[tmp height]];
    [self->dstBitmap_ setBitmap:[tmp pixelmap]
                       withRect:r];
    [tmp release];
    [r release];

    return;
}

@end
