//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ִ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditBitmapColorReplace.h"

// ============================================================================
@implementation PoCoEditBitmapColorReplace

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dbmp : Խоݲ
//    sbmp : Խ
//    msk  : ޥ
//    mtx  : ִɽ
//
//  Return
//    function   : 
//    srcBitmap_ : Խ(instance ѿ)
//    dstBitmap_ : Խоݲ(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    matrix_    : ִɽ(instance ѿ)
//
-(id)initTargetBitmap:(PoCoBitmap *)dbmp
     withSourceBitmap:(PoCoBitmap *)sbmp
             withMask:(PoCoBitmap *)msk
           withMatrix:(const unsigned char *)mtx
{
    DPRINT((@"[PoCoEditBitmapColorReplace initBitmap]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = sbmp;
        self->dstBitmap_ = dbmp;
        self->mask_ = msk;
        self->matrix_ = mtx;
        [self->srcBitmap_ retain];
        [self->dstBitmap_ retain];
        [self->mask_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_ : Խ(instance ѿ)
//    dstBitmap_ : Խоݲ(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditBitmapColorReplace dealloc]\n"));

    // 񸻤β
    [self->srcBitmap_ retain];
    [self->dstBitmap_ retain];
    [self->mask_ retain];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;
    self->mask_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_ : Խ(instance ѿ)
//    mask_      : ޥ(instance ѿ)
//    matrix_    : ִɽ(instance ѿ)
//
//  Return
//    dstBitmap_ : Խоݲ(instance ѿ)
//
-(void)execute
{
    const int bw = [self->srcBitmap_ width];
    const int mw = [self->mask_ width];
    const int brow = (bw + (bw & 0x01));
    const int mrow = (mw + (mw & 0x01));
    const int bskip = (brow - bw);
    const int mskip = (mrow - mw);
    int x;
    int y;
    unsigned char *dbmp = [self->dstBitmap_ pixelmap];
    const unsigned char *sbmp = [self->srcBitmap_ pixelmap];
    const unsigned char *mbmp = [self->mask_ pixelmap];

    DPRINT((@"[PoCoEditBitmapColorReplace execute]\n"));

    // ľ
    y = [self->srcBitmap_ height];
    do {
        // ʿ
        x = bw;
        do {
            // 
            if (*(mbmp) == 0x00) {
                // ϰϤˤʤ
                ;
            } else if (self->matrix_[*(sbmp)] == *(sbmp)) {
                // ѹʤ
                *(dbmp) = *(sbmp);
            } else {
                // οǾ(ä˥ѥåȤ°ˤͤʤ)
                *(dbmp) = self->matrix_[*(sbmp)];
            }

            // 
            (x)--;
            (sbmp)++;
            (dbmp)++;
            (mbmp)++;
        } while (x != 0);

        // 
        (y)--;
        sbmp += bskip;
        dbmp += bskip;
        mbmp += mskip;
    } while (y != 0);

    return;
}

@end
