//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - Ǥΰ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditRegionFill.h"

// ============================================================================
@implementation PoCoEditRegionFill

// --------------------------------------------------------- instance - private
//
// оΰ򻻽
//  half-open property Τᡢ +1 
//
//  Call
//    s       : 
//    e       : 
//    bitmap_ : о( instance ѿ)
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcRect:(PoCoPoint *)s
                  end:(PoCoPoint *)e
{
    PoCoRect *r;

    r = [[PoCoRect alloc] init];
    if ([s x] < [e x]) {
        [r setLeft:MAX(0, [s x])];
        [r setRight:MIN([e x] + 1, [self->bitmap_ width])];
    } else {
        [r setLeft:MAX(0, [e x])];
        [r setRight:MIN([s x] + 1, [self->bitmap_ width])];
    }
    if ([s y] < [e y]) {
        [r setTop:MAX(0, [s y])];
        [r setBottom:MIN([e y] + 1, [self->bitmap_ height])];
    } else {
        [r setTop:MAX(0, [e y])];
        [r setBottom:MIN([s y] + 1, [self->bitmap_ height])];
    }

    return r;
}


//
// ޥڤ
//
//  Call
//    mask : ޥ
//    s    : 
//    e    : 
//    r    : оΰ
//
//  Return
//    function : ޥ
//
-(PoCoBitmap *)truncMask:(PoCoBitmap *)mask
            withStartPos:(PoCoPoint *)s
              withEndPos:(PoCoPoint *)e
                withRect:(PoCoRect *)r
{
    PoCoBitmap *pat;
    PoCoRect *mr;

    if (([mask width] == [r width]) && ([mask height] == [r height])) {
        // (getBitmap Ǻ餺 pointer ʣ̤ˤʤΤ retain)
        pat = mask;
        [pat retain];
    } else {
        // ʬ
        mr = [[PoCoRect alloc] init];
        if ([r left] == 0) {
            [mr setLeft:-(MIN([s x], [e x]))];
        }
        if ([r top] == 0) {
            [mr setTop:-(MIN([s y], [e y]))];
        }
        [mr setRight:[mr left] + [r width]];
        [mr setBottom:[mr top] + [r height]];
        pat = [mask getBitmap:mr];
        [mr release];
    }

    return pat;
}


//
// ѥȷޥ
//
//  Call
//    style : ޥ
//    tile  : ѥ
//
//  Return
//    style : ޥ
//
-(void)andStyleMask:(PoCoBitmap *)style
    withTilePattern:(PoCoBitmap *)tile
{
    unsigned int size;
    unsigned char *stylePixel;
    unsigned char *tilePixel;

    size = [style width];
    size += (size & 1);
    size *= [style height];
    stylePixel = [style pixelmap];
    tilePixel = [tile pixelmap];

    do {
        // ѤȤ
        *(stylePixel) = (*(stylePixel) & *(tilePixel));

        // 
        (size)--;
        (stylePixel)++;
        (tilePixel)++;
    } while (size != 0);

    return;
}


//
// ¹
//
//  Call
//    r            : ΰ
//    maskBitmap   : ޥ
//    bitmap_      : о( instance ѿ)
//    palette_     : ѥѥå( instance ѿ)
//    colorBitmap_ : ѥ顼ѥ( instance ѿ)
//    colorRow_    : colpat rowbytes( instance ѿ)
//    bitmapRow_   : bitmap rowbytes( instance ѿ)
//    dist_        : оݤξɤǧ(instance ѿ)
//
//  Return
//    bitmap_ : о( instance ѿ)
//
-(void)draw:(PoCoRect *)r
   withMask:(PoCoBitmap *)maskBitmap
{
    unsigned int x;                     // X ѻ
    unsigned int y;                     // Y ѻ
    unsigned int maskRow;               // ޥ row bytes
    unsigned char *bitmapPixel;         // оݲ pixelmap
    unsigned char *colorPixel;          // 顼ѥ pixelmap
    unsigned char *maskPixel;           // ѥ pixelmap
    unsigned int bitmapSkip;            // оݤμ skip
    unsigned int colorSkip;             // 顼ѥμ skip
    unsigned int maskSkip;              // ѥμ skip
    const unsigned int areaWidth = [r width];

    // ޥ rowbytes 
    maskRow = [maskBitmap width];
    maskRow += (maskRow & 1);

    // Ƽ pixelmap μ
    bitmapPixel = [self->bitmap_ pixelmap] + (([r top] * self->bitmapRow_) + [r left]);
    colorPixel = [self->colorBitmap_ pixelmap];
    maskPixel  = [maskBitmap pixelmap];

    // skip ͤλ
    bitmapSkip = (self->bitmapRow_ - areaWidth);
    colorSkip = (self->colorRow_ - areaWidth);
    maskSkip = (maskRow - areaWidth);

    // 
    y = [r height];
    do {
        x = areaWidth;
        do {
            if (*(maskPixel) == 0) {
                // ϰϳ
                ;
            } else if ((self->dist_) &&
                       ([[self->palette_ palette:*(bitmapPixel)] isMask])) {
                // ɤػ
                ;
            } else if ([[self->palette_ palette:*(colorPixel)] noDropper]) {
                // Ѷػ
                ;
            } else {
                // 
                *(bitmapPixel) = *(colorPixel);
            }

            // 
            (x)--;
            (maskPixel)++;
            (colorPixel)++;
            (bitmapPixel)++;
        } while (x != 0);

        // 
        (y)--;
        maskPixel += maskSkip;
        colorPixel += colorSkip;
        bitmapPixel += bitmapSkip;
    } while (y != 0);

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    plt  : ѥѥå
//    tile : ѥѥ
//    pat  : ѥ顼ѥ
//    dist : оݤξɤǧ
//
//  Return
//    function : 
//    dist_    : оݤξɤǧ(instance ѿ)
//
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
           checkDist:(BOOL)dist
{
//    DPRINT((@"[PoCoEditRegionFill initWithPattern]\n"));

    // super class ν
    self = [super initWithPattern:bmp
                          palette:plt
                              pen:nil
                             tile:tile
                          pattern:pat];

    // Ȥν
    if (self != nil) {
        self->dist_ = dist;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditRegionFill dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    mask        : ޥ
//    s           : 
//    e           : 
//    bitmap_     : о( instance ѿ)
//    tileBitmap_ : ѥ bitmap( instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw:(PoCoBitmap *)mask
      withStartPos:(PoCoPoint *)s
        withEndPos:(PoCoPoint *)e
{
    PoCoRect *r;
    PoCoBitmap *maskBitmap;

    // оΰλ
    r = [self calcRect:s end:e];
    if (([r left] >= [self->bitmap_ width]) || ([r right] < 0) ||
        ([r top] >= [self->bitmap_ height]) || ([r bottom] < 0)) {
        ;
    } else {
        // ѥ(Ǽ)
        [super beginDraw:r];

        // ޥڤȴ
        maskBitmap = [self truncMask:mask
                        withStartPos:s
                          withEndPos:e
                            withRect:r];

        // ѥȷޥ
        [self andStyleMask:maskBitmap
           withTilePattern:self->tileBitmap_];

        // 
        [self draw:r
          withMask:maskBitmap];

        // ޥ
        [maskBitmap release];

        // ѥ(Ǽʬ)
        [super endDraw];
    }
    [r release];

    return;
}

@end
