//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - 
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditResizeBitmap.h"

// ============================================================================
@implementation PoCoEditResizeBitmap

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dbmp : 
//    sbmp : ܸ
//
//  Return
//    function   : 
//    srcBitmap_ : ܸ(instance ؿ)
//    dstBitmap_ : (instance ؿ)
//
-(id)initDst:(PoCoBitmap *)dbmp
     withSrc:(PoCoBitmap *)sbmp
{
    DPRINT((@"[PoCoEditResizeBitmap initDst withSrc]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = sbmp;
        self->dstBitmap_ = dbmp;
        [self->srcBitmap_ retain];
        [self->dstBitmap_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_ : ܸ(instance ؿ)
//    dstBitmap_ : (instance ؿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditResizeBitmap dealloc]\n"));

    // 񸻤β
    [self->dstBitmap_ release];
    [self->srcBitmap_ release];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_ : ܸ(instance ؿ)
//    dstBitmap_ : (instance ؿ)
//
//  Return
//    dstBitmap_ : (instance ؿ)
//
-(void)executeResize
{
    int dx;                    // ʿ()
    int dy;                    // ľ()
    const int dw = [self->dstBitmap_  width];
    const int dh = [self->dstBitmap_ height];
    const int dskip = (dw & 0x01);
    long long sx;                    // ʿ(ܸ)
    long long sy;                    // ľ(ܸ)
    const long long sw = ([self->srcBitmap_  width] << 10);
    const long long sh = ([self->srcBitmap_ height] << 10);
    const long long srow = ((sw + (sw & (0x01 << 10))) >> 10);
    const long long hstep = (sw / (long long)(dw));
    const long long vstep = (sh / (long long)(dh));
    unsigned char *sp = [self->srcBitmap_ pixelmap];
    unsigned char *dp = [self->dstBitmap_ pixelmap];

    DPRINT((@"[PoCoEditResizeBitmap executeResize]\n"));

    // ľ
    sy = 0;
    dy = dh;
    do {
        // ʿ
        sx = 0;
        dx = dw;
        do {
            // ܸλȰ֤򻻽Ф
            *(dp) = sp[(((sy >> 10) * srow) + (sx >> 10))];

            // 
            if (sx < sw) {
                sx += hstep;
                if (sx > sw) {
                    sx = sw;
                }
            }
            (dx)--;
            (dp)++;
        } while (dx != 0);

        // 
        if (sy < sh) {
            sy += vstep;
            if (sy > sh) {
                sy = sh;
            }
        }
        (dy)--;
        dp += dskip;
    } while (dy != 0);

    return;
}

@end




// ============================================================================
@implementation PoCoEditResizeBitmapDouble

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dbmp1 : 1
//    dbmp2 : 2
//    sbmp1 : ܸ1
//    sbmp2 : ܸ2
//
//  Return
//    function     : 
//    srcBitmap_[] : ܸ(instance ؿ)
//    dstBitmap_[] : (instance ؿ)
//
-(id)initDst1:(PoCoBitmap *)dbmp1
     withDst2:(PoCoBitmap *)dbmp2
     withSrc1:(PoCoBitmap *)sbmp1
     withSrc2:(PoCoBitmap *)sbmp2
{
    DPRINT((@"[PoCoEditResizeBitmapDouble initDst withSrc]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_[0] = sbmp1;
        self->srcBitmap_[1] = sbmp2;
        self->dstBitmap_[0] = dbmp1;
        self->dstBitmap_[1] = dbmp2;
        [self->srcBitmap_[0] retain];
        [self->srcBitmap_[1] retain];
        [self->dstBitmap_[0] retain];
        [self->dstBitmap_[1] retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_[] : ܸ(instance ؿ)
//    dstBitmap_[] : (instance ؿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditResizeBitmapDouble dealloc]\n"));

    // 񸻤β
    [self->dstBitmap_[0] release];
    [self->dstBitmap_[1] release];
    [self->srcBitmap_[0] release];
    [self->srcBitmap_[1] release];
    self->srcBitmap_[0] = nil;
    self->srcBitmap_[1] = nil;
    self->dstBitmap_[0] = nil;
    self->dstBitmap_[1] = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_[] : ܸ(instance ؿ)
//    dstBitmap_[] : (instance ؿ)
//
//  Return
//    dstBitmap_[] : (instance ؿ)
//
-(void)executeResize
{
    long long i;
    int dx;                    // ʿ()
    int dy;                    // ľ()
    const int dw = [self->dstBitmap_[0]  width];
    const int dh = [self->dstBitmap_[0] height];
    const int dskip = (dw & 0x01);
    long long sx;                    // ʿ(ܸ)
    long long sy;                    // ľ(ܸ)
    const long long sw = ([self->srcBitmap_[0]  width] << 10);
    const long long sh = ([self->srcBitmap_[0] height] << 10);
    const long long srow = ((sw + (sw & (0x01 << 10))) >> 10);
    const long long hstep = (sw / (long long)(dw));
    const long long vstep = (sh / (long long)(dh));
    unsigned char *sp1 = [self->srcBitmap_[0] pixelmap];
    unsigned char *sp2 = [self->srcBitmap_[1] pixelmap];
    unsigned char *dp1 = [self->dstBitmap_[0] pixelmap];
    unsigned char *dp2 = [self->dstBitmap_[1] pixelmap];

    DPRINT((@"[PoCoEditResizeBitmap executeResize]\n"));

    // ľ
    sy = 0;
    dy = dh;
    do {
        // ʿ
        sx = 0;
        dx = dw;
        do {
            // ܸλȰ֤򻻽Ф
            i = (((sy >> 10) * srow) + (sx >> 10));
            *(dp1) = sp1[i];
            *(dp2) = sp2[i];

            // 
            if (sx < sw) {
                sx += hstep;
                if (sx > sw) {
                    sx = sw;
                }
            }
            (dx)--;
            (dp1)++;
            (dp2)++;
        } while (dx != 0);

        // 
        if (sy < sh) {
            sy += vstep;
            if (sy > sh) {
                sy = sh;
            }
        }
        (dy)--;
        dp1 += dskip;
        dp2 += dskip;
    } while (dy != 0);

    return;
}

@end
