//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ǤճѲž
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditRotateBitmap.h"

// =========================================================== PoCoRotateThread

// ------------------------------------------------------------------ interface
@interface PoCoRotateThread : NSObject
{
    unsigned char *sp_;                 // ž
    unsigned char *dp_;                 // ž
    PoCoRect *srcRect_;                 // žϰ
    PoCoRect *dstRect_;                 // žϰ
    long long sp_x_;                    // žɸ(X)
    long long sp_y_;                    // žɸ(Y)
    long long diff_x_;                  // žư(X)
    long long diff_y_;                  // žư(Y)
    int srcRowBytes_;                   // ž row bytes
}

// initialize
-(id)initDst:(unsigned char *)dp
     withSrc:(unsigned char *)sp
     dstRect:(PoCoRect *)dr
     srcRect:(PoCoRect *)sr
   srcPointX:(long long)sp_x
   srcPointY:(long long)sp_y
    srcDiffX:(long long)diff_x
    srcDiffY:(long long)diff_y
 srcRowBytes:(int)srow;

// deallocate
-(void)dealloc;

// ¹
-(void)execute;

@end


// ------------------------------------------------------------------ implement
@implementation PoCoRotateThread

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    sp     : ž
//    dp     : ž
//    sr     : žϰ
//    dr     : žϰ
//    sp_x   : žɸ(X)
//    sp_y   : žɸ(Y)
//    diff_x : žư(X)
//    diff_y : žư(Y)
//    srow   : ž row bytes
//
//  Return
//    sp_          : ž(instance ѿ)
//    dp_          : ž(instance ѿ)
//    srcRect_     : žϰ(instance ѿ)
//    dstRect_     : žϰ(instance ѿ)
//    sp_x_        : žɸ(X)(instance ѿ)
//    sp_y_        : žɸ(Y)(instance ѿ)
//    diff_x_      : žư(X)(instance ѿ)
//    diff_y_      : žư(Y)(instance ѿ)
//    srcRowBytes_ : ž row bytes(instance ѿ)
//
-(id)initDst:(unsigned char *)dp
     withSrc:(unsigned char *)sp
     dstRect:(PoCoRect *)dr
     srcRect:(PoCoRect *)sr
   srcPointX:(long long)sp_x
   srcPointY:(long long)sp_y
    srcDiffX:(long long)diff_x
    srcDiffY:(long long)diff_y
 srcRowBytes:(int)srow
{
    DPRINT((@"[PoCoRotateThread init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->sp_ = sp;
        self->dp_ = dp;
        self->srcRect_ = sr;
        self->dstRect_ = dr;
        self->sp_x_ = sp_x;
        self->sp_y_ = sp_y;
        self->diff_x_ = diff_x;
        self->diff_y_ = diff_y;
        self->srcRowBytes_ = srow;

        [self->srcRect_ retain];
        [self->dstRect_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcRect_ : žϰ(instance ѿ)
//    dstRect_ : žϰ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoRotateThreadDouble dealloc]\n"));

    // 񸻤
    [self->srcRect_ release];
    [self->dstRect_ release];
    self->srcRect_ = nil;
    self->dstRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    sp_          : ž(instance ѿ)
//    dp_          : ž(instance ѿ)
//    srcRect_     : žϰ(instance ѿ)
//    dstRect_     : žϰ(instance ѿ)
//    sp_x_        : žɸ(X)(instance ѿ)
//    sp_y_        : žɸ(Y)(instance ѿ)
//    diff_x_      : žư(X)(instance ѿ)
//    diff_y_      : žư(Y)(instance ѿ)
//    srcRowBytes_ : ž row bytes(instance ѿ)
//
//  Return
//    dp_    : ž(instance ѿ)
//    sp_x_  : žɸ(X)(instance ѿ)
//    sp_y_  : žɸ(Y)(instance ѿ)
//
-(void)execute
{
    int i;
    int dx;
    int x;
    int y;
    BOOL draw;

    DPRINT((@"[PoCoRotateThread execute]\n"));

    draw = NO;
    for (dx = [self->dstRect_ left]; dx <= [self->dstRect_ right]; (dx)++) {
        // žλȰ֤򻻽
#if 0
        x = (int)((self->sp_x_ + 512) >> 10);
        y = (int)((self->sp_y_ + 512) >> 10);
#else   // 0
        x = (int)((self->sp_x_ + 512) / 1024);
        y = (int)((self->sp_y_ + 512) / 1024);
#endif  // 0
        if (([self->srcRect_ left] <= x) && (x <= [self->srcRect_  right]) &&
            ([self->srcRect_  top] <= y) && (y <= [self->srcRect_ bottom])) {
            x -= ([self->srcRect_ left]);
            y -= ([self->srcRect_ top]);
            i = ((y * self->srcRowBytes_) + x);
            *(self->dp_) = self->sp_[i];
            draw = YES;
        } else if (draw) {
            // ٤Ǥ褷ʤϰϳȴȤˤʤ
            break;
        }

        // 
        (self->dp_)++;
        self->sp_x_ += self->diff_x_;
        self->sp_y_ += self->diff_y_;
    }

    // ȴ
    [NSThread exit];

    return;
}

@end




// ===================================================== PoCoRotateThreadDouble

// ------------------------------------------------------------------ interface
@interface PoCoRotateThreadDouble : NSObject
{
    unsigned char *sp1_;                // ž1
    unsigned char *sp2_;                // ž2
    unsigned char *dp1_;                // ž1
    unsigned char *dp2_;                // ž2
    PoCoRect *srcRect_;                 // žϰ
    PoCoRect *dstRect_;                 // žϰ
    long long sp_x_;                    // žɸ(X)
    long long sp_y_;                    // žɸ(Y)
    long long diff_x_;                  // žư(X)
    long long diff_y_;                  // žư(Y)
    int srcRowBytes_;                   // ž row bytes
}

// initialize
-(id)initDst1:(unsigned char *)dp1
     withDst2:(unsigned char *)dp2
     withSrc1:(unsigned char *)sp1
     withSrc2:(unsigned char *)sp2
      dstRect:(PoCoRect *)dr
      srcRect:(PoCoRect *)sr
    srcPointX:(long long)sp_x
    srcPointY:(long long)sp_y
     srcDiffX:(long long)diff_x
     srcDiffY:(long long)diff_y
  srcRowBytes:(int)srow;

// deallocate
-(void)dealloc;

// ¹
-(void)execute;

@end


// ------------------------------------------------------------------ implement
@implementation PoCoRotateThreadDouble

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    sp1    : ž1
//    sp2    : ž2
//    dp1    : ž1
//    dp2    : ž2
//    sr     : žϰ
//    dr     : žϰ
//    sp_x   : žɸ(X)
//    sp_y   : žɸ(Y)
//    diff_x : žư(X)
//    diff_y : žư(Y)
//    srow   : ž row bytes
//
//  Return
//    sp1_         : ž1(instance ѿ)
//    sp2_         : ž2(instance ѿ)
//    dp1_         : ž1(instance ѿ)
//    dp2_         : ž2(instance ѿ)
//    srcRect_     : žϰ(instance ѿ)
//    dstRect_     : žϰ(instance ѿ)
//    sp_x_        : žɸ(X)(instance ѿ)
//    sp_y_        : žɸ(Y)(instance ѿ)
//    diff_x_      : žư(X)(instance ѿ)
//    diff_y_      : žư(Y)(instance ѿ)
//    srcRowBytes_ : ž row bytes(instance ѿ)
//
-(id)initDst1:(unsigned char *)dp1
     withDst2:(unsigned char *)dp2
     withSrc1:(unsigned char *)sp1
     withSrc2:(unsigned char *)sp2
      dstRect:(PoCoRect *)dr
      srcRect:(PoCoRect *)sr
    srcPointX:(long long)sp_x
    srcPointY:(long long)sp_y
     srcDiffX:(long long)diff_x
     srcDiffY:(long long)diff_y
  srcRowBytes:(int)srow
{
    DPRINT((@"[PoCoRotateThreadDouble init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->sp1_ = sp1;
        self->sp2_ = sp2;
        self->dp1_ = dp1;
        self->dp2_ = dp2;
        self->srcRect_ = sr;
        self->dstRect_ = dr;
        self->sp_x_ = sp_x;
        self->sp_y_ = sp_y;
        self->diff_x_ = diff_x;
        self->diff_y_ = diff_y;
        self->srcRowBytes_ = srow;

        [self->srcRect_ retain];
        [self->dstRect_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcRect_ : žϰ(instance ѿ)
//    dstRect_ : žϰ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoRotateThreadDouble dealloc]\n"));

    // 񸻤
    [self->srcRect_ release];
    [self->dstRect_ release];
    self->srcRect_ = nil;
    self->dstRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    sp1_         : ž1(instance ѿ)
//    sp2_         : ž2(instance ѿ)
//    dp1_         : ž1(instance ѿ)
//    dp2_         : ž2(instance ѿ)
//    srcRect_     : žϰ(instance ѿ)
//    dstRect_     : žϰ(instance ѿ)
//    sp_x_        : žɸ(X)(instance ѿ)
//    sp_y_        : žɸ(Y)(instance ѿ)
//    diff_x_      : žư(X)(instance ѿ)
//    diff_y_      : žư(Y)(instance ѿ)
//    srcRowBytes_ : ž row bytes(instance ѿ)
//
//  Return
//    dp1_   : ž1(instance ѿ)
//    dp2_   : ž2(instance ѿ)
//    sp_x_  : žɸ(X)(instance ѿ)
//    sp_y_  : žɸ(Y)(instance ѿ)
//
-(void)execute
{
    int i;
    int dx;
    int x;
    int y;
    BOOL draw;

    DPRINT((@"[PoCoRotateThreadDouble execute]\n"));

    draw = NO;
    for (dx = [self->dstRect_ left]; dx <= [self->dstRect_ right]; (dx)++) {
        // žλȰ֤򻻽
#if 0
        x = (int)((self->sp_x_ + 512) >> 10);
        y = (int)((self->sp_y_ + 512) >> 10);
#else   // 0
        x = (int)((self->sp_x_ + 512) / 1024);
        y = (int)((self->sp_y_ + 512) / 1024);
#endif  // 0
        if (([self->srcRect_ left] <= x) && (x <= [self->srcRect_  right]) &&
            ([self->srcRect_  top] <= y) && (y <= [self->srcRect_ bottom])) {
            x -= ([self->srcRect_ left]);
            y -= ([self->srcRect_ top]);
            i = ((y * self->srcRowBytes_) + x);
            *(self->dp1_) = self->sp1_[i];
            *(self->dp2_) = self->sp2_[i];
            draw = YES;
        } else if (draw) {
            // ٤Ǥ褷ʤϰϳȴȤˤʤ
            break;
        }

        // 
        (self->dp1_)++;
        (self->dp2_)++;
        self->sp_x_ += self->diff_x_;
        self->sp_y_ += self->diff_y_;
    }

    // ȴ
    [NSThread exit];

    return;
}

@end




// ============================================================================
@implementation PoCoEditRotateBitmap

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dbmp : ž
//    sbmp : ž
//    dr   : žϰ
//    sr   : žϰ
//    rot  : žؿ
//
//  Return
//    function   : 
//    srcBitmap_ : ž(instance ؿ)
//    dstBitmap_ : ž(instance ؿ)
//    srcRect_   : žϰ(instance ؿ)
//    dstRect_   : žϰ(instance ؿ)
//    rotate_    : žؿ(instance ѿ)
//
-(id)initDst:(PoCoBitmap *)dbmp
     withSrc:(PoCoBitmap *)sbmp
     dstRect:(PoCoRect *)dr
     srcRect:(PoCoRect *)sr
 withRotater:(PoCoCalcRotation *)rot
{
    DPRINT((@"[PoCoEditRotateBitmap initDst withSrc]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = sbmp;
        self->dstBitmap_ = dbmp;
        self->srcRect_ = sr;
        self->dstRect_ = dr;
        self->rotate_ = rot;
        [self->srcBitmap_ retain];
        [self->dstBitmap_ retain];
        [self->srcRect_ retain];
        [self->dstRect_ retain];
        [self->rotate_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_ : ž(instance ؿ)
//    dstBitmap_ : ž(instance ؿ)
//    srcRect_   : žϰ(instance ؿ)
//    dstRect_   : žϰ(instance ؿ)
//    rotate_    : žؿ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditRotateBitmap dealloc]\n"));

    // 񸻤β
    [self->srcBitmap_ release];
    [self->dstBitmap_ release];
    [self->srcRect_ release];
    [self->dstRect_ release];
    [self->rotate_ release];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;
    self->srcRect_ = nil;
    self->dstRect_ = nil;
    self->rotate_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_ : ž(instance ؿ)
//    dstBitmap_ : ž(instance ؿ)
//    srcRect_   : žϰ(instance ؿ)
//    dstRect_   : žϰ(instance ؿ)
//    rotate_    : žؿ(instance ѿ)
//
//  Return
//    dstBitmap_ : ž(instance ؿ)
//
-(void)executeRotate
#if 1   // thread 
{
    int l;
    int cnt;
    BOOL flag;
    unsigned char *sp;
    unsigned char *dp;
    int srow = ([self->srcBitmap_ width] + ([self->srcBitmap_ width] & 0x01));
    int drow = ([self->dstBitmap_ width] + ([self->dstBitmap_ width] & 0x01));
    double x;
    double y;
    long long op_x;
    long long op_y;
    long long diff[4];
    id *scan;
    id *thread;

    scan = NULL;
    thread = NULL;
    sp = [self->srcBitmap_ pixelmap];
    dp = [self->dstBitmap_ pixelmap];

    // ž褫žκ帶
    x = (double)([self->dstRect_ left]);
    y = (double)([self->dstRect_ top]);
    [self->rotate_ recalcPointHori:&(x)
                           andVert:&(y)];
    op_x = (long long)(x * 1024.0);
    op_y = (long long)(y * 1024.0);

    // ̤
    [self->rotate_ diffInt:&(diff[0])];

    // 񸻤
    cnt = (([self->dstRect_ bottom] - [self->dstRect_ top]) + 1);
    scan = (id *)(calloc(cnt, sizeof(id)));
    thread = (id *)(calloc(cnt, sizeof(id)));
    if ((scan == NULL) || (thread == NULL)) {
        goto EXIT;
    }

    // žľ(ľ򤹤٤ thread ˤ)
    for (l = 0; l < cnt; (l)++) {
        // žʿ
        scan[l] = [[PoCoRotateThread alloc] initDst:dp
                                            withSrc:sp
                                            dstRect:self->dstRect_
                                            srcRect:self->srcRect_
                                          srcPointX:op_x
                                          srcPointY:op_y
                                           srcDiffX:diff[0]
                                           srcDiffY:diff[1]
                                        srcRowBytes:srow];
        thread[l] = [[NSThread alloc] initWithTarget:scan[l]
                                            selector:@selector(execute)
                                              object:nil];
        [thread[l] start];

        // 
        dp += drow;
        op_x += diff[2];
        op_y += diff[3];
    }

    // ٤Ƥ thread ΤԤ
    [NSThread sleepForTimeInterval:0.001];
    do {
        flag = NO;
        for (l = 0; l < cnt; (l)++) {
            if (thread[l] == nil) {
                // ˽äƤ
                ;
            } else if ([thread[l] isFinished]) {
                // λΤǲ
                [thread[l] release];
                [scan[l] release];
                thread[l] = nil;
                scan[l] = nil;
            } else {
                // ¹
                flag = YES;
            }
        }
        [NSThread sleepForTimeInterval:0.001];
    } while (flag);

EXIT:
    if (scan != NULL) {
        free(scan);
    }
    if (thread != NULL) {
        free(thread);
    }
    return;
}
#endif  // 1
#if 0   // 黻ʿ­Τ
{
    PoCoPoint *p;
    int dx;                             // ʿ(ž)
    int dy;                             // ľ(ž)
    unsigned char *sp;
    unsigned char *dp;
    int srow = ([self->srcBitmap_ width] + ([self->srcBitmap_ width] & 0x01));
    int dskip = ([self->dstBitmap_ width] & 0x01);
    double x;
    double y;
    long long op_x;
    long long op_y;
    long long sp_x;
    long long sp_y;
    long long diff[4];

    sp = [self->srcBitmap_ pixelmap];
    dp = [self->dstBitmap_ pixelmap];

    // ž褫žκ帶
    x = (double)([self->dstRect_ left]);
    y = (double)([self->dstRect_ top]);
    [self->rotate_ recalcPointHori:&(x)
                           andVert:&(y)];
    op_x = (long long)(x * 1024.0);
    op_y = (long long)(y * 1024.0);

    // ̤
    [self->rotate_ diffInt:&(diff[0])];

    // žľ
    p = [[PoCoPoint alloc] init];
    for (dy = [self->dstRect_ top]; dy <= [self->dstRect_ bottom]; (dy)++) {
        // žʿ
        sp_x = op_x;
        sp_y = op_y;
        for (dx = [self->dstRect_ left]; dx <= [self->dstRect_ right]; (dx)++) {
            // žλȰ֤򻻽
#if 0
            [p setX:(int)((sp_x + 512) >> 10)
               setY:(int)((sp_y + 512) >> 10)];
#else   // 0
            [p setX:(int)((sp_x + 512) / 1024)
               setY:(int)((sp_y + 512) / 1024)];
#endif  // 0
            if (([self->srcRect_ left] <= [p x]) &&
                ([self->srcRect_ top] <= [p y]) &&
                ([p x] <= [self->srcRect_ right]) &&
                ([p y] <= [self->srcRect_ bottom])) {
                [p moveX:-([self->srcRect_ left])
                   moveY:-([self->srcRect_ top])];
                *(dp) = sp[(([p y] * srow) + [p x])];
            }

            // 
            (dp)++;
            sp_x += diff[0];
            sp_y += diff[1];
        }

        // 
        dp += dskip;
        op_x += diff[2];
        op_y += diff[3];
    }
    [p release];

    return;
}
#endif  // 0
#if 0   // 
{
    PoCoPoint *p;
    int dx;                             // ʿ(ž)
    int dy;                             // ľ(ž)
    unsigned char *sp;
    unsigned char *dp;
    int srow = ([self->srcBitmap_ width] + ([self->srcBitmap_ width] & 0x01));
    int dskip = ([self->dstBitmap_ width] & 0x01);

    sp = [self->srcBitmap_ pixelmap];
    dp = [self->dstBitmap_ pixelmap];

    // žľ
    p = [[PoCoPoint alloc] init];
    for (dy = [self->dstRect_ top]; dy <= [self->dstRect_ bottom]; (dy)++) {
        // žʿ
        for (dx = [self->dstRect_ left]; dx <= [self->dstRect_ right]; (dx)++) {
            // žλȰ֤򻻽
            [p setX:dx
               setY:dy];
            [self->rotate_ recalcPoint:p];
            if (([self->srcRect_ left] <= [p x]) &&
                ([self->srcRect_ top] <= [p y]) &&
                ([p x] <= [self->srcRect_ right]) &&
                ([p y] <= [self->srcRect_ bottom])) {
                [p moveX:-([self->srcRect_ left])
                   moveY:-([self->srcRect_ top])];
                *(dp) = sp[(([p y] * srow) + [p x])];
            }

            // 
            (dp)++;
        }

        // 
        dp += dskip;
    }
    [p release];
#if 0
{
    int x;
    int y;
    unsigned char *p;

    printf("================================\n");
    printf("----------------\n");
    printf("width : %d, height: %d\n", [self->srcBitmap_ width], [self->srcBitmap_ height]);
    for (y = 0; y < [self->srcBitmap_ height]; (y)++) {
        p  = [self->srcBitmap_ pixelmap];
        p += (y * ([self->srcBitmap_ width] + ([self->srcBitmap_ width] & 0x01)));
        for (x = 0; x < [self->srcBitmap_ width]; (x)++) {
            printf("%c", ((*(p) != 0x00) ? '1' : '0'));
            (p)++;
        }
        printf("\n");
    }

    printf("----------------\n");
    printf("width : %d, height: %d\n", [self->dstBitmap_ width], [self->dstBitmap_ height]);
    for (y = 0; y < [self->dstBitmap_ height]; (y)++) {
        p  = [self->dstBitmap_ pixelmap];
        p += (y * ([self->dstBitmap_ width] + ([self->dstBitmap_ width] & 0x01)));
        for (x = 0; x < [self->dstBitmap_ width]; (x)++) {
            printf("%c", ((*(p) != 0x00) ? '1' : '0'));
            (p)++;
        }
        printf("\n");
    }
}
#endif  // 0

    return;
}
#endif  // 0

@end




// ============================================================================
@implementation PoCoEditRotateBitmapDouble

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dbmp1 : ž1
//    dbmp2 : ž2
//    sbmp1 : ž1
//    sbmp2 : ž2
//    dr    : žϰ
//    sr    : žϰ
//    rot   : žؿ
//
//  Return
//    function     : 
//    srcBitmap_[] : ž(instance ؿ)
//    dstBitmap_[] : ž(instance ؿ)
//    srcRect_     : žϰ(instance ؿ)
//    dstRect_     : žϰ(instance ؿ)
//    rotate_      : žؿ(instance ѿ)
//
-(id)initDst1:(PoCoBitmap *)dbmp1
     withDst2:(PoCoBitmap *)dbmp2
     withSrc1:(PoCoBitmap *)sbmp1
     withSrc2:(PoCoBitmap *)sbmp2
     dstRect:(PoCoRect *)dr
     srcRect:(PoCoRect *)sr
 withRotater:(PoCoCalcRotation *)rot
{
    DPRINT((@"[PoCoEditRotateBitmapDouble initDst withSrc]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_[0] = sbmp1;
        self->srcBitmap_[1] = sbmp2;
        self->dstBitmap_[0] = dbmp1;
        self->dstBitmap_[1] = dbmp2;
        self->srcRect_ = sr;
        self->dstRect_ = dr;
        self->rotate_ = rot;
        [self->srcBitmap_[0] retain];
        [self->srcBitmap_[1] retain];
        [self->dstBitmap_[0] retain];
        [self->dstBitmap_[1] retain];
        [self->srcRect_ retain];
        [self->dstRect_ retain];
        [self->rotate_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_[] : ž(instance ؿ)
//    dstBitmap_[] : ž(instance ؿ)
//    srcRect_     : žϰ(instance ؿ)
//    dstRect_     : žϰ(instance ؿ)
//    rotate_      : žؿ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditRotateBitmapDouble dealloc]\n"));

    // 񸻤β
    [self->srcBitmap_[0] release];
    [self->srcBitmap_[1] release];
    [self->dstBitmap_[0] release];
    [self->dstBitmap_[1] release];
    [self->srcRect_ release];
    [self->dstRect_ release];
    [self->rotate_ release];
    self->srcBitmap_[0] = nil;
    self->srcBitmap_[1] = nil;
    self->dstBitmap_[0] = nil;
    self->dstBitmap_[1] = nil;
    self->srcRect_ = nil;
    self->dstRect_ = nil;
    self->rotate_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    srcBitmap_[] : ž(instance ؿ)
//    dstBitmap_[] : ž(instance ؿ)
//    srcRect_     : žϰ(instance ؿ)
//    dstRect_     : žϰ(instance ؿ)
//    rotate_      : žؿ(instance ѿ)
//
//  Return
//    dstBitmap_ : ž(instance ؿ)
//
-(void)executeRotate
{
    int l;
    int cnt;
    BOOL flag;
    unsigned char *sp1;
    unsigned char *sp2;
    unsigned char *dp1;
    unsigned char *dp2;
    int srow = ([self->srcBitmap_[0] width] + ([self->srcBitmap_[0] width] & 0x01));
    int drow = ([self->dstBitmap_[0] width] + ([self->dstBitmap_[0] width] & 0x01));
    double x;
    double y;
    long long op_x;
    long long op_y;
    long long diff[4];
    id *scan;
    id *thread;

    scan = NULL;
    thread = NULL;
    sp1 = [self->srcBitmap_[0] pixelmap];
    sp2 = [self->srcBitmap_[1] pixelmap];
    dp1 = [self->dstBitmap_[0] pixelmap];
    dp2 = [self->dstBitmap_[1] pixelmap];

    // ž褫žκ帶
    x = (double)([self->dstRect_ left]);
    y = (double)([self->dstRect_ top]);
    [self->rotate_ recalcPointHori:&(x)
                           andVert:&(y)];
    op_x = (long long)(x * 1024.0);
    op_y = (long long)(y * 1024.0);

    // ̤
    [self->rotate_ diffInt:&(diff[0])];

    // 񸻤
    cnt = (([self->dstRect_ bottom] - [self->dstRect_ top]) + 1);
    scan = (id *)(calloc(cnt, sizeof(id)));
    thread = (id *)(calloc(cnt, sizeof(id)));
    if ((scan == NULL) || (thread == NULL)) {
        goto EXIT;
    }

    // žľ(ľ򤹤٤ thread ˤ)
    for (l = 0; l < cnt; (l)++) {
        // žʿ
        scan[l] = [[PoCoRotateThreadDouble alloc] initDst1:dp1
                                                  withDst2:dp2
                                                  withSrc1:sp1
                                                  withSrc2:sp2
                                                   dstRect:self->dstRect_
                                                   srcRect:self->srcRect_
                                                 srcPointX:op_x
                                                 srcPointY:op_y
                                                  srcDiffX:diff[0]
                                                  srcDiffY:diff[1]
                                               srcRowBytes:srow];
        thread[l] = [[NSThread alloc] initWithTarget:scan[l]
                                            selector:@selector(execute)
                                              object:nil];
        [thread[l] start];

        // 
        dp1 += drow;
        dp2 += drow;
        op_x += diff[2];
        op_y += diff[3];
    }

    // ٤Ƥ thread ΤԤ
    [NSThread sleepForTimeInterval:0.001];
    do {
        flag = NO;
        for (l = 0; l < cnt; (l)++) {
            if (thread[l] == nil) {
                // ˽äƤ
                ;
            } else if ([thread[l] isFinished]) {
                // λΤǲ
                [thread[l] release];
                [scan[l] release];
                thread[l] = nil;
                scan[l] = nil;
            } else {
                // ¹
                flag = YES;
            }
        }
        [NSThread sleepForTimeInterval:0.001];
    } while (flag);

EXIT:
    if (scan != NULL) {
        free(scan);
    }
    if (thread != NULL) {
        free(thread);
    }
    return;
}

@end
