//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ɸ - 
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditNormalBase.h"

// ============================================================================
@implementation PoCoEditNormalBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    plt  : ѥѥå
//    pen  : ѥڥ
//    tile : ѥѥ
//    pat  : ѥ顼ѥ
//
//  Return
//    function      : 
//    bitmap_       : о bitmap(instance ѿ)
//    palette_      : ѥѥå(instance ѿ)
//    penPattern_   : ѥڥ(instance ѿ)
//    tilePattern_  : ѥѥ(instance ѿ)
//    colorPattern_ : ѥ顼ѥ(instance ѿ)
//    tileBitmap_   : ѥ(instance ѿ)
//    colorBitmap_  : 顼ѥ(instance ѿ)
//    tileRow_      : ѥ rowbytes(instance ѿ)
//    colorRow_     : 顼ѥ rowbytes(instance ѿ)
//    bitmapRow_    : оݤ rowbytes(instance ѿ)
//    drawLeftTop_  : ϰϤκ(instance ѿ)
//
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                 pen:(PoCoMonochromePattern *)pen
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
{
//    DPRINT((@"[PoCoEditNormalBase initWithPattern]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->palette_ = plt;
        self->penPattern_ = pen;
        self->tilePattern_ = tile;
        self->colorPattern_ = pat;
        self->tileBitmap_ = nil;
        self->colorBitmap_ = nil;
        self->tileRow_ = 0;
        self->colorRow_ = 0;
        self->bitmapRow_ = 0;
        self->drawLeftTop_ = nil;

        // 줾 retain
        [self->bitmap_ retain];
        [self->palette_ retain];
        [self->penPattern_ retain];
        [self->tilePattern_ retain];
        [self->colorPattern_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_       : о bitmap(instance ѿ)
//    palette_      : ѥѥå(instance ѿ)
//    penPattern_   : ѥڥ(instance ѿ)
//    tilePattern_  : ѥѥ(instance ѿ)
//    colorPattern_ : ѥ顼ѥ(instance ѿ)
//    tileBitmap_   : ѥ(instance ѿ)
//    colorBitmap_  : 顼ѥ(instance ѿ)
//    drawLeftTop_  : ϰϤκ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditNormalBase dealloc]\n"));

    // 񸻤β
    [self->bitmap_ release];
    [self->palette_ release];
    [self->penPattern_ release];
    [self->tilePattern_ release];
    [self->colorPattern_ release];
    [self->tileBitmap_ release];
    [self->colorBitmap_ release];
    [self->drawLeftTop_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;
    self->penPattern_ = nil;
    self->tilePattern_ = nil;
    self->colorPattern_ = nil;
    self->tileBitmap_ = nil;
    self->colorBitmap_ = nil;
    self->drawLeftTop_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//  1
//
//  Call
//    pnt           : 濴
//    bitmap_       : о bitmap(instance ѿ)
//    palette_      : ѥѥå(instance ѿ)
//    penPattern_   : ѥڥ(instance ѿ)
//    tilePattern_  : ѥѥ(instance ѿ)
//    colorPattern_ : ѥ顼ѥ(instance ѿ)
//
//  Return
//    bitmap_ : о bitmap(instance ѿ)
//
-(void)drawPoint:(PoCoPoint *)pnt
{
    unsigned int x;                     // X ѻ
    unsigned int y;                     // Y ѻ
    unsigned int ty;                    // ѥ Y ѻ
    unsigned int cy;                    // 顼ѥ Y ѻ
    unsigned int px;                    // ڥ X ѻ
    unsigned int py;                    // ڥ Y ѻ
    unsigned int ti;                    // ѥ
    unsigned int pi;                    // ڥ
    unsigned int ci;                    // 顼ѥ
    unsigned int di;                    // оݤ
    unsigned int trow;                  // ѥ rowbytes
    unsigned int crow;                  // 顼ѥ rowbytes
    unsigned int row;                   // оݤ rowbytes
    unsigned char *pixmap;              // оݲ pixelmap
    PoCoRect *r;                        // ϰ(ڥ礭ʬޤ)
    PoCoBitmap *tile;                   // ϰϤ˹碌ѥ
    PoCoBitmap *col;                    // ϰϤ˹碌顼ѥ
    unsigned char *tilePat;             // ѥ pixelmap
    unsigned char *colPat;              // 顼ѥ pixelmap
    unsigned char *penPat;              // ڥ pixelmap

//    DPRINT((@"[PoCoEditNormalBase drawPoint]\n"));

    r = nil;
    tile = nil;
    col = nil;

    // оΰλ
    r = [[PoCoRect alloc] init];
    [r setLeft:([pnt x] - (PEN_STYLE_SIZE >> 1))];
    [r setTop:([pnt y] - (PEN_STYLE_SIZE >> 1))];
    [r setRight:MIN([pnt x] + (PEN_STYLE_SIZE >> 1), [self->bitmap_ width])];
    [r setBottom:MIN([pnt y] + (PEN_STYLE_SIZE >> 1), [self->bitmap_ height])];
    if (([r left] >= [self->bitmap_ width]) || ([r right] < 0) ||
        ([r top] >= [self->bitmap_ height]) || ([r bottom] < 0)) {
        goto EXIT;
    }
    if ([r left] < 0) {
        px = -[r left];
        [r setLeft:0];
    } else {
        px = 0;
    }
    if ([r top] < 0) {
        py = -[r top];
        [r setTop:0];
    } else {
        py = 0;
    }
    if ([r empty]) {
        goto EXIT;
    }

    // ƥѥ pixelmap μ
    tile = [self->tilePattern_ getPixelmap:r];
    col = [self->colorPattern_ pixelmap:r];
    penPat = (unsigned char *)([self->penPattern_ pattern]);
    tilePat = [tile pixelmap];
    colPat = [col pixelmap];
    trow = ([tile width] + ([tile width] & 1));
    crow = ([col width] + ([col width] & 1));

    // μ¹
    ty = 0;
    cy = 0;
    row = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));
    pixmap = [self->bitmap_ pixelmap];
    for (y = [r top]; y < [r bottom]; (y)++, (ty)++, (py)++, (cy)++) {
        ti = (ty * trow);
        pi = ((py * PEN_STYLE_SIZE) + px);
        ci = (cy * crow);
        di = ((y * row) + [r left]);
        for (x = [r left]; x < [r right]; (x)++, (ti)++, (pi)++, (ci)++, (di)++) {
            if (tilePat[ti] == 0) {
                // ѥоݳ
                ;
            } else if (penPat[pi] == 0) {
                // ڥоݳ
                ;
            } else if ([[self->palette_ palette:pixmap[di]] isMask]) {
                // оݤɤػ
                ;
            } else if ([[self->palette_ palette:colPat[ci]] noDropper]) {
                // Ѷػ(ۤػ)
                ;
            } else {
                // ¹
                pixmap[di] = colPat[ci];
            }
        }
    }

EXIT:
    [r release];
    [tile release];
    [col release];
    return;
}


//
// 賫
//
//  Call
//    r             : ΰ
//    bitmap_       : о bitmap(instance ѿ)
//    tilePattern_  : ѥѥ(instance ѿ)
//    colorPattern_ : ѥ顼ѥ(instance ѿ)
//
//  Return
//    tileBitmap_  : ѥ bitmap(instance ѿ)
//    colorBitmap_ : 顼ѥ bitmap(instance ѿ)
//    tileRow_     : ѥ rowbytes(instance ѿ)
//    colorRow_    : 顼ѥ rowbytes(instance ѿ)
//    bitmapRow_   : оݤ rowbytes(instance ѿ)
//    drawLeftTop_ : ϰϤκ(instance ѿ)
//
-(void)beginDraw:(PoCoRect *)r
{
    // ѥ
    self->tileBitmap_ = [self->tilePattern_ getPixelmap:r];
    self->colorBitmap_ = [self->colorPattern_ pixelmap:r];

    // row bytes 򻻽
    self->tileRow_ = ([self->tileBitmap_ width] + ([self->tileBitmap_ width] & 1));
    self->colorRow_ = ([self->colorBitmap_ width] + ([self->colorBitmap_ width] & 1));
    self->bitmapRow_ = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));

    // lefttop 򵭲
    self->drawLeftTop_ = [[PoCoPoint alloc] initX:[r left] initY:[r top]];

    return;
}


//
// 轪λ
//
//  Call
//    None
//
//  Return
//    tileBitmap_  : ѥ bitmap(instance ѿ)
//    colorBitmap_ : 顼ѥ bitmap(instance ѿ)
//    drawLeftTop_ : ϰϤκ(instance ѿ)
//
-(void)endDraw
{
    // ѥ˴
    [self->tileBitmap_ release];
    [self->colorBitmap_ release];
    [self->drawLeftTop_ release];
    self->tileBitmap_ = nil;
    self->colorBitmap_ = nil;
    self->drawLeftTop_ = nil;

    return;
}


//
// 
//  Ϣ³褹硢賫ϤƤ֤
//
//  Call
//    pnt          : 濴
//    bitmap_      : о bitmap(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    penPattern_  : ѥڥ(instance ѿ)
//    tileBitmap_  : ѥ(instance ѿ)
//    colorBitmap_ : 顼ѥ(instance ѿ)
//    tileRow_     : tilepat rowbytes(instance ѿ)
//    colorRow_    : colpat rowbytes (instance ѿ)
//    bitmapRow_   : bitmap rowbytes (instance ѿ)
//    drawLeftTop_ : ϰϤκ(instance ѿ)
//
//  Return
//    bitmap_ : о bitmap(instance ѿ)
//
-(void)drawPoint2:(PoCoPoint *)pnt
{
    unsigned int x;                     // X ѻ
    unsigned int y;                     // Y ѻ
    unsigned int px;                    // ڥ X ѻ
    unsigned int py;                    // ڥ Y ѻ
    unsigned char *pixmap;              // оݲ pixelmap
    PoCoRect *r;                        // ϰ(ڥ礭ʬޤ)
    unsigned char *tilePat;             // ѥ pixelmap
    unsigned char *colPat;              // 顼ѥ pixelmap
    unsigned char *penPat;              // ڥ pixelmap
    unsigned int tileSkip;              // ѥμ skip
    unsigned int penSkip;               // ڥμ skip
    unsigned int colSkip;               // 顼ѥμ skip
    unsigned int pixSkip;               // оݤμ skip
    unsigned int areaWidth;

//    DPRINT((@"[PoCoEditNormalBase drawPoint2]\n"));

    r = nil;

    // оΰλ
    r = [[PoCoRect alloc] init];
    [r setLeft:([pnt x] - (PEN_STYLE_SIZE >> 1))];
    [r setTop:([pnt y] - (PEN_STYLE_SIZE >> 1))];
    [r setRight:MIN([pnt x] + (PEN_STYLE_SIZE >> 1), [self->bitmap_ width])];
    [r setBottom:MIN([pnt y] + (PEN_STYLE_SIZE >> 1), [self->bitmap_ height])];
    if (([r left] >= [self->bitmap_ width]) || ([r right] < 0) ||
        ([r top] >= [self->bitmap_ height]) || ([r bottom] < 0)) {
        goto EXIT;
    }
    if ([r left] < 0) {
        px = -[r left];
        [r setLeft:0];
    } else {
        px = 0;
    }
    if ([r top] < 0) {
        py = -[r top];
        [r setTop:0];
    } else {
        py = 0;
    }
    if ([r empty]) {
        goto EXIT;
    }

    // Ƽ pixelmap Ƭ
    tilePat = [self->tileBitmap_ pixelmap] + ((([r top] - [self->drawLeftTop_ y]) * self->tileRow_) + ([r left] - [self->drawLeftTop_ x]));
    penPat = (unsigned char *)([self->penPattern_ pattern]) + ((py * PEN_STYLE_SIZE) + px);
    colPat = [self->colorBitmap_ pixelmap] + ((([r top] - [self->drawLeftTop_ y]) * self->colorRow_) + ([r left] - [self->drawLeftTop_ x]));
    pixmap = [self->bitmap_ pixelmap] + (([r top] * self->bitmapRow_) + [r left]);

    // skip ͤλ
    areaWidth = [r width];
    tileSkip = (self->tileRow_ - areaWidth);
    penSkip = (PEN_STYLE_SIZE - areaWidth);
    colSkip = (self->colorRow_ - areaWidth);
    pixSkip = (self->bitmapRow_ - areaWidth);

    // μ¹
    y = [r height];
    do {
        x = areaWidth;
        do {
            if (*(tilePat) == 0) {
                // ѥоݳ
                ;
            } else if (*(penPat) == 0) {
                // ڥоݳ
                ;
            } else if ([[self->palette_ palette:*(pixmap)] isMask]) {
                // оݤɤػ
                ;
            } else if ([[self->palette_ palette:*(colPat)] noDropper]) {
                // Ѷػ(ۤػ)
                ;
            } else {
                // ¹
                *(pixmap) = *(colPat);
            }

            // 
            (x)--;
            (tilePat)++;
            (penPat)++;
            (colPat)++;
            (pixmap)++;
        } while (x != 0);

        // 
        (y)--;
        tilePat += tileSkip;
        penPat += penSkip;
        colPat += colSkip;
        pixmap += pixSkip;
    } while (y != 0);

EXIT:
    [r release];
    return;
}

@end
