//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ɸ - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditNormalDrawLine.h"

// ============================================================================
@implementation PoCoEditNormalDrawLine

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    plt  : ѥѥå
//    pen  : ѥڥ
//    tile : ѥѥ
//    pat  : ѥ顼ѥ
//
//  Return
//    function  : 
//    points_   : (instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                 pen:(PoCoMonochromePattern *)pen
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
{
//    DPRINT((@"[PoCoEditNormalDrawLine initWithPattern]\n"));

    // super class ν
    self = [super initWithPattern:bmp
                          palette:plt
                              pen:pen
                             tile:tile
                          pattern:pat];

    // Ȥν
    if (self != nil) {
        // ݻ
        self->points_ = [[NSMutableArray alloc] init];
        if (self->points_ == nil) {
            DPRINT((@"can't alloc NSMutableArray\n"));
            [self release];
            self = nil;
            goto EXIT;
        }

        // ΰ
        self->drawRect_ = [[PoCoRect alloc] initLeft:[bmp width]
                                             initTop:[bmp height]
                                           initRight:0
                                          initBottom:0];
        if (self->drawRect_ == nil) {
            DPRINT((@"can't alloc PoCoRect \n"));
            [self release];
            self = nil;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_   : (instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditNormalDrawLine dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->points_ release];
    [self->drawRect_ release];
    self->points_ = nil;
    self->drawRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Ͽ
//
//  Call
//    p       : Ͽ
//    bitmap_ : о bitmap( instance ѿ)
//
//  Return
//    points_   : (instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)addPoint:(PoCoPoint *)p
{
    PoCoPoint *tmp;

    // Ͽ(ʣȤ)
    tmp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    [self->points_ addObject:tmp];
    [tmp release];

    // ΰ򹹿
    if (([p x] - (PEN_STYLE_SIZE >> 1)) < [self->drawRect_ left]) {
        [self->drawRect_ setLeft:MAX(([p x] - (PEN_STYLE_SIZE >> 1)), 0)];
    }
    if (([p x] + (PEN_STYLE_SIZE >> 1)) > [self->drawRect_ right]) {
        [self->drawRect_ setRight:MIN([p x] + (PEN_STYLE_SIZE >> 1), [self->bitmap_ width])];
    }
    if (([p y] - (PEN_STYLE_SIZE >> 1)) < [self->drawRect_ top]) {
        [self->drawRect_ setTop:MAX(([p y] - (PEN_STYLE_SIZE >> 1)), 0)];
    }
    if (([p y] + (PEN_STYLE_SIZE >> 1)) > [self->drawRect_ bottom]) {
        [self->drawRect_ setBottom:MIN([p y] + (PEN_STYLE_SIZE >> 1),[self->bitmap_ height])];
    }

    return;
}


//
// ¹
//
//  Call
//    points_   : (instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw
{
    NSEnumerator *iter;
    int i;
    int e;                              // 
    int ax;                             // ʿ
    int ay;                             // ľ
    int dx;                             // ʿʬ
    int dy;                             // ľʬ
    int sx;                             // ʿ
    int sy;                             // ľ
    PoCoPoint *dp;
    PoCoPoint *p1;
    PoCoPoint *p2;

    // 賫
    [super beginDraw:self->drawRect_];

    // 
    iter = [self->points_ objectEnumerator];
    p1 = [iter nextObject];
    for (p2 = [iter nextObject]; p2 != nil; p2 = [iter nextObject]) {
        // ʿͤλ
        dx = [p2 x] - [p1 x];
        if (dx < 0) {
            sx = -1;
            dx = -dx;
        } else {
            sx = 1;
        }
        ax = (dx << 1);

        // ľͤλ
        dy = [p2 y] - [p1 y];
        if (dy < 0) {
            sy = -1;
            dy = -(dy);
        } else {
            sy = 1;
        }
        ay = (dy << 1);

        // 
        if ((dx == 0) && (dy == 0)) {
            // Ʊ
            ;
        } else if (dx == 0) {
            // ľ
            for (dp = p1; !([dp isEqualPos:p2]); [dp moveY:sy]) {
                [super drawPoint2:dp];
            }
        } else if (dy == 0) {
            // ʿ
            for (dp = p1; !([dp isEqualPos:p2]); [dp moveX:sx]) {
                [super drawPoint2:dp];
            }
        } else if (dx < dy) {
            // Ǥ(ľ̤礭)
            dp = p1;
            e = -dy;
            for (i = 0; i < dy; (i)++) {
                [super drawPoint2:dp];

                // ΰư
                e += ax;
                [dp moveY:sy];
                if (e >= 0) {
                    [dp moveX:sx];
                    e -= ay;
                }
            }
        } else {
            // Ǥ(ʿ̤礭)
            dp = p1;
            e = -(dx);
            for (i = 0; i < dx; (i)++) {
                [super drawPoint2:dp];

                // ΰư
                e += ay;
                [dp moveX:sx];
                if (e >= 0) {
                    [dp moveY:sy];
                    e -= ax;
                }
            }
        }
        [super drawPoint2:p2];

        // ʣ
        p1 = p2;
    }

    // 轪λ
    [super endDraw];

    return;
}

@end
