//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ɸ - ɤĤ֤
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoEditNormalPaint.h"

// ======================================================= PoCoPaintPointBuffer

// ------------------------------------------------------------------ interface
@interface PoCoPaintPointBuffer : NSObject
{
    int left_;                          // ü
    int right_;                         // ü
    int vert_;                          // ľ
    int prev_;                          // οľ
}

// initialize
-(id)initWithVert:(int)v
         withPrev:(int)pv;

// deallocate
-(void)dealloc;

// 
-(void)setLeft:(int)l;                  // ü
-(void)setRight:(int)r;                 // ü

// 
-(int)left;                             // ü
-(int)right;                            // ü
-(int)vert;                             // ľ
-(int)prev;                             // οľ

@end


// ------------------------------------------------------------------ implement
@implementation PoCoPaintPointBuffer

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    v  : ľ
//    pv : οľ
//
//  Return
//    function : 
//    left_    : ü(instance ѿ)
//    right_   : ü(instance ѿ)
//    vert_    : ľ(instance ѿ)
//    prev_    : οľ(instance ѿ)
//
-(id)initWithVert:(int)v
         withPrev:(int)pv
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->left_ = 0;
        self->right_ = 0;
        self->vert_ = v;
        self->prev_ = pv;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ü
//
//  Call
//    l : ü
//
//  Return
//    left_ : ü(instance ѿ)
//
-(void)setLeft:(int)l
{
    self->left_ = l;

    return;
}


//
// ü
//
//  Call
//    r : ü
//
//  Return
//    right_ : ü(instance ѿ)
//
-(void)setRight:(int)r
{
    self->right_ = r;

    return;
}


//
// ü
//
//  Call
//    left : ü(instance ѿ)
//
//  Return
//    function : ü
//
-(int)left
{
    return self->left_;
}


//
// ü
//
//  Call
//    right_ : ü(instance ѿ)
//
//  Return
//    function : ü
//
-(int)right
{
    return self->right_;
}


//
// ľ֤
//
//  Call
//    vert_ : ľ(instance ѿ)
//
//  Return
//    function : ľ
//
-(int)vert
{
    return self->vert_;
}


//
// οľ֤
//
//  Call
//    prev_ : οľ(instance ѿ)
//
//  Return
//    function : οľ
//
-(int)prev
{
    return self->prev_;
}

@end




// ============================================================================
@implementation PoCoEditNormalPaint

// --------------------------------------------------------- instance - private
//
// ƿꥹȤ
//
//  Call
//    palette_ : ѥå(instanceѿ)
//    range_   : ϰ(instance ѿ)
//    baseCol_ : ࿧(instance ѿ)
//
//  Return
//    acceptable_[] : ƿ(instance ѿ)
//
-(void)createAcceptableTable
{
    int idx;
    int border;

    //  NO ˤ
    memset(self->acceptable_, 0x00, (COLOR_MAX * sizeof(BOOL)));

    // ʤȤ⼫Ȥϵ
    self->acceptable_[self->baseCol_] = YES;

    // Ȥ¦εϰϤ
    border = MAX(0, (self->baseCol_ - self->range_));
    for (idx = (self->baseCol_ - 1); idx >= border; (idx)--) {
        // ɤػ߿ĶƤϵϰϤˤʤ
        if ([[self->palette_ palette:idx] isMask]) {
            break;
        }

        // ƿˤ
        self->acceptable_[idx] = YES;
    }

    // Ȥ¦εϰϤ
    border = MIN(COLOR_MAX, (self->baseCol_ + self->range_));
    for (idx = (self->baseCol_ + 1); idx <= border; (idx)++) {
        // ɤػ߿ĶƤϵϰϤˤʤ
        if ([[self->palette_ palette:idx] isMask]) {
            break;
        }

        // ƿˤ
        self->acceptable_[idx] = YES;
    }

    return;
}


//
// 1饤
//
//  Call
//    c             : õ(self->acceptable_[] ѤΤǤΰԻ)
//    l             : ü
//    r             : ü
//    v             : ľ
//    pv            : οľ
//    bitmap_       : о bitmap( instance ѿ)
//    acceptable_[] : ƿ(instance ѿ)
//
//  Return
//    points_ : (instance ѿ)
//
-(void)scanLine:(unsigned char)c
           left:(int)l
          right:(int)r
              v:(int)v
             pv:(int)pv
{
    unsigned int row;
    unsigned char *pixelmap;
    PoCoPaintPointBuffer *pos;

    // pixelmap ε
    row = [self->bitmap_ width];
    row += (row & 1);
    pixelmap = [self->bitmap_ pixelmap] + (row * v);

    // 
    while (l <= r) {
        // Хåե
        pos = [[PoCoPaintPointBuffer alloc] initWithVert:v
                                                withPrev:pv];

        // üõ
#if 0
        for ( ; (l < r) && (!(self->acceptable_[pixelmap[l]])); (l)++) { }
#else   // 0
        for ( ; l < r; (l)++) {
            if (self->acceptable_[pixelmap[l]]) {
                break;
            }
        }
#endif  // 0
        if (!(self->acceptable_[pixelmap[l]])) {
            [pos release];
            break;
        }
        [pos setLeft:l];

        // üõ
#if 0
        for ( ; (l <= r) && (self->acceptable_[pixelmap[l]]); (l)++) { }
#else   // 0
        for ( ; l <= r; (l)++) {
            if (!(self->acceptable_[pixelmap[l]])) {
                break;
            }
        }
#endif  // 0
        [pos setRight:(l - 1)];

        // ɸϿ
        [self->points_ addObject:pos];
        [pos release];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    plt  : ѥѥå
//    tile : ѥѥ
//    pat  : ѥ顼ѥ
//    rng  : ϰ
//
//  Return
//    function      : 
//    drect_        : ϰ(instance ѿ)
//    points_       : (instance ѿ)
//    mask_         : Ѥߥޥ(instance ѿ)
//    range_        : ϰ(instance ѿ)
//    baseCol_      : ࿧(instance ѿ)
//    acceptable_[] : ƿ(instance ѿ)
//
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
               range:(int)rng
{
//    DPRINT((@"[PoCoEditNormalPaint initWithPattern]\n"));

    // super class ν
    self = [super initWithPattern:bmp
                          palette:plt
                              pen:nil
                             tile:tile
                          pattern:pat];

    // Ȥν
    if (self != nil) {
        self->mask_ = nil;
        self->points_ = nil;
        self->drect_ = nil;
        self->range_ = rng;
        self->baseCol_ = 0;
        memset(self->acceptable_, 0x00, (COLOR_MAX * sizeof(BOOL)));

        // 񸻳
        self->points_ = [[NSMutableArray alloc] init];
        self->drect_ = [[PoCoRect alloc] initLeft:[bmp width]
                                          initTop:[bmp height]
                                        initRight:0
                                       initBottom:0];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    drect_  : ϰ(instance ѿ)
//    points_ : (instance ѿ)
//    mask_   : Ѥߥޥ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditNormalPaint dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->points_ release];
    [self->drect_ release];
    [self->mask_ release];
    self->points_ = nil;
    self->drect_ = nil;
    self->mask_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ϰϤ
//
//  Call
//    drect_ : ϰ(instance ѿ)
//
//  Return
//    function : ϰ
//
-(PoCoRect *)drect
{
    return self->drect_;
}


//
// Ѥߥޥ
//
//  Call
//    mask_ : Ѥߥޥ(instance ѿ)
//
//  Return
//    function : Ѥߥޥ
//
-(PoCoBitmap *)mask
{
    return self->mask_;
}


//
// ¹
//
//  Call
//    p             : 
//    bitmap_       : о bitmap(instanceѿ)
//    palette_      : ѥå(instanceѿ)
//    tilePattern_  : ѥ(instanceѿ)
//    colorPattern_ : 顼ѥ(instanceѿ)
//    points_       : (instance ѿ)
//    range_        : ϰ(instance ѿ)
//
//  Return
//    bitmap_  : о bitmap( instance ѿ)
//    drect_   : ϰ(instance ѿ)
//    points_  : (instance ѿ)
//    mask_    : Ѥߥޥ(instance ѿ)
//    baseCol_ : ࿧(instance ѿ)
//
-(void)executeDraw:(PoCoPoint *)p
{
    unsigned char c;                    // ο
    int l;                              // ü
    int r;                              // ü
    int h;                              // ϰϤ(ʿΤ)
    int v;                              // ľ
    unsigned int row;                   // row bytes
    unsigned int vJump;                 // ľ֤ޤǤ
    unsigned char *pixelmap;            // оݤ pixelmap
    unsigned char *maskmap;             // Ѥߥޥ pixelmap
    PoCoBitmap *tile;                   // ϰϤ˹碌ѥ
    unsigned char *tilePat;             // ѥ pixelmap
    PoCoBitmap *col;                    // ϰϤ˹碌顼ѥ
    unsigned char *colPat;              // 顼ѥ pixelmap
    PoCoRect *dr;                       // ϰ()
    PoCoPaintPointBuffer *pos;          // ɸХåե
    const int width = ([self->bitmap_ width] - 1);

    // Ͽ
    pos = [[PoCoPaintPointBuffer alloc] initWithVert:[p y]
                                            withPrev:[p y]];
    [pos setLeft:[p x]];
    [pos setRight:[p x]];
    [self->points_ addObject:pos];
    [pos release];

    // ѤߤΥޥ
    self->mask_ = [[PoCoBitmap alloc] initWidth:[self->bitmap_ width]
                                     initHeight:[self->bitmap_ height]
                                   defaultColor:0];

    // ѥμ
    dr = [[PoCoRect alloc] initLeft:0
                            initTop:0
                          initRight:[self->bitmap_ width]
                         initBottom:[self->bitmap_ height]];
    tile = [self->tilePattern_ getPixelmap:dr];
    col = [self->colorPattern_ pixelmap:dr];
    [dr release];

    // row bytes 
    row = [self->bitmap_ width];
    row += (row & 1);

    // ο
    c = *([self->bitmap_ pixelmap] + (([p y] * row) + [p x]));
    self->baseCol_ = (int)(c);

    // ƿꥹȤ
    [self createAcceptableTable];

    // 
    do {
        // ɸ
        pos = [self->points_ objectAtIndex:0];
        v = [pos vert];
        vJump = (v * row);

        maskmap = ([self->mask_ pixelmap] + vJump);
        if (maskmap[[pos left]] == 0x00) {
            pixelmap = ([self->bitmap_ pixelmap] + vJump);

            // üõ
            l = [pos left];
            for ( ; (l > 0) && (self->acceptable_[pixelmap[l - 1]]); (l)--) { }

            // üõ
            r = [pos right];
            for ( ; (r < width) && (self->acceptable_[pixelmap[r + 1]]); (r)++) { }

            // ϰϤ򹹿
            if (l < [self->drect_ left]) {
                [self->drect_ setLeft:l];
            }
            if ([self->drect_ right] <= r) {
                [self->drect_ setRight:(r + 1)];
            }
            if (v < [self->drect_ top]) {
                [self->drect_ setTop:v];
            }
            if ([self->drect_ bottom] <= v) {
                [self->drect_ setBottom:(v + 1)];
            }

            // ֤
            tilePat = [tile pixelmap] + vJump;
            colPat = [col pixelmap] + vJump;
            for (h = l; h <= r; h++) {
                if (tilePat[h] == 0) {
                    // ѥоݳ
                    ;
                } else if ([[self->palette_ palette:colPat[h]] noDropper]) {
                    // Ѷػ(ۤػ)
                    ;
                } else if ([[self->palette_ palette:pixelmap[h]] isMask]) {
                    // оݤɤػ
                    ;
                } else {
                    // ¹
                    pixelmap[h] = colPat[h];
                }

                // Ѥߤˤ
                maskmap[h] = 0xff;
            }

            // ιԤ
            v = ([pos vert] - 1);
            if (v >= 0) {
                if ([pos prev] == v) {
                    [self scanLine:c
                              left:l
                             right:([pos left] - 1)
                                 v:v
                                pv:(v + 1)];
                    [self scanLine:c
                              left:([pos right] + 1)
                             right:r
                                 v:v
                                pv:(v + 1)];
                } else {
                    [self scanLine:c
                              left:l
                             right:r
                                 v:v
                                pv:(v + 1)];
                }
            }

            // ιԤ
            v = ([pos vert] + 1);
            if (v < [self->bitmap_ height]) {
                if ([pos prev] == v) {
                    [self scanLine:c
                              left:l
                             right:([pos left] - 1)
                                 v:v
                                pv:(v - 1)];
                    [self scanLine:c
                              left:([pos right] + 1)
                             right:r
                                 v:v
                                pv:(v - 1)];
                } else {
                    [self scanLine:c
                              left:l
                             right:r
                                 v:v
                                pv:(v - 1)];
                }
            }
        }
        [self->points_ removeObjectAtIndex:0];
    } while ([self->points_ count] > 0);
    [tile release];
    [col release];

    return;
}

@end




// ============================================================================
@implementation PoCoEditNormalBorderPaint

// --------------------------------------------------------- instance - private
//
// ƿꥹȤ
//
//  Call
//    border_ : (instance ѿ)
//
//  Return
//    acceptable_[] : ƿ(instance ѿ)
//
-(void)createAcceptableTable
{
    //  YES ˤ
    memset(self->acceptable_, 0xff, (COLOR_MAX * sizeof(BOOL)));

    // Ƥʤ
    self->acceptable_[[self->border_ num]] = NO;

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    plt  : ѥѥå
//    tile : ѥѥ
//    pat  : ѥ顼ѥ
//    bcol : 
//
//  Return
//    function : 
//    border_  : (instance ѿ)
//
-(id)initWithPattern:(PoCoBitmap *)bmp
             palette:(PoCoPalette *)plt
                tile:(PoCoMonochromePattern *)tile
             pattern:(PoCoColorPattern *)pat
              border:(PoCoSelColor *)bcol
{
//    DPRINT((@"[PoCoEditNormalBorderPaint initWithPattern]\n"));

    // super class ν
    self = [super initWithPattern:bmp
                          palette:plt
                             tile:tile
                          pattern:pat
                            range:0];

    // Ȥν
    if (self != nil) {
        self->border_ = bcol;
        [self->border_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    border_ : (instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditNormalBorderPaint dealloc]\n"));

    // 񸻤β
    [self->border_ release];
    self->border_ = nil;

    // super class β
    [super dealloc];

    return;
}


#if 0   // most simple flood fill algorithm as principal, so that no longer use.
//
// ¹
//
//  Call
//    p             : 
//    bitmap_       : о bitmap(instanceѿ)
//    palette_      : ѥå(instanceѿ)
//    tilePattern_  : ѥ(instanceѿ)
//    colorPattern_ : 顼ѥ(instanceѿ)
//    points_       : ( instance ѿ)
//    border_       : (instance ѿ)
//
//  Return
//    bitmap_ : о bitmap( instance ѿ)
//    drect_  : ϰ( instance ѿ)
//    points_ : ( instance ѿ)
//    mask_   : Ѥߥޥ( instance ѿ)
//
-(void)executeDraw:(PoCoPoint *)p
{
    unsigned int row;                   // row bytes
    unsigned int idx;                   // ֤ޤǤ
    unsigned char *pixelmap;            // оݤ pixelmap
    unsigned char *maskmap;             // Ѥߥޥ pixelmap
    PoCoBitmap *tile;                   // ϰϤ˹碌ѥ
    unsigned char *tilePat;             // ѥ pixelmap
    PoCoBitmap *col;                    // ϰϤ˹碌顼ѥ
    unsigned char *colPat;              // 顼ѥ pixelmap
    PoCoRect *dr;                       // ϰ()
    PoCoPoint *pos;                     // ɸ

    // ˥ѥ̤ϻȤʤ
    if (([self->border_ isPattern]) ||
        ([self->border_ isUnder])) {
        goto EXIT;
    }

    // Ͽ
    pos = [[PoCoPoint alloc] initX:[p x]
                             initY:[p y]];
    [self->points_ addObject:pos];
    [pos release];

    // ѤߤΥޥ
    self->mask_ = [[PoCoBitmap alloc] initWidth:[self->bitmap_ width]
                                     initHeight:[self->bitmap_ height]
                                   defaultColor:0];

    // ѥμ
    dr = [[PoCoRect alloc] initLeft:0
                            initTop:0
                          initRight:[self->bitmap_ width]
                         initBottom:[self->bitmap_ height]];
    tile = [self->tilePattern_ getPixelmap:dr];
    col = [self->colorPattern_ pixelmap:dr];
    [dr release];
    maskmap = [self->mask_ pixelmap];
    pixelmap = [self->bitmap_ pixelmap];
    tilePat = [tile pixelmap];
    colPat = [col pixelmap];

    // row bytes 
    row = [self->bitmap_ width];
    row += (row & 1);

    // 
    do {
        // ɸ
        p = [self->points_ objectAtIndex:0];
        if (([p x] >= 0) &&
            ([p y] >= 0) &&
            ([p x] < [self->bitmap_ width]) &&
            ([p y] < [self->bitmap_ height])) {
            idx = (([p y] * row) + [p x]);
            if ((maskmap[idx] == 0x00) &&
                (pixelmap[idx] != [self->border_ num])) {
                // ϰϤ򹹿
                if ([p x] < [self->drect_ left]) {
                    [self->drect_ setLeft:[p x]];
                }
                if ([self->drect_ right] <= [p x]) {
                    [self->drect_ setRight:([p x] + 1)];
                }
                if ([p y] < [self->drect_ top]) {
                    [self->drect_ setTop:[p y]];
                }
                if ([self->drect_ bottom] <= [p y]) {
                    [self->drect_ setBottom:([p y] + 1)];
                }

                // 
                if (tilePat[idx] == 0) {
                    // ѥоݳ
                    ;
                } else if ([[self->palette_ palette:colPat[idx]] noDropper]) {
                    // Ѷػ(ۤػ)
                    ;
                } else if ([[self->palette_ palette:pixelmap[idx]] isMask]) {
                    // оݤɤػ
                    ;
                } else {
                    // ¹
                    pixelmap[idx] = colPat[idx];
                }

                // Ѥߤˤ
                maskmap[idx] = 0xff;

                // 4ɲ
                pos = [[PoCoPoint alloc] initX:([p x] - 1)
                                         initY:([p y]    )];
                [self->points_ addObject:pos];
                [pos release];
                pos = [[PoCoPoint alloc] initX:([p x] + 1)
                                         initY:([p y]    )];
                [self->points_ addObject:pos];
                [pos release];
                pos = [[PoCoPoint alloc] initX:([p x]    )
                                         initY:([p y] - 1)];
                [self->points_ addObject:pos];
                [pos release];
                pos = [[PoCoPoint alloc] initX:([p x]    )
                                         initY:([p y] + 1)];
                [self->points_ addObject:pos];
                [pos release];
            }
        }
        [self->points_ removeObjectAtIndex:0];
    } while ([self->points_ count] > 0);
    [tile release];
    [col release];

EXIT:
    return;
}
#endif  // 0

@end
