//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ɸ - Žդ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditNormalPasteImage.h"

// ============================================================================
@implementation PoCoEditNormalPasteImage

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : о bitmap
//    plt  : ѥå
//    tile : ѥѥ
//    mask : ޥ
//    pst  : Žդ
//
//  Return
//    function     : 
//    maskBitmap_  : ޥ(instance ѿ)
//    pasteBitmap_ : Žդ(instance ѿ)
//
-(id)initWithBitmap:(PoCoBitmap *)bmp
            palette:(PoCoPalette *)plt
               tile:(PoCoMonochromePattern *)tile
               mask:(PoCoBitmap *)mask
        pasteBitmap:(PoCoBitmap *)pst
{
//    DPRINT((@"[PoCoEditNormalPasteImage initWithPattern]\n"));

    // super class ν
    self = [super initWithPattern:bmp
                          palette:plt
                              pen:nil
                             tile:tile
                          pattern:nil];

    // Ȥν
    if (self != nil) {
        self->maskBitmap_ = mask;
        self->pasteBitmap_ = pst;
        [self->maskBitmap_ retain];
        [self->pasteBitmap_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    maskBitmap_  : ޥ(instance ѿ)
//    pasteBitmap_ : Žդ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditNormalPasteImage dealloc]\n"));

    // 񸻤β
    [self->maskBitmap_ release];
    [self->pasteBitmap_ release];
    self->maskBitmap_ = nil;
    self->pasteBitmap_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    pasteRect    : Žդζ
//    bitmap_      : о bitmap( instance ѿ)
//    palette_     : ѥå( instance ѿ)
//    tilePattern_ : ѥ( instance ѿ)
//    maskBitmap_  : ޥ(instance ѿ)
//    pasteBitmap_ : Žդ(instance ѿ)
//
//  Return
//    bitmap_ : о bitmap( instance ѿ)
//
-(void)executeDraw:(PoCoRect *)pasteRect
{
    PoCoRect *r;                        // ϰ
    unsigned int x;                     // X ѻ
    unsigned int y;                     // Y ѻ
    unsigned int px;                    // Žդ X 
    unsigned int py;                    // Žդ Y 
    PoCoBitmap *tpat;                   // ѥ
    unsigned char *dbmp;                // оݲ pixelmap
    unsigned char *pbmp;                // Žդ pixelmap
    unsigned char *tbmp;                // ѥ pixelmap
    unsigned char *mbmp;                // ޥ pixelmap
    int drow;                           // оݲ rowbytes
    int prow;                           // Žդ rowbytes
    int dskip;                          // оݤμ skip
    int pskip;                          // Žդμ skip
    int tskip;                          // ѥμ skip
    int mskip;                          // ޥμ skip
    int w;
    int i;

    r = nil;
    tpat = nil;

    // оΰλ
    r = [[PoCoRect alloc] initLeft:[pasteRect left]
                           initTop:[pasteRect top]
                         initRight:MIN([pasteRect right], [self->bitmap_ width])
                        initBottom:MIN([pasteRect bottom], [self->bitmap_ height])];
    if (([r left]   >= [self->bitmap_ width])  ||
        ([r top]    >= [self->bitmap_ height]) ||
        ([r right]  < 0) ||
        ([r bottom] < 0)) {
        goto EXIT;
    }
    if ([r left] < 0) {
        px = -([r left]);
        [r setLeft:0];
    } else {
        px = 0;
    }
    if ([r top] < 0) {
        py = -([r top]);
        [r setTop:0];
    } else {
        py = 0;
    }
    if ([r empty]) {
        goto EXIT;
    }

    // rowbytes 򻻽
    drow = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));
    prow = ([self->pasteBitmap_ width] + ([self->pasteBitmap_ width] & 1));

    // Ƽ pixelmap Ƭ
    dbmp = ([self->bitmap_ pixelmap] + (([r top] * drow) + [r left]));
    pbmp = [self->pasteBitmap_ pixelmap];
    if (([self->pasteBitmap_ width] == [pasteRect width]) &&
        ([self->pasteBitmap_ height] == [pasteRect height])) {
        pbmp += ((py * prow) + px);
    }

    // skip ͤλ
    w = [r width];
    dskip = (drow - w);
    pskip = (prow - w);

    // ѥ
    if (self->tilePattern_ != nil) {
        tpat = [self->tilePattern_ getPixelmap:r];
        tbmp = [tpat pixelmap];
        i = ([tpat width] + ([tpat width] & 1));
        tskip = (i - w);
    } else {
        tpat = nil;
        tbmp = NULL;
        tskip = 0;
    }

    // ޥ
    if (self->maskBitmap_ != nil) {
        i = ([self->maskBitmap_ width] + ([self->maskBitmap_ width] & 1));
        mbmp = ([self->maskBitmap_ pixelmap] + ((py * i) + px));
        mskip = (i - w);
    } else {
        mbmp = NULL;
        mskip = 0;
    }

    // μ¹
    y = [r height];
    do {
        x = w;
        do {
            if ((tbmp != NULL) && (*(tbmp) == 0)) {
                // ѥоݳ
                ;
            } else if ((mbmp != NULL) && (*(mbmp) == 0)) {
                // ޥоݳ
                ;
            } else if ([[self->palette_ palette:*(dbmp)] isMask]) {
                // оݤɤػ
                ;
            } else if ([[self->palette_ palette:*(pbmp)] noDropper]) {
                // Ѷػ(ۤػ)
                ;
            } else {
                // ¹
                *(dbmp) = *(pbmp);
            }

            // 
            (x)--;
            (dbmp)++;
            (pbmp)++;
            if (tbmp != NULL) {
                (tbmp)++;
            }
            if (mbmp != NULL) {
                (mbmp)++;
            }
        } while (x != 0);

        // 
        (y)--;
        dbmp += dskip;
        pbmp += pskip;
        if (tbmp != NULL) {
            tbmp += tskip;
        }
        if (mbmp != NULL) {
            mbmp += mskip;
        }
    } while (y != 0);

EXIT:
    [r release];
    [tpat release];
    return;
}

@end
