//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - Ȼ - ľ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditRandomDrawLine.h"

#import "PoCoEditRandomFill.h"
#import "PoCoCreateStyleMask.h"

// ============================================================================
@implementation PoCoEditRandomDrawLine

// --------------------------------------------------------- instance - private
//
// 
//
//  Call
//    p            : 濴
//    tile         : ѥ
//    bitmap_      : Խо(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    tilePattern_ : ѥ(instance ѿ)
//    ratio_       : (0.1%ñ)(instance ѿ)
//    range_       : ϰ(instance ѿ)
//
//  Return
//    None
//
-(void)drawPoint:(PoCoPoint *)p
{
    PoCoPoint *p2;
    PoCoRect *drawRect;                 // ͽΰ()
    PoCoRect *trueRect;                 // ΰ(ϰϳޤ)
    PoCoCreateStyleMask *styleMask;     // ޥ
    PoCoEditRandomFill *filler;

    // (˸鱦)
    p2 = [[PoCoPoint alloc] initX:([p x] + self->range_)
                            initY:([p y] + self->range_)];

    // ΰ
    trueRect = [[PoCoRect alloc] initLeft:([p x] - self->range_)
                                  initTop:([p y] - self->range_)
                                initRight:[p2 x]
                               initBottom:[p2 y]];
    drawRect = [[PoCoRect alloc] initLeft:MAX(([p x] - self->range_), 0)
                                  initTop:MAX(([p y] - self->range_), 0)
                                initRight:MIN([p2 x], [self->bitmap_ width])
                               initBottom:MIN([p2 y], [self->bitmap_ height])];

    // (ߤ򵯤Τ nil Ǥ褤)
    styleMask = [[PoCoCreateStyleMask alloc] init];
    if ([styleMask ellipse:p
                       end:p2
               orientation:nil]) {
        // 
        filler = [[PoCoEditRandomFill alloc]
                       init:self->bitmap_
                    palette:self->palette_
                      ratio:self->ratio_
                      range:self->range_];
        [filler executeDraw:[styleMask mask]
                   withTile:self->tilePattern_
               withTrueRect:trueRect
               withDrawRect:drawRect];
        [filler release];
    }
    [styleMask release];
    [p2 release];
    [trueRect release];
    [drawRect release];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp  : Խо
//    plt  : ѥѥå
//    tile : ѥ
//    size : 礭
//
//  Return
//    function     : 
//    bitmap_      : Խо(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    tilePattern_ : ѥ(instance ѿ)
//    points_      : 褹(instance ѿ)
//    ratio_       : (0.1%ñ)(instance ѿ)
//    range_       : ϰ(instance ѿ)
//    drawRect_    : ϰ(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  palette:(PoCoPalette *)plt
     tile:(PoCoMonochromePattern *)tile
    ratio:(int)rat
    range:(int)rng
{
    DPRINT((@"[PoCoEditRandomDrawLine init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->palette_ = plt;
        self->tilePattern_ = tile;
        self->ratio_ = rat;
        self->range_ = rng;

        // 줾 retain Ƥ
        [self->bitmap_ retain];
        [self->palette_ retain];
        [self->tilePattern_ retain];

        // 񸻤γ
        self->points_ = [[NSMutableArray alloc] init];
        self->drawRect_ = [[PoCoRect alloc] initLeft:[self->bitmap_ width]
                                             initTop:[self->bitmap_ height]
                                           initRight:0
                                          initBottom:0];  
        if ((self->points_ == nil) || (self->drawRect_ == nil)) {
            // 
            DPRINT((@"memory allocation error.\n"));
            [self release];
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_      : Խо(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    tilePattern_ : ѥ(instance ѿ)
//    points_      : 褹(instance ѿ)
//    drawRect_    : ϰ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditRandomDrawLine dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->bitmap_ release];
    [self->palette_ release];
    [self->tilePattern_ release];
    [self->points_ release];
    [self->drawRect_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;
    self->tilePattern_ = nil;
    self->points_ = nil;
    self->drawRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Ͽ
//
//  Call
//    p       : Ͽ
//    bitmap_ : Խо(instance ѿ)
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)addPoint:(PoCoPoint *)p
{
    const int sz = (ATOMIZER_TBL_ROW / 2);
    PoCoPoint *tmp;

    tmp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    [self->points_ addObject:tmp];
    [tmp release];

    // ΰ򹹿(+1  half-open property Τ)
    if (([p x] - sz) < [self->drawRect_ left]) {
        [self->drawRect_ setLeft:MAX(([p x] - sz), 0)];
    }
    if (([p y] - sz) < [self->drawRect_ top]) {
        [self->drawRect_ setTop:MAX(([p y] - sz), 0)];
    }
    if (([p x] + sz + 1) > [self->drawRect_ right]) {
        [self->drawRect_ setRight:MIN(([p x] + sz + 1), [self->bitmap_ width])];
    }
    if (([p y] + sz + 1) > [self->drawRect_ bottom]) {  
        [self->drawRect_ setBottom:MIN(([p y] + sz + 1), [self->bitmap_ height])];
    }

    return;
}


//
// 
//
//  Call
//    bitmap_ : Խо(instance ѿ)
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)clearPoint
{
    [self->points_ removeAllObjects];

    // ϰϤ
    [self->drawRect_ setLeft:[self->bitmap_ width]];
    [self->drawRect_ setTop:[self->bitmap_ height]];
    [self->drawRect_ setRight:0];
    [self->drawRect_ setBottom:0];

    return;
}


//
// ¹
//
//  Call
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw
{
    NSEnumerator *iter;                 // points_ ȿ
    PoCoPoint *p1;                      // 
    PoCoPoint *p2;                      // 
    PoCoPoint *dp;                      // (濴)
    int i;                              // ɸ(ʿʤľ)
    int e;                              // 
    int dx;                             // ʿʬ
    int dy;                             // ľʬ
    int sx;                             // ʿ(ˡ1Τ)
    int sy;                             // ľ(ˡ1Τ)
    int ax;                             // ʿ
    int ay;                             // ľ

    // ΰʤ
    if ([self->drawRect_ empty]) {
        goto EXIT;
    }

    // ȿ
    iter = [self->points_ objectEnumerator];
    p1 = [iter nextObject];
    for (p2 = [iter nextObject]; p2 != nil; p2 = [iter nextObject]) {
        dp = p1;

        // Ѱ̻
        dx = abs([p2 x] - [dp x]);
        dy = abs([p2 y] - [dp y]);
        sx = (([p2 x] < [dp x]) ? -1 : 1);
        sy = (([p2 y] < [dp y]) ? -1 : 1);
        ax = (dx << 1);
        ay = (dy << 1);

        // ΰư
        if ((dx == 0) && (dy == 0)) {
            // Ʊ
            [self drawPoint:dp];
        } else if (dx == 0) {
            // ľ
            for ( ; !([dp isEqualPos:p2]); [dp moveY:sy]) {
                [self drawPoint:dp];
            }
        } else if (dy == 0) {
            // ʿ
            for ( ; !([dp isEqualPos:p2]); [dp moveX:sx]) {
                [self drawPoint:dp];
            }  
        } else if (dx < dy) {  
            // Ǥ(ľ̤礭)
            e = -(dy);
            for (i = 0; i < dy; (i)++) {
                [self drawPoint:dp];

                // ΰư
                e += ax;
                [dp moveY:sy];
                if (e >= 0) {
                    [dp moveX:sx];
                    e -= ay;
                }
            }
        } else {
            // Ǥ(ʿ̤礭)
            e = -(dx);
            for (i = 0; i < dx; (i)++) {
                [self drawPoint:dp];

                // ΰư
                e += ay;
                [dp moveX:sx];
                if (e >= 0) {
                    [dp moveY:sy];
                    e -= ax;
                }
            }
        }

        // ʣ
        p1 = p2;
    }

EXIT:
    return;
}

@end
