//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - Ȼ - ΰɤĤ֤
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditRandomFill.h"

#import "PoCoUtil.h"

// ============================================================================
@implementation PoCoEditRandomFill

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp : Խо
//    plt : ѥѥå
//    rat : 
//    rng : ϰ
//
//  Return
//    function : 
//    bitmap_  : Խо(instance ѿ)
//    palette_ : ѥѥå(instance ѿ)
//    ratio_   : (0.1%ñ)(instance ѿ)
//    range_   : ϰ(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  palette:(PoCoPalette *)plt
    ratio:(int)rat
    range:(int)rng
{
    DPRINT((@"[PoCoEditRandomFill init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->palette_ = plt;
        self->ratio_ = rat;
        self->range_ = rng;

        // 줾 retain Ƥ
        [self->bitmap_ retain];
        [self->palette_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_  : Խо(instance ѿ)
//    palette_ : ѥѥå(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditRandomFill dealloc]\n"));

    // 񸻤β
    [self->bitmap_ release];
    [self->palette_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//  ʣư򤱤뤿ˡưϷޥ 0x00 ˤ
//
//  Call
//    mask     : 
//    tile     : ѥ
//    trueRect : ϰ(ϰϳޤ)
//    drawRect : ϰ(ϰΤ)
//    bitmap_  : Խо(instance ѿ)
//    palette_ : ѥѥå(instance ѿ)
//    ratio_   : (0.1%ñ)(instance ѿ)
//    range_   : ϰ(instance ѿ)
//
//  Return
//    mask    : 
//    bitmap_ : Խо(instance ѿ)
//
-(void)executeDraw:(PoCoBitmap *)mask
          withTile:(PoCoMonochromePattern *)tile
      withTrueRect:(PoCoRect *)trueRect
      withDrawRect:(PoCoRect *)drawRect
{
    PoCoBitmap *tileBitmap;             // ѥ(ϰϤĴѤ)
    PoCoRect *tr;
    PoCoRect *dr;
    PoCoRect *rr;
    PoCoPoint *sp;
    PoCoPoint *dp;
    int brow;                           // оݤ rowbyets
    int mrow;                           //  rowbytes
    int trow;                           // ѥ rowbytes
    unsigned char *bbmp;
    unsigned char *mbmp;
    const unsigned char *tbmp;
    int bsidx;
    int bdidx;
    int msidx;
    int mdidx;
    int tsidx;
    int tdidx;

    tr = nil;
    dr = nil;
    tileBitmap = nil;

    // ΰʤ
    if([drawRect empty]){
        goto EXIT;
    }

    // half-open property ˤΤǱ +1
    tr = [[PoCoRect alloc] initLeft:[trueRect left]
                            initTop:[trueRect top]
                          initRight:([trueRect right] + 1)
                         initBottom:([trueRect bottom] + 1)];
    dr = [[PoCoRect alloc] initLeft:[drawRect left]
                            initTop:[drawRect top]
                          initRight:([drawRect right] + 1)
                         initBottom:([drawRect bottom] + 1)];
    if ([self->bitmap_ width] < [dr right]) {
        [dr setRight:[self->bitmap_ width]];
    }
    if ([self->bitmap_ height] < [dr bottom]) {
        [dr setBottom:[self->bitmap_ height]];
    }
    
    // 賫
    tileBitmap = [tile getPixelmap:tr];

    // Ƽͤλ
    brow = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));
    mrow = ([mask width]          + ([mask width]          & 1));
    trow = ([tileBitmap width]    + ([tileBitmap width]    & 1));

    // Ƽѥӥåȥޥåפ
    bbmp = [self->bitmap_ pixelmap];
    mbmp = [mask pixelmap];
    tbmp = [tileBitmap pixelmap];

    // /
    sp = [[PoCoPoint alloc] init];
    dp = [[PoCoPoint alloc] init];
    rr = [[PoCoRect alloc] init];
    for ([sp setY:[tr top]]; [sp y] < [tr bottom]; [sp moveY:1]) {
        for ([sp setX:[tr left]]; [sp x] < [tr right]; [sp moveX:1]) {
            [rr   setLeft:MAX(([sp x] - self->range_    ), [tr   left])];
            [rr    setTop:MAX(([sp y] - self->range_    ), [tr    top])];
            [rr  setRight:MIN(([sp x] + self->range_ - 1), [tr  right])];
            [rr setBottom:MIN(([sp y] + self->range_ - 1), [tr bottom])];
            if (!([rr empty])) {
                [dp setX:[PoCoUtil randomStartRange:[rr left]
                                       withEndRange:[rr right]]];
                [dp setY:[PoCoUtil randomStartRange:[rr top]
                                       withEndRange:[rr bottom]]];
                bsidx = (( [sp y]             * brow) +  [sp x]             );
                bdidx = (( [dp y]             * brow) +  [dp x]             );
                msidx = ((([sp y] - [tr top]) * mrow) + ([sp x] - [tr left]));
                mdidx = ((([dp y] - [tr top]) * mrow) + ([dp x] - [tr left]));
                tsidx = ((([sp y] - [tr top]) * trow) + ([sp x] - [tr left]));
                tdidx = ((([dp y] - [tr top]) * trow) + ([dp x] - [tr left]));
                if ((!([sp isEqualPos:dp])) &&
                    ([dr isPointInRect:sp]) &&
                    ([dr isPointInRect:dp]) &&
                    ([PoCoUtil canDrawFromRatio:self->ratio_]) &&
                    (mbmp[msidx] != 0) &&
                    (tbmp[tsidx] != 0) &&
                    (!([[self->palette_ palette:bbmp[bsidx]] isMask])) &&
                    (!([[self->palette_ palette:bbmp[bsidx]] noDropper])) &&
                    (mbmp[mdidx] != 0) &&
                    (tbmp[tdidx] != 0) &&
                    (!([[self->palette_ palette:bbmp[bdidx]] isMask])) &&
                    (!([[self->palette_ palette:bbmp[bdidx]] noDropper]))) {
                    // ؤ
#if 0
                    bbmp[bsidx] = (bbmp[bsidx] ^ bbmp[bdidx]);
                    bbmp[bdidx] = (bbmp[bdidx] ^ bbmp[bsidx]);
                    bbmp[bsidx] = (bbmp[bsidx] ^ bbmp[bdidx]);
#else   // 0
                    bbmp[bsidx] ^= bbmp[bdidx];
                    bbmp[bdidx] ^= bbmp[bsidx];
                    bbmp[bsidx] ^= bbmp[bdidx];
#endif  // 0

                    // ʣư򤱤뤿˷ޥ 0x00 ˤ
                    mbmp[msidx] = 0x00;
                    mbmp[mdidx] = 0x00;
                }
            }
        }
    }
    [sp release];
    [dp release];
    [rr release];

EXIT:
    [tileBitmap release];
    [tr release];
    [dr release];
    return;
}

@end
