//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - Ѱǻ - ΰɤĤ֤
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditUniformedDensityFill.h"

#import "PoCoColorMixer.h"

// ========================================================== PoCoThreadCounter

// ------------------------------------------------------------------ interface
@interface PoCoThreadCounter : NSObject
{
    int count_;                         // 
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// count
-(void)up;                              // ­
-(void)down;                            // 
-(int)count;                            // 

@end


// ------------------------------------------------------------------ implement
@implementation PoCoThreadCounter

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//    count_   : (instance ѿ)
//
-(id)init
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->count_ = 0;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class β
    [super dealloc];

    return;
}


//
// ­
//
//  Call
//    None
//
//  Return
//    count_ : (instance ѿ)
//
-(void)up
{
    (self->count_)++;

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    count_ : (instance ѿ)
//
-(void)down
{
    (self->count_)--;

    return;
}


//
// 
//
//  Call
//    count_ : (instance ѿ)
//
//  Return
//    function : 
//
-(int)count
{
    return self->count_;
}

@end




// ================================================= PoCoUniformedDensityThread

// ------------------------------------------------------------------ interface
@interface PoCoUniformedDensityThread : NSObject
{
    PoCoPoint *pos_;                    // 
    PoCoRect *trueRect_;                // ϰ(ϰϳޤ)
    PoCoRect *drawRect_;                // ϰ(ϰϳޤ)
    unsigned char *dstBitmap_;          // о
    const unsigned char *patBitmap_;    // 顼ѥ
    const unsigned char *maskBitmap_;   // 
    PoCoColorMode colMode_;             // 黻⡼
    PoCoPalette *palette_;              // ѥѥå
    int density_;                       // (0.1%ñ)
    PoCoColorBuffer *colorBuffer_;      // ݻ
    PoCoThreadCounter *counter_;        // counter
}

// initialize
-(id)initStartPos:(PoCoPoint *)p
     withTrueRect:(PoCoRect *)tr
     withDrawRect:(PoCoRect *)dr
        dstBitmap:(unsigned char *)bbmp
        patBitmap:(const unsigned char *)pbmp
       maskBitmap:(const unsigned char *)mbmp
          colMode:(PoCoColorMode)cmode
          palette:(PoCoPalette *)plt
          density:(int)den
           buffer:(PoCoColorBuffer *)buf
          counter:(PoCoThreadCounter *)cnt;

// deallocate
-(void)dealloc;

// ¹
-(void)execute;

@end


// ------------------------------------------------------------------ implement
@implementation PoCoUniformedDensityThread

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    p     : 
//    trect : ϰ(ϰϳޤ)
//    drect : ϰ(ϰΤ)
//    bbmp  : о
//    pbmp  : 顼ѥ
//    mbmp  : 
//    cmode : 黻⡼
//    plt   : ѥѥå
//    den   : (0.1%ñ)
//    buf   : ݻ
//    cnt   : counter
//
//  Return
//    function     : 
//    pos_         : (instance ѿ)
//    trueRect_    : ϰ(ϰϳޤ)(instance ѿ)
//    drawRect_    : ϰ(ϰΤ)(instance ѿ)
//    dstBitmap_   : о(instance ѿ)
//    patBitmap_   : 顼ѥ(instance ѿ)
//    maskBitmap_  : (instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    density_     : (0.1%ñ)(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//    counter_     : counter(instance ѿ)
//
-(id)initStartPos:(PoCoPoint *)p
     withTrueRect:(PoCoRect *)tr
     withDrawRect:(PoCoRect *)dr
        dstBitmap:(unsigned char *)bbmp
        patBitmap:(const unsigned char *)pbmp
       maskBitmap:(const unsigned char *)mbmp
          colMode:(PoCoColorMode)cmode
          palette:(PoCoPalette *)plt
          density:(int)den
           buffer:(PoCoColorBuffer *)buf
          counter:(PoCoThreadCounter *)cnt
{
    DPRINT((@"[PoCoUniformedDensityThread init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->trueRect_ = tr;
        self->drawRect_ = dr;
        self->dstBitmap_ = bbmp;
        self->patBitmap_ = pbmp;
        self->maskBitmap_ = mbmp;
        self->colMode_ = cmode;
        self->palette_ = plt;
        self->density_ = den;
        self->colorBuffer_ = buf;
        self->counter_ = cnt;

        // ֤ʣ
        self->pos_ = [[PoCoPoint alloc] initX:[p x]
                                        initY:[p y]];

        // 줾 retain Ƥ
        [self->trueRect_ retain];
        [self->drawRect_ retain];
        [self->palette_ retain];
        [self->colorBuffer_ retain];
        [self->counter_ retain];

        // ׿
        [self->counter_ up];
    }

    return self;
}



//
// deallocate
//
//  Call
//    None
//
//  Return
//    pos_         : (instance ѿ)
//    trueRect_    : ϰ(ϰϳޤ)(instance ѿ)
//    drawRect_    : ϰ(ϰΤ)(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//    counter_     : counter(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoUniformedDensityThread dealloc]\n"));

    // 񸻤
    [self->pos_ release];
    [self->trueRect_ release];
    [self->drawRect_ release];
    [self->palette_ release];
    [self->colorBuffer_ release];
    [self->counter_ release];
    self->pos_ = nil;
    self->trueRect_ = nil;
    self->drawRect_ = nil;
    self->palette_ = nil;
    self->colorBuffer_ = nil;
    self->counter_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    pos_         : (instance ѿ)
//    trueRect_    : ϰ(ϰϳޤ)(instance ѿ)
//    drawRect_    : ϰ(ϰΤ)(instance ѿ)
//    dstBitmap_   : о(instance ѿ)
//    patBitmap_   : 顼ѥ(instance ѿ)
//    maskBitmap_  : (instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    density_     : (0.1%ñ)(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
//  Return
//    dstBitmap_ : о(instance ѿ)
//    counter_   : counter(instance ѿ)
//
-(void)execute
{
    for ([self->pos_ setX:[self->trueRect_ left]];
         [self->pos_ x] < [self->trueRect_ right];
         [self->pos_ moveX:1]) {
        if (([self->drawRect_ isPointInRect:self->pos_]) &&
            (*(self->maskBitmap_) != 0) &&
            (!([[self->palette_ palette:*(self->dstBitmap_)] isMask]))) {
            *(self->dstBitmap_) = [PoCoColorMixer calcColor:self->palette_
                                                    colMode:self->colMode_
                                                   density2:self->density_
                                                     color1:*(self->dstBitmap_)
                                                     color2:*(self->patBitmap_)
                                                     buffer:self->colorBuffer_];
        }

        // 
        (self->dstBitmap_)++;
        (self->patBitmap_)++;
        (self->maskBitmap_)++;
    }

    // ȴ
    [self->counter_ down];
    [NSThread exit];

    return;
}

@end




// ============================================================================
@implementation PoCoEditUniformedDensityFill

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp   : Խо
//    cmode : 黻⡼
//    plt   : ѥѥå
//    pat   : ѥ顼ѥ
//    buf   : ݻ
//    den   : ǻ
//
//  Return
//    function     : 
//    bitmap_      : Խо(instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    pattern_     : ѥ顼ѥ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//    density_     : (0.1%ñ)(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
  pattern:(PoCoColorPattern *)pat
   buffer:(PoCoColorBuffer *)buf
  density:(int)den
{
    DPRINT((@"[PoCoEditUniformedDensityFill init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->bitmap_ = bmp;
        self->colMode_ = cmode;
        self->palette_ = plt;
        self->pattern_ = pat;
        self->density_ = den;
        self->colorBuffer_ = buf;

        // 줾 retain Ƥ
        [self->bitmap_ retain];
        [self->palette_ retain];
        [self->pattern_ retain];
        [self->colorBuffer_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    bitmap_      : Խо(instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    pattern_     : ѥ顼ѥ(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditUniformedDensityFill dealloc]\n"));

    // 񸻤β
    [self->bitmap_ release];
    [self->palette_ release];
    [self->pattern_ release];
    [self->colorBuffer_ release];
    self->bitmap_ = nil;
    self->palette_ = nil;
    self->pattern_ = nil;
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    d   : (0.1%ñ)
//    bmp : Խо
//
//  Return
//    density_ : (0.1%ñ)(instance ѿ)
//    bitmap_  : Խо(instance ѿ)
//
-(void)replaceDensity:(int)d
           withBitmap:(PoCoBitmap *)bmp
{
    // ʬ˺
    [self->bitmap_ release];

    // ؤ
    self->density_ = d;
    self->bitmap_ = bmp;
    [self->bitmap_ retain];

    return;
}


//
// ¹
//
//  Call
//    mask     : 
//    tile     : ѥ
//    trueRect : ϰ(ϰϳޤ)
//    drawRect : ϰ(ϰΤ)
//    bitmap_  : Խо(instance ѿ)
//    palette_ : ѥѥå(instance ѿ)
//    pattern_ : ѥ顼ѥ(instance ѿ)
//    density_ : (0.1%ñ)(instance ѿ)
//
//  Return
//    bitmap_ : Խо(instance ѿ)
//
-(void)executeDraw:(PoCoBitmap *)mask
          withTile:(PoCoMonochromePattern *)tile
      withTrueRect:(PoCoRect *)trueRect
      withDrawRect:(PoCoRect *)drawRect
#if 0
{
    PoCoBitmap *patBitmap;              // 顼ѥ(ϰϤĴѤ)
    PoCoRect *tr;
    PoCoRect *dr;
    PoCoPoint *p;
    int brow;                           // оݤ rowbyets
    int prow;                           // 顼ѥ rowbytes
    int mrow;                           //  rowbytes
    unsigned char *bbmp;                // оݤ
    const unsigned char *pbmp;          // 顼ѥ
    const unsigned char *mbmp;          // 
    BOOL flag;
    int l;
    int cnt;
    id *scan;
    id *thread;
    PoCoThreadCounter *counter;

    tr = nil;
    dr = nil;
    patBitmap = nil;
    scan = NULL;
    thread = NULL;
    counter = nil;

    // ΰʤ
    if ([drawRect empty]) {
        goto EXIT;
    }

    // half-open property ˤΤǱ +1
    tr = [[PoCoRect alloc] initLeft:[trueRect left]
                            initTop:[trueRect top]
                          initRight:([trueRect right] + 1)
                         initBottom:([trueRect bottom] + 1)];
    dr = [[PoCoRect alloc] initLeft:[drawRect left]
                            initTop:[drawRect top]
                          initRight:([drawRect right] + 1)
                         initBottom:([drawRect bottom] + 1)];
    if ([self->bitmap_ width] < [dr right]) {
        [dr setRight:[self->bitmap_ width]];
    }
    if ([self->bitmap_ height] < [dr bottom]) {
        [dr setBottom:[self->bitmap_ height]];
    }

    // 賫
    patBitmap = [self->pattern_ pixelmap:tr];

    // Ƽͤλ
    brow = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));
    prow = ([patBitmap width]     + ([patBitmap width]     & 1));
    mrow = ([mask width]          + ([mask width]          & 1));

    // Ƽѥӥåȥޥåפ
    bbmp = [self->bitmap_ pixelmap] + (([tr top] * brow) + [tr left]);
    pbmp = [patBitmap pixelmap];
    mbmp = [mask pixelmap];

    // 񸻤
    cnt = [tr height];
    if (cnt <= 0) {
        goto EXIT;
    }
    scan = (id *)(calloc(cnt, sizeof(id)));
    thread = (id *)(calloc(cnt, sizeof(id)));
    if ((scan == NULL) || (thread == NULL)) {
        goto EXIT;
    }
    counter = [[PoCoThreadCounter alloc] init];

    // /(ľ򤹤٤ thread ˤ)
    l = 0;
    p = [[PoCoPoint alloc] init];
    for ([p setY:[tr top]]; [p y] < [tr bottom]; [p moveY:1]) {
        // ʿ
        scan[l] = [[PoCoUniformedDensityThread alloc]
                      initStartPos:p
                      withTrueRect:tr
                      withDrawRect:dr
                         dstBitmap:bbmp
                         patBitmap:pbmp
                        maskBitmap:mbmp
                           colMode:self->colMode_
                           palette:self->palette_
                           density:self->density_
                            buffer:self->colorBuffer_
                           counter:counter];
        thread[l] = [[NSThread alloc] initWithTarget:scan[l]
                                            selector:@selector(execute)
                                              object:nil];
        [thread[l] start];

        // 
        bbmp += brow;
        pbmp += prow;
        mbmp += mrow;
        (l)++;

        // thread ܿ
        while ([counter count] >= 2) {
            [NSThread sleepForTimeInterval:0.001];
        }
    }
    [p release];

    // ٤Ƥ thread ΤԤ
    [NSThread sleepForTimeInterval:0.001];
    do {
        flag = NO;
        for (l = 0; l < cnt; (l)++) {
            if (thread[l] == nil) {
                // ˽äƤ
                ;
            } else if ([thread[l] isFinished]) {
                // λΤǲ
                [thread[l] release];
                [scan[l] release];
                thread[l] = nil;
                scan[l] = nil;
            } else {
                // ¹
                flag = YES;
            }
        }
        [NSThread sleepForTimeInterval:0.001];
    } while (flag);

EXIT:
    if (scan != NULL) {
        free(scan);
    }
    if (thread != NULL) {
        free(thread);
    }
    [counter release];
    [patBitmap release];
    [tr release];
    [dr release];
    return;
}
#else   // 1
{
    PoCoBitmap *patBitmap;              // 顼ѥ(ϰϤĴѤ)
    PoCoRect *tr;
    PoCoRect *dr;
    PoCoPoint *p;
    int brow;                           // оݤ rowbyets
    int prow;                           // 顼ѥ rowbytes
    int mrow;                           //  rowbytes
    int bskip;                          // оݤμιԤޤǤΥ
    int pskip;                          // 顼ѥμιԤޤǤΥ
    int mskip;                          // μιԤޤǤΥ
    unsigned char *bbmp;                // оݤ
    const unsigned char *pbmp;          // 顼ѥ
    const unsigned char *mbmp;          // 

    tr = nil;
    dr = nil;
    patBitmap = nil;

    // ΰʤ
    if ([drawRect empty]) {
        goto EXIT;
    }

    // half-open property ˤΤǱ +1
    tr = [[PoCoRect alloc] initLeft:[trueRect left]
                            initTop:[trueRect top]
                          initRight:([trueRect right] + 1)
                         initBottom:([trueRect bottom] + 1)];
    dr = [[PoCoRect alloc] initLeft:[drawRect left]
                            initTop:[drawRect top]
                          initRight:([drawRect right] + 1)
                         initBottom:([drawRect bottom] + 1)];
    if ([self->bitmap_ width] < [dr right]) {
        [dr setRight:[self->bitmap_ width]];
    }
    if ([self->bitmap_ height] < [dr bottom]) {
        [dr setBottom:[self->bitmap_ height]];
    }

    // 賫
    patBitmap = [self->pattern_ pixelmap:tr];

    // Ƽͤλ
    brow = ([self->bitmap_ width] + ([self->bitmap_ width] & 1));
    prow = ([patBitmap width]     + ([patBitmap width]     & 1));
    mrow = ([mask width]          + ([mask width]          & 1));
    bskip = (brow - [tr width]);
    pskip = (prow - [tr width]);
    mskip = (mrow - [tr width]);

    // Ƽѥӥåȥޥåפ
    bbmp = [self->bitmap_ pixelmap] + (([tr top] * brow) + [tr left]);
    pbmp = [patBitmap pixelmap];
    mbmp = [mask pixelmap];

    // /
    p = [[PoCoPoint alloc] init];
    for ([p setY:[tr top]]; [p y] < [tr bottom]; [p moveY:1]) {
        for ([p setX:[tr left]]; [p x] < [tr right]; [p moveX:1]) {
            if (([dr isPointInRect:p]) &&
                (*(mbmp) != 0) &&
                (!([[self->palette_ palette:*(bbmp)] isMask]))) {
                *(bbmp) = [PoCoColorMixer calcColor:self->palette_
                                            colMode:self->colMode_
                                           density2:self->density_
                                             color1:*(bbmp)
                                             color2:*(pbmp)
                                             buffer:self->colorBuffer_];
            }

            // 
            (bbmp)++;
            (pbmp)++;
            (mbmp)++;
        }

        // 
        bbmp += bskip;
        pbmp += pskip;
        mbmp += mskip;
    }
    [p release];

EXIT:
    [patBitmap release];
    [tr release];
    [dr release];
    return;
}
#endif  // 1

@end
