//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ܤ - 
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoEditWaterDropBase.h"

#import "PoCoColorMixer.h"

// ============================================================================
@implementation PoCoEditWaterDropBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp   : о bitmap
//    cmode : 黻⡼
//    plt   : ѥѥå
//    buf   : ݻ
//
//  Return
//    function     : 
//    srcBitmap_   : 踵(ʣ)(instance ѿ)
//    dstBitmap_   : (instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    cols_        : (instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//    rowBytes_    : row bytes(instance ѿ)
//
-(id)initWithBitmap:(PoCoBitmap *)bmp
            colMode:(PoCoColorMode)cmode
            palette:(PoCoPalette *)plt
             buffer:(PoCoColorBuffer *)buf
{
//    DPRINT((@"[PoCoEditWaterDropBase initWithPattern]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->srcBitmap_ = nil;
        self->cols_ = nil;

        // ݻ
        self->dstBitmap_ = bmp;
        self->colMode_ = cmode;
        self->palette_ = plt;
        self->colorBuffer_ = buf;
        [self->dstBitmap_ retain];
        [self->palette_ retain];
        [self->colorBuffer_ retain];

        // row bytes 򻻽
        self->rowBytes_ = ([bmp width] + ([bmp width] & 0x01));

        // 񸻤
        self->srcBitmap_ = [bmp copy];
        if (self->srcBitmap_ == nil) {
            DPRINT((@"can't alloc source bitmap.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
        self->cols_ = [[NSMutableArray alloc] init];
        if (self->cols_ == nil) {
            DPRINT((@"can't alloc array.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    srcBitmap_   : 踵(ʣ)(instance ѿ)
//    dstBitmap_   : (instance ѿ)
//    cols_        : (instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditWaterDropBase dealloc]\n"));

    // 񸻤β
    [self->srcBitmap_ release];
    [self->dstBitmap_ release];
    [self->cols_ removeAllObjects];
    [self->cols_ release];
    [self->palette_ release];
    [self->colorBuffer_ release];
    self->srcBitmap_ = nil;
    self->dstBitmap_ = nil;
    self->cols_ = nil;
    self->palette_ = nil;
    self->colorBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 黻
//
//  Call
//    p            : 濴
//    dr           : ΰ
//    mask         : (nil )
//    srcBitmap_   : 踵(ʣ)(instance ѿ)
//    dstBitmap_   : (instance ѿ)
//    colMode_     : 黻⡼(instance ѿ)
//    cols_        : (instance ѿ)
//    palette_     : ѥѥå(instance ѿ)
//    colorBuffer_ : ݻ(instance ѿ)
//    rowBytes_    : row bytes(instance ѿ)
//
//  Return
//    dstBitmap_ : (instance ѿ)
//
-(void)calcColor:(PoCoPoint *)p
    withDrawRect:(PoCoRect *)dr
        withMask:(PoCoBitmap *)mask
{
    PoCoRect *r;
    unsigned char *sbmp;
    const unsigned char *mbmp;
    int idx;
    int x;
    int y;
    int sskip;
    int mrow;
    int mskip_x;
    int mskip_y;
    PoCoColor *c;
    unsigned char ch;
    PoCoColorMixerUnit *elm;

    r = nil;

    // ⤽ϰϳʤ鲿⤷ʤ
    if (!([dr isPointInRect:p])) {
        goto EXIT;
    }

    // Ƥ˺
    [self->cols_ removeAllObjects];

    // 濴
    idx = (([p y] * self->rowBytes_) + [p x]);

    // 褬Ǥʤʤ鲿⤷ʤ
    ch = *([self->srcBitmap_ pixelmap] + idx);
    c = [self->palette_ palette:ch];
    if (([c isMask]) || ([c noDropper])) {
        goto EXIT;
    }

    // ϰϤ
    r = [[PoCoRect alloc] initLeft:MAX(([p x] - 1), 0)
                           initTop:MAX(([p y] - 1), 0)
                         initRight:MIN(([p x] + 2), [self->srcBitmap_ width])
                        initBottom:MIN(([p y] + 2), [self->srcBitmap_ height])];
    sbmp  = [self->srcBitmap_ pixelmap];
    sbmp += (([r top] * self->rowBytes_) + [r left]);
    sskip = (self->rowBytes_ - [r width]);
    if (mask != nil) {
        mrow = ([mask width] + ([mask width] & 1));
        mskip_x = 1;
        mskip_y = (mrow - [r width]);      
        mbmp = ([mask pixelmap] + (([r top] * mrow) + [r left]));
    } else {
        mrow = 0;
        mskip_x = 0;
        mskip_y = 0;
        mbmp = NULL;
    }

    // 
    y = [r height];
    do {
        x = [r width];
        do {
            // 
            c = [self->palette_ palette:*(sbmp)];
            if ([c noDropper]) {
                // ѶػߤϽ
                ;
            } else if ((mask != nil) &&
                       (mbmp != NULL) &&
                       (*(mbmp) == 0)) {
                // ϰϳ
                ;
            } else {
                if (self->colMode_ == PoCoColorMode_RGB) {
                    // RGB
                    elm = [[PoCoColorMixerUnit alloc]
                              initWithElement1:[c red]
                                  withElement2:[c green]
                                  withElement3:[c blue]];
                } else {
                    // HLS
                    elm = [[PoCoColorMixerUnit alloc]
                              initWithElement1:[c hue]
                                  withElement2:[c lightness]
                                  withElement3:[c saturation]];
                }
                [self->cols_ addObject:elm];
                [elm release];
            }

            // 
            (x)--;
            (sbmp)++;
            mbmp += mskip_x;
        } while (x != 0);

        // 
        (y)--;
        sbmp += sskip;
        mbmp += mskip_y;
    } while (y != 0);

    // 򻻽С
    if (self->colMode_ == PoCoColorMode_RGB) {
        // RGB
        ch = [PoCoColorMixer calcColorRGB:self->palette_
                               withColors:self->cols_
                                   buffer:self->colorBuffer_
                                 orgColor:ch];
    } else {
        // HLS
        ch = [PoCoColorMixer calcColorHLS:self->palette_
                               withColors:self->cols_
                                   buffer:self->colorBuffer_
                                 orgColor:ch];
    }
    *([self->dstBitmap_ pixelmap] + idx) = ch;

EXIT:
    [r release];
    return;
}

@end
