//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ܤ - ΰɤĤ֤
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoEditWaterDropFill.h"

#import "PoCoColorMixer.h"

// ============================================================================
@implementation PoCoEditWaterDropFill

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp   : Խо
//    cmode : 黻⡼
//    plt   : ѥѥå
//    buf   : ݻ
//
//  Return
//    function : 
//
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
   buffer:(PoCoColorBuffer *)buf
{
    DPRINT((@"[PoCoEditWaterDropFill init]\n"));

    // super class ν
    self = [super initWithBitmap:bmp
                         colMode:cmode
                         palette:plt
                          buffer:buf];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditWaterDropFill dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    mask       : 
//    tile       : ѥ
//    trueRect   : ϰ(ϰϳޤ)
//    drawRect   : ϰ(ϰΤ)
//    srcBitmap_ : 踵(ʣ)(instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw:(PoCoBitmap *)mask
          withTile:(PoCoMonochromePattern *)tile
      withTrueRect:(PoCoRect *)trueRect
      withDrawRect:(PoCoRect *)drawRect
{
    PoCoRect *tr;
    PoCoRect *dr;
    PoCoPoint *p;
    int mrow;                           //  rowbytes
    int mskip;                          // μιԤޤǤΥ
    const unsigned char *mbmp;          // 

    tr = nil;
    dr = nil;

    // ΰʤ
    if ([drawRect empty]) {
        goto EXIT;
    }

    // half-open property ˤΤǱ +1
    tr = [[PoCoRect alloc] initLeft:[trueRect left]
                            initTop:[trueRect top]
                          initRight:([trueRect right] + 1)
                         initBottom:([trueRect bottom] + 1)];
    dr = [[PoCoRect alloc] initLeft:[drawRect left]
                            initTop:[drawRect top]
                          initRight:([drawRect right] + 1)
                         initBottom:([drawRect bottom] + 1)];
    if ([self->srcBitmap_ width] < [dr right]) {
        [dr setRight:[self->srcBitmap_ width]];
    }
    if ([self->srcBitmap_ height] < [dr bottom]) {
        [dr setBottom:[self->srcBitmap_ height]];
    }

    // Ƽͤλ
    mrow = ([mask width] + ([mask width] & 1));
    mskip = (mrow - [tr width]);

    // Ƽѥӥåȥޥåפ
    mbmp = [mask pixelmap];

    // /
    p = [[PoCoPoint alloc] init];
    for ([p setY:[tr top]]; [p y] < [tr bottom]; [p moveY:1]) {
        for ([p setX:[tr left]]; [p x] < [tr right]; [p moveX:1]) {
            if (([dr isPointInRect:p]) &&
                (*(mbmp) != 0)) {
                [super calcColor:p
                    withDrawRect:dr
                        withMask:mask];
            }

            // 
            (mbmp)++;
        }

        // 
        mbmp += mskip;
    }
    [p release];

EXIT:
    [tr release];
    [dr release];
    return;
}

@end
