//
//	Pelistina on Cocoa - PoCo -
//	Խϥ饤֥ - ܤ - ľ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoEditWaterDropDrawLineBase.h"

#import "PoCoColorMixer.h"

// ============================================================================
@implementation PoCoEditWaterDropDrawLineBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    bmp   : Խо
//    cmode : 黻⡼
//    plt   : ѥѥå
//    buf   : ݻ
//
//  Return
//    function  : 
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(id)init:(PoCoBitmap *)bmp
  colMode:(PoCoColorMode)cmode
  palette:(PoCoPalette *)plt
   buffer:(PoCoColorBuffer *)buf
{
    DPRINT((@"[PoCoEditWaterDropDrawLineBase init]\n"));

    // super class ν
    self = [super initWithBitmap:bmp
                         colMode:cmode
                         palette:plt
                          buffer:buf];

    // Ȥν
    if (self != nil) {
        // 񸻤γ
        self->points_ = [[NSMutableArray alloc] init];
        self->drawRect_ = [[PoCoRect alloc] initLeft:[bmp width]
                                             initTop:[bmp height]
                                           initRight:0
                                          initBottom:0];  
        if ((self->points_ == nil) || (self->drawRect_ == nil)) {
            // 
            DPRINT((@"memory allocation error.\n"));
            [self release];
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditWaterDropDrawLineBase dealloc]\n"));

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->points_ release];
    [self->drawRect_ release];
    self->points_ = nil;
    self->drawRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Ͽ
//
//  Call
//    p          : Ͽ
//    srcBitmap_ : 踵(ʣ)(instance ѿ)
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)addPoint:(PoCoPoint *)p
{
    const int sz = [self pointSize];
    PoCoPoint *tmp;

    tmp = [[PoCoPoint alloc] initX:[p x] initY:[p y]];
    [self->points_ addObject:tmp];
    [tmp release];

    // ΰ򹹿(+1  half-open property Τ)
    if (([p x] - sz) < [self->drawRect_ left]) {
        [self->drawRect_ setLeft:MAX(([p x] - sz), 0)];
    }
    if (([p y] - sz) < [self->drawRect_ top]) {
        [self->drawRect_ setTop:MAX(([p y] - sz), 0)];
    }
    if (([p x] + sz + 1) > [self->drawRect_ right]) {
        [self->drawRect_ setRight:MIN(([p x] + sz + 1), [self->srcBitmap_ width])];
    }
    if (([p y] + sz + 1) > [self->drawRect_ bottom]) {  
        [self->drawRect_ setBottom:MIN(([p y] + sz + 1), [self->srcBitmap_ height])];
    }

    return;
}


//
// 
//
//  Call
//    srcBitmap_ : 踵(ʣ)(instance ѿ)
//
//  Return
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
-(void)clearPoint
{
    [self->points_ removeAllObjects];

    // ϰϤ
    [self->drawRect_ setLeft:[self->srcBitmap_ width]];
    [self->drawRect_ setTop:[self->srcBitmap_ height]];
    [self->drawRect_ setRight:0];
    [self->drawRect_ setBottom:0];

    return;
}


//
// ¹
//  ǤϺɸ黻Ū
//  褽ΤΤ϶ class  drawPoint: Ǽ
//
//  Call
//    points_   : 褹(instance ѿ)
//    drawRect_ : ϰ(instance ѿ)
//
//  Return
//    None
//
-(void)executeDraw
{
    NSEnumerator *iter;                 // points_ ȿ
    PoCoPoint *p1;                      // 
    PoCoPoint *p2;                      // 
    PoCoPoint *dp;                      // (濴)
    int i;                              // ɸ(ʿʤľ)
    int e;                              // 
    int dx;                             // ʿʬ
    int dy;                             // ľʬ
    int sx;                             // ʿ(ˡ1Τ)
    int sy;                             // ľ(ˡ1Τ)
    int ax;                             // ʿ
    int ay;                             // ľ

    // ΰʤ
    if([self->drawRect_ empty]){
        goto EXIT;
    }

    // ȿ
    iter = [self->points_ objectEnumerator];
    p1 = [iter nextObject];
    for (p2 = [iter nextObject]; p2 != nil; p2 = [iter nextObject]) {
        dp = p1;

        // Ѱ̻
        dx = abs([p2 x] - [dp x]);
        dy = abs([p2 y] - [dp y]);
        sx = (([p2 x] < [dp x]) ? -1 : 1);
        sy = (([p2 y] < [dp y]) ? -1 : 1);
        ax = (dx << 1);
        ay = (dy << 1);

        // ΰư
        if ((dx == 0) && (dy == 0)) {
            // Ʊ
            [self drawPoint:dp];
        } else if (dx == 0) {
            // ľ
            for ( ; !([dp isEqualPos:p2]); [dp moveY:sy]) {
                [self drawPoint:dp];
            }
        } else if (dy == 0) {
            // ʿ
            for ( ; !([dp isEqualPos:p2]); [dp moveX:sx]) {
                [self drawPoint:dp];
            }  
        } else if (dx < dy) {  
            // Ǥ(ľ̤礭)
            e = -(dy);
            for (i = 0; i < dy; (i)++) {
                [self drawPoint:dp];

                // ΰư
                e += ax;
                [dp moveY:sy];
                if (e >= 0) {
                    [dp moveX:sx];
                    e -= ay;
                }
            }
        } else {
            // Ǥ(ʿ̤礭)
            e = -(dx);
            for (i = 0; i < dx; (i)++) {
                [self drawPoint:dp];

                // ΰư
                e += ay;
                [dp moveX:sx];
                if (e >= 0) {
                    [dp moveY:sy];
                    e -= ax;
                }
            }
        }

        // ʣ
        p1 = p2;
    }

EXIT:
    return;
}


//
// ϰ
//   class ϰϤΥɥåȿ/2֤
//
//  Call
//    None
//
//  Return
//    function : ϰ
//
-(int)pointSize
{
    return 0;                           // Ǥ 0 ֤
}


//
// 
//
//  Call
//    p : 濴
//
//  Return
//    None
//
-(void)drawPoint:(PoCoPoint *)p
{
    // Ǥϲ⤷ʤ
    ;

    return;
}

@end
