//
//	Pelistina on Cocoa - PoCo -
//	ʱߴؿ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoCalcEllipse.h"

#import "PoCoCalcRotation.h"

// ============================================================================
@implementation PoCoCalcEllipse

// --------------------------------------------------------- instance - private
//
// ɲ
//
//  Call
//    num    : ɸֹ
//    x      : X ɸ
//    y      : Y ɸ
//    append : ɲä
//             YES : ɲ
//             NO  : Ƭ
//    pos_[] : ɸ(instance ѿ)
//
//  Return
//    pos_[] : ɸ(instance ѿ)
//
-(void)addPos:(int)num
            x:(int)x
            y:(int)y
       append:(BOOL)append
{
    PoCoPoint *p;

    p = [[PoCoPoint alloc] initX:x
                           initY:y];
    if (append) {
        [self->pos_[num] addObject:p];
    } else {
        [self->pos_[num] insertObject:p
                              atIndex:0];
    }
    [p release];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function   : 
//    arrayIter_ : ȿ(pos_ )(instance ѿ)
//    posIter_   : ȿ(pos_ )(instance ѿ)
//    pos_[]     : ɸ(instance ѿ)
//
-(id)init
{
    int l;

    DPRINT((@"[PoCoCalcEllipse init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->arrayIter_ = 0;
        self->posIter_ = nil;
        for (l = 0; l < 8; l++) {
            self->pos_[l] = [[NSMutableArray alloc] init];
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pos_[] : ɸ(instance ѿ)
//
-(void)dealloc
{
    int l;

    DPRINT((@"[PoCoCalcEllipse dealloc]\n"));

    // 񸻤
    for (l = 0; l < 8; l++) {
        [self->pos_[l] removeAllObjects];
        [self->pos_[l] release];
        self->pos_[l] = nil;
    }

    // super class β
    [super dealloc];

    return;
}


//
// 黻
//
//  Call
//    cp  : 濴
//    ep  : 
//    ort : 
//          == nil : žʤ
//          != nil : ž
//
//  Return
//    None
//
-(void)calc:(PoCoPoint *)cp
     endPos:(PoCoPoint *)ep
orientation:(PoCoPoint *)ort
{
    int h;
    int v;
    int c;                              // 
    int x[2];
    int y[2];
    int fx[2] = {0, 0};
    int fy[2] = {0, 0};
    int deg;
    PoCoCalcRotationForEllipse *rot;

    h = (([cp x] < [ep x]) ? ([ep x] - [cp x]) : ([cp x] - [ep x]));
    v = (([cp y] < [ep y]) ? ([ep y] - [cp y]) : ([cp y] - [ep y]));
    rot = [[PoCoCalcRotationForEllipse alloc] initWithCenterPos:cp
                                                     withEndPos:ep
                                                    ifAnyOrient:ort];
    if (h == 0) {
        ;
    } else if (h == v) {
        // 
        c = h;
        x[0] = h;
        for (y[0] = 0; x[0] >= y[0]; (y[0])++) {
            [self addPos:0
                       x:([cp x] + x[0])
                       y:([cp y] + y[0])
                  append:YES];
            [self addPos:7
                       x:([cp x] + x[0])
                       y:([cp y] - y[0])
                  append:NO];
            [self addPos:3
                       x:([cp x] - x[0])
                       y:([cp y] + y[0])
                  append:NO];
            [self addPos:4
                       x:([cp x] - x[0])
                       y:([cp y] - y[0])
                  append:YES];
            [self addPos:1
                       x:([cp x] + y[0])
                       y:([cp y] + x[0])
                  append:NO];
            [self addPos:6
                       x:([cp x] + y[0])
                       y:([cp y] - x[0])
                  append:YES];
            [self addPos:2
                       x:([cp x] - y[0])
                       y:([cp y] + x[0])
                  append:YES];
            [self addPos:5
                       x:([cp x] - y[0])
                       y:([cp y] - x[0])
                  append:NO];
            c -= ((y[0] << 1) + 1);
            if (c < 0) {
                c += ((x[0] - 1) << 1);
                (x[0])--;
            }
        }
    } else if ([rot isExec]) {
        // žʱ
        for (deg = 0; deg < 3600; (deg)++) {
            [self addPos:(deg / 450)
                       x:([cp x] + [rot calcXAxis:deg
                                       horiLength:h
                                       vertLength:v])
                       y:([cp y] + [rot calcYAxis:deg
                                       horiLength:h
                                       vertLength:v])
                  append:YES];
        }
    } else if (h > v) {
        // ʿʱ
        c = h;
        x[0] = h;
        for (y[0] = 0; x[0] >= y[0]; (y[0])++) {
            x[1] = ((x[0] * v) / h);
            y[1] = ((y[0] * v) / h);
            if ((fx[0] != x[0]) || (fy[1] != y[1])) {
                [self addPos:0
                           x:([cp x] + x[0])
                           y:([cp y] + y[1])
                      append:YES];
                [self addPos:7
                           x:([cp x] + x[0])
                           y:([cp y] - y[1])
                      append:NO];
                [self addPos:3
                           x:([cp x] - x[0])
                           y:([cp y] + y[1])
                      append:NO];
                [self addPos:4
                           x:([cp x] - x[0])
                           y:([cp y] - y[1])
                      append:YES];
                fx[0] = x[0];
                fy[1] = y[1];
            }
            if ((fx[1] != x[1]) || (fy[0] != y[0])) {
                [self addPos:1
                           x:([cp x] + y[0])
                           y:([cp y] + x[1])
                      append:NO];
                [self addPos:6
                           x:([cp x] + y[0])
                           y:([cp y] - x[1])
                      append:YES];
                [self addPos:2
                           x:([cp x] - y[0])
                           y:([cp y] + x[1])
                      append:YES];
                [self addPos:5
                           x:([cp x] - y[0])
                           y:([cp y] - x[1])
                      append:NO];
                fx[1] = x[1];
                fy[0] = y[0];
            }
            c -= ((y[0] << 1) - 1);
            if (c < 0) {
                c += ((x[0] - 1) << 1);
                (x[0])--;
            }
        }
    } else {
        // ľʱ
        c = v;
        x[0] = v;
        for (y[0] = 0; x[0] >= y[0]; (y[0])++) {
            x[1] = ((x[0] * h) / v);
            y[1] = ((y[0] * h) / v);
            if ((fx[1] != x[1]) || (fy[0] != y[0])) {
                [self addPos:0
                           x:([cp x] + x[1])
                           y:([cp y] + y[0])
                      append:YES];
                [self addPos:7
                           x:([cp x] + x[1])
                           y:([cp y] - y[0])
                      append:NO];
                [self addPos:3
                           x:([cp x] - x[1])
                           y:([cp y] + y[0])
                      append:NO];
                [self addPos:4
                           x:([cp x] - x[1])
                           y:([cp y] - y[0])
                      append:YES];
                fx[1] = x[1];
                fy[0] = y[0];
            }
            if ((fx[0] != x[0]) || (fy[1] != y[1])) {
                [self addPos:1
                           x:([cp x] + y[1])
                           y:([cp y] + x[0])
                      append:NO];
                [self addPos:6
                           x:([cp x] + y[1])
                           y:([cp y] - x[0])
                      append:YES];
                [self addPos:2
                           x:([cp x] - y[1])
                           y:([cp y] + x[0])
                      append:YES];
                [self addPos:5
                           x:([cp x] - y[1])
                           y:([cp y] - x[0])
                      append:NO];
                fx[0] = x[0];
                fy[1] = y[1];
            }
            c -= ((y[0] << 1) - 1);
            if (c < 0) {
                c += ((x[0] - 1) << 1);
                (x[0])--;
            }
        }
    }

    [rot release];
    return;
}


//
// 
//
//  Call
//    arrayIter_ : ȿ(pos_ )(instance ѿ)
//    posIter_   : ȿ(pos_ )(instance ѿ)
//    pos_[]     : ɸ(instance ѿ)
//
//  Return
//    arrayIter_ : ȿ(pos_ )(instance ѿ)
//    posIter_   : ȿ(pos_ )(instance ѿ)
//
-(PoCoPoint *)points
{
    PoCoPoint *p;

    p = nil;

    while (self->arrayIter_ < 8) {
        if (self->posIter_ == nil) {
            self->posIter_ = [self->pos_[self->arrayIter_] objectEnumerator];
        }

        p = [self->posIter_ nextObject];
        if (p != nil) {
            break;
        }

        // 
        self->posIter_ = nil;
        (self->arrayIter_)++;
    }

    return p;
}

@end
