//
//	Pelistina on Cocoa - PoCo -
//	žؿ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoCalcRotation.h"

// ============================================================================
@implementation PoCoCalcRotation

// ------------------------------------------------------------ class - private
//
// 
//  15ñ̹ߤ
//
//  Call
//    rad : 饸
//
//  Return
//    funcion : 饸
//
+(double)corrRotate:(double)rad
{
    int deg;

    // ٤Ѵ
    deg = (int)(floor((PoCoDivPI * rad) * 10.0));

    // 15٤ϰϤ˴ݤ
    deg += ((deg < 0) ? -75 : 75);
    deg /= 150;
    deg *= 150;

    // 360٤ϰϤ˴ݤ
    deg %= 3600;

    // 饸ˤ֤
    return (((double)(deg) / 10.0) * PoCoMulPI);
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    p : 
//    v : ĤϿľ
//    g : Ĥ礭ɸ
//
//  Return
//    function : 
//    control_ : (instance ѿ)
//    vert_    : ĤϿľ(instance ѿ)
//    greater_ : Ĥ礭ɸ(instance ѿ)
//    sin_     : žѤ sin(instance ѿ)
//    cos_     : žѤ cos(instance ѿ)
//    prevSin_ :  sin(instance ѿ)
//    prevCos_ :  cos(instance ѿ)
//
-(id)initWithControlPoint:(PoCoPoint *)p
        isVerticalControl:(BOOL)v
         isGreaterControl:(BOOL)g
{
    DPRINT((@"[PoCoCalcRotation initWithControlPoint]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->control_ = nil;
        self->vert_ = v;
        self->greater_ = g;
        self->sin_ = ((v) ? 0.0                : ((g) ? 1.0 : -1.0));
        self->cos_ = ((v) ? ((g) ? 1.0 : -1.0) : 0.0               );
        self->prevSin_ = self->sin_;
        self->prevCos_ = self->cos_;

        // 񸻤
        self->control_ = [[PoCoPoint alloc] initX:[p x]
                                            initY:[p y]];
        if (self->control_ == nil) {
            DPRINT((@"can't allocation\n"));
            [self release];
            self = nil;
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    control_ : (instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoCalcRotation dealloc]\n"));

    // 񸻤
    [self->control_ release];
    self->control_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ư
//
//  Call
//    p        : ư
//    corr     : 
//               YES : 
//               NO  : ʤ
//    control_ : (instance ѿ)
//
//  Return
//    function : ٤Ѥä
//               YES : Ѥä
//               NO  : ѤäƤʤ
//    sin_     : žѤ sin(instance ѿ)
//    cos_     : žѤ cos(instance ѿ)
//    prevSin_ :  sin(instance ѿ)
//    prevCos_ :  cos(instance ѿ)
//
-(BOOL)moveControlPoint:(PoCoPoint *)p
              isCorrect:(BOOL)corr
{
    BOOL result;
    int vx;
    int vy;
    double scr;

    vx = ([p x] - [self->control_ x]);
    vy = ([p y] - [self->control_ y]);
    if ((vy == 0) && (vx != 0)) {
        self->sin_ = 0.0;
        self->cos_ = ((vx < 0) ? -1.0 : 1.0);
    } else {
        scr = sqrt((double)((vx * vx) + (vy * vy)));
        if (scr != 0.0) {
            self->sin_ = ((double)(vy) / scr);
            self->cos_ = ((double)(vx) / scr);
            if (corr) {
                self->sin_ = sin([PoCoCalcRotation corrRotate:asin(self->sin_)]);
                self->cos_ = cos([PoCoCalcRotation corrRotate:acos(self->cos_)]);
            }
        } else {
            self->sin_ = 0.0;
            self->cos_ = 1.0;
        }
    }

    // η̤ӤͤФ
    result = ((self->sin_ != self->prevSin_) || (self->cos_ != self->prevCos_));
    self->prevSin_ = self->sin_;
    self->prevCos_ = self->cos_;

    return result;
}


//
// 黻(Ф)
//  žž
//
//  Call
//    p        : о
//    control_ : (instance ѿ)
//    vert_    : ĤϿľ(instance ѿ)
//               YES : ľվ( or )
//               NO  : ʿվ( or )
//    greater_ : Ĥ礭ɸ(instance ѿ)
//               YES : 礭( or )
//               NO  : ( or )
//    sin_     : žѤ sin(instance ѿ)
//    cos_     : žѤ cos(instance ѿ)
//
//  Return
//    p : о
//
-(void)calcPoint:(PoCoPoint *)p
{
    double cx;
    double cy;
    double fx = (double)([self->control_ x]);
    double fy = (double)([self->control_ y]);

    if (self->vert_) {
        if (self->greater_) {
            // դĤ(Ϻ¦)
            cx = ((double)([p x]) - fx);
            cy = ((double)([p y]) - fy);
        } else {
            // դĤ(ϱ¦)
            cx = (fx - (double)([p x]));
            cy = (fy - (double)([p y]));
        }
        fx += ((cx * self->cos_) - (cy * self->sin_));
        fy += ((cx * self->sin_) + (cy * self->cos_));
    } else {
        if (self->greater_) {
            // Ĥ(Ͼ¦)
            cx = (fx - (double)([p x]));
            cy = ((double)([p y]) - fy);
        } else {
            // Ĥ(ϲ¦)
            cx = ((double)([p x]) - fx);
            cy = (fy - (double)([p y]));
        }
        fx += ((cy * self->cos_) - (cx * self->sin_));
        fy += ((cx * self->cos_) + (cy * self->sin_));
    }

    // ɸ
    [p setX:(int)(floor(fx + 0.5))
       setY:(int)(floor(fy + 0.5))];

    return;
}


#if 0   // Ȥʤ
//
// ձ黻(Ф)
//  ž褫ž
//
//  Call
//    p        : о
//    control_ : (instance ѿ)
//    vert_    : ĤϿľ(instance ѿ)
//               YES : ľվ( or )
//               NO  : ʿվ( or )
//    greater_ : Ĥ礭ɸ(instance ѿ)
//               YES : 礭( or )
//               NO  : ( or )
//    sin_     : žѤ sin(instance ѿ)
//    cos_     : žѤ cos(instance ѿ)
//
//  Return
//    p : о
//
-(void)recalcPoint:(PoCoPoint *)p
{
    double cx;
    double cy;
    double fx = (double)([self->control_ x]);
    double fy = (double)([self->control_ y]);

    if (self->vert_) {
        if (self->greater_) {
            // դĤ(Ϻ¦)
            cx = ((double)([p x]) - fx);
            cy = ((double)([p y]) - fy);
        } else {
            // դĤ(ϱ¦)
            cx = (fx - (double)([p x]));
            cy = (fy - (double)([p y]));
        }
        fx += ((cx * self->cos_) + (cy * self->sin_));
        fy += ((cy * self->cos_) - (cx * self->sin_));
    } else {
        if (self->greater_) {
            // Ĥ(Ͼ¦)
            cx = ((double)([p x]) - fx);
            cy = ((double)([p y]) - fy);
        } else {
            // Ĥ(ϲ¦)
            cx = (fx - (double)([p x]));
            cy = (fy - (double)([p y]));
        }
        fx += ((cx * self->sin_) - (cy * self->cos_));
        fy += ((cx * self->cos_) + (cy * self->sin_));
    }

    // ɸ
    [p setX:(int)(floor(fx + 0.5))
       setY:(int)(floor(fy + 0.5))];

    return;
}
#endif  // 0


//
// ձ黻(Ф)
//  ž褫ž
//
//  Call
//    x        : о
//    y        : о
//    control_ : (instance ѿ)
//    vert_    : ĤϿľ(instance ѿ)
//               YES : ľվ( or )
//               NO  : ʿվ( or )
//    greater_ : Ĥ礭ɸ(instance ѿ)
//               YES : 礭( or )
//               NO  : ( or )
//    sin_     : žѤ sin(instance ѿ)
//    cos_     : žѤ cos(instance ѿ)
//
//  Return
//    x : о
//    y : о
//
-(void)recalcPointHori:(double *)x
               andVert:(double *)y
{
    double cx;
    double cy;
    double fx = (double)([self->control_ x]);
    double fy = (double)([self->control_ y]);

    if (self->greater_) {
        cx = (*(x) - fx);
        cy = (*(y) - fy);
    } else {
        cx = (fx - *(x));
        cy = (fy - *(y));
    }
    if (self->vert_) {
        *(x) = (fx + ((cx * self->cos_) + (cy * self->sin_)));
        *(y) = (fy + ((cy * self->cos_) - (cx * self->sin_)));
    } else {
        *(x) = (fx + ((cx * self->sin_) - (cy * self->cos_)));
        *(y) = (fy + ((cx * self->cos_) + (cy * self->sin_)));
    }

    return;
}


//
// 
//   1024 ܤ
//
//  Call
//    vert_    : ĤϿľ(instance ѿ)
//               YES : ľվ( or )
//               NO  : ʿվ( or )
//    greater_ : Ĥ礭ɸ(instance ѿ)
//               YES : 礭( or )
//               NO  : ( or )
//    sin_     : žѤ sin(instance ѿ)
//    cos_     : žѤ cos(instance ѿ)
//
//  Return
//    d : 
//        d[0] : žʿβžʿ
//        d[1] : žʿβžľ
//        d[2] : žľβžʿ
//        d[3] : žľβžľ
//
-(void)diffInt:(long long *)d
{
    if (self->vert_) {
        if (self->greater_) {
            d[0] = (long long)(  self->cos_  * 1024.0);
            d[1] = (long long)(-(self->sin_) * 1024.0);
            d[2] = (long long)(  self->sin_  * 1024.0);
            d[3] = (long long)(  self->cos_  * 1024.0);
        } else {
            d[0] = (long long)(-(self->cos_) * 1024.0);
            d[1] = (long long)(  self->sin_  * 1024.0);
            d[2] = (long long)(-(self->sin_) * 1024.0);
            d[3] = (long long)(-(self->cos_) * 1024.0);
        }
    } else {
        if (self->greater_) {
            d[0] = (long long)(  self->sin_  * 1024.0);
            d[1] = (long long)(  self->cos_  * 1024.0);
            d[2] = (long long)(-(self->cos_) * 1024.0);
            d[3] = (long long)(  self->sin_  * 1024.0);
        } else {
            d[0] = (long long)(-(self->sin_) * 1024.0);
            d[1] = (long long)(-(self->cos_) * 1024.0);
            d[2] = (long long)(  self->cos_  * 1024.0);
            d[3] = (long long)(-(self->sin_) * 1024.0);
        }
    }

    return;
}

@end




// ============================================================================
@implementation PoCoCalcRotationForBox

// --------------------------------------------------------- instance - private
//
// ɸ򻻽
//
//  Call
//    centerPos_ : 濴(instance ѿ)
//    cos_       : cos(instance ѿ)
//    sin_       : sin(instance ѿ)
//
//  Return
//    p : žκɸ
//
-(void)calcPoint:(PoCoPoint *)p
{
    double cx;
    double cy;
    double fx = (double)([self->centerPos_ x]);
    double fy = (double)([self->centerPos_ y]);

    cx = ((double)([p x]) - fx);
    cy = ((double)([p y]) - fy);
    fx += ((cx * self->cos_) - (cy * self->sin_));
    fy += ((cx * self->sin_) + (cy * self->cos_));

    // ɸ
    [p setX:(int)(floor(fx + 0.5))
       setY:(int)(floor(fy + 0.5))];

    return;
}
#if 0
{
    double cx;
    double cy;
    double fx = (double)([self->control_ x]);
    double fy = (double)([self->control_ y]);

    if (self->vert_) {
        if (self->greater_) {
            // դĤ(Ϻ¦)
            cx = ((double)([p x]) - fx);
            cy = ((double)([p y]) - fy);
        } else {
            // դĤ(ϱ¦)
            cx = (fx - (double)([p x]));
            cy = (fy - (double)([p y]));
        }
        fx += ((cx * self->cos_) - (cy * self->sin_));
        fy += ((cx * self->sin_) + (cy * self->cos_));
    } else {
        if (self->greater_) {
            // Ĥ(Ͼ¦)
            cx = (fx - (double)([p x]));
            cy = ((double)([p y]) - fy);
        } else {
            // Ĥ(ϲ¦)
            cx = ((double)([p x]) - fx);
            cy = (fy - (double)([p y]));
        }
        fx += ((cy * self->cos_) - (cx * self->sin_));
        fy += ((cx * self->cos_) + (cy * self->sin_));
    }

    // ɸ
    [p setX:(int)(floor(fx + 0.5))
       setY:(int)(floor(fy + 0.5))];

    return;
}
#endif  // 0


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    spos : 
//    epos : 
//    opos : 
//
//  Return
//    function     : 
//    centerPos_   : 濴(instance ѿ)
//    ortPos_      : (instance ѿ)
//    leftTop_     : (ܾ̾)(instance ѿ)
//    rightTop_    : (ܾ̾)(instance ѿ)
//    leftBottom_  : (ܾ̾)(instance ѿ)
//    rightBottom_ : (ܾ̾)(instance ѿ)
//    cos_         : cos(instance ѿ)
//    sin_         : sin(instance ѿ)
//
-(id)initWithStartPos:(PoCoPoint *)spos
           withEndPos:(PoCoPoint *)epos
          ifAnyOrient:(PoCoPoint *)opos
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->centerPos_ = nil;
        self->ortPos_ = nil;
        self->leftTop_ = nil;
        self->rightTop_ = nil;
        self->leftBottom_ = nil;
        self->rightBottom_ = nil;
        self->cos_ = 1.0;
        self->sin_ = 0.0;

        // 濴򻻽
        self->centerPos_ = [[PoCoPoint alloc] initX:((([epos x] - [spos x]) / 2) + [spos x])
                                              initY:((([epos y] - [spos y]) / 2) + [spos y])];

        // 򵭲
        if (opos != nil) {
            self->ortPos_ = [[PoCoPoint alloc] initX:[opos x]
                                               initY:[opos y]];
        }

        // 4
        self->leftTop_ = [[PoCoPoint alloc] initX:[spos x]
                                            initY:[spos y]];
        self->rightTop_ = [[PoCoPoint alloc] initX:[epos x]
                                             initY:[spos y]];
        self->leftBottom_ = [[PoCoPoint alloc] initX:[spos x]
                                               initY:[epos y]];
        self->rightBottom_ = [[PoCoPoint alloc] initX:[epos x]
                                                initY:[epos y]];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    centerPos_   : 濴(instance ѿ)
//    ortPos_      : (instance ѿ)
//    leftTop_     : (ܾ̾)(instance ѿ)
//    rightTop_    : (ܾ̾)(instance ѿ)
//    leftBottom_  : (ܾ̾)(instance ѿ)
//    rightBottom_ : (ܾ̾)(instance ѿ)
//
-(void)dealloc
{
    // 񸻤
    [self->centerPos_ release];
    [self->ortPos_ release];
    [self->leftTop_ release];
    [self->rightTop_ release];
    [self->leftBottom_ release];
    [self->rightBottom_ release];
    self->centerPos_ = nil;
    self->ortPos_ = nil;
    self->leftTop_ = nil;
    self->rightTop_ = nil;
    self->leftBottom_ = nil;
    self->rightBottom_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 黻¹
//
//  Call
//    diagonal   : гѤѤ뤫
//    centerPos_ : 濴(instance ѿ)
//    ortPos_    : (instance ѿ)
//
//  Return
//    leftTop_     : (ܾ̾)(instance ѿ)
//    rightTop_    : (ܾ̾)(instance ѿ)
//    leftBottom_  : (ܾ̾)(instance ѿ)
//    rightBottom_ : (ܾ̾)(instance ѿ)
//    cos_         : cos(instance ѿ)
//    sin_         : sin(instance ѿ)
//
-(void)calc:(BOOL)diagonal
{
    double oc;
    double ec;
    int rot;
    double r;

    // ʤв⤷ʤ
    if (self->ortPos_ == nil) {
        goto EXIT;
    }

    // () cos 򻻽
    oc = ((double)([self->ortPos_ x] - [self->centerPos_ x]) / sqrt((double)(([self->ortPos_ x] - [self->centerPos_ x]) * ([self->ortPos_ x] - [self->centerPos_ x])) + (double)(([self->ortPos_ y] - [self->centerPos_ y]) * ([self->ortPos_ y] - [self->centerPos_ y]))));
    if (diagonal) {
        ec = ((double)([self->leftBottom_ x] - [self->centerPos_ x]) / sqrt((double)(([self->leftBottom_ x] - [self->centerPos_ x]) * ([self->leftBottom_ x] - [self->centerPos_ x])) + (double)(([self->leftBottom_ y] - [self->centerPos_ y]) * ([self->leftBottom_ y] - [self->centerPos_ y]))));
    } else {
        ec = ((double)([self->rightBottom_ x] - [self->centerPos_ x]) / sqrt((double)(([self->rightBottom_ x] - [self->centerPos_ x]) * ([self->rightBottom_ x] - [self->centerPos_ x])) + (double)(([self->rightBottom_ y] - [self->centerPos_ y]) * ([self->rightBottom_ y] - [self->centerPos_ y]))));
    }
    if (oc == ec) {
        // žǤʤΤǲ⤷ʤ
        goto EXIT;
    }

    // ž٤򻻽
    if (((!(diagonal)) && ([self->rightBottom_ y] < [self->centerPos_ y])) ||
        ((  diagonal ) && ([self->leftBottom_  y] < [self->centerPos_ y]))) {
        if ([self->ortPos_ y] < [self->centerPos_ y]) {
            rot = ((int)(floor((acos(ec) * PoCoDivPI) * 100.0)) - (int)(floor((acos(oc) * PoCoDivPI) * 100.0)));
        } else {
            rot = ((int)(floor((acos(oc) * PoCoDivPI) * 100.0)) + (int)(floor((acos(ec) * PoCoDivPI) * 100.0)));
        }
    } else {
        if ([self->ortPos_ y] < [self->centerPos_ y]) {
            rot = -((int)(floor((acos(oc) * PoCoDivPI) * 100.0)) + (int)(floor((acos(ec) * PoCoDivPI) * 100.0)));
        } else {
            rot = ((int)(floor((acos(oc) * PoCoDivPI) * 100.0)) - (int)(floor((acos(ec) * PoCoDivPI) * 100.0)));
        }
    }

    // radian ᤷ cossin 򻻽
    r = (((double)(rot) / 100.0) * PoCoMulPI);
    self->cos_ = cos(r);
    self->sin_ = sin(r);

    // κɸ򻻽
    [self calcPoint:self->leftTop_];
    [self calcPoint:self->rightTop_];
    [self calcPoint:self->leftBottom_];
    [self calcPoint:self->rightBottom_];

EXIT:
    return;
}


// --------------------------------------------- instance - public - ɸ
//
// (ܾ̾)
//
//  Call
//    leftTop_ : (ܾ̾)(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)leftTop
{
    return self->leftTop_;
}


//
// (ܾ̾)
//
//  Call
//    rightTop_ : (ܾ̾)(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)rightTop
{
    return self->rightTop_;
}


//
// (ܾ̾)
//
//  Call
//    leftBottom_ : (ܾ̾)(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)leftBottom
{
    return self->leftBottom_;
}


//
// (ܾ̾)
//
//  Call
//    rightBottom_ : (ܾ̾)(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)rightBottom
{
    return self->rightBottom_;
}

@end




// ============================================================================
@implementation PoCoCalcRotationForEllipse

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    cpos : 濴
//    epos : 
//    opos : 
//
//  Return
//    function  : 
//    rotation_ : ž(instance ѿ)
//    cos_      : self->rotation_  cos(instance ѿ)
//    sin_      : self->rotation_  sin(instance ѿ)
//    exec_     : žǽ(instance ѿ)
//
-(id)initWithCenterPos:(PoCoPoint *)cpos
            withEndPos:(PoCoPoint *)epos
           ifAnyOrient:(PoCoPoint *)opos
{
    int rot;
    double oc;
    double ec;

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->rotation_ = 0.0;
        self->cos_ = 0.0;
        self->sin_ = 0.0;
        self->exec_ = NO;

        // ٤򻻽
        if (opos != nil) {
            // cos 򻻽
            oc = ((double)([opos x] - [cpos x]) / sqrt((double)(([opos x] - [cpos x]) * ([opos x] - [cpos x])) + (double)(([opos y] - [cpos y]) * ([opos y] - [cpos y]))));
            ec = ((double)([epos x] - [cpos x]) / sqrt((double)(([epos x] - [cpos x]) * ([epos x] - [cpos x])) + (double)(([epos y] - [cpos y]) * ([epos y] - [cpos y]))));
        } else {
            oc = 0.0;
            ec = oc;
        }

        // žѤ򻻽
        if (oc != ec) {
            // degree 򻻽(0.01ñ̤θ꾮)
            if ([epos y] < [cpos y]) {
                if ([opos y] < [cpos y]) {
                    rot = ((int)(floor((acos(ec) * PoCoDivPI) * 100.0)) - (int)(floor((acos(oc) * PoCoDivPI) * 100.0)));
                } else {
                    rot = ((int)(floor((acos(oc) * PoCoDivPI) * 100.0)) + (int)(floor((acos(ec) * PoCoDivPI) * 100.0)));
                }
            } else {
                if ([opos y] < [cpos y]) {
                    rot = -((int)(floor((acos(oc) * PoCoDivPI) * 100.0)) + (int)(floor((acos(ec) * PoCoDivPI) * 100.0)));
                } else {
                    rot = ((int)(floor((acos(oc) * PoCoDivPI) * 100.0)) - (int)(floor((acos(ec) * PoCoDivPI) * 100.0)));
                }
            }

            // radian ᤷ cossin 򻻽
            self->rotation_ = (((double)(rot) / 100.0) * PoCoMulPI);
            self->cos_ = cos(self->rotation_);
            self->sin_ = sin(self->rotation_);

            // žǽ
            self->exec_ = YES;
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // 񸻤
    ;

    // super class β
    [super dealloc];

    return;
}


//
// žǽ
//
//  Call
//    exec_ : žǽ
//
//  Return
//    function : žǽ
//
-(BOOL)isExec
{
    return self->exec_;
}


//
// ʿɸ
//
//  Call
//    rot  : (0.1ñ̤θ꾮)
//    h    : ʿ
//    v    : ľ
//    cos_ : self->rotation_  cos(instance ѿ)
//    sin_ : self->rotation_  sin(instance ѿ)
//
//  Return
//    function : ɸ
//
-(int)calcXAxis:(int)rot
     horiLength:(int)h
     vertLength:(int)v
{
    return (int)(floor(((double)(h) * cos(((double)(rot) / 10.0) * PoCoMulPI) * self->cos_) - ((double)(v) * sin(((double)(rot) / 10.0) * PoCoMulPI) * self->sin_)));
}


//
// ľɸ
//
//  Call
//    rot  : (0.1ñ̤θ꾮)
//    h    : ʿ
//    v    : ľ
//    cos_ : self->rotation_  cos(instance ѿ)
//    sin_ : self->rotation_  sin(instance ѿ)
//
//  Return
//    function : ɸ
//
-(int)calcYAxis:(int)rot
     horiLength:(int)h
     vertLength:(int)v
{
    return (int)(floor(((double)(h) * cos(((double)(rot) / 10.0) * PoCoMulPI) * self->sin_) + ((double)(v) * sin(((double)(rot) / 10.0) * PoCoMulPI) * self->cos_)));
}

@end
