//
//	Pelistina on Cocoa - PoCo -
//	ݻ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoColorBuffer.h"

#import "PoCoPalette.h"

// ===================================================== PoCoColorBufferElement 

// ------------------------------------------------------------------ interface
@interface PoCoColorBufferElement : NSObject
{
    unsigned char index_;               // ֹ
    unsigned char r_;                   // ()
    unsigned char g_;                   // ()
    unsigned char b_;                   // ()
}

// initialize
-(id)init:(unsigned char)index
  withRed:(unsigned char)r
withGreen:(unsigned char)g
 withBlue:(unsigned char)b;

// deallocate
-(void)dealloc;

// property(get)
-(unsigned char)index;
-(NSString *)name;

// property(set)
-(void)setIndex:(unsigned char)index;

@end


// ------------------------------------------------------------------ implement
@implementation PoCoColorBufferElement

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    index : ֹ
//    r     : ()
//    g     : ()
//    b     : ()
//
//  Return
//    index_ : ֹ(instance ѿ)
//    r_     : ()(instance ѿ)
//    g_     : ()(instance ѿ)
//    b_     : ()(instance ѿ)
//
-(id)init:(unsigned char)index
  withRed:(unsigned char)r
withGreen:(unsigned char)g
 withBlue:(unsigned char)b
{
    // super class ز
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->index_ = index;
        self->r_ = r;
        self->g_ = g;
        self->b_ = b;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class ز
    [super dealloc];

    return;
}


//
// ֹ
//
//  Call
//    index_ : ֹ(instance ѿ)
//
//  Return
//    function : ֹ
//
-(unsigned char)index
{
    return self->index_;
}


//
// ̾μ
//
//  Call
//    r_ : ()(instance ѿ)
//    g_ : ()(instance ѿ)
//    b_ : ()(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)name
{
    return [NSString stringWithFormat:@"rgb:%02x%02x%02x", self->r_, self->g_, self->b_];
}


//
// ֹ
//
//  Call
//    index : ֹ
//
//  Return
//    index_ : ֹ(instance ѿ)
//
-(void)setIndex:(unsigned char)index
{
    self->index_ = index;
}
@end




// =================================================== PoCoColorOnceCalcElement 

// ------------------------------------------------------------------ interface
@interface PoCoColorOnceCalcElement : NSObject
{
    PoCoColorMode colMode_;             // 黻⡼
    int density1_;                      // ǻ(0.1%ñ)((i1))
    int density2_;                      // ǻ(0.1%ñ)((i2))
    unsigned char index1_;              // 1(迧ֹ)
    unsigned char index2_;              // 2(ֹ)
    unsigned char result_;              // 黻̤οֹ
}

// class method
+(NSString *)createName:(PoCoColorMode)colMode
           withDensity1:(int)d1
           withDensity2:(int)d2
             withColor1:(unsigned char)i1
             withColor2:(unsigned char)i2;

// initialize
-(id)init:(PoCoColorMode)colMode
withDensity1:(int)d1
withDensity2:(int)d2
  withColor1:(unsigned char)i1
  withColor2:(unsigned char)i2
  withResult:(unsigned char)ch;

// deallocate
-(void)dealloc;

// property(get)
-(unsigned char)index;
-(NSString *)name;

@end


// ------------------------------------------------------------------ implement
@implementation PoCoColorOnceCalcElement

// ------------------------------------------------------------- class - public
//
// ̾μ
//
//  Call
//    colMode : 黻⡼
//    d1      : ǻ(0.1%ñ)((i1))
//    d2      : ǻ(0.1%ñ)((i2))
//    i1      : 1(迧ֹ)
//    i2      : 2(ֹ)
//
//  Return
//    function : ʸ
//
+(NSString *)createName:(PoCoColorMode)colMode
           withDensity1:(int)d1
           withDensity2:(int)d2
             withColor1:(unsigned char)i1
             withColor2:(unsigned char)i2
{
    return [NSString stringWithFormat:@"once:%d%04d%04d%02d%02d", (int)(colMode), d1, d2, i1, i2];
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    colMode : 黻⡼
//    d1      : ǻ(0.1%ñ)((i1))
//    d2      : ǻ(0.1%ñ)((i2))
//    i1      : 1(迧ֹ)
//    i2      : 2(ֹ)
//    ch      : 黻̤οֹ
//
//  Return
//    colMode_  : 黻⡼(instance ѿ)
//    density1_ : ǻ(0.1%ñ)((i1))(instance ѿ)
//    density2_ : ǻ(0.1%ñ)((i2))(instance ѿ)
//    index1_   : 1(迧ֹ)(instance ѿ)
//    index2_   : 2(ֹ)(instance ѿ)
//    result_   : 黻̤οֹ(instance ѿ)
//
-(id)init:(PoCoColorMode)colMode
withDensity1:(int)d1
withDensity2:(int)d2
  withColor1:(unsigned char)i1
  withColor2:(unsigned char)i2
  withResult:(unsigned char)ch
{
    // super class ز
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->colMode_ = colMode;
        self->density1_ = d1;
        self->density2_ = d2;
        self->index1_ = i1;
        self->index2_ = i2;
        self->result_ = ch;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class ز
    [super dealloc];

    return;
}


//
// ֹ
//
//  Call
//    result_ : 黻̤οֹ(instance ѿ)
//
//  Return
//    function : ֹ
//
-(unsigned char)index
{
    return self->result_;
}


//
// ̾μ
//
//  Call
//    colMode_  : 黻⡼(instance ѿ)
//    density1_ : ǻ(0.1%ñ)((i1))(instance ѿ)
//    density2_ : ǻ(0.1%ñ)((i2))(instance ѿ)
//    index1_   : 1(迧ֹ)(instance ѿ)
//    index2_   : 2(ֹ)(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)name
{
    return [PoCoColorOnceCalcElement createName:self->colMode_
                                   withDensity1:self->density1_
                                   withDensity2:self->density2_
                                     withColor1:self->index1_
                                     withColor2:self->index2_];
}

@end




// ============================================================================
@implementation PoCoColorBuffer


// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    palette : ѥå(nil Բ)
//    r       : оݿ()
//    g       : оݿ()
//    b       : оݿ()
//
//  Return
//    function : ֹ
//
+(unsigned char)find:(PoCoPalette *)palette
             withRed:(unsigned char)r
           withGreen:(unsigned char)g
            withBlue:(unsigned char)b
{
    unsigned char index;
    int l;
    PoCoColor *col;
    int diff;                           // 俧οΥ
    int cdiff;                          // 򿧤οΥ

    diff = INT_MAX;
    index = 0;

    for (l = 0; l < COLOR_MAX; (l)++) {
        col = [palette palette:l];
        if ([col noDropper]) {
            // Ѷػ
            ; 
        } else {
            cdiff =   abs(r - [col red])
                    + abs(g - [col green])
                    + abs(b - [col blue]);
            if (cdiff == 0) {
                // 
                index = (unsigned char)(l);
                break;
            } else if (cdiff < diff) {
                // ȤƵ
                index = (unsigned char)(l);
                diff = cdiff;
            }
        }
    }

    return index;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    buffer_ : ݻΰ(instance ѿ)
//
-(id)init
{
    // super class ز
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->buffer_ = [[NSMutableDictionary alloc] init];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    buffer_ : ݻΰ(instance ѿ)
//
-(void)dealloc
{
    // 񸻤β
    [self->buffer_ release];
    self->buffer_ = nil;

    // super class ز
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    palette : ѥå
//              == nil : ݻΰƹۤʤ(˺)
//              != nil : ݻΰƹۤ(Ѳǽʿ)
//
//  Return
//    buffer_ : ݻΰ(instance ѿ)
//
-(void)reset:(PoCoPalette *)palette
{
    // ٤˺
    [self->buffer_ removeAllObjects];

    // ƹ
    if (palette != nil) {
        [self create:palette isAlways:YES];
    }

    return;
}


//
// 
//
//  Call
//    palette : ѥå
//    always  : ˹ۤ뤫
//              YES : ۤ
//              NO  : 1ĤǤݻƤйۤʤ
//
//  Return
//    buffer_ : ݻΰ(instance ѿ)
//
-(void)create:(PoCoPalette *)palette
     isAlways:(BOOL)always
{
    int l;
    PoCoColor *col;
    PoCoColorBufferElement *elm;

    // 
    if ((always) || ([self->buffer_ count] == 0)) {
        for (l = 0; l < COLOR_MAX; (l)++) {
            col = [palette palette:l];
            if ([col noDropper]) {
                // Ѷػ߿Ͻ
                ;
            } else {
                // Ǥ
                elm = [[PoCoColorBufferElement alloc] init:(unsigned char)(l)
                                                   withRed:[col red]
                                                 withGreen:[col green]
                                                  withBlue:[col blue]];

                // ݻΰϿ
                [self->buffer_ setValue:elm
                                 forKey:[elm name]];
                [elm release];
            }
        }
    }

    return;
}


//
// 
//
//  Call
//    palette : ѥå(nil Բ)
//    r       : оݿ()
//    g       : оݿ()
//    b       : оݿ()
//    buffer_ : ݻΰ(instance ѿ)
//
//  Return
//    function : ֹ
//    buffer_  : ݻΰ(instance ѿ)
//
-(unsigned char)findWithBuffer:(PoCoPalette *)palette
                       withRed:(unsigned char)r
                     withGreen:(unsigned char)g
                      withBlue:(unsigned char)b
{
    unsigned char index;
    PoCoColorBufferElement *elm;
    PoCoColorBufferElement *tmp;

    // Ǥ
    elm = [[PoCoColorBufferElement alloc] init:0
                                       withRed:r
                                     withGreen:g
                                      withBlue:b];

    // ݻΰ䤤碌
    tmp = [self->buffer_ valueForKey:[elm name]];
    if (tmp != nil) {
        index = [tmp index];
    } else {
        // ʤжᤤõݻΰɲ
        index = [PoCoColorBuffer find:palette
                              withRed:r
                            withGreen:g
                             withBlue:b];
        [elm setIndex:index];
        [self->buffer_ setValue:elm
                         forKey:[elm name]];
    }

    [elm release];
    return index;
}


//
// α黻̤õ
//
//  Call
//    colMode : 黻⡼
//    d1      : ǻ(0.1%ñ)((i1))
//    d2      : ǻ(0.1%ñ)((i2))
//    i1      : 1(迧ֹ)
//    i2      : 2(ֹ)
//    buffer_ : ݻΰ(instance ѿ)
//
//  Return
//    function : 
//               <  0 : Ĥʤä
//               >= 0 : Ĥֹ
//
-(int)findOnceCalc:(PoCoColorMode)colMode
      withDensity1:(int)d1
      withDensity2:(int)d2
        withColor1:(unsigned char)i1
        withColor2:(unsigned char)i2
{
    PoCoColorOnceCalcElement *tmp;

    tmp = [self->buffer_ valueForKey:[PoCoColorOnceCalcElement
                                         createName:colMode
                                       withDensity1:d1
                                       withDensity2:d2
                                         withColor1:i1
                                         withColor2:i2]];

    return ((tmp != nil) ? [tmp index] : -1);
}


//
// α黻̤ɲ
//
//  Call
//    colMode : 黻⡼
//    d1      : ǻ(0.1%ñ)((i1))
//    d2      : ǻ(0.1%ñ)((i2))
//    i1      : 1(迧ֹ)
//    i2      : 2(ֹ)
//    ch      : 黻̤οֹ
//
//  Return
//    buffer_ : ݻΰ(instance ѿ)
//
-(void)addOnceCalc:(PoCoColorMode)colMode
      withDensity1:(int)d1
      withDensity2:(int)d2
        withColor1:(unsigned char)i1
        withColor2:(unsigned char)i2
        withResult:(unsigned char)ch
{
    PoCoColorOnceCalcElement *elm;

    elm = [[PoCoColorOnceCalcElement alloc] init:colMode
                                    withDensity1:d1
                                    withDensity2:d2
                                      withColor1:i1
                                      withColor2:i2
                                      withResult:ch];
    [self->buffer_ setValue:elm
                     forKey:[elm name]];
    [elm release];

    return;
}

@end
