//
//	Pelistina on Cocoa - PoCo -
//	
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoColorMixer.h"

#import "PoCoPalette.h"
#import "PoCoColorBuffer.h"

// ============================================================================
@implementation PoCoColorMixerUnit

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    e1 : 1
//    e2 : 2
//    e3 : 3
//
//  Return
//    e1_ : 1(instance ѿ)
//    e2_ : 2(instance ѿ)
//    e3_ : 3(instance ѿ)
//
-(id)initWithElement1:(int)e1
         withElement2:(int)e2
         withElement3:(int)e3
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->e1_ = e1;
        self->e2_ = e2;
        self->e3_ = e3;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// (1)
//
//  Call
//    e1_ : 1(instance ѿ)
//
//  Return
//    function : 
//
-(int)element1
{
    return self->e1_;
}


//
// (2)
//
//  Call
//    e2_ : 2(instance ѿ)
//
//  Return
//    function : 
//
-(int)element2;
{
    return self->e2_;
}


//
// (3)
//
//  Call
//    e3_ : 3(instance ѿ)
//
//  Return
//    function : 
//
-(int)element3;
{
    return self->e3_;
}

@end




// ============================================================================
@implementation PoCoColorMixer

// ------------------------------------------------------------- class - public
//
// 黻(2ʿ)
//
//  Call
//    palette : ѥѥå
//    colMode : 黻⡼
//    d2      : ǻ(0.1%ñ)((i2))
//    i1      : 1(迧ֹ)
//    i2      : 2(ֹ)
//    buffer  : ݻ
//              == nil : Ѥʤ༡
//              != nil : Хåեõ
//
//  Return
//    function : 
//
+(unsigned char)calcColor:(PoCoPalette *)palette
                  colMode:(PoCoColorMode)colMode
                 density2:(int)d2
                   color1:(unsigned char)i1
                   color2:(unsigned char)i2
                   buffer:(PoCoColorBuffer *)buffer
{
    unsigned char ch = i1;              // ͤΤޤ
    int i;
    unsigned char e[3];                 // (RGB ʤ HLS)
    unsigned char h[2];                 // (0 : i1ѡ1 : i2)
    PoCoColor *cd;                      // (candidate)
    const unsigned int d1 = (1000 - d2);
    const PoCoColor *c1 = [palette palette:i1];
    const PoCoColor *c2 = [palette palette:i2];

    // ǻ100%ΰ
    if (d2 <= 0) {
        // οΤޤ
        ;
        goto EXIT;
    } else if ((d2 >= 1000) && (!([[palette palette:i2] noDropper]))) {
        // Τߤˤʤ
        ch = i2;
        goto EXIT;
    }

    // α黻Ʊ
    if (buffer != nil) {
        i = [buffer findOnceCalc:colMode
                    withDensity1:d1
                    withDensity2:d2
                      withColor1:i1
                      withColor2:i2];
        if (i >= 0) {
            ch = (unsigned char)(i);
            goto EXIT;
        }
    }

    // Ǽ
    if (colMode == PoCoColorMode_RGB) {
        // RGB
        e[0] = ((([c1 red]   * d1) + ([c2 red]   * d2)) / 1000);
        e[1] = ((([c1 green] * d1) + ([c2 green] * d2)) / 1000);
        e[2] = ((([c1 blue]  * d1) + ([c2 blue]  * d2)) / 1000);
    } else {
        // HLS
        if ([c2 saturation] == 0) {
            // ̵̿ʤΤǿˤ
            e[0] = [c1 hue];
            e[2] = [c1 saturation];
        } else if ([c1 saturation] == 0) {
            // 褬̵̿ʤΤǿˤ
            e[0] = [c2 hue];
            e[2] = [c2 saturation];
        } else {
            // ֿȤ
            h[0] = [c1 hue];
            h[1] = [c2 hue];
            if (h[1] < h[0]) {
                if ((h[0] - h[1]) <= (256 - h[0] + h[1])) {
                    i = (h[0] - (((h[0] - h[1]) * d2) / 1000));
                } else {
                    i = (h[0] + (((256 - h[0] + h[1]) * d2) / 1000));
                }
            } else {
                if ((h[1] - h[0]) <= (256 - h[1] + h[0])) {
                    i = (h[0] + (((h[1] - h[0]) * d2) / 1000));
                } else {
                    i = (h[0] - (((255 - h[1] + h[0]) * d2) / 1000));
                }
            }
            if (i < 0) {
                i += 255;
            } else if (i > 255) {
                i -= 255;
            }

            e[0] = (unsigned char)(i);
            e[2] = ((([c1 saturation] * d1) + ([c2 saturation] * d2)) / 1000);
        }
        e[1] = ((([c1 lightness] * d1) + ([c2 lightness] * d2)) / 1000);

        // RGB ᤹
        cd = [[PoCoColor alloc] init];
        [cd setHue:e[0] setLightness:e[1] setSaturation:e[2]];
        e[0] = [cd red];
        e[1] = [cd green];
        e[2] = [cd blue];
        [cd release];
    }
 
    // 
    if (buffer != nil) {
        // ݻƤ뿧õ
        ch = [buffer findWithBuffer:palette
                            withRed:e[0]
                          withGreen:e[1]
                           withBlue:e[2]];

        // α黻̤ȤƵ
        [buffer addOnceCalc:colMode
               withDensity1:d1
               withDensity2:d2
                 withColor1:i1
                 withColor2:i2
                 withResult:ch];
    } else {
        // ༡õ
        ch = [PoCoColorBuffer find:palette
                           withRed:e[0]
                         withGreen:e[1]
                          withBlue:e[2]];
    }
    
EXIT:
    return ch;
}


//
// 黻(ǤոĿʿ)
//  RGB 黻
//
//  Call
//    palette : ѥѥå
//    cols    : оݤο
//    buffer  : ݻ
//              == nil : Ѥʤ༡
//              != nil : Хåեõ
//    org     : 黻濴οֹ
//
//  Return
//    function : 
//
+(unsigned char)calcColorRGB:(PoCoPalette *)palette
                  withColors:(NSArray *)cols
                      buffer:(PoCoColorBuffer *)buffer
                    orgColor:(unsigned char)org
{
    unsigned char ch = org;
    NSEnumerator *iter;
    PoCoColorMixerUnit *c;
    float r;
    float g;
    float b;

    iter = [cols objectEnumerator];

    // ֤­
    c = [iter nextObject];
    r = ((float)([c element1]) / 255.0);
    g = ((float)([c element2]) / 255.0);
    b = ((float)([c element3]) / 255.0);
    for (c = [iter nextObject]; c != nil; c = [iter nextObject]) {
        r += ((float)([c element1]) / 255.0);
        g += ((float)([c element2]) / 255.0);
        b += ((float)([c element3]) / 255.0);
    }

    // ʿͻ
    r = ((r / (float)([cols count])) * 255.0);
    g = ((g / (float)([cols count])) * 255.0);
    b = ((b / (float)([cols count])) * 255.0);

    // 
    if (buffer != nil) {
        // ݻƤ뿧õ
        ch = [buffer findWithBuffer:palette
                            withRed:(int)(floor(r))
                          withGreen:(int)(floor(g))
                           withBlue:(int)(floor(b))];
    } else {
        // ༡õ
        ch = [PoCoColorBuffer find:palette
                           withRed:(int)(floor(r))
                         withGreen:(int)(floor(g))
                          withBlue:(int)(floor(b))];
    }

    return ch;
}


//
// 黻(ǤոĿʿ)
//  HLS 黻
//
//  Call
//    palette : ѥѥå
//    cols    : оݤο
//    buffer  : ݻ
//              == nil : Ѥʤ༡
//              != nil : Хåեõ
//    org     : 黻濴οֹ
//
//  Return
//    function : 
//
+(unsigned char)calcColorHLS:(PoCoPalette *)palette
                  withColors:(NSArray *)cols
                      buffer:(PoCoColorBuffer *)buffer
                    orgColor:(unsigned char)org
{
    unsigned char ch = org;
    NSEnumerator *iter;
    PoCoColorMixerUnit *c;
    int h;
    float l;
    float s;
    int cnum;
    int hbuf;
    int rbuf;
    int bbuf;
    PoCoColor *cd;

    iter = [cols objectEnumerator];
    cnum = 0;

    // ֤­
    h = [[palette palette:org] hue];
    l = 0.0;
    s = 0.0;
    bbuf = [[palette palette:org] saturation];
    rbuf = ((bbuf == 0) ? -1 : 0);
    for (c = [iter nextObject]; c != nil; c = [iter nextObject]) {
        hbuf = [c element1];
        if (bbuf == 0) {
            if (rbuf < 0) {
                if ([c element3] > 0) {
                    rbuf = hbuf;
                    (cnum)++;
                }
            } else if ([c element3] > 0) {
                if (hbuf < rbuf) {
                    if ((rbuf - hbuf) < (255 - rbuf + hbuf)) {
                        rbuf = ((rbuf + hbuf) >> 1);
                    } else {
                        rbuf += ((255 - rbuf + hbuf) >> 1);
                        if (rbuf > 255) {
                            rbuf -= 255;
                        }
                    }
                } else {
                    if ((hbuf - rbuf) < (255 - hbuf + rbuf)) {
                        rbuf = ((rbuf + hbuf) >> 1);
                    } else {
                        rbuf -= ((255 - hbuf + rbuf) >> 1);
                        if (rbuf < 0) {
                            rbuf += 255;
                        }
                    }
                }
                s += ((float)([c element3]) / 255.0);
                (cnum)++;
            }
        } else if ([c element3] > 0) {
            if (h < hbuf) {
                if ((hbuf - h) <= (256 - hbuf + h)) {
                    rbuf += ((hbuf - h) >> 1);
                } else {
                    rbuf += ((hbuf - 255 - h) >> 1);
                }
            } else {
                if ((h - hbuf) <= (256 - h + hbuf)) {
                    rbuf += ((hbuf - h) >> 1);
                } else {
                    rbuf += ((255 - h + hbuf) >> 1);
                }
            }
            s += ((float)([c element3]) / 255.0);
            (cnum)++;
        }
        l += ((float)([c element2]) / 255.0);
    }

    // ʿͻ
    if (cnum > 0) {
        if (bbuf == 0) {
            h = rbuf;
        } else {
            h += (rbuf / cnum);
        }
        l = ((l / (float)([cols count])) * 255.0);
        s = ((s / (float)(cnum)) * 255.0);
        if (h < 0) {
            h += 255;
        } else if (h > 255) {
            h -= 255;
        }

        // 
        cd = [[PoCoColor alloc] init];
        [cd setHue:h setLightness:(int)(floor(l)) setSaturation:(int)(floor(s))];
        if (buffer != nil) {
            // ݻƤ뿧õ
            ch = [buffer findWithBuffer:palette
                                withRed:[cd red]
                              withGreen:[cd green]
                               withBlue:[cd blue]];
        } else {
            // ༡õ
            ch = [PoCoColorBuffer find:palette
                               withRed:[cd red]
                             withGreen:[cd green]
                              withBlue:[cd blue]];
        }
        [cd release];
    }

    return ch;
}

@end
