//
//	Pelistina on Cocoa - PoCo -
//	ޥ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoCreateStyleMask.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoPicture.h"
#import "PoCoMyDocument.h"
#import "PoCoTilePattern.h"

#import "PoCoCalcRotation.h"
#import "PoCoCalcEllipse.h"
#import "PoCoEditInvertPolygon.h"
#import "PoCoEditNormalPaint.h"

// ============================================================================
@implementation PoCoCreateStyleMask

// ------------------------------------------------------------ class - private
//
// bitmap 
//  ޥȤƤ¤ʤΤǡֹ椬 0 ݤΤ
//
//  Call
//    dstRect    : ̤(ºɸ)(joinRect 񤹤뤳)
//    joinBitmap : 黻о
//    joinRect   : 黻оݤ(ºɸ)
//
//  Return
//    dstBitmap : 
//
+(void)orBitmap:(PoCoBitmap *)dstBitmap
        dstRect:(PoCoRect *)dstRect
     joinBitmap:(PoCoBitmap *)joinBitmap
       joinRect:(PoCoRect *)joinRect
{
    const int jw = [joinBitmap width];
    const int jskip = (jw & 0x01);
    const int dw = [dstBitmap width];
    const int drow = (dw + (dw & 0x01));
    const int dskip = (drow - jw);
    int x;
    int y;
    unsigned char *dbmp;
    unsigned char *jbmp;

    dbmp = ([dstBitmap pixelmap] + ((([joinRect top] - [dstRect top]) * drow) + ([joinRect left] - [dstRect left])));
    jbmp = [joinBitmap pixelmap];

    // ľ
    y = [joinBitmap height];
    do {
        // ʿ
        x = jw;
        do {
            // 
            *(dbmp) |= *(jbmp);

            // 
            (x)--;
            (dbmp)++;
            (jbmp)++;
        } while (x != 0);

        // 
        (y)--;
        dbmp += dskip;
        jbmp += jskip;
    } while (y != 0);

    return;
}


//
// bitmap ¾
//  ¾ʬοֹ椬 0 Ǥʤз̤ӽ
//
//  Call
//    dstRect    : ̤(ºɸ)(sprtRect 񤹤뤳)
//    sprtBitmap : 黻о
//    sprtRect   : 黻оݤ(ºɸ)
//
//  Return
//    dstBitmap : 
//
+(void)excludeBitmap:(PoCoBitmap *)dstBitmap
             dstRect:(PoCoRect *)dstRect
      separateBitmap:(PoCoBitmap *)sprtBitmap
        separateRect:(PoCoRect *)sprtRect
{
    const int sw = [sprtBitmap width];
    const int sskip = (sw & 0x01);
    const int dw = [dstBitmap width];
    const int drow = (dw + (dw & 0x01));
    const int dskip = (drow - sw);
    int x;
    int y;
    unsigned char *dbmp;
    const unsigned char *sbmp;

    dbmp = ([dstBitmap pixelmap] + ((([sprtRect top] - [dstRect top]) * drow) + ([sprtRect left] - [dstRect left])));
    sbmp = [sprtBitmap pixelmap];

    // ľ
    y = [sprtBitmap height];
    do {
        // ʿ
        x = sw;
        do {
            // ¾
            if (*(sbmp) != 0x00) {
                *(dbmp) = 0x00;
            }

            // 
            (x)--;
            (dbmp)++;
            (sbmp)++;
        } while (x != 0);

        // 
        (y)--;
        dbmp += dskip;
        sbmp += sskip;
    } while (y != 0);

    return;
}


//
// Ȥ򹹿
//  ¾ˤäƾʤ(礭Ѥʤ)Τߤ
//
//  Call
//    rect   : (ºɸ)
//    bitmap : оݥޥ
//
//  Return
//    rect : (ºɸ)
//
+(void)resizeRect:(PoCoRect *)rect
       withBitmap:(PoCoBitmap *)bitmap
{
    const int skip = ([bitmap width] & 0x01);
    int l = INT_MAX;
    int t = INT_MAX;
    int r = INT_MIN;
    int b = INT_MIN;
    int x;
    int y;
    int h;
    int w;
    const unsigned char *bmp;

    bmp = [bitmap pixelmap];
    y = [rect top];
    h = [bitmap height];
    do {
        // ʿ
        x = [rect left];
        w = [bitmap width];
        do {
            if (*(bmp) != 0x00) {
                l = MIN(x, l);
                t = MIN(y, t);
                r = MAX(x, r);
                b = MAX(y, b);
            }

            // 
            (x)++;
            (w)--;
            (bmp)++;
        } while (w != 0);

        // 
        (y)++;
        (h)--;
        bmp += skip;
    } while (h != 0);

    // Ȥ򹹿
    [rect   setLeft:l];
    [rect    setTop:t];
    [rect  setRight:(r + 1)];
    [rect setBottom:(b + 1)];

    return;
}


// --------------------------------------------------------- instance - private
//
// ΰλ()
//
//  Call
//    startPos : 
//    endPos   : 轪
//    ort      : 
//    diagonal : гѤѤ뤫
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcBoxRect:(PoCoPoint *)startPos
                     end:(PoCoPoint *)endPos
             orientation:(PoCoPoint *)ort
              isDiagonal:(BOOL)diagonal
{
    PoCoRect *r;
    PoCoCalcRotationForBox *rot;

    r = [[PoCoRect alloc] initLeft:INT_MAX
                           initTop:INT_MAX
                         initRight:INT_MIN
                        initBottom:INT_MIN];

    // žɸ򻻽
    rot = [[PoCoCalcRotationForBox alloc] initWithStartPos:startPos
                                                withEndPos:endPos
                                               ifAnyOrient:ort];
    [rot calc:diagonal];

    // 
    [r setLeft:MIN([r left], [[rot leftTop] x])];
    [r setLeft:MIN([r left], [[rot rightTop] x])];
    [r setLeft:MIN([r left], [[rot leftBottom] x])];
    [r setLeft:MIN([r left], [[rot rightBottom] x])];

    // 
    [r setTop:MIN([r top], [[rot leftTop] y])];
    [r setTop:MIN([r top], [[rot rightTop] y])];
    [r setTop:MIN([r top], [[rot leftBottom] y])];
    [r setTop:MIN([r top], [[rot rightBottom] y])];

    // 
    [r setRight:MAX([r right], [[rot leftTop] x])];
    [r setRight:MAX([r right], [[rot rightTop] x])];
    [r setRight:MAX([r right], [[rot leftBottom] x])];
    [r setRight:MAX([r right], [[rot rightBottom] x])];

    // 
    [r setBottom:MAX([r bottom], [[rot leftTop] y])];
    [r setBottom:MAX([r bottom], [[rot rightTop] y])];
    [r setBottom:MAX([r bottom], [[rot leftBottom] y])];
    [r setBottom:MAX([r bottom], [[rot rightBottom] y])];

    [rot release];
    return r;
}


//
// ΰλ(/ʱ)
//
//  Call
//    startPos : ()
//    endPos   : 轪()
//    ort      : 
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcEllipseRect:(PoCoPoint *)startPos
                         end:(PoCoPoint *)endPos
                 orientation:(PoCoPoint *)ort
{
    PoCoRect *r;
    int i;
    PoCoCalcRotationForEllipse *rot;
    int x;
    int y;
    int h;
    int v;
    int d;

    r = [[PoCoRect alloc] init];

    // ʿλ
    i = ([startPos x] < [endPos x]) ? ([endPos x] - [startPos x]) :
                                      ([startPos x] - [endPos x]);
    [r setLeft:([startPos x] - i)];
    [r setRight:([startPos x] + i + 1)];
     
    // ľλ  
    i = ([startPos y] < [endPos y]) ? ([endPos y] - [startPos y]) :
                                      ([startPos y] - [endPos y]);
    [r setTop:([startPos y] - i)];
    [r setBottom:([startPos y] + i + 1)];

    // ˤžȿ
    rot = [[PoCoCalcRotationForEllipse alloc] initWithCenterPos:startPos
                                                     withEndPos:endPos
                                                    ifAnyOrient:ort];
    if ([rot isExec]) {  
        h = ([r width] / 2);
        v = ([r height] / 2);
        [r setLeft:INT_MAX];
        [r setTop:INT_MAX];
        [r setRight:INT_MIN];
        [r setBottom:INT_MIN];
        for (d = 0; d < 3600; (d)++) {
            x = ([startPos x] + [rot calcXAxis:d
                                    horiLength:h
                                    vertLength:v]);
            y = ([startPos y] + [rot calcYAxis:d
                                    horiLength:h
                                    vertLength:v]);
            if (x < [r left]) {
                [r setLeft:x];
            } else if (x > [r right]) {
                [r setRight:x];
            }
            if (y < [r top]) {
                [r setTop:y];         
            } else if (y > [r bottom]) {
                [r setBottom:y];
            }
        }
    }
    [rot release];

    return r;
}


//
// ΰλ(ʿԻշ)
//
//  Call
//    firstPos  : 1
//    secondPos : 2
//    thirdPos  : 3
//    fourthPos : 4
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcParallelogramRect:(PoCoPoint* )firstPos
                            second:(PoCoPoint *)secondPos
                             third:(PoCoPoint *)thirdPos
                            fourth:(PoCoPoint *)fourthPos
{
    PoCoRect *r;

    r = [[PoCoRect alloc] initLeft:[firstPos x]
                           initTop:[firstPos y]
                         initRight:[firstPos x]
                        initBottom:[firstPos y]];

    // 
    if ([secondPos x] < [r left]) { [r setLeft:[secondPos x]]; }
    if ([thirdPos  x] < [r left]) { [r setLeft:[thirdPos  x]]; }
    if ([fourthPos x] < [r left]) { [r setLeft:[fourthPos x]]; }

    // 
    if ([secondPos y] < [r top]) { [r setTop:[secondPos y]]; }
    if ([thirdPos  y] < [r top]) { [r setTop:[thirdPos  y]]; }
    if ([fourthPos y] < [r top]) { [r setTop:[fourthPos y]]; }

    // 
    if ([r right] < [secondPos x]) { [r setRight:[secondPos x]]; }
    if ([r right] < [thirdPos  x]) { [r setRight:[thirdPos  x]]; }
    if ([r right] < [fourthPos x]) { [r setRight:[fourthPos x]]; }

    // 
    if ([r bottom] < [secondPos y]) { [r setBottom:[secondPos y]]; }
    if ([r bottom] < [thirdPos  y]) { [r setBottom:[thirdPos  y]]; }
    if ([r bottom] < [fourthPos y]) { [r setBottom:[fourthPos y]]; }

    return r;
}


//
// ΰλ(ľ)
//
//  Call
//    points : 
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcPolygonRect:(NSMutableArray *)points
{
    PoCoRect *r;
    NSEnumerator *iter;
    PoCoPoint *p;

    r = [[PoCoRect alloc] initLeft:INT_MAX
                           initTop:INT_MAX
                         initRight:INT_MIN
                        initBottom:INT_MIN];
    iter = [points objectEnumerator];
    for (p = [iter nextObject]; p != nil; p = [iter nextObject]) {
        [r   setLeft:MIN([p x], [r   left])];
        [r    setTop:MIN([p y], [r    top])];
        [r  setRight:MAX([p x], [r  right])];
        [r setBottom:MAX([p y], [r bottom])];
    }

    return r;
}


//
// ɤ(seed paint)¹
//
//  Call
//    p       : о(seed)
//    bmp     : оݲ
//    bmpRect : оݲ(ºɸ)
//    border  : ꤫
//              YES : ˤɤ
//              NO  : ɸοˤɤ
//    range   : ϰ
//
//  Return
//    edit : ԽϤμ
//
-(void)executePaint:(PoCoEditNormalPaint **)edit
         targetPont:(PoCoPoint *)p
         withBitmap:(PoCoBitmap *)bmp
         bitmapRect:(PoCoRect *)bmpRect
           isBorder:(BOOL)border
         colorRange:(int)range
{
    PoCoPoint *tp;
    PoCoBitmap *tbmp;
    PoCoColorPattern *pat;

    tp = nil;
    tbmp = nil;
    pat = nil;

    // оݲʣ
    tbmp = [bmp copy];
    if (tbmp == nil) {
        DPRINT((@"can't copy bitmap.\n"));
        goto EXIT;
    }

    // ɸ
    tp = [[PoCoPoint alloc] initX:([p x] - [bmpRect left])
                            initY:([p y] - [bmpRect top])];
    if (tp == nil) {
        DPRINT((@"can't create normalized point.\n"));
        goto EXIT;
    }

    // ƥ顼ѥ
    pat = [[PoCoColorPattern alloc] initWidth:1
                                   initHeight:1
                                 defaultColor:[tbmp pixelmap][([tp y] * ([tbmp width] + ([tbmp width] & 0x01))) + [tp x]]];

    // ɤ¹
    if (border) {
        // 
        *(edit) = [[PoCoEditNormalBorderPaint alloc] 
                      initWithPattern:tbmp
                              palette:[[[[NSDocumentController sharedDocumentController] currentDocument] picture] palette]
                                 tile:[[(PoCoAppController *)([NSApp delegate]) tileSteadyPattern] pattern:7]
                              pattern:pat
                               border:[[(PoCoAppController *)([NSApp delegate]) editInfo] selColor]];
    } else {
        // ɸƱ쿧
        *(edit) = [[PoCoEditNormalPaint alloc] 
                      initWithPattern:tbmp
                              palette:[[[[NSDocumentController sharedDocumentController] currentDocument] picture] palette]
                                 tile:[[(PoCoAppController *)([NSApp delegate]) tileSteadyPattern] pattern:7]
                              pattern:pat
                                range:range];
    }
    [*(edit) executeDraw:tp];

EXIT:
    [pat release];
    [tbmp release];
    [tp release];
    return;
}


//
// ѤߤΥޥޥ˷
//
//  Call
//    drawnBitmap : Ѥߥޥ
//    drawnRect   : Ѥߤ(ºɸ)
//    styleRect   : ޥ(ºɸ)
//    styleBitmap : ޥ(instance ѿ)
//
//  Return
//    resultRect : (ºɸ)
//    styleMask_ : ޥ(instance ѿ)
//
-(void)joinMaskBitmap:(PoCoBitmap *)drawnBitmap
             maskRect:(PoCoRect *)drawnRect
          styleBitmap:(PoCoBitmap *)styleBitmap
            styleRect:(PoCoRect *)styleRect
           resultRect:(PoCoRect *)resultRect
{
    PoCoBitmap *dstBitmap;

    // ɤäȤζȼ
    if ((styleRect != nil) && (styleBitmap != nil)) {
        [resultRect   setLeft:MIN([styleRect   left], [drawnRect   left])];
        [resultRect    setTop:MIN([styleRect    top], [drawnRect    top])];
        [resultRect  setRight:MAX([styleRect  right], [drawnRect  right])];
        [resultRect setBottom:MAX([styleRect bottom], [drawnRect bottom])];
    } else {
        [resultRect   setLeft:[drawnRect   left]];
        [resultRect    setTop:[drawnRect    top]];
        [resultRect  setRight:[drawnRect  right]];
        [resultRect setBottom:[drawnRect bottom]];
    }

    // ̤ bitmap 
    dstBitmap = [[PoCoBitmap alloc] initWidth:[resultRect width] + 1
                                   initHeight:[resultRect height] + 1
                                 defaultColor:0];
    if (dstBitmap == nil) {
        DPRINT((@"can't create joinMaskBitmap.\n"));
        goto EXIT;
    }

    // ޥ̤ȿ
    if ((styleRect != nil) && (styleBitmap != nil)) {
        [PoCoCreateStyleMask orBitmap:dstBitmap
                              dstRect:resultRect
                           joinBitmap:styleBitmap
                             joinRect:styleRect];
    }

    // ɤ줿ޥ̤ȿ
    [PoCoCreateStyleMask orBitmap:dstBitmap
                          dstRect:resultRect
                       joinBitmap:drawnBitmap
                         joinRect:drawnRect];

    // ؤ
    [self->styleMask_ release];
    self->styleMask_ = dstBitmap;

EXIT:
    return;
}


//
// ѤߤΥޥޥӽ
//
//  Call
//    drawnBitmap : Ѥߥޥ
//    drawnRect   : Ѥߤ(ºɸ)
//    styleRect   : ޥ(ºɸ)
//    styleBitmap : ޥ(instance ѿ)
//
//  Return
//    resultRect : (ºɸ)
//    styleMask_ : ޥ(instance ѿ)
//
-(void)separateMaskBitmap:(PoCoBitmap *)drawnBitmap
                 maskRect:(PoCoRect *)drawnRect
              styleBitmap:(PoCoBitmap *)styleBitmap
                styleRect:(PoCoRect *)styleRect
               resultRect:(PoCoRect *)resultRect
{
    PoCoBitmap *dstBitmap;
    PoCoRect *r;

    // ηޥʣ
    dstBitmap = [styleBitmap copy];
    if (dstBitmap == nil) {
        DPRINT((@"can't create excludeMaskBitmap.\n"));
        goto EXIT;
    }
    [resultRect   setLeft:[styleRect   left]];
    [resultRect    setTop:[styleRect    top]];
    [resultRect  setRight:[styleRect  right]];
    [resultRect setBottom:[styleRect bottom]];

    // ɤ줿ޥ̤ȿ
    [PoCoCreateStyleMask excludeBitmap:dstBitmap
                               dstRect:resultRect
                        separateBitmap:drawnBitmap
                          separateRect:drawnRect];

    // Ȥ򹹿
    [PoCoCreateStyleMask resizeRect:resultRect
                         withBitmap:dstBitmap];

    // Ȥ˱äޥؤ
    [self->styleMask_ release];
    r = [[PoCoRect alloc] initLeft: ([resultRect   left] - [styleRect left])
                           initTop: ([resultRect    top] - [styleRect  top])
                         initRight:(([resultRect  right] - [styleRect left]) + 1)
                        initBottom:(([resultRect bottom] - [styleRect  top]) + 1)];
    self->styleMask_ = [dstBitmap getBitmap:r];
    [r release];
    [dstBitmap release];

EXIT:
    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function   : 
//    styleMask_ : ޥ(instance ѿ)
//
-(id)init
{
//    DPRINT((@"[PoCoCreateStyleMask init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->styleMask_ = nil;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    styleMask_ : ޥ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoCreateStyleMask dealloc]\n"));

    // 񸻤β
    [self->styleMask_ release];
    self->styleMask_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    styleMask_ : ޥ(instance ѿ)
//
//  Return
//    function : ޥ
//
-(PoCoBitmap *)mask
{
    return self->styleMask_;
}


// --------------------------------------------------- instance - public - 
//
// 
//
//  Call
//    startPos : ()
//    endPos   : 轪()
//    ort      : 
//    diagonal : гѤѤ뤫
//
//  Return
//    function   : YES : 
//                 NO  : 
//    styleMask_ : ޥ(instance ѿ)
//
-(BOOL)box:(PoCoPoint *)startPos
       end:(PoCoPoint *)endPos
orientation:(PoCoPoint *)ort
isDiagonal:(BOOL)diagonal
{
    BOOL  result;
    PoCoEditInvertPolygon *fill;
    PoCoRect *r;
    NSMutableArray *poly;
    PoCoPoint *t;  
    PoCoCalcRotationForBox *rot;

    result = NO;
    fill = nil;
    r = nil;
    poly = nil;
    rot = nil;

    // Ǥ褷ʤ
    if ((startPos == nil) || (endPos == nil)) {
        goto EXIT;
    }

    // ʬϻĤʤ
    [self->styleMask_ release];
    self->styleMask_ = nil;

    // Ĺ
    r = [self calcBoxRect:startPos
                      end:endPos
              orientation:ort
               isDiagonal:diagonal];

    // žɸ򻻽
    rot = [[PoCoCalcRotationForBox alloc] initWithStartPos:startPos
                                                withEndPos:endPos
                                               ifAnyOrient:ort];
    [rot calc:diagonal];

    // ɸϿ
    poly = [[NSMutableArray alloc] init];
    t = [[PoCoPoint alloc] initX:([[rot leftTop] x] - [r left])
                           initY:([[rot leftTop] y] - [r top])];
    [poly addObject:t];
    [t release];
    t = [[PoCoPoint alloc] initX:([[rot leftBottom] x] - [r left])
                           initY:([[rot leftBottom] y] - [r top])];
    [poly addObject:t];
    [t release];
    t = [[PoCoPoint alloc] initX:([[rot rightBottom] x] - [r left])
                           initY:([[rot rightBottom] y] - [r top])];
    [poly addObject:t];
    [t release];
    t = [[PoCoPoint alloc] initX:([[rot rightTop] x] - [r left])
                           initY:([[rot rightTop] y] - [r top])];
    [poly addObject:t];
    [t release];
    [rot release];

    // ޥ(half-open property Τᡢ+1)
    self->styleMask_ = [[PoCoBitmap alloc] initWidth:([r width] + 1)
                                          initHeight:([r height] + 1)
                                        defaultColor:0];
    if (self->styleMask_ == nil) {
        DPRINT((@"can't create StyleMask.\n"));
        goto EXIT;
    }

    // ɤĤ֤
    fill = [[PoCoEditInvertPolygon alloc] initWithBitmap:self->styleMask_
                                              withPoints:poly
                                            withDrawRect:r
                                              isZeroOnly:YES];
    if (fill == nil) {
        DPRINT((@"can't create FillEditter.\n"));
        goto EXIT;
    }
    [fill executeDraw];

    // ｪλ
    result = YES;

EXIT:
    [fill release];
    [r release];
    [poly removeAllObjects];
    [poly release];
    return result;
}


//
// /ʱ
//
//  Call
//    startPos : ()
//    endPos   : 轪()
//    ort      : 
//
//  Return
//    function   : YES : 
//                 NO  : 
//    styleMask_ : ޥ(instance ѿ)
//
-(BOOL)ellipse:(PoCoPoint *)startPos
           end:(PoCoPoint *)endPos
   orientation:(PoCoPoint *)ort
{
    BOOL result;
    PoCoEditInvertPolygon *fill;
    PoCoRect *r;
    NSMutableArray *poly;
    PoCoPoint *t;
    PoCoCalcEllipse *calc;
    PoCoPoint *p;

    result = NO;
    fill = nil;
    r = nil;
    poly = nil;

    // Ǥ褷ʤ
    if ((startPos == nil) || (endPos == nil)) {
        goto EXIT;
    }

    // ʬϻĤʤ
    [self->styleMask_ release];
    self->styleMask_ = nil;

    // Ĺ
    r = [self calcEllipseRect:startPos
                          end:endPos
                  orientation:ort];

    // ʱȤɸϿ
    poly = [[NSMutableArray alloc] init];
    calc = [[PoCoCalcEllipse alloc] init];
    [calc calc:startPos
        endPos:endPos
   orientation:ort];
    for (p = [calc points]; p != nil; p = [calc points]) {
        t = [[PoCoPoint alloc] initX:([p x] - [r left])
                               initY:([p y] - [r top])];
        [poly addObject:t];
        [t release];
    }
    [calc release];

    // ޥ(half-open property Τᡢ+1)
    self->styleMask_ = [[PoCoBitmap alloc] initWidth:([r width] + 1)
                                          initHeight:([r height] + 1)
                                        defaultColor:0];
    if (self->styleMask_ == nil) {
        DPRINT((@"can't create StyleMask.\n"));
        goto EXIT;
    }

    // ɤĤ֤               
    fill = [[PoCoEditInvertPolygon alloc] initWithBitmap:self->styleMask_
                                              withPoints:poly
                                            withDrawRect:r
                                              isZeroOnly:YES];
    if (fill == nil) {
        DPRINT((@"can't create FillEditter.\n"));
        goto EXIT;
    }
    [fill executeDraw];

    // ｪλ
    result = YES;

EXIT:
    [fill release];
    [r release];
    [poly removeAllObjects];
    [poly release];
    return result;
}


//
// ʿԻշ
//
//  Call
//    firstPos  : 1
//    secondPos : 2
//    thirdPos  : 3
//    fourthPos : 4
//
//  Return
//    function   : YES : 
//                 NO  : 
//    styleMask_ : ޥ(instance ѿ)
//
-(BOOL)parallelogram:(PoCoPoint* )firstPos
              second:(PoCoPoint *)secondPos
               third:(PoCoPoint *)thirdPos
              fourth:(PoCoPoint *)fourthPos
{
    BOOL result;
    PoCoEditInvertPolygon *fill;
    PoCoRect *r;
    NSMutableArray *poly;
    PoCoPoint *t;

    result = NO;
    fill = nil;
    r = nil;
    poly = nil;

    // ­Ƥʤ褷ʤ
    if ((firstPos == nil) ||
        (secondPos == nil) ||
        (thirdPos == nil) ||
        (fourthPos == nil)) {
        goto EXIT;
    }

    // ʬϻĤʤ
    [self->styleMask_ release];
    self->styleMask_ = nil;

    // Ĺ
    r = [self calcParallelogramRect:firstPos
                             second:secondPos
                              third:thirdPos
                             fourth:fourthPos];

    // ɸϿ
    poly = [[NSMutableArray alloc] init];
    t = [[PoCoPoint alloc] initX:([firstPos x] - [r left])
                           initY:([firstPos y] - [r top])];
    [poly addObject:t];
    [t release];
    t = [[PoCoPoint alloc] initX:([secondPos x] - [r left])
                           initY:([secondPos y] - [r top])];
    [poly addObject:t];
    [t release];
    t = [[PoCoPoint alloc] initX:([thirdPos x] - [r left])
                           initY:([thirdPos y] - [r top])];
    [poly addObject:t];
    [t release];
    t = [[PoCoPoint alloc] initX:([fourthPos x] - [r left])
                           initY:([fourthPos y] - [r top])];
    [poly addObject:t];
    [t release];

    // ޥ(half-open property Τᡢ+1)
    self->styleMask_ = [[PoCoBitmap alloc] initWidth:([r width] + 1)
                                          initHeight:([r height] + 1)
                                        defaultColor:0];
    if (self->styleMask_ == nil) {
        DPRINT((@"can't create StyleMask.\n"));
        goto EXIT;
    }
 
    // ɤĤ֤
    fill = [[PoCoEditInvertPolygon alloc] initWithBitmap:self->styleMask_
                                              withPoints:poly
                                            withDrawRect:r
                                              isZeroOnly:YES];
    if (fill == nil) {
        DPRINT((@"can't create FillEditter.\n"));
        goto EXIT;
    }
    [fill executeDraw];

    // ｪλ
    result = YES;

EXIT:
    [fill release];
    [r release];
    [poly removeAllObjects];
    [poly release];
    return result;
}


//
// ľ(ϩ)
//
//  Call
//    points : 
//
//  Return
//    function   : YES : 
//                 NO  : 
//    styleMask_ : ޥ(instance ѿ)
//
-(BOOL)polygon:(NSMutableArray *)points
{
    BOOL  result;
    PoCoEditInvertPolygon *fill;
    PoCoRect *r;
    NSMutableArray *poly;
    NSEnumerator *iter;
    PoCoPoint *p;
    PoCoPoint *t;

    result = NO;
    fill = nil;
    r = nil;
    poly = nil;

    // ʬϻĤʤ
    [self->styleMask_ release];
    self->styleMask_ = nil;

    // Ĺ
    r = [self calcPolygonRect:points];

    // ɸϿ
    poly = [[NSMutableArray alloc] init];
    iter = [points objectEnumerator];
    for (p = [iter nextObject]; p != nil; p = [iter nextObject]) {
        t = [[PoCoPoint alloc] initX:([p x] - [r left])
                               initY:([p y] - [r top])];
        [poly addObject:t];
        [t release];
    }
    p = [[points objectEnumerator] nextObject];
    t = [[PoCoPoint alloc] initX:([p x] - [r left])
                           initY:([p y] - [r top])];
    [poly addObject:t];
    [t release];

    // ޥ(half-open property Τᡢ+1)
    self->styleMask_ = [[PoCoBitmap alloc] initWidth:([r width] + 1)
                                          initHeight:([r height] + 1)
                                        defaultColor:0];
    if (self->styleMask_ == nil) {
        DPRINT((@"can't create StyleMask.\n"));
        goto EXIT;
    }
 
    // ɤĤ֤
    fill = [[PoCoEditInvertPolygon alloc] initWithBitmap:self->styleMask_
                                              withPoints:poly
                                            withDrawRect:r
                                              isZeroOnly:YES];
    if (fill == nil) {
        DPRINT((@"can't create FillEditter.\n"));
        goto EXIT;
    }
    [fill executeDraw];

    // ｪλ
    result = YES;

EXIT:
    [fill release];
    [r release];
    [poly removeAllObjects];
    [poly release];
    return result;
}


//
// ɤ(seed paint)
//
//  Call
//    p           : о(seed)
//    imageBitmap : оݲ
//    imageRect   : оݲ(ºɸ)
//    border      : ꤫
//                  YES : ˤɤ
//                  NO  : ɸοˤɤ
//    range       : ϰ
//
//  Return
//    function   : YES : 
//                 NO  : 
//    resultRect : ϰ
//    styleMask_ : ޥ(instance ѿ)
//
-(BOOL)paint:(PoCoPoint *)p
 imageBitmap:(PoCoBitmap *)imageBitmap
   imageRect:(PoCoRect *)imageRect
    isBorder:(BOOL)border
  colorRange:(int)range
  resultRect:(PoCoRect *)resultRect
{
    return [self paintJoin:p
               imageBitmap:imageBitmap
                 imageRect:imageRect
               styleBitmap:nil
                 styleRect:nil
                  isBorder:border
                colorRange:range
                resultRect:resultRect];
}


//
// ɤ(seed paint)η
//
//  Call
//    p           : о(seed)
//    imageBitmap : оݲ
//    imageRect   : оݲ(ºɸ)
//    styleBitmap : ޥ(ºɸ)
//    styleRect   : ޥ(ºɸ)
//    border      : ꤫
//                  YES : ˤɤ
//                  NO  : ɸοˤɤ
//    range       : ϰ
//
//  Return
//    function   : YES : 
//                 NO  : 
//    resultRect : ϰ
//    styleMask_ : ޥ(instance ѿ)
//
-(BOOL)paintJoin:(PoCoPoint *)p
     imageBitmap:(PoCoBitmap *)imageBitmap
       imageRect:(PoCoRect *)imageRect
     styleBitmap:(PoCoBitmap *)styleBitmap
       styleRect:(PoCoRect *)styleRect
        isBorder:(BOOL)border
      colorRange:(int)range
      resultRect:(PoCoRect *)resultRect
{
    BOOL  result;
    PoCoEditNormalPaint *edit;
    PoCoBitmap *mbmp;
    PoCoRect *mr;

    result = NO;
    edit = nil;
    mbmp = nil;
    mr = nil;

    // ɤ¹
    [self executePaint:&(edit)
            targetPont:p
            withBitmap:imageBitmap
            bitmapRect:imageRect
              isBorder:border
            colorRange:range];
    if (edit == nil) {
        DPRINT((@"can't create seedPaint mask.\n"));
        goto EXIT;
    }

    // ɤä(ѤߤΥޥ)ޥ˷
    mr = [[PoCoRect alloc] initLeft:[[edit drect]   left]
                            initTop:[[edit drect]    top]
                          initRight:[[edit drect]  right]
                         initBottom:[[edit drect] bottom]];
    mbmp = [[edit mask] getBitmap:mr];
    if (mbmp == nil) {
        DPRINT((@"can't join styleMask with seedPaint.\n"));
        goto EXIT;
    }
    [self joinMaskBitmap:mbmp
                maskRect:mr
             styleBitmap:styleBitmap
               styleRect:styleRect
              resultRect:resultRect];

    // ｪλ
    result = YES;

EXIT:
    [mr release];
    [mbmp release];
    [edit release];
    return result;
}


//
// ɤ(seed paint)ʬΥ
//
//  Call
//    p           : о(seed)
//    imageBitmap : оݲ
//    imageRect   : оݲ(ºɸ)
//    styleBitmap : ޥ(ºɸ)
//    styleRect   : ޥ(ºɸ)
//    border      : ꤫
//                  YES : ˤɤ
//                  NO  : ɸοˤɤ
//    range       : ϰ
//
//  Return
//    function   : YES : 
//                 NO  : 
//    resultRect : ϰ
//    styleMask_ : ޥ(instance ѿ)
//
-(BOOL)paintSeparate:(PoCoPoint *)p
         imageBitmap:(PoCoBitmap *)imageBitmap
           imageRect:(PoCoRect *)imageRect
         styleBitmap:(PoCoBitmap *)styleBitmap
           styleRect:(PoCoRect *)styleRect
            isBorder:(BOOL)border
          colorRange:(int)range
          resultRect:(PoCoRect *)resultRect
{
    BOOL  result;
    PoCoEditNormalPaint *edit;
    PoCoBitmap *mbmp;
    PoCoRect *mr;

    result = NO;
    edit = nil;
    mbmp = nil;
    mr = nil;

    // ɤ¹
    [self executePaint:&(edit)
            targetPont:p
            withBitmap:imageBitmap
            bitmapRect:imageRect
              isBorder:border
            colorRange:range];
    if (edit == nil) {
        DPRINT((@"can't create seedPaint mask.\n"));
        goto EXIT;
    }

    // ɤä(ѤߤΥޥ)ޥӽ
    mr = [[PoCoRect alloc] initLeft:[[edit drect]   left]
                            initTop:[[edit drect]    top]
                          initRight:[[edit drect]  right]
                         initBottom:[[edit drect] bottom]];
    mbmp = [[edit mask] getBitmap:mr];
    if (mbmp == nil) {
        DPRINT((@"can't separate styleMask with seedPaint.\n"));
        goto EXIT;
    }
    [self separateMaskBitmap:mbmp
                    maskRect:mr
                 styleBitmap:styleBitmap
                   styleRect:styleRect
                  resultRect:resultRect];

    // ｪλ
    result = YES;

EXIT:
    [mr release];
    [mbmp release];
    [edit release];
    return result;
}

@end
