//
//	Pelistina on Cocoa - PoCo -
//	PNG 饤֥
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

// ----------------------------------------------------------------------------
@interface PoCoPNGEncoder : NSObject
{
    unsigned char chunkName_[4];        // CHUNK ̾
    unsigned char *chunkBody_;          // CHUNK 
    unsigned int bufferLen_;            // chunkBody 
    unsigned int bufferSize_;           // chunkBody 
}

// CRC32 ׻
+(unsigned int)calcCRC:(unsigned int)crc
                 bytes:(const void *)bytes
                length:(unsigned int)len;

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// CHUNK 
-(PoCoErr)createChunk:(const unsigned char *)name;

// CHUNK 񤭹
-(PoCoErr)writeByteChunk:(unsigned char)val;
-(PoCoErr)writeIntChunk:(unsigned int)val;
-(PoCoErr)writeChunk:(const void *)bytes
              length:(unsigned int)len;

// CHUNK Ĥ
-(PoCoErr)closeChunk;

// NSData 
-(NSData *)createNSData;

@end


// ----------------------------------------------------------------------------
@interface PoCoPNGDecoder : NSObject
{
    unsigned char chunkName_[4];        // CHUNK ̾
    unsigned char *chunkBody_;          // CHUNK 
    unsigned int bufferLen_;            // chunkBody 
    unsigned int bufferSize_;           // chunkBody 
    unsigned int bufferRefer_;          // chunkBody Ȱ

    unsigned char *filterBuffer_;       // ե륿ѤΥХåե
    unsigned int filterSize_;           // ե륿
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// CHUNK 򳫤
-(BOOL)openChunk:(const unsigned char *)name;

// CHUNK ɤ߹
-(BOOL)readByteChunk:(unsigned char *)val;
-(BOOL)readIntChunk:(unsigned int *)val;
-(BOOL)readChunk:(void *)bytes
          length:(unsigned int)len
          readed:(unsigned int *)read;

// 
-(const unsigned char *)chunkName;
-(const void *)bytes;
-(unsigned int)length;

// CHUNK Ĥ
-(void)closeChunk;

// NSData ɤ߹
-(BOOL)loadNSData:(NSData *)data
        withRange:(NSRange *)range;

// ե륿ط
-(void)initFilter:(unsigned int)w;
-(void)filtering:(unsigned int)type
            data:(unsigned char *)data;

@end
