//
//	Pelistina on Cocoa - PoCo -
//	ϰϴ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

// ϥɥ
typedef enum _pocoHandleType {
    PoCoHandleType_center = 0,          // ſ
    PoCoHandleType_corner_lt = 1,       // 
    PoCoHandleType_edge_t = 2,          // 
    PoCoHandleType_corner_rt = 3,       // 
    PoCoHandleType_edge_r = 4,          // 
    PoCoHandleType_corner_rb = 5,       // 
    PoCoHandleType_edge_b = 6,          // 
    PoCoHandleType_corner_lb = 7,       // 
    PoCoHandleType_edge_l = 8,          // 

    PoCoHandleType_effective = 9,       // 9

    PoCoHandleType_in_rect = 10,        // ΰ
    PoCoHandleType_out_rect = 11,       // ΰ賰
    PoCoHandleType_in_shape = 12,       // Ǥΰ
    PoCoHandleType_out_shape = 13,      // Ǥΰ賰

    PoCoHandleType_unknown = 14         // (ΩƤʤ)
} PoCoHandleType;


// ˡ
typedef enum _pocoModifierType {
    PoCoModifierType_move_hori,           // ʿư
    PoCoModifierType_move_vert,           // ľư
    PoCoModifierType_resize_hori,         // ʿѷ
    PoCoModifierType_resize_vert,         // ľѷ
    PoCoModifierType_resize_similer_hori, // ѷ(ʿ)
    PoCoModifierType_resize_similer_vert, // ѷ(ľ)
    PoCoModifierType_rotate,              // 

    PoCoModifierType_none                 // ̵
} PoCoModifierType;


// ȥ饹
@class MyDocument;
@class PoCoEditInfo;
@class PoCoBitmap;
@class PoCoCalcRotation;

// ----------------------------------------------------------------------------
@interface PoCoSelectionShape : NSObject
{
    // ѷ
    NSMutableArray *originalPoints_;    // ɸ(ѷ)
    PoCoRect *originalRect_;            // Ĺ(ѷ)
    PoCoRect *originalHandle_[9];       // ϥɥ(ѷ)
    PoCoBitmap *originalShape_;         // (ѷ)
    PoCoBitmap *originalImage_;         // (ѷ)

    // ѷ
    NSMutableArray *resultPoints_;      // ɸ(ѷ)
    PoCoRect *resultRect_;              // Ĺ(ѷ)
    PoCoRect *resultHandle_[9];         // ϥɥ(ѷ)
    PoCoBitmap *resultShape_;           // (ѷ)
    PoCoBitmap *resultImage_;           // (ѷ)

    // ѷ
    PoCoHandleType handle_;             // ѷΥϥɥ
    PoCoPoint *point_;                  // ()
    PoCoCalcRotation *rotate_;          // žؿ
    PoCoModifierType modify_;           // ѷν
}

// handle Ƚ
+(BOOL)isCorner:(PoCoHandleType)type;
+(BOOL)isEdge:(PoCoHandleType)type;
+(BOOL)isInner:(PoCoHandleType)type;
+(BOOL)isOuter:(PoCoHandleType)type;

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// ѷη˺
-(void)clearOriginal;

// ѷλϿ(nil Ͽλ)
-(void)addPoint:(PoCoPoint *)p;

// ѷβϿ
-(void)setImage:(PoCoBitmap *)bmp;

// ѷηѷηʣ
-(void)copyResultToOriginal;

// 
-(PoCoHandleType)controlHandle;
-(PoCoPoint *)controlPoint;
-(PoCoCalcRotation *)calcRotater;
-(BOOL)isCornerHandle;
-(BOOL)isEdgeHandle;
-(BOOL)isInnerHandle;
-(BOOL)isOuterHandle;

// ѷ
-(NSMutableArray *)originalPoints;
-(PoCoRect *)originalRect;
-(PoCoRect *)originalHandle:(PoCoHandleType)type;
-(PoCoBitmap *)originalShape;
-(PoCoBitmap *)originalImage;
-(PoCoHandleType)originalHitTest:(PoCoPoint *)p
                       handleGap:(int)gap
                       withShape:(BOOL)shape;
-(BOOL)isSameStyleOriginalRectShape;

// ѷ
-(NSMutableArray *)resultPoints;
-(PoCoRect *)resultRect;
-(PoCoRect *)resultHandle:(PoCoHandleType)type;
-(PoCoBitmap *)resultShape;
-(PoCoBitmap *)resultImage;
-(PoCoHandleType)resultHitTest:(PoCoPoint *)p
                     handleGap:(int)gap
                     withShape:(BOOL)shape;
-(BOOL)isSameStyleResultRectShape;

// ѷ
-(BOOL)startTrans:(PoCoPoint *)p        // 
        handleGap:(int)gap
        withShape:(BOOL)shape;
-(void)runningTrans:(PoCoPoint *)p      // ѷ
          withEvent:(NSEvent *)evt
  isLiveUpdateShape:(BOOL)liveShape
 isLiveUpdateResult:(BOOL)liveResult;
-(void)endTrans;                        // λ

// ¾βù
-(void)delete:(MyDocument *)doc         // 
 withEditInfo:(PoCoEditInfo *)info;
-(void)flip:(BOOL)hori;                 // ȿž
-(void)autoGrad:(MyDocument *)doc       // ưǡ
        penSize:(int)size
     isAdjacent:(BOOL)adj
         matrix:(const BOOL *)mtx
   withSizePair:(NSDictionary *)sizePair;
-(void)colorReplace:(MyDocument *)doc   // ִ
             matrix:(const unsigned char *)mtx;
-(void)texture:(MyDocument *)doc        // ƥ
  withEditInfo:(PoCoEditInfo *)info
    baseColors:(NSArray *)base
gradientColors:(NSArray *)grad;


// ɤ
-(void)seedNew:(PoCoPoint *)p           // 
        bitmap:(PoCoBitmap *)bmp
      isBorder:(BOOL)border
    colorRange:(int)range;
-(void)seedJoin:(PoCoPoint *)p          // 
         bitmap:(PoCoBitmap *)bmp
       isBorder:(BOOL)border
     colorRange:(int)range;
-(void)seedSeparate:(PoCoPoint *)p      // ʬΥ
             bitmap:(PoCoBitmap *)bmp
           isBorder:(BOOL)border
         colorRange:(int)range;

@end
