//
//	Pelistina on Cocoa - PoCo -
//	PoCo 
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

// -------------------------------------------------------------- endian Ѵ
// 16 bit ͤؤ
#define PoCoSwapUH(i) ((((i) & 0xff00) >> 8) | (((i) & 0x00ff) << 8))

// 32 bit ͤؤ 
#define PoCoSwapUW(i) ((((i) & 0xff000000) >> 24) | \
                       (((i) & 0x00ff0000) >>  8) | \
                       (((i) & 0x0000ff00) <<  8) | \
                       (((i) & 0x000000ff) << 24))


// ----------------------------------------------------------------- ٷ׻
#define PoCoPI    (double)(3.14159265358979)
#define PoCoDivPI ((double)(180.0) / PoCoPI)
#define PoCoMulPI (PoCoPI / (double)(180.0))


// ----------------------------------------------------------------------------
@interface PoCoPoint : NSObject
{
    int x_;
    int y_;
}

// NSPoint κɸ
+(NSPoint)corrNSPoint:(NSPoint)p;

// initialize
-(id)init;
-(id)initX:(int)px                      // ꥤ˥饤
     initY:(int)py;
-(id)initNSPoint:(NSPoint)p;

// deallocate
-(void)dealloc;

// 
-(int)x;
-(int)y;

// 
-(void)setX:(int)px
       setY:(int)py;
-(void)setX:(int)px;
-(void)setY:(int)py;

// 
-(void)moveX:(int)sx
       moveY:(int)sy;
-(void)moveX:(int)sx;
-(void)moveY:(int)sy;

// ǧ
-(BOOL)isEqualPos:(PoCoPoint *)p;

@end


// ----------------------------------------------------------------------------
// half-open property
// Ϻ (0,0) Ȥ˱Ӥ
@interface PoCoRect : NSObject
{
    PoCoPoint *lefttop_;
    PoCoPoint *rightbot_;
}

// PoCoRect Ѵ
+(NSRect)toNSRect:(PoCoRect *)r;

// ĥ
+(PoCoRect *)expandRect:(PoCoRect *)r
                withGap:(int)gap;

// initialize
-(id)init;
-(id)initLeft:(int)left                 // ꥤ˥饤
      initTop:(int)top
    initRight:(int)right
   initBottom:(int)bottom;
-(id)initNSRect:(NSRect)r;
-(id)initPoCoRect:(PoCoRect *)r;

// deallocate
-(void)dealloc;

// 
-(int)left;
-(int)top;
-(int)right;
-(int)bottom;
-(PoCoPoint *)lefttop;
-(PoCoPoint *)rightbot;
-(int)width;
-(int)height;
-(BOOL)empty;
-(NSRect)toNSRect;

// 
-(void)setLeft:(int)left;
-(void)setTop:(int)top;
-(void)setRight:(int)right;
-(void)setBottom:(int)bottom;
-(void)setLeft:(int)left
        setTop:(int)top;
-(void)setRight:(int)right
      setBottom:(int)bottom;

// ư
-(void)shiftX:(int)x;
-(void)shiftY:(int)y;
-(void)shiftX:(int)x
       shiftY:(int)y;

// ǧ
-(BOOL)isEqualRect:(PoCoRect *)r;
-(BOOL)isPointInRect:(PoCoPoint *)p;

// ĥ
-(void)expand:(int)gap;

@end


// ----------------------------------------------------------------------------
@interface PoCoSelColor : NSObject
{
    BOOL isColor_;                      // YES :     NO : ѥ
    BOOL isUnder_;                      // YES : ̤
    int colorNum_;                      // 򤷤Ƥ뿧ֹ
    int patternNum_;                    // 򤷤Ƥѥֹ
}

// initialize
-(id)initWithColorNum:(int)num;

// deallocate
-(void)dealloc;

// 
-(BOOL)isColor;
-(BOOL)isPattern;                       // isColor ȿž̤֤
-(BOOL)isUnder;
-(unsigned int)num;

// 
-(void)setColor:(int)num;
-(void)setPattern:(int)num;
-(void)toggleUnder;

@end


// ----------------------------------------------------------------------------
@interface PoCoEditPictureNotification : NSObject
{
    PoCoRect *rect_;                    // ΰ
    int index_;                         // оݥ쥤䡼ֹ
}

// initialize
-(id)initWithRect:(PoCoRect *)r
          atIndex:(int)idx;

// deallocate
-(void)dealloc;

// 
-(PoCoRect *)rect;
-(int)index;

@end


// ----------------------------------------------------------------------------
@interface PoCoMainViewSupplement : NSObject
{
    // ط
    unsigned int color_;                // (0xffRRGGBB)
    BOOL pattern_;                      // YES: ѥNO: ñ

    // 
    unsigned int  step_;                // Υƥå׿(0: ̵)
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// طʷ
-(unsigned int)backgroundColor;
-(BOOL)isPattern;
-(void)setBackgroundColor:(unsigned int)col;
-(void)setPattern:(BOOL)flag;

// 
-(unsigned int)gridStep;
-(void)setGridStep:(unsigned int)step;

@end


// ----------------------------------------------------------------------------
@interface PoCoGradationPairInfo : NSObject
{
    unsigned int first_;                // ֹ̿
    unsigned int second_;               // ֹ̿
    int size_;                          // 礭
}

// ʸ
+(NSString *)pairString:(unsigned int)first
             withSecond:(unsigned int)second;

// initialize
-(id)initWithFirst:(unsigned int)first
        withSecond:(unsigned int)second
          withSize:(int)size;

// deallocate
-(void)dealloc;

// 
-(NSString *)name;
-(unsigned int)first;
-(unsigned int)second;
-(int)size;
-(int)sizeForSlider;

// 
-(void)setFirst:(unsigned int)val;
-(void)setSecond:(unsigned int)val;
-(void)setSize:(int)val;

@end


// ----------------------------------------------------------------------------
@interface PoCoBaseGradientPair : NSObject
{
    unsigned int base_;                 // base color
    NSArray *colors_;                   // colors of replacing
}

// initialize
-(id)init:(unsigned int)b
   colors:(NSArray *)cl;

// deallocate
-(void)dealloc;

// 
-(unsigned int)base;
-(NSArray *)colors;

@end
