//
//	Pelistina on Cocoa - PoCo -
//	PoCo 
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoTypedef.h"

// ============================================================================
@implementation PoCoPoint

// ------------------------------------------------------------- class - public
//
// NSPoint κɸ
//
//  Call
//    p : 
//
//  Return
//    function : 
//
+(NSPoint)corrNSPoint:(NSPoint)p
{
    p.x -= 1.0;
    p.y -= 2.0;

    return p;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//
-(id)init
{
    return [self initX:0
                 initY:0];
}


//
// initialize(ꥤ˥饤)
//  ɸνĤ
//
//  Call
//    px : Xɸ
//    py : Yɸ
//
//  Return
//    function : 
//    x_       : Xɸ(instance ѿ)
//    y_       : Yɸ(instance ѿ)
//
-(id)initX:(int)px
     initY:(int)py
{
//     DPRINT((@"[PoCoPoint initX:%d initY:%d]\n", px, py));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->x_ = px;
	self->y_ = py;
    }

    return self;
}


//
// initialize
//  NSPoint 
//
//  Call
//    p : ꤷ
//
//  Return
//    function : 
//
-(id)initNSPoint:(NSPoint)p
{
    return [self initX:(int)(floor(p.x))
                 initY:(int)(floor(p.y))];
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoPoint dealloc]"));

    // super class 
    [super dealloc];

    return;
}


//
// ͤμ(X)
//
//  Call
//    x_ : Xɸ(instance ѿ)
//
//  Return
//    function : Xɸ
//
-(int)x
{
    return self->x_;
}


//
// ͤμ(Y)
//
//  Call
//    y_ : Yɸ(instance ѿ)
//
//  Return
//    function : Yɸ
//
-(int)y
{
    return self->y_;
}


//
// ͤ(Ʊ)
//
//  Call
//    px : Xɸ
//    py : Yɸ
//
//  Return
//    x_ : Xɸ(instance ѿ)
//    y_ : Yɸ(instance ѿ)
//
-(void)setX:(int)px
       setY:(int)py
{
    self->x_ = px;
    self->y_ = py;

    return;
}


//
// ͤ(X)
//
//  Call
//    px : Xɸ
//
//  Return
//    x_ : Xɸ(instance ѿ)
//
-(void)setX:(int)px
{
    self->x_ = px;

    return;
}


//
// ͤ(Y)
//
//  Call
//    py : Yɸ
//
//  Return
//    y_ : Yɸ(instance ѿ)
//
-(void)setY:(int)py
{
    self->y_ = py;

    return;
}


//
// ͤι(Ʊ)
//
//  Call
//    sx : Xư
//    sy : Yư
//
//  Return
//    x_ : Xɸ(instance ѿ)
//    y_ : Yɸ(instance ѿ)
//
-(void)moveX:(int)sx
       moveY:(int)sy
{
    self->x_ += sx;
    self->y_ += sy;

    return;
}


//
// ͤι(X)
//
//  Call
//    sx : Xư
//
//  Return
//    x_ : Xɸ(instance ѿ)
//    y_ : Yɸ(instance ѿ)
//
-(void)moveX:(int)sx
{
    self->x_ += sx;

    return;
}


//
// ͤι(Y)
//
//  Call
//    sy : Yư
//
//  Return
//    y_ : Yɸ(instance ѿ)
//
-(void)moveY:(int)sy
{
    self->y_ += sy;

    return;
}


//
// Ʊͤγǧ
//
//  Call
//    p  : ǧ
//    x_ : Xɸ(instance ѿ)
//    y_ : Yɸ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isEqualPos:(PoCoPoint *)p
{
    return ((self->x_ == [p x]) && (self->y_ == [p y]));
}

@end




// ============================================================================
@implementation PoCoRect

// ------------------------------------------------------------- class - public
//
// PoCoRect Ѵ
//  ŷȿžϤʤ
//  (Cocoa ǤϤʤPoCo 帶ȤѴ)
//
//  Call
//    r : Ѵ
//
//  Return
//    function : Ѵ
//
+(NSRect)toNSRect:(PoCoRect *)r
{
    NSRect nr;

    nr.origin.x = [r left];
    nr.origin.y = [r top];
    nr.size.width = [r width];
    nr.size.height = [r height];

    return nr;
}


//
// ĥ
//
//  Call
//    r   : 
//    gap : 
//
//  Return
//    function : (Ʊ)
//
+(PoCoRect *)expandRect:(PoCoRect *)r
                withGap:(int)gap
{
    [r   setLeft:([r   left] - gap)];
    [r    setTop:([r    top] - gap)];
    [r  setRight:([r  right] + gap)];
    [r setBottom:([r bottom] + gap)];

    return r;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//
-(id)init
{
    return [self initLeft:0
                  initTop:0
                initRight:0
               initBottom:0];
}


//
// initialize(ꥤ˥饤)
//
//  Call
//    left   : 
//    top    : 
//    right  : 
//    bottom : 
//
//  Return
//    function  : 
//    lefttop_  : (instance ѿ)
//    rightbot_ : (instance ѿ)
//
-(id)initLeft:(int)left
      initTop:(int)top
    initRight:(int)right
   initBottom:(int)bottom
{
//    DPRINT((@"[PoCoRect initLeft:%d initTop:%d initRight:%d initBottom:%d]\n", left, top, right, bottom));

    // super class 
    self = [super init];

    // Ȥ
    if (self != nil) {
        self->lefttop_ = nil;
        self->rightbot_ = nil;

        // lefttop_ 
        self->lefttop_ = [[PoCoPoint alloc] initX:left
                                            initY:top];
        if (self->lefttop_ == nil) {
            [self release];
            self = nil;
            goto EXIT;
        }

        // rightbot_ 
        self->rightbot_ = [[PoCoPoint alloc] initX:right
                                             initY:bottom];
        if (self->rightbot_ == nil) {
            [self release];
            self = nil;
            goto EXIT;
        }
    }

EXIT:
    return self;
}


//
// initialize
//  NSRect 
//
//  Call
//    r : ꤷ
//
//  Return
//    function : 
//
-(id)initNSRect:(NSRect)r
{
    return [self initLeft:(int)(floor(r.origin.x))
                  initTop:(int)(floor(r.origin.y))
                initRight:(int)(floor(r.origin.x + r.size.width))
               initBottom:(int)(floor(r.origin.y + r.size.height))];
}


//
// initialize
//  PoCoRect 
//
//  Call
//    r : ꤷ
//
//  Return
//    function : 
//
-(id)initPoCoRect:(PoCoRect *)r
{
    return [self initLeft:[r left]
                  initTop:[r top]
                initRight:[r right]
               initBottom:[r bottom]];
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    lefttop_  : (instance ѿ)
//    rightbot_ : (instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoRect dealloc]\n"));

    // ƺɸ
    [self->lefttop_ release];
    [self->rightbot_ release];
    self->lefttop_ = nil;
    self->rightbot_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ͤμ(left)
//
//  Call
//    lefttop_ : (instance ѿ)
//
//  Return
//    function : ɸ
//
-(int)left
{
    return [self->lefttop_ x];
}


//
// ͤμ(top)
//
//  Call
//    lefttop_ : (instance ѿ)
//
//  Return
//    function : ɸ
//
-(int)top
{
    return [self->lefttop_ y];
}


//
// ͤμ(right)
//
//  Call
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : ɸ
//
-(int)right
{
    return [self->rightbot_ x];
}


//
// ͤμ(bottom)
//
//  Call
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : ɸ
//
-(int)bottom
{
    return [self->rightbot_ y];
}


//
// ͤμ()
//
//  Call
//    lefttop_ : (instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)lefttop
{
    return self->lefttop_;
}


//
// ͤμ()
//
//  Call
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)rightbot
{
    return self->rightbot_;
}


//
// ͤμ()
//
//  Call
//    lefttop_  : (instance ѿ)
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : 
//
-(int)width
{
    return ([self->rightbot_ x] - [self->lefttop_ x]);
}


//
// ͤμ(⤵)
//
//  Call
//    lefttop_  : (instance ѿ)
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : 
//
-(int)height
{
    return ([self->rightbot_ y] - [self->lefttop_ y]);
}


//
// Ƚ
//
//  Call
//    lefttop_  : (instance ѿ)
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : YES : 
//               NO  : ͭ
//
-(BOOL)empty
{
    return (([self->lefttop_ x] >= [self->rightbot_ x]) ||
            ([self->lefttop_ y] >= [self->rightbot_ y]));
}


//
// NSRect Ǽ
//
//  Call
//    None
//
//  Return
//    function : Ѵ
//
-(NSRect)toNSRect
{
    return [PoCoRect toNSRect:self];
}


//
// ͤ()
//
//  Call
//    left : 
//
//  Return
//    lefttop_ : (instance ѿ)
//
-(void)setLeft:(int)left
{
    [self->lefttop_ setX:left];

    return;
}


//
// ͤ()
//
//  Call
//    top : 
//
//  Return
//    lefttop_ : (instance ѿ)
//
-(void)setTop:(int)top
{
    [self->lefttop_ setY:top];

    return;
}


//
// ͤ()
//
//  Call
//    right : 
//
//  Return
//    rightbot_ : (instance ѿ)
//
-(void)setRight:(int)right
{
    [self->rightbot_ setX:right];

    return;
}


//
// ͤ()
//
//  Call
//    bottom : 
//
//  Return
//    rightbot_ : (instance ѿ)
//
-(void)setBottom:(int)bottom
{
    [self->rightbot_ setY:bottom];

    return;
}


//
// ͤ()
//
//  Call
//    left : 
//    top  : 
//
//  Return
//    lefttop_ : (instance ѿ)
//
-(void)setLeft:(int)left
        setTop:(int)top
{
    [self->lefttop_ setX:left
                    setY:top];

    return;
}


//
// ͤ()
//
//  Call
//    right  : 
//    bottom : 
//
//  Return
//    rightbot_ : (instance ѿ)
//
-(void)setRight:(int)right
      setBottom:(int)bottom
{
    [self->rightbot_ setX:right
                     setY:bottom];

    return;
}


//
// ư(ʿư)
//
//  Call
//    x : ʿư(dot ñ)
//
//  Return
//    None
//
-(void)shiftX:(int)x
{
    [self  setLeft:([self  left] + x)];
    [self setRight:([self right] + x)];

    return;
}


//
// ư(ľư)
//
//  Call
//    y : ľư(dot ñ)
//
//  Return
//    None
//
-(void)shiftY:(int)y
{
    [self    setTop:([self    top] + y)];
    [self setBottom:([self bottom] + y)];

    return;
}


//
// ư(ʿ/ľƱ)
//
//  Call
//    x : ʿư(dot ñ)
//    y : ľư(dot ñ)
//
//  Return
//    None
//
-(void)shiftX:(int)x
       shiftY:(int)y
{
    [self shiftX:x];
    [self shiftY:y];

    return;
}


//
// Ʊͤγǧ
//
//  Call
//    r         : ǧ
//    lefttop_  : (instance ѿ)
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isEqualRect:(PoCoRect *)r
{
    return (([self->lefttop_  isEqualPos:[r  lefttop]]) &&
            ([self->rightbot_ isEqualPos:[r rightbot]]));
}


//
// ޤγǧ
//
//  Call
//    p         : ǧ
//    lefttop_  : (instance ѿ)
//    rightbot_ : (instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isPointInRect:(PoCoPoint *)p
{
    return (([p x] >= [self->lefttop_ x]) && ([p y] >= [self->lefttop_ y]) &&
            ([p x] < [self->rightbot_ x]) && ([p y] < [self->rightbot_ y]));
}


//
// ĥ
//
//  Call
//    gap : 
//
//  Return
//    None
//
-(void)expand:(int)gap
{
    [PoCoRect expandRect:self
                 withGap:gap];

    return;
}

@end




// ============================================================================
@implementation PoCoSelColor

// ---------------------------------------------------------- instance - public
//
// initialize
//  ֹΤ߽ꤹ
//
//  Call
//    num : ֹ(ֹ)
//
//  Return
//    function    : 
//    isColor_    : ֹ椫ѥֹ椫(instance ѿ)
//    isUnder_    : ̥쥤䡼Ѥ뤫(instance ѿ)
//    colorNum_   : 򤷤Ƥ뿧ֹ(instance ѿ)
//    patternNum_ : 򤷤Ƥѥֹ(instance ѿ)
//
-(id)initWithColorNum:(int)num
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->isColor_ = YES;
        self->isUnder_ = NO;
        self->colorNum_ = num;
        self->patternNum_ = 0;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class 
    [super dealloc];

    return;
}


//
// ֹ椫
//
//  Call
//    isColor_ : ֹ椫ѥֹ椫(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isColor
{
    return self->isColor_;
}


//
// ѥֹ椫
//
//  Call
//    isColor_ : ֹ椫ѥֹ椫(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isPattern
{
    return ((self->isColor_) ? NO : YES);
}


//
// ̥쥤䡼Ѥ뤫
//
//  Call
//    isUnder_ : ̥쥤䡼Ѥ뤫(instance ѿ)
//
//  Return
//    function : 
//
//
-(BOOL)isUnder
{
    return self->isUnder_;
}


//
// ֹμ
//
//  Call
//    isColor_    : ֹ椫ѥֹ椫(instance ѿ)
//    colorNum_   : 򤷤Ƥ뿧ֹ(instance ѿ)
//    patternNum_ : 򤷤Ƥѥֹ(instance ѿ)
//
//  Return
//    function : ֹ
//
-(unsigned int)num
{
    return ((self->isColor_) ? self->colorNum_ : self->patternNum_);
}


//
// ֹ
//
//  Call
//    num : ֹ
//
//  Return
//    isColor_  : ֹ椫ѥֹ椫(instance ѿ)
//    isUnder_  : ̥쥤䡼Ѥ뤫(instance ѿ)
//    colorNum_ : 򤷤Ƥ뿧ֹ(instance ѿ)
//
-(void)setColor:(int)num
{
    self->isColor_ = YES;
    self->isUnder_ = NO;
    self->colorNum_ = num;

    return;
}


//
// ѥֹ
//
//  Call
//    num : ֹ
//
//  Return
//    isColor_    : ֹ椫ѥֹ椫(instance ѿ)
//    isUnder_    : ̥쥤䡼Ѥ뤫(instance ѿ)
//    patternNum_ : 򤷤Ƥѥֹ(instance ѿ)
//
-(void)setPattern:(int)num
{
    self->isColor_ = NO;
    self->isUnder_ = NO;
    self->patternNum_ = num;

    return;
}


//
// ̥쥤䡼λѤڤؤ
//
//  Call
//    isUnder_ : ̥쥤䡼Ѥ뤫(instance ѿ)
//
//  Return
//    isUnder_ : ̥쥤䡼Ѥ뤫(instance ѿ)
//
-(void)toggleUnder
{
    self->isUnder_ = ((self->isUnder_) ? NO : YES);

    return;
}

@end




// ============================================================================
@implementation PoCoEditPictureNotification

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    r   : ΰ
//    idx : оݥ쥤䡼ֹ
//
//  Return
//    function : 
//    rect_    : ΰ(instance ѿ)
//    index_   : оݥ쥤䡼ֹ(instance ѿ)
//
-(id)initWithRect:(PoCoRect *)r
          atIndex:(int)idx
{
//    DPRINT((@"[PoCoEditPictureNotification initWithRect: atIndex:]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->rect_ = r;
        self->index_ = idx;
        [self->rect_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    rect_ : ΰ(instance ѿ)
//
-(void)dealloc
{
//    DPRINT((@"[PoCoEditPictureNotification dealloc]\n"));

    // 񸻤β
    [self->rect_ release];
    self->rect_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ΰμ
//
//  Call
//    rect_ : ΰ(instance ѿ)
//
//  Return
//    function : ΰ
//
-(PoCoRect *)rect
{
    return self->rect_;
}


//
// оݥ쥤䡼ֹμ
//
//  Call
//    index_ : оݥ쥤䡼ֹ(instance ѿ)
//
//  Return
//    function : оݥ쥤䡼ֹ
//
-(int)index
{
    return self->index_;
}

@end




// ============================================================================
@implementation PoCoMainViewSupplement

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    color_   : (0xffRRGGBB)(instance ѿ)
//    pattern_ : طʤμ(instance ѿ)
//               YES: ѥ
//               NO:  ñ
//    step_    : Υƥå׿(instance ѿ)
//
-(id)init
{
//    DPRINT((@"[PoCoMainViewSupplement init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->color_ = 0xffffffff;
        self->pattern_ = NO;
        self->step_ = 0;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
//    DPRINT((@"[PoCoMainViewSupplement dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// طʿ
//
//  Call
//    color_ : (0xffRRGGBB)(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)backgroundColor
{
    return self->color_;
}


//
// طʼ
//
//  Call
//    pattern_ : طʤμ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isPattern
{
    return self->pattern_;
}


//
// طʿ
//
//  Call
//    col : 
//
//  Return
//    color_ : (0xffRRGGBB)(instance ѿ)
//
-(void)setBackgroundColor:(unsigned int)col
{
    self->color_ = col;

    return;
}


//
// طʼ
//
//  Call
//    flag : 
//
//  Return
//    pattern_ : طʤμ(instance ѿ)
//
-(void)setPattern:(BOOL)flag
{
    self->pattern_ = flag;

    return;
}


//
// ԥ륰åɼƥå׼
//
//  Call
//    step_ : Υƥå׿(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)gridStep
{
    return self->step_;
}


//
// ԥ륰åɼƥå
//
//  Call
//    step : 
//
//  Return
//    step_ : Υƥå׿(instance ѿ)
//
-(void)setGridStep:(unsigned int)step
{
    self->step_ = step;

    return;
}

@end




// ============================================================================
@implementation PoCoGradationPairInfo

// ------------------------------------------------------------- class - public
//
// ʸ
//
//  Call
//    first  : ֹ̿
//    second : ֹ̿
//
//  Return
//    function : ʸ
//
+(NSString *)pairString:(unsigned int)first
             withSecond:(unsigned int)second
{
    return [NSString stringWithFormat:@"%03d%03d", first, second];
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    first  : ֹ̿
//    second : ֹ̿
//    size   : 礭
//
//  Return
//    function : 
//    first_   : ֹ̿(instance ѿ)
//    second_  : ֹ̿(instance ѿ)
//    size_    : 礭(instance ѿ)
//
-(id)initWithFirst:(unsigned int)first
        withSecond:(unsigned int)second
          withSize:(int)size
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->first_ = first;
        self->second_ = second;
        self->size_ = size;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ̾Τ
//
//  Call
//    first_  : ֹ̿(instance ѿ)
//    second_ : ֹ̿(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)name
{
    return [PoCoGradationPairInfo pairString:self->first_
                                  withSecond:self->second_];
}


//
// ֹ̿
//
//  Call
//    first_ : ֹ̿(instance ѿ)
//
//  Return
//    function :  
//
-(unsigned int)first
{
    return self->first_;
}


//
// ֹ̿
//
//  Call
//    second_ : ֹ̿(instance ѿ)
//
//  Return
//    function :  
//
-(unsigned int)second
{
    return self->second_;
}


//
// 礭
//
//  Call
//    size_ : 礭(instance ѿ)
//
//  Return
//    function :  
//
-(int)size
{
    return self->size_;
}


//
// 礭(slider )
//
//  Call
//    size_ : 礭(instance ѿ)
//
//  Return
//    function :  
//
-(int)sizeForSlider
{
    return (self->size_ / 8);
}


//
// ֹ̿
//
//  Call
//    val :  
//
//  Return
//    first_ : ֹ̿(instance ѿ)
//
-(void)setFirst:(unsigned int)val
{
    self->first_ = val;

    return;
}


//
// ֹ̿
//
//  Call
//    val :  
//
//  Return
//    second_ : ֹ̿(instance ѿ)
//
-(void)setSecond:(unsigned int)val
{
    self->second_ = val;

    return;
}


//
// 礭
//
//  Call
//    val :  
//
//  Return
//    size_ : 礭(instance ѿ)
//
-(void)setSize:(int)val
{
    self->size_ = val;

    return;
}

@end




// ============================================================================
@implementation PoCoBaseGradientPair

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    b  : base color
//    cl : colors of replacing
//
//  Return
//    base_   : base color(instance value)
//    colors_ : colors of replacing(instance value)
//
-(id)init:(unsigned int)b
   colors:(NSArray *)cl
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->base_ = b;
        self->colors_ = cl;
        [self->colors_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    colors_ : colors of replacing(instance value)
//
-(void)dealloc
{
    // 񸻤β
    [self->colors_ release];
    self->colors_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// base color 
//
//  Call
//    base_ : base color(instance value)
//
//  Return
//    function : base color
//
-(unsigned int)base
{
    return self->base_;
}


//
// colors 
//
//  Call
//    colors_ : colors of replacing(instance value)
//
//  Return
//    function : colors of replacing
//
-(NSArray *)colors
{
    return self->colors_;
}

@end
