//
//	Pelistina on Cocoa - PoCo -
//	zlib ѥ饤֥
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoZlib.h"

// 
static const unsigned int BUFFER_SIZE = 8192;

// ============================================================================
@implementation PoCoZlibDeflate

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    funcion : 
//    zstrm_  : zlib data stream(instance ѿ)
//    buf_    : ȥХåե(instance ѿ)
//
-(id)init
{
    int z_er;

    DPRINT((@"[PoCoZlibDeflate init]\n"));

    // super class 
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->buf_ = NULL;
        memset(&(self->zstrm_), 0x00, sizeof(z_stream));

        // ȥХåե
        self->buf_ = (unsigned char *)(malloc(BUFFER_SIZE));
        if (self->buf_ == NULL) {
            DPRINT((@"memory allocation error.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }

        // zlib 
        self->zstrm_.avail_out = BUFFER_SIZE;
        self->zstrm_.next_out = self->buf_;
        z_er = deflateInit(&(self->zstrm_), Z_BEST_COMPRESSION);
        if (z_er != Z_OK) {
            DPRINT((@"deflateInit : %d\n", z_er));
            [self release];
            self = nil;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    zstrm_ : zlib data stream(instance ѿ)
//    buf_   : ȥХåե(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoZlibDeflate dealloc]\n"));

    // zlib λ
    deflateEnd(&(self->zstrm_));

    // ȥХåե
    if (self->buf_ != NULL) {
        free(self->buf_);
    }
    self->buf_ = NULL;

    // duper class 
    [super dealloc];

    return;
}


//
// (ǡɲ)
//
//  Call
//    bytes  : оݥǡ
//    lenth  : ǡĹ
//    zstrm_ : zlib data stream(instance ѿ)
//
//  Return
//    function : <  0 : error code
//               == 0 : ̽λ
//               == 1 : ̷³
//    zstrm_   : zlib data stream(instance ѿ)
//
-(PoCoWErr)appendBytes:(const unsigned char *)bytes
                length:(unsigned int)length
{
    PoCoWErr rv;
    int z_er;

    // z_stream 
    if ((bytes != NULL) && (length > 0)) {
        self->zstrm_.avail_in = length;
        self->zstrm_.next_in = (Bytef *)(bytes);
    }

    // ̼¹
    z_er = deflate(&(self->zstrm_), Z_SYNC_FLUSH);
    if (z_er == Z_OK) {
        // 
        rv = ((self->zstrm_.avail_in == 0) ? 0 : 1);
    } else if (z_er == Z_STREAM_END) {
        // λ
        rv = 0;
    } else {
        // ¾ƥ顼(Z_NEED_DICT ͭʤ)
        rv = ER_ZLIB;
        DPRINT((@"deflate(Z_SYNC_FLUSH) : %d\n", z_er));
    }

    return rv;
}


//
// ̽λ
//
//  Call
//    zstrm_ : zlib data stream(instance ѿ)
//
//  Return
//    function : <  0 : error code
//               == 0 : Z_STREAM_END(̽λ)
//               == 1 : ̷³
//
-(PoCoWErr)finishData
{
    PoCoWErr rv;
    int z_er;

    // Z_FINISH ȯ
    z_er = deflate(&(self->zstrm_), Z_FINISH);
    if (z_er == Z_OK) {
        // ³
        rv = 1;
    } else if (z_er == Z_STREAM_END) {
        // λ
        rv = 0;
    } else {
        // ¾ƥ顼(Z_NEED_DICT ͭʤ)
        rv = ER_ZLIB;
        DPRINT((@"deflate(Z_FINISH) : %d\n", z_er));
    }

    return rv;
}


//
// 
//
//  Call
//    buf_ : ȥХåե(instance ѿ)
//
//  Return
//    function : Х
//
-(void *)bytes
{
    return (void *)(self->buf_);
}


//
// 
//
//  Call
//    zstrm_ : zlib data stream(instance ѿ)
//
//  Return
//    function : Хåե
//
-(unsigned int)length
{
    return (BUFFER_SIZE - self->zstrm_.avail_out);
}


//
// Хåե
//  ºݤˤϡz_stream.avail_out/z_strem.next_out 򺹤᤹
//
//  Call
//    length : 
//
//  Return
//    zstrm_ : zlib data stream(instance ѿ)
//
-(void)clearBuffer:(unsigned int)length
{
    self->zstrm_.avail_out += length;
    self->zstrm_.next_out -= length;

    return;
}

@end




// ============================================================================
@implementation PoCoZlibInflate

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//    zstrm_   : zlib data stream(instance ѿ)
//    buf_     : ȥХåե(instance ѿ)
//
-(id)init
{
    int z_er;

    DPRINT((@"[PoCoZlibInflate init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->buf_ = NULL;
        memset(&(self->zstrm_), 0x00, sizeof(z_stream));

        // ȥХåե
        self->buf_ = (unsigned char *)(malloc(BUFFER_SIZE));
        if (self->buf_ == NULL) {
            DPRINT((@"memory allocation error.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }

        // zlib 
        self->zstrm_.avail_out = BUFFER_SIZE;
        self->zstrm_.next_out = self->buf_;
        z_er = inflateInit(&(self->zstrm_));
        if (z_er != Z_OK) {
            DPRINT((@"inflateInit : %d(0x%08x)\n", z_er, z_er));
            [self release];
            self = nil;
            goto EXIT;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    zstrm_ : zlib data stream(instance ѿ)
//    buf_   : ȥХåե(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoZlibInflate dealloc]\n"));

    // zlib λ
    inflateEnd(&(self->zstrm_));

    // ȥХåե
    if (self->buf_ != NULL) {
        free(self->buf_);
    }
    self->buf_ = NULL;

    // super class β
    [super dealloc];

    return;
}

//
// ĥ(ǡɲ)
//
//  Call
//    bytes : ĥоݥǡ
//    lenth : ǡĹ
//    zstrm_ : zlib data stream(instance ѿ)
//
//  Return
//    function : <  0 : error code
//               == 0 : ĥλ
//               == 1 : ĥ³
//    zstrm_   : zlib data stream(instance ѿ)
//
-(PoCoWErr)appendBytes:(const unsigned char *)bytes
                length:(unsigned int)length
{
    PoCoWErr rv;
    int z_er;

    // z_stream 
    if ((bytes != NULL) && (length > 0)) {
        self->zstrm_.avail_in = length;
        self->zstrm_.next_in = (Bytef *)(bytes);
    }

    // ĥ¹
    z_er = inflate(&(self->zstrm_), Z_SYNC_FLUSH);
    if (z_er == Z_OK) {
        // 
        rv = ((self->zstrm_.avail_in == 0) ? 0 : 1);
    } else if (z_er == Z_STREAM_END) {
        // λ
        rv = 0;
    } else {
        // ¾ƥ顼(Z_NEED_DICT ͭʤ)
        rv = ER_ZLIB;
        DPRINT((@"inflate(Z_SYNC_FLUSH) : %d\n", z_er));
    }

    return rv;
}


//
// ĥλ
//
//  Call
//    zstrm_ : zlib data stream(instance ѿ)
//
//  Return
//    function : <  0 : error code
//               == 0 : Z_STREAM_END(ĥλ)
//               == 1 : ĥ³
//
-(PoCoWErr)finishData
{
    PoCoWErr rv;
    int z_er;

    // Z_FINISH ȯ
    z_er = inflate(&(self->zstrm_), Z_FINISH);
    if (z_er == Z_OK) {
        // ³
        rv = 1;
    } else if (z_er == Z_STREAM_END) {
        // λ
        rv = 0;
    } else {
        // ¾ƥ顼(Z_NEED_DICT ͭʤ)
        rv = ER_ZLIB;
        DPRINT((@"inflate(Z_FINISH) : %d\n", z_er));
    }

    return rv;
}


//
// 
//
//  Call
//    buf_ : ȥХåե(instance ѿ)
//
//  Return
//    function : Х
//
-(void *)bytes
{
    return (void *)(self->buf_);
}


//
// 
//
//  Call
//    zstrm_ : zlib data stream(instance ѿ)
//
//  Return
//    function : Хåե
//
-(unsigned int)length
{
    return (BUFFER_SIZE - self->zstrm_.avail_out);
}


//
// Хåե
//  ºݤˤϡz_stream.avail_out/z_strem.next_out 򺹤᤹
//
//  Call
//    length : 
//
//  Return
//    zstrm_ : zlib data stream(instance ѿ)
//
-(void)clearBuffer:(unsigned int)length
{
    self->zstrm_.avail_out += length;
    self->zstrm_.next_out -= length;

    return;
}

@end
