//
//	Pelistina on Cocoa - PoCo -
//	layer 
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

//  class 
@class PoCoPalette;
@class PoCoPNGDecoder;

// ----------------------------------------------------------------------------
// bitmap 256
@interface PoCoBitmap : NSObject <NSCopying>
{
    int width_;                         // (dot )
    int height_;                        // ⤵(dot )
    int size_;                          // (byte ñ/˶)

    unsigned char *bitmap_;             // pixelmap(single plane)
}

// initialize
-(id)init;
-(id)initWidth:(int)w                   // ꥤ˥饤
    initHeight:(int)h
  defaultColor:(unsigned char)c;
-(id)copyWithZone:(NSZone *)zone;       // ʣ

// deallocate
-(void)dealloc;

// 
-(int)width;
-(int)height;
-(unsigned char *)pixelmap;             // pointer  free() ʤ

// ʣ
// 줿 bitmap βϸƤӽФȤǤ(free() Ѥ뤳)
-(unsigned char *)getBitmap;                  // 
-(PoCoBitmap *)getBitmap:(const PoCoRect *)r; // ʬ

// ʬ
// bitmap Ƥ copy (retain ǤϤʤ)
-(void)setBitmap:(const unsigned char *)bmp
        withRect:(const PoCoRect *)r;

// ѷ
// ͤѷʤ
// /̾ΰտޤϻʤ
-(BOOL)resizeWidth:(int)w
      resizeHeight:(int)h;

// ե
-(NSData *)createFileData;                          // ¸
-(id)initWithPNGDecoder:(PoCoPNGDecoder *)png;      // ɤ߹(̾)
-(id)initWithPNGDecoderIDAT:(PoCoPNGDecoder *)png   // ɤ߹(IDAT CHUNK)
                  sizeWidth:(unsigned int)w
                 sizeHeight:(unsigned int)h;

@end


// ----------------------------------------------------------------------------
// 쥤䡼
@interface PoCoLayerBase : NSObject <NSCopying>
{
    PoCoBitmap *bitmap_;                // Ƥμ(Խо)
    NSBitmapImageRep *preview_;         // ܤɽ
    NSRect sampleRect_;                 // ܤ礭

    BOOL drawLock_;                     // YES : ػ
    BOOL isDisplay_;                    // YES : ɽ

    NSString *name_;                    // ̾
}

// initialize
-(id)init;
-(id)initWidth:(int)w                   // ꥤ˥饤
    initHeight:(int)h
  defaultColor:(unsigned char)c;
-(id)copyWithZone:(NSZone *)zone;       // ʣ

// deallocate
-(void)dealloc;

// (ƶ class Ǽ뤳)
-(PoCoLayerType)layerType;
-(NSString *)typeName;

// 
-(PoCoBitmap *)bitmap;
-(NSImage *)preview;
-(BOOL)drawLock;
-(BOOL)isDisplay;
-(NSString *)name;

// 
-(void)setDrawLock;
-(void)clearDrawLock;
-(void)setIsDisplay;
-(void)clearIsDisplay;
-(void)setName:(NSString *)str;

// preview ι
-(void)updatePreview:(PoCoPalette *)palette;

// ե(ƶ class Ǽ뤳)
-(NSData *)createFileData;                      // ¸
-(id)initWithPNGDecoder:(PoCoPNGDecoder *)png;  // ɤ߹

@end


// ----------------------------------------------------------------------------
// 쥤䡼
//  [PoCoLayerBase initWidth: initHeight:] Ƥ֤Τ˾ޤ
@interface PoCoBitmapLayer : PoCoLayerBase
{
}

// 
-(PoCoLayerType)layerType;
-(NSString *)typeName;

// ե
-(NSData *)createFileData;                          // ¸
-(id)initWithPNGDecoder:(PoCoPNGDecoder *)png;      // ɤ߹(ɸ)
-(id)initWithPNGDecoderIDAT:(PoCoPNGDecoder *)png   // ɤ߹(IDAT CHUNK)
                  sizeWidth:(unsigned int)w
                 sizeHeight:(unsigned int)h;

@end


// ----------------------------------------------------------------------------
// ʸ쥤䡼
@interface PoCoStringLayer : PoCoLayerBase
{
    PoCoRect *str_r_;                   // 쥤ΰ
    NSString *str_;                     // оʸ

// Ƭ§ʸ
// §ʸ
// ʸʿ
// ʸطʿ
// 
// ʸ
// ʸΨ
}

// initialize
-(id)init;

// deallocate
-(void)dealloc;

// 
-(PoCoLayerType)layerType;
-(NSString *)typeName;

// ... accessor method ޤ ...

// ե
-(NSData *)createFileData;                      // ¸
-(id)initWithPNGDecoder:(PoCoPNGDecoder *)png;  // ɤ߹

@end


#if 0
// ----------------------------------------------------------------------------
// ޷쥤䡼(ǰŪȤߤǡѤǤʤ)
@interface PoCoFigureLayer : PoCoLayerBase
{
}

@end


// ----------------------------------------------------------------------------
// ե쥤䡼(ǰŪȤߤǡѤǤʤ)
@interface PoCoFileLayer : PoCoLayerBase
{
}

@end

#endif  // 0
