//
//	Pelistina on Cocoa - PoCo -
//	palette 
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

//  class
@class PoCoPNGDecoder;

// ----------------------------------------------------------------------------
@interface PoCoColor : NSObject <NSCopying>
{
    unsigned char red_;                 // (0-255)
    unsigned char green_;               // (0-255)
    unsigned char blue_;                // (0-255)

    BOOL isTrans_;                      // YES : Ʃ
    BOOL noDropper_;                    // YES : ۤػ
    BOOL isMask_;                       // YES : 񤭶ػ

    wchar_t *paletteTable_;
    BOOL *transTable_;
}

// initialize
-(id)init;
-(id)initRed:(unsigned char)r            // ꥤ˥饤
       Green:(unsigned char)g
        Blue:(unsigned char)b
withPaletteTable:(wchar_t *)pal
  withTransTable:(BOOL *)trn;
-(id)copyWithZone:(NSZone *)zone;       // ʣ

// deallocate
-(void)dealloc;

// ׳ǧ
-(BOOL)isEqualColor:(PoCoColor *)target
          checkAttr:(BOOL)attrFlag;

// 
-(unsigned char)red;
-(unsigned char)green;
-(unsigned char)blue;
-(unsigned char)hue;
-(unsigned char)lightness;
-(unsigned char)saturation;
-(float)floatRed;
-(float)floatGreen;
-(float)floatBlue;
-(BOOL)isTrans;
-(BOOL)noDropper;
-(BOOL)isMask;

// 
-(void)setRed:(unsigned char)r
     setGreen:(unsigned char)g
      setBlue:(unsigned char)b;
-(void)setHue:(unsigned char)h
 setLightness:(unsigned char)l
setSaturation:(unsigned char)s;
-(void)setTrans:(BOOL)flg;
-(void)setDropper:(BOOL)flg;
-(void)setMask:(BOOL)flg;

@end


// ----------------------------------------------------------------------------
@interface PoCoPalette : NSObject <NSCopying>
{
    PoCoColor *palette_[COLOR_MAX];
}

// initialize
-(id)init;
-(id)initWithTable:(wchar_t *)pal       // ꥤ˥饤
         withTrans:(BOOL *)trn;
-(id)copyWithZone:(NSZone *)zone;       // ʣ

// deallocate
-(void)dealloc;

// 
-(PoCoColor *)palette:(int)index;

// ׳ǧ
-(BOOL)isEqualPalette:(PoCoPalette *)target
            checkAttr:(BOOL)attrFlag;

// ե
-(NSData *)createFileData:(BOOL)toAlpha;    // ¸
-(BOOL)loadPLTEChunk:(PoCoPNGDecoder *)png; // ɤ߹(PLTE Chunk)
-(BOOL)loadTRNSChunk:(PoCoPNGDecoder *)png; // ɤ߹(tRNS Chunk)
-(BOOL)loadDROPChunk:(PoCoPNGDecoder *)png; // ɤ߹(drOP Chunk)
-(BOOL)loadMASKChunk:(PoCoPNGDecoder *)png; // ɤ߹(maSK Chunk)

@end
