//
//	Pelistina on Cocoa - PoCo -
//	
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Foundation/Foundation.h>

//  class
@class PoCoPalette;
@class PoCoLayerBase;
@class PoCoColorPattern;
@class PoCoBuffer;

// ----------------------------------------------------------------------------
@interface PoCoPicture : NSObject
{
    PoCoPalette *palette_;              // ѥå
    NSMutableArray *layer_;             // 쥤䡼(0:ǲ)
    PoCoColorPattern *colpat_[COLOR_PATTERN_NUM]; // 顼ѥ
    PoCoBuffer *viewBuffer_;            // ɽѤκȥХåե

    wchar_t paletteTable_[COLOR_MAX];   // ѥåͥơ֥
    BOOL transTable_[COLOR_MAX];        // Ʃơ֥(ºݤȤȿž)
    wchar_t shadowPaletteTable_[COLOR_MAX]; // ѥåͥơ֥(shadow copy)
    BOOL shadowTransTable_[COLOR_MAX];  // Ʃơ֥(shadow copy)

    int h_unit_;                        // ʿѻ(ɽ TAD )
    int v_unit_;                        // ľѻ(ɽ TAD )

    BOOL isUseBKGD_;                    // طʿ
    unsigned int bkgdColor_;            // (ѥåֹ)

    BOOL isUseICCP_;                    // YES : iCCP CHUNK    NO : other
    unsigned int gamma_;                // gAMA CHUNK
    unsigned int chromakey_[8];         // cHRM CHUNK
    unsigned int srgb_;                 // sRGB CHUNK
}

// ڡȥܡɤ
+(BOOL)pastePBoardData:(NSData *)data
             withRange:(NSRange *)range
           resultLayer:(PoCoLayerBase **)lyr
         resultPalette:(PoCoPalette *)plt;

// initialize
-(id)init:(int)dpi;

// deallocate
-(void)dealloc;

// 쥤䡼δ
-(PoCoErr)addLayer:(int)index           // ɲ()
             width:(int)w
            height:(int)h
             color:(unsigned char)c;
-(PoCoErr)addStringLayer:(int)index     // ɲ(ʸ)
             color:(unsigned char)c;
-(void)deleteLayer:(int)index;          // 
-(NSMutableArray *)layer;               // ()
-(id)layer:(int)index;                  // (ñ)
-(void)insertLayer:(int)index           // 
             layer:(PoCoLayerBase *)lyr;
-(void)updateLayerPreview:(int)index;   // ܹ

// μ
-(NSRect)bitmapRect;
-(PoCoRect *)bitmapPoCoRect;

// 祦ɥɽѲμ
-(NSBitmapImageRep *)getMainImage:(PoCoRect *)rect
                        withScale:(int)scale
                   withSupplement:(PoCoMainViewSupplement *)supplement;

// ο
-(int)pointColor:(PoCoPoint *)p
         atIndex:(int)index;

// ѥåȤδ
-(PoCoPalette *)palette;                // 
-(void)didUpdatePalette;                // ѥåȹ
-(void)pushPaletteTable;                // ɽѥơ֥
-(void)popPaletteTable;                 // ɽѥơ֥ʽ

// 顼ѥδ
-(PoCoColorPattern *)colpat:(int)index; // 
-(void)setColpat:(int)index             // 
         pattern:(PoCoColorPattern *)pat;

// 
-(int)h_unit;                           // pHYs (ʿ)
-(int)v_unit;                           // pHYs (ľ)
-(BOOL)bkgdColor:(unsigned int *)idx;   // bKGD CHUNK 
-(BOOL)isUseICCP;                       // iCCP Ѽ
-(unsigned int)gamma;                   // gAMA CHUNK 
-(const unsigned int *)chromakey;       // cHRM CHUNK 
-(unsigned int)srgb;                    // sRGB CHUNK 
-(void)setHUnit:(int)h                  // pHYs CHUNK 
      withVUnit:(int)v;
-(void)setBKGD:(BOOL)flg                // bKGD CHUNK 
     withIndex:(unsigned int)idx;
-(void)setUseICCP:(BOOL)flag;          // iCCP 
-(void)setGamma:(unsigned int)val;     // gAMA CHUNK 
-(void)setChromakey:(const unsigned int *)val;  // cHRM CHUNK 
-(void)setSrgb:(unsigned int)val;      // sRGB CHUNK 

// ե
-(NSData *)createFileData:(BOOL)toAlpha;// ¸
-(BOOL)loadFileData:(NSData *)data      // ɤ߹
          withRange:(NSRange *)range;

// ڡȥܡɤŽդ
-(NSData *)createPBoardData:(PoCoRect *)r
                    atIndex:(int)index
                    toAlpha:(BOOL)toAlpha;

@end
