//
//	Pelistina on Cocoa - PoCo -
//	
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//
// wchar_t  32bit νϤǤ뤳Ȥ˰¸ƤΤ
//

#import "PoCoPicture.h"

#import <wchar.h>

#import "PoCoPalette.h"
#import "PoCoLayer.h"
#import "PoCoColorPattern.h"
#import "PoCoControllerPictureLayerUnificater.h"
#import "PoCoBuffer.h"

#import "PoCoPNG.h"
#import "PoCoZlib.h"

#if 0
# define GAMACHUNK_WINDOWS
#endif  // 0

// 
#define GRID_HORI_SOLID   0x01
#define GRID_HORI_DOTTED  0x02
#define GRID_VERT_SOLID   0x04
#define GRID_VERT_DOTTED  0x08
#define GRID_NONE 0x00
#define GRID_HORI (GRID_HORI_SOLID | GRID_HORI_DOTTED)
#define GRID_VERT (GRID_VERT_SOLID | GRID_VERT_DOTTED)

static const int TRANS_GRID = 16;
static const int TRANS_GRID_HALF = (TRANS_GRID >> 1);


// ============================================================================
@implementation PoCoPicture

// ------------------------------------------------------------ class - private
//
// IHDR Chunk(إå)ɤ߹
//
//  Call
//    data   : ɤ߹
//    range  : ɤ߹ϰ
//    width  : ֤
//    height : ι⤵֤
//
//  Return
//    function : YES : 
//               NO  : 
//    range    : ɤ߹ϰ
//    width    : 
//    height   : ι⤵
//
+(BOOL)loadIHDRChunk:(NSData *)data
           withRange:(NSRange *)range
               width:(unsigned int *)width
              height:(unsigned int *)height
{
    BOOL result;
    PoCoPNGDecoder *png;
    unsigned char i;

    DPRINT((@"[PoCoPicture loadIHDRChunk: widthRange: width: height:]\n"));

    png = nil;

    // CHUNK ɤ߹
    png = [[PoCoPNGDecoder alloc] init];
    [png loadNSData:data withRange:range];

    // CHUNK 򳫤
    result = [png openChunk:(unsigned char *)("IHDR")];
    if (result != YES) {
        DPRINT((@"not IHDR Chunk.\n"));
        goto EXIT;
    }

    // 
    result = [png readIntChunk:width];
    if (result != YES) {
        DPRINT((@"can't read width.\n"));
        goto EXIT;
    }

    // ⤵
    result = [png readIntChunk:height];
    if (result != YES) {
        DPRINT((@"can't read height.\n"));
        goto EXIT;
    }

    // ӥåȿ
    result = [png readByteChunk:&(i)];
    if (result != YES) {
        DPRINT((@"can't read bitdepth.\n"));
        goto EXIT;
    } else if (i != 8) {
        DPRINT((@"not support bitdepth : %d\n", i));
        result = NO;
        goto EXIT;
    }

    // 顼פ
    result = [png readByteChunk:&(i)];
    if (result != YES) {
        DPRINT((@"can't read color type.\n"));
        goto EXIT;
    } else if (i != 3) {
        DPRINT((@"not support color type : %d\n", i));
        result = NO;
        goto EXIT;
    }

    // ˡ
    result = [png readByteChunk:&(i)];
    if (result != YES) {
        DPRINT((@"can't read compression method.\n"));
        goto EXIT;
    } else if (i != 0) {
        DPRINT((@"not support compression method : %d\n", i));
        result = NO;
        goto EXIT;
    }

    // ե륿̤
    result = [png readByteChunk:&(i)];
    if (result != YES) {
        DPRINT((@"can't read filter method.\n"));
        goto EXIT;
    } else if (i != 0) {
        DPRINT((@"not support filter method : %d\n", i));
        result = NO;
        goto EXIT;
    }

    // 󥿡졼ˡ
    result = [png readByteChunk:&(i)];
    if (result != YES) {
        DPRINT((@"can't read interlace method.\n"));
        goto EXIT;
    } else if (i != 0) {
        DPRINT((@"not support interlace method : %d\n", i));
        result = NO;
        goto EXIT;
    }

    // CHUNK Ĥ
    [png closeChunk];

    // 
    result = YES;

EXIT:
    [png release];
    return result;
}


//
// Ǥդ CHUNK ɤ߹(ڡȥܡ)
//
//  Call
//    data   : ɤ߹
//    range  : ɤ߹ϰ
//    width  : 
//    height : ⤵
//    lyr    : ƤФ쥤䡼
//    plt    : ƤФѥå
//
//  Return
//    function : YES : 
//               NO  : 
//    range    : ɤ߹ϰ
//    lyr      : ƤФ쥤䡼
//    plt      : ƤФѥå
//
+(BOOL)loadChunks:(NSData *)data
        withRange:(NSRange *)range
        sizeWidth:(unsigned int)width
       sizeHeight:(unsigned int)height
      resultLayer:(PoCoLayerBase **)lyr
    resultPalette:(PoCoPalette *)plt
{
    BOOL result;
    BOOL isContinue;
    PoCoPNGDecoder *png;

    isContinue = YES;
    png = nil;

    // PNG 
    png = [[PoCoPNGDecoder alloc] init];
    do {
        // CHUNK ɤ߹
        result = [png loadNSData:data withRange:range];
        if (result != YES) {
            break;
        }

        // CHUNK 򳫤
        [png openChunk:[png chunkName]];

        // CHUNK פȤʬ
        if (memcmp([png chunkName], "iCCP", 4) == 0) {
            // iCCP CHUNK(ICC Profile)
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "sRGB", 4) == 0) {
            // sRGB CHUNK(sRGB)
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "gAMA", 4) == 0) {
            // gAMA CHUNK()
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "cHRM", 4) == 0) {
            // cHRM CHUNK()
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "pHYs", 4) == 0) {
            // pHYs Chunk(ʪ)
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "PLTE", 4) == 0) {
            // PLTE Chunk(ѥå)
            result = [plt loadPLTEChunk:png];
        } else if (memcmp([png chunkName], "tRNS", 4) == 0) {
            // tRNS Chunk(Ʃ)
            result = [plt loadTRNSChunk:png];
        } else if (memcmp([png chunkName], "drOP", 4) == 0) {
            // drOP Chunk(ۤػ)
            result = [plt loadDROPChunk:png];
        } else if (memcmp([png chunkName], "maSK", 4) == 0) {
            // maSK Chunk(񤭶ػ)
            result = [plt loadMASKChunk:png];
        } else if (memcmp([png chunkName], "cpAT", 4) == 0) {
            // cpAT Chunk(顼ѥ)
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "ilAY", 4) == 0) {
            // ilAY Chunk(쥤䡼)
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "slAY", 4) == 0) {
            // slAY Chunk(ʸ쥤䡼)
            ;     // ڡȥܡɤǤ̵
        } else if (memcmp([png chunkName], "IDAT", 4) == 0) {
            // IDAT Chunk()
            *(lyr) = [[PoCoBitmapLayer alloc]
                         initWithPNGDecoderIDAT:png
                                      sizeWidth:width
                                     sizeHeight:height];
        } else if (memcmp([png chunkName], "IEND", 4) == 0) {
            // IEND Chunk(λ)
            result = YES;               // ｪλ
            isContinue = NO;
        } else {
            // ¾̵
            ;
        }

        // CHUNK Ĥ
        [png closeChunk];
    } while ((isContinue) && (result));
    [png release];

    return result;
}


// ------------------------------------------------------------- class - public
//
// ڡȥܡɤ
//
//  Call
//    data  : ɤ߹
//    range : ɤ߹ϰ
//    lyr   : ƤФ쥤䡼
//    plt   : ƤФѥå
//
//  Return
//    function : YES : 
//               NO  : 
//    range    : ɤ߹ϰ
//    lyr      : ƤФ쥤䡼
//    plt      : ƤФѥå
//
+(BOOL)pastePBoardData:(NSData *)data
             withRange:(NSRange *)range
           resultLayer:(PoCoLayerBase **)lyr
         resultPalette:(PoCoPalette *)plt
{
    BOOL result;
    unsigned int width;
    unsigned int height;

    DPRINT((@"[PoCoPicture pastePBoardData: withRange: resultLayer: resultPalette:]\n"));

    // IHDR CHUNK ɤ߹
    result = [PoCoPicture loadIHDRChunk:data
                              withRange:range
                                  width:&(width)
                                 height:&(height)];
    if (result != YES) {
        DPRINT((@"can't load IHDR Chunk.\n"));
    } else {
        // ³ CHUNK ɤ߹
        result = [PoCoPicture loadChunks:data
                               withRange:range
                               sizeWidth:width
                              sizeHeight:height
                             resultLayer:lyr
                           resultPalette:plt];
        if (result != YES) {
            DPRINT((@"can't paste image.\n"));
        } else {
            // ｪλ
            result = YES;
        }
    }

    return result;
}


// --------------------------------------------------------- instance - private
#if 1
//
// 1ޥʬ
//
//  Call
//    imageBitmap : о pixlemap
//    square      : ޥ礭(dot )
//    row         : pixlemap  rowbytes
//    color       : 
//    grid        : åμ
//
//  Return
//    None
//
-(void)drawArea:(unsigned int *)imageBitmap
         square:(int)square
       rowBytes:(int)row
          color:(unsigned int)color
       withGrid:(unsigned char)grid
{
    int l;
    unsigned int *bmp;

    l = square;
    bmp = imageBitmap;
    do {
        // ɤĤ֤
        wmemset((wchar_t *)(bmp), color, square);

        // å()
        if ((grid & GRID_HORI) == GRID_NONE) {
            // ̵
            ;
        } else if ((grid & GRID_HORI_SOLID) == GRID_HORI_SOLID) {
            // 
            *(bmp) ^= 0x00ffffff;
        } else if ((l & 0x01) != 0x00) {
            // 
            *(bmp) ^= 0x00ffffff;
        }

        // 
        (l)--;
        bmp += row;
    } while (l != 0);

    // å()
    if ((grid & GRID_VERT) == GRID_NONE) {
        // ̵
        ;
    } else {
        l = square;
        bmp = imageBitmap;
        do {
            if ((grid & GRID_VERT_SOLID) == GRID_VERT_SOLID) {
                // 
                *(bmp) ^= 0x00ffffff;
            } else if ((l & 0x01) != 0x00) {
                // 
                *(bmp) ^= 0x00ffffff;
            }

            // 
            (l)--;
            (bmp)++;
        } while (l != 0);
    }

    return;
}
#else   // 1
//
// 1ޥʬ
//
//  Call
//    imageBitmap : о pixlemap
//    width       : ޥ(dot )
//    height      : ޥι⤵(dot )
//    row         : pixlemap  rowbytes
//    color       : 
//    grid        : åμ
//
//  Return
//    None
//
-(void)drawArea:(unsigned int *)imageBitmap
          width:(int)width
         height:(int)height
       rowBytes:(int)row
          color:(unsigned int)color
       withGrid:(unsigned char)grid
{
    int l;
    unsigned int *bmp;

    l = height;
    bmp = imageBitmap;
    do {
        // ɤĤ֤
        wmemset((wchar_t *)(bmp), color, width);

        // å()
        if ((grid & GRID_HORI) == GRID_NONE) {
            // ̵
            ;
        } else if ((grid & GRID_HORI_SOLID) == GRID_HORI_SOLID) {
            // 
            *(bmp) ^= 0x00ffffff;
        } else if ((l & 0x01) != 0x00) {
            // 
            *(bmp) ^= 0x00ffffff;
        }

        // 
        (l)--;
        bmp += row;
    } while (l != 0);

    // å()
    if ((grid & GRID_VERT) == GRID_NONE) {
        // ̵
        ;
    } else {
        l = width;
        bmp = imageBitmap;
        do {
            if ((grid & GRID_VERT_SOLID) == GRID_VERT_SOLID) {
                // 
                *(bmp) ^= 0x00ffffff;
            } else if ((l & 0x01) != 0x00) {
                // 
                *(bmp) ^= 0x00ffffff;
            }

            // 
            (l)--;
            (bmp)++;
        } while (l != 0);
    }

    return;
}
#endif  // 1


//
// ϰϤ򻻽
//
//  Call
//    rect   : == nil : 
//             != nil : ΰ
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : ΰ
//
-(PoCoRect *)calcViewRect:(PoCoRect *)rect
{
    PoCoRect *area;
    int i;
    const PoCoBitmap *bot = [[self->layer_ objectAtIndex:0] bitmap]; // ̲

    // ΰλ
    area = [[PoCoRect alloc] initLeft:0
                              initTop:0
                            initRight:[bot width]
                           initBottom:[bot height]];
    if (rect == nil) {
        // Ĵʤ
        ;
    } else if (area != nil) {
        // դĴ
        i = [rect left];
        if (i <= 0) {
            ;
        } else if (i < [area right]) {
            [area setLeft:i];
        } else {
            [area setLeft:[area right]];
            goto EXIT;
        }

        // üĴ
        i = [rect top];
        if (i <= 0) {
            ;
        } else if (i < [area bottom]) {
            [area setTop:i];
        } else {
            [area setTop:[area bottom]];
            goto EXIT;
        }

        // դĴ
        i = [rect right];
        if (i < 0) {
            [area setLeft:[area right]];
            goto EXIT;
        } else if (i < [area right]) {
            [area setRight:i];
        }

        // üĴ
        i = [rect bottom];
        if (i < 0) {
            [area setTop:[area bottom]];
        } else if (i < [area bottom]) {
            [area setBottom:i];
        }
    }

EXIT:
    return area;
}


//
// ط
//
//  Call
//    image      : ɽѲ
//    rect       : ζ
//    scale      : ɽΨ(0.1% ñ)
//    supplement : ɽ
//                 == nil : ̵(ɽɥ)
//                 != nil : (祦ɥ)
//
//  Return
//    image : ɽѲ
//
-(void)drawBackground:(NSBitmapImageRep *)image
             withArea:(PoCoRect *)area
            withScale:(int)scale
       withSupplement:(PoCoMainViewSupplement *)supplement
{
    unsigned int *bmp;
    long x;
    long y;
    int gx;
    int gy;

    if ((supplement == nil) ||
        (([supplement backgroundColor] & 0x00ffffff) == 0x00ffffff)) {
        // 󤬤ʤط
        memset([image bitmapData], 0xff, [image bytesPerRow] * [image pixelsHigh]);
    } else {
        // ñ
        wmemset((wchar_t *)([image bitmapData]), [supplement backgroundColor], (([image bytesPerRow] * [image pixelsHigh]) / sizeof(wchar_t)));

        // ѥ
        if ([supplement isPattern]) {
            bmp = (unsigned int *)([image bitmapData]);
            y = [image pixelsHigh];
            gy = ((([area bottom] * scale) / 1000) - 1);
            do {
                x = [image pixelsWide];
                gx = (([area left] * scale) / 1000);
                do {
                    // 
                    if ((gx % TRANS_GRID) < TRANS_GRID_HALF) {
                        if ((gy % TRANS_GRID) < TRANS_GRID_HALF) {
                            *(bmp) = 0xffffffff;
                        }
                    } else {
                        if ((gy % TRANS_GRID) >= TRANS_GRID_HALF) {
                            *(bmp) = 0xffffffff;
                        }
                    }

                    // 
                    (x)--;
                    (gx)++;
                    (bmp)++;
                } while (x != 0);

                // 
                (y)--;
                (gy)--;
            } while (y != 0);
        }
    }

    return;
}


//
//  NSImageRep ()
//
//  Call
//    rect        : ζ
//    scale       : ɽΨ(0.1% ñ)
//    viewBuffer_ : ɽѤκȥХåե(instance ѿ)
//
//  Return
//    function :  NSImageRep
//
-(NSBitmapImageRep *)createViewImageRepScaleUp:(PoCoRect *)rect
                                     withScale:(int)scale
{
    const int width = ([rect width] * scale / 1000);
    const int height = ([rect height] * scale / 1000);
    const int row = (width << 2);

    return [[NSBitmapImageRep alloc]
               initWithBitmapDataPlanes:[self->viewBuffer_ resizeBitmap:height
                                                               rowBytes:row]
                             pixelsWide:width
                             pixelsHigh:height
                          bitsPerSample:8
                        samplesPerPixel:3
                               hasAlpha:NO
                               isPlanar:NO
                         colorSpaceName:NSCalibratedRGBColorSpace
                           bitmapFormat:(NSBitmapFormat)(0)
                            bytesPerRow:row
                           bitsPerPixel:32];
}


//
//  NSImageRep (̾)
//
//  Call
//    rect        : ζ
//    scale       : ɽΨ(0.1% ñ)
//    viewBuffer_ : ɽѤκȥХåե(instance ѿ)
//
//  Return
//    function :  NSImageRep
//
-(NSBitmapImageRep *)createViewImageRepScaleDown:(PoCoRect *)rect
                                       withScale:(int)scale
{
    const int adjust = (((1000 / scale) == 0) ? 0 : ((1000 / scale) - 1));
    const int width = ((([rect width] + adjust) * scale) / 1000);
    const int height = ((([rect height] + adjust) * scale) / 1000);
    const int row = (width << 2);

    return [[NSBitmapImageRep alloc]
               initWithBitmapDataPlanes:[self->viewBuffer_ resizeBitmap:height
                                                               rowBytes:row]
                             pixelsWide:width
                             pixelsHigh:height
                          bitsPerSample:8
                        samplesPerPixel:3
                               hasAlpha:NO
                               isPlanar:NO
                         colorSpaceName:NSCalibratedRGBColorSpace
                           bitmapFormat:(NSBitmapFormat)(0)
                            bytesPerRow:row
                           bitsPerPixel:32];
}


//
// ܲ
//
//  Call
//    area            : ζ
//    supplement      : ɽ
//                      == nil : ̵(ɽɥ)
//                      != nil : (祦ɥ)
//    viewBuffer_     : ɽѤκȥХåե(instance ѿ)
//    layer_          : ƥ쥤䡼(instance ѿ)
//    paletteTable_[] : ѥåͻȥơ֥(instance ѿ)
//    transTable_[]   : Ʃ껲ȥơ֥(instance ѿ)
//
//  Return
//    function : ɽѲ
//
-(NSBitmapImageRep *)createViewEvenSize:(PoCoRect *)area
                         withSupplement:(PoCoMainViewSupplement *)supplement
#if 1
{
    NSBitmapImageRep *image;            // ɽѲ
    unsigned int *imageBitmap;          // image  plane 
    PoCoBitmap *mask;                   // Ѥߥޥ
    int maskRow;                        // mask  rowbytes
    unsigned char *maskBitmap;          // mask  plane 
    int maskCount;                      // mask λĤ
    unsigned int maskSkip;              // mask  rowbytes - (Ԥ)
    int srcRow;                         // 踵 rowbytes
    unsigned char *srcBitmap;           // 踵 plane 
    unsigned int srcJump;               // 踵 plane ϰ
    unsigned int srcSkip;               // 踵 rowbytes - (Ԥ)
    int sx;                             // X (src)
    int sy;                             // Y (src)
    PoCoLayerBase *lyr;                 // оݤΥ쥤䡼
    NSEnumerator *iter;                 // 쥤䡼
    const int areaWidth = [area width];
    const int areaHeight = [area height];

    image = nil;
    mask = nil;

    // mask ΰ
    mask = [[PoCoBitmap alloc] initWidth:areaWidth
                              initHeight:areaHeight
                            defaultColor:1];
    if (mask == nil) {
        DPRINT((@"can't alloc PoCoBitmap(mask)\n"));
        goto EXIT;
    }
    maskRow = areaWidth + (areaWidth & 1);
    maskCount = areaWidth * areaHeight;
    maskSkip = maskRow - areaWidth;

    // NSBitmapImageRep 
    image = [[NSBitmapImageRep alloc]
                initWithBitmapDataPlanes:[self->viewBuffer_
                                             resizeBitmap:areaHeight
                                                 rowBytes:(areaWidth << 2)]
                              pixelsWide:areaWidth
                              pixelsHigh:areaHeight
                           bitsPerSample:8
                         samplesPerPixel:3
                                hasAlpha:NO
                                isPlanar:NO
                          colorSpaceName:NSCalibratedRGBColorSpace
                            bitmapFormat:(NSBitmapFormat)(0)
                             bytesPerRow:(areaWidth << 2)
                            bitsPerPixel:32];
    if (image == nil) {
        DPRINT((@"can't alloc NSBitmapImageRep\n"));
        goto EXIT;
    }

    // Ϥ
    [self drawBackground:image
                withArea:area
               withScale:1000
          withSupplement:supplement];

    // layer_ Ǹ缡
    iter = [self->layer_ reverseObjectEnumerator];
    lyr = [iter nextObject];
    srcRow = [[lyr bitmap] width];
    srcRow += (srcRow & 1);
    srcJump = ([area bottom] - 1) * srcRow + [area left];
    srcSkip = srcRow + areaWidth;
    for ( ; lyr != nil; lyr = [iter nextObject]) {
        // ɽ쥤䡼ʤФ
        if (!([lyr isDisplay])) {
            continue;
        }

        // Ƥȿ
        srcBitmap = [[lyr bitmap] pixelmap] + srcJump;
        maskBitmap = [mask pixelmap];
        imageBitmap = (unsigned int *)([image bitmapData]);
        sy = areaHeight;
        do {
            sx = areaWidth;
            do {
                if ((self->transTable_[*(srcBitmap)]) && (*(maskBitmap))) {
                    // 
                    *(imageBitmap) = self->paletteTable_[*(srcBitmap)];

                    // Ѥ
                    *(maskBitmap) = 0;

                    // 򹹿(Ƥ)
                    (maskCount)--;
                }

                // 
                (sx)--;
                (imageBitmap)++;
                (srcBitmap)++;
                (maskBitmap)++;
            } while (sx != 0);

            // ιԤ
            (sy)--;
            srcBitmap  -= srcSkip;
            maskBitmap += maskSkip;
        } while (sy != 0);

        // 
        if (maskCount == 0) {
            break;
        }
    }

EXIT:
    [mask release];
    return image;
}
#else   // 1
{
    NSBitmapImageRep *image;            // ɽѲ
    unsigned int *imageBitmap;          // image  plane 
    unsigned int imageJump;
    unsigned int imageSkip;
    PoCoBitmap *mask;                   // Ѥߥޥ
    int maskRow;                        // mask  rowbytes
    unsigned char *maskBitmap;          // mask  plane 
    int maskCount;                      // mask λĤ
    unsigned int maskSkip;              // mask  rowbytes - (Ԥ)
    int srcRow;                         // 踵 rowbytes
    unsigned char *srcBitmap;           // 踵 plane 
    unsigned int srcJump;               // 踵 plane ϰ
    unsigned int srcSkip;               // 踵 rowbytes - (Ԥ)
    int sx;                             // X (src)
    int sy;                             // Y (src)
    PoCoLayerBase *lyr;                 // оݤΥ쥤䡼
    NSEnumerator *iter;                 // 쥤䡼
    const int areaWidth = [area width];
    const int areaHeight = [area height];

    image = nil;
    mask = nil;

    // mask ΰ
    mask = [[PoCoBitmap alloc] initWidth:areaWidth
                              initHeight:areaHeight
                            defaultColor:1];
    if (mask == nil) {
        DPRINT((@"can't alloc PoCoBitmap(mask)\n"));
        goto EXIT;
    }
    maskRow = areaWidth + (areaWidth & 1);
    maskCount = areaWidth * areaHeight;
    maskSkip = maskRow - areaWidth;

    // NSBitmapImageRep 
    image = [[NSBitmapImageRep alloc]
                initWithBitmapDataPlanes:NULL
                              pixelsWide:areaWidth
                              pixelsHigh:areaHeight
                           bitsPerSample:8
                         samplesPerPixel:3
                                hasAlpha:NO
                                isPlanar:NO
                          colorSpaceName:NSCalibratedRGBColorSpace
                            bitmapFormat:(NSBitmapFormat)(0)
                             bytesPerRow:(areaWidth << 2)
                            bitsPerPixel:32];
    if (image == nil) {
        DPRINT((@"can't alloc NSBitmapImageRep\n"));
        goto EXIT;
    }
    imageJump = [image bytesPerRow] * [image pixelsHigh];
    imageJump -= [image bytesPerRow];
#if 0
    imageSkip = (([image bytesPerRow] << 1) >> 2);
#else   // 0
    imageSkip = ([image bytesPerRow] >> 1);
#endif  // 0

    // Ϥ
    [self drawBackground:image
                withArea:area
               withScale:1000
          withSupplement:supplement];

    // layer_ Ǹ缡
    iter = [self->layer_ reverseObjectEnumerator];
    lyr = [iter nextObject];
    srcRow = [[lyr bitmap] width];
    srcRow += (srcRow & 1);
    srcJump = [area top] * srcRow + [area left];
    srcSkip = srcRow - [area right] + [area left];
    for ( ; lyr != nil; lyr = [iter nextObject]) {
        // ɽ쥤䡼ʤФ
        if (!([lyr isDisplay])) {
            continue;
        }

        // Ƥȿ
        srcBitmap = [[lyr bitmap] pixelmap] + srcJump;
        maskBitmap = [mask pixelmap];
        imageBitmap = (unsigned int *)([image bitmapData] + imageJump);
        sy = areaHeight;
        do {
            sx = areaWidth;
            do {
                if ((self->transTable_[*(srcBitmap)]) && (*(maskBitmap))) {
                    // 
                    *(imageBitmap) = self->paletteTable_[*(srcBitmap)];

                    // Ѥ
                    *(maskBitmap) = 0;

                    // 򹹿(Ƥ)
                    (maskCount)--;
                }

                // 
                (sx)--;
                (imageBitmap)++;
                (srcBitmap)++;
                (maskBitmap)++;
            } while (sx != 0);

            // ιԤ
            (sy)--;
            imageBitmap -= imageSkip;
            srcBitmap   += srcSkip;
            maskBitmap  += maskSkip;
        } while (sy != 0);

        // 
        if (maskCount == 0) {
            break;
        }
    }

EXIT:
    [mask release];
    return image;
}
#endif  // 1


//
// 
//
//  Call
//    area            : ζ
//    scale           : ɽΨ(0.1% ñ)
//    supplement      : ɽ
//                      == nil : ̵(ɽɥ)
//                      != nil : (祦ɥ)
//    layer_          : ƥ쥤䡼(instance ѿ)
//    paletteTable_[] : ѥåͻȥơ֥(instance ѿ)
//    transTable_[]   : Ʃ껲ȥơ֥(instance ѿ)
//
//  Return
//    function : ɽѲ
//
-(NSBitmapImageRep *)createViewScaleUp:(PoCoRect *)area
                             withScale:(int)scale
                        withSupplement:(PoCoMainViewSupplement *)supplement
#if 1
{
    NSBitmapImageRep *image;            // ɽѲ
    unsigned int *imageBitmap;          // image  plane 
    int imageRow;                       // image  rowbytes
    unsigned int imageStep;             // image  step 
    unsigned int imageSkip;             // image μιԤؤΰư
    PoCoBitmap *mask;                   // Ѥߥޥ
    int maskRow;                        // mask  rowbytes
    unsigned char *maskBitmap;          // mask  plane 
    int maskCount;                      // mask λĤ
    unsigned int maskSkip;              // mask  rowbytes - (Ԥ)
    int srcRow;                         // 踵 rowbytes
    unsigned char *srcBitmap;           // 踵 plane 
    unsigned int srcJump;               // 踵 plane ϰ
    unsigned int srcSkip;               // 踵 rowbytes - (Ԥ)
    int sx;                             // X (src)
    int sy;                             // Y (src)
    PoCoLayerBase *lyr;                 // оݤΥ쥤䡼
    NSEnumerator *iter;                 // 쥤䡼
    const int areaWidth = [area width];
    const int areaHeight = [area height];
    int gx;
    int gy;
    unsigned char gridType;

    image = nil;
    mask = nil;

    // mask ΰ
    mask = [[PoCoBitmap alloc] initWidth:[area width]
                              initHeight:[area height]
                            defaultColor:1];
    if (mask == nil) {
        DPRINT((@"can't alloc PoCoBitmap(mask)\n"));
        goto EXIT;
    }
    maskRow = [mask width] + ([mask width] & 1);
    maskCount = [area width] * [area height];
    maskSkip = maskRow - areaWidth;

    // NSBitmapImageRep 
    image = [self createViewImageRepScaleUp:area
                                  withScale:scale];
    if (image == nil) {
        DPRINT((@"can't alloc NSBitmapImageRep\n"));
        goto EXIT;
    }
    imageRow = (int)([image bytesPerRow]);
    imageRow >>= 2;
    imageStep = scale / 1000;
    imageSkip = imageRow * (imageStep - 1);

    // Ϥ
    [self drawBackground:image
                withArea:area
               withScale:scale
          withSupplement:supplement];

    // layer_ Ǹ缡
    iter = [self->layer_ reverseObjectEnumerator];
    lyr = [iter nextObject];
    srcRow = [[lyr bitmap] width];
    srcRow += (srcRow & 1);
    srcJump = ([area bottom] - 1) * srcRow + [area left];
    srcSkip = srcRow + areaWidth;
    for ( ; lyr != nil; lyr = [iter nextObject]) {
        // ɽ쥤䡼ʤФ
        if (!([lyr isDisplay])) {
            continue;
        }

        // Ƥȿ
        srcBitmap = [[lyr bitmap] pixelmap] + srcJump;
        maskBitmap = [mask pixelmap];
        imageBitmap = (unsigned int *)([image bitmapData]);
        sy = areaHeight;
        gy = [area bottom];
        do {
            sx = areaWidth;
            gx = [area left];
            do {
                // åμ
                gridType = GRID_NONE;
                if ((supplement != nil) &&
                    ([supplement gridStep] > 0) &&  // ̵ǤϤʤ
                    (scale >= 4000)) {              // ܰʾɽ
                    // Ѥμ
                    if (gx > 0) {
                        gridType |= GRID_HORI_DOTTED;
                        if ((gx % [supplement gridStep]) == 0) {
                            gridType |= GRID_HORI_SOLID;
                        }
                    }

                    // Ѥμ
                    if ((gy > 0) && (gy < [[lyr bitmap] height])) {
                        gridType |= GRID_VERT_DOTTED;
                        if ((gy % [supplement gridStep]) == 0) {
                            gridType |= GRID_VERT_SOLID;
                        }
                    }
                }

                // Ʃʤ(ؤʤΤѤߤʤФ)
                if ((self->transTable_[*(srcBitmap)]) && (*(maskBitmap))) {
                    // 
                    [self drawArea:imageBitmap
                            square:imageStep
                          rowBytes:imageRow
                             color:self->paletteTable_[*(srcBitmap)]
                          withGrid:gridType];

                    // Ѥ
                    *(maskBitmap) = 0;

                    // 򹹿(Ƥ)
                    (maskCount)--;
                }

                // 
                (sx)--;
                (gx)++;
                imageBitmap += imageStep;
                (srcBitmap)++;
                (maskBitmap)++;
            } while (sx != 0);

            // ιԤ
            (sy)--;
            (gy)--;
            imageBitmap += imageSkip;
            srcBitmap   -= srcSkip;
            maskBitmap  += maskSkip;
        } while (sy != 0);

        // 
        if (maskCount == 0) {
            break;
        }
    }

EXIT:
    [mask release];
    return image;
}
#else   // 1
{
    NSBitmapImageRep *image;            // ɽѲ
    unsigned int *imageBitmap;          // image  plane 
    int imageRow;                       // image  rowbytes
    unsigned int imageStep;             // image  step 
    unsigned int imageSkip;             // image μιԤؤΰư
    int imageCnt;
    int imageErrX;
    int imageErrY;
    unsigned int imageCorrX;
    unsigned int imageCorrY;
    PoCoBitmap *mask;                   // Ѥߥޥ
    int maskRow;                        // mask  rowbytes
    unsigned char *maskBitmap;          // mask  plane 
    int maskCount;                      // mask λĤ
    unsigned int maskSkip;              // mask  rowbytes - (Ԥ)
    int srcRow;                         // 踵 rowbytes
    unsigned char *srcBitmap;           // 踵 plane 
    unsigned int srcJump;               // 踵 plane ϰ
    unsigned int srcSkip;               // 踵 rowbytes - (Ԥ)
    int sx;                             // X (src)
    int sy;                             // Y (src)
    PoCoLayerBase *lyr;                 // оݤΥ쥤䡼
    NSEnumerator *iter;                 // 쥤䡼
    const int areaWidth = [area width];
    const int areaHeight = [area height];
    int gx;
    int gy;
    unsigned char gridType;
    int scaleMod;

    image = nil;
    mask = nil;

    // mask ΰ
    mask = [[PoCoBitmap alloc] initWidth:[area width]
                              initHeight:[area height]
                            defaultColor:1];
    if (mask == nil) {
        DPRINT((@"can't alloc PoCoBitmap(mask)\n"));
        goto EXIT;
    }
    maskRow = ([mask width] + ([mask width] & 1));
    maskCount = ([area width] * [area height]);
    maskSkip = (maskRow - areaWidth);

    // NSBitmapImageRep 
    image = [self createViewImageRepScaleUp:area
                                  withScale:scale];
    if (image == nil) {
        DPRINT((@"can't alloc NSBitmapImageRep\n"));
        goto EXIT;
    }
    imageRow = (int)([image bytesPerRow]);
    imageRow >>= 2;
    imageStep = (scale / 1000);
    scaleMod = (scale % 1000);
    imageSkip = (imageRow * (imageStep - 1));

    // Ϥ
    [self drawBackground:image
                withArea:area
               withScale:scale
          withSupplement:supplement];

    // layer_ Ǹ缡
    iter = [self->layer_ reverseObjectEnumerator];
    lyr = [iter nextObject];
    srcRow = [[lyr bitmap] width];
    srcRow += (srcRow & 1);
    srcJump = ((([area bottom] - 1) * srcRow) + [area left]);
    srcSkip = (srcRow + areaWidth);
    for ( ; lyr != nil; lyr = [iter nextObject]) {
        // ɽ쥤䡼ʤФ
        if (!([lyr isDisplay])) {
            continue;
        }

        // Ƥȿ
        srcBitmap = ([[lyr bitmap] pixelmap] + srcJump);
        maskBitmap = [mask pixelmap];
        imageBitmap = (unsigned int *)([image bitmapData]);
        sy = areaHeight;
        gy = [area bottom];
        imageErrY = 0;
        imageCorrY = 0;
        do {
            imageCnt = imageRow;
            imageErrX = 0;
            imageCorrX = 0;
            sx = areaWidth;
            gx = [area left];
            do {
                // åμ
                gridType = GRID_NONE;
                if ((supplement != nil) &&
                    ([supplement gridStep] > 0) &&  // ̵ǤϤʤ
                    (scale >= 4000)) {              // ܰʾɽ
                    // Ѥμ
                    if (gx > 0) {
                        gridType |= GRID_HORI_DOTTED;
                        if ((gx % [supplement gridStep]) == 0) {
                            gridType |= GRID_HORI_SOLID;
                        }
                    }

                    // Ѥμ
                    if ((gy > 0) && (gy < [[lyr bitmap] height])) {
                        gridType |= GRID_VERT_DOTTED;
                        if ((gy % [supplement gridStep]) == 0) {
                            gridType |= GRID_VERT_SOLID;
                        }
                    }
                }

                // Ʃʤ(ؤʤΤѤߤʤФ)
                if ((self->transTable_[*(srcBitmap)]) && (*(maskBitmap))) {
                    // 
                    [self drawArea:imageBitmap
                             width:(imageStep + imageCorrX)
                            height:(imageStep + imageCorrY)
                          rowBytes:imageRow
                             color:self->paletteTable_[*(srcBitmap)]
                          withGrid:gridType];

                    // Ѥ
                    *(maskBitmap) = 0;

                    // 򹹿(Ƥ)
                    (maskCount)--;
                }

                // 
                (sx)--;
                (gx)++;
                imageBitmap += (imageStep + imageCorrX);
                (srcBitmap)++;
                (maskBitmap)++;
                imageCnt -= (imageStep + imageCorrX);
                imageErrX += scaleMod;
                if (imageErrX >= 1000) {
                    imageErrX -= 1000;
                    imageCorrX = 1;
                } else {
                    imageCorrX = 0;
                }
            } while (sx != 0);

            // ιԤ
            (sy)--;
            (gy)--;
            imageBitmap += (imageSkip + imageCnt + (imageRow * imageCorrY));
            srcBitmap -= srcSkip;
            maskBitmap += maskSkip;
            imageErrY += scaleMod;
            if (imageErrY >= 1000) {
                imageErrY -= 1000;
                imageCorrY = 1;
            } else {
                imageCorrY = 0;
            }
        } while (sy != 0);

        // 
        if (maskCount == 0) {
            break;
        }
    }

EXIT:
    [mask release];
    return image;
}
#endif  // 1


//
// ̾
//
//  Call
//    area            : ζ
//    scale           : ɽΨ(0.1% ñ)
//    supplement      : ɽ
//                      == nil : ̵(ɽɥ)
//                      != nil : (祦ɥ)
//    layer_          : ƥ쥤䡼(instance ѿ)
//    paletteTable_[] : ѥåͻȥơ֥(instance ѿ)
//    transTable_[]   : Ʃ껲ȥơ֥(instance ѿ)
//
//  Return
//    function : ɽѲ
//
-(NSBitmapImageRep *)createViewScaleDown:(PoCoRect *)area
                               withScale:(int)scale
                          withSupplement:(PoCoMainViewSupplement *)supplement
{
    #define FRAC_BIAS 1024              // 꾮 bias

    NSBitmapImageRep *image;            // ɽѲ
    unsigned int *dp;                   // 
    long dw;                            // 
    long dh;                            // ι⤵

    PoCoBitmap *mask;                   // Ѥߥޥ
    unsigned char *mp;                  // mask 
    int mrow;                           // mask  rowbytes
    int mskip;                          // mask  rowbytes - (Ԥ)
    long long mcount;                   // mask λĤ

    unsigned char *sp;                  // 踵
    long long srow;                     // 踵 rowbytes
    long long sskip;                    // 踵 rowbytes - (Ԥ)
    long long sstep;                    // 踵 step 
    long long sfrac;                    // 踵ü(step ü)
    long long sjump;                    // 踵ϰ
    long long sw;                       // 踵(üѻ)
    long long sh;                       // 踵ι⤵(üѻ)
    long scnt;

    PoCoLayerBase *lyr;                 // оݤΥ쥤䡼
    NSEnumerator *iter;                 // 쥤䡼
    const long width = [area width];

    image = nil;
    mask = nil;

    // NSBitmapImageRep 
    image = [self createViewImageRepScaleDown:area
                                    withScale:scale];
    if (image == nil) {
        DPRINT((@"can't alloc NSBitmapImageRep\n"));
        goto EXIT;
    }

    // mask ΰ
    mask = [[PoCoBitmap alloc] initWidth:(int)([image pixelsWide])
                              initHeight:(int)([image pixelsHigh])
                            defaultColor:1];
    if (mask == nil) {
        DPRINT((@"can't alloc PoCoBitmap(mask)\n"));
        goto EXIT;
    }
    mrow = ([mask width] + ([mask width] & 1));
    mcount = ([mask width] * [mask height]);
    mskip = (mrow - [mask width]);

    // Ϥ
    [self drawBackground:image
                withArea:area
               withScale:scale
          withSupplement:supplement];

    // layer_ Ǹ缡
    iter = [self->layer_ reverseObjectEnumerator];
    lyr = [iter nextObject];
    srow = [[lyr bitmap] width];
    srow += (srow & 1);
    sjump = ((([area bottom] - 1) * srow) + [area left]);
    sfrac = ((1000 * FRAC_BIAS) / (long long)(scale));
    sstep = (unsigned int)(sfrac / FRAC_BIAS);
    if (sstep == 0) {
        sstep = 1;
    }
    sfrac -= (sstep * FRAC_BIAS);
    sskip = ((srow * sstep) + width);
#if 0
printf("\n");
printf("scale     : %d\n", scale);
printf("area      : %d, %d, %d, %d(%d, %d)\n", [area left], [area top], [area right], [area bottom], [area width], [area height]);
printf("image     : %d, %d\n", [image pixelsWide], [image pixelsHigh]);
printf("mrow      : %d\n", mrow);
printf("mskip     : %d\n", mskip);
printf("mcount    : %d\n", mcount);
printf("srow      : %d\n", srow);
printf("sskip     : %d\n", sskip);
printf("sstep     : %d\n", sstep);
printf("sfrac     : %d\n", sfrac);
printf("sjump     : %d\n", sjump);
#endif  // 0
    for ( ; lyr != nil; lyr = [iter nextObject]) {
        // ɽ쥤䡼ʤФ
        if (!([lyr isDisplay])) {
            continue;
        }

        // Ƥȿ
        dp = (unsigned int *)([image bitmapData]);
        mp = [mask pixelmap];
        sp = ([[lyr bitmap] pixelmap] + sjump);
        sh = 0;
        dh = [image pixelsHigh];
        do {
            scnt = 0;
            sw = 0;
            dw = [image pixelsWide];
            do {
                if ((self->transTable_[*(sp)]) && (*(mp))) {
                    // 
                    *(dp) = self->paletteTable_[*(sp)];

                    // Ѥ
                    *(mp) = 0;

                    // 򹹿(Ƥ)
                    (mcount)--;
                }

                // 
                (dw)--;
                (dp)++;
                (mp)++;
                sp += sstep;
                scnt += sstep;
                sw += sfrac;
                if (sw > FRAC_BIAS) {
                    (sp)++;
                    (scnt)++;
                    sw -= FRAC_BIAS;
                }
            } while (dw != 0);

            // 
            (dh)--;
            mp += mskip;
            sp -= (sskip - (width - scnt));
            sh += sfrac;
            if (sh > FRAC_BIAS) {
                sp -= srow;
                sh -= FRAC_BIAS;
            }
        } while (dh != 0);

        // 
        if (mcount <= 0) {
            break;
        }
    }

EXIT:
    [mask release];
    return image;
}


// -------------------------------------- instance - private - եϷ
//
// IHDR Chunk(إå)
//
//  Call
//    width  : 
//    height : ⤵
//
//  Return
//    function : data
//
-(NSData *)createIHDRChunk:(int)width
                    height:(int)height
{
    NSData *data;
    PoCoPNGEncoder *png;

    DPRINT((@"[PoCoPicture:createIHDRChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("IHDR")];

    // IHDR Chunk Ƥ񤭹
    [png writeIntChunk:width];          // 
    [png writeIntChunk:height];         // ⤵
    [png writeByteChunk:8];             // 1ǤΥӥåȿ
    [png writeByteChunk:3];             // 顼(index color)
    [png writeByteChunk:0];             // ˡ
    [png writeByteChunk:0];             // ե륿
    [png writeByteChunk:0];             // 󥿡졼(none interlace)

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}


//
// iCCP Chunk(ICC Profile)
//
//  Call
//    None
//
//  Return
//    function : data
//
-(NSData *)createICCPChunk
#if (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_5)
{
    static  unsigned char nm[] = {'I', 'C', 'C', ' ', 'P', 'r', 'o', 'f', 'i', 'l', 'e', 0x00};
    NSData *data;
    PoCoPNGEncoder *png;
    PoCoWErr rv;
    PoCoZlibDeflate *zlib;
    NSData *scr;

    DPRINT((@"[PoCoPicture:createICCPChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("iCCP")];

    // ̾
    [png writeChunk:nm
             length:sizeof(nm)];

    // ˡ
    [png writeByteChunk:0x00];

    // MainScreen  ICC Profile 
    scr = [[[NSScreen mainScreen] colorSpace] ICCProfileData];

    // ICC Profile 򰵽
    zlib = [[PoCoZlibDeflate alloc] init];
    rv = [zlib appendBytes:[scr bytes]
                    length:(int)([scr length])];
    if (rv < ER_OK) {
        DPRINT((@"[zlib appendBytes: length:] : %d(0x%08x)\n", rv, rv));
    } else {
        [png writeChunk:[zlib bytes]
                 length:[zlib length]];
        [zlib clearBuffer:[zlib length]];
        do {
            rv = [zlib finishData];
            if (rv < ER_OK) {
                DPRINT((@"[zlib finishData] : %d(0x%08x)\n", rv, rv));
                break;
            }
            [png writeChunk:[zlib bytes]
                     length:[zlib length]];
            [zlib clearBuffer:[zlib length]];
        } while (rv == 1);
    }
    [zlib release];

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}
#else // MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_5
{
    static  unsigned char profile[] = {
        0x49, 0x43, 0x43, 0x20, 0x50, 0x72, 0x6f, 0x66,
        0x69, 0x6c, 0x65, 0x00, 0x00, 0x78, 0x01, 0x63,
        0x60, 0x60, 0x32, 0x70, 0x74, 0x71, 0x72, 0x65,
        0x12, 0x60, 0x60, 0xc8, 0xcd, 0x2b, 0x29, 0x0a,
        0x72, 0x77, 0x52, 0x88, 0x88, 0x8c, 0x52, 0x60,
        0xbf, 0xc0, 0xc0, 0xc1, 0xc0, 0xcd, 0x20, 0xcc,
        0x60, 0xcc, 0x60, 0x9d, 0x98, 0x5c, 0x5c, 0xe0,
        0x18, 0x10, 0xe0, 0xc3, 0x00, 0x04, 0x79, 0xf9,
        0x79, 0xa9, 0x20, 0x1a, 0x15, 0x7c, 0xbb, 0xc6,
        0xc0, 0x08, 0x12, 0xb9, 0xac, 0x0b, 0x32, 0xeb,
        0xde, 0x8a, 0xe6, 0xa6, 0x1b, 0x33, 0xaf, 0x7e,
        0x7b, 0x5a, 0xbc, 0xc5, 0xc8, 0xdd, 0xea, 0xa1,
        0x05, 0xaa, 0x5a, 0x0c, 0x1e, 0x57, 0x72, 0x41,
        0x51, 0x09, 0x50, 0xf4, 0x0f, 0x10, 0x1b, 0xa5,
        0xa4, 0x16, 0x27, 0x33, 0x30, 0x30, 0x1a, 0x00,
        0xd9, 0xd9, 0xe5, 0x25, 0x05, 0x40, 0x71, 0xc6,
        0x39, 0x40, 0xb6, 0x48, 0x52, 0x36, 0x98, 0xbd,
        0x01, 0xc4, 0x2e, 0x0a, 0x09, 0x72, 0x06, 0x8a,
        0x1f, 0x01, 0xb2, 0xf9, 0xd2, 0x21, 0xec, 0x2b,
        0x20, 0x76, 0x12, 0x84, 0xfd, 0x04, 0xc4, 0x2e,
        0x02, 0x7a, 0x02, 0xa8, 0xe6, 0x0b, 0x48, 0x7d,
        0x3a, 0x98, 0xcd, 0xc4, 0x01, 0x62, 0x27, 0x41,
        0xd8, 0x32, 0x20, 0x76, 0x49, 0x6a, 0x05, 0xc8,
        0x5e, 0x06, 0xe7, 0xfc, 0x82, 0xca, 0xa2, 0xcc,
        0xf4, 0x8c, 0x12, 0x05, 0x23, 0x03, 0x03, 0x03,
        0x05, 0xc7, 0x94, 0xfc, 0xa4, 0x54, 0x85, 0xe0,
        0xca, 0xe2, 0x92, 0xd4, 0xdc, 0x62, 0x05, 0xcf,
        0xbc, 0xe4, 0xfc, 0xa2, 0x82, 0xfc, 0xa2, 0xc4,
        0x92, 0xd4, 0x14, 0xa0, 0x5a, 0x88, 0xfb, 0x40,
        0xba, 0x18, 0x04, 0x21, 0x0a, 0x41, 0x21, 0xa6,
        0x61, 0x68, 0x69, 0x69, 0xa1, 0x09, 0x16, 0xa5,
        0x22, 0x01, 0x8a, 0x07, 0x88, 0x71, 0x9f, 0x03,
        0xc1, 0xe1, 0xcb, 0x28, 0x76, 0x06, 0x21, 0x86,
        0xb0, 0x28, 0xb9, 0xb4, 0xa8, 0x0c, 0xca, 0x63,
        0x64, 0x32, 0x66, 0x60, 0x20, 0xc4, 0x47, 0x98,
        0x31, 0x47, 0x82, 0x81, 0xc1, 0x7f, 0x29, 0x03,
        0x03, 0xcb, 0x1f, 0x84, 0x98, 0x49, 0x2f, 0x03,
        0xc3, 0x02, 0x1d, 0x06, 0x06, 0xfe, 0xa9, 0x08,
        0x31, 0x35, 0x43, 0x06, 0x06, 0x01, 0x7d, 0x06,
        0x86, 0x7d, 0x73, 0x00, 0x68, 0xdb, 0x5a, 0x0e
    };

    NSData *data;
    PoCoPNGEncoder *png;

    DPRINT((@"[PoCoPicture:createICCPChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("iCCP")];

    // iCCP Chunk Ƥ񤭹
    [png writeChunk:profile length:sizeof(profile)];

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}
#endif  // MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_5


//
// sRGB Chunk(sRGB)
//
//  Call
//    srgb_ : sRGB CHUNK(instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createSRGBChunk
{
    NSData *data;
    PoCoPNGEncoder *png;
    unsigned char i;

    DPRINT((@"[PoCoPicture:createSRGBChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("sRGB")];

    // sRGB Chunk Ƥ񤭹
    i = self->srgb_;
    [png writeByteChunk:i];

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}


//
// gAMA Chunk()
//
//  Call
//    gamma_ : gAMA CHUNK(instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createGAMAChunk
{
    NSData *data;
    PoCoPNGEncoder *png;

    DPRINT((@"[PoCoPicture:createGAMAChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("gAMA")];

    // gAMA Chunk Ƥ񤭹
    [png writeIntChunk:self->gamma_];

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}


//
// cHRM Chunk()
//
//  Call
//    chromakey_[] : cHRM CHUNK(instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createCHRMChunk
{
    NSData *data;
    PoCoPNGEncoder *png;

    DPRINT((@"[PoCoPicture:createCHRMChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("cHRM")];

    // cHRM Chunk Ƥ񤭹
    [png writeIntChunk:self->chromakey_[0]];
    [png writeIntChunk:self->chromakey_[1]];
    [png writeIntChunk:self->chromakey_[2]];
    [png writeIntChunk:self->chromakey_[3]];
    [png writeIntChunk:self->chromakey_[4]];
    [png writeIntChunk:self->chromakey_[5]];
    [png writeIntChunk:self->chromakey_[6]];
    [png writeIntChunk:self->chromakey_[7]];

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}


//
// bKGD Chunk(طʿ)
//
//  Call
//    bkgdColor_ : طʿ(instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createBKGDChunk
{
    NSData *data;
    PoCoPNGEncoder *png;
    unsigned char i;

    DPRINT((@"[PoCoPicture:createGKGDChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("bKGD")];

    // bKGD Chunk Ƥ񤭹
    i = self->bkgdColor_;
    [png writeByteChunk:i];

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}


//
// pHYs Chunk(ʪ)
//
//  Call
//    h_unit_ : ʿѻ(instance ѿ)
//    v_unit_ : ľѻ(instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createPHYSChunk
{
    NSData *data;
    PoCoPNGEncoder *png;

    DPRINT((@"[PoCoPicture:createPHYSChunk]\n"));

    png = [[PoCoPNGEncoder alloc] init];

    // CHUNK 
    [png createChunk:(unsigned char *)("pHYs")];

    // pHYs Chunk Ƥ񤭹
    [png writeIntChunk:(int)(floor((1000 * self->h_unit_) / 25.4))];
    [png writeIntChunk:(int)(floor((1000 * self->v_unit_) / 25.4))];
    [png writeByteChunk:1];

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];
    [png release];

    return data;
}


//
// IDAT Chunk()Υᥤ
//
//  Call
//    bmp : оݲ
//
//  Return
//    function : data
//
-(NSData *)createIDATChunkMain:(PoCoBitmap *)bmp
{
    NSData *data;
    PoCoPNGEncoder *png;
    PoCoWErr rv;
    int y;
    PoCoZlibDeflate *zlib;
    unsigned char *src;                 // ̸
    unsigned char *line;                // 1ʬΥХåե
    unsigned int row;                   // row bytes
    const unsigned int width = [bmp width];
    const unsigned int height = [bmp height];

    DPRINT((@"[PoCoPicture:createIDATChunkMain]\n"));

    data = nil;
    png = nil;
    zlib = nil;
    line = NULL;
    row = width + (width & 1);

    // 1饤ΥХåե
    line = (unsigned char *)(calloc(width + 1, sizeof(unsigned char)));
    if (line == NULL) {
        DPRINT((@"memory allocation error.\n"));
        goto EXIT;
    }

    // CHUNK 
    png = [[PoCoPNGEncoder alloc] init];
    [png createChunk:(unsigned char *)("IDAT")];

    // 򥨥󥳡
    zlib = [[PoCoZlibDeflate alloc] init];
    src = [bmp pixelmap];
    for (y = 0; y < height; y++) {
        // 1饤󰵽(filter type Ͼ None filter)
        memcpy(line + 1, src, width);
        rv = [zlib appendBytes:line length:(width + 1)];
        if (rv < ER_OK) {
            DPRINT((@"[zlib appendBytes length] : %d(0x%08x)\n", rv, rv));
            [png release];
            png = nil;
            goto EXIT;
        }
        [png writeChunk:[zlib bytes] length:[zlib length]];
        [zlib clearBuffer:[zlib length]];
        while (rv == 1) {
            rv = [zlib appendBytes:NULL length:0];
            if (rv < ER_OK) {
                DPRINT((@"[zlib appendBytes length] : %d(0x%08x)\n", rv, rv));
                [png release];
                png = nil;
                goto EXIT;
            }
            [png writeChunk:[zlib bytes] length:[zlib length]];
            [zlib clearBuffer:[zlib length]];
        }

        // ιԤ
        src += row;
    }

    // ̽λ
    do {
        rv = [zlib finishData];
        if (rv < ER_OK) {
            DPRINT((@"[zlib finishData] : %d(0x%08x)\n", rv, rv));
            [png release];
            png = nil;
            goto EXIT;
        }
        [png writeChunk:[zlib bytes] length:[zlib length]];
        [zlib clearBuffer:[zlib length]];
    } while (rv == 1);

    // CHUNK Ĥ
    [png closeChunk];

    // NSData 
    data = [png createNSData];

EXIT:
    if (line != NULL) {
        free(line);
    }
    [png release];
    [zlib release];
    return data;
}


//
// IDAT Chunk()
//  ɽ礷 IDAT CHUNK ˳Ǽ
//
//  Call
//    None
//
//  Return
//    function : data
//
-(NSData *)createIDATChunk
{
    NSData *data;
    PoCoBitmapLayer *bmp;               // ̸(ɽѤ߲)

    DPRINT((@"[PoCoPicture:createIDATChunk]\n"));

    // ɽ쥤䡼礷
    bmp = [PoCoControllerPictureLayerUnificater
              createUnificatePicture:self
                             isFirst:YES];

    // IDAT Chunk 
    data = [self createIDATChunkMain:[bmp bitmap]];
    [bmp release];

    return data;
}


//
// IDAT Chunk()
//  Υ쥤䡼Τߤ IDAT CHUNK ˳Ǽ
//
//  Call
//    r      : ڤϰ
//    index  : оݥ쥤䡼
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createIDATChunk:(PoCoRect *)r
                   atIndex:(int)index
{
    NSData *data;
    PoCoBitmap *bmp;                    // ̸(ɽ)

    DPRINT((@"[PoCoPicture:createIDATChunk atIndex]\n"));

    // оݥ쥤䡼ɽƼ
    bmp = [[[self->layer_ objectAtIndex:index] bitmap] getBitmap:r];

    // IDAT Chunk 
    data = [self createIDATChunkMain:bmp];
    [bmp release];

    return data;
}


//
// iCCP Chunk(ICC Profile)ɤ߹
//  CHUNK ƤϳФʤ(̵뤹)
//  sRGB äƤ⡢iCCP ʤ iCCP ͥ褹
//  (iCCP  sRGB ξΤ PNG Ͱȿ)
//
//  Call
//    png : PNG decoder
//
//  Return
//    function   : YES : 
//                 NO  : 
//    isUseICCP_ : iCCP (instance ѿ)
//
-(BOOL)loadICCPChunk:(PoCoPNGDecoder *)png
{
    // ƤϴΤʤ
    self->isUseICCP_ = YES;

    return YES;                         //  YES
}


//
// sRGB Chunk(sRGB)ɤ߹
//  iCCP äƤ⡢sRGB ʤ sRGB ͥ褹
//  (iCCP  sRGB ξΤ PNG Ͱȿ)
//
//  Call
//    png : PNG decoder
//
//  Return
//    function   : YES : 
//                 NO  : 
//    srgb_      : sRGB CHUNK(instance ѿ)
//    isUseICCP_ : iCCP (instance ѿ)
//
-(BOOL)loadSRGBChunk:(PoCoPNGDecoder *)png
{
    BOOL result;
    unsigned char i;

    // ɤ߹
    result = [png readByteChunk:&(i)];
    if (result != YES) {
        DPRINT((@"can't read sRGB CHUNK.\n"));
        goto EXIT;
    }
    self->srgb_ = i;
    self->isUseICCP_ = NO;

EXIT:
    return result;
}


//
// gAMA Chunk()ɤ߹
//
//  Call
//    png : PNG decoder
//
//  Return
//    function : YES : 
//               NO  : 
//    gamma_   : gAMA CHUNK(instance ѿ)
//
-(BOOL)loadGAMAChunk:(PoCoPNGDecoder *)png
{
    BOOL result;
    unsigned int i;

    // ɤ߹
    result = [png readIntChunk:&(i)];
    if (result != YES) {
        DPRINT((@"can't read gAMA CHUNK.\n"));
        goto EXIT;
    }
    self->gamma_ = i;

EXIT:
    return result;
}


//
// cHRM Chunk()ɤ߹
//
//  Call
//    png : PNG decoder
//
//  Return
//    function     : YES : 
//                   NO  : 
//    chromakey_[] : cHRM CHUNK(instance ѿ)
//
-(BOOL)loadCHRMChunk:(PoCoPNGDecoder *)png
{
    BOOL result;
    int l;
    unsigned int i;

    result = NO;

    // 8ĸ
    for (l = 0; l < 8; l++) {
        result = [png readIntChunk:&(i)];
        if (result != YES) {
            DPRINT((@"can't read cHRM[%d] CHUNK.\n", l));
            break;
        } else {
            self->chromakey_[l] = i;
        }
    }

    return result;
}


//
// bKGD Chunk(طʿ)ɤ߹
//
//  Call
//    png : PNG decoder
//
//  Return
//    function   : YES : 
//                 NO  : 
//    isUseBKGD_ : طʿ(instance ѿ)
//    bkgdColor_ : طʿ(instance ѿ)
//
-(BOOL)loadBKGDChunk:(PoCoPNGDecoder *)png
{
    BOOL result;
    unsigned char i;

    // bKGD Ѥˤ
    self->isUseBKGD_ = YES;

    // Ǥ
    result = [png readByteChunk:&(i)];
    if (result) {
        self->bkgdColor_ = i;
    }

    return result;
}


//
// pHYs Chunk(ʪ)ɤ߹
//
//  Call
//    png : PNG decoder
//
//  Return
//    function : YES : 
//               NO  : 
//    h_unit_  : ʿѻ(instance ѿ)
//    v_unit_  : ľѻ(instance ѿ)
//
-(BOOL)loadPHYSChunk:(PoCoPNGDecoder *)png
{
    BOOL result;
    unsigned int i;

    // ʿ٤
    result = [png readIntChunk:&(i)];
    if (result != YES) {
        goto EXIT;
    }
    self->h_unit_ = (int)(floor(((float)(i) * 25.4) / (float)(1000.0) + (float)(0.5)));

    // ľ٤
    result = [png readIntChunk:&(i)];
    if (result != YES) {
        goto EXIT;
    }
    self->v_unit_ = (int)(floor(((float)(i) * 25.4) / (float)(1000.0) + (float)(0.5)));

EXIT:
    return result;
}


//
// Ǥդ CHUNK ɤ߹
//  Ū IDAT Chunk ̵
//  ilAY/slAY  1Ĥʤä쥤䡼ɤؤ
//
//  Call
//    data      : ɤ߹
//    range     : ɤ߹ϰ
//    width     : 
//    height    : ⤵
//    colpat_[] : 顼ѥ(instance ѿ)
//
//  Return
//    function  : YES : 
//                NO  : 
//    range     : ɤ߹ϰ
//    colpat_[] : 顼ѥ(instance ѿ)
//
-(BOOL)loadChunks:(NSData *)data
        withRange:(NSRange *)range
        sizeWidth:(unsigned int)width
       sizeHeight:(unsigned int)height
{
    BOOL result;
    int cpat;                           // 顼ѥθĿ
    BOOL isContinue;
    BOOL isNoExistLayer;
    PoCoPNGDecoder *png;
    PoCoLayerBase *lyr;

    png = nil;
    isContinue = YES;
    isNoExistLayer = YES;
    cpat = 0;

    png = [[PoCoPNGDecoder alloc] init];
    do {
        // CHUNK ɤ߹
        result = [png loadNSData:data withRange:range];
        if (result != YES) {
            break;
        }

        // CHUNK 򳫤
        [png openChunk:[png chunkName]];

        // CHUNK פȤʬ
        if (memcmp([png chunkName], "iCCP", 4) == 0) {
            // iCCP CHUNK(ICC Profile)
            result = [self loadICCPChunk:png];
        } else if (memcmp([png chunkName], "sRGB", 4) == 0) {
            // sRGB CHUNK(sRGB)
            result = [self loadSRGBChunk:png];
        } else if (memcmp([png chunkName], "gAMA", 4) == 0) {
            // gAMA CHUNK()
            result = [self loadGAMAChunk:png];
        } else if (memcmp([png chunkName], "cHRM", 4) == 0) {
            // cHRM CHUNK()
            result = [self loadCHRMChunk:png];
        } else if (memcmp([png chunkName], "pHYs", 4) == 0) {
            // pHYs Chunk(ʪ)
            result = [self loadPHYSChunk:png];
        } else if (memcmp([png chunkName], "PLTE", 4) == 0) {
            // PLTE Chunk(ѥå)
            result = [self->palette_ loadPLTEChunk:png];
        } else if (memcmp([png chunkName], "tRNS", 4) == 0) {
            // tRNS Chunk(Ʃ)
            result = [self->palette_ loadTRNSChunk:png];
        } else if (memcmp([png chunkName], "drOP", 4) == 0) {
            // drOP Chunk(ۤػ)
            result = [self->palette_ loadDROPChunk:png];
        } else if (memcmp([png chunkName], "maSK", 4) == 0) {
            // maSK Chunk(񤭶ػ)
            result = [self->palette_ loadMASKChunk:png];
        } else if (memcmp([png chunkName], "bKGD", 4) == 0) {
            // bKGD CHUNK(طʿ)
            result = [self loadBKGDChunk:png];
        } else if (memcmp([png chunkName], "cpAT", 4) == 0) {
            // cpAT Chunk(顼ѥ)
            if (cpat < COLOR_PATTERN_NUM) {
                result = [self->colpat_[cpat] loadCPATChunk:png];
                cpat++;
            }
        } else if (memcmp([png chunkName], "ilAY", 4) == 0) {
            // ilAY Chunk(쥤䡼)
            lyr = [[PoCoBitmapLayer alloc] initWithPNGDecoder:png];
            if (lyr == nil) {
                result = NO;
            } else {
                [self insertLayer:-1 layer:lyr];
                isNoExistLayer = NO;
            }
            [lyr release];
        } else if (memcmp([png chunkName], "slAY", 4) == 0) {
            // slAY Chunk(ʸ쥤䡼)
            lyr = [[PoCoStringLayer alloc] initWithPNGDecoder:png];
            if (lyr == nil) {
                result = NO;
            } else {
                [self insertLayer:-1 layer:lyr];
                isNoExistLayer = NO;
            }
            [lyr release];
        } else if (memcmp([png chunkName], "IDAT", 4) == 0) {
            // IDAT Chunk()
            if (isNoExistLayer) {
                lyr = [[PoCoBitmapLayer alloc]
                          initWithPNGDecoderIDAT:png
                                       sizeWidth:width
                                      sizeHeight:height];
                if (lyr == nil) {
                    result = NO;
                } else {
                    [self insertLayer:-1 layer:lyr];
                    isNoExistLayer = NO;
                }
                [lyr release];
            }
        } else if (memcmp([png chunkName], "IEND", 4) == 0) {
            // IEND Chunk(λ)
            result = YES;               // ｪλ
            isContinue = NO;
        } else {
            // ¾̵
            ;
        }

        // CHUNK Ĥ
        [png closeChunk];
    } while ((isContinue) && (result));
    [png release];

    return result;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dpi             : 
//    paletteTable_[] : ѥåͥơ֥(instance ѿ)
//    transTable_[]   : Ʃơ֥(instance ѿ)
//
//  Return
//    palette_     : ѥå(instance ѿ)
//    layer_       : ƥ쥤䡼(instance ѿ)
//    colpat_[]    : 顼ѥ(instance ѿ)
//    viewBuffer_  : ɽѤκȥХåե(instance ѿ)
//    h_unit_      : ʿѻ(instance ѿ)
//    v_unit_      : ľѻ(instance ѿ)
//    isUseBKGD_   : طʿ(instance ѿ)
//    bkgdColor_   : طʿֹ(instance ѿ)
//    isUseICCP_   : iCCP (instance ѿ)
//    gamma_       : gAMA CHUNK(instance ѿ)
//    chromakey_[] : cHRM CHUNK(instance ѿ)
//    srgb_        : sRGB CHUNK(instance ѿ)
//
-(id)init:(int)dpi
{
    int l;

    DPRINT((@"[PoCoPicture init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->palette_ = nil;
        self->layer_ = nil;
        for (l = 0; l < COLOR_PATTERN_NUM; l++) {
            self->colpat_[l] = nil;
        }
        self->h_unit_ = dpi;
        self->v_unit_ = dpi;
        self->isUseBKGD_ = NO;
        self->bkgdColor_ = 255;
        self->isUseICCP_ = NO;
#ifdef  GAMACHUNK_WINDOWS
        self->gamma_ = 45455;           // 1 / 2.2(Windows)
#else   // GAMACHUNK_WINDOWS
        self->gamma_ = 55556;           // 1 / 1.8(Mac)
#endif  // GAMACHUNK_WINDOWS
        self->chromakey_[0] = 31270;
        self->chromakey_[1] = 32900;
        self->chromakey_[2] = 64000;
        self->chromakey_[3] = 33000;
        self->chromakey_[4] = 30000;
        self->chromakey_[5] = 60000;
        self->chromakey_[6] = 15000;
        self->chromakey_[7] = 6000;
        self->srgb_ = 0;

        //  class μΤ
        self->palette_ = [[PoCoPalette alloc] initWithTable:self->paletteTable_
                                                  withTrans:self->transTable_];
        if (self->palette_ == nil) {
            DPRINT((@"PoCoPalette init error.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
        self->layer_ = [[NSMutableArray alloc] init];
        if (self->layer_ == nil) {
            DPRINT((@"NSMutableArray init error.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }

        // 顼ѥ
        for (l = 0; l < COLOR_PATTERN_NUM; l++) {
            self->colpat_[l] = [[PoCoColorPattern alloc] initWidth:16
                                                        initHeight:16
                                                      defaultColor:l];
            if (self->colpat_[l] == nil) {
                DPRINT((@"PoCoColorPattern(%d) init error.\n", l));
                [self release];
                self = nil;
                goto EXIT;
            }
        }

        // ɽѤκȥХåե
        self->viewBuffer_ = [[PoCoBuffer alloc] init];
        if (self->viewBuffer_ == nil) {
            DPRINT((@"PoCoBuffer init error.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    palette_    : ѥå(instance ѿ)
//    layer_      : ƥ쥤䡼(instance ѿ)
//    colpat_[]   : 顼ѥ(instance ѿ)
//    viewBuffer_ : ɽѤκȥХåե(instance ѿ)
//
-(void)dealloc
{
    int l;

    DPRINT((@"[PoCoPicture dealloc]\n"));

    // Υ쥤䡼
    [self deleteLayer:-1];

    // 顼ѥβ
    for (l = 0; l < COLOR_PATTERN_NUM; l++) {
        [self->colpat_[l] release];
        self->colpat_[l] = nil;
    }

    // member β
    [self->viewBuffer_ release];
    [self->palette_ release];
    [self->layer_ release];

    self->layer_ = nil;
    self->palette_ = nil;
    self->viewBuffer_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 쥤䡼ɲ
//   method Ͼ˲쥤䡼Τɲä
//  쥤䡼ʤϡɲäˤʤ(index ̵/w  h ɬ)
//  쥤䡼ϡw  h ̵(ǲإ쥤䡼ΤΤ)
//
//  Call
//    index  : >= 0 : (üʾʤɲäˤʤ)
//             <  0 : üɲ
//    w      : (dot)(쥤䡼ʤΤɬ)
//    h      : ⤵(dot)(쥤䡼ʤΤɬ)
//    c      : 
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : error code
//    layer_    : ƥ쥤䡼(instance ѿ)
//
-(PoCoErr)addLayer:(int)index
             width:(int)w
            height:(int)h
             color:(unsigned char)c
{
    PoCoErr er;
    PoCoLayerBase *lyr;                 // ɲä쥤䡼

    er = ER_OK;

    // /⤵λСɲ/Ƚ
    if ([self->layer_ count] > 0) {
        w = [[[self->layer_ objectAtIndex:0] bitmap] width];
        h = [[[self->layer_ objectAtIndex:0] bitmap] height];
    }

    // 쥤䡼򿷵
    lyr = [[PoCoBitmapLayer alloc] initWidth:w
                                  initHeight:h
                                defaultColor:c];
    if (lyr == nil) {
        DPRINT((@"can't create new layer.\n"));
        er = ER_ADDLAYER;
    } else {
        // 쥤䡼ɲ
        [self insertLayer:index layer:lyr];
    }
    [lyr release];

    return er;
}


//
// ʸ쥤䡼ɲ
//
//  Call
//    index  : >= 0 : (üʾʤɲäˤʤ)
//             <  0 : üɲ
//    c      : 
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : error code
//    layer_    : ƥ쥤䡼(instance ѿ)
//
-(PoCoErr)addStringLayer:(int)index
                   color:(unsigned char)c
{
    PoCoErr er;
    int w;
    int h;
    PoCoLayerBase *lyr;                 // ɲä쥤䡼

    er = ER_OK;

    // /⤵λСɲ/Ƚ
    w = [[[self->layer_ objectAtIndex:0] bitmap] width];
    h = [[[self->layer_ objectAtIndex:0] bitmap] height];

    // 쥤䡼򿷵
    lyr = [[PoCoStringLayer alloc] initWidth:w
                                  initHeight:h
                                defaultColor:c];
    if (lyr == nil) {
        DPRINT((@"can't create new string layer.\n"));
        er = ER_ADDLAYER;
    } else {
        // 쥤䡼ɲ
        [self insertLayer:index layer:lyr];
    }
    [lyr release];

    return er;
}


//
// 쥤䡼
//
//  Call
//    index  : >= 0 : оֹ
//             <  0 : 
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    layer_ : ƥ쥤䡼(instance ѿ)
//
-(void)deleteLayer:(int)index
{
    if (index < 0) {
        // 
        [self->layer_ removeAllObjects];
    } else if ((unsigned int)(index) < [self->layer_ count]) {
        [self->layer_ removeObjectAtIndex:(unsigned int)(index)];
    }

    return;
}


//
// ()
//
//  Call
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : 쥤䡼
//
-(NSMutableArray *)layer
{
    return self->layer_;
}


//
// (ñ)
//
//  Call
//    index : ֹ
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : оݥ쥤䡼
//
-(id)layer:(int)index
{
    return [self->layer_ objectAtIndex:index];
}


//
// 쥤䡼
//
//  Call
//    index    : <  0 : 
//               >= 0 : Ǥհ
//    lyr      : 쥤䡼
//    palette_ : ѥå(instance ѿ)
//
//  Return
//    layer_ : ƥ쥤䡼(instance ѿ)
//
-(void)insertLayer:(int)index
             layer:(PoCoLayerBase *)lyr
{
    const unsigned int cnt = (int)([self->layer_ count]);

    if ((cnt <= 0) || (index < 0) || (index >= cnt)) {
        [self->layer_ addObject:lyr];
    } else {
        [self->layer_ insertObject:lyr atIndex:(unsigned int)(index)];
    }

    // ܤ
    [lyr updatePreview:self->palette_];

    return;
}


//
// 쥤䡼ܹ
//
//  Call
//    index    : <  0 : 
//               >= 0 : 쥤䡼Τ߹
//    layer_   : ƥ쥤䡼(instance ѿ)
//    palette_ : ѥå(instance ѿ)
//
//  Return
//    None
//
-(void)updateLayerPreview:(int)index
{
    PoCoLayerBase *lyr;

    // оݥ쥤䡼μ
    lyr = ((index >= 0) ? [self->layer_ objectAtIndex:index] : nil);
    if (lyr != nil) {
        // 쥤䡼Τߤι
        [lyr updatePreview:self->palette_];
    } else {
        // (ѥåȤιȤ뤳ȤƱ)
        [self didUpdatePalette];
    }

    return;
}


//
// μ
//  Ƭ쥤䡼礭 NSRect ɤؤ
//
//  Call
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : 礭
//
-(NSRect)bitmapRect
{
    NSRect r;

    r.origin.x = 0;
    r.origin.y = 0;
    r.size.width = [[[self->layer_ objectAtIndex:0] bitmap] width];
    r.size.height = [[[self->layer_ objectAtIndex:0] bitmap] height];

    return r;
}


//
// μ
//   PoCoRect ֤
//
//  Call
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : 礭
//
-(PoCoRect *)bitmapPoCoRect
{
    PoCoRect *r;

    r = [[PoCoRect alloc] initLeft:0
                           initTop:0
                         initRight:[[[self->layer_ objectAtIndex:0] bitmap] width]
                        initBottom:[[[self->layer_ objectAtIndex:0] bitmap] height]];

    return r;
}


//
// 祦ɥɽѲμ
//  ʬ
//
//  Call
//    rect       : == nil : 
//                 != nil : ΰ
//    scale      : ɽΨ(0.1% ñ)
//    supplement : ɽ
//                 == nil : ̵(ɽɥ)
//                 != nil : (祦ɥ)
//
//  Return
//    function : 
//
-(NSBitmapImageRep *)getMainImage:(PoCoRect *)rect
                        withScale:(int)scale
                   withSupplement:(PoCoMainViewSupplement *)supplement
{
    NSBitmapImageRep *image;
    PoCoRect *area;

    image = nil;

    // ΰλ
    area = [self calcViewRect:rect];
    if (!([area empty])) {
        // 
        if (scale == 1000) {
            image = [self createViewEvenSize:area
                              withSupplement:supplement];
        } else if (scale > 1000) {
            image = [self createViewScaleUp:area
                                  withScale:scale
                             withSupplement:supplement];
        } else {
            image = [self createViewScaleDown:area
                                    withScale:scale
                               withSupplement:supplement];
        }
    }
    [area release];

    return image;
}


//
// ο
//
//  Call
//    p      : (ɸ)
//    index  : оݥ쥤䡼ֹ
//    layer_ : ƥ쥤䡼(instance ѿ)
//
//  Return
//    function : ֹ
//
-(int)pointColor:(PoCoPoint *)p
         atIndex:(int)index
{
    int num;
    PoCoBitmap *bmp;
    PoCoLayerBase *lyr;
    unsigned char *pixmap;

    num = 0;
    lyr = [self->layer_ objectAtIndex:index];
    if (lyr != nil) {
        bmp = [lyr bitmap];
        pixmap = [bmp pixelmap];
        if (pixmap != NULL) {
            num = pixmap[([p y] * ([bmp width] + ([bmp width] & 1))) + [p x]];
        }
    }

    return num;
}


//
// ѥåȤμ
//
//  Call
//    palette_ : ѥå(instance ѿ)
//
//  Return
//    function : ѥå
//
-(PoCoPalette *)palette
{
    return self->palette_;
}


//
// ѥåȹ
//
//  Call
//    layer_   : ƥ쥤䡼(instance ѿ)
//    palette_ : ѥå  (instance ѿ)
//
//  Return
//    None
//
-(void)didUpdatePalette
{
    NSEnumerator *iter;
    PoCoLayerBase *lyr;

    iter = [self->layer_ objectEnumerator];
    lyr = [iter nextObject];
    for ( ;lyr != nil; lyr = [iter nextObject]) {
        [lyr updatePreview:self->palette_];
    }

    return;
}


//
// ɽѥơ֥
//
//  Call
//    paletteTable_[] : ѥåͥơ֥(instance ѿ)
//    transTable_[]   : Ʃơ֥(instance ѿ)
//
//  Return
//    shadowPaletteTable_[] : ѥåͥơ֥(instance ѿ)
//    shadowTransTable_[]   : Ʃơ֥(instance ѿ)
//
-(void)pushPaletteTable
{
    memcpy(self->shadowPaletteTable_, self->paletteTable_, sizeof(wchar_t) * COLOR_MAX);
    memcpy(self->shadowTransTable_, self->transTable_, sizeof(BOOL) * COLOR_MAX);

    return;
}


//
// ɽѥơ֥ʽ
//
//  Call
//    shadowPaletteTable_[] : ѥåͥơ֥(instance ѿ)
//    shadowTransTable_[]   : Ʃơ֥(instance ѿ)
//
//  Return
//    paletteTable_[] : ѥåͥơ֥(instance ѿ)
//    transTable_[]   : Ʃơ֥(instance ѿ)
//
-(void)popPaletteTable
{
    memcpy(self->paletteTable_, self->shadowPaletteTable_, sizeof(wchar_t) * COLOR_MAX);
    memcpy(self->transTable_, self->shadowTransTable_, sizeof(BOOL) * COLOR_MAX);

    return;
}


//
// 顼ѥμ
//
//  Call
//    index     : ѥֹ
//    colpat_[] : 顼ѥ(instance ѿ)
//
//  Return
//    function 顼ѥ
//
-(PoCoColorPattern *)colpat:(int)index
{
    return (((index >= 0) && (index < COLOR_PATTERN_NUM)) ? self->colpat_[index] : nil);
}


//
// 顼ѥι
//
//  Call
//    index : ѥֹ
//    pat   : ѥ
//
//  Return
//    colpat_[] : 顼ѥ(instance ѿ)
//
-(void)setColpat:(int)index
         pattern:(PoCoColorPattern *)pat
{
    if ((index >= 0) && (index < COLOR_PATTERN_NUM)) {
        [self->colpat_[index] release];
        self->colpat_[index] = pat;
        [self->colpat_[index] retain];
    }

    return;
}


// --------------------------------------- instance - public - Ϸ
//
// pHYs (ʿ)
//
//  Call
//    h_unit_ : ʿѻ(instance ѿ)
//
//  Return
//    function : (TAD )
//
-(int)h_unit
{
    return self->h_unit_;
}


//
// pHYs (ľ)   
//
//  Call
//    v_unit_ : ľѻ(instance ѿ)
//
//  Return
//    function : (TAD )
//
-(int)v_unit
{
    return self->v_unit_;
}


//
// iCCP Ѽ
//
//  Call
//    isUseICCP_ : iCCP (instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isUseICCP
{
    return self->isUseICCP_;
}


//
// bKGD CHUNK 
//
//  Call
//    idx        : ǤγǼ
//                 != NULL : 
//                 == NULL : ʤ
//    isUseBKGD_ : طʿ(instance ѿ)
//    bkgdColor_ : طʿ(instance ѿ)
//
//  Return
//    function : طʿ
//    idx      : 
//
-(BOOL)bkgdColor:(unsigned int *)idx
{
    if (idx != NULL) {
        *(idx) = self->bkgdColor_;
    }

    return self->isUseBKGD_;
}


//
// gAMA CHUNK 
//
//  Call
//    gamma_ : gAMA CHUNK(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)gamma
{
    return self->gamma_;
}


//
// cHRM CHUNK 
//
//  Call
//    chromakey_[] : cHRM CHUNK(instance ѿ)
//
//  Return
//    function : ( 8 )
//
-(const unsigned int *)chromakey
{
    return self->chromakey_;
}


//
// sRGB CHUNK 
//
//  Call
//    srgb_ : sRGB CHUNK(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)srgb
{
    return self->srgb_;
}


//
// pHYs CHUNK 
//
//  Call
//    h : ʿ
//    v : ľ
//
//  Return
//    h_unit_ : ʿѻ(instance ѿ)
//    v_unit_ : ľѻ(instance ѿ)
//
-(void)setHUnit:(int)h
      withVUnit:(int)v
{
    self->h_unit_ = h;
    self->v_unit_ = v;

    return;
}

//
// bKGD CHUNK 
//
//  Call
//    flg : طʿ
//    idx : ֹ
//          (flg  YES/NO ˤ餺ǽ)
//
//  Return
//    isUseBKGD_ : طʿ(instance ѿ)
//    bkgdColor_ : طʿ(instance ѿ)
//
-(void)setBKGD:(BOOL)flg
     withIndex:(unsigned int)idx
{
    self->isUseBKGD_ = flg;
    self->bkgdColor_ = idx;

    return;
}


//
// iCCP 
//
//  Call
//    flag : 
//           YES :  iCCP CHUNK Τ
//           NO  :  iCCP CHUNK ʳ
//
//  Return
//    isUseICCP_ : iCCP (instance ѿ)
//
-(void)setUseICCP:(BOOL)flag
{
    self->isUseICCP_ = flag;

    return;
}


//
// gAMA CHUNK 
//
//  Call
//    val : 
//
//  Return
//    gamma_ : gAMA CHUNK(instance ѿ)
//
-(void)setGamma:(unsigned int)val
{
    self->gamma_ = val;

    return;
}


//
// cHRM CHUNK 
//
//  Call
//    val: ( 8 )
//
//  Return
//    chromakey_[] : cHRM CHUNK(instance ѿ)
//
-(void)setChromakey:(const unsigned int *)val
{
    unsigned int l;

    for (l = 0; l < 8; l++) {
        self->chromakey_[l] = val[l];
    }

    return;
}


//
// sRGB CHUNK 
//
//  Call
//    val : 
//
//  Return
//    srgb_ : sRGB CHUNK(instance ѿ)
//
-(void)setSrgb:(unsigned int)val
{
    self->srgb_ = val;

    return;
}


// ----------------------------------------- instance - public - ե
//
// ¸
//
//  Call
//    toAlpha    : grayscale Ʃ٤Ȥ뤫
//    palette_   : ѥå(instance ѿ)
//    colpat_[]  : 顼ѥ(instance ѿ)
//    layer_     : ƥ쥤䡼(instance ѿ)
//    isUseBKGD_ : طʿ(instance ѿ)
//    isUseICCP_ : iCCP (instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createFileData:(BOOL)toAlpha
{
    NSMutableData *data;
    int l;
    NSEnumerator *iter;
    PoCoLayerBase *lyr;

    DPRINT((@"[PoCoPicture createFileData]\n"));

    data = [NSMutableData data];

    // IHDR Chunk 
    lyr = [self->layer_ objectAtIndex:0];
    [data appendData:[self createIHDRChunk:[[lyr bitmap] width]
                                    height:[[lyr bitmap] height]]];

    //  CHUNK 
    if (self->isUseICCP_) {
        // iCCP CHUNK 
        [data appendData:[self createICCPChunk]];
    } else {
        // sRGB CHUNK 
        [data appendData:[self createSRGBChunk]];

        // gAMA CHUNK 
        [data appendData:[self createGAMAChunk]];

        // cHRM CHUNK 
        [data appendData:[self createCHRMChunk]];
    }

    // pHYs CHUNK 
    [data appendData:[self createPHYSChunk]];

    // ѥåȴϢ CHUNK 
    [data appendData:[self->palette_ createFileData:toAlpha]];

    // bKGD CHUNK 
    if (self->isUseBKGD_) {
        [data appendData:[self createBKGDChunk]];
    }

    // 顼ѥ CHUNK 
    for (l = 0; l < COLOR_PATTERN_NUM; l++) {
        [data appendData:[self->colpat_[l] createFileData]];
    }

    // ƥ쥤䡼Ȥ CHUNK 
    iter = [self->layer_ objectEnumerator];
    lyr = [iter nextObject];
    for ( ;lyr != nil; lyr = [iter nextObject]) {
        [data appendData:[lyr createFileData]];
    }

    // IDAT Chunk 
    [data appendData:[self createIDATChunk]];

    return data;
}


//
// ɤ߹
//
//  Call
//    data  : ɤ߹
//    range : ɤ߹ϰ
//
//  Return
//    function : YES : 
//               NO  : 
//    range    : ɤ߹ϰ
//
-(BOOL)loadFileData:(NSData *)data
          withRange:(NSRange *)range
{
    BOOL result;
    unsigned int width;
    unsigned int height;

    DPRINT((@"[PoCoPicture loadFIleData: withRange:]\n"));

    // [MyDocument init] Ǻä쥤䡼˴
    [self deleteLayer:0];

    // IHDR CHUNK ɤ߹
    result = [PoCoPicture loadIHDRChunk:data
                              withRange:range
                                  width:&(width)
                                 height:&(height)];
    if (result != YES) {
        DPRINT((@"can't load IHDR Chunk.\n"));
        goto EXIT;
    }

    // ³ CHUNK ɤ߹
    result = [self loadChunks:data
                    withRange:range
                    sizeWidth:width
                   sizeHeight:height];
    if (result != YES) {
        DPRINT((@"can't load file.\n"));
        goto EXIT;
    }

    // 
    result = YES;

EXIT:
    return result;
}


// ---------------------------------------- instance - public - Pasteboard Ϣ
//
// ڡȥܡɤŽդ
//
//  Call
//    r          : ڤϰ
//    index      : оݥ쥤䡼
//    toAlpha    : grayscale Ʃ٤Ȥ뤫
//    palette_   : ѥå(instance ѿ)
//    isUseICCP_ : iCCP (instance ѿ)
//
//  Return
//    function : data
//
-(NSData *)createPBoardData:(PoCoRect *)r
                    atIndex:(int)index
                    toAlpha:(BOOL)toAlpha
{
    NSMutableData *data;
#if 0   // 顼ѥϽ(090922)
    int l;
#endif  // 0

    DPRINT((@"[PoCoPicture createPBoardData]\n"));

    data = [NSMutableData data];

    // IHDR Chunk 
    [data appendData:[self createIHDRChunk:[r width] height:[r height]]];

    //  CHUNK 
    if (self->isUseICCP_) {
        // iCCP CHUNK 
        [data appendData:[self createICCPChunk]];
    } else {
        // sRGB CHUNK 
        [data appendData:[self createSRGBChunk]];

        // gAMA CHUNK 
        [data appendData:[self createGAMAChunk]];

        // cHRM CHUNK 
        [data appendData:[self createCHRMChunk]];
    }

    // pHYs CHUNK 
    [data appendData:[self createPHYSChunk]];

    // ѥåȴϢ CHUNK 
    [data appendData:[self->palette_ createFileData:toAlpha]];

#if 0   // 顼ѥϽ(090922)
    // 顼ѥ CHUNK 
    for (l = 0; l < COLOR_PATTERN_NUM; l++) {
        [data appendData:[self->colpat_[l] createFileData]];
    }
#endif  // 0

    // IDAT Chunk 
    [data appendData:[self createIDATChunk:r
                                   atIndex:index]];

    return data;
}

@end
