//
//	Pelistina on Cocoa - PoCo -
//	Խִ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoEditState.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"

// ============================================================================
@implementation PoCoEditState

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function  : 
//    point_[]  : ɸδ(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//    count_    : Խ(instance ѿ)
//    isEdit_   : Խ(instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoEditState init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->point_[0] = nil;
        self->point_[1] = nil;
        self->point_[2] = nil;
        self->count_ = 0;
        self->isEdit_ = NO;

        // Խμ
        self->editInfo_ = [(PoCoAppController *)([NSApp delegate]) editInfo];
        [self->editInfo_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    point_[]  : ɸδ(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoEditState dealloc]\n"));

    // 񸻤β
    [self->point_[0] release];
    [self->point_[1] release];
    [self->point_[2] release];
    [self->editInfo_ release];
    self->point_[0] = nil;
    self->point_[1] = nil;
    self->point_[2] = nil;
    self->editInfo_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// Խ
//
//  Call
//    None
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//    count_   : Խ(instance ѿ)
//    isEdit_  : Խ(instance ѿ)
//
-(void)beginEditMode
{
    // ϻĤʤ
    [self clearFirstPoint];
    [self clearSecondPoint];
    [self clearThirdPoint];

    // Խ
    self->count_ = 0;
    self->isEdit_ = YES;

    return;
}


//
// Խλ
//
//  Call
//    None
//
//  Return
//    isEdit_ : Խ(instance ѿ)
//
-(void)endEditMode
{
    self->isEdit_ = NO;

    // ƺɸ
    [self clearFirstPoint];
    [self clearSecondPoint];
    [self clearThirdPoint];

    return;
}


//
// Խ
//
//  Call
//    None
//
//  Return
//    count_ : Խ(instance ѿ)
//
-(void)countUpEdit
{
    if (self->count_ < __INT_MAX__) {
        (self->count_)++;
    }

    return;
}


//
// (Խ)
//
//  Call
//    count_ : Խ(instance ѿ)
//
//  Return
//    function : Խ
//
-(int)count
{
    return self->count_;
}


//
// Խ
//
//  Call
//    isEdit_ : Խ(instance ѿ)
//
//  Return
//    function : Խ
//
-(BOOL)isEdit
{
    return self->isEdit_;
}


// ----------------------------------------- instance - public - ɸδϢ
//
// 1ܤμ
//  ̤Խ
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : ɸ
//
-(PoCoPoint *)firstPoint
{
    return self->point_[0];
}


//
// 2ܤμ
//  ʿԻշϤǤ
//  ¾̤Ͻ
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : ɸ
//
-(PoCoPoint *)secondPoint
{
    return self->point_[1];
}


//
// 3ܤμ
//  ʿԻշν
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : ɸ
//
-(PoCoPoint *)thirdPoint
{
    return self->point_[2];
}


//
// 1ܤ
//
//  Call
//    p         : == nil : Խκɸݻ
//                != nil : ؼ줿ɸݻ
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//
-(void)setFirstPoint:(PoCoPoint *)p
{
    // nil ξԽ
    if (p == nil) {
        p = [self->editInfo_ pdPos];
    }

    // ʬ
    [self clearFirstPoint];

    // ɸʣ
    self->point_[0] = [[PoCoPoint alloc] initX:[p x]
                                         initY:[p y]];

    return;
}


//
// 2ܤ
//
//  Call
//    p         : == nil : Խκɸݻ
//                != nil : ؼ줿ɸݻ
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//
-(void)setSecondPoint:(PoCoPoint *)p
{
    // nil ξԽ
    if (p == nil) {
        p = [self->editInfo_ pdPos];
    }

    // ʬ
    [self clearSecondPoint];

    // ɸʣ
    self->point_[1] = [[PoCoPoint alloc] initX:[p x]
                                         initY:[p y]];

    return;
}


//
// 3ܤ
//
//  Call
//    p         : == nil : Խκɸݻ
//                != nil : ؼ줿ɸݻ
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//
-(void)setThirdPoint:(PoCoPoint *)p
{
    // nil ξԽ
    if (p == nil) {
        p = [self->editInfo_ pdPos];
    }

    // ʬ
    [self clearThirdPoint];

    // ɸʣ
    self->point_[2] = [[PoCoPoint alloc] initX:[p x]
                                         initY:[p y]];

    return;
}


//
// 1ܤξõ
//
//  Call
//    None
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//
-(void)clearFirstPoint
{
    [self->point_[0] release];
    self->point_[0] = nil;

    return;
}


//
// 2ܤξõ
//
//  Call
//    None
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//
-(void)clearSecondPoint
{
    [self->point_[1] release];
    self->point_[1] = nil;

    return;
}


//
// 3ܤξõ
//
//  Call
//    None
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//
-(void)clearThirdPoint
{
    [self->point_[2] release];
    self->point_[2] = nil;

    return;
}


//
// 1ܤꤹ٤
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isFirstPoint
{
    return (self->point_[0] == nil);
}


//
// 2ܤꤹ٤
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isSecondPoint
{
    return (self->point_[0] != nil);
}


//
// 3ܤꤹ٤
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isThirdPoint
{
    return (self->point_[1] != nil);
}


//
// 1ܤäƤ뤫
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)hasFirstPoint
{
    return (self->point_[0] != nil);
}


//
// 2ܤäƤ뤫
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)hasSecondPoint
{
    return (self->point_[1] != nil);
}


//
// 3ܤäƤ뤫
//
//  Call
//    point_[] : ɸδ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)hasThirdPoint
{
    return (self->point_[2] != nil);
}


//
// 
//  ԽοʹԤ˹碌֤ͤ
//
//  Call
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isPointHold
{
    return ([self->editInfo_ pointModeType] == PoCoPointModeType_PointHold);
}


//
// ư
//  ԽοʹԤ˹碌֤ͤ
//
//  Call
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isPointMove
{
    return ([self->editInfo_ pointModeType] == PoCoPointModeType_PointMove);
}


//
// 
//  ԽοʹԤ˹碌֤ͤ
//
//  Call
//    editInfo_ : Խ(instance ѿ)
//    count_    : Խ(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isIdenticalShape
{
    return (
        ([self->editInfo_ pointModeType] == PoCoPointModeType_IdenticalShape)
        &&
        (self->count_ > 0)
    );
}


//
// ΰư
//
//  Call
//    x : ʿ
//    y : ľ
//
//  Return
//    point_[] : ɸδ(instance ѿ)
//
-(void)moveX:(int)x
       moveY:(int)y
{
    [self->point_[0] moveX:x
                     moveY:y];
    [self->point_[1] moveX:x
                     moveY:y];
    [self->point_[2] moveX:x
                     moveY:y];

    return;
}

@end
