//
//	Pelistina on Cocoa - PoCo -
//	MyDocument(Խоݤδμ紴)
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class 
@class PoCoLayerBase;
@class PoCoPalette;
@class PoCoPicture;
@class PoCoSelLayer;
@class PoCoView;
@class PoCoColorPattern;
@class PoCoColorBuffer;

// ----------------------------------------------------------------------------
@interface MyDocument : NSDocument
{
    PoCoPicture *picture_;              // 
    PoCoSelLayer *selLayer_;            // 쥤䡼
    PoCoColorPattern *eraser_;          // äѲ
    PoCoColorBuffer *colorBuffer_;      // ݻ
    IBOutlet PoCoView *view_;           // ɽΰ
    IBOutlet NSScrollView *scroller_;   // scroller
}

// ڡȥܡɤŽդ¹
+(BOOL)readPngFromPasteboard:(NSPasteboard *)pb
                 resultLayer:(PoCoLayerBase **)lyr
               resultPalette:(PoCoPalette *)plt;

// initialize
-(id)init;
-(id)initWidth:(int)w                   // ꥤ˥饤
    initHeight:(int)h
initResolution:(int)r
  defaultColor:(unsigned char)c;

// deallocate
-(void)dealloc;

// 
-(PoCoPicture *)picture;
-(PoCoSelLayer *)selLayer;
-(PoCoColorBuffer *)colorBuffer;
-(PoCoView *)view;

// äѲ
-(void)setEraser;
-(void)clearEraser;
-(PoCoColorPattern *)eraser;

// ɥڤؤ
-(void)windowDidBecomeMain:(NSNotification *)note;

// äΰϤ
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender;

// 
-(void)setUpdateState:(NSDocumentChangeType)type;

// ѥåȹ
-(void)didUpdatePalette;

// 
-(void)didUpdatePicture:(PoCoRect *)r;

// 赡ǽѹ
-(void)didChangeDrawTool;

// 쥤䡼ѹ 
-(void)didLayerResize;

// ɽɥ֥륯å
-(void)dclickOnSubView:(PoCoPoint *)p;

// ɥ饤ɽ
-(void)drawGuideLine;

// Խֲ
-(void)cancelEdit;

// ڡ٥
-(void)spaceKeyEvent:(BOOL)isPress;

//  nib file
-(NSString *)windowNibName;

// nib ɤ߹߸
-(void)windowControllerDidLoadNib:(NSWindowController *)aController;

// ¸μ¹
#if (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3)
-(NSData *)dataOfType:(NSString *)aType
                error:(NSError **)outError;
#else   // (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3)
-(NSData *)dataRepresentationOfType:(NSString *)aType;
#endif  // (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3)

// ɤ߹ߤμ¹
#if (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3)
-(BOOL)readFromData:(NSData *)data
             ofType:(NSString *)aType
              error:(NSError **)outError;
#else   // (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3)
-(BOOL)loadDataRepresentation:(NSData *)data
                       ofType:(NSString *)aType;
#endif  // (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3)

// ڡȥܡɤŽդ¹
-(void)writePngToPasteboard:(NSPasteboard *)pb
                   withRect:(PoCoRect *)r
                    atIndex:(int)index;

@end
