//
//	Pelistina on Cocoa - PoCo -
//	PoCoView class
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import <Cocoa/Cocoa.h>

//  class
@class PoCoPicture;
@class MyDocument;
@class PoCoEditInfo;
@class PoCoControllerFactory;
@class PoCoDrawBase;

// ----------------------------------------------------------------------------
@interface PoCoView : NSView
{
    IBOutlet NSSlider *slider_;         // Ψ slider
    IBOutlet MyDocument *document_;     // Խоݤθ

    int zfactNum_;                      // ɽΨֹ
    int frameGap_;                      // 
    BOOL isDrawing_;                    // 
    BOOL isAltMode_;                    // ALT Ʊ
    BOOL isSpaceMode_;                  // SPACE Ʊ
    PoCoEditInfo *editInfo_;            // Խ
    PoCoDrawBase *drawTool_;            // Խǽμ
    BOOL prevContinuation_;             // Ϣ³/Ϣ³
    PoCoDrawModeType prevDrawMode_;     // 
    PoCoPenStyleType prevPenStyle_;     // Υڥ
}

#if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_9)
// responsive scroll
+(BOOL)isCompatibleWithResponsiveScrolling;
#endif  // MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_9

// initialize
-(id)initWithFrame:(NSRect)frameRect;

// deallocate
-(void)dealloc;

// 쥤䡼ѷȼ
-(void)layerResize:(BOOL)isRedraw;

// 濴ɽ
-(void)centering;

// (κɸϤǻؼ)
-(void)setNeedsDisplayInOriginalRect:(PoCoRect *)r;

// Խڤؤ
-(void)didChangeDrawTool;

// ɽɥ֥륯å
-(void)doubleClickedOnSubView:(PoCoPoint *)dp;

// 
-(void)drawRect:(NSRect)rect;

// ɸϤȿž
-(BOOL)isFlipped;

// ˥塼򹹿
-(BOOL)validateMenuItem:(NSMenuItem *)menu;

// ΰ褫饦ɥΰѴ
-(NSRect)toDispRect:(PoCoRect *)r;

// ɽΨ˱ϥɥγĥ
-(int)handleRectGap;

// Pointer ϰϻ
-(void)resetCursorRects;

// ɥ饤ɽ
-(void)drawGuideLine;

// Խֲ
-(void)cancelEdit;

// ڡ٥
-(void)spaceKeyEvent:(BOOL)isPress;

// undo/redo ¹Լ(observer)
-(void)undoManagementing:(NSNotification *)note;

// PasteBoardmenu 
// -(IBAction)cut:(id)sender;           // ڤ(PoCo Ǥڤ̵)
-(IBAction)copy:(id)sender;
-(IBAction)paste:(id)sender;
-(NSDragOperation)draggingSourceOperationMaskForLocal:(BOOL)isLocal;
-(IBAction)delete:(id)sender;
-(IBAction)flipHorizontal:(id)sender;
-(IBAction)flipVertical:(id)sender;
-(IBAction)autoGradation:(id)sender;
-(IBAction)colorReplace:(id)sender;
-(IBAction)texture:(id)sender;
-(IBAction)selectAll:(id)sender;
-(IBAction)selectClear:(id)sender;
-(IBAction)zoomIn:(id)sender;
-(IBAction)zoomOut:(id)sender;
-(IBAction)actualSize:(id)sender;
-(IBAction)documentSetting:(id)sender;
-(IBAction)canvasResize:(id)sender;
-(IBAction)clipImage:(id)sender;

// ѥåϢ
-(IBAction)nextColor:(id)sender;
-(IBAction)prevColor:(id)sender;
-(IBAction)useUnderLayer:(id)sender;
-(IBAction)colorElementAll:(id)sender;
-(IBAction)colorElementRed:(id)sender;
-(IBAction)colorElementGreen:(id)sender;
-(IBAction)colorElementBlue:(id)sender;
-(IBAction)colorAttributeMask:(id)sender;
-(IBAction)colorAttribueDropper:(id)sender;
-(IBAction)colorAttribueTransparent:(id)sender;

// ٥Ȥμ
-(BOOL)acceptsFirstMouse:(NSEvent *)evt;  // ܥμ
#if (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3)
-(void)tabletProximity:(NSEvent *)evt;    // ڥ
#endif  // MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_3
-(void)mouseDown:(NSEvent *)evt;          // ܥ
-(void)mouseDragged:(NSEvent *)evt;       // ܥɥå
-(void)mouseUp:(NSEvent *)evt;            // ܥ꡼
-(void)rightMouseDown:(NSEvent *)evt;     // ܥ
-(void)rightMouseDragged:(NSEvent *)evt;  // ܥɥå
-(void)rightMouseUp:(NSEvent *)evt;       // ܥ꡼
-(void)keyDown:(NSEvent *)evt;            // 
-(void)keyUp:(NSEvent *)evt;              // ꡼
-(void)mouseMoved:(NSEvent *)evt;         // ޥư
-(void)scrollWheel:(NSEvent *)evt;        // ۥž
#if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6)
-(void)touchesBeganWithEvent:(NSEvent *)evt;      // touch 
-(void)touchesMovedWithEvent:(NSEvent *)evt;      // touch ư
-(void)touchesEndedWithEvent:(NSEvent *)evt;      // touch λ
-(void)touchesCancelledWithEvent:(NSEvent *)evt;  // touch 
#endif  // MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_6

// Ψ slider μ¹Է̤μ
-(IBAction)zoomFactor:(id)sender;

@end
