//
//	Pelistina on Cocoa - PoCo -
//	Խ - 
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawBase.h"

#import "PoCoMyDocument.h"
#import "PoCoView.h"
#import "PoCoAppController.h"
#import "PoCoView.h"
#import "PoCoLayer.h"
#import "PoCoPicture.h"
#import "PoCoSelLayer.h"
#import "PoCoEditInfo.h"
#import "PoCoEditState.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoDrawBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function   : 
//    document_  : Խо(instance ѿ)
//    editInfo_  : Խ(instance ѿ)
//    editState_ : Խξ(instance ѿ)
//    factory_   : Խ(instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDrawBase initWithDoc]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->document_ = nil;
        self->editInfo_ = nil;
        self->editState_ = nil;
        self->factory_ = nil;

        // 줾μΤ
        self->document_ = doc;
        self->editInfo_ = [(PoCoAppController *)([NSApp delegate]) editInfo];
        self->editState_ = [[PoCoEditState alloc] init];
        self->factory_ = [(PoCoAppController *)([NSApp delegate]) factory];

        // 줾μΤ retain
        [self->document_ retain];
        [self->editInfo_ retain];
#if 0   // editState_  alloc ƤΤ retain 
        [self->editState_ retain];
#endif  // 0
        [self->factory_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    documnet_  : Խо(instance ѿ)
//    editInfo_  : Խ(instance ѿ)
//    editState_ : Խξ(instance ѿ)
//    factory_   : Խ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoDrawBase dealloc]\n"));

    // 񸻤β
    [self->document_ release];
    [self->editInfo_ release];
    [self->editState_ release];
    [self->factory_ release];
    self->document_ = nil;
    self->editInfo_ = nil;
    self->editState_ = nil;
    self->factory_ = nil;

    // super class β
    [super dealloc];

    return;
}


// --------------------------------------------- instance - public - ϰ
//
// ڡȥܡɤŽդ
//
//  Call
//    lyr : Žդ
//
//  Return
//    None
//
-(void)pasteBitmap:(PoCoLayerBase *)lyr
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    None
//
-(void)delete
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// ȿž
//
//  Call
//    hori : ʿ
//           YES : ʿ˲ȿž
//           NO  : ľ˲ȿž
//
//  Return
//    None
//
-(void)flipImage:(BOOL)hori
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// ưǡ
//
//  Call
//    size     : 礭(0: Ǥա1-128 ϰ)
//    adj      : (YES: ٤礦ֹΤ)
//    mtx      : оݿ(256 ĹYES: о)
//    sizePair : 礭ȿֹз
//
//  Return
//    None
//
-(void)autoGrad:(int)size
     isAdjacent:(BOOL)adj
         matrix:(const BOOL *)mtx
   withSizePair:(NSDictionary *)sizePair
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// ִ
//
//  Call
//    mtx : ִɽ(256 Ĺ)
//
//  Return
//    None
//
-(void)colorReplace:(const unsigned char *)mtx
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// ƥ
//
//  Call
//    base : ܿ(NSArray<unsigned int>)
//    grad : ǻø(NSArray<unsinged int, NSArray<unsigned int> >)
//
//  Return
//    None
//
-(void)texture:(NSArray *)base
  withGradient:(NSArray *)grad
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    None
//
-(void)selectAll
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    None
//
-(void)selectClear
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// ư
//
//  Call
//    None
//
//  Return
//    None
//
-(void)recreatePasteImage
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


// --------------------------------------------------- instance - public - 
//
// Խػߥ쥤䡼Ƚ
//  
//  Call
//    document_ : Խо(instance ѿ)
// 
//  Return
//    function : YES : ػ
//               NO  : 
//
-(BOOL)isNotEditLayer
{
    return [[[self->document_ picture] layer:[[self->document_ selLayer] sel]] drawLock];
}


//
// ۤ
//
//  Call
//    documnet_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    editInfo_ : Խ(instance ѿ)
//
-(void)dropper
{
    int num;                            // 
    PoCoRect *r;
    PoCoPoint *p;                       // ɸ
    PoCoSelColor *old;                  // 

    p = [self->editInfo_ pdPos];
    r = [[self->document_ picture] bitmapPoCoRect];
    if ([r isPointInRect:p]) {
        old = [self->editInfo_ selColor];
        num = [[self->document_ picture] pointColor:p
                                            atIndex:[[self->document_ selLayer] sel]];

        // ڤؤ
        if (([old isPattern]) || ([old num] != num)) {
            [self->editInfo_ setSelColor:num];

            // ڤؤ
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoChangeColor
                              object:nil];

        }
    }
    [r release];

    return;
}


//
// ꤺ
//
//  Call
//    evt       : ٥
//    document_ : Խо(instance ѿ)
//
//  Return
//    None
//
-(void)dragMove:(NSEvent *)evt
{
    NSRect r;

    // ɽȼ
    r = [[self->document_ view] visibleRect];

    // ʿư
    if ([evt deltaX] != 0) {
        r.origin.x -= [evt deltaX]; 
        [[self->document_ view] scrollRectToVisible:r];
    }
    
    // ľư
    if ([evt deltaY] != 0) {
        r.origin.y -= [evt deltaY];
        [[self->document_ view] scrollRectToVisible:r];
    }

    return;
}


//
// ä
//
//  Call
//    group     : ä
//    document_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    editInfo_ : Խ(instance ѿ)
//
-(void)beginUndo:(BOOL)group
{
    // ä
    if ([self->editInfo_ enableUndo]) {
        if (group) {
            [[self->document_ undoManager] beginUndoGrouping];
        }
    }

    // äѲ
    if (([self->editInfo_ enableEraser]) &&
        (!([self->editInfo_ eraserType]))) {
        [self->document_ setEraser];
    }

    return;
}


//
// äλ
//
//  Call
//    group     : ä
//    document_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    None
//
-(void)endUndo:(BOOL)group
{
    // äλ
    if ([self->editInfo_ enableUndo]) {
        if (group) {
            [[self->document_ undoManager] endUndoGrouping];
        }
    }

    return;
}


//
// Pointer ϰϹ
//
//  Call
//    document_ : Խо(instance ѿ)
//
//  Return
//    None
//
-(void)updateCursorRect
{
    // ǤϰϤ򤹤٤Ʋ
    [[self->document_ view] discardCursorRects];

    return;
}


//
// ɥ饤
//
//  Call
//    None
//
//  Return
//    None
//
-(void)drawGuideLine
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// Խֲ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)cancelEdit
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


//
// ѷ
//
//  Call
//    None
//
//  Return
//    function : 
//
-(PoCoBitmap *)originalImage
{
    // Ǥϲ⤷ʤ
    ;

    return nil;
}


//
// ѷ
//
//  Call
//    None
//
//  Return
//    function :  
//
-(PoCoBitmap *)originalShape
{
    // Ǥϲ⤷ʤ
    ;

    return nil;
}


//
// autoscroll ¹Բ
//
//  Call
//    None
//
//  Return
//    function : YES : ػ
//               NO  : 
//
-(BOOL)canAutoScroll
{
    // Ǥϲ⤷ʤ
    ;

    return NO;
}


// ------------------------------------------- instance - public - ٥
//
// ܥ
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseDown:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// ܥɥå
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseDrag:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// ܥ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseUp:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// ܥ
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)rightMouseDown:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// ܥɥå
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)rightMouseDrag:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// ܥ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)rightMouseUp:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// 
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}


//
// ޥư
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseMove:(NSEvent *)evt
{
    // ǤϤʤˤ⤷ʤ
    ;

    return;
}

@end
