//
//	Pelistina on Cocoa - PoCo -
//	Խ - /ʱ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawEllipse.h"

#import <Carbon/Carbon.h>

#import "PoCoMyDocument.h"
#import "PoCoSelLayer.h"
#import "PoCoEditInfo.h"
#import "PoCoEditState.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoDrawEllipseBase

// --------------------------------------------------------- instance - private
//
// Ȥã
//
//  Call
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editInfo_ : Խ( instance ѿ)
//
-(void)setInfoPDRect
{
    PoCoRect *r;

    r = [[PoCoRect alloc] initLeft:[[self->editState_  firstPoint] x]
                           initTop:[[self->editState_  firstPoint] y]
                         initRight:[[self->editState_ secondPoint] x]
                        initBottom:[[self->editState_ secondPoint] y]];
    [self->editInfo_ setPDRect:r];
    [r release];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function : 
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDrawEllipseBase initWithDoc]\n"));

    // super class ν
    self = [super initWithDoc:doc];

    // Ȥν
    if (self != nil) {
        // ⤷ʤ
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoDrawEllipseBase dealloc]\n"));

    // ɥ饤õ
    [self drawGuideLine];

    // äλ
    [super endUndo:NO];

    // Խλ
    [self->editState_ endEditMode];

    // Ȥã
    [self setInfoPDRect];

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    None
//
//  Return
//    None
//
-(void)exec
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


// --------------------------------------------------- instance - public - 
//
// ɥ饤
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)drawGuideLine
{
    if ([self->editState_ hasThirdPoint]) {
        [self->factory_ createInvertEllipseEditter:YES
                                             layer:[[self->document_ selLayer] sel]
                                             start:[self->editState_ firstPoint]
                                               end:[self->editState_ secondPoint]
                                       orientation:[self->editState_ thirdPoint]];
    } else if ([self->editState_ hasSecondPoint]) {
        [self->factory_ createInvertEllipseEditter:YES
                                             layer:[[self->document_ selLayer] sel]
                                             start:[self->editState_ firstPoint]
                                               end:[self->editState_ secondPoint]
                                       orientation:nil];
    }

    return;
}


//
// Խֲ
//
//  Call
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    None
//
-(void)cancelEdit
{
    if (!([self->editState_ isFirstPoint])) {
        // ɥ饤õ
        [self drawGuideLine];

        // äλ
        [super endUndo:NO];

        // Խλ
        [self->editState_ endEditMode];

        // Ȥã
        [self setInfoPDRect];
    }

    return;
}


//
// autoscroll ¹Բ
//
//  Call
//    None
//
//  Return
//    function : YES : ػ
//               NO  : 
//
-(BOOL)canAutoScroll
{
    return YES;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ((([evt modifierFlags] & NSCommandKeyMask) != 0x00) &&
               (([evt modifierFlags] & NSControlKeyMask) != 0x00)) {
        // Command + Control ϥݥȤȤ
        [self drawGuideLine];           // ɥ饤õ
        [super dropper];
        [self drawGuideLine];           // ɥ饤ɽ
    } else if ([self->editState_ isFirstPoint]) {
        // ܳ
        [self->editState_ beginEditMode];

        // ɸ
        [self->editState_ setFirstPoint:nil];

        // ä
        [super beginUndo:NO];
    } else if ((!([self->editState_ hasThirdPoint])) &&
               (([evt modifierFlags] & NSCommandKeyMask) != 0x00) &&
               ([evt clickCount] <= 1)) {
        // ɥ饤õ
        [self drawGuideLine];

        // 3ܼ
        [self->editState_ setSecondPoint:nil];
        [self->editState_ setThirdPoint:nil];

        // ɥ饤
        [self drawGuideLine];
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // 
        if (!([self->editState_ isIdenticalShape])) {
            if ([self->editState_ hasThirdPoint]) {
                [self->editState_ setThirdPoint:nil];
            } else {
                [self->editState_ setSecondPoint:nil];
            }
        }

        // ¹
        [self->editState_ countUpEdit];
        [self exec];

        // ѹ
        if ([self->editState_ isPointMove]) {
            if ([self->editState_ hasThirdPoint]) {
                [self->editState_ clearThirdPoint];
            }
            [self->editState_ setFirstPoint:[self->editState_ secondPoint]];
        }

        // ɥ饤
        [self drawGuideLine];

        // ǽ PD ֹ
        [self->editInfo_ setLastPos:[self->editState_ secondPoint]];
    }

    return;
}


//
// ܥɥå
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseDrag:(NSEvent *)evt
{
    // ̾ΥޥưƱˤ
    [self mouseMove:evt];

    return;
}


//
// ܥ꡼
//
//  Call
//    None
//
//  Return
//    None
//
-(void)mouseUp:(NSEvent *)evt
{
    // ⤷ʤ
    ;

    return;
}


//
// ܥ
//
//  Call
//    evt        : ٥
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    None
//
-(void)rightMouseDown:(NSEvent *)evt
{
    if ([self->editState_ isFirstPoint]) {
        // ۤ
        [super dropper];
    } else {
        // Խֲ
        [self cancelEdit];
    }

    return;
}


//
// 
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ʤˤ⤷ʤ
    ;

    return;
}


//
// ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // Escape ξϾԽ
    if ([evt keyCode] == kVK_Escape) {
        // Խֲ
        [self cancelEdit];
    }

    return;
}


//
// ޥư
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseMove:(NSEvent *)evt
{
    if ([self->editState_ isFirstPoint]) {
        // ʤ
        ;
    } else {
        // Υɥ饤õ
        [self drawGuideLine];

        // 
        if ([self->editState_ isIdenticalShape]) {
            // 
            if ([self->editState_ hasThirdPoint]) {
                [self->editState_
                    moveX:([[self->editInfo_ pdPos] x] - [[self->editState_ thirdPoint] x])
                    moveY:([[self->editInfo_ pdPos] y] - [[self->editState_ thirdPoint] y])];
            } else {
                [self->editState_
                    moveX:([[self->editInfo_ pdPos] x] - [[self->editState_ secondPoint] x])
                    moveY:([[self->editInfo_ pdPos] y] - [[self->editState_ secondPoint] y])];
            }
        } else if ([self->editState_ hasThirdPoint]) {
            // 
            [self->editState_ setThirdPoint:nil];
        } else {
            // 
            [self->editState_ setSecondPoint:nil];
        }

        // ɥ饤
        [self drawGuideLine];

        // Ȥã
        [self setInfoPDRect];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseNormal

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createNormalEllipseEditter:YES
                                         layer:[[self->document_ selLayer] sel]
                                         start:[self->editState_ firstPoint]
                                           end:[self->editState_ secondPoint]
                                   orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseUniformedDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createUniformedDensityEllipseEditter:YES
                                                   layer:[[self->document_ selLayer] sel]
                                                   start:[self->editState_ firstPoint]
                                                     end:[self->editState_ secondPoint]
                                             orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createDensityEllipseEditter:YES
                                          layer:[[self->document_ selLayer] sel]
                                          start:[self->editState_ firstPoint]
                                            end:[self->editState_ secondPoint]
                                    orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseAtomizer

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createAtomizerEllipseEditter:YES
                                           layer:[[self->document_ selLayer] sel]
                                           start:[self->editState_ firstPoint]
                                             end:[self->editState_ secondPoint]
                                     orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseGradation

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createGradationEllipseEditter:YES
                                            layer:[[self->document_ selLayer] sel]
                                            start:[self->editState_ firstPoint]
                                              end:[self->editState_ secondPoint]
                                      orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseRandom

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createRandomEllipseEditter:YES
                                         layer:[[self->document_ selLayer] sel]
                                         start:[self->editState_ firstPoint]
                                           end:[self->editState_ secondPoint]
                                   orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseWaterDrop

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createWaterDropEllipseEditter:YES
                                            layer:[[self->document_ selLayer] sel]
                                            start:[self->editState_ firstPoint]
                                              end:[self->editState_ secondPoint]
                                      orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseFillNormal

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createNormalEllipseFillEditter:YES
                                             layer:[[self->document_ selLayer] sel]
                                             start:[self->editState_ firstPoint]
                                               end:[self->editState_ secondPoint]
                                       orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseFillUniformedDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createUniformedDensityEllipseFillEditter:YES
                                                       layer:[[self->document_ selLayer] sel]
                                                       start:[self->editState_ firstPoint]
                                                         end:[self->editState_ secondPoint]
                                                 orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];
    
    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseFillDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createDensityEllipseFillEditter:YES
                                              layer:[[self->document_ selLayer] sel]
                                              start:[self->editState_ firstPoint]
                                                end:[self->editState_ secondPoint]
                                        orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];
    
    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseFillAtomizer

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createAtomizerEllipseFillEditter:YES
                                               layer:[[self->document_ selLayer] sel]
                                               start:[self->editState_ firstPoint]
                                                 end:[self->editState_ secondPoint]
                                         orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseFillGradation

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createGradationEllipseFillEditter:YES
                                                layer:[[self->document_ selLayer] sel]
                                                start:[self->editState_ firstPoint]
                                                  end:[self->editState_ secondPoint]
                                          orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseFillRandom

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createRandomEllipseFillEditter:YES
                                             layer:[[self->document_ selLayer] sel]
                                             start:[self->editState_ firstPoint]
                                               end:[self->editState_ secondPoint]
                                       orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawEllipseFillWaterDrop

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createWaterDropEllipseFillEditter:YES
                                                layer:[[self->document_ selLayer] sel]
                                                start:[self->editState_ firstPoint]
                                                  end:[self->editState_ secondPoint]
                                          orientation:(([self->editState_ hasThirdPoint]) ? [self->editState_ thirdPoint] : nil)];

    return;
}

@end
