//
//	Pelistina on Cocoa - PoCo -
//	Խ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoDrawFactory.h"

#import "PoCoMyDocument.h"
#import "PoCoView.h"
#import "PoCoAppController.h"
#import "PoCoEditInfo.h"

#import "PoCoDrawFreeLine.h"
#import "PoCoDrawLine.h"
#import "PoCoDrawBox.h"
#import "PoCoDrawEllipse.h"
#import "PoCoDrawParallelogram.h"
#import "PoCoDrawPaint.h"
#import "PoCoDrawProportional.h"
#import "PoCoDrawSelection.h"
#import "PoCoDrawDragMove.h"

// ============================================================================
@implementation PoCoDrawFactory

// ------------------------------------------------------------ class - private
//
// ͳ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawFreeLine:(MyDocument *)doc
                withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawFreeLine: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawFreeLineNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawFreeLineUniformedDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawFreeLineDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawFreeLineAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawFreeLineGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawFreeLineRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawFreeLineWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// ľ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawLine:(MyDocument *)doc
            withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawLine: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawLineNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawLineUniformedDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawLineDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawLineAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawLineGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawLineRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawLineWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// 
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawBox:(MyDocument *)doc
           withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawBox: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawBoxNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawBoxUniformedDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawBoxDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawBoxAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawBoxGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawBoxRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawBoxWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// /ʱ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawEllipse:(MyDocument *)doc
               withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawEllipse: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawEllipseNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawEllipseUniformedDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawEllipseDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawEllipseAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawEllipseGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawEllipseRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawEllipseWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// ʿԻշ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawParallelogram:(MyDocument *)doc
                     withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawParellelogram: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawParallelogramNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawParallelogramUniformedDensity alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawParallelogramDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawParallelogramAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawParallelogramGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawParallelogramRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawParallelogramWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// ɤĤ֤
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawBoxFill:(MyDocument *)doc
               withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawBoxFill: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawBoxFillNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawBoxFillUniformedDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawBoxFillDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawBoxFillAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawBoxFillGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawBoxFillRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawBoxFillWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// ɤĤ֤/ʱ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawEllipseFill:(MyDocument *)doc
                   withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawEllipseFill: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawEllipseFillNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ǻ
            obj = [[PoCoDrawEllipseFillUniformedDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ñǻ
            obj = [[PoCoDrawEllipseFillDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawEllipseFillAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawEllipseFillGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawEllipseFillRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawEllipseFillWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// ɤĤ֤ʿԻշ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawParallelogramFill:(MyDocument *)doc
                         withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawParalellogramFill: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawParallelogramFillNormal alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawParallelogramFillUniformedDensity alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawParallelogramFillDensity alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawParallelogramFillAtomizer alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawParallelogramFillGradation alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawParallelogramFillRandom alloc] initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawParallelogramFillWaterDrop alloc] initWithDoc:doc];
            break;
    }

    return obj;
}


//
// ɤĤ֤
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawPaint:(MyDocument *)doc
             withPen:(PoCoPenStyleType)pen
{
    DPRINT((@"[PoCoDrawFactory createDrawPaint: withPen:%d\n", pen));

    return [[PoCoDrawPaint alloc] initWithDoc:doc];
}


//
// ɮ㼫ͳ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawProportionalFreeLine:(MyDocument *)doc
                            withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory createDrawProportionalFreeLine: withPen:%d\n", pen));

    obj = nil;

    // ڥ褴Ȥʬ
    switch (pen) {
        case PoCoPenStyleType_Normal:
        default:
            // ̾
            obj = [[PoCoDrawProportionalFreeLineNormal alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_UniformedDensity:
            // ñǻ
            obj = [[PoCoDrawProportionalFreeLineUniformedDensity alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_Density:
            // ǻ
            obj = [[PoCoDrawProportionalFreeLineDensity alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_Atomizer:
            // ̸᤭
            obj = [[PoCoDrawProportionalFreeLineAtomizer alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_Gradation:
            // ǡ
            obj = [[PoCoDrawProportionalFreeLineGradation alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_Random:
            // Ȼ
            obj = [[PoCoDrawProportionalFreeLineRandom alloc]
                      initWithDoc:doc];
            break;
        case PoCoPenStyleType_WaterDrop:
            // ܤ
            obj = [[PoCoDrawProportionalFreeLineWaterDrop alloc]
                      initWithDoc:doc];
            break;
    }

    return obj;
}


//
// 
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawSelection:(MyDocument *)doc
                 withPen:(PoCoPenStyleType)pen
{
    DPRINT((@"[PoCoDrawFactory createDrawSelection: withPen:%d\n", pen));

    return  [[PoCoDrawSelection alloc] initWithDoc:doc];
}


//
// ꤺ
//
//  Call
//    doc : Խо
//    pen : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)createDrawDragMove:(MyDocument *)doc
                withPen:(PoCoPenStyleType)pen
{
    DPRINT((@"[PoCoDrawFactory createDrawDragMove: withPen:%d\n", pen));

    return [[PoCoDrawDragMove alloc] initWithDoc:doc];
}


// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    doc  : Խо
//    draw : ǽ
//    pen  : ڥ
//
//  Return
//    function : ԽϤμ
//
+(id)create:(MyDocument *)doc
   withDraw:(PoCoDrawModeType)draw
    withPen:(PoCoPenStyleType)pen
{
    id obj;

    DPRINT((@"[PoCoDrawFactory create: withDraw:%d withPen:%d]\n", draw, pen));

    obj = nil;

    // ǽȤʬ
    switch (draw) {
        case PoCoDrawModeType_FreeLine:
        default:
            // ͳ
            obj = [PoCoDrawFactory createDrawFreeLine:doc
                                              withPen:pen];
            break;
        case PoCoDrawModeType_Line:
            // ľ
            obj = [PoCoDrawFactory createDrawLine:doc
                                          withPen:pen];
            break;
        case PoCoDrawModeType_Box:
            // 
            obj = [PoCoDrawFactory createDrawBox:doc
                                         withPen:pen];
            break;
        case PoCoDrawModeType_Ellipse:
            // /ʱ
            obj = [PoCoDrawFactory createDrawEllipse:doc
                                             withPen:pen];
            break;
        case PoCoDrawModeType_Parallelogram:
            // ʿԻշ
            obj = [PoCoDrawFactory createDrawParallelogram:doc
                                                   withPen:pen];
            break;
        case PoCoDrawModeType_BoxFill:
            // ɤĤ֤
            obj = [PoCoDrawFactory createDrawBoxFill:doc
                                             withPen:pen];
            break;
        case PoCoDrawModeType_EllipseFill:
            // ɤĤ֤/ʱ
            obj = [PoCoDrawFactory createDrawEllipseFill:doc
                                                 withPen:pen];
            break;
        case PoCoDrawModeType_ParallelogramFill:
            // ɤĤ֤ʿԻշ
            obj = [PoCoDrawFactory createDrawParallelogramFill:doc
                                                       withPen:pen];
            break;
        case PoCoDrawModeType_Paint:
            // ɤĤ֤
            obj = [PoCoDrawFactory createDrawPaint:doc
                                           withPen:pen];
            break;
        case PoCoDrawModeType_ProportionalFreeLine:
            // ɮ㼫ͳ
            obj = [PoCoDrawFactory createDrawProportionalFreeLine:doc
                                                          withPen:pen];
            break;
        case PoCoDrawModeType_Selection:
            // 
            obj = [PoCoDrawFactory createDrawSelection:doc
                                               withPen:pen];
            break;
        case PoCoDrawModeType_DragMove:
            // ꤺ
            obj = [PoCoDrawFactory createDrawDragMove:doc
                                              withPen:pen];
            break;
    }

    return obj;
}

@end
