//
//	Pelistina on Cocoa - PoCo -
//	Խ - ͳ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawFreeLine.h"

#import "PoCoMyDocument.h"
#import "PoCoSelLayer.h"
#import "PoCoEditInfo.h"
#import "PoCoEditState.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoDrawFreeLineBase

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function : 
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDrawFreeLineBase initWithDoc]\n"));

    // super class ν
    self = [super initWithDoc:doc];

    // Ȥν
    if (self != nil) {
        // ⤷ʤ
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoDrawFreeLineBase dealloc]\n"));

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    None
//
//  Return
//    None
//
-(void)exec
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


// --------------------------------------------------- instance - public - 
//
// autoscroll ¹Բ
//
//  Call
//    None
//
//  Return
//    function : YES : ػ
//               NO  : 
//
-(BOOL)canAutoScroll
{
    return YES;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editState_  : Խξ( instance ѿ)
//    prevEraser_ : ξä(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    // Խػߥ쥤䡼
    if ([super isNotEditLayer]) {
        ;
    } else {
        // shift+ctrl ϰŪ˾ä֤Ȥ
        self->prevEraser_ = [self->editInfo_ eraserType];
        if ((([evt modifierFlags] & NSShiftKeyMask) != 0x00) &&
            (([evt modifierFlags] & NSControlKeyMask) != 0x00)) {
            [self->editInfo_ setEraserType:YES];
        }

        // ܳ
        [self->editState_ beginEditMode];

        // ɸ
        [self->editState_ setFirstPoint:nil];
        [self->editState_ setSecondPoint:[self->editState_ firstPoint]];

        // ä
        [super beginUndo:YES];

        // ¹
        [self exec];
    }

    return;
}


//
// ܥɥå
//
//  Call
//    evt        : ٥
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseDrag:(NSEvent *)evt
{
    // Խػߥ쥤䡼
    if ([super isNotEditLayer]) {
        ;
    } else {
        // ɸ
        [self->editState_ setFirstPoint:[self->editState_ secondPoint]];
        [self->editState_ setSecondPoint:nil];

        // ¹
        [self exec];
    }

    return;
}


//
// ܥ꡼
//
//  Call
//    evt         : ٥
//    editInfo_   : Խ( instance ѿ)
//    prevEraser_ : ξä(instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseUp:(NSEvent *)evt
{
    // Խػߥ쥤䡼
    if ([super isNotEditLayer]) {
        ;
    } else {
        // äλ
        [super endUndo:YES];

        // ǽ PD ֹ
        [self->editInfo_ setLastPos:[self->editState_ secondPoint]];

        // ܽλ
        [self->editState_ endEditMode];

        // ä֤򸵤᤹
        [self->editInfo_ setEraserType:self->prevEraser_];
    }

    return;
}


//
// ܥ
//
//  Call
//    evt        : ٥
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    None
//
-(void)rightMouseDown:(NSEvent *)evt
{
    if ([self->editState_ isEdit]) {
        // Խ̵
        ;
    } else {
        // ۤΤ
        [super dropper];
    }

    return;
}


//
// ޥư
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseMove:(NSEvent *)evt
{
    // ⤷ʤ
    ;

    return;
}

@end




// ============================================================================
@implementation PoCoDrawFreeLineNormal

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // ̾μ
    name = [[NSBundle mainBundle]
               localizedStringForKey:@"DrawFreeLine"
                               value:@"free line"
                               table:nil];

    // 
    [self->factory_ createNormalFreeLineEditter:YES
                                          layer:[[self->document_ selLayer] sel]
                                          start:[self->editState_ firstPoint]
                                            end:[self->editState_ secondPoint]
                                       undoName:name];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawFreeLineUniformedDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // ̾μ
    name = [[NSBundle mainBundle]
               localizedStringForKey:@"DrawFreeLine"
                               value:@"free line"
                               table:nil];

    // 
    [self->factory_ createUniformedDensityFreeLineEditter:YES
                                                    layer:[[self->document_ selLayer] sel]
                                                    start:[self->editState_ firstPoint]
                                                      end:[self->editState_ secondPoint]
                                                 undoName:name];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawFreeLineDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // ̾μ
    name = [[NSBundle mainBundle]
               localizedStringForKey:@"DrawFreeLine"
                               value:@"free line"
                               table:nil];

    // 
    [self->factory_ createDensityFreeLineEditter:YES
                                            layer:[[self->document_ selLayer] sel]
                                            start:[self->editState_ firstPoint]
                                              end:[self->editState_ secondPoint]
                                         undoName:name];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawFreeLineAtomizer

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // ̾μ
    name = [[NSBundle mainBundle]
               localizedStringForKey:@"DrawFreeLine"
                               value:@"free line"
                               table:nil];

    // 
    [self->factory_ createAtomizerFreeLineEditter:YES
                                            layer:[[self->document_ selLayer] sel]
                                            start:[self->editState_ firstPoint]
                                              end:[self->editState_ secondPoint]
                                         undoName:name];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawFreeLineGradation

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // ̾μ
    name = [[NSBundle mainBundle]
               localizedStringForKey:@"DrawFreeLine"
                               value:@"free line"
                               table:nil];

    // 
    [self->factory_ createGradationFreeLineEditter:YES
                                             layer:[[self->document_ selLayer] sel]
                                             start:[self->editState_ firstPoint]
                                               end:[self->editState_ secondPoint]
                                          undoName:name];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawFreeLineRandom

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // ̾μ
    name = [[NSBundle mainBundle]
               localizedStringForKey:@"DrawFreeLine"
                               value:@"free line"
                               table:nil];

    // 
    [self->factory_ createRandomFreeLineEditter:YES
                                          layer:[[self->document_ selLayer] sel]
                                          start:[self->editState_ firstPoint]
                                            end:[self->editState_ secondPoint]
                                       undoName:name];

    return;
}

@end





// ============================================================================
@implementation PoCoDrawFreeLineWaterDrop

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // ̾μ
    name = [[NSBundle mainBundle]
               localizedStringForKey:@"DrawFreeLine"
                               value:@"free line"
                               table:nil];

    // 
    [self->factory_ createWaterDropFreeLineEditter:YES
                                             layer:[[self->document_ selLayer] sel]
                                             start:[self->editState_ firstPoint]
                                               end:[self->editState_ secondPoint]
                                          undoName:name];

    return;
}

@end

