//
//	Pelistina on Cocoa - PoCo -
//	Խ - ľ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawLine.h"

#import <Carbon/Carbon.h>

#import "PoCoMyDocument.h"
#import "PoCoSelLayer.h"
#import "PoCoEditInfo.h"
#import "PoCoEditState.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoDrawLineBase

// --------------------------------------------------------- instance - private
//
// Ȥã
//
//  Call
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editInfo_ : Խ( instance ѿ)
//              
-(void)setInfoPDRect
{
    PoCoRect *r;

    r = [[PoCoRect alloc] initLeft:[[self->editState_  firstPoint] x]
                           initTop:[[self->editState_  firstPoint] y]
                         initRight:[[self->editState_ secondPoint] x]
                        initBottom:[[self->editState_ secondPoint] y]];
    [self->editInfo_ setPDRect:r];
    [r release];

    return;
}   


//
// ɲ
//
//  Call
//    pt : 
//
//  Return
//    points_ : (instance ѿ)
//
-(void)addPointToPoints:(PoCoPoint *)pt
{
    PoCoPoint *tmp;

    tmp = [[PoCoPoint alloc] initX:[pt x]
                             initY:[pt y]];
    [self->points_ addObject:tmp];
    [tmp release];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function : 
//    points_  : (instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDrawLineBase initWithDoc]\n"));

    // super class ν
    self = [super initWithDoc:doc];

    // Ȥν
    if (self != nil) {
        // ⤷ʤ
        self->points_ = [[NSMutableArray alloc] init];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    points_ : (instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoDrawLineBase dealloc]\n"));

    // ɥ饤õ
    [self drawGuideLine];

    // äλ
    [super endUndo:NO];

    // Խλ
    [self->editState_ endEditMode];

    // Ȥã
    [self setInfoPDRect];

    // 񸻤β
    [self->points_ removeAllObjects];
    [self->points_ release];
    self->points_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    None
//
//  Return
//    None
//
-(void)exec
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


// --------------------------------------------------- instance - public - 
//
// ɥ饤
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : (instance ѿ)
//
//  Return
//    None
//
-(void)drawGuideLine
{
    if ([self->points_ count] != 0) {
        // ľ
        if ([self->editInfo_ interGuide] != PoCoInterpolationGuideView_Curve) {
            // ľ
            [self->factory_ createInvertPolylineEditter:YES
                                                  layer:[[self->document_ selLayer] sel]
                                                   poly:self->points_];
        }
        if ([self->editInfo_ interGuide] != PoCoInterpolationGuideView_Line) {
            // 
            [self->factory_ createInvertCurveWithPointsEditter:YES
                                                         layer:[[self->document_ selLayer] sel]
                                                        points:self->points_
                                                          type:[self->editInfo_ interType]
                                                          freq:[self->editInfo_ interFreq]];
        }
    } else {
        // ľ
        if ([self->editState_ hasSecondPoint]) {
            [self->factory_ createInvertLineEditter:YES
                                              layer:[[self->document_ selLayer] sel]
                                              start:[self->editState_ firstPoint]
                                                end:[self->editState_ secondPoint]];
        }
    }

    return;
}


//
// Խֲ
//
//  Call
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    points_ : (instance ѿ)
//
-(void)cancelEdit
{
    if (!([self->editState_ isFirstPoint])) {
        // ɥ饤õ
        [self drawGuideLine];

        // äλ
        [super endUndo:NO];

        // Խλ
        [self->editState_ endEditMode];
        [self->points_ removeAllObjects];

        // Ȥã
        [self setInfoPDRect];
    }

    return;
}


//
// autoscroll ¹Բ
//
//  Call
//    None
//
//  Return
//    function : YES : ػ
//               NO  : 
//
-(BOOL)canAutoScroll
{
    return YES;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    points_    : (instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    points_    : (instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    const BOOL inter = ([self->points_ count] != 0);

    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ((([evt modifierFlags] & NSCommandKeyMask) != 0x00) &&
               (([evt modifierFlags] & NSControlKeyMask) != 0x00)) {
        // Command + Control ϥݥȤȤ
        [self drawGuideLine];           // ɥ饤õ
        [super dropper];
        [self drawGuideLine];           // ɥ饤ɽ
    } else if ([self->editState_ isFirstPoint]) {
        // ܳ
        [self->editState_ beginEditMode];

        // ɸ
        [self->editState_ setFirstPoint:nil];

        // ̵ˤ
        [self->points_ removeAllObjects];

        // ä
        [super beginUndo:NO];
    } else if ((([evt modifierFlags] & NSCommandKeyMask) != 0x00) &&
               ([evt clickCount] <= 1)) {
        // ľ

        // ɥ饤õ
        [self drawGuideLine];

        // ɲ
        if (inter) {
            // 2ܰʹ
            [self->editState_ setSecondPoint:nil];
            [self addPointToPoints:[self->editState_ secondPoint]];
        } else {
            // 
            [self addPointToPoints:[self->editState_ firstPoint]];  // 1
            [self->editState_ setSecondPoint:nil];
            [self addPointToPoints:[self->editState_ secondPoint]]; // 2
            [self addPointToPoints:[self->editState_ secondPoint]]; // 3(2ܤƱ)
        }

        // ɥ饤
        [self drawGuideLine];
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // 
        if (inter) {
            // ľ
#if 0   // mouseMove ϿƤΤפʤ
            [self->editState_ setSecondPoint:nil];
            [self->points_ removeLastObject];
            [self addPointToPoints:[self->editState_ secondPoint]];
#endif  // 0
        } else {
            // ľ
            if (!([self->editState_ isIdenticalShape])) {
                [self->editState_ setSecondPoint:nil];
            }
        }

        // ¹
        [self->editState_ countUpEdit];
        [self exec];

        // ѹ
        if (inter) {
            // ľξϷϰݻʤ
            [self->points_ removeAllObjects];

            // ǽ PD ֹ
            [self->editState_ setSecondPoint:nil];
            [self->editInfo_ setLastPos:[self->editState_ secondPoint]];

            // Խ֤ȴ
            [self->editState_ endEditMode]; // Խλ
            [super endUndo:NO];             // äλ
            [self setInfoPDRect];           // Ȥã
        } else {
            // ľξ˰ͤ
            if ([self->editState_ isPointMove]) {
                [self->editState_ setFirstPoint:[self->editState_ secondPoint]];
            }

            // ǽ PD ֹ
            [self->editInfo_ setLastPos:[self->editState_ secondPoint]];

            // ɥ饤
            [self drawGuideLine];
        }
    }

    return;
}


//
// ܥɥå
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseDrag:(NSEvent *)evt
{
    // ̾ΥޥưƱˤ
    [self mouseMove:evt];

    return;
}


//
// ܥ꡼
//
//  Call
//    None
//
//  Return
//    None
//
-(void)mouseUp:(NSEvent *)evt
{
    // ⤷ʤ
    ;

    return;
}


//
// ܥ
//
//  Call
//    evt        : ٥
//    editState_ : Խξ( instance ѿ)
//    points_    : (instance ѿ)
//
//  Return
//    None
//
-(void)rightMouseDown:(NSEvent *)evt
{
    if ([self->editState_ isFirstPoint]) {
        // ۤ
        [super dropper];
    } else if ([self->points_ count] != 0) {
        // ɥ饤õ
        [self drawGuideLine];

        // ľο򸺤餹
        [self->editState_ setSecondPoint:nil];
        [self->points_ removeLastObject];
        if ([self->points_ count] < 3) {
            // 3̤ξľ
            [self->points_ removeAllObjects];
        } else {
            // 3ʾξϹ˸餷Ǹ֤߰ˤľ
            [self->points_ removeLastObject];
            [self addPointToPoints:[self->editState_ secondPoint]];
        }

        // ɥ饤
        [self drawGuideLine];
    } else {
        // Խֲ
        [self cancelEdit];
    }

    return;
}


//
// 
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ʤˤ⤷ʤ
    ;

    return;
}


//
// ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // Escape ξϾԽ
    if ([evt keyCode] == kVK_Escape) {
        // Խֲ
        [self cancelEdit];
    }

    return;
}


//
// ޥư
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    points_    : (instance ѿ)
//
//  Return
//    editState_ : Խξ( instance ѿ)
//    points_    : (instance ѿ)
//
-(void)mouseMove:(NSEvent *)evt
{
    if ([self->editState_ isFirstPoint]) {
        // ʤ
        ;
    } else {
        // Υɥ饤õ
        [self drawGuideLine];

        // 
        if ([self->points_ count] != 0) {
            // ľ
            [self->editState_ setSecondPoint:nil];
            [self->points_ removeLastObject];
            [self addPointToPoints:[self->editState_ secondPoint]];
        } else {
            // ľξ˰ͤ
            if ([self->editState_ isIdenticalShape]) {
                // 
                [self->editState_
                    moveX:([[self->editInfo_ pdPos] x] - [[self->editState_ secondPoint] x])
                    moveY:([[self->editInfo_ pdPos] y] - [[self->editState_ secondPoint] y])];
            } else {
                // 
                [self->editState_ setSecondPoint:nil];
            }
        }

        // ɥ饤
        [self drawGuideLine];

        // Ȥã
        [self setInfoPDRect];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawLineNormal

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // 
    if ([self->points_ count] != 0) {
        // ľ
        [self->factory_ createNormalCurveWithPointsEditter:YES
                                                     layer:[[self->document_ selLayer] sel]
                                                    points:self->points_
                                                      type:[self->editInfo_ interType]
                                                      freq:[self->editInfo_ interFreq]];
    } else {
        // ̾μ
        name = [[NSBundle mainBundle]
                   localizedStringForKey:@"DrawLineShape"
                                   value:@"line shape"
                                   table:nil];

        // ľ
        [self->factory_ createNormalFreeLineEditter:YES
                                              layer:[[self->document_ selLayer] sel]
                                              start:[self->editState_ firstPoint]
                                                end:[self->editState_ secondPoint]
                                           undoName:name];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawLineUniformedDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // 
    if ([self->points_ count] != 0) {
        // ľ
        [self->factory_ createUniformedDensityCurveWithPointsEditter:YES
                                                               layer:[[self->document_ selLayer] sel]
                                                              points:self->points_
                                                                type:[self->editInfo_ interType]
                                                                freq:[self->editInfo_ interFreq]];
    } else {
        // ̾μ
        name = [[NSBundle mainBundle]
                   localizedStringForKey:@"DrawLineShape"
                                   value:@"line shape"
                                   table:nil];

        // ľ
        [self->factory_ createUniformedDensityFreeLineEditter:YES
                                                        layer:[[self->document_ selLayer] sel]
                                                        start:[self->editState_ firstPoint]
                                                          end:[self->editState_ secondPoint]
                                                     undoName:name];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawLineDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // 
    if ([self->points_ count] != 0) {
        // ľ
        [self->factory_ createDensityCurveWithPointsEditter:YES
                                                      layer:[[self->document_ selLayer] sel]
                                                     points:self->points_
                                                       type:[self->editInfo_ interType]
                                                       freq:[self->editInfo_ interFreq]];
    } else {
        // ̾μ
        name = [[NSBundle mainBundle]
                   localizedStringForKey:@"DrawLineShape"
                                   value:@"line shape"
                                   table:nil];

        // ľ
        [self->factory_ createDensityFreeLineEditter:YES
                                               layer:[[self->document_ selLayer] sel]
                                               start:[self->editState_ firstPoint]
                                                 end:[self->editState_ secondPoint]
                                            undoName:name];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawLineAtomizer

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // 
    if ([self->points_ count] != 0) {
        // ľ
        [self->factory_ createAtomizerCurveWithPointsEditter:YES
                                                       layer:[[self->document_ selLayer] sel]
                                                      points:self->points_
                                                        type:[self->editInfo_ interType]
                                                        freq:[self->editInfo_ interFreq]];
    } else {
        // ̾μ
        name = [[NSBundle mainBundle]
                   localizedStringForKey:@"DrawLineShape"
                                   value:@"line shape"
                                   table:nil];

        // ľ
        [self->factory_ createAtomizerFreeLineEditter:YES
                                                layer:[[self->document_ selLayer] sel]
                                                start:[self->editState_ firstPoint]
                                                  end:[self->editState_ secondPoint]
                                             undoName:name];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawLineGradation

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // 
    if ([self->points_ count] != 0) {
        // ľ
        [self->factory_ createGradationCurveWithPointsEditter:YES
                                                        layer:[[self->document_ selLayer] sel]
                                                       points:self->points_
                                                         type:[self->editInfo_ interType]
                                                         freq:[self->editInfo_ interFreq]];
    } else {
        // ̾μ
        name = [[NSBundle mainBundle]
                   localizedStringForKey:@"DrawLineShape"
                                   value:@"line shape"
                                   table:nil];

        // ľ
        [self->factory_ createGradationFreeLineEditter:YES
                                                 layer:[[self->document_ selLayer] sel]
                                                 start:[self->editState_ firstPoint]
                                                   end:[self->editState_ secondPoint]
                                              undoName:name];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawLineRandom

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // 
    if ([self->points_ count] != 0) {
        // ľ
        [self->factory_ createRandomCurveWithPointsEditter:YES
                                                     layer:[[self->document_ selLayer] sel]
                                                    points:self->points_
                                                      type:[self->editInfo_ interType]
                                                      freq:[self->editInfo_ interFreq]];
    } else {
        // ̾μ
        name = [[NSBundle mainBundle]
                   localizedStringForKey:@"DrawLineShape"
                                   value:@"line shape"
                                   table:nil];

        // ľ
        [self->factory_ createRandomFreeLineEditter:YES
                                              layer:[[self->document_ selLayer] sel]
                                              start:[self->editState_ firstPoint]
                                                end:[self->editState_ secondPoint]
                                           undoName:name];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawLineWaterDrop

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    points_    : ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    NSString *name;

    // 
    if ([self->points_ count] != 0) {
        // ľ
        [self->factory_ createWaterDropCurveWithPointsEditter:YES
                                                        layer:[[self->document_ selLayer] sel]
                                                       points:self->points_
                                                        type:[self->editInfo_ interType]
                                                        freq:[self->editInfo_ interFreq]];
    } else {
        // ̾μ
        name = [[NSBundle mainBundle]
                   localizedStringForKey:@"DrawLineShape"
                                   value:@"line shape"
                                   table:nil];

        // ľ
        [self->factory_ createWaterDropFreeLineEditter:YES
                                                 layer:[[self->document_ selLayer] sel]
                                                 start:[self->editState_ firstPoint]
                                                   end:[self->editState_ secondPoint]
                                              undoName:name];
    }

    return;
}

@end
