//
//	Pelistina on Cocoa - PoCo -
//	Խ - ʿԻշ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawParallelogram.h"

#import <Carbon/Carbon.h>

#import "PoCoMyDocument.h"
#import "PoCoSelLayer.h"
#import "PoCoEditInfo.h"
#import "PoCoEditState.h"
#import "PoCoControllerFactory.h"

// ============================================================================
@implementation PoCoDrawParallelogramBase

// --------------------------------------------------------- instance - private
//  
// Ȥã
//
//  Call
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editInfo_ : Խ( instance ѿ)
//
-(void)setInfoPDRect
{
    PoCoRect *r;

    r = nil;
    if ([self->editState_ hasThirdPoint]) {
        // 2-3
        r = [[PoCoRect alloc] initLeft:[[self->editState_ firstPoint] x]
                               initTop:[[self->editState_ firstPoint] y]
                             initRight:[[self->editState_ thirdPoint] x]
                            initBottom:[[self->editState_ thirdPoint] y]];
        [self->editInfo_ setPDRect:r];
    } else {
        // 1-2
        r = [[PoCoRect alloc] initLeft:[[self->editState_  firstPoint] x]
                               initTop:[[self->editState_  firstPoint] y]
                             initRight:[[self->editState_ secondPoint] x]
                            initBottom:[[self->editState_ secondPoint] y]];
        [self->editInfo_ setPDRect:r];
    }
    [r release];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function : 
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDrawParallelogramBase initWithDoc]\n"));

    // super class ν
    self = [super initWithDoc:doc];

    // Ȥν
    if (self != nil) {
        // ⤷ʤ
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoDrawParallelogramBase dealloc]\n"));

    // ɥ饤õ
    if ([self->editState_ hasFirstPoint]) {
        [self drawGuideLine];
    }

    // äλ
    [super endUndo:NO];

    // Խλ
    [self->editState_ endEditMode];

    // Ȥã
    [self setInfoPDRect];     

    // 񸻤β
    ;

    // super class β
    [super dealloc];

    return;
}


//
// ¹
//
//  Call
//    None
//
//  Return
//    None
//
-(void)exec
{
    // Ǥϲ⤷ʤ
    ;

    return;
}


// --------------------------------------------------- instance - public - 
//
// ɥ饤
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)drawGuideLine
{
    if ([self->editState_ hasThirdPoint]) {
        // 2-3
        [self->factory_ createInvertParallelogramEditter:YES
                                                   layer:[[self->document_ selLayer] sel]
                                                   first:[self->editState_ firstPoint]
                                                  second:[self->editState_ secondPoint]
                                                   third:[self->editState_ thirdPoint]];
    } else if ([self->editState_ hasSecondPoint]) {
        // 1-2
        [self->factory_ createInvertLineEditter:YES
                                          layer:[[self->document_ selLayer] sel]
                                          start:[self->editState_ firstPoint]
                                            end:[self->editState_ secondPoint]];
    }

    return;
}


//
// Խֲ
//
//  Call
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    None
//
-(void)cancelEdit
{
    if (!([self->editState_ isFirstPoint])) {
        // ɥ饤õ
        [self drawGuideLine];

        // äλ
        [super endUndo:NO];

        // Խλ
        [self->editState_ endEditMode];

        // Ȥã
        [self setInfoPDRect];     
    }

    return;
}


//
// autoscroll ¹Բ
//
//  Call
//    None
//
//  Return
//    function : YES : ػ
//               NO  : 
//
-(BOOL)canAutoScroll
{
    return YES;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ((([evt modifierFlags] & NSCommandKeyMask) != 0x00) &&
               (([evt modifierFlags] & NSControlKeyMask) != 0x00)) {
        // Command + Control ϥݥȤȤ
        [self drawGuideLine];           // ɥ饤õ
        [super dropper];
        [self drawGuideLine];           // ɥ饤ɽ
    } else if ([self->editState_ isFirstPoint]) {
        // ܳ
        [self->editState_ beginEditMode];

        // ɸ
        [self->editState_ setFirstPoint:nil];

        // ä
        [super beginUndo:NO];
    } else if (!([self->editState_ hasThirdPoint])) {
        // ɥ饤õ
        [self drawGuideLine];

        // 3ܼ
        [self->editState_ setSecondPoint:nil];
        [self->editState_ setThirdPoint:nil];

        // ɥ饤
        [self drawGuideLine];
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // 
        if (!([self->editState_ isIdenticalShape])) {
            [self->editState_ setThirdPoint:nil];
        }

        // ¹
        [self->editState_ countUpEdit];
        [self exec];

        // ѹ
        if ([self->editState_ isPointHold]) {
            [self->editState_ clearSecondPoint];
            [self->editState_ clearThirdPoint];
            [self->editState_ setSecondPoint:nil];
        } else if ([self->editState_ isPointMove]) {
            [self->editState_ clearFirstPoint];
            [self->editState_ clearSecondPoint];
            [self->editState_ clearThirdPoint];
            [self->editState_ setFirstPoint:nil];
        }

        // ɥ饤
        [self drawGuideLine];

        // ǽ PD ֹ
        [self->editInfo_ setLastPos:[self->editInfo_ pdPos]];
    }

    return;
}


//
// ܥɥå
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)mouseDrag:(NSEvent *)evt
{
    // ̾ΥޥưƱˤ
    [self mouseMove:evt];

    return;
}


//
// ܥ꡼
//
//  Call
//    None
//
//  Return
//    None
//
-(void)mouseUp:(NSEvent *)evt
{
    // ⤷ʤ
    ;

    return;
}


//
// ܥ
//
//  Call
//    evt        : ٥
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    None
//
-(void)rightMouseDown:(NSEvent *)evt
{
    if ([self->editState_ isFirstPoint]) {
        // ۤ
        [super dropper];
    } else {
        // Խֲ
        [self cancelEdit];
    }

    return;
}


//
// 
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ʤˤ⤷ʤ
    ;

    return;
}


//
// ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // Escape ξϾԽ
    if ([evt keyCode] == kVK_Escape) {
        // Խֲ
        [self cancelEdit];
    }

    return;
}


//
// ޥư
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editState_ : Խξ( instance ѿ)
//
-(void)mouseMove:(NSEvent *)evt
{
    if ([self->editState_ isFirstPoint]) {
        // ʤ
        ;
    } else {
        // Υɥ饤õ
        if (([self->editState_ hasSecondPoint]) ||
            ([self->editState_ hasThirdPoint])) {
            [self drawGuideLine];
        }

        if ([self->editState_ isIdenticalShape]) {
            // 
            [self->editState_
                moveX:([[self->editInfo_ pdPos] x] - [[self->editState_ thirdPoint] x])
                moveY:([[self->editInfo_ pdPos] y] - [[self->editState_ thirdPoint] y])];
        } else {
            // 
            if ([self->editState_ hasThirdPoint]) {
                [self->editState_ setThirdPoint:nil];
            } else {
                [self->editState_ setSecondPoint:nil];
            }
        }

        // ɥ饤
        [self drawGuideLine];

        // Ȥã
        [self setInfoPDRect];     
    }

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramNormal

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createNormalParallelogramEditter:YES
                                               layer:[[self->document_ selLayer] sel]
                                               first:[self->editState_ firstPoint]
                                              second:[self->editState_ secondPoint]
                                               third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramUniformedDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createUniformedDensityParallelogramEditter:YES
                                                         layer:[[self->document_ selLayer] sel]
                                                         first:[self->editState_ firstPoint]
                                                        second:[self->editState_ secondPoint]
                                                         third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createDensityParallelogramEditter:YES
                                                layer:[[self->document_ selLayer] sel]
                                                first:[self->editState_ firstPoint]
                                               second:[self->editState_ secondPoint]
                                                third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramAtomizer

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createAtomizerParallelogramEditter:YES
                                                 layer:[[self->document_ selLayer] sel]
                                                 first:[self->editState_ firstPoint]
                                                second:[self->editState_ secondPoint]
                                                 third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramGradation

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createGradationParallelogramEditter:YES
                                                  layer:[[self->document_ selLayer] sel]
                                                  first:[self->editState_ firstPoint]
                                                 second:[self->editState_ secondPoint]
                                                  third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramRandom

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createRandomParallelogramEditter:YES
                                               layer:[[self->document_ selLayer] sel]
                                               first:[self->editState_ firstPoint]
                                              second:[self->editState_ secondPoint]
                                               third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramWaterDrop

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createWaterDropParallelogramEditter:YES
                                                  layer:[[self->document_ selLayer] sel]
                                                  first:[self->editState_ firstPoint]
                                                 second:[self->editState_ secondPoint]
                                                  third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramFillNormal

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createNormalParallelogramFillEditter:YES
                                                   layer:[[self->document_ selLayer] sel]
                                                   first:[self->editState_ firstPoint]
                                                  second:[self->editState_ secondPoint]
                                                   third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramFillUniformedDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createUniformedDensityParallelogramFillEditter:YES
                                                             layer:[[self->document_ selLayer] sel]
                                                             first:[self->editState_ firstPoint]
                                                            second:[self->editState_ secondPoint]
                                                             third:[self->editState_ thirdPoint]];
    
    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramFillDensity

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createDensityParallelogramFillEditter:YES
                                                    layer:[[self->document_ selLayer] sel]
                                                    first:[self->editState_ firstPoint]
                                                   second:[self->editState_ secondPoint]
                                                    third:[self->editState_ thirdPoint]];
    
    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramFillAtomizer

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createAtomizerParallelogramFillEditter:YES
                                                     layer:[[self->document_ selLayer] sel]
                                                     first:[self->editState_ firstPoint]
                                                    second:[self->editState_ secondPoint]
                                                     third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramFillGradation

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createGradationParallelogramFillEditter:YES
                                                      layer:[[self->document_ selLayer] sel]
                                                      first:[self->editState_ firstPoint]
                                                     second:[self->editState_ secondPoint]
                                                      third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramFillRandom

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createRandomParallelogramFillEditter:YES
                                                   layer:[[self->document_ selLayer] sel]
                                                   first:[self->editState_ firstPoint]
                                                  second:[self->editState_ secondPoint]
                                                   third:[self->editState_ thirdPoint]];

    return;
}

@end




// ============================================================================
@implementation PoCoDrawParallelogramFillWaterDrop

// ---------------------------------------------------------- instance - public
//
// ¹
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)exec
{
    // 
    [self->factory_ createWaterDropParallelogramFillEditter:YES
                                                      layer:[[self->document_ selLayer] sel]
                                                      first:[self->editState_ firstPoint]
                                                     second:[self->editState_ secondPoint]
                                                      third:[self->editState_ thirdPoint]];

    return;
}

@end
