//
//	Pelistina on Cocoa - PoCo -
//	Խ - ϰ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoDrawSelection.h"

#import <Carbon/Carbon.h>

#import "PoCoMyDocument.h"
#import "PoCoView.h"
#import "PoCoPicture.h"
#import "PoCoSelLayer.h"
#import "PoCoEditInfo.h"
#import "PoCoEditState.h"
#import "PoCoControllerFactory.h"
#import "PoCoCreateStyleMask.h"

// 
typedef enum __pocoSelEditType {
    edit_withHandle,
    edit_paste,
    edit_delete,
    edit_flip_hori,
    edit_flip_vert,
    edit_autograd,
    edit_colorreplace,
    edit_texture,
    edit_key_move
} PoCoSelectionEditType;

// ============================================================================
@implementation PoCoDrawSelection

// ------------------------------------------------------------ class - private
//
// ϰϤĥ
//  half-open property Τ +1 
//
//  Call
//    r : 
//
//  Return
//    function : (Ʊ)
//
+(PoCoRect *)expandForHalfOpen:(PoCoRect *)r
{
    [r setRight:([r right] + 1)];
    [r setBottom:([r bottom] + 1)];

    return r;
}


// --------------------------------------------------------- instance - private
//
// Խ¹
//
//  Call
//    type       : 
//    copy       : ʣ̷
//    document_  : Խо( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//    prevRect_  : ưζ(instance ѿ)
//    prevImage_ : Խβ(instance ѿ)
//
//  Return
//    None
//
-(void)exec:(PoCoSelectionEditType)type
     isCopy:(BOOL)copy
{
    NSBundle *bndl = [NSBundle mainBundle];
    NSString *name;
    PoCoRect *r;

    name = nil;

    // Խˡ
    switch (type) {
        case edit_paste:
            // Žդ
            name = [bndl localizedStringForKey:@"PasteImage"
                                         value:@"paste"
                                         table:nil];
            break;
        case edit_delete:
            // 
            name = [bndl localizedStringForKey:@"Delete"
                                         value:@"delete"
                                         table:nil];
            break;
        case edit_flip_hori:
            // ȿž(ʿ)
            name = [bndl localizedStringForKey:@"FlipHori"
                                         value:@"flip(horizontal)"
                                         table:nil];
            break;
        case edit_flip_vert:
            // ȿž(ľ)
            name = [bndl localizedStringForKey:@"FlipVert"
                                         value:@"flip(vertical)"
                                         table:nil];
            break;
        case edit_autograd:
            // ưǡ
            name = [bndl localizedStringForKey:@"AutoGrad"
                                         value:@"auto gradation"
                                         table:nil];
            break;
        case edit_colorreplace:
            // ִ
            name = [bndl localizedStringForKey:@"BitmapColorReplace"
                                         value:@"color replace"
                                         table:nil];
            break;
        case edit_texture:
            // ƥ
            name = [bndl localizedStringForKey:@"Texture"
                                         value:@"texture"
                                         table:nil];
            break;
        case edit_key_move:
            // ư()
            goto KEY_MOVE;
            break;

        default:
        case edit_withHandle:
            // ϥɥȼ
            if ([self->shape_ isInnerHandle]) {
                // ư
KEY_MOVE:
                if (copy) {
                    // ʣ
                    name = [bndl localizedStringForKey:@"CopyImage"
                                                 value:@"copy"
                                                 table:nil];
                } else {
                    // ư
                    name = [bndl localizedStringForKey:@"MoveImage"
                                                 value:@"move"
                                                 table:nil];
                }
            } else if ([self->shape_ isCornerHandle]) {
                // ܷ
                name = [bndl localizedStringForKey:@"ResizeWithHandle"
                                             value:@"resize(handle)"
                                             table:nil];
            } else if ([self->shape_ isEdgeHandle]) {
                // ž
                name = [bndl localizedStringForKey:@"RotateWithHandle"
                                             value:@"rotate(handle)"
                                             table:nil];
            }
            break;
    }

    // ʣ̷ǤŽդβ
    if (copy) {
        // ʬ˺
        [self->prevImage_ release];
        self->prevImage_ = nil;

        // Τʣ
        self->prevImage_ = [[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap] copy];
    }

    // ̤Žդ
    if (([self->shape_ resultShape] != nil) &&
        (([self->shape_ resultPoints] == nil) ||
        ([[self->shape_ resultPoints] count] == 0))) {
        r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]];
    } else {
        r = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]]];
    }
    [self->factory_ createNormalPasteImageEditter:YES
                                            layer:[[self->document_ selLayer] sel]
                                             rect:r
                                           bitmap:[self->shape_ resultImage]
                                           region:[self->shape_ resultShape]
                                         prevRect:((copy) ? nil : self->prevRect_)
                                       prevBitmap:((copy) ? nil : self->prevImage_)
                                         undoName:name];
    [r release];

    return;
}


//
// ϰϤ򹹿
//
//  Call
//    r : 
//
//  Return
//    editInfo_ : Խ( instance ѿ)
//
-(void)updateSelectionRect:(PoCoRect *)r
{
    PoCoRect *tmp;

    if ((r == nil) || ([r empty])) {
        tmp = [[PoCoRect alloc] init];
        [self->editInfo_ setPDRect:tmp];
    } else {
        // ݥ󥿰
        [self->editInfo_ setPDRect:r];

        // ϰϤ half-open property Τ +1
        tmp = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:r]];
    }
    [self->editInfo_ setSelRect:tmp];
    [tmp release];

    return;
}


//
// 
//
//  Call
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//    prevImage_ : β()(instance ѿ)
//    prevPos_   : (instance ѿ)
//    prevRect_  : ϰ(Ĺ)(instance ѿ)
//
-(void)initSelectionShape
{
    [self->editState_ beginEditMode];
    [self->editState_ setFirstPoint:nil];
    [self->editState_ setSecondPoint:nil];
    [self->editInfo_ setLastPos:[self->editState_ firstPoint]];
    [self->shape_ release];
    [self->prevImage_ release];
    [self->prevPos_ release];
    [self->prevRect_ release];
    self->shape_ = nil;
    self->prevImage_ = nil;
    self->prevPos_ = nil;
    self->prevRect_ = nil;

    // ϰϷ򿷵˵(ƤӽФǷ˱Ԥ)
    self->shape_ = [[PoCoSelectionShape alloc] init];

    return;
}


//
// 
//  ϰμŪ
//
//  Call
//    document_ : Խо( instance ѿ)
//
//  Return
//    prevImage_ : Խβ(instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//
-(void)decideSelectionShape
{
    PoCoRect *r;

    [self->prevImage_ release];
    self->prevImage_ = [[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap] copy];
    r = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ originalRect]]];
    [self->shape_ setImage:[self->prevImage_ getBitmap:r]];
    [r release];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function    : 
//    isCopy_     : ʣ̻(instance ѿ)
//    isDrag_     : ɥå椫(instance ѿ)
//    isPaint_    : ɤ椫(instance ѿ)
//    shape_      : ϰϷ(instance ѿ)
//    prevImage_  : β()(instance ѿ)
//    prevPos_    : (instance ѿ)
//    prevRect_   : ϰ(Ĺ)(instance ѿ)
//    prevHandle_ : Υϥɥ(instance ѿ)
//    modify_     : (instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDrawSelection initWithDoc]\n"));

    // super class ν
    self = [super initWithDoc:doc];

    // Ȥν
    if (self != nil) {
        self->isCopy_ = NO;
        self->isDrag_ = NO;
        self->isPaint_ = NO;
        self->shape_ = nil;
        self->prevImage_ = nil;
        self->prevPos_ = nil;
        self->prevRect_ = nil;
        self->prevHandle_ = PoCoHandleType_unknown;
    }

    return self;
}


//
// deallocate
//
//  Call
//    document_  : Խо( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//
//  Return
//    shape_     : ϰϷ(instance ѿ)
//    prevImage_ : β()(instance ѿ)
//    prevPos_   : (instance ѿ)
//    prevRect_  : ϰ(Ĺ)(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoDrawSelection dealloc]\n"));

    // ɥ饤õ
    [self drawGuideLine];

    // Pointer ᤹
    [[self->document_ view] discardCursorRects];

    // Խλ
    [self->editState_ endEditMode];

    // Ȥã
    [self updateSelectionRect:nil];

    // 񸻤β
    [self->shape_ release];
    [self->prevImage_ release];
    [self->prevPos_ release];
    [self->prevRect_ release];
    self->shape_ = nil;
    self->prevImage_ = nil;
    self->prevPos_ = nil;
    self->prevRect_ = nil;

    // super class β
    [super dealloc];

    return;
}


// --------------------------------------------- instance - public - ϰ
//
// ڡȥܡɤŽդ
//
//  Call
//    lyr       : Žդ
//    document_ : Խо( instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//    prevImage_ : β()(instance ѿ)
//    prevRect_  : ϰ(Ĺ)(instance ѿ)
//
-(void)pasteBitmap:(PoCoLayerBase *)lyr
{
    PoCoView *view = [self->document_ view];
    PoCoPoint *p;
    const int w = [[lyr bitmap] width];
    const int h = [[lyr bitmap] height];
    const int l = ([[self->editInfo_ lastPos] x] - (w >> 1));
    const int t = ([[self->editInfo_ lastPos] y] - (h >> 1));
    const int r = (l + w - 1);
    const int b = (t + h - 1);

    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else {
        // ξ֤˴
        [self->shape_ release];
        self->shape_ = nil;
        [self->editState_ beginEditMode];

        // ɸ
        self->shape_ = [[PoCoSelectionShape alloc] init];
        p = [[PoCoPoint alloc] initX:l
                               initY:t];
        [self->shape_ addPoint:p];
        [p release];
        p = [[PoCoPoint alloc] initX:r
                               initY:t];
        [self->shape_ addPoint:p];
        [p release];
        p = [[PoCoPoint alloc] initX:r
                               initY:b];
        [self->shape_ addPoint:p];
        [p release];
        p = [[PoCoPoint alloc] initX:l
                               initY:b];
        [self->shape_ addPoint:p];
        [p release];
        [self->shape_ addPoint:nil];

        // Žդʽ(ʣ)
        [self->shape_ setImage:[[lyr bitmap] copy]];

        // Խ¹
        [super beginUndo:NO];           // ä
        [self exec:edit_paste
            isCopy:YES];
        [super endUndo:NO];             // äλ

        // ϰϤʤɤ򹹿
        [self->editState_ setFirstPoint:[[self->shape_ resultRect] lefttop]];
        [self->editState_ setSecondPoint:[[self->shape_ resultRect] rightbot]];
        [self updateSelectionRect:[self->shape_ resultRect]];
        [self->prevRect_ release];
        self->prevRect_ = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]]];

        // pointer 
        [[view window] invalidateCursorRectsForView:view];

        // ɥ饤ɽ
        [self drawGuideLine];
    }

    return;
}


//
// 
//
//  Call
//    document_ : Խо( instance ѿ)
//    shape_    : ϰϷ(instance ѿ)
//
//  Return
//    None
//
-(void)delete
{
    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ([[self->shape_ resultRect] empty]) {
        // ϰϤʤ鲿⤷ʤ
        ;
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // Խ¹
        [super beginUndo:NO];           // ä
        [self->shape_ delete:self->document_
                withEditInfo:self->editInfo_];
        [self exec:edit_delete
            isCopy:YES];
        [super endUndo:NO];             // äλ

        // ɥ饤ɽ
        [self drawGuideLine];
    }

    return;
}


//
// ȿž
//
//  Call
//    hori : ʿ
//           YES : ʿ˲ȿž
//           NO  : ľ˲ȿž
//
//  Return
//    None
//
-(void)flipImage:(BOOL)hori
{
    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ([[self->shape_ resultRect] empty]) {
        // ϰϤʤ鲿⤷ʤ
        ;
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // Խ¹
        [super beginUndo:NO];           // ä
        [self->shape_ flip:hori];
        [self exec:((hori) ? edit_flip_hori : edit_flip_vert)
            isCopy:YES];
        [super endUndo:NO];             // äλ

        // ɥ饤ɽ
        [self drawGuideLine];
    }

    return;
}


//
// ưǡ
//
//  Call
//    size      : 礭(0: Ǥա1-128 ϰ)
//    adj       : (YES: ٤礦ֹΤ)
//    mtx       : оݿ(256 ĹYES: о)
//    sizePair  : 礭ȿֹз
//    document_ : Խо( instance ѿ)
//    shape_    : ϰϷ(instance ѿ)
//
//  Return
//    None
//
-(void)autoGrad:(int)size
     isAdjacent:(BOOL)adj
         matrix:(const BOOL *)mtx
   withSizePair:(NSDictionary *)sizePair
{
    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ([[self->shape_ resultRect] empty]) {
        // ϰϤʤ鲿⤷ʤ
        ;
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // Խ¹
        [super beginUndo:NO];           // ä
        [self->shape_ autoGrad:self->document_
                       penSize:size
                    isAdjacent:adj
                        matrix:mtx
                  withSizePair:sizePair];
        [self exec:edit_autograd
            isCopy:YES];
        [super endUndo:NO];             // äλ

        // ɥ饤ɽ
        [self drawGuideLine];
    }

    return;
}


//
// ִ
//
//  Call
//    mtx       : ִɽ(256 Ĺ)
//    document_ : Խо( instance ѿ)
//    shape_    : ϰϷ(instance ѿ)
//
//  Return
//    None
//
-(void)colorReplace:(const unsigned char *)mtx
{
    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ([[self->shape_ resultRect] empty]) {
        // ϰϤʤ鲿⤷ʤ
        ;
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // Խ¹
        [super beginUndo:NO];           // ä
        [self->shape_ colorReplace:self->document_
                            matrix:mtx];
        [self exec:edit_colorreplace
            isCopy:YES];
        [super endUndo:NO];             // äλ

        // ɥ饤ɽ
        [self drawGuideLine];
    }

    return;
}


//
// ƥ
//
//  Call
//    base : ܿ(NSArray<unsigned int>)
//    grad : ǻø(NSArray<unsinged int, NSArray<unsigned int> >)
//
//  Return
//    None
//
-(void)texture:(NSArray *)base
  withGradient:(NSArray *)grad
{
    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else if ([[self->shape_ resultRect] empty]) {
        // ϰϤʤ鲿⤷ʤ
        ;
    } else {
        // ɥ饤õ
        [self drawGuideLine];

        // Խ¹
        [super beginUndo:NO];           // ä
        [self->shape_ texture:self->document_
                 withEditInfo:self->editInfo_
                   baseColors:base
               gradientColors:grad];
        [self exec:edit_texture
            isCopy:YES];
        [super endUndo:NO];             // äλ

        // ɥ饤ɽ
        [self drawGuideLine];
    }

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    editState_ : Խξ( instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//    prevImage_ : β()(instance ѿ)
//    prevRect_  : ϰ(Ĺ)(instance ѿ)
//
-(void)selectAll
{
    PoCoView *view = [self->document_ view];
    PoCoPoint *p;
    PoCoRect *r;

    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else {
        // Ƥ˺
        [self selectClear];
        [self->editState_ beginEditMode];

        // ϰ
        r = [[self->document_ picture] bitmapPoCoRect];
        self->shape_ = [[PoCoSelectionShape alloc] init];
        p = [[PoCoPoint alloc] initX:[r left]
                               initY:[r top]];
        [self->shape_ addPoint:p];
        [p release];
        p = [[PoCoPoint alloc] initX:([r right] - 1)
                               initY:[r top]];
        [self->shape_ addPoint:p];
        [p release];
        p = [[PoCoPoint alloc] initX:([r right] - 1)
                               initY:([r bottom] - 1)];
        [self->shape_ addPoint:p];
        [p release];
        p = [[PoCoPoint alloc] initX:[r left]
                               initY:([r bottom] - 1)];
        [self->shape_ addPoint:p];
        [p release];
        [self->shape_ addPoint:nil];
        [r release];

        // ϰϤʤɤ򹹿
        [self->editState_ setFirstPoint:[[self->shape_ resultRect] lefttop]];
        [self->editState_ setSecondPoint:[[self->shape_ resultRect] rightbot]];
        [self updateSelectionRect:[self->shape_ resultRect]];
        [self->prevRect_ release];
        self->prevRect_ = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]]];
        [self->prevImage_ release];
        self->prevImage_ = [[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap] copy];
        r = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ originalRect]]];
        [self->shape_ setImage:[self->prevImage_ getBitmap:r]];
        [r release];

        // pointer 
        [[view window] invalidateCursorRectsForView:view];

        // ɥ饤ɽ
        [self drawGuideLine];
    }

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    editState_ : Խξ( instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//    prevImage_ : β()(instance ѿ)
//    prevPos_   : (instance ѿ)
//    prevRect_  : ϰ(Ĺ)(instance ѿ)
//
-(void)selectClear
{
    PoCoView *view = [self->document_ view];

    // ɥ饤õ
    if (self->shape_ != nil) {
        [self drawGuideLine];
    }

    // ξϤ٤˺
    [self->editState_ endEditMode];
    [self->shape_ release];
    [self->prevImage_ release];
    [self->prevPos_ release];
    [self->prevRect_ release];
    self->shape_ = nil;
    self->prevImage_ = nil;
    self->prevPos_ = nil;
    self->prevRect_ = nil;

    // ϰϹ
    [self updateSelectionRect:nil];

    // pointer 
    [[view window] invalidateCursorRectsForView:view];

    return;
}


//
// ư
//
//  Call
//    document_ : Խо( instance ѿ)
//
//  Return
//    shape_     : ϰϷ(instance ѿ)
//    prevImage_ : Խβ(instance ѿ)
//
-(void)recreatePasteImage
{
    PoCoRect *r;
    PoCoBitmap *org;
    PoCoBitmap *bmp;

    if (self->shape_ != nil) {
        // ʣ
        [self->shape_ copyResultToOriginal];

        // Խβ򺹤ؤ
        [self->prevImage_ release];
        self->prevImage_ = [[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap] copy];

        // 
        r = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ originalRect]]];
        bmp = [self->prevImage_ getBitmap:r];
        [r release];

        // ѷβʣƼǾ
        r = [[PoCoRect alloc]
                  initLeft:MAX(0, [[self->shape_ originalRect] left])
                   initTop:MAX(0, [[self->shape_ originalRect] top])
                 initRight:MIN([self->prevImage_ width], ([[self->shape_ originalRect] right] + 1))
                initBottom:MIN([self->prevImage_ height], ([[self->shape_ originalRect] bottom] + 1))];
        org = [[self->shape_ originalImage] copy];
        [org setBitmap:[bmp pixelmap]
              withRect:r];
        [r release];
        [bmp release];

        // ϰϷϿ
        [self->shape_ setImage:org];
    }

    return;
}


// --------------------------------------------------- instance - public - 
//
// Pointer ϰϹ
//
//  Call
//    document_ : Խо( instance ѿ)
//    editInfo_ : Խ( instance ѿ)
//    isDrag_   : ɥå椫(instance ѿ)
//    shape_    : ϰϷ(instance ѿ)
//
//  Return
//    None
//
-(void)updateCursorRect
{
    PoCoView *view = [self->document_ view];
    PoCoRect *r;
    const int gap = [view handleRectGap];

    // ٤Ʋ
    [super updateCursorRect];

    if (self->shape_ != nil) {
        if (([self->shape_ originalImage] != nil) && (self->isDrag_)) {
            // ѷ
            r = [[self->document_ picture] bitmapPoCoRect];
            [view addCursorRect:[view toDispRect:r]
                         cursor:[NSCursor closedHandCursor]];
            [r release];
        } else if (([NSEvent modifierFlags] & NSCommandKeyMask) != 0x00) {
            // ɤϷѤʤ
            ;
        } else {
            // ϰ
            r = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]]];
            [view addCursorRect:[view toDispRect:r]
                         cursor:[NSCursor openHandCursor]];
            [r release];

            if ([self->editInfo_ useHandle]) {
                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_lt]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];
                [r release];

                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_t]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];    
                [r release];

                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_rt]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];
                [r release];

                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_r]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];    
                [r release];

                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_rb]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];
                [r release];

                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_b]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];    
                [r release];

                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_lb]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];
                [r release];

                // 
                r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_l]];
                [r expand:gap];
                [view addCursorRect:[view toDispRect:r]
                             cursor:[NSCursor crosshairCursor]];    
                [r release];
            }
        }
    }

    return;
}


//
// ɥ饤
//
//  Call
//    document_  : Խо( instance ѿ)
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    factory_   : Խ( instance ѿ)
//    isDrag_    : ɥå椫(instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//
//  Return
//    None
//
-(void)drawGuideLine
{
    const int idx = [[self->document_ selLayer] sel];
    const int gap = [[self->document_ view] handleRectGap];
    PoCoRect *r;
    PoCoPoint *p;
    PoCoCreateStyleMask *mask;

    if ([self->editState_ hasSecondPoint]) {
        if ([self->shape_ originalImage] == nil) {
            // ϰ
            if ([self->editInfo_ continuationType]) {
                // Ǥշ
                [self->factory_ createInvertPolylineEditter:YES
                                                      layer:idx
                                                       poly:[self->shape_ originalPoints]];
            } else {
                // 
                [self->factory_ createInvertPolygonEditter:YES
                                                     layer:idx
                                                      poly:[self->shape_ originalPoints]];
            }
        } else if (([self->shape_ resultRect] != nil) &&
                   (!([[self->shape_ resultRect] empty]))) {
            // ϰϳ
            if (([self->editInfo_ selectionFill]) &&
                ([self->shape_ resultShape] != nil)) {
                // ɤĤ֤
                [self->factory_ createInvertBoxEditter:YES
                                                 layer:idx
                                                 start:[[self->shape_ resultRect] lefttop]
                                                   end:[[self->shape_ resultRect] rightbot]
                                           orientation:nil];
                [self->factory_ createInvertRegionFillEditter:YES
                                                        layer:idx
                                                         rect:[self->shape_ resultRect]
                                                         mask:[self->shape_ resultShape]];
            } else if (([self->shape_ resultShape] != nil) &&
                       (([self->shape_ resultPoints] == nil) ||
                        ([[self->shape_ resultPoints] count] == 0))) {
                // ɤĤ֤ζ
                p = [[PoCoPoint alloc] initX:([[self->shape_ resultRect] right] - 1)
                                       initY:([[self->shape_ resultRect] bottom] - 1)];
                [self->factory_ createInvertBoxEditter:YES
                                                 layer:idx
                                                 start:[[self->shape_ resultRect] lefttop]
                                                   end:p
                                           orientation:nil];
                [p release];
                [self->factory_ createInvertRegionBorderEditter:YES
                                                          layer:idx
                                                           rect:[self->shape_ resultRect]
                                                           mask:[self->shape_ resultShape]];
            } else {
                // 
                [self->factory_ createInvertBoxEditter:YES
                                                 layer:idx
                                                 start:[[self->shape_ resultRect] lefttop]
                                                   end:[[self->shape_ resultRect] rightbot]
                                           orientation:nil];
                if (!([self->shape_ isSameStyleResultRectShape])) {
                    [self->factory_ createInvertPolygonEditter:YES
                                                         layer:idx
                                                          poly:[self->shape_ resultPoints]];
                }
            }

            // ϥɥ
            if ([self->editInfo_ useHandle]) {
                mask = [[PoCoCreateStyleMask alloc] init];
                if (self->isDrag_) {
#if 0
                    // ĤǤϥɥ
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ controlHandle]];
                    if (!([r empty])) {
                        [r expand:gap];
                        if ([mask box:[r lefttop]
                                  end:[r rightbot]
                          orientation:nil
                           isDiagonal:NO]) {
                            [self->factory_ createInvertRegionFillEditter:YES
                                                                    layer:idx
                                                                     rect:r
                                                                     mask:[mask mask]];
                        }
                    }
                    [r release];
#else   // 0
                    // ѷϲ⤷ʤ
                    ;
#endif  // 0
                } else {
                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_lt]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];

                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_t]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];

                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_rt]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];

                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_r]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];

                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_rb]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];

                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_b]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];

                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_corner_lb]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];

                    // 
                    r = [[PoCoRect alloc] initPoCoRect:[self->shape_ resultHandle:PoCoHandleType_edge_l]];
                    [r expand:gap];
                    if ([mask box:[r lefttop]
                              end:[r rightbot]
                      orientation:nil
                       isDiagonal:NO]) {
                        [self->factory_ createInvertRegionFillEditter:YES
                                                                layer:idx
                                                                 rect:r
                                                                 mask:[mask mask]];
                    }
                    [r release];
                }
                [mask release];
            }
        }
    }

    return;
}


//
// Խֲ
//
//  Call
//    editInfo_ : Խ( instance ѿ)
//
//  Return
//    None
//
-(void)cancelEdit
{
    if (!([[self->editInfo_ selRect] empty])) {
        [self selectClear];
    }

    return;
}


//
// ѷ
//
//  Call
//    shape_ : ϰϷ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoBitmap *)originalImage
{
    return [self->shape_ originalImage];
}


//
// ѷ
//
//  Call
//    shape_ : ϰϷ(instance ѿ)
//
//  Return
//    function :  
//
-(PoCoBitmap *)originalShape
{
    return [self->shape_ originalShape];
}


//
// autoscroll ¹Բ
//
//  Call
//    None
//
//  Return
//    function : YES : ػ
//               NO  : 
//
-(BOOL)canAutoScroll
{
    return YES;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    isPaint_   : ɤ椫(instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//    prevImage_ : β()(instance ѿ)
//    prevPos_   : (instance ѿ)
//    prevRect_  : ϰ(Ĺ)(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    BOOL create;

    if ([super isNotEditLayer]) {
        // Խػߥ쥤䡼
        ;
    } else {
        if (([evt modifierFlags] & NSCommandKeyMask) != 0x00) {
            // ɤ
            self->isPaint_ = YES;
            if (self->shape_ != nil) {
                // ɥ饤õ
                [self drawGuideLine];
            }
            if ((([evt modifierFlags] & NSShiftKeyMask) != 0x00) &&
                ([self->shape_ resultRect] != nil) &&
                (!([[self->shape_ resultRect] empty]))) {
                // 
                [self->shape_ seedJoin:[self->editInfo_ pdPos]
                                bitmap:[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap]
                              isBorder:(([evt modifierFlags] & NSControlKeyMask) != 0x00)
                            colorRange:(([self->editInfo_ continuationType]) ? [self->editInfo_ colorRange] : 0)];
            } else if (([evt modifierFlags] & NSAlternateKeyMask) != 0x00) {
                // ʬΥ
                [self->shape_ seedSeparate:[self->editInfo_ pdPos]
                                    bitmap:[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap]
                                  isBorder:(([evt modifierFlags] & NSControlKeyMask) != 0x00)
                                colorRange:(([self->editInfo_ continuationType]) ? [self->editInfo_ colorRange] : 0)];
            } else {
                // ϰ
                [self initSelectionShape];
                [self->shape_ seedNew:[self->editInfo_ pdPos]
                               bitmap:[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap]
                             isBorder:(([evt modifierFlags] & NSControlKeyMask) != 0x00)
                           colorRange:(([self->editInfo_ continuationType]) ? [self->editInfo_ colorRange] : 0)];
            }
        } else if ([self->shape_ startTrans:[self->editInfo_ pdPos]
                                  handleGap:([self->editInfo_ useHandle]) ? [[self->document_ view] handleRectGap] : -(HANDLE_GAP << 1)
                                  withShape:NO]) {
            // ѷ(ϰ⡢ʤϥɥ)
            create = NO;
            if (([PoCoSelectionShape isInner:self->prevHandle_]) &&
                ([PoCoSelectionShape isInner:self->prevHandle_] == [self->shape_ isInnerHandle])) {
                // ư³ΤǷʤɤϤΤޤ
                ;
            } else if (([PoCoSelectionShape isCorner:self->prevHandle_]) &&
                       ([PoCoSelectionShape isCorner:self->prevHandle_] == [self->shape_ isCornerHandle])) {
                if (self->prevHandle_ == [self->shape_ controlHandle]) {
                    // ƱϥɥʤΤǷʤɤϤΤޤ
                    ;
                } else {
                    // 㤦ϥɥʤΤǷ
                    create = YES;
                }
            } else if (([PoCoSelectionShape isEdge:self->prevHandle_]) &&
                       ([PoCoSelectionShape isEdge:self->prevHandle_] == [self->shape_ isEdgeHandle])) {
                // ž󤴤Ȥ˳
                create = YES;
            } else {
                // 㤦ϤˤʤΤǷ
                create = YES;
            }
            if (create) {
                // ɥ饤õ
                [self drawGuideLine];

                // (̤ʣ)
                [self->shape_ copyResultToOriginal];
                [self->shape_ setImage:[[self->shape_ resultImage] copy]];

#if 0   // Ūʣ̤ؼޤǤϺǽξ֤ݻ
                // ѷβ()Ƽ
                [self->prevImage_ release];
                self->prevImage_ = [[[[self->document_ picture] layer:[[self->document_ selLayer] sel]] bitmap] copy];
#endif  // 0

                // ɥ饤
                [self drawGuideLine];
            }

            // Խ
            [self->prevRect_ release];
            self->prevRect_ = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]]];

            // ä(äˤ)
            [super beginUndo:YES];
        } else {
            // ϰϳʤ
            if (self->shape_ != nil) {
                // ɥ饤õ
                [self drawGuideLine];
            }

            // ϰ
            [self initSelectionShape];
            self->prevPos_ = [[PoCoPoint alloc]
                                 initX:[[self->editInfo_ pdPos] x]
                                 initY:[[self->editInfo_ pdPos] y]];
            [self->shape_ addPoint:self->prevPos_];
        }
        self->prevHandle_ = [self->shape_ controlHandle];
    }

    return;
}


//
// ܥɥå
//
//  Call
//    evt        : ٥
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    prevPos_   : (instance ѿ)
//
//  Return
//    editInfo_  : Խ( instance ѿ)
//    editState_ : Խξ( instance ѿ)
//    isDrag_    : ɥå椫(instance ѿ)
//    isPaint_   : ɤ椫(instance ѿ)
//    shape_     : ϰϷ(instance ѿ)
//    prevPos_   : (instance ѿ)
//
-(void)mouseDrag:(NSEvent *)evt
{
    PoCoView *view = [self->document_ view];
    PoCoPoint *p;

    if (self->shape_ != nil) {
        if (self->isPaint_) {
            // ɤϲ⤷ʤ
            ;
        } else {
            // ɥ饤õ
            [self drawGuideLine];

            // ɥå
            self->isDrag_ = YES;

            // 
            if ([self->shape_ isOuterHandle]) {
                // ϰ
                [self->editState_ setSecondPoint:nil];
                if (([self->prevPos_ x] != [[self->editState_ secondPoint] x]) ||
                    ([self->prevPos_ y] != [[self->editState_ secondPoint] y])) {
                        if ([self->editInfo_ continuationType]) {
                        [self->shape_ addPoint:[self->editState_ secondPoint]];
                    } else {
                        [self->shape_ clearOriginal];
                        [self->shape_ addPoint:[self->editState_ firstPoint]];
                        if ((([[self->editState_ firstPoint] x] < [[self->editState_ secondPoint] x]) &&
                             ([[self->editState_ firstPoint] y] < [[self->editState_ secondPoint] y])) ||
                            (([[self->editState_ firstPoint] x] >= [[self->editState_ secondPoint] x]) &&
                             ([[self->editState_ firstPoint] y] >= [[self->editState_ secondPoint] y]))) {
                            p = [[PoCoPoint alloc] initX:[[self->editState_ firstPoint] x]
                                                   initY:[[self->editState_ secondPoint] y]];
                            [self->shape_ addPoint:p];
                            [p release];
                            p = [[PoCoPoint alloc] initX:[[self->editState_ secondPoint] x]
                                                   initY:[[self->editState_ secondPoint] y]];
                            [self->shape_ addPoint:p];
                            [p release];
                            p = [[PoCoPoint alloc] initX:[[self->editState_ secondPoint] x]
                                                   initY:[[self->editState_ firstPoint] y]];
                            [self->shape_ addPoint:p];
                            [p release];
                        } else {
                            p = [[PoCoPoint alloc] initX:[[self->editState_ secondPoint] x]
                                                   initY:[[self->editState_ firstPoint] y]];
                            [self->shape_ addPoint:p];
                            [p release];
                            p = [[PoCoPoint alloc] initX:[[self->editState_ secondPoint] x]
                                                   initY:[[self->editState_ secondPoint] y]];
                            [self->shape_ addPoint:p];
                            [p release];
                            p = [[PoCoPoint alloc] initX:[[self->editState_ firstPoint] x]
                                                   initY:[[self->editState_ secondPoint] y]];
                            [self->shape_ addPoint:p];
                            [p release];
                        }
                    }
                    [self->prevPos_ setX:[[self->editState_ secondPoint] x]
                                    setY:[[self->editState_ secondPoint] y]];
                }

                // ϰϹ
                [self updateSelectionRect:[self->shape_ originalRect]];
            } else {
                // ϰѷ
                [self->shape_ runningTrans:[self->editInfo_ pdPos]
                                 withEvent:evt
                         isLiveUpdateShape:[self->editInfo_ selectionFill]
                        isLiveUpdateResult:[self->editInfo_ liveEditSelection]];

                // ϰϹ
                [self updateSelectionRect:[self->shape_ resultRect]];

                // ̤༡ɽ
                if ([self->editInfo_ liveEditSelection]) {
                    if (([self->shape_ resultRect] != nil) &&
                        (!([[self->shape_ resultRect] empty])) &&
                        ([self->shape_ resultShape] != nil)) {
                        // Խ
                        [self exec:edit_withHandle
                            isCopy:NO];
                        [self->prevRect_ release];
                        self->prevRect_ = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]]];
                    }
                }
            }

            // pointer 
            [[view window] invalidateCursorRectsForView:view];

            // ɥ饤
            [self drawGuideLine];
        }
    }

    return;
}


//
// ܥ꡼
//
//  Call
//    evt       : ٥
//    document_ : Խо( instance ѿ)
//    isCopy_   : ʣ̻(instance ѿ)
//
//  Return
//    isDrag_   : ɥå椫(instance ѿ)
//    isPaint_  : ɤ椫(instance ѿ)
//    shape_    : ϰϷ(instance ѿ)
//    prevPos_  : (instance ѿ)
//
-(void)mouseUp:(NSEvent *)evt
{
    PoCoView *view = [self->document_ view];

    if (self->shape_ != nil) {
        if (self->isPaint_) {
            // ɤʤΤϰ
            self->isPaint_ = NO;
            [self decideSelectionShape];
        } else {
            // ɥå򳰤
            self->isDrag_ = NO;

            // ɥ饤õ
            [self drawGuideLine];

            // 
            if ([self->shape_ isOuterHandle]) {
                // ϰ
                [self->shape_ addPoint:nil];
                if ([[self->shape_ resultRect] empty]) {
                    // ϰϤȤƤʤΤǵѲ
                    [self->editState_ endEditMode];
                    [self->shape_ release];
                    [self->prevPos_ release];
                    self->shape_ = nil;
                    self->prevPos_ = nil;
                } else {
                    // ϰ
                    [self decideSelectionShape];
                }
            } else if (!([[self->shape_ resultRect] empty])) {
                // Խ
                [self->shape_ endTrans];

                // Խ¹
                [self exec:edit_withHandle
                    isCopy:((self->isCopy_) ||
                            (([evt modifierFlags] & NSControlKeyMask) != 0x00))];

                // äλ(äˤ)
                [super endUndo:YES];
            }
        }

        // ɥ饤ɽ
        [self drawGuideLine];

        // ϰϹ
        [self updateSelectionRect:[self->shape_ resultRect]];

        // pointer 
        [[view window] invalidateCursorRectsForView:view];
    }

    return;
}


//
// ܥ
//
//  Call
//    evt     : ٥
//    isDrag_ : ɥå椫(instance ѿ)
//
//  Return
//    isCopy_ : ʣ̻(instance ѿ)
//
-(void)rightMouseDown:(NSEvent *)evt
{
    if (self->isDrag_) {
        // ʣ̻
        self->isCopy_ = YES;
    } else {
        // ۤ
        [self drawGuideLine];
        [super dropper];
        [self drawGuideLine];
    }

    return;
}


//
// ܥ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    isCopy_ : ʣ̻(instance ѿ)
//
-(void)rightMouseUp:(NSEvent *)evt
{
    // ʣ̻
    self->isCopy_ = NO;

    return;
}


//
// 
//
//  Call
//    evt     : ٥
//    isDrag_ : ɥå椫(instance ѿ)
//    shape_  : ϰϷ(instance ѿ)
//
//  Return
//    prevRect_ : ưζ(instance ѿ)
//
-(void)keyDown:(NSEvent *)evt
{
    PoCoView *view = [self->document_ view];
    PoCoPoint *p;
    PoCoPoint *cp;
    int gap;

    if (self->isDrag_) {
        // ɥåϲ⤷ʤ
        ;
    } else if (self->shape_ != nil) {
        if ([evt keyCode] == kVK_Delete) {
            // 
            [self delete];
        } else {
            // ư
            if (([evt modifierFlags] & NSAlternateKeyMask) != 0x00) {
                gap = 1;
            } else {
                gap = MAX(1, [[self->document_ view] handleRectGap]);
            }
            if (([evt modifierFlags] & NSShiftKeyMask) != 0x00) {
                gap *= 5;
            }
            cp = [[self->shape_ originalHandle:PoCoHandleType_center] lefttop];
            p = [[PoCoPoint alloc] initX:[cp x]
                                   initY:[cp y]];
            switch ([evt keyCode]) {
                case kVK_UpArrow:
                    // 
                    [p moveY:-(gap)];
                    break;
                case kVK_RightArrow:
                    // 
                    [p moveX:gap];
                    break;
                case kVK_DownArrow:
                    // 
                    [p moveY:gap];
                    break;
                case kVK_LeftArrow:
                    // 
                    [p moveX:-(gap)];
                    break;
                default:
                    // ¾ϲ⤷ʤ
                    ;
                    break;
            }
            if (!([cp isEqualPos:p])) {
                // ϥɥȽ(-HANDLE_GAP: ͶȤʤΤǤä)
                if ([self->shape_ startTrans:cp
                                   handleGap:-(HANDLE_GAP << 1)
                                   withShape:NO]) {
                    // ɥ饤õ
                    [self drawGuideLine];

                    // ζȤ򹹿
                    [self->prevRect_ release];
                    self->prevRect_ = [PoCoDrawSelection expandForHalfOpen:[[PoCoRect alloc] initPoCoRect:[self->shape_ resultRect]]];

                    // ̤ʣ
                    [self->shape_ copyResultToOriginal];
                    [self->shape_ setImage:[[self->shape_ resultImage] copy]];

                    // Խ(ñȯʤΤǼäǤϤʤ)
                    [super beginUndo:NO];   // ä
                    [self->shape_ runningTrans:p
                                     withEvent:nil
                             isLiveUpdateShape:NO
                            isLiveUpdateResult:NO];
                    [self->shape_ endTrans];
                    [self exec:edit_key_move
                        isCopy:(([evt modifierFlags] & NSControlKeyMask) != 0x00)];
                    [super endUndo:NO];     // äλ

                    // ϰϹ
                    [self updateSelectionRect:[self->shape_ resultRect]];

                    // pointer 
                    [[view window] invalidateCursorRectsForView:view];

                    // ɥ饤ɽ
                    [self drawGuideLine];
                }
            }
            [p release];
        }
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ٥
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // Ȥꤢޤ⤷ʤ
    ;

    return;
}


//
// ޥư
//
//  Call
//    evt       : ٥
//    document_ : Խо( instance ѿ)
//    shape_    : ϰϷ(instance ѿ)
//    modify_   : (instance ѿ)
//
//  Return
//    modify_ : (instance ѿ)
//
-(void)mouseMove:(NSEvent *)evt
{
    PoCoView *view = [self->document_ view];

    if (self->shape_ != nil) {
        // ξ֤㤦 cursor ѹ
        if (self->modify_ != (unsigned int)([NSEvent modifierFlags])) {
            [[view window] invalidateCursorRectsForView:view];
        }

        // λФ
        self->modify_ = (unsigned int)([NSEvent modifierFlags]);
    }

    return;
}

@end
