//
//	Pelistina on Cocoa - PoCo -
//	2ͥѥ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoMonochromePattern.h"

#import "PoCoLayer.h"

// 
#define CLASS_VERSION 1                 // class ֹ

// ============================================================================
@implementation PoCoMonochromePattern

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    if (self == [PoCoMonochromePattern class]) {
        [self setVersion:CLASS_VERSION];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoMonochromePattern init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->width_ = 0;
        self->height_ = 0;
        self->pattern_ = NULL;
    }

    return self;
}


//
// deallocate
//
//  Call
//    pattern_ : ѥ(instance ѿ)
//
//  Return
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
//
-(void)dealloc
{
    DPRINT((@"[PoCoMonochromePattern dealloc]\n"));

    // 񸻤β
    if (self->pattern_ != NULL) {
        free(self->pattern_);
    }
    self->pattern_ = NULL;
    self->width_ = 0;
    self->height_ = 0;

    // super class β
    [super dealloc];

    return;
}


//
// μ
//
//  Call
//    width_ : (dot ñ)(instance ѿ)
//
//  Return
//    function : 
//
-(unsigned int)width
{
    return self->width_;
}


//
// ⤵μ
//
//  Call
//    height_ : ⤵(dot ñ)(instance ѿ)
//
//  Return
//    function : ⤵
//
-(unsigned int)height
{
    return self->height_;
}


//
// ѥμ
//
//  Call
//    pattern_ : ѥ(instance ѿ)
//
//  Return
//    function : ѥ
//
-(const unsigned char *)pattern
{
    return self->pattern_;
}


//
// 
//
//  Call
//    pat      : ѥμ(NULL ʤʤ)
//    w        : μ(NULL ʤʤ)
//    h        : ⤵μ(NULL ʤʤ)
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
//  Return
//    function : ѥ
//    w        : 
//    h        : ⤵
//
-(void)getPattern:(const unsigned char **)pat
         getWidth:(unsigned int *)w
        getHeight:(unsigned int *)h
{
    if (pat != NULL) {
        *(pat) = self->pattern_;
    }
    if (w != NULL) {
        *(w) = self->width_;
    }
    if (h != NULL) {
        *(h) = self->height_;
    }

    return;
}


//
// ()
//  Ƥʣ(ƤӽФ˻Ѥ pat ϲƤ褤)
//
//  Call
//    pat : ꤹ
//    w   : ꤹƤ(dot ñ)
//    h   : ꤹƤι⤵(dot ñ)
//
//  Return
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
-(void)setPattern:(const unsigned char *)pat
            width:(unsigned int)w
           height:(unsigned int)h
{
    unsigned char *buf;
    const size_t size = ((w + (w & 1)) * h);

    if (size > 0) {
        buf = (unsigned char *)(malloc(size));
        if (buf == NULL) {
            DPRINT((@"memory allocation error.\n"));
        } else {
            // buffer ˰öʣ
            memcpy(buf, pat, size);

            // Ƥ
            if (self->pattern_ != NULL) {
                free(self->pattern_);
            }
            self->pattern_ = NULL;

            // buffer ί᤿Ƥǹ
            self->pattern_ = buf;
            self->width_ = w;
            self->height_ = h;
        }
    }

    return;
}


//
// ɽѲμ
//  ˼Τ
//
//  Call
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
//  Return
//    function : 
//
-(NSBitmapImageRep *)getImage
{
    NSBitmapImageRep *img;
    unsigned int x;
    unsigned int y;
    unsigned int si;
    unsigned int di;
    unsigned int imgRow;
    unsigned int patRow;
    unsigned char *plane;

    img = nil;

    // ž
    img = [[NSBitmapImageRep alloc]
              initWithBitmapDataPlanes:NULL
                            pixelsWide:self->width_
                            pixelsHigh:self->height_
                         bitsPerSample:8
                       samplesPerPixel:3
                              hasAlpha:NO
                              isPlanar:NO
                        colorSpaceName:NSCalibratedRGBColorSpace
                           bytesPerRow:0
                          bitsPerPixel:0];
    if (img == nil) {
        DPRINT((@"can't alloc NSBitmapImageRep\n"));
        goto EXIT;
    }

    // row bytes 
    imgRow = (int)([img bytesPerRow]);
    patRow = (self->width_ + (self->width_ & 1));

    // 
    plane = [img bitmapData];
    for (y = 0; y < self->height_; (y)++) {
        si = ((self->height_ - y - 1) * patRow);
        di = (y * imgRow);
        for (x = 0; x < self->width_; (x)++, (si)++, di += 3) {
            memset(&(plane[di]), (self->pattern_[si] == 0) ? 0x00 : 0xff, 3);
        }
    }

EXIT:
    return img;
}


//
// ѥμ
//
//  Call
//    r        : ΰ
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
//  Return
//    function : pixelmap
//
-(PoCoBitmap *)getPixelmap:(PoCoRect *)r
{
    PoCoBitmap *bmp;
    unsigned int sx;
    unsigned int sy;
    unsigned int dx;
    unsigned int dy;
    unsigned int si;
    unsigned int di;
    unsigned int startX;
    unsigned int startY;
    unsigned int row;
    unsigned int bitmapRow;
    unsigned char *bitmap;
    const unsigned int bitmapWidth = [r width];
    const unsigned int bitmapHeight = [r height];

    bmp = nil;

    // λ
    startX = (([r left] < 0) ? 0 : ([r left] % self->width_));
    startY = (([r  top] < 0) ? 0 : ([r  top] % self->height_));

    // PoCoBitmap 
    bmp = [[PoCoBitmap alloc] initWidth:bitmapWidth
                             initHeight:bitmapHeight
                           defaultColor:0];
    if (bmp == nil) {
        DPRINT((@"can't alloc PoCoBitmap\n"));
        goto EXIT;
    }

    // 
    bitmap = [bmp pixelmap];
    row = (self->width_ + (self->width_ & 1));
    bitmapRow = (bitmapWidth + (bitmapWidth & 1));
    for (dy = 0, sy = startY; dy < bitmapHeight; (dy)++) {
        si = ((sy * row) + startX);
        di = (dy * bitmapRow);
        for (dx = 0, sx = startX; dx < bitmapWidth; (dx)++) {
            bitmap[di] = self->pattern_[si];
            (di)++;
            (sx)++;
            (si)++;
            if (sx >= self->width_) {
                sx = 0;
                si = (sy * row);
            }
        }
        (sy)++;
        if (sy >= self->height_) {
            sy = 0;
        }
    }

EXIT:
    return bmp;
}


// -------------------------------------------- instance - public - file 
//
// ɤ߹
//
//  Call
//    coder : coder(api ѿ)
//
//  Return
//    function : 
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
-(id)initWithCoder:(NSCoder *)coder
{
#if 0   // Сֹä˰ռʤ
    int ver;
#endif  // 0
    NSUInteger len;
    size_t  size;

//    DPRINT((@"[PoCoMonochromePattern initWithCoder]\n"));

    // super class ν
    self = [super init];

    // Ȥν(ɤ߹ߡ
    if (self != nil) {
        self->width_ = 0;
        self->height_ = 0;
        self->pattern_ = NULL;

#if 0   // Сֹä˰ռʤ
        // ֹμ
        ver = [coder versionForClassName:@"PoCoMonochromePattern"];
//        DPRINT((@"PoCoMonochromePattern version : %d\n", ver));
#endif  // 0
        
        // 礭μ
        [coder decodeValueOfObjCType:@encode(unsigned int) at:&(self->width_)];
        [coder decodeValueOfObjCType:@encode(unsigned int) at:&(self->height_)];

        size = ((self->width_ + (self->width_ & 1)) * self->height_);
        self->pattern_ = (unsigned char *)(malloc(size));
        if (self->pattern_ == NULL) {
            DPRINT((@"memory allocation error.\n"));
            [self release];
            self = nil;
        } else {
            memcpy(self->pattern_, [coder decodeBytesWithReturnedLength:&(len)], size);
        }
    }

    return self;
}


//
// ¸
//
//  Call
//    coder    : coder(api ѿ)
//    width_   : (dot ñ)(instance ѿ)
//    height_  : ⤵(dot ñ)(instance ѿ)
//    pattern_ : ѥ(instance ѿ)
//
//  Return
//    None
//
-(void)encodeWithCoder:(NSCoder *)coder
{
    const size_t  size = ((self->width_ + (self->width_ & 1)) * self->height_);

//    DPRINT((@"[PoCoMonochromePattern encodeWithCoder]\n"));

    // 礭¸
    [coder encodeValueOfObjCType:@encode(unsigned int) at:&(self->width_)];
    [coder encodeValueOfObjCType:@encode(unsigned int) at:&(self->height_)];

    // ѥ¸
    [coder encodeBytes:self->pattern_ length:size];

    return;
}

@end




// ============================================================================
@implementation PoCoMonochromePatternContainerBase

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    // ⤷ʤ
    ;

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//
-(id)init
{
    return [super init];
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    [super dealloc];

    return;
}


//
// 
//  ǤϾ nil ֤
//
//  Call
//    index : ֹ
//
//  Return
//    function : ѥ
//
-(PoCoMonochromePattern *)pattern:(int)index
{
    return nil;
}


//
// 
//
//  Call
//    pat   : 
//    index : ֹ
//
//  Return
//    None
//
-(void)setPattern:(PoCoMonochromePattern *)pat
          atIndex:(int)index
{
    // ⤷ʤ
    ;

    return;
}

@end
