//
//	Pelistina on Cocoa - PoCo -
//	ڥ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoPenStyle.h"

#import "PoCoPenStyleDefault.h"

// ѿ
static NSString *PATTERN_NAME = @"PoCoPenStyleData_%d";

// ؿץȥ
static void  setPattern(PoCoMonochromePattern *pat, int i);

// ------------------------------------------------------------------- ؿ
//
// ͤ
//
//  Call
//    pat : ѥ
//    i   : ǥå
//
//  Return
//    pat : ѥ
//
static void  setPattern(PoCoMonochromePattern *pat, int i)
{
    [pat setPattern:(const unsigned char *)(&(PoCoPenStyleDefault[i]))
              width:PEN_STYLE_SIZE
             height:PEN_STYLE_SIZE];

    return;
}




// ============================================================================
@implementation PoCoPenStyle

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    PoCoPenStyleDefault[] : (ѿ)
//
//  Return
//    None
//
+(void)initialize
{
    int l;
    NSMutableDictionary *dic;
    PoCoMonochromePattern *pat;

    DPRINT((@"[PoCoPenStyle initialize]\n"));

    dic = [NSMutableDictionary dictionary];

    // ڥͤ缡
    for (l = 0; l < PEN_STYLE_NUM; (l)++) {
        pat = [[PoCoMonochromePattern alloc] init];
        setPattern(pat, l);
        [dic setObject:[NSArchiver archivedDataWithRootObject:pat]
                forKey:[NSString stringWithFormat:PATTERN_NAME, l]];
        [pat release];
    }

    // default 
    [[NSUserDefaults standardUserDefaults] registerDefaults:dic];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function   : 
//    pattern_[] : ڥ(instance ѿ)
//
-(id)init
{
    int l;
    NSUserDefaults *def;

    DPRINT((@"[PoCoPenStyle init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        for (l = 0; l < PEN_STYLE_NUM; (l)++) {
            self->pattern_[l] = nil;
        }

        // ڥɤ߹
        def = [NSUserDefaults standardUserDefaults];
        for (l = 0; l < PEN_STYLE_NUM; (l)++) {
            self->pattern_[l] = [NSUnarchiver unarchiveObjectWithData:[def objectForKey:[NSString stringWithFormat:PATTERN_NAME, l]]];
            if (self->pattern_[l] == nil) {
                DPRINT((@"can't create penstyle : %d\n", l));
                [self release];
                self = nil;
                break;
            }
            [self->pattern_[l] retain];
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pattern_[] : ڥ(instance ѿ)
//
-(void)dealloc
{
    int l;

    // 񸻤β
    for (l = 0; l < PEN_STYLE_NUM; (l)++) {
        [self->pattern_[l] release];
        self->pattern_[l] = nil;
    }

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    index      : ֹ
//    pattern_[] : ڥ(instance ѿ)
//
//  Return
//    function : ڥ
//
-(PoCoMonochromePattern *)pattern:(int)index
{
    PoCoMonochromePattern *pat;

    if ((index < 0) || (index >= PEN_STYLE_NUM)) {
        pat = nil;
    } else {
        pat = self->pattern_[index];
    }

    return pat;
}


//
// 
//
//  Call
//    pat   : ѥ
//    index : ֹ
//
//  Return
//    pattern_[] : ڥ(instance ѿ)
//
-(void)setPattern:(PoCoMonochromePattern *)pat
          atIndex:(int)index
{
    if ((index < 0) || (index >= PEN_STYLE_NUM)) {
        ;
    } else {
        [self->pattern_[index] setPattern:[pat pattern]
                                    width:[pat width]
                                   height:[pat height]];

        // 򹹿
        [[NSUserDefaults standardUserDefaults]
            setObject:[NSArchiver archivedDataWithRootObject:self->pattern_[index]]
               forKey:[NSString stringWithFormat:PATTERN_NAME, index]];
    }

    return;
}

@end




// ============================================================================
@implementation PoCoPenSteadyStyle

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    // ⤷ʤ
    ;

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    PoCoPenStyleDefault[] : (ѿ)
//
//  Return
//    function  : 
//    pattern_[] : ڥ(instance ѿ)
//
-(id)init
{
    int l;

    DPRINT((@"[PoCoPenSteadyStyle init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        for (l = 0; l < PEN_STYLE_NUM; (l)++) {
            self->pattern_[l] = nil;
        }

        // ڥɤ߹
        for (l = 0; l < PEN_STYLE_NUM; (l)++) {
            self->pattern_[l] = [[PoCoMonochromePattern alloc] init];
            setPattern(self->pattern_[l], l);
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pattern_[] : ڥ(instance ѿ)
//
-(void)dealloc
{
    int l;

    // 񸻤β
    for (l = 0; l < PEN_STYLE_NUM; (l)++) {
        [self->pattern_[l] release];
        self->pattern_[l] = nil;
    }

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    index      : ֹ
//    pattern_[] : ڥ(instance ѿ)
//
//  Return
//    function : ڥ
//
-(PoCoMonochromePattern *)pattern:(int)index
{
    PoCoMonochromePattern *pat;

    if ((index < 0) || (index >= PEN_STYLE_NUM)) {
        pat = nil;
    } else {
        pat = self->pattern_[index];
    }

    return pat;
}


//
// 
//
//  Call
//    pat   : ѥ
//    index : ֹ
//
//  Return
//    None
//
-(void)setPattern:(PoCoMonochromePattern *)pat
          atIndex:(int)index
{
    // ⤷ʤ
    ;

    return;
}

@end
