//
//	Pelistina on Cocoa - PoCo -
//	ưǡоݿΰ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoAutoGradationColorView.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

#import "PoCoAutoGradationPanel.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoAutoGradationColorView

// --------------------------------------------------------- instance - private
//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frameRect : ΰ(api ѿ)
//     
//  Return
//    function  : 
//    isOn_[]   : (instance ѿ)
//    setValue_ : (instance ѿ)
//    docCntl_  : document controller(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect;
{
    int l;

    DPRINT((@"[PoCoAutoGrdationColorView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        for (l = 0; l < COLOR_MAX; l++) {
            self->isOn_[l] = NO;
        }
        self->setValue_ = NO;

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_ : document controller(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoAutoGrdationColorView dealloc]\n"));

    // 񸻤
    [self->docCntl_ release];
    self->docCntl_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ɽ׵
//
//  Call
//    rect    : ɽΰ(api ѿ)
//    isOn_[] : (instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int l;

    DPRINT((@"[PoCoAutoGrdationColorView drawRect]\n"));

    for (l = 0; l < COLOR_MAX; (l)++) {
        if (NSIntersectsRect(rect, [self numToRect:l])) {
            [self drawColor:l
                   isSelect:self->isOn_[l]];
        }
    }

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return  
//    function : YES
// 
-(BOOL)isFlipped
{
    return YES;
}


//
// (٤)
//
//  Call
//    isOn_[] : (instance ѿ)
//
//  Return
//    function : 
//
-(const BOOL *)matrix
{
    return (const BOOL *)(&(self->isOn_[0]));
}


//
// ()
//
//  Call
//    index   : о
//    isOn_[] : (instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)attribute:(int)index
{
    return self->isOn_[index];
}


//
// 
//
//  Call
//    on    : 
//    index : о
//
//  Return
//    isOn_[] : (instance ѿ)
//
-(void)setAttribute:(BOOL)on
            atIndex:(int)index
{
    self->isOn_[index] = on;

    return;
}


//
// 1ʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : ɽ
//               NO  : ɽ
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        isSelect:(BOOL)sel
{
    NSRect  r;
    const PoCoPalette *plt = [[[self->docCntl_ currentDocument] picture] palette];
    const PoCoColor *col = [plt palette:num];

    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            [[NSColor whiteColor] set];
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            [[NSColor blackColor] set];
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


//
// Ϣ³򸡾
//
//  Call
//    isOn_[] : (instance ѿ)
//
//  Return
//    function : Ƚ
//
-(BOOL)verifyContinuous
{
    BOOL result;
    BOOL noAttach;
    BOOL isStart;
    int l;

    result = YES;
    noAttach = YES;
    isStart = NO;

    if ([self verifySelectExist]) {
        // Ƭ֤˷꤬ʤ򸡾
        for (l = 0; l < COLOR_MAX; (l)++) {
            if (noAttach) {
                // ̤ã(ƬõƤ)
                if (self->isOn_[l]) {
                    // Ƭã
                    noAttach = NO;
                    isStart = YES;
                }
            } else if (isStart) {
                // ƬˤãƤ(õƤ)
                if (self->isOn_[l]) {
                    // Ϣ³Ƥ
                    ;
                } else {
                    // ã(Ϥ)
                    noAttach = NO;
                    isStart = NO;
                }
            } else {
                // ˤãƤ(Ϥ)(õƤ)
                if (self->isOn_[l]) {
                    // ˤʤäƤΤϢ³Ƥʤ
                    result = NO;
                    break;
                }
            }
        }
    } else {
        // ⤽2İʾ򤷤Ƥʤ
        result = NO;
    }

    return result;
}


//
// ̵ͭ򸡾
//  2İʾʤеȤ
//
//  Call
//    isOn_[] : (instance ѿ)
//
//  Return
//    function : Ƚ
//
-(BOOL)verifySelectExist
{
    int num;
    int l;

    num = 0;

    // Ƭ֤˷꤬ʤ򸡾
    for (l = 0; l < COLOR_MAX; (l)++) {
        // 򤷤ƤΤ夲
        if (self->isOn_[l]) {
            (num)++;
        }
    }

    return (num >= 2);
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt     : ȯ٥(api ѿ)
//    isOn_[] : (instance ѿ)
//
//  Return
//    setValue_ : (instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    int num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = ((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX);

        // ͤȽ
        self->setValue_ = ((self->isOn_[num]) ? NO : YES);

        // ɥåƱˤ
        [self mouseDragged:evt];
    }

    return;
}


//
// ɥå
//
//  Call
//    evt       : ȯ٥(api ѿ)
//    setValue_ : (instance ѿ)
//
//  Return
//    isOn_[] : (instance ѿ)
//
-(void)mouseDragged:(NSEvent *)evt
{
    int num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = ((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX);

        // ͤȿ
        if (self->setValue_ != self->isOn_[num]) {
            self->isOn_[num] = self->setValue_;

            // 
            [self setNeedsDisplayInRect:[self numToRect:num]];

            // ɾ(panel ¦ꤲ)
            [[[self window] windowController] verifySetting];
        }
    }

    return;
}

@end
