//
//	Pelistina on Cocoa - PoCo -
//	ưǡѥͥ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoAutoGradationPanel.h"

#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoLayer.h"
#import "PoCoPalette.h"
#import "PoCoAutoGradationColorView.h"
#import "PoCoAutoGradationSizePairOperate.h"

// ѿ
static NSString *DEFAULT_ADJACENT = @"PoCoAutoGradationDefaultAdjacent";
static NSString *DEFAULT_AUTO = @"PoCoAutoGradationDefaultAuto";

// ======================================== PoCoAutoGradationAdjacentInitialize

// ------------------------------------------------------------------ interface
@interface PoCoAutoGradationAdjacentInitialize : NSObject
{
    // ʪ
    NSMutableDictionary *pair_;

    // 
    const BOOL *matrix_;
    PoCoBitmap *image_;
    PoCoBitmap *shape_;
    int size_;

    // ־
    int beginIndex_;                    // ֹ([beginIndex_, endIndex_])
    int endIndex_;                      // ֹ([beginIndex_, endIndex_])
    unsigned int counts_[COLOR_MAX];    // ȤθĿ
    unsigned int full_;                 // ɥåȿ
    int maxIndex_;                      // Ŀοֹ
}

// initialize
-(id)initWithDictionary:(NSMutableDictionary *)dict
             withMatrix:(const BOOL *)matrix
              withImage:(PoCoBitmap *)image
              withShape:(PoCoBitmap *)shape
            defaultSize:(int)size;

// deallocate
-(void)dealloc;

// ¹
-(void)createFlatState;
-(void)countupColor;
-(void)distributeSizeForForward;
-(void)distributeSizeForBackword;

@end


// ------------------------------------------------------------- implementation
@implementation PoCoAutoGradationAdjacentInitialize

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    dict   : 礭з
//    matrix : оݿ(256 )
//    image  : оݲ
//    shape  : 
//    size   : (1-16)
//
//  Return
//    function    : 
//    pair_       : 礭з(instance ѿ)
//    matrix_     : оݿ(256 )(instance ѿ)
//    image_      : оݲ(instance ѿ)
//    shape_      : (instance ѿ)
//    size_       : (1-16)(instance ѿ)
//    beginIndex_ : ֹ([beginIndex_, endIndex_])(instance ѿ)
//    endIndex_   : ֹ([beginIndex_, endIndex_])(instance ѿ)
//    counts_     : ȤθĿ(instance ѿ)
//    full_       : ɥåȿ(instance ѿ)
//    maxIndex_   : Ŀοֹ(instance ѿ)
//
-(id)initWithDictionary:(NSMutableDictionary *)dict
             withMatrix:(const BOOL *)matrix
              withImage:(PoCoBitmap *)image
              withShape:(PoCoBitmap *)shape
            defaultSize:(int)size
{
    // super class ز
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->pair_ = dict;
        self->matrix_ = matrix;
        self->image_ = image;
        self->shape_ = shape;
        self->size_ = size;
        self->beginIndex_ = -1;
        self->endIndex_ = -1;
        memset(self->counts_, 0x00, (COLOR_MAX * sizeof(unsigned int)));
        self->maxIndex_ = -1;
        [self->pair_ retain];
        [self->image_ retain];
        [self->shape_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pair_  : 礭з(instance ѿ)
//    image_ : оݲ(instance ѿ)
//    shape_ : (instance ѿ)
//
-(void)dealloc
{
    // 񸻤
    [self->pair_ release];
    [self->image_ release];
    [self->shape_ release];
    self->pair_ = nil;
    self->image_ = nil;
    self->shape_ = nil;

    // super class ز
    [super dealloc];

    return;
}


// ------------------------------------------------------------ instance - ¹
//
// Ѱ֤
//  ٤ƤФ̾Ͽ(θν̾Τ䤤碌뤳)
//  оݿοϰϤФԤ
//
//  Call
//    matrix_ : оݿ(256 )(instance ѿ)
//    size_   : (1-16)(instance ѿ)
//
//  Return
//    pair_       : 礭з(instance ѿ)
//    beginIndex_ : ֹ([beginIndex_, endIndex_])(instance ѿ)
//    endIndex_   : ֹ([beginIndex_, endIndex_])(instance ѿ)
//
-(void)createFlatState
{
    int idx;
    PoCoGradationPairInfo *tmp;

    // ϰϤõ
    for (idx = 0; idx < COLOR_MAX; (idx)++) {
        if (self->matrix_[idx]) {
            // ǽãΤʤȤƵ
            if (self->beginIndex_ < 0) {
                self->beginIndex_ = idx;
            }
        } else {
            // ֤оݳʤ齪ȤƵ
            if (self->beginIndex_ >= 0) {
                self->endIndex_ = (idx - 1);
                break;
            }
        }
    }

    // ʤϺǸޤǤоϰϤä
    if ((self->beginIndex_ >= 0) && (self->endIndex_ < 0)) {
        self->endIndex_ = COLOR_MAX;
    }

    // ̷⤹̤ʤ̵
    if (self->endIndex_ <= self->beginIndex_) {
        goto EXIT;
    }

    // ٤ƱλФ
    for (idx = self->beginIndex_; idx < self->endIndex_; (idx)++) {
        // 
        tmp = [[PoCoGradationPairInfo alloc] initWithFirst:(unsigned int)(idx)
                                                withSecond:(unsigned int)(idx + 1)
                                                  withSize:(self->size_ * 8)];
        [self->pair_ setValue:tmp
                       forKey:[tmp name]];
        [tmp release];

        // 
        tmp = [[PoCoGradationPairInfo alloc] initWithFirst:(unsigned int)(idx + 1)
                                                withSecond:(unsigned int)(idx)
                                                  withSize:(self->size_ * 8)];
        [self->pair_ setValue:tmp
                       forKey:[tmp name]];
        [tmp release];
    }

EXIT:
    return;
}


//
// ɥåȿο夲
//
//  Call
//    matrix_ : оݿ(256 )(instance ѿ)
//    image_  : оݲ(instance ѿ)
//    shape_  : (instance ѿ)
//
//  Return
//    counts_   : ȤθĿ(instance ѿ)
//    full_     : ɥåȿ(instance ѿ)
//    maxIndex_ : Ŀοֹ(instance ѿ)
//
-(void)countupColor
{
    int w;
    int h;
    unsigned char *ibmp;
    unsigned char *sbmp;
    int skip;

    ibmp = [self->image_ pixelmap];
    sbmp = [self->shape_ pixelmap];
    skip = ([self->image_ width] & 0x01);
    h = [self->image_ height];
    do {
        w = [self->image_ width];
        do {
            if (*(sbmp) != 0) {
                // Τޤ޷׾
                (self->full_)++;
                if (self->matrix_[*(ibmp)]) {
                    // оݿΤоݤȤ
                    (self->counts_[*(ibmp)])++;

                    // ĿΤΤ򹹿
                    if ((self->maxIndex_ < 0) ||
                        (self->counts_[self->maxIndex_] < self->counts_[*(ibmp)])) {
                        self->maxIndex_ = *(ibmp);
                    }
                }
            }

            // 
            (w)--;
            (ibmp)++;
            (sbmp)++;
        } while (w != 0);

        // 
        (h)--;
        ibmp += skip;
        sbmp += skip;
    } while (h != 0);

    return;
}


//
// οʬ
//  ɥåȿ˱꿶
//   (ǤΥ 1-128 ϰϤȤʤ)
//
//  Call
//    pair_       : 礭з(instance ѿ)
//    size_       : (1-16)(instance ѿ)
//    beginIndex_ : ֹ([beginIndex_, endIndex_])(instance ѿ)
//    endIndex_   : ֹ([beginIndex_, endIndex_])(instance ѿ)
//    counts_     : ȤθĿ(instance ѿ)
//    full_       : ɥåȿ(instance ѿ)
//    maxIndex_   : Ŀοֹ(instance ѿ)
//
//  Return
//    pair_ : 礭з(instance ѿ)
//
-(void)distributeSizeForForward
{
    int idx;
    PoCoGradationPairInfo *info;

    if (self->size_ > 4) {
        for (idx = self->beginIndex_; idx < self->endIndex_; (idx)++) {
            info = [self->pair_ objectForKey:[PoCoGradationPairInfo pairString:(unsigned int)(idx)
                                                                    withSecond:(unsigned int)(idx + 1)]];
            [info setSize:(8 * MAX(4, (unsigned int)(self->size_ * ((float)(self->counts_[idx + 1]) / (float)(self->counts_[self->maxIndex_])))))];
        }
    }

    return;
}


//
// οʬ
//  ɥåȿ˱꿶
//   (ǤΥ 1-128 ϰϤȤʤ)
//
//  Call
//    pair_       : 礭з(instance ѿ)
//    size_       : (1-16)(instance ѿ)
//    beginIndex_ : ֹ([beginIndex_, endIndex_])(instance ѿ)
//    endIndex_   : ֹ([beginIndex_, endIndex_])(instance ѿ)
//    counts_     : ȤθĿ(instance ѿ)
//    full_       : ɥåȿ(instance ѿ)
//    maxIndex_   : Ŀοֹ(instance ѿ)
//
//  Return
//    pair_ : 礭з(instance ѿ)
//
-(void)distributeSizeForBackword
{
    int idx;
    PoCoGradationPairInfo *info;

    if (self->size_ > 4) {
        for (idx = self->endIndex_; idx > self->beginIndex_; (idx)--) {
            info = [self->pair_ objectForKey:[PoCoGradationPairInfo pairString:(unsigned int)(idx)
                                                                    withSecond:(unsigned int)(idx - 1)]];
            [info setSize:(8 * MAX(4, (unsigned int)(self->size_ * ((float)(self->counts_[idx - 1]) / (float)(self->counts_[self->maxIndex_])))))];
        }
    }

    return;
}

@end




// ============================================================================
@implementation PoCoAutoGradationPanel

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    NSMutableDictionary *dic;
  
    dic = [NSMutableDictionary dictionary];

    // ƽͤ
    [dic setObject:[NSNumber numberWithBool:YES]
            forKey:DEFAULT_ADJACENT];
    [dic setObject:[NSNumber numberWithInt:0]
            forKey:DEFAULT_AUTO];

    // default 
    [[NSUserDefaults standardUserDefaults] registerDefaults:dic];

    return;
}


// --------------------------------------------------------- instance - private
//
// 礭зνͤ
//  ͤܤΩƤ(verify ˹ʤΤ)
//
//  Call
//    selectView_ : ΰ(outlet)
//    sizeSlider_ : (ư)(outlet)
//    image_      : оݲ(instance ѿ)
//    shape_      : (instance ѿ)
//
//  Return
//    sizePair_ : 礭з(instance ѿ)
//
-(void)createSizePair
{
    PoCoAutoGradationAdjacentInitialize *work;

    work = nil;

    // Τ̵ˤΤ߽ͤ
    if (self->sizePair_ != nil) {
        goto EXIT;
    }

    // ǽ϶Ѱ礭Ͽ
    self->sizePair_ = [[NSMutableDictionary alloc] init];
    work = [[PoCoAutoGradationAdjacentInitialize alloc] initWithDictionary:self->sizePair_
                                                                withMatrix:[self->selectView_ matrix]
                                                                 withImage:self->image_
                                                                 withShape:self->shape_
                                                               defaultSize:[self->sizeSlider_ intValue]];
    [work createFlatState];

    // оΰγƿȤΥɥåȿ夲
    [work countupColor];

    // ɥåȿ˱ƾ礭ʬ
    [work distributeSizeForForward];

    // Ʊ礭ʬ
    [work distributeSizeForBackword];

EXIT:
    [work release];
    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc   : Խо
//    info  : Խ
//    image : оݲ
//    shape : 
//
//  Return
//    function  : 
//    document_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//    image_    : оݲ(instance ѿ)
//    shape_    : (instance ѿ)
//    isOk_     : ¹Ԥ뤫(instance ѿ)
//    sizePair_ : 礭з(instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
    withEditInfo:(PoCoEditInfo *)info
       withImage:(PoCoBitmap *)image
       withShape:(PoCoBitmap *)shape
{
    DPRINT((@"[PoCoAutoGradationPanel initWithDoc:]\n"));

    // super class ν
    self = [super initWithWindowNibName:@"PoCoAutoGradationPanel"];

    // Ȥν
    if (self != nil) {
        self->isOk_ = NO;
        self->document_ = doc;
        self->editInfo_ = info;
        self->image_ = image;
        self->shape_ = shape;
        self->sizePair_ = nil;
        [self->document_ retain];
        [self->editInfo_ retain];
        [self->image_ retain];
        [self->shape_ retain];
    }

    return self;

}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    document_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//    image_    : оݲ(instance ѿ)
//    shape_    : (instance ѿ)
//    sizePair_ : 礭з(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoAutoGradationPanel dealloc]\n"));

    // 񸻤β
    [self->document_ release];
    [self->editInfo_ release];
    [self->image_ release];
    [self->shape_ release];
    [self->sizePair_ release];
    self->document_ = nil;
    self->editInfo_ = nil;
    self->image_ = nil;
    self->shape_ = nil;
    self->sizePair_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    editInfo_ : Խ(instance ѿ)
//
//  Return
//    selectView_ : ΰ(outlet)
//    adjacent_   : (outlet)
//    manual_     : ư(outlet)
//    auto_       : ư(outlet)
//    pair_       : Ф(outlet)
//    sizeSlider_ : (ư)(outlet)
//    sizeDetail_ : ܺ(Ф)(outlet)
//
-(void)startWindow
{
    // 
    [self->sizeSlider_ setIntValue:[self->editInfo_ penSize]];

    // 
    [self->adjacent_ setState:[[NSUserDefaults standardUserDefaults] boolForKey:DEFAULT_ADJACENT]];

    // оݿϽ᤹ͤμǽ
    [self defaultSelect:nil];

    // λ
    switch ([[NSUserDefaults standardUserDefaults] integerForKey:DEFAULT_AUTO]) {
        case 2:
            // Ф
            if (([[NSUserDefaults standardUserDefaults] boolForKey:DEFAULT_ADJACENT]) && ([self->selectView_ verifyContinuous])) {
                [self->manual_ setState:0];
                [self->auto_ setState:0];
                [self->pair_ setState:1];
                [self->sizeSlider_ setEnabled:YES];
                [self->sizeDetail_ setEnabled:YES];

                // ͤ
                [self createSizePair];
                break;
            }
            ;   // ̲
        default:
        case 0:
            // ư
            [self->manual_ setState:1];
            [self->auto_ setState:0];
            [self->pair_ setState:0];
            [self->sizeSlider_ setEnabled:YES];
            [self->sizeDetail_ setEnabled:NO];
            break;
        case 1:
            // ư
            [self->manual_ setState:0];
            [self->auto_ setState:1];
            [self->pair_ setState:0];
            [self->sizeSlider_ setEnabled:NO];
            [self->sizeDetail_ setEnabled:NO];
            break;
    }

    // modal session 
    [NSApp runModalForWindow:[self window]];

    return;
}


//
// ɾ
//
//  Call
//    selectView_ : ΰ(outlet)
//    adjacent_   : (outlet)
//
//  Return
//    exec_       : ¹(outlet)
//    pair_       : Ф(outlet)
//    sizeDetail_ : ܺ(Ф)(outlet)
//
-(void)verifySetting
{
    if ([self->adjacent_ state] != 0) {
        // ܤξϼ¹ԤβݤФȤλβݤڤؤ
        if ([self->selectView_ verifyContinuous]) {
            [self->exec_ setEnabled:YES];
            [self->pair_ setEnabled:YES];
        } else {
            [self->exec_ setEnabled:NO];
            [self->pair_ setEnabled:NO];
        }
    } else {
        // ܤǤϤʤϼ¹ԤβݤΤ
        if ([self->selectView_ verifySelectExist]) {
            [self->exec_ setEnabled:YES];
        } else {
            [self->exec_ setEnabled:NO];
        }

        // ФȤλϤǤʤ
        [self->pair_ setEnabled:NO];
        [self->sizeDetail_ setEnabled:NO];
        if ([self->pair_ state] != 0) {
            [self->manual_ setState:1];
            [self->pair_ setState:0];
        }
    }

    return;
}


// --------------------------------------------------- instance - public - 
//
// ¹Ԥ뤫
//
//  Call
//    isOk_ : ¹Ԥ뤫(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isOk
{
    return self->isOk_;
}


//
// 
//
//  Call
//    auto_       : ư(outlet)
//    sizeSlider_ : (outlet)
//
//  Return
//    function : 
//
-(int)penSize
{
    return (([self->auto_ state] != 0) ? 0 : ([self->sizeSlider_ intValue] * 8));
}


//
// 
//
//  Call
//    adjacent_ : (outlet)
//
//  Return
//    function : 
//
-(BOOL)isAdjacent
{
    return ([self->adjacent_ state] != 0);
}


//
// оݿ
//
//  Call
//    selectView_ : ΰ(outlet)
//
//  Return
//    function : оݿ
//
-(const BOOL *)matrix
{
    return [self->selectView_ matrix];
}


//
// 礭з
//
//  Call
//    pair_     : Ф(outlet)
//    sizePair_ : 礭з(instance ѿ)
//
//  Return
//    function : 
//
-(NSDictionary *)sizePair
{
    return (([self->pair_ state] != 0) ? (NSDictionary *)(self->sizePair_) : nil);
}


// -------------------------------------------- instance - public - IBAction 
//
// 
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)colorSelect:(id)sender
{
    // ɾ
    [self verifySetting];

    return;
}


//
// ᤹ͤ
//
//  Call
//    sender    : о(api ѿ)
//    document_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//    image_    : оݲ(instance ѿ)
//    shape_    : (instance ѿ)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)defaultSelect:(id)sender
{
    int l;
    BOOL flag;
    PoCoColor *col;
    int w;
    int h;
    unsigned char *ibmp;
    unsigned char *sbmp;
    int skip;
    BOOL indeed[COLOR_MAX];

    // оݲƼºݤ˻οΤߤ˸ꤹ
    if ((self->image_ == nil) || (self->shape_ == nil)) {
        memset(indeed, 0x01, (sizeof(BOOL) * COLOR_MAX));
    } else {
        memset(indeed, 0x00, (sizeof(BOOL) * COLOR_MAX));
        ibmp = [self->image_ pixelmap];
        sbmp = [self->shape_ pixelmap];
        skip = ([self->image_ width] & 0x01);
        h = [self->image_ height];
        do {
            w = [self->image_ width];
            do {
                if (*(sbmp) != 0) {
                    indeed[*(ibmp)] = YES;
                }

                // 
                (w)--;
                (ibmp)++;
                (sbmp)++;
            } while (w != 0);

            // 
            (h)--;
            ibmp += skip;
            sbmp += skip;
        } while (h != 0);
    }

    // ۤġ񤭵ĤоݿȤ
#if 0
    for (l = 0; l < COLOR_MAX; (l)++) {
        col = [[[self->document_ picture] palette] palette:l];
        if ([self->adjacent_ state] == 0) {
            // ܤǤʤеۤꡦ񤭤ΤߤȤ
            if (([col noDropper]) || ([col isMask])) {
                flag = NO;
            } else {
                flag = YES;
            }
        } else {
            // ܤξϿǤޤ
            if (([col noDropper]) || ([col isMask])) {
                flag = NO;
            } else if (([col red] == 0) && ([col green] == 0) && ([col blue] == 0)) {
                flag = NO;
            } else {
                flag = YES;
            }
        }
        [self->selectView_ setAttribute:((indeed[l]) ? flag : NO)
                                atIndex:l];
    }
#else   // 0
    for (l = 0; l < COLOR_MAX; (l)++) {
        col = [[[self->document_ picture] palette] palette:l];
        if (([col noDropper]) || ([col isMask])) {
            flag = NO;
        } else if (([col red] == 0) && ([col green] == 0) && ([col blue] == 0)) {
            flag = NO;
        } else {
            flag = YES;
        }
        [self->selectView_ setAttribute:((indeed[l]) ? flag : NO)
                                atIndex:l];
    }
#endif  // 0

    // 
    [self->selectView_ setNeedsDisplay:YES];

    // ɾ
    [self verifySetting];

    return;
}


//
// ȿž
//
//  Call
//    sender      : о(api ѿ)
//    selectView_ : ΰ(outlet)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)reverseSelect:(id)sender
{
    int l;

    // ͤȿž
    for (l = 0; l < COLOR_MAX; (l)++) {
        [self->selectView_ setAttribute:([self->selectView_ attribute:l] ? NO :
YES)
                                atIndex:l];
    }

    // 
    [self->selectView_ setNeedsDisplay:YES];

    // ɾ
    [self verifySetting];

    return;
}


//
// ٤
//
//  Call
//    sender      : о(api ѿ)
//    selectView_ : ΰ(outlet)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)allSelect:(id)sender
{
    int l;

    // ٤ YES ڤؤ
    for (l = 0; l < COLOR_MAX; (l)++) {
        [self->selectView_ setAttribute:YES
                                atIndex:l];
    }

    // 
    [self->selectView_ setNeedsDisplay:YES];

    // ɾ
    [self verifySetting];

    return;
}


//
// ٤
//
//  Call
//    sender      : о(api ѿ)
//    selectView_ : ΰ(outlet)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)allClear:(id)sender
{
    int l;

    // ٤ NO ڤؤ
    for (l = 0; l < COLOR_MAX; (l)++) {
        [self->selectView_ setAttribute:NO
                                atIndex:l];
    }

    // 
    [self->selectView_ setNeedsDisplay:YES];

    // ɾ
    [self verifySetting];

    return;
}


//
// 
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)adjacent:(id)sender
{
    // ɾ
    [self verifySetting];

    return;
}


//
// ư
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    manual_     : ư(outlet)
//    auto_       : ư(outlet)
//    pair_       : Ф(outlet)
//    sizeSlider_ : (outlet)
//    sizeDetail_ : ܺ(Ф)(outlet)
//
-(IBAction)manual:(id)sender
{
#if 0
    [self->manual_ setState:1];
#endif  // 0
    [self->auto_ setState:0];
    [self->pair_ setState:0];
    [self->sizeSlider_ setEnabled:YES];
    [self->sizeDetail_ setEnabled:NO];

    return;
}


//
// ư
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    manual_     : ư(outlet)
//    auto_       : ư(outlet)
//    pair_       : Ф(outlet)
//    sizeSlider_ : (outlet)
//    sizeDetail_ : ܺ(Ф)(outlet)
//
-(IBAction)auto:(id)sender
{
    [self->manual_ setState:0];
#if 0
    [self->auto_ setState:0];
#endif  // 0
    [self->pair_ setState:0];
    [self->sizeSlider_ setEnabled:NO];
    [self->sizeDetail_ setEnabled:NO];

    return;
}


//
// Ф
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    manual_     : ư(outlet)
//    auto_       : ư(outlet)
//    pair_       : Ф(outlet)
//    sizeSlider_ : (outlet)
//    sizeDetail_ : ܺ(Ф)(outlet)
//
-(IBAction)pair:(id)sender
{
    [self->manual_ setState:0];
    [self->auto_ setState:0];
#if 0
    [self->pair_ setState:1];
#endif  // 0
    [self->sizeSlider_ setEnabled:YES];
    [self->sizeDetail_ setEnabled:YES];

    // ͤ
    [self createSizePair];

    return;
}


#if 0   // raiseSizeDetailSheet: ˰ܹԤ
//
// ܺ(Ф)
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)sizeDetail:(id)sender
{
    // ⤷ʤ
    ;

    return;
}
#endif  // 0


//
// 
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    sizePair_ : 礭з(instance ѿ)
//
-(IBAction)sizeSlide:(id)sender
{
    // ͤ
    if (self->sizePair_ != nil) {
        [self->sizePair_ release];
        self->sizePair_ = nil;
        [self createSizePair];
    }

    return;
}


//
// ä
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)cancel:(id)sender
{
    // Ĥ
    [[self window] close];

    // modal session λ
    [NSApp stopModal];

    return;
}


//
// 
//
//  Call
//    sender    : о(api ѿ)
//    adjacent_ : (outlet)
//    manual_   : ư(outlet)
//    auto_     : ư(outlet)
//    pair_     : Ф(outlet)
//
//  Return
//    isOk_ : ¹Ԥ뤫(instance ѿ)
//
-(IBAction)ok:(id)sender
{
    self->isOk_ = YES;

    // ܤȥλˡ򵭲
    [[NSUserDefaults standardUserDefaults]
        setBool:([self->adjacent_ state] != 0)
         forKey:DEFAULT_ADJACENT];
    if ([self->auto_ state] != 0) {
        [[NSUserDefaults standardUserDefaults] setInteger:1
                                                   forKey:DEFAULT_AUTO];
    } else if ([self->pair_ state] != 0) {
        [[NSUserDefaults standardUserDefaults] setInteger:2
                                                   forKey:DEFAULT_AUTO];
    } else /* if ([self->manual_ state] != 0) */ { 
        [[NSUserDefaults standardUserDefaults] setInteger:0
                                                   forKey:DEFAULT_AUTO];
    }

    // Ĥ
    [self cancel:sender];               // cancel μĤ

    return;
}


// --------------------------------- instance - public - ̾ܺꥷȴϢ
//
// ̾ܺꥷȤ򳫤
//
//  Call
//    sender       : о(api ѿ)
//    detailSheet_ : ̾ܺꥷ(outlet)
//    detailList_  : ̾ܺꥹ(outlet)
//    sizePair_    : 礭з(instance ѿ)
//
//  Return
//    None
//
-(IBAction)raiseSizeDetailSheet:(id)sender
{
    // зϤ
    [(PoCoAutoGradationSizePairOperate *)([self->detailList_ delegate]) setSizeDetail:(NSDictionary *)(self->sizePair_)];

    // Ȥ򳫤
    [NSApp beginSheet:self->detailSheet_
       modalForWindow:[self window]
        modalDelegate:self
       didEndSelector:@selector(sizeDetailSheetDidEnd:returnCode:contextInfo:)
          contextInfo:nil];

    // ɽ򹹿
    [self->detailList_ reloadData];

    return;
}


//
// ̾ܺꥷȤĤ
//
//  Call
//    sender       : о(api ѿ)
//    detailSheet_ : ̾ܺꥷ(outlet)
//    detailList_  : ̾ܺꥹ(outlet)
//
//  Return
//    None
//
-(IBAction)endSizeDetailSheet:(id)sender
{
    // ȤĤ
    [self->detailSheet_ orderOut:sender];
    [NSApp endSheet:self->detailSheet_
         returnCode:[sender tag]];

    // з˺줵
    [(PoCoAutoGradationSizePairOperate *)([self->detailList_ delegate]) setSizeDetail:nil];

    return;
}


//
// ̾ܺꥷȤĤ줿
//
//  Call
//    sheet        : Ĥsheet(api ѿ)
//    returnCode   : λ֤(api ѿ)
//    contextInfo  : (api ѿ)
//    detailSheet_ : ̾ܺꥷ(outlet)
//
//  Return
//    sizePair_ : 礭з(instance ѿ)
//
-(void)sizeDetailSheetDidEnd:(NSWindow *)sheet
                  returnCode:(int)returnCode
                 contextInfo:(void *)contextInfo
{
    NSArray *pair;
    NSEnumerator *iter;
    PoCoGradationPairInfo *info;

    // [set] ȴƤ顢ȿ
    if (returnCode != 0) {
        goto EXIT;
    }

    // ̤
    pair = [(PoCoAutoGradationSizePairOperate *)([self->detailList_ delegate]) sizeDetail];

    // Ƥȿ(̤μΤʣΤǤϤʤġͤƤ)
    iter = [pair objectEnumerator];
    for (info = [iter nextObject]; info != nil; info = [iter nextObject]) {
        [(PoCoGradationPairInfo *)([self->sizePair_ objectForKey:[info name]]) setSize:[info size]];
    }

EXIT:
    return;
}

@end
