//
//	Pelistina on Cocoa - PoCo -
//	ִΰ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoColorReplaceColorView.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoColorReplaceColorView

// --------------------------------------------------------- instance - private
//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// ι
//
//  Call
//    num : ֹ
//    evt : ٥
//
//  Return
//    function : ֹ
//
-(int)selColor:(int)num
         event:(NSEvent *)evt
{
    const int oldNum = num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = ((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX);

        // ڤؤϺȯ
        if (oldNum != num) {
            [self setNeedsDisplayInRect:[self numToRect:oldNum]];
            [self setNeedsDisplayInRect:[self numToRect:num]];
        }
    }

    return num;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//   
//  Call
//    frameRect : ΰ(api ѿ)
//     
//  Return
//    function  : 
//    leftNum_  : ܥǤ(instanceѿ)
//    rightNum_ : ܥǤ(instanceѿ)
//    docCntl_  : document controller(instanceѿ)
//
-(id)initWithFrame:(NSRect)frameRect;
{
    DPRINT((@"[PoCoColorReplaceColorView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->leftNum_ = 0;
        self->rightNum_ = 0;
        self->docCntl_ = nil;

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_ : document controller(instanceѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoColorReplaceColorView dealloc]\n"));

    // 񸻤
    [self->docCntl_ release];
    self->docCntl_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ɽ׵
//
//  Call
//    rect      : ɽΰ(api ѿ)
//    leftNum_  : ܥǤ(instance ѿ)
//    rightNum_ : ܥǤ(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int l;

    DPRINT((@"[PoCoColorReplaceColorView drawRect]\n"));

    for (l = 0; l < COLOR_MAX; (l)++) {
        if (NSIntersectsRect(rect, [self numToRect:l])) {
            [self drawColor:l
                   isSelect:((l == self->leftNum_) || (l == self->rightNum_))
                     isDown:(l == self->rightNum_)];
        }
    }

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return  
//    function : YES
// 
-(BOOL)isFlipped
{
    return YES;
}


//
// 1ʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : ɽ
//               NO  : ɽ
//    down     : YES : ɽ
//               NO  : 夬ɽ
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        isSelect:(BOOL)sel
          isDown:(BOOL)down
{
    NSRect  r;
    const PoCoPalette *plt = [[[self->docCntl_ currentDocument] picture] palette];
    const PoCoColor *col = [plt palette:num];

    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            if (down) {
                [[NSColor blackColor] set];
            } else {
                [[NSColor whiteColor] set];
            }
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            if (down) {
                [[NSColor whiteColor] set];
            } else {
                [[NSColor blackColor] set];
            }
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


// ----------------------------------------------- instance - public - 
//
// ܥǤ
//
//  Call
//    leftNum_ : ܥǤ(instanceѿ)
//
//  Return
//    function : 
//
-(int)leftNum
{
    return self->leftNum_;
}


//
// ܥǤ
//
//  Call
//    rightNum_ : ܥǤ(instanceѿ)
//
//  Return
//    function : 
//
-(int)rightNum
{
    return self->rightNum_;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    leftNum_ : ܥǤ(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    self->leftNum_ = [self selColor:self->leftNum_
                              event:evt];

    return;
}


//
// ɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    leftNum_ : ܥǤ(instance ѿ)
//
-(void)mouseDragged:(NSEvent *)evt
{
    self->leftNum_ = [self selColor:self->leftNum_
                              event:evt];

    return;
}


//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    rightNum_ : ܥǤ(instance ѿ)
//
-(void)rightMouseDown:(NSEvent *)evt
{
    self->rightNum_ = [self selColor:self->rightNum_
                               event:evt];

    return;
}


//
// ܥɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    rightNum_ : ܥǤ(instance ѿ)
//
-(void)rightMouseDragged:(NSEvent *)evt
{
    self->rightNum_ = [self selColor:self->rightNum_
                               event:evt];

    return;
}

@end
