//
//	Pelistina on Cocoa - PoCo -
//	ִѥͥ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoColorReplacePanel.h"

#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"
#import "PoCoColorReplaceColorView.h"

// ѿ
static NSString *COLREP_SELRANGE = @"PoCoColorReplaceSelectionRange";

// ======================================================= PoCoColorReplacePair

// ------------------------------------------------------------------ interface
@interface PoCoColorReplacePair : NSObject
{
    int src_;                           // ִֹ
    int dst_;                           // ִ迧ֹ
}

// initialize
-(id)initWithSrc:(int)s
         withDst:(int)d;

// deallocate
-(void)dealloc;

// 
-(int)src;
-(int)dst;

// ɽʸμ
-(NSString *)srcString;
-(NSString *)dstString;

@end


// ------------------------------------------------------------- implementation
@implementation PoCoColorReplacePair

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    s : Ѵοֹ
//    d : Ѵοֹ
//
//  Return
//    function : 
//    src_     : Ѵοֹ(instance ѿ)
//    dst_     : Ѵοֹ(instance ѿ)
//
-(id)initWithSrc:(int)s
         withDst:(int)d
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->src_ = s;
        self->dst_ = d;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class 
    [super dealloc];

    return;
}


//
// (Ѵοֹ)
//
//  Call
//    src_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : 
//
-(int)src
{
    return self->src_;
}


//
// (Ѵοֹ)
//
//  Call
//    dst_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : 
//
-(int)dst
{
    return self->dst_;
}


//
// Ѵɽʸμ
//
//  Call
//    src_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)srcString
{
    PoCoColor *col = [[[[[NSDocumentController sharedDocumentController] currentDocument] picture] palette] palette:self->src_];

    return [NSString stringWithFormat:@"%3d:%02X-%02X-%02X", self->src_, [col red], [col green], [col blue]];
}


//
// Ѵɽʸμ
//
//  Call
//    dst_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)dstString
{
    PoCoColor *col = [[[[[NSDocumentController sharedDocumentController] currentDocument] picture] palette] palette:self->dst_];

    return [NSString stringWithFormat:@"%3d:%02X-%02X-%02X", self->dst_, [col red], [col green], [col blue]];
}

@end




// ============================================================================
@implementation PoCoColorReplacePanel

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    NSMutableDictionary *dic;

    dic = [NSMutableDictionary dictionary];

    // ƽͤ
    [dic setObject:[NSNumber numberWithInt:1]
            forKey:COLREP_SELRANGE];

    // default 
    [[NSUserDefaults standardUserDefaults] registerDefaults:dic];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc  : Խо
//    info : Խ
//
//  Return
//    function      : 
//    document_     : Խо(instance ѿ)
//    editInfo_     : Խ(instance ѿ)
//    isOk_         : ¹Ԥ뤫(instance ѿ)
//    replaceTable_ : ִǡ(instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
    withEditInfo:(PoCoEditInfo *)info
{
    DPRINT((@"[PoCoColorReplacePanel initWithDoc:]\n"));

    // super class ν
    self = [super initWithWindowNibName:@"PoCoColorReplacePanel"];

    // Ȥν
    if (self != nil) {
        self->isOk_ = NO;
        self->document_ = doc;
        self->editInfo_ = info;
        [self->document_ retain];
        [self->editInfo_ retain];

        // ꥹȤ
        self->replaceTable_ = [[NSMutableArray alloc] init];
        if (self->replaceTable_ == nil) {
            DPRINT((@"can't alloc replaceTable.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    document_     : Խо(instance ѿ)
//    editInfo_     : Խ(instance ѿ)
//    replaceTable_ : ִǡ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoColorReplacePanel dealloc]\n"));

    // о˴
    [self->replaceTable_ removeAllObjects];

    // 񸻤β
    [self->document_ release];
    [self->editInfo_ release];
    [self->replaceTable_ release];
    self->replaceTable_ = nil;
    self->document_ = nil;
    self->editInfo_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    Nnoe
//
//  Return
//    rangeEdit_ : ϰ(outlet)
//
-(void)startWindow
{
    // ϰϤͤ
    [self->rangeEdit_ setIntegerValue:[[NSUserDefaults standardUserDefaults] integerForKey:COLREP_SELRANGE]];

    // modal session 
    [NSApp runModalForWindow:[self window]];

    return;
}


// --------------------------------------------------- instance - public - 
//
// ¹Ԥ뤫
//
//  Call
//    isOk_ : ¹Ԥ뤫(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isOk
{
    return self->isOk_;
}


//
// ִɽ
//
//  Call
//    replaceTable_ : ִǡ(instance ѿ)
//
//  Return
//    function : ִɽ
//    matrix_  : ִɽ(instance ѿ)
//
-(const unsigned char *)matrix
{
    int l;
    NSEnumerator *iter;
    PoCoColorReplacePair *elm;

    // ִɽ(źƱͤˤ)
    for (l = 0; l < COLOR_MAX; (l)++) {
        self->matrix_[l] = l;
    }

    // ִǡƤȿ
    iter = [self->replaceTable_ objectEnumerator];
    for (elm = [iter nextObject]; elm != nil; elm = [iter nextObject]) {
        if ([elm src] != [elm dst]) {
            self->matrix_[[elm src]] = [elm dst];
        }
    }

    return self->matrix_;
}


// ----------------------------------- instance - public - ǡ᥽å
//
// Կμ
//
//  Call
//    table         : о(api ѿ)
//    replaceTable_ : ִǡ(instance ѿ)
//
//  Return
//    function : Կ
//
-(int)numberOfRowsInTableView:(NSTableView *)table
{
    DPRINT((@"[PoCoPaletteReplaceView numberOfRowsInTableView]\n"));

    return (int)([self->replaceTable_ count]);
}


//
// ɽ
//
//  Call
//    table  : о(api ѿ)
//    column : оݷ(api ѿ)
//    row    : оݹ(api ѿ)
//
//  Return
//    function : ɽ
//
-(id)tableView:(NSTableView *)table
objectValueForTableColumn:(NSTableColumn *)column
                      row:(int)row
{
    NSString *identifier;
    PoCoColorReplacePair *pair;

    DPRINT((@"[PoCoPaletteReplaceView tableView: objectValueForTableColumn: row]\n"));

    // ̻Ҥμ
    identifier = [column identifier];

    // оݹԤƤμ
    pair = [self->replaceTable_ objectAtIndex:row];

    return [pair valueForKey:identifier];
}


//
// Խ
//    ԽԲĤʤΤǲ⤷ʤ
//
//  Call
//    table  : о(api ѿ)
//    object : Խ(api ѿ)
//    column : оݷ(api ѿ)
//    row    : оݹ(api ѿ)
//
//  Return
//    None
//
-(void)tableView:(NSTableView *)table
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)column
             row:(int)row
{
    DPRINT((@"[PoCoPaletteReplaceView tableView: setObjectValue: ForTableColumn: row]\n"));

    // ⤷ʤ
    ;

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// ɲ
//
//  Call
//    sender      : о(api ѿ)
//    colorList_  : ɽ(outlet)
//    selectView_ : ΰ(outlet)
//    rangeEdit_  : ϰ(outlet)
//
//  Return
//    replaceTable_ : ִǡ(instance ѿ)
//
-(IBAction)addColor:(id)sender
{
    PoCoColorReplacePair *pair;
    int l;
    int s;
    int d;

    s = [self->selectView_ leftNum];
    d = [self->selectView_ rightNum];

    // о
    l = [self->rangeEdit_ intValue];
    while (l != 0) {
        pair = [[PoCoColorReplacePair alloc] initWithSrc:s
                                                 withDst:d];
        if (pair == nil) {
            DPRINT((@"can't alloc PoCoColorReplacePair.\n"));
        } else {
            // ǡɲ
            [self->replaceTable_ addObject:pair];
            [pair release];
        }

        // 
        if (l < 0) {
            (s)--;
            (d)--;
            (l)++;
            if (s < 0) {
                s = 0;
            }
            if (d < 0) {
                d = 0;
            }
        } else if (l > 0) {
            (s)++;
            (d)++;
            (l)--;
            if (s >= COLOR_MAX) {
                s = (COLOR_MAX - 1);
            }
            if (d >= COLOR_MAX) {
                d = (COLOR_MAX - 1);
            }
        }
    }

    // ɽ򹹿
    [self->colorList_ reloadData];

    return;
}


//
// ä
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)cancel:(id)sender
{
    // Ĥ
    [[self window] close];

    // modal session λ
    [NSApp stopModal];

    return;
}


//
// 
//
//  Call
//    sender     : о(api ѿ)
//    rangeEdit_ : ϰ(outlet)
//
//  Return
//    isOk_ : ¹Ԥ뤫(instance ѿ)
//
-(IBAction)ok:(id)sender
{
    self->isOk_ = YES;

    // ϰϤ򵭲
    [[NSUserDefaults standardUserDefaults] setInteger:[self->rangeEdit_ integerValue]
                                               forKey:COLREP_SELRANGE];

    // Ĥ
    [self cancel:sender];               // cancel μĤ

    return;
}


//
// ϰ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)rangeEdit:(id)sender
{
    // ⤷ʤ
    ;

    return;
}

@end
