//
//	Pelistina on Cocoa - PoCo -
//	ɥѥͥ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoDocumentSettingPanel.h"

#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

// ============================================================================
@implementation PoCoDocumentSettingPanel

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function  : 
//    document_ : Խо(instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoDocumentSettingPanel initWithDoc:]\n"));

    // super class ν
    self = [super initWithWindowNibName:@"PoCoDocumentSettingPanel"];

    // Ȥν
    if (self != nil) {
        self->document_ = doc;
        [self->document_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    document_ : Խо(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoDocuemntSettingPanel dealloc]\n"));

    // 񸻤β
    [self->document_ release];
    self->document_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    document_ : Խо(instance ѿ)
//
//  Return
//    h_unit_     : pHYs(ʿ)(outlet)
//    v_unit_     : pHYs(ľ)(outlet)
//    bkgdCheck_  : bKGD()(outlet)
//    bkgdIndex_  : bKGD(ֹ)(outlet)
//    iccp_       : iCCP(outlet)
//    gamma_      : gAMA(outlet)
//    chromakey1_ : cHRM(outlet)
//    chromakey2_ : cHRM(outlet)
//    chromakey3_ : cHRM(outlet)
//    chromakey4_ : cHRM(outlet)
//    chromakey5_ : cHRM(outlet)
//    chromakey6_ : cHRM(outlet)
//    chromakey7_ : cHRM(outlet)
//    chromakey8_ : cHRM(outlet)
//    srgb_       : sRGB(outlet)
//
-(void)startWindow
{
    PoCoPicture *picture;
    BOOL state;
    const unsigned int *chrm;
    unsigned int bkgd;

    // PoCoPicture 
    picture = [self->document_ picture];

    // 
    [self->h_unit_ setIntValue:[picture h_unit]];
    [self->v_unit_ setIntValue:[picture v_unit]];

    // bKGD
    [self->bkgdCheck_ setState:(([picture bkgdColor:&(bkgd)]) ? 1 : 0)];
    [self->bkgdIndex_ setIntValue:bkgd];
    [self useBKGD:self->bkgdCheck_];
    [self editBKGD:self->bkgdIndex_];

    // gAMA
    [self->gamma_ setIntValue:[picture gamma]];

    // chromakey
    chrm = [picture chromakey];
    [self->chromakey1_ setIntValue:chrm[0]];
    [self->chromakey2_ setIntValue:chrm[1]];
    [self->chromakey3_ setIntValue:chrm[2]];
    [self->chromakey4_ setIntValue:chrm[3]];
    [self->chromakey5_ setIntValue:chrm[4]];
    [self->chromakey6_ setIntValue:chrm[5]];
    [self->chromakey7_ setIntValue:chrm[6]];
    [self->chromakey8_ setIntValue:chrm[7]];

    // sRGB
    [self->srgb_ setIntValue:[picture srgb]];

    // iCCP
    if ([picture isUseICCP]) {
        [self->iccp_ setState:1];
        state = NO;
    } else {
        [self->iccp_ setState:0];
        state = YES;
    }
    [self->gamma_ setEnabled:state];
    [self->chromakey1_ setEnabled:state];
    [self->chromakey2_ setEnabled:state];
    [self->chromakey3_ setEnabled:state];
    [self->chromakey4_ setEnabled:state];
    [self->chromakey5_ setEnabled:state];
    [self->chromakey6_ setEnabled:state];
    [self->chromakey7_ setEnabled:state];
    [self->chromakey8_ setEnabled:state];
    [self->srgb_ setEnabled:state];

    // modal session 
    [NSApp runModalForWindow:[self window]];

    return;
}


//
// bKGD ڤؤ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    bkgdIndex_ : bKGD(ֹ)(outlet)
//    bkgdInfo_  : bKGD()(outlet)
//
-(IBAction)useBKGD:(id)sender
{
    BOOL state = ([self->bkgdCheck_ state] != 0);

    [self->bkgdIndex_ setEnabled:state];
    [self->bkgdInfo_ setEnabled:state];

    return;
}


//
// bKGD 
//
//  Call
//    sender     : о(api ѿ)
//    document_  : Խо(instance ѿ)
//    bkgdIndex_ : bKGD(ֹ)(outlet)
//
//  Return
//    bkgdInfo_ : bKGD()(outlet)
//
-(IBAction)editBKGD:(id)sender
{
    PoCoPicture *picture;
    PoCoColor *col;
    unsigned int idx;

    // PoCoPicture 
    picture = [self->document_ picture];

    // bKGD
    idx = [self->bkgdIndex_ intValue];

    // Ƥ
    col = [[picture palette] palette:idx];
    [self->bkgdInfo_ setStringValue:[NSString stringWithFormat:@"0x%02x-0x%02x-0x%02x",
                                        [col red],
                                        [col green],
                                        [col blue]]];

    return;
}


//
// iCCP ڤؤ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    iccp_       : iCCP(outlet)
//    gamma_      : gAMA(outlet)
//    chromakey1_ : cHRM(outlet)
//    chromakey2_ : cHRM(outlet)
//    chromakey3_ : cHRM(outlet)
//    chromakey4_ : cHRM(outlet)
//    chromakey5_ : cHRM(outlet)
//    chromakey6_ : cHRM(outlet)
//    chromakey7_ : cHRM(outlet)
//    chromakey8_ : cHRM(outlet)
//    srgb_       : sRGB(outlet)
//
-(IBAction)useICCP:(id)sender
{
    BOOL state = ([self->iccp_ state] == 0);

    [self->gamma_ setEnabled:state];
    [self->chromakey1_ setEnabled:state];
    [self->chromakey2_ setEnabled:state];
    [self->chromakey3_ setEnabled:state];
    [self->chromakey4_ setEnabled:state];
    [self->chromakey5_ setEnabled:state];
    [self->chromakey6_ setEnabled:state];
    [self->chromakey7_ setEnabled:state];
    [self->chromakey8_ setEnabled:state];
    [self->srgb_ setEnabled:state];

    return;
}


//
// ä
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)cancel:(id)sender
{
    // Ĥ
    [[self window] close];

    // modal session λ
    [NSApp stopModal];

    return;
}


//
// 
//
//  Call
//    sender      : о(api ѿ)
//    document_   : Խо(instance ѿ)
//    h_unit_     : pHYs(ʿ)(outlet)
//    v_unit_     : pHYs(ľ)(outlet)
//    bkgdCheck_  : bKGD()(outlet)
//    iccp_       : iCCP(outlet)
//    gamma_      : gAMA(outlet)
//    chromakey1_ : cHRM(outlet)
//    chromakey2_ : cHRM(outlet)
//    chromakey3_ : cHRM(outlet)
//    chromakey4_ : cHRM(outlet)
//    chromakey5_ : cHRM(outlet)
//    chromakey6_ : cHRM(outlet)
//    chromakey7_ : cHRM(outlet)
//    chromakey8_ : cHRM(outlet)
//    srgb_       : sRGB(outlet)
//
//  Return
//    None
//
-(IBAction)ok:(id)sender
{
    PoCoPicture *picture;
    unsigned int chrm[8];
    unsigned int bkgd;

    // PoCoPicture 
    picture = [self->document_ picture];

    // 
    [picture setHUnit:[self->h_unit_ intValue]
            withVUnit:[self->v_unit_ intValue]];

    // bKGD
    bkgd = [self->bkgdIndex_ intValue];
    [picture setBKGD:([self->bkgdCheck_ state] != 0) withIndex:bkgd];

    // iCCP
    [picture setUseICCP:([self->iccp_ state] != 0)];

    // gAMA
    [picture setGamma:[self->gamma_ intValue]];

    // cHRM
    chrm[0] = [self->chromakey1_ intValue];
    chrm[1] = [self->chromakey2_ intValue];
    chrm[2] = [self->chromakey3_ intValue];
    chrm[3] = [self->chromakey4_ intValue];
    chrm[4] = [self->chromakey5_ intValue];
    chrm[5] = [self->chromakey6_ intValue];
    chrm[6] = [self->chromakey7_ intValue];
    chrm[7] = [self->chromakey8_ intValue];
    [picture setChromakey:chrm];

    // sRGB
    [picture setSrgb:[self->srgb_ intValue]];

    // Ĥ
    [self cancel:sender];               // cancel μĤ

    return;
}

@end
