//
//	Pelistina on Cocoa - PoCo -
//	ѥåȼΰ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoImportPaletteColorSelectView.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoImportPaletteColorSelectView

// --------------------------------------------------------- instance - private
//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// 1ʬ
//
//  Call
//    num            : ֹ
//    sel            : YES : ɽ
//                     NO  : ɽ
//    targetPalette_ : оݥѥå(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        isSelect:(BOOL)sel
{
    NSRect r;
    const PoCoColor *col = [self->targetPalette_ palette:num];

    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            [[NSColor whiteColor] set];
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            [[NSColor blackColor] set];
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//   
//  Call
//    frameRect : ΰ(api ѿ)
//     
//  Return
//    function       : 
//    isOn_[]        : (instance ѿ)
//    setValue_      : (instance ѿ)
//    targetPalette_ : оݥѥå(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect;
{
    int l;

    DPRINT((@"[PoCoImportPaletteColorSelectView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        for (l = 0; l < COLOR_MAX; l++) {
            self->isOn_[l] = NO;
        }
        self->setValue_ = NO;
        self->targetPalette_ = nil;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    targetPalette_ : оݥѥå(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoImportPaletteColorSelectView dealloc]\n"));

    // 񸻤β
    [self->targetPalette_ release];
    self->targetPalette_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// оݥѥåȤ
//
//  Call
//    target : о
//
//  Return
//    targetPalette_ : оݥѥå(instance ѿ)
//
-(void)setTarget:(PoCoPalette *)target
{
    // Τ˺
    [self->targetPalette_ release];
    self->targetPalette_ = nil;

    // Τڤؤ
    self->targetPalette_ = target;
    [self->targetPalette_ retain];

    return;
}


//
// ɽ׵
//
//  Call
//    rect    : ɽΰ(api ѿ)
//    isOn_[] : (instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int l;

    DPRINT((@"[PoCoImportPaletteColorSelectView drawRect]\n"));

    for (l = 0; l < COLOR_MAX; l++) {
        if (NSIntersectsRect(rect, [self numToRect:l])) {
            [self drawColor:l
                   isSelect:self->isOn_[l]];
        }
    }

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return  
//    function : YES
// 
-(BOOL)isFlipped
{
    return YES;
}


//
// (ο)
//
//  Call
//    index   : о
//    isOn_[] : (instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)attribute:(int)index
{
    return self->isOn_[index];
}

//
// ()
//
//  Call
//    isOn_[] : (instance ѿ)
//
//  Return
//    function : 
//
-(const BOOL *)attributs;
{
    return (const BOOL *)(&(self->isOn_[0]));
}


//
// 
//
//  Call
//    on    : 
//    index : о
//
//  Return
//    isOn_[] : (instance ѿ)
//
-(void)setAttribute:(BOOL)on atIndex:(int)index
{
    self->isOn_[index] = on;

    return;
}


// ------------------------------------------- instance - public ٥Ƚ
//
// ܥ
//
//  Call
//    evt     : ȯ٥(api ѿ)
//    isOn_[] : (instance ѿ)
//
//  Return
//    setValue_ : (instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    int num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = (((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX));

        // ͤȽ
        self->setValue_ = ((self->isOn_[num]) ? NO : YES);

        // ɥåƱˤ
        [self mouseDragged:evt];
    }

    return;
}


//
// ɥå
//
//  Call
//    evt       : ȯ٥(api ѿ)
//    setValue_ : (instance ѿ)
//
//  Return
//    isOn_[] : (instance ѿ)
//
-(void)mouseDragged:(NSEvent *)evt
{
    int num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = (((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX));

        // ͤȿ
        if (self->setValue_ != self->isOn_[num]) {
            self->isOn_[num] = self->setValue_;

            // 
            [self setNeedsDisplayInRect:[self numToRect:num]];
        }
    }

    return;
}

@end
