//
//	Pelistina on Cocoa - PoCo -
//	ѥåȼѥͥ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoImportPalettePanel.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"
#import "PoCoImportPaletteColorSelectView.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerPaletteImporter.h"

// ============================================================================
@implementation PoCoImportPalettePanel

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc    : Խо
//    target : оݥѥå
//
//  Return
//    document_      : Խо(instance ѿ)
//    targetPalette_ : оݥѥå(instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
withTargetPalette:(PoCoPalette *)target
{
    DPRINT((@"[PoCoImportPalettePanel initWithDoc: withTargetPalette:]\n"));

    // super class 
    self = [super initWithWindowNibName:@"PoCoImportPalettePanel"];

    // Ȥν
    if (self != nil) {
        self->document_ = doc;
        self->targetPalette_ = target;
        [self->document_ retain];
        [self->targetPalette_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    document_      : Խо(instance ѿ)
//    targetPalette_ : оݥѥå(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoImportPalettePanel dealloc]\n"));

    // 񸻤β
    [self->targetPalette_ release];
    [self->document_ release];
    self->targetPalette_ = nil;
    self->document_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    selectView_    : ΰ(outlet)
//    targetPalette_ : оݥѥå(instance ѿ)
//
//  Return
//   None
//
-(void)startWindow
{
    // оݥѥåȤ
    [self->selectView_ setTarget:self->targetPalette_];

    // ͤ
    [self setDiff:nil];                 // [ʬ] η̤ͤˤ

    // modal session 
    [NSApp runModalForWindow:[self window]];

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// ޤʤ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)noImport:(id)sender
{
    // Ĥ
    [[self window] close];

    // modal session λ
    [NSApp stopModal];

    return;
}


//
// ߼¹
//
//  Call
//    sender         : о(api ѿ)
//    selectView_    : ΰ(outlet)
//    targetPalette_ : оݥѥå(instance ѿ)
//
//  Return
//    None
//
-(IBAction)doImport:(id)sender
{
    // 
    [[(PoCoAppController *)([NSApp delegate]) factory] createPaletteImporter:YES
                                        targetPalette:targetPalette_
                                            withFlags:[self->selectView_ attributs]];

    // Ĥ
    [self noImport:sender];             // [ޤʤ] μĤ

    return;
}


//
// ʬ
//
//  Call
//    sender         : о(api ѿ)
//    selectView_    : ΰ(outlet)
//    document_      : Խо(instance ѿ)
//    targetPalette_ : оݥѥå(instance ѿ)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)setDiff:(id)sender
{
    int l;

    // äƤΤоݤˤ
    for (l = 0; l < COLOR_MAX; l++) {
        if ([[[[self->document_ picture] palette] palette:l] isEqualColor:[self->targetPalette_ palette:l] checkAttr:NO]) {
            [self->selectView_ setAttribute:NO atIndex:l];
        } else {
            [self->selectView_ setAttribute:YES atIndex:l];
        }
    }

    // 
    [self->selectView_ setNeedsDisplay:YES];

    return;
}


//
// ȿž
//
//  Call
//    sender      : о(api ѿ)
//    selectView_ : ΰ(outlet)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)reverseSelect:(id)sender
{
    int l;

    // ͤȿž
    for (l = 0; l < COLOR_MAX; l++) {
        [self->selectView_ setAttribute:([self->selectView_ attribute:l] ? NO : YES)
                                atIndex:l];
    }

    // 
    [self->selectView_ setNeedsDisplay:YES];

    return;
}


//
// ٤
//
//  Call
//    sender      : о(api ѿ)
//    selectView_ : ΰ(outlet)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)allSelect:(id)sender
{
    int l;

    // ٤ YES ڤؤ
    for (l = 0; l < COLOR_MAX; l++) {
        [self->selectView_ setAttribute:YES
                                atIndex:l];
    }

    // 
    [self->selectView_ setNeedsDisplay:YES];

    return;
}


//
// ٤
//
//  Call
//    sender      : о(api ѿ)
//    selectView_ : ΰ(outlet)
//
//  Return
//    selectView_ : ΰ(outlet)
//
-(IBAction)allClear:(id)sender
{
    int l;

    // ٤ NO ڤؤ
    for (l = 0; l < COLOR_MAX; l++) {
        [self->selectView_ setAttribute:NO
                                atIndex:l];
    }

    // 
    [self->selectView_ setNeedsDisplay:YES];

    return;
}

@end
