//
//	Pelistina on Cocoa - PoCo -
//	ΰ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoNewDocumentColorSelectView.h"

#import "PoCoPalette.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)
  
// ============================================================================
@implementation PoCoNewDocumentColorSelectView

// --------------------------------------------------------- instance - private
//
// 줿ɸѴ
//
//  Call
//    p  : ºɸ(̾)
//    rb : YES : 
//         NO  : 
//
//  Return
//    function : ѥåʿ̰
//
-(PoCoPoint *)toNormalPos:(PoCoPoint *)p
            isRightBottom:(BOOL)rb
{
    PoCoPoint *np;

    np = [[PoCoPoint alloc] initX:([p x] / SEL_SIZE)
                            initY:([p y] / SEL_SIZE)];
    if (rb) {
        [np moveX:-1 moveY:-1];
    }

    return np;
}


//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// 1ʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : 
//               NO  : 
//    palette_ : (instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num isSelect:(BOOL)sel
{
    NSRect  r;
    PoCoColor *col;

    col = [self->palette_ palette:num];
    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            [[NSColor whiteColor] set];
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            [[NSColor blackColor] set];
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


// ---------------------------- PoCoNewDocumentColorSelectView  instance ؿ
//
// initialize
//
//  Call
//    frameRect : ΰ
//
//  Return
//    function : 
//    palette_ : (instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect
{
    DPRINT((@"[PoCoNewDocumentColorSelectView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->palette_ = [[PoCoPalette alloc] init];
        if (self->palette_ == nil) {
            DPRINT((@"can't alloc PoCoPalette\n"));
            [self release];
            self = nil;
        }
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    palette_ : (instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoNewDocumentColorSelectView dealloc]\n"));

    // 񸻤
    [self->palette_ release];
    self->palette_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return
//    function : YES
//
-(BOOL)isFlipped
{
    return YES;
}


//
// ɽ׵
//
//  Call
//    rect    : ׵ΰ(api ѿ)
//    selnum_ : ֹ(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int i;
    int x;
    int y;
    PoCoRect *r;
    PoCoPoint *lt;
    PoCoPoint *rb;

    // ϰϤλ
    r = [[PoCoRect alloc] initNSRect:rect];
    lt = [self toNormalPos:[r  lefttop]
             isRightBottom:NO];
    rb = [self toNormalPos:[r rightbot]
             isRightBottom:YES];
    if ((r == nil) || (lt == nil) || (rb == nil)) {
        ;
    } else {
        // ɽ
        if (([lt x] == [rb x]) && ([lt y] == [rb y])) {
            i = (([lt y] * H_MAX) + [lt x]);
            [self drawColor:i
                   isSelect:(i == self->selnum_)];
        } else if ([lt x] == [rb x]) {
            i = (([lt y] * H_MAX) + [lt x]);
            for (y = [lt y]; y <= [rb y]; (y)++, i += H_MAX) {
                [self drawColor:i
                       isSelect:(i == self->selnum_)];
            }
        } else if ([lt y] == [rb y]) {
            i = (([lt y] * H_MAX) + [lt x]);
            for (x = [lt x]; x <= [rb x]; (x)++, (i)++) {
                [self drawColor:i
                       isSelect:(i == self->selnum_)];
            }
        } else {
            for (y = [lt y]; y <= [rb y]; (y)++) {
                i = ((y * H_MAX) + [lt x]);
                for (x = [lt x]; x <= [rb x]; (x)++, (i)++) {
                    [self drawColor:i
                           isSelect:(i == self->selnum_)];
                }
            }
        }
    }
    [lt release];
    [rb release];
    [r release];

    return;
}


//
// ֹ
//
//  Call
//    num : ֹ
//
//  Return
//    selnum_ : ֹ(instance ѿ)
//
-(void)setSelnum:(unsigned char)num
{
    self->selnum_ = num;

    return;
}


//
// ֹμ
//
//  Call
//    selnum_ : ֹ(instance ѿ)
//
//  Return
//    function : ֹ
//
-(unsigned char)selnum
{
    return self->selnum_;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt     : ȯ٥(api ѿ)
//    selnum_ : ֹ(instance ѿ)
//
//  Return
//    selnum_ : ֹ(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    NSPoint p;
    const int old = self->selnum_;

    p = [self convertPoint:[evt locationInWindow]
                  fromView:nil];
    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        self->selnum_ = (((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX));
        if (old != self->selnum_) {
            [self setNeedsDisplayInRect:[self numToRect:old]];
            [self setNeedsDisplayInRect:[self numToRect:self->selnum_]];
        }
    }

    return;
}


//
// ɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)mouseDragged:(NSEvent *)evt
{
    // mouse down Ʊˤ
    [self mouseDown:evt];

    return;
}

@end
