//
//	Pelistina on Cocoa - PoCo -
//	ѥͥ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoNewDocumentPanel.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoNewDocumentColorSelectView.h"

// ѿ
static NSString *DEFAULT_WIDTH = @"PoCoNewDocumentDefaultWidth";
static NSString *DEFAULT_HEIGHT = @"PoCoNewDocumentDefaultHeight";
static NSString *DEFAULT_RESOLUTION = @"PoCoNewDocumentDefaultResolution";
static NSString *DEFAULT_COLOR = @"PoCoNewDocumentDefaultColor";

// ============================================================================
@implementation PoCoNewDocumentPanel

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    NSMutableDictionary *dic;

    dic = [NSMutableDictionary dictionary];

    // ƽͤ
    [dic setObject:[NSNumber numberWithInt:640] forKey:DEFAULT_WIDTH];
    [dic setObject:[NSNumber numberWithInt:480] forKey:DEFAULT_HEIGHT];
    [dic setObject:[NSNumber numberWithInt:120] forKey:DEFAULT_RESOLUTION];
    [dic setObject:[NSNumber numberWithInt:0] forKey:DEFAULT_COLOR];

    // default 
    [[NSUserDefaults standardUserDefaults] registerDefaults:dic];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function      : 
//    defaultColor_ : (instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoNewDocumentPanel init]\n"));

    // super class ν
    self = [super initWithWindowNibName:@"PoCoNewDocumentPanel"];

    // Ȥν
    if (self != nil) {
        self->defaultColor_ = (unsigned char)([[NSUserDefaults standardUserDefaults] integerForKey:DEFAULT_COLOR]);
    }

    return self;
}


//
// deallocate
//
//  Call
//   None
//
//  Return
//   None
//
-(void)dealloc
{
    DPRINT((@"[PoCoNewDocumentPanel dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// ɥ(ѥͥ)ɤ߹ޤ줿
//
//  Call
//    width_      : (outlet)
//    height_     : ⤵(outlet)
//    resolution_ : (outlet)
//    colorView_  : (outlet)
//
//  Return
//    None
//
-(void)windowDidLoad
{
    NSUserDefaults *def;

    def = [NSUserDefaults standardUserDefaults];

    [self->width_ setIntValue:(int)([def integerForKey:DEFAULT_WIDTH])];
    [self->height_ setIntValue:(int)([def integerForKey:DEFAULT_HEIGHT])];
    [self->resolution_ setIntValue:(int)([def integerForKey:DEFAULT_RESOLUTION])];
    [self->colorView_ setSelnum:(unsigned char)([def integerForKey:DEFAULT_COLOR])];

    return;
}


//
// 
//  modal session 򳫻
//
//  Call
//    None
//
//  Return
//    noNextOpen_ : 鳫ʤ(outlet)
//
-(void)startWindow
{
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];

    // (ξ)ɥȤ򳫤ʤ
    [self->noNextOpen_ setState:([editInfo noOpenNewDocPanel]) ? 1 : 0];

    // modal session 
    [NSApp runModalForWindow:[self window]];

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// ä
//
//  Call
//    sender      : о(api ѿ)
//    noNextOpen_ : 鳫ʤ(outlet)
//
//  Return
//    None
//
-(IBAction)cancelNewDocument:(id)sender
{
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];

    // (ξ)ɥȤ򳫤ʤ
    [editInfo setNoOpenNewDocPanel:([self->noNextOpen_ state] != 0)];

    // modal session λ
    [NSApp stopModal];

    // Ĥ
    [[self window] close];

    return;
}


//
// 
//
//  Call
//    sender      : о(api ѿ)
//    name_       : ̾(outlet)
//    width_      : (outlet)
//    height_     : ⤵(outlet)
//    resolution_ : (outlet)
//    colorView_  : (outlet)
//
//  Return
//    defaultColor_ : (instance ѿ)
//
-(IBAction)createNewDocument:(id)sender
{
    id newDoc;
    int w;
    int h;
    int r;
    NSString *nm;
    NSUserDefaults *def;

    // ͤμ
    w = [self->width_ intValue];
    h = [self->height_ intValue];
    r = [self->resolution_ intValue];
    if ((w <= 0) || (h <= 0) || (r <= 0)) {
        NSBeep();
        goto EXIT;
    }
    self->defaultColor_ = [self->colorView_ selnum];

    //  document 
    newDoc = [[MyDocument alloc] initWidth:w
                                initHeight:h
                            initResolution:r
                              defaultColor:self->defaultColor_];
    if (newDoc == nil) {
        DPRINT((@"can't make new document.\n"));
    } else {
        [[NSDocumentController sharedDocumentController] addDocument:newDoc];
        [newDoc makeWindowControllers];
        [newDoc showWindows];
        if ([[self->name_ stringValue] length] > 0) {
            nm = [[NSString stringWithString:[self->name_ stringValue]]
              stringByAppendingPathExtension:@"poco"];
            [newDoc setFileURL:[NSURL URLWithString:nm]];
        }

        // DocumentController ˰ϤΤ˺
        [newDoc release];
    }

    // ͤͤȤƵ
    def = [NSUserDefaults standardUserDefaults];

    [def setInteger:w forKey:DEFAULT_WIDTH];
    [def setInteger:h forKey:DEFAULT_HEIGHT];
    [def setInteger:r forKey:DEFAULT_RESOLUTION];
    [def setInteger:self->defaultColor_ forKey:DEFAULT_COLOR];

    // ѥͥĤ
    [self cancelNewDocument:sender];    // cancel μĤ

EXIT:
    return;
}

@end
