//
//	Pelistina on Cocoa - PoCo -
//	Ķѥͥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoPreferencesPanel.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"

// ============================================================================
@implementation PoCoPreferencesPanel

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//
-(id)init
{
    DPRINT((@"[PoCoPerferencesPanel init]\n"));

    // super class ν
    self = [super initWithWindowNibName:@"PoCoPreferencesPanel"];

    // Ȥν
    if (self != nil) {
        // ⤷ʤ
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoPreferencesPanel dealloc]\n"));

    // 񸻤β
    ;   // ⤷ʤ

    // super class ν
    [super dealloc];

    return;
}


//
// ɥɤ߹ޤ줿
//
//  Call
//    None
//
//  Return
//    None
//
-(void)windowDidLoad
{
    // ⤷ʤ
    ;

    return;
}


//
// ɥĤ(delegate method)
//
//  Call
//    note : (api ѿ)
//
//  Return
//    None
//
-(void)windowWillClose:(NSNotification *)note
{
#if 0   // Ƕɸॢץꥱˤʤä modal ˤʤ
    // modal session λ
    [NSApp stopModal];
#endif  // 0

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    enableUndo_         : äͭ(outlet)
//    enableLiveResize_   : LiveResize (outlet)
//    enableEraser_       : äͭ(outlet)
//    undoMax_            : ä(outlet)
//    enableColorBuffer_  : ݻ(outlet)
//    showSelectionFill_  : ΰɤĤ֤ɽ(outlet)
//    liveEditSelection_  : ϰϤԽɽ(outlet)
//    saveDocWindowPos_   : 祦ɥΰ֤򵭲(outlet)
//    holdSubWindowPos_   : ɥΰ֤(outlet)
//    showScrollerOnView_ : view  scroller ɽ(outlet)
//    pixelGrid_          : ԥ륰åɤδֳ(outlet)
//    showTransGrid_      : Ʃåɤɽ(outlet)
//    backColorR_         : طʿR(outlet)
//    backColorG_         : طʿG(outlet)
//    backColorB_         : طʿB(outlet)
//    previewQuality_     : ץӥ塼ʼ(outlet)
//    previewSize_        : ץӥ塼礭(outlet)
//    grayToAlpha_        : Grayscale Ʃ٤ˤ(outlet)
//    interGuide_         : ֶΥɥ饤ɽ(outlet)
//    interType_          : ֶμ(outlet)
//    interFreq_          : ֶ(outlet)
//    colorRange_         : ϰ(outlet)
//    syncWithSubView_    : ɽɥȤƱ(outlet)
//    syncWithPalette_    : 򿧤ȤƱ(outlet)
//
-(void)startWindow
{
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];

    // ä
    [self->enableUndo_ setState:([editInfo enableUndo]) ? 1 : 0];

    // ä
    [self->undoMax_ setIntValue:[editInfo undoMaxLevel]];

    // LiveResize 
    [self->enableLiveResize_ setState:([editInfo enableLiveResize]) ? 1 : 0];

    // äͭ
    [self->enableEraser_ setState:([editInfo enableEraser]) ? 1 : 0];

    // ݻ
    [self->enableColorBuffer_ setState:([editInfo enableColorBuffer]) ? 1 : 0];

    // ΰɤĤ֤ɽ
    [self->showSelectionFill_ setState:([editInfo selectionFill]) ? 1 : 0];

    // ϰϤԽɽ
    [self->liveEditSelection_ setState:([editInfo liveEditSelection]) ? 1 : 0];

    // 祦ɥΰ֤򵭲
    [self->saveDocWindowPos_ setState:([editInfo saveDocWindowPos]) ? 1 : 0];

    // ɥΰ֤
    [self->holdSubWindowPos_ setState:([editInfo holdSubWindowPos]) ? 1 : 0];

    // view  scroller ɽ
    switch ([editInfo showScrollerView]) {
        default:
        case PoCoScrollerType_default:
            [self->showScrollerView_ setState:1 atRow:0 column:0];
            [self->showScrollerView_ setState:0 atRow:0 column:1];
            [self->showScrollerView_ setState:0 atRow:0 column:2];
            break;
        case PoCoScrollerType_always:
            [self->showScrollerView_ setState:0 atRow:0 column:0];
            [self->showScrollerView_ setState:1 atRow:0 column:1];
            [self->showScrollerView_ setState:0 atRow:0 column:2];
            break;
        case PoCoScrollerType_overlay:
            [self->showScrollerView_ setState:0 atRow:0 column:0];
            [self->showScrollerView_ setState:0 atRow:0 column:1];
            [self->showScrollerView_ setState:1 atRow:0 column:2];
            break;
    }

    // ԥ륰åɤδֳ
    [self->pixelGrid_ setIntValue:[[editInfo supplement] gridStep]];

    // Ʃåɤɽ
    [self->showTransGrid_ setState:([[editInfo supplement] isPattern]) ? 1 : 0];

    // طʿRGB
    [self->backColorR_ setIntValue: ([[editInfo supplement] backgroundColor] & 0x000000ff)       ];
    [self->backColorG_ setIntValue:(([[editInfo supplement] backgroundColor] & 0x0000ff00) >>  8)];
    [self->backColorB_ setIntValue:(([[editInfo supplement] backgroundColor] & 0x00ff0000) >> 16)];

    // ץӥ塼ʼ礭
    [self->previewQuality_ setIntValue:[editInfo previewQuality]];
    [self->previewSize_ setIntValue:[editInfo previewSize]];

    // Grayscale Ʃ٤ˤ
    [self->grayToAlpha_ setState:([editInfo grayToAlpha]) ? 1 : 0];

    // ֶΥɥ饤ɽ
    switch ([editInfo interGuide]) {
        default:
        case PoCoInterpolationGuideView_Line:
            [self->interGuide_ setState:1 atRow:0 column:0];
            [self->interGuide_ setState:0 atRow:0 column:1];
            [self->interGuide_ setState:0 atRow:0 column:2];
            break;
        case PoCoInterpolationGuideView_Curve:
            [self->interGuide_ setState:0 atRow:0 column:0];
            [self->interGuide_ setState:1 atRow:0 column:1];
            [self->interGuide_ setState:0 atRow:0 column:2];
            break;
        case PoCoInterpolationGuideView_CurveLine:
            [self->interGuide_ setState:0 atRow:0 column:0];
            [self->interGuide_ setState:0 atRow:0 column:1];
            [self->interGuide_ setState:1 atRow:0 column:2];
            break;
    }

    // ֶμ
    switch ([editInfo interType]) {
        default:
        case PoCoCurveWithPoints_Lagrange:
            [self->interType_ setState:1 atRow:0 column:0];
            [self->interType_ setState:0 atRow:0 column:1];
            break;
        case PoCoCurveWithPoints_Spline:
            [self->interType_ setState:0 atRow:0 column:0];
            [self->interType_ setState:1 atRow:0 column:1];
            break;
    }

    // ֶ
    [self->interFreq_ setIntValue:[editInfo interFreq]];

    // ϰ
    [self->colorRange_ setIntValue:[editInfo colorRange]];

    // ɽɥȤƱ
    [self->syncWithSubView_ setState:([editInfo syncSubView]) ? 1 : 0];

    // ɽɥȤƱ
    [self->syncWithPalette_ setState:([editInfo syncPalette]) ? 1 : 0];

#if 0   // Ƕɸॢץꥱˤʤä modal ˤʤ
    // modal session 
    [NSApp runModalForWindow:[self window]];
#endif  // 0

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// äͭ
//
//  Call
//    sender      : о(api ѿ)
//    enableUndo_ : äͭ(outlet)
//
//  Return
//    None
//
-(IBAction)enableUndo:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setEnableUndo:([self->enableUndo_ state] != 0)];

    return;
}


//
// ä
//
//  Call
//    sender   : о(api ѿ)
//    undoMax_ : ä(outlet)
//
//  Return
//    None
//
-(IBAction)undoMax:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setUndoMaxLevel:[self->undoMax_ intValue]];

    return;
}


//
// LiveResize 
//
//  Call
//    sender            : о(api ѿ)
//    enableLiveResize_ : LiveResize (outlet)
//
//  Return
//    None
//
-(IBAction)enableLiveResize:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setEnableLiveResize:([self->enableLiveResize_ state] != 0)];

    return;
}


//
// äͭ
//
//  Call
//    sender        : о(api ѿ)
//    enableEraser_ : äͭ(outlet)
//
//  Return
//    None
//
-(IBAction)enableEraser:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setEnableEraser:([self->enableEraser_ state] != 0)];

    return;
}


//
// ݻ
//
//  Call
//    sender             : о(api ѿ)
//    enableColorBuffer_ : ݻ(outlet)
//
//  Return
//    None
//
-(IBAction)enableColorBuffer:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setEnableColorBuffer:([self->enableColorBuffer_ state] != 0)];

    return;
}


//
// ΰɤĤ֤ɽ
//
//  Call
//    sender             : о(api ѿ)
//    showSelectionFill_ : ΰɤĤ֤ɽ(outlet)
//
//  Return
//    None
//
-(IBAction)showSelectionFill:(id)sender
{
    // ɥ饤õ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    // ȿ
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setSelectionFill:([self->showSelectionFill_ state] != 0)];

    // ɥ饤
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    return;
}


//
// ϰϤԽɽ
//
//  Call
//    sender             : о(api ѿ)
//    liveEditSelection_ : ϰϤԽɽ(outlet)
//
//  Return
//    None
//
-(IBAction)liveEditSelection:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setLiveEditSelection:([self->liveEditSelection_ state] != 0)];

#if 0   // äɬפǤϤʤ(Խ˥ѥͥʤƤǤʤ)
    // 
    [[NSNotificationCenter defaultCenter] postNotificationName:PoCoRedrawPicture
                                                        object:nil];
#endif  // 0

    return;
}


//
// 祦ɥΰ֤򵭲
//
//  Call
//    sender            : о(api ѿ)
//    saveDocWindowPos_ : 祦ɥΰ֤򵭲(outlet)
//
//  Return
//    None
//
-(IBAction)saveDocWindowPos:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setSaveDocWindowPos:([self->saveDocWindowPos_ state] != 0)];

    return;
}


//
// ɥΰ֤
//
//  Call
//    sender            : о(api ѿ)
//    holdSubWindowPos_ : ɥΰ֤(outlet)
//
//  Return
//    None
//
-(IBAction)holdSubWindowPos:(id)sender
{
    PoCoAppController *cntl = (PoCoAppController *)([NSApp delegate]);
    BOOL type;

    type = ([self->holdSubWindowPos_ state] != 0);
    [cntl subWindowHold:type];
    [[cntl editInfo] setHoldSubWindowPos:type];

    return;
}


//
// view  scroller ɽ
//
//  Call
//    sender            : о(api ѿ)
//    showScrollerView_ : view  scroller ɽ(outlet)
//
//  Return
//    None
//
-(IBAction)showScrollerView:(id)sender
{
    switch ([sender selectedColumn]) {
        default:
        case 0:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setShowScrollerView:PoCoScrollerType_default];
            [self->showScrollerView_ setState:1 atRow:0 column:0];
            [self->showScrollerView_ setState:0 atRow:0 column:1];
            [self->showScrollerView_ setState:0 atRow:0 column:2];
            break;
        case 1:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setShowScrollerView:PoCoScrollerType_always];
            [self->showScrollerView_ setState:0 atRow:0 column:0];
            [self->showScrollerView_ setState:1 atRow:0 column:1];
            [self->showScrollerView_ setState:0 atRow:0 column:2];
            break;
        case 2:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setShowScrollerView:PoCoScrollerType_overlay];
            [self->showScrollerView_ setState:0 atRow:0 column:0];
            [self->showScrollerView_ setState:0 atRow:0 column:1];
            [self->showScrollerView_ setState:1 atRow:0 column:2];
            break;
    }

    return;
}


//
// ԥ륰åɴֳ
//
//  Call
//    sender     : о(api ѿ)
//    pixelGrid_ : ԥ륰åɤδֳ(outlet)
//
//  Return
//    None
//
-(IBAction)pixelGrid:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setGridStep:(unsigned int)([self->pixelGrid_ intValue])];

    // 
    [[NSNotificationCenter defaultCenter] postNotificationName:PoCoRedrawPicture
                                                        object:nil];

    return;
}


//
// Ʃåɽ
//
//  Call
//    sender         : о(api ѿ)
//    showTransGrid_ : Ʃåɤɽ(outlet)
//
//  Return
//    None
//
-(IBAction)showTransGrid:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setPattern:([self->showTransGrid_ state] != 0)];

    // 
    [[NSNotificationCenter defaultCenter] postNotificationName:PoCoRedrawPicture
                                                        object:nil];

    return;
}


//
// طʿ
//
//  Call
//    sender      : о(api ѿ)
//    backColorR_ : طʿR(outlet)
//    backColorG_ : طʿG(outlet)
//    backColorB_ : طʿB(outlet)
//
//  Return
//    None
//
-(IBAction)backColor:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setBackgroundColor:(unsigned int)(0xff000000 | ([self->backColorB_ intValue] << 16) | ([self->backColorG_ intValue] << 8) | ([self->backColorR_ intValue]))];

    // 
    [[NSNotificationCenter defaultCenter] postNotificationName:PoCoRedrawPicture
                                                        object:nil];

    return;
}


//
// ץӥ塼ʼ
//
//  Call
//    sender          : о(api ѿ)
//    previewQuality_ : ץӥ塼ʼ(outlet)
//
//  Return
//    None
//
-(IBAction)previewQuality:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setPreviewQuality:(unsigned int)([self->previewQuality_ intValue])];

    // 
    [[NSNotificationCenter defaultCenter] postNotificationName:PoCoLayerPreviewUpdate
                                                        object:nil];

    return;
}


//
// ץӥ塼礭
//
//  Call
//    sender       : о(api ѿ)
//    previewSize_ : ץӥ塼礭(outlet)
//
//  Return
//    None
//
-(IBAction)previewSize:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setPreviewSize:(unsigned int)([self->previewSize_ intValue])];

    // 
    [[NSNotificationCenter defaultCenter] postNotificationName:PoCoLayerPreviewUpdate
                                                        object:nil];

    return;
}


//
// Grayscale Ʃ٤ˤ
//
//  Call
//    sender       : о(api ѿ)
//    grayToAlpha_ : Grayscale Ʃ٤ˤ(outlet)
//
//  Return
//    None
//
-(IBAction)grayToAlpha:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setGrayToAlpha:([self->grayToAlpha_ state] != 0)];

    return;
}


//
// ֶΥɥ饤ɽ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    interGuide_ : ֶΥɥ饤ɽ(outlet)
//
-(IBAction)interGuide:(id)sender
{
    // ɥ饤õ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    // ȿ
    switch ([sender selectedColumn]) {
        default:
        case 0:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setInterGuide:PoCoInterpolationGuideView_Line];
            [self->interGuide_ setState:1 atRow:0 column:0];
            [self->interGuide_ setState:0 atRow:0 column:1];
            [self->interGuide_ setState:0 atRow:0 column:2];
            break;
        case 1:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setInterGuide:PoCoInterpolationGuideView_Curve];
            [self->interGuide_ setState:0 atRow:0 column:0];
            [self->interGuide_ setState:1 atRow:0 column:1];
            [self->interGuide_ setState:0 atRow:0 column:2];
            break;
        case 2:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setInterGuide:PoCoInterpolationGuideView_CurveLine];
            [self->interGuide_ setState:0 atRow:0 column:0];
            [self->interGuide_ setState:0 atRow:0 column:1];
            [self->interGuide_ setState:1 atRow:0 column:2];
            break;
    }

    // ɥ饤
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    return;
}


//
// ֶμ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    interType_ : ֶμ(outlet)
//
-(IBAction)interType:(id)sender
{
    // ɥ饤õ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    // ȿ
    switch ([sender selectedColumn]) {
        default:
        case 0:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setInterType:PoCoCurveWithPoints_Lagrange];
            [self->interType_ setState:1 atRow:0 column:0];
            [self->interType_ setState:0 atRow:0 column:1];
            break;
        case 1:
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setInterType:PoCoCurveWithPoints_Spline];
            [self->interType_ setState:0 atRow:0 column:0];
            [self->interType_ setState:1 atRow:0 column:1];
            break;
    }

    // ɥ饤
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    return;
}


//
// ֶ
//
//  Call
//    sender     : о(api ѿ)
//    interFreq_ : ֶ(outlet)
//
//  Return
//    None
//
-(IBAction)intreFreq:(id)sender
{
    // ɥ饤õ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    // ȿ
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setInterFreq:(unsigned int)([self->interFreq_ intValue])];

    // ɥ饤
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    return;
}


//
// ϰ
//
//  Call
//    sender      : о(api ѿ)
//    colorRange_ : ϰ(outlet)
//
//  Return
//    None
//
-(IBAction)colorRange:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setColorRange:(int)([self->colorRange_ intValue])];

    return;
}


//
// ɽɥȤƱ
//
//  Call
//    sender           : о(api ѿ)
//    syncWithSubView_ : ɽɥȤƱ(outlet)
//
//  Return
//    None
//
-(IBAction)syncWithSubView:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setSyncSubView:([self->syncWithSubView_ state] != 0)];

    return;
}


//
// 򿧤ȤƱ
//
//  Call
//    sender           : о(api ѿ)
//    syncWithPalette_ : 򿧤ȤƱ(outlet)
//
//  Return
//    None
//
-(IBAction)syncWithPalette:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setSyncPalette:([self->syncWithPalette_ state] != 0)];

    return;
}

@end
