//
//	Pelistina on Cocoa - PoCo -
//	ѿѥͥ
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoCanvasResizePanel.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoLayer.h"
#import "PoCoPicture.h"
#import "PoCoControllerFactory.h"

// ѿ
static NSString *DEFAULT_FITTING = @"PoCoCanvasResizeDefaultFitting";

// ============================================================================
@implementation PoCoCanvasResizePanel

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    NSMutableDictionary *dic;
  
    dic = [NSMutableDictionary dictionary];

    // ƽͤ
    [dic setObject:[NSNumber numberWithBool:YES] forKey:DEFAULT_FITTING];

    // default 
    [[NSUserDefaults standardUserDefaults] registerDefaults:dic];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc : Խо
//
//  Return
//    function  : 
//    document_ : Խо(instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
{
    DPRINT((@"[PoCoCanvasResizePanel initWithDoc:]\n"));

    // super class ν
    self = [super initWithWindowNibName:@"PoCoCanvasResizePanel"];

    // Ȥν
    if (self != nil) {
        self->document_ = doc;
        [self->document_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    document_ : Խо(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoCanvasResizePanel dealloc]\n"));

    // 񸻤β
    [self->document_ release];
    self->document_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    document_ : Խо(instance ѿ)
//
//  Return
//    fit_    : (outlet)
//    width_  : (outlet)
//    height_ : ⤵(outlet)
//
-(void)startWindow
{
    PoCoRect *r;

    r = [[self->document_ picture] bitmapPoCoRect];

    [self->fit_ setState:[[NSUserDefaults standardUserDefaults]
                             boolForKey:DEFAULT_FITTING]]; // 
    [self->width_ setIntValue:[r width]];      // 
    [self->height_ setIntValue:[r height]];    // ⤵

    // modal session 
    [NSApp runModalForWindow:[self window]];

    [r release];

    return;
}


//
// ä
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)cancel:(id)sender;
{
    // Ĥ
    [[self window] close];

    // modal session λ
    [NSApp stopModal];

    return;
}


//
// 
//
//  Call
//    sender    : о(api ѿ)
//    fit_      : (outlet)
//    width_    : (outlet)
//    height_   : ⤵(outlet)
//    document_ : Խо(instance ѿ)
//
//  Return
//    None
//
-(IBAction)ok:(id)sender
{
    // Խֲ
    [self->document_ cancelEdit];

    // ¹
    [[(PoCoAppController *)([NSApp delegate]) factory] createCanvasResizer:YES
                                              isFit:([self->fit_ state] != 0)
                                              width:[self->width_ intValue]
                                             height:[self->height_ intValue]];

    // ܤ򵭲
    [[NSUserDefaults standardUserDefaults]
        setBool:([self->fit_ state] != 0)
         forKey:DEFAULT_FITTING];

    // Ĥ
    [self cancel:sender];               // cancel μĤ

    return;
}

@end
