//
//	Pelistina on Cocoa - PoCo -
//	ƥ㿧ΰ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoTextureColorView.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoTextureColorView

// --------------------------------------------------------- instance - private
//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// ι
//
//  Call
//    num : ֹ
//    evt : ٥
//
//  Return
//    function : ֹ
//
-(int)selColor:(int)num
         event:(NSEvent *)evt
{
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = ((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX);
    }

    return num;
}


//
// ɽѹ
//
//  Call
//    top_  : Ƭ(instace ѿ)
//    hori_ : ʿϰ(instace ѿ)
//    vert_ : ľϰ(instace ѿ)
//
//  Return
//    matrix_[] : ɽ(instance ѿ)
//
-(void)setMartix
{
    int x;
    int y;
    int idx;

    memset(self->matrix_, 0x00, (COLOR_MAX * sizeof(BOOL)));

    for (y = 0; y < self->vert_; (y)++) {
        idx = (self->top_ + (y * 16));
        for (x = 0; x < self->hori_; (x)++) {
            if (idx < COLOR_MAX) {
                self->matrix_[idx] = YES;
                (idx)++;
            }
        }
    }

    // ȯԤƤ
    [self setNeedsDisplay:YES];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//   
//  Call
//    frameRect : ΰ(api ѿ)
//     
//  Return
//    function  : 
//    top_      : Ƭ(instace ѿ)
//    hori_     : ʿϰ(instace ѿ)
//    vert_     : ľϰ(instace ѿ)
//    docCntl_  : document controller(instance ѿ)
//    matrix_[] : ɽ(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect;
{
    DPRINT((@"[PoCoColorReplaceColorView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->top_ = 0;
        self->hori_ = 1;
        self->vert_ = 1;
        self->docCntl_ = nil;
        memset(self->matrix_, 0x00, (COLOR_MAX * sizeof(BOOL)));

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_ : document controller(instanceѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoColorReplaceColorView dealloc]\n"));

    // 񸻤
    [self->docCntl_ release];
    self->docCntl_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ɽ׵
//
//  Call
//    rect      : ɽΰ(api ѿ)
//    top_      : Ƭ(instace ѿ)
//    matrix_[] : ɽ(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int l;

    DPRINT((@"[PoCoColorReplaceColorView drawRect]\n"));

    for (l = 0; l < COLOR_MAX; (l)++) {
        if (NSIntersectsRect(rect, [self numToRect:l])) {
            [self drawColor:l
                   isSelect:self->matrix_[l]
                     isDown:(l != self->top_)];
        }
    }

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return  
//    function : YES
// 
-(BOOL)isFlipped
{
    return YES;
}


//
// 1ʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : ɽ
//               NO  : ɽ
//    down     : YES : ɽ
//               NO  : 夬ɽ
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        isSelect:(BOOL)sel
          isDown:(BOOL)down
{
    NSRect  r;
    const PoCoPalette *plt = [[[self->docCntl_ currentDocument] picture] palette];
    const PoCoColor *col = [plt palette:num];

    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            if (down) {
                [[NSColor blackColor] set];
            } else {
                [[NSColor whiteColor] set];
            }
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            if (down) {
                [[NSColor whiteColor] set];
            } else {
                [[NSColor blackColor] set];
            }
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


// --------------------------------------------------- instance - public - 
//
// ʿϰ
//
//  Call
//    val : 
//
//  Return
//    hori_  : ʿϰ(instace ѿ)
//
-(void)setHoriRange:(int)val
{
    self->hori_ = val;
    [self setMartix];

    return;
}


//
// ľϰ
//
//  Call
//    val : 
//
//  Return
//    vert_ : ľϰ(instace ѿ)
//
-(void)setVertRange:(int)val
{
    self->vert_ = val;
    [self setMartix];

    return;
}


//
// ϰ(ξ)
//
//  Call
//    h : (ʿ)
//    v : (ľ)
//
//  Return
//    hori_  : ʿϰ(instace ѿ)
//    vert_ : ľϰ(instace ѿ)
//
-(void)setHoriRange:(int)h
       andVertRange:(int)v
            
{
    self->hori_ = h;
    self->vert_ = v;
    [self setMartix];

    return;
}


// ----------------------------------------------- instance - public - 
//
// Ƭ
//
//  Call
//    top_ : ܥǤ(instance ѿ)
//
//  Return
//    function : 
//
-(int)topIndex
{
    return self->top_;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    top_ : Ƭ(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    self->top_ = [self selColor:self->top_
                          event:evt];
    [self setMartix];

    return;
}

@end
