//
//	Pelistina on Cocoa - PoCo -
//	ƥѥͥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoTexturePanel.h"

#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"
#import "PoCoTextureColorView.h"

// ѿ
static NSString *TEXTURE_HSELRANGE = @"PoCoTextureHoriSelectionRange";
static NSString *TEXTURE_VSELRANGE = @"PoCoTextureVertSelectionRange";

// ============================================================================
@implementation PoCoTexturePanel

// ------------------------------------------------------------- class - public
//
// 
//
//  Call
//    None
//
//  Return
//    None
//
+(void)initialize
{
    NSMutableDictionary *dic;

    dic = [NSMutableDictionary dictionary];

    // ƽͤ
    [dic setObject:[NSNumber numberWithInt:1]
            forKey:TEXTURE_HSELRANGE];
    [dic setObject:[NSNumber numberWithInt:1]
            forKey:TEXTURE_VSELRANGE];

    // default 
    [[NSUserDefaults standardUserDefaults] registerDefaults:dic];

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    doc  : Խо
//    info : Խ
//
//  Return
//    function  : 
//    document_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//    isOk_     : ¹Ԥ뤫(instance ѿ)
//    base_     : texture δܿ(instance ѿ)
//    gradient_ : ǻø(instance ѿ)
//
-(id)initWithDoc:(MyDocument *)doc
    withEditInfo:(PoCoEditInfo *)info
{
    DPRINT((@"[PoCoTexturePanel initWithDoc:]\n"));

    // super class ν
    self = [super initWithWindowNibName:@"PoCoTexturePanel"];

    // Ȥν
    if (self != nil) {
        self->isOk_ = NO;
        self->base_ = nil;
        self->gradient_ = nil;
        self->document_ = doc;
        self->editInfo_ = info;
        [self->document_ retain];
        [self->editInfo_ retain];

        // ꥹȤ
        self->base_ = [[NSMutableArray alloc] init];
        if (self->base_ == nil) {
            DPRINT((@"can't alloc base colors table.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
        self->gradient_ = [[NSMutableArray alloc] init];
        if (self->gradient_ == nil) {
            DPRINT((@"can't alloc gradient colors table.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    document_ : Խо(instance ѿ)
//    editInfo_ : Խ(instance ѿ)
//    base_     : texture δܿ(instance ѿ)
//    gradient_ : ǻø(instance ѿ)
//
-(void)dealloc
{
    NSEnumerator *iter;
    PoCoBaseGradientPair *obj;

    DPRINT((@"[PoCoTexturePanel dealloc]\n"));

    // ˴
    iter = [self->gradient_ objectEnumerator];
    for (obj = [iter nextObject]; obj != nil; obj = [iter nextObject]) {
        [(NSMutableArray *)([obj colors]) removeAllObjects];
    }
    [self->gradient_ removeAllObjects];
    [self->base_ removeAllObjects];

    // 񸻤β
    [self->document_ release];
    [self->editInfo_ release];
    [self->base_ release];
    [self->gradient_ release];
    self->document_ = nil;
    self->editInfo_ = nil;
    self->base_ = nil;
    self->gradient_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// 
//
//  Call
//    Nnoe
//
//  Return
//    horiRangeEdit_ : ʿϰ(ǻøϰ)(outlet)
//    vertRangeEdit_ : ľϰ(ܿϰ)(outlet)
//
-(void)startWindow
{
    // ϰϤͤ
    [self->horiRangeEdit_ setIntegerValue:[[NSUserDefaults standardUserDefaults] integerForKey:TEXTURE_HSELRANGE]];
    [self->vertRangeEdit_ setIntegerValue:[[NSUserDefaults standardUserDefaults] integerForKey:TEXTURE_VSELRANGE]];

    [self->gradientView_ setHoriRange:(int)([[NSUserDefaults standardUserDefaults] integerForKey:TEXTURE_HSELRANGE])];
    [self->baseView_     setVertRange:(int)([[NSUserDefaults standardUserDefaults] integerForKey:TEXTURE_VSELRANGE])];
    [self->replaceView_  setHoriRange:(int)([[NSUserDefaults standardUserDefaults] integerForKey:TEXTURE_HSELRANGE])
                         andVertRange:(int)([[NSUserDefaults standardUserDefaults] integerForKey:TEXTURE_VSELRANGE])];

    // modal session 
    [NSApp runModalForWindow:[self window]];

    return;
}


// --------------------------------------------------- instance - public - 
//
// ¹Ԥ뤫
//
//  Call
//    isOk_ : ¹Ԥ뤫(instance ѿ)
//
//  Return
//    function : 
//
-(BOOL)isOk
{
    return self->isOk_;
}


//
// texture δܿ
//
//  Call
//    base_ : texture δܿ(instance ѿ)
//
//  Return
//    function : texture δܿ
//
-(NSArray *)base
{
    return (NSArray *)(self->base_);
}


//
// ǻø
//
//  Call
//    gradient_ : ǻø(instance ѿ)
//
//  Return
//    function : ǻø
//
-(NSArray *)gradient
{
    return (NSArray *)(self->gradient_);
}


// -------------------------------------------- instance - public - IBAction 
//
// ä
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)cancel:(id)sender
{
    // Ĥ
    [[self window] close];

    // modal session λ
    [NSApp stopModal];

    return;
}


//
// 
//
//  Call
//    sender         : о(api ѿ)
//    baseView_      : texture δܿΰ(outlet)
//    gradientView_  : ǻøΰ(outlet)
//    replaceView_   : ִΰ(outlet)
//    horiRangeEdit_ : ʿϰ(ǻøϰ)(outlet)
//    vertRangeEdit_ : ľϰ(ܿϰ)(outlet)
//
//  Return
//    isOk_ : ¹Ԥ뤫(instance ѿ)
//    base_     : texture δܿ(instance ѿ)
//    gradient_ : ǻø(instance ѿ)
//
-(IBAction)ok:(id)sender
{
    const int hori = (int)([self->horiRangeEdit_ integerValue]);
    const int vert = (int)([self->vertRangeEdit_ integerValue]);
    int val1;
    int val2;
    int cnt1;
    int cnt2;
    PoCoBaseGradientPair *pair;
    NSMutableArray *cl;

    // texture δܿ
    val1 = [self->baseView_ topIndex];
    for (cnt1 = 0; cnt1 < vert; (cnt1)++) {
        // ܿꥹȤϿ
        [self->base_ addObject:[NSNumber numberWithInt:val1]];

        // 
        if ((val1 + 16) < COLOR_MAX) {
            val1 += 16;
        }
    }

    // ǻø
    val1 = [self->gradientView_ topIndex];
    for (cnt1 = 0; cnt1 < hori; (cnt1)++) {
        cl = [[NSMutableArray alloc] init];
        val2 = [self->replaceView_ topIndex];
        if ((val2 + cnt1) < COLOR_MAX) {
            val2 += cnt1;
        }
        for (cnt2 = 0; cnt2 < vert; (cnt2)++) {
            // ִꥹȤϿ
            [cl addObject:[NSNumber numberWithInt:val2]];

            // 
            if ((val2 + 16) < COLOR_MAX) {
                val2 += 16;
            }
        }

        // ǻøִΥڥ
        pair = [[PoCoBaseGradientPair alloc] init:(unsigned int)(val1)
                                           colors:(NSArray *)(cl)];

        // ڥꥹȤϿ
        [self->gradient_ addObject:pair];
        [cl release];
        [pair release];

        // 
        if ((val1 + 16) < COLOR_MAX) {
            (val1)++;
        }
    }
#if 0
{
  int i1;
  int i2;

  printf("\n");
  printf("\n");
  printf("\n");
  printf("\n");
  printf("--------base colors\n");
  for (i1 = 0; i1 < [self->base_ count]; (i1)++) {
    printf("%3d, ", [(NSNumber *)([self->base_ objectAtIndex:i1]) intValue]);
  }
  printf("\n");

  printf("--------pair colors\n");
  for (i1 = 0; i1 < [self->gradient_ count]; (i1)++) {
    printf("%3d : ", [(PoCoBaseGradientPair *)([self->gradient_ objectAtIndex:i1]) base]);
    for (i2 = 0; i2 < [[(PoCoBaseGradientPair *)([self->gradient_ objectAtIndex:i1]) colors] count]; (i2)++) {
      printf("%3d, ", [(NSNumber *)([[(PoCoBaseGradientPair *)([self->gradient_ objectAtIndex:i1]) colors] objectAtIndex:i2]) intValue]);
    }
    printf("\n");
  }
}
#endif  // 0

    // ¹Ԥȴ
    self->isOk_ = YES;

    // ϰϤ򵭲
    [[NSUserDefaults standardUserDefaults] setInteger:[self->horiRangeEdit_ integerValue]
                                               forKey:TEXTURE_HSELRANGE];
    [[NSUserDefaults standardUserDefaults] setInteger:[self->vertRangeEdit_ integerValue]
                                               forKey:TEXTURE_VSELRANGE];

    // Ĥ
    [self cancel:sender];               // cancel μĤ

    return;
}


//
// ʿϰ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    gradientView_ : ǻøΰ(outlet)
//    replaceView_  : ִΰ(outlet)
//
-(IBAction)horiRangeEdit:(id)sender
{
    // ʿϢ³λΰȿ
    [self->gradientView_ setHoriRange:(int)([sender integerValue])];
    [self->replaceView_ setHoriRange:(int)([sender integerValue])];

    return;
}


//
// ľϰ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    baseView_    : texture δܿΰ(outlet)
//    replaceView_ : ִΰ(outlet)
//
-(IBAction)vertRangeEdit:(id)sender
{
    // ľϢ³λΰȿ
    [self->baseView_ setVertRange:(int)([sender integerValue])];
    [self->replaceView_ setVertRange:(int)([sender integerValue])];

    return;
}

@end
