//
//	Pelistina on Cocoa - PoCo -
//	顼ѥ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoColorPatternView.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoView.h"
#import "PoCoSelLayer.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"
#import "PoCoColorPattern.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerColorPatternSetter.h"

// 
static  unsigned int SEL_SIZE = 64;     // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 8;         // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoColorPatternView

// --------------------------------------------------------- instance - private
//
// observer Ͽ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)registObserver
{
    NSNotificationCenter *nc;

    nc = [NSNotificationCenter defaultCenter];
    if (nc != nil) {
        // Խоѹ
        [nc addObserver:self
               selector:@selector(changePicture:)
                   name:PoCoChangePicture
                 object:nil];   
    
        // ѥåѹ
        [nc addObserver:self
               selector:@selector(changePalette:)
                   name:PoCoChangePalette
                 object:nil];

        // ѹ
        [nc addObserver:self
               selector:@selector(changeColor:)
                   name:PoCoChangeColor
                 object:nil];

        // 顼ѥ󹹿
        [nc addObserver:self
               selector:@selector(changePattern:)
                   name:PoCoColorPatternSet
                 object:nil];
    }

    return;
}


//
// 줿ɸѴ
//
//  Call
//    p  : ºɸ(̾)
//    rb : YES : 
//         NO  : 
//
//  Return
//    function : ʿ̰
//
-(PoCoPoint *)toNormalPos:(PoCoPoint *)p
               isRightBot:(BOOL)rb
{
    PoCoPoint *np = [[PoCoPoint alloc] initX:([p x] / SEL_SIZE)
                                       initY:([p y] / SEL_SIZE)];
    if (rb) {
        [np moveX:-1 moveY:-1];
    }

    return np;
}


//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// 1ޥʬ
//
//  Call
//    num      : ֹ
//    isSelect : YES : ɽ
//               NO  : ɽ
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawCell:(int)num
       isSelect:(BOOL)sel
{
    NSRect r;
    NSImageRep *img;
    PoCoRect *pr;
    PoCoPicture *picture;
    PoCoColorPattern *pat;

    picture = [[self->docCntl_ currentDocument] picture];
    pat = [picture colpat:num];
    if (pat != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        pr = nil;
        if (sel) {
            [[NSColor whiteColor] set];
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            [[NSColor blackColor] set];
            [NSBezierPath fillRect:r];
            pr = [[PoCoRect alloc] initLeft:1
                                    initTop:1
                                  initRight:r.size.width
                                 initBottom:r.size.height];
        } else {
            pr = [[PoCoRect alloc] initLeft:0
                                    initTop:0
                                  initRight:SEL_SIZE
                                 initBottom:SEL_SIZE];
        }
        img = [pat preview:pr
                   palette:[picture palette]];
        [pr release];

        // ѥ
        if (img != nil) {
            [img drawAtPoint:r.origin];
            [img release];
        }
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frameRect : ΰ(api ѿ)
//
//  Return
//    function  : 
//    info_     : Խ(instance ѿ)
//    docCntl_  : document controller(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect
{
    DPRINT((@"[PoCoColorPatternView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->info_ = nil;
        self->docCntl_ = nil;

        // observer Ͽ
        [self registObserver];

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];

        // Խ
        self->info_ = [(PoCoAppController *)([NSApp delegate]) editInfo];
        [self->info_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    info_    : Խ(instance ѿ)
//    docCntl_ : document controller(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoColorPatternView dealloc]\n"));

    // observer Ͽ
    [[NSNotificationCenter defaultCenter] removeObserver:self];

    // 񸻤
    [self->info_ release];
    [self->docCntl_ release];
    self->info_ = nil;
    self->docCntl_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return
//    function : YES
//
-(BOOL)isFlipped
{
    return YES;
}


//
// ɽ׵
//
//  Call
//    rect  : ΰ(api ѿ)
//    info_ : Խ(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int i;
    int x;
    int y;
    int snum;
    PoCoRect *r;
    PoCoPoint *lt;
    PoCoPoint *rb;
    PoCoSelColor *scol;

//    DPRINT((@"[PoCoPaletteView drawRect]\n"));

    // 򿧾
    scol = [self->info_ selColor];
    snum = (([scol isUnder]) || ([scol isColor])) ? -1 : [scol num];

    // ϰϤλ
    r = [[PoCoRect alloc] initNSRect:rect];
    lt = [self toNormalPos:[r  lefttop] isRightBot:NO];
    rb = [self toNormalPos:[r rightbot] isRightBot:YES];
    if ((r == nil) || (lt == nil) || (rb == nil)) {
        ;
    } else {
        // ɽ
        if (([lt x] == [rb x]) && ([lt y] == [rb y])) {
            i = (([lt y] * H_MAX) + [lt x]);
            [self drawCell:i
                  isSelect:(i == snum)];
        } else if ([lt x] == [rb x]) {
            i = (([lt y] * H_MAX) + [lt x]);
            for (y = [lt y]; y <= [rb y]; (y)++, i += H_MAX) {
                [self drawCell:i
                      isSelect:(i == snum)];
            }
        } else if ([lt y] == [rb y]) {
            i = (([lt y] * H_MAX) + [lt x]);
            for (x = [lt x]; x <= [rb x]; (x)++, (i)++) {
                [self drawCell:i
                      isSelect:(i == snum)];
            }
        } else {
            for (y = [lt y]; y <= [rb y]; (y)++) {
                i = ((y * H_MAX) + [lt x]);
                for (x = [lt x]; x <= [rb x]; (x)++, (i)++) {
                    [self drawCell:i
                          isSelect:(i == snum)];
                }
            }
        }
    }
    [r release];
    [lt release];
    [rb release];

    return;
}


// -------------------------------------------- instance - public - observer 
//
// ɽڤؤ
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePicture:(NSNotification *)note
{
    // ñ
    [self setNeedsDisplay:YES];

    return;
}


//
// ѥåȤԽ
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePalette:(NSNotification *)note
{
    // ñ
    [self setNeedsDisplay:YES];

    return;
}


//
// 򿧤ڤؤ
//
//  Call
//    note  : 
//    info_ : Խ(instance ѿ)
//
//  Return
//    None
//
-(void)changeColor:(NSNotification *)note
{
    int onum;
    PoCoSelColor *scol;

    // 
    scol = [self->info_ oldColor];
    if ([scol isPattern]) {
        onum = [scol num];
        [self setNeedsDisplayInRect:[self numToRect:onum]];
    } else {
        onum = -1;
    }
    
    // ߤ
    scol = [self->info_ selColor];
    if (([scol isPattern]) && (onum != [scol num])) {
        [self setNeedsDisplayInRect:[self numToRect:[scol num]]];
    }

    return;
}


//
// 顼ѥ󹹿
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePattern:(NSNotification *)note
{
    // ñ
    [self setNeedsDisplay:YES];

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// ѥ
//
//  Call
//    sender   : о(api ѿ)
//    info_    : Խ(instance ѿ)
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(IBAction)setPattern:(id)sender
{
    MyDocument *doc;

    if ([[self->info_ selRect] empty]) {
        // ϰϤʤ̵
        ;
    } else if ([[self->info_ selColor] isPattern]) {
        doc = [self->docCntl_ currentDocument];

        // Ⱦõ
        [[doc view] drawGuideLine];

        // Υ顼ѥ򹹿
        [[(PoCoAppController *)([NSApp delegate]) factory]
            createColorPatternSetter:YES
                                 num:[[self->info_ selColor] num]
                               layer:[[[self->docCntl_ currentDocument] selLayer] sel]
                                rect:[self->info_ selRect]];

        // ɽ
        [[doc view] drawGuideLine];
    }

    return;
}


// ----------------------------------------- instance - public - ٥Ƚ
// 
// ܥ󥤥٥Ȥμ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    function : 
//
-(BOOL)acceptsFirstMouse:(NSEvent *)evt
{
    // Ƚ̵
    ;

    return YES;
}


//
// ܥ
//
//  Call
//    evt   : ȯ٥(api ѿ)
//    info_ : Խ(instance ѿ)
//
//  Return
//    None
//
-(void)mouseDown:(NSEvent *)evt
{
    int num;
    NSPoint p;
    PoCoSelColor *oldColor;
    
    // ֤
    p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];
    if ([self mouse:p inRect:[self bounds]]) {
        oldColor = [self->info_ selColor];

        // ֹ
        num = (((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX));
        if (([oldColor isColor]) || ([oldColor num] != num)) {
            // ڤؤ
            [self->info_ setSelPattern:num];

            // ڤؤ(Ȥ)
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoChangeColor
                              object:nil];
        }
    }

    return;
}

            
//
// ɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//  
-(void)mouseDragged:(NSEvent *)evt
{
    // ܥƱˤ
    [self mouseDown:evt];
  
    return;
} 

@end
