//
//	Pelistina on Cocoa - PoCo -
//	顼ѥ󥦥ɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoColorPatternWindow.h"

#import <Carbon/Carbon.h>

#import "PoCoAppController.h"
#import "PoCoColorPatternView.h"

// ============================================================================
@implementation PoCoColorPatternWindow

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    None
//
-(id)init
{
    DPRINT((@"[PoCoColorPatternWindow init]\n"));

    // super class 
    self = [super initWithWindowNibName:@"PoCoColorPatternWindow"];

    // Ȥ
    if (self != nil) {
        // ¸
        [self setWindowFrameAutosaveName:@"ColorPatternWindowPos"];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    DPRINT((@"[PoCoColorPatternWindow dealloc]\n"));

    // super class β
    [super dealloc];

    return;
}


//
// ɥɤ߹ޤ줿
//
//  Call
//    None
//
//  Return
//    None
//
-(void)windowDidLoad
{
    return;
}


//
// ɥĤ(delegate method)
//
//  Call
//    note : (api ѿ)
//
//  Return
//    None
//
-(void)windowWillClose:(NSNotification *)note
{
    [(PoCoAppController *)([NSApp delegate]) closedColorPatternWindow];

    return;
}
  
    
//
// äΰϤ
//
//  Call
//    sender : ɥ(api ѿ)
//  
//  Return
//    function : ä
//
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] undoManager];
}


//
// ѥ
//
//  Call
//    sender           : о
//    patternInfoView_ : 顼ѥ(outlet)
//
//  Return
//    None
//
-(void)setPattern:(id)sender
{
    // Τޤ޲
    [self->patternInfoView_ setPattern:sender];

    return;
}


// ----------------------------------------- instance - public - ٥Ȥμ
//
// 
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ڡ٥(keyDown)
    if ([evt keyCode] == kVK_Space) {
        if (!([evt isARepeat])) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoSpaceKeyEvent
                              object:[NSNumber numberWithBool:YES]];
        }
    } else {
        // super class ز
        [super keyDown:evt];
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ڡ٥(keyUp)
    if ([evt keyCode] == kVK_Space) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoSpaceKeyEvent
                          object:[NSNumber numberWithBool:NO]];
    } else {
        // super class ز
        [super keyUp:evt];
    }

    return;
}

@end
