//
//	Pelistina on Cocoa - PoCo -
//	Խ󥦥ɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoInformationWindow.h"

#import <Carbon/Carbon.h>

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"

// ============================================================================
@implementation PoCoInformationWindow

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//    info_    : Խ(instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoInformationWindow init]\n"));

    // super class 
    self = [super initWithWindowNibName:@"PoCoInformationWindow"];

    // Ȥ
    if (self != nil) {
        // Խμ
        self->info_ = [(PoCoAppController *)([NSApp delegate]) editInfo];
        [self->info_ retain];

        // observer Ͽ
        [[NSNotificationCenter defaultCenter]
            addObserver:self
               selector:@selector(editInfoChangePos:)
                   name:PoCoEditInfoChangePos object:nil];

        // ¸
        [self setWindowFrameAutosaveName:@"InformationWindowPos"];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    info_ : Խ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoInformationWindow dealloc]\n"));

    // 񸻤β
    [self->info_ release];
    self->info_ = nil;

    // observer Ͽ
    [[NSNotificationCenter defaultCenter] removeObserver:self];

    // super class β
    [super dealloc];

    return;
}


//
// ɸι()
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)editInfoChangePos:(NSNotification *)note
{
    PoCoEditInfoPos type = [[note object] intValue];

    // ѹ
    if (type & PoCoEditInfoPos_pictureRect) {
        [self displayPictureSize];
    }

    // ɽϰѹ
    if (type & PoCoEditInfoPos_viewRect) {
        [self displayDisplayRect];
    }

    // PD ְư
    if (type & PoCoEditInfoPos_pdPos) {
        [self displayPDPos];
    }

    // Խϰư
    if (type & PoCoEditInfoPos_pdRect) {
        [self displayPDRect];
    }

    // ϰѹ
    if (type & PoCoEditInfoPos_selRect) {
        [self displaySelectionRect];
    }

    return;
}


//
// ɥɤ߹ޤ줿
//
//  Call
//    None
//
//  Return
//    None
//
-(void)windowDidLoad
{
    // ɽ
    [self displayPictureSize];

    // ɽϰϤɽ
    [self displayDisplayRect];

    // PD ֤ɽ
    [self displayPDPos];

    // ԽϰϤɽ
    [self displayPDRect];

    // ϰϤɽ
    [self displaySelectionRect];

    return;
}


//
// ɥĤ(delegate method)
//
//  Call
//    note : (api ѿ)
//
//  Return
//    None
//
-(void)windowWillClose:(NSNotification *)note
{
    [(PoCoAppController *)([NSApp delegate]) closedInformationWindow];

    return;
}
  
    
//
// äΰϤ
//
//  Call
//    sender  : ɥ(api ѿ)
//  
//  Return
//    function : ä
//
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] undoManager];
}


// ------------------------------------------- instance - public - Ƥɽ
//
// ɽ
//
//  Call
//    info_       : Խ(instance ѿ)
//    sizeWidth_  : ⤵(outlet)
//    sizeHeight_ : (outlet)
//
//  Return
//   None
//
-(void)displayPictureSize
{
    PoCoRect *r;

    r = [self->info_ pictureRect];

    [self->sizeWidth_ setStringValue:[NSString stringWithFormat:@"%5d", [r width]]];
    [self->sizeHeight_ setStringValue:[NSString stringWithFormat:@"%5d", [r height]]];

    return;
}


//
// ɽϰϤɽ
//
//  Call
//    info_       : Խ(instance ѿ)
//    viewLeft_   : ɽ(outlet)
//    viewTop_    : ɽ(outlet)
//    viewRight_  : ɽ(outlet)
//    viewBottom_ : ɽ(outlet)
//
//  Return
//    None
//
-(void)displayDisplayRect
{
    PoCoRect *r;

    r = [self->info_ pictureView];

    [self->viewLeft_ setStringValue:[NSString stringWithFormat:@"%5d", [r left]]];
    [self->viewTop_ setStringValue:[NSString stringWithFormat:@"%5d", [r top]]];
    [self->viewRight_ setStringValue:[NSString stringWithFormat:@"%5d", [r right]]];
    [self->viewBottom_ setStringValue:[NSString stringWithFormat:@"%5d", [r bottom]]];

    return;
}


//
// PD ֤ɽ
//
//  Call
//    info_ : Խ(instance ѿ)
//    posX_ : PD ʿ(outlet)
//    posY_ : PD ľ(outlet)
//
//  Return
//    None
//
-(void)displayPDPos
{
    PoCoPoint *p;

    p = [self->info_ pdPos];

    [self->posX_ setStringValue:[NSString stringWithFormat:@"%5d", [p x]]];
    [self->posY_ setStringValue:[NSString stringWithFormat:@"%5d", [p y]]];

    return;
}


//
// ԽϰϤɽ
//
//  Call
//    info_      : Խ(instance ѿ)
//    posLeft_   : Ⱥ(outlet)
//    posTop_    : Ⱦ(outlet)
//    posRight_  : ȱ(outlet)
//    posBottom_ : Ȳ(outlet)
//    posWidth_  : (outlet)
//    posHeight_ : ȹ⤵(outlet)
//
//  Return
//    None
//
-(void)displayPDRect
{
    PoCoRect *r;

    r = [self->info_ pdRect];

    [self->posLeft_ setStringValue:[NSString stringWithFormat:@"%5d", [r left]]];
    [self->posTop_ setStringValue:[NSString stringWithFormat:@"%5d", [r top]]];
    [self->posRight_ setStringValue:[NSString stringWithFormat:@"%5d", [r right]]];
    [self->posBottom_ setStringValue:[NSString stringWithFormat:@"%5d", [r bottom]]];
    [self->posWidth_ setStringValue:[NSString stringWithFormat:@"%5d", [r width]]];
    [self->posHeight_ setStringValue:[NSString stringWithFormat:@"%5d", [r height]]];

    return;
}


//
// ϰϤɽ
//
//  Call
//    info_      : Խ(instance ѿ)
//    selLeft_   : (outlet)
//    selTop_    : (outlet)
//    selRight_  : (outlet)
//    selBottom_ : (outlet)
//    selWidth_  : (outlet)
//    selHeight_ : ⤵(outlet)
//
//  Return
//    None
//
-(void)displaySelectionRect
{
    PoCoRect *r;

    r = [self->info_ selRect];

    [self->selLeft_ setStringValue:[NSString stringWithFormat:@"%5d", [r left]]];
    [self->selTop_ setStringValue:[NSString stringWithFormat:@"%5d", [r top]]];
    [self->selRight_ setStringValue:[NSString stringWithFormat:@"%5d", [r right]]];
    [self->selBottom_ setStringValue:[NSString stringWithFormat:@"%5d", [r bottom]]];
    [self->selWidth_ setStringValue:[NSString stringWithFormat:@"%5d", [r width]]];
    [self->selHeight_ setStringValue:[NSString stringWithFormat:@"%5d", [r height]]];

    return;
}


// ----------------------------------------- instance - public - ٥Ȥμ
//
// 
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ڡ٥(keyDown)
    if ([evt keyCode] == kVK_Space) {
        if (!([evt isARepeat])) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoSpaceKeyEvent
                              object:[NSNumber numberWithBool:YES]];
        }
    } else {
        // super class ز
        [super keyDown:evt];
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ڡ٥(keyUp)
    if ([evt keyCode] == kVK_Space) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoSpaceKeyEvent
                          object:[NSNumber numberWithBool:NO]];
    } else {
        // super class ز
        [super keyUp:evt];
    }

    return;
}

@end
