//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoLayerOperate.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoSelLayer.h"
#import "PoCoLayer.h"

#import "PoCoControllerFactory.h"
#import "PoCoControllerLayerBitmapAdder.h"
#import "PoCoControllerLayerStringAdder.h"
#import "PoCoControllerLayerDeleter.h"
#import "PoCoControllerLayerMover.h"
#import "PoCoControllerLayerDisplaySetter.h"
#import "PoCoControllerLayerLockSetter.h"
#import "PoCoControllerLayerNameSetter.h"
#import "PoCoControllerPictureLayerUnificater.h"

// 
enum ColumnType {                       // ɽηζʬ
    ColumnType_Display,                 // ɽ/ɽ
    ColumnType_DrawLock,                // Խ/ػ
    ColumnType_LayerType,               // 쥤䡼̾
    ColumnType_Sample,                  // 
    ColumnType_Name                     // 쥤䡼̾
};

// ============================================================================
@implementation PoCoLayerOperate

// --------------------------------------------------------- instance - private
//
// observer Ͽ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)registObserver
{
    NSNotificationCenter *nc;

    nc = [NSNotificationCenter defaultCenter];
    if (nc != nil) {
        // Խоѹ
        [nc addObserver:self            // Խоѹ
               selector:@selector(changePicture:)
                   name:PoCoChangePicture
                 object:nil];
        [nc addObserver:self            // ѹ
               selector:@selector(changePicture:)
                   name:PoCoCanvasResize
                 object:nil];
        [nc addObserver:self            // ڤȴ
               selector:@selector(changePicture:)
                   name:PoCoImageClip
                 object:nil];

        // ѥåѹ
        [nc addObserver:self
               selector:@selector(changePalette:)
                   name:PoCoChangePalette
                 object:nil];

        // 쥤䡼¤ѹ
        [nc addObserver:self
               selector:@selector(editLayer:)
                   name:PoCoEditLayer
                 object:nil];

        // Խμ
        [nc addObserver:self
               selector:@selector(editPicture:)
                   name:PoCoEditPicture
                 object:nil];

        // 쥤䡼ܤι
        [nc addObserver:self
               selector:@selector(updatePreview:)
                   name:PoCoLayerPreviewUpdate
                 object:nil];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function       : 
//    docCntl_       : document controller(instance ѿ)
//    selLayer_      : 쥤䡼(instance ѿ)
//    targetRow_     : ưɸ(instance ѿ)
//    info_          : Խ(instance ѿ)
//    prevSelectRow_ : (instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoLayerOperate init]\n"));

    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->selLayer_ = nil;
        self->targetRow_ = -1;
        self->prevSelectRow_ = -1;

        // observer Ͽ
        [self registObserver];

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        self->selLayer_ = [[self->docCntl_ currentDocument] selLayer];
        [self->docCntl_ retain];
        [self->selLayer_ retain];

        // Խ
        self->info_ = [(PoCoAppController *)([NSApp delegate]) editInfo];
        [self->info_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_  : document controller(instance ѿ)
//    selLayer_ : 쥤䡼(instance ѿ)
//    info_     : Խ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoLayerOperate dealloc]\n"));

    // observer Ͽ
    [[NSNotificationCenter defaultCenter] removeObserver:self];

    // 񸻤β
    [self->docCntl_ release];
    [self->selLayer_ release];
    [self->info_ release];
    self->docCntl_ = nil;
    self->selLayer_ = nil;
    self->info_ = nil;

    // super class β
    [super dealloc];

    return;
}


// -------------------------------------------- instance - public - observer 
//
// ɽڤؤ()
//
//  Call
//    note       : 
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(void)changePicture:(NSNotification *)note
{
    // 쥤䡼 current ΤΤѹ
    if ([[self->docCntl_ currentDocument] selLayer] != nil) {
        // ʬ˺
        [self->selLayer_ release];
        self->selLayer_ = nil;

        // ΤΤ򵭲
        self->selLayer_ = [[self->docCntl_ currentDocument] selLayer];
        [self->selLayer_ retain];

        // ɽ
        [self->layerList_ reloadData];

        // ɽ/оݤڤؤ
        [self->layerList_ selectRowIndexes:[NSIndexSet indexSetWithIndex:([[[[self->docCntl_ currentDocument] picture] layer] count] - [self->selLayer_ sel] - 1)]
                      byExtendingSelection:NO];
    }

    return;
}


//
// ѥåȤԽ()
//
//  Call
//    note       : 
//    layerList_ : ɽ(outlet)
//
//  Return
//    None
//
-(void)changePalette:(NSNotification *)note
{
    // ɽɽ򹹿
    [self->layerList_ reloadData];

    return;
}


//
// 쥤䡼¤ѹ()
//
//  Call
//    note       : 
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(void)editLayer:(NSNotification *)note
{
    // ɽ򹹿
    if ([[note object] boolValue]) {
        // ¤ưʤΤ
        [self->layerList_ reloadData];

        // ֹϤ߽Фʤ褦ˤ
        if ([[[[self->docCntl_ currentDocument] picture] layer] count] <= [self->selLayer_ sel]) {
            [self->selLayer_ setSel:((int)([[[[self->docCntl_ currentDocument] picture] layer] count]) - 1)];
        }
    } else {
        // ñ
        [self->layerList_ setNeedsDisplay:YES];
    }

    return;
}


//
// Խ()
//
//  Call
//    note       : 
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)editPicture:(NSNotification *)note
{
    NSRect r;
    int cnt;
    PoCoEditPictureNotification *obj;

    obj = [note object];
    if (obj != nil) {
        // оݥ쥤䡼Τ߹
        cnt = (int)([[[[self->docCntl_ currentDocument] picture] layer] count]);
        r = NSIntersectionRect([self->layerList_ rectOfRow:(cnt - [obj index] - 1)], 
                               [self->layerList_ rectOfColumn:ColumnType_Sample]);
        [[[self->docCntl_ currentDocument] picture] updateLayerPreview:[obj index]];
        [self->layerList_ setNeedsDisplayInRect:r];
    } else {
        // 
        [[[self->docCntl_ currentDocument] picture] updateLayerPreview:-1];
        [self->layerList_ reloadData];
    }

    return;
}


//
// ܹ()
//
//  Call
//    note       : 
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)updatePreview:(NSNotification *)note
{
    // 
    [[[self->docCntl_ currentDocument] picture] updateLayerPreview:-1];
    [self->layerList_ reloadData];

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// 쥤䡼
//
//  Call
//    sender     : о
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//    info_      : Խ(instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(IBAction)newBitmapLayer:(id)sender
{
    id cntl;

    // ѹ(Խ֤)
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoSelLayerChange
                      object:nil];

    // Խ
    cntl = [[(PoCoAppController *)([NSApp delegate]) factory]
               createLayerBitmapAdder:NO
                                color:[[self->info_ selColor] num]];
    if ([cntl execute]) {
        // 쥤䡼ڤؤ
        [self->selLayer_ setSel:((int)([[[[self->docCntl_ currentDocument] picture] layer] count]) - 1)];
        [self->layerList_ selectRowIndexes:[NSIndexSet indexSetWithIndex:0]
                      byExtendingSelection:NO];
        [self->layerList_ scrollRowToVisible:0];
    }
    [cntl release];

    return;
}


//
// ʸ쥤䡼
//
//  Call
//    sender     : о
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//    info_      : Խ(instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(IBAction)newStringLayer:(id)sender
{
    id cntl;

    // ѹ(Խ֤)
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoSelLayerChange
                      object:nil];

    // Խ
    cntl = [[(PoCoAppController *)([NSApp delegate]) factory]
               createLayerStringAdder:NO
                                color:[[self->info_ selColor] num]];
    if ([cntl execute]) {
        // 쥤䡼ڤؤ
        [self->selLayer_ setSel:((int)([[[[self->docCntl_ currentDocument] picture] layer] count]) - 1)];
        [self->layerList_ selectRowIndexes:[NSIndexSet indexSetWithIndex:0]
                      byExtendingSelection:NO];
        [self->layerList_ scrollRowToVisible:0];
    }
    [cntl release];

    return;
}


//
// 쥤䡼
//
//  Call
//    sender     : о
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//    selLayer_  : 쥤䡼(instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(IBAction)deleteLayer:(id)sender
{
    id cntl;
    int cnt;
    int sel;

    // ѹ(Խ֤)
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoSelLayerChange
                      object:nil];

    // Խ
    cntl = [[(PoCoAppController *)([NSApp delegate]) factory]
               createLayerDeleter:NO
                            index:[self->selLayer_ sel]];
    if ([cntl execute]) {
        // 쥤䡼ڤؤ
        cnt = (int)([[[[self->docCntl_ currentDocument] picture] layer] count]);
        sel = [self->selLayer_ sel];
        if (sel >= cnt) {
            sel = (cnt - 1);
        } else if (sel > 0) {
            (sel)--;
        }
        [self->selLayer_ setSel:sel];
        [self->layerList_ selectRowIndexes:[NSIndexSet indexSetWithIndex:(cnt-sel-1)]
                      byExtendingSelection:NO];
        [self->layerList_ scrollRowToVisible:(cnt - sel - 1)];
    }
    [cntl release];

    return;
}


//
// ɽ쥤䡼
//
//  Call
//    sender     : о
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(IBAction)unificateLayer:(id)sender
{
    id cntl;

    // ѹ(Խ֤)
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoSelLayerChange
                      object:nil];

    // Խ
    cntl = [[(PoCoAppController *)([NSApp delegate]) factory]
               createPictureLayerUnificater:NO];
    if ([cntl execute]) {
        // 쥤䡼ڤؤ
        [self->selLayer_ setSel:((int)([[[[self->docCntl_ currentDocument] picture] layer] count]) - 1)];
        [self->layerList_ selectRowIndexes:[NSIndexSet indexSetWithIndex:0]
                      byExtendingSelection:NO];
        [self->layerList_ scrollRowToVisible:0];
    }
    [cntl release];

    return;
}


// --------------------------------------- instance - public - ѥǥꥲ
//
// Ԥ
//
//  Call
//    table : о(api ѿ)
//    row   : оݹ(api ѿ)
//
//  Return
//    function       : ( YES)
//    selLayer_      : 쥤䡼(instance ѿ)
//    prevSelectRow_ : (instance ѿ)
//
-(BOOL)tableView:(NSTableView *)table
 shouldSelectRow:(int)row
{
//    DPRINT((@"[PoCoLayerOperate tableView: shouldSelectRow:%d]\n", row));

    // ѹ(Խ֤)
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoSelLayerChange
                      object:nil];

    // 쥤䡼ڤؤ
    self->prevSelectRow_ = (int)([table selectedRow]);
    [self->selLayer_ setSel:((int)([table numberOfRows]) - row - 1)];

    return YES;
}


//
// Ԥ򤷤
//  ºݤڤؤä notify 
//
//  Call
//    note : 
//
//  Return
//    prevSelectRow_ : (instance ѿ)
//
-(void)tableViewSelectionDidChange:(NSNotification *)note
{
    // ˺(ڤؤͭʤΤǶŪ᤹ɬפʤ)
    self->prevSelectRow_ = -1;

    return;
}


//
// ͽưɸμ
//  ȼɲ api
//
//  Call
//    table      : о
//    targetRow_ : ɸ(instance ѿ)
//
//  Return
//    function : ɸ
//
-(int)targetRowInTableView:(NSTableView *)table
{
//    DPRINT((@"[PoCoLayerOperate targetRowInTableView]\n"));

    return self->targetRow_;
}


//
// ͽưɸ
//  ȼɲ api
//
//  Call
//    table : о
//    row   : ɸ
//
//  Return
//    targetRow_ : ɸ(instance ѿ)
//
-(void)tableView:(NSTableView *)table
    setTargetRow:(int)row
{
//    DPRINT((@"[PoCoLayerOperate tableView: setTargetRow:%d]\n", row));

    self->targetRow_ = row;

    return;
}


// ----------------------------- instance - public - ѥǡ᥽å
//
// Կμ
//
//  Call
//    table    : о(api ѿ)
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    function : Կ   
//      
-(int)numberOfRowsInTableView:(NSTableView *)table
{
//    DPRINT((@"[PoCoLayerOperate numberOfRowsInTableView]\n"));

    return (int)([[[[self->docCntl_ currentDocument] picture] layer] count]);
}


//
// ɽ
//
//  Call
//    table    : о(api ѿ)
//    column   : оݷ(api ѿ)
//    row      : оݹ(api ѿ)
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    function : ɽ
//
-(id)tableView:(NSTableView *)table
objectValueForTableColumn:(NSTableColumn *)column
                      row:(int)row
{
    NSString *identifier;
    NSMutableArray *layerArray;
    PoCoLayerBase *layer;

//    DPRINT((@"[PoCoLayerOperate tableView: objectValueForTableColumn: row:%d]\n", row));

    identifier = [column identifier];
    layerArray = [[[self->docCntl_ currentDocument] picture] layer];
    layer = [layerArray objectAtIndex:([layerArray count] - row - 1)];

    return [layer valueForKey:identifier];
}


//
// Խ
//
//  Call
//    table          : о(api ѿ)
//    object         : Խ(api ѿ)
//    column         : оݷ(api ѿ)
//    row            : оݹ(api ѿ)
//    docCntl_       : document controller(instance ѿ)
//    selLayer_      : 쥤䡼(instance ѿ)
//    prevSelectRow_ : (instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(void)tableView:(NSTableView *)table
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)column
             row:(int)row
{
    NSString *identifier;
    id cntl;
    int idx;
    int cnt;
    PoCoControllerFactory *factory = [(PoCoAppController *)([NSApp delegate]) factory];

//    DPRINT((@"[PoCoLayerOperate tableView: setObjectValue: ForTableColumn: row:%d]\n", row));

    // оݤϰ˼
    idx = [self->selLayer_ sel];
    cnt = (int)([[[[self->docCntl_ currentDocument] picture] layer] count]);
    if (idx < 0) {
        idx = 0;
    } else if (idx >= cnt) {
        idx = (cnt - 1);
    }

    // Խ
    cntl = nil;
    identifier = [column identifier];
    if ([identifier compare:@"isDisplay"] == NSOrderedSame) {
        // ɽ
        cntl = [factory createLayerDisplaySetter:NO
                                            disp:([object intValue] != 0)
                                           index:idx];
    } else if ([identifier compare:@"drawLock"] == NSOrderedSame) {
        // Խ
        cntl = [factory createLayerLockSetter:NO
                                         lock:([object intValue] != 0)
                                        index:idx];
    } else if ([identifier compare:@"name"] == NSOrderedSame) {
        // 쥤䡼̾
        cntl = [factory createLayerNameSetter:NO
                                         name:object
                                        index:idx];
    }

    // Խ¹
    [cntl execute];

    // 쥤䡼᤹
    if ((cntl != nil) && (self->prevSelectRow_ >= 0)) {
        [table selectRowIndexes:[NSIndexSet indexSetWithIndex:self->prevSelectRow_]
           byExtendingSelection:NO];
        [self->selLayer_ setSel:((int)([table numberOfRows]) - self->prevSelectRow_ - 1)];
    }
    [cntl release];

    return;
}


//
// ưμ¹
//  ȼɲ api
//
//  Call
//    table      : о
//    row        : ưɸ
//    copy       : YES : ʣ
//                 NO  : ư
//    layerList_ : ɽ(outlet)
//    docCntl_   : document controller(instance ѿ)
//    selLayer_  : 쥤䡼(instance ѿ)
//
//  Return
//    selLayer_ : 쥤䡼(instance ѿ)
//
-(void)tableView:(NSTableView *)table
       moveToRow:(int)row
          isCopy:(BOOL)copy
{
    id  cntl;
    int cnt;
    int sel;

//    DPRINT((@"[PoCoLayerOperate tableView: moveToRow:%d isCopy:%s]\n", row, (copy) ? "YES" : "NO"));

    cnt = (int)([[[[self->docCntl_ currentDocument] picture] layer] count]);
    if (row >= cnt) {
        sel = 0;
    } else {
        sel = (cnt - row);
    }
    cntl = [[(PoCoAppController *)([NSApp delegate]) factory]
               createLayerMover:NO
                            src:[self->selLayer_ sel]
                         target:sel
                           copy:copy];
    if ([cntl execute]) {
        // μ¹
        if (copy) {
            [self->layerList_ selectRowIndexes:[NSIndexSet indexSetWithIndex:(cnt - sel)]
                          byExtendingSelection:NO];
            [self->layerList_ scrollRowToVisible:(cnt - sel)];
        } else {
            if ([self->selLayer_ sel] < sel) {
                (sel)--;
            }
            [self->layerList_ selectRowIndexes:[NSIndexSet indexSetWithIndex:(cnt - sel - 1)]
                          byExtendingSelection:NO];
            [self->layerList_ scrollRowToVisible:(cnt - sel - 1)];
        }

        // 쥤䡼ڤؤ
        [self->selLayer_ setSel:sel];
    } else {
        // ñ˺Ƥ
        [table setNeedsDisplay:YES];
    }
    [cntl release];

    return;
}

@end
