//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼ơ֥
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoLayerTableView.h"

#import <Carbon/Carbon.h>

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoLayerOperate.h"

#import "PoCoMyDocument.h"
#import "PoCoView.h"

// ============================================================================
@implementation PoCoLayerTableView

// --------------------------------------------------------- instance - private
//
// ȯ
//
//  Call
//    row : оݹ
//
//  Return
//    None
//
-(void)setRedraw:(int)row
{
    NSRect r;

    r = [self rectOfRow:MIN([self numberOfRows] - 1, row)];
    r.origin.y -= 2.0;
    r.size.height += 2.0;
    [self setNeedsDisplayInRect:r];

    return;
}


// ---------------------------------------------------------- instance - public
//
// ɽ׵
//
//  Call
//    rect : ׵ΰ(api ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    NSRect r;
    PoCoLayerOperate *oprt = (PoCoLayerOperate *)([self delegate]);
    const int row = [oprt targetRowInTableView:self];

    // ̾¹
    [super drawRect:rect];

    // ưɽ
    if (row >= 0) {
        r = [self rectOfRow:MIN([self numberOfRows] - 1, row)];
        if (NSIntersectsRect(r, rect)) {
            [[NSColor blackColor] set];
            [NSBezierPath setDefaultLineWidth:(float)(2.0)];
            if (row >= [self numberOfRows]) {
                r.origin.y += r.size.height;
            }
            [NSBezierPath strokeLineFromPoint:r.origin
                                      toPoint:NSMakePoint(r.origin.x + r.size.width, r.origin.y)];
        }
    }

    return;
}


//
// ⤵
//
//  Call
//    None
//
//  Return
//    function : ⤵
//
-(CGFloat)rowHeight
{
    // ˥쥤䡼ץӥ塼礭 + 2 Ȥ
    return (CGFloat)([[(PoCoAppController *)([NSApp delegate]) editInfo] previewSize] + 2);
}


//
// ˥塼򹹿
//
//  Call
//    menu : menu(api ѿ)
//
//  Return
//    function : 
//
-(BOOL)validateMenuItem:(NSMenuItem *)menu
{
    BOOL result;

    if ([menu action] == @selector(selectAll:)) {
        result = ((PoCoView *)([(MyDocument *)([[NSDocumentController sharedDocumentController] currentDocument]) view]) != nil);
    } else {
        result = [super validateMenuItem:menu];
    }

    return result;
}


//   
// 
//
//  Call
//    sender : ˥塼ܤؤΥ󥹥(api ѿ)
//
//  Return
//    None
//
-(IBAction)selectAll:(id)sender
{
    [(PoCoView *)([(MyDocument *)([[NSDocumentController sharedDocumentController] currentDocument]) view]) selectAll:sender];

    return;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    isMoving_    : ư椫(instance ѿ)
//    isRightDown_ : ܥ󲡤(instance ѿ)
//    startRow_    : ưϹ(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    int row;
    int clm;
    NSPoint p;
    PoCoLayerOperate *oprt = (PoCoLayerOperate *)([self delegate]);

    p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];
    clm = (int)([self columnAtPoint:p]);
    if ((clm < 2) || (clm == 4)) {
        self->isMoving_ = NO;
    } else {
        self->isMoving_ = YES;
    }
    self->isRightDown_ = NO;

    if (self->isMoving_) {
        row = (int)([self rowAtPoint:p]);
        if (row >= 0) {
            if ([[self delegate] tableView:self shouldSelectRow:row]) {
                [self selectRowIndexes:[NSIndexSet indexSetWithIndex:row]
                  byExtendingSelection:NO];
            }
            self->startRow_ = row;
        }
        [oprt tableView:self setTargetRow:-1];
    } else {
        [super mouseDown:evt];
    }

    return;
}


//
// ɥå
//
//  Call
//    evt       : ȯ٥(api ѿ)
//    isMoving_ : ư椫(instance ѿ)
//
//  Return
//    None
//
-(void)mouseDragged:(NSEvent *)evt
{
    int row;
    NSRect  r;
    NSPoint p;
    PoCoLayerOperate *oprt = (PoCoLayerOperate *)([self delegate]);
    const int old = [oprt targetRowInTableView:self];

    if (self->isMoving_) {
        [[self superview] autoscroll:evt];

        // ɸ֤λ
        p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];
        if ([self mouse:p inRect:[self bounds]]) {
            row = (int)([self rowAtPoint:p]);
            if (row < 0) {
                row = (int)([self numberOfRows]);
            } else {
                r = [self rectOfRow:row];
                if (p.y > (r.origin.y + (r.size.height / 2))) {
                    row++;
                }
            }

            // ɸɽ׵ȯ
            if (row != old) {
                [oprt tableView:self setTargetRow:row];
                [self setRedraw:old];
                [self setRedraw:row];
            }
        }
    } else {
        [super mouseDragged:evt];
    }

    return;
}


//
// ܥ꡼
//
//  Call
//    evt          : ȯ٥(api ѿ)
//    isMoving_    : ư椫(instance ѿ)
//    startRow_    : ưϹ(instance ѿ)
//    isRightDown_ : ܥ󲡤(instance ѿ)
//
//  Return
//    isMoving_ : ư椫(instance ѿ)
//
-(void)mouseUp:(NSEvent *)evt
{
    PoCoLayerOperate *oprt = (PoCoLayerOperate *)([self delegate]);
    const int targetRow = [oprt targetRowInTableView:self];
    const BOOL isCopy = ((self->isRightDown_) ||
                         (([evt modifierFlags] & NSControlKeyMask) != 0));

    if (self->isMoving_) {
        [oprt tableView:self setTargetRow:-1];
        if (targetRow < 0) {
            [self setNeedsDisplay:YES];
        } else if ((isCopy) || (self->startRow_ != targetRow)) {
            [oprt tableView:self
                  moveToRow:targetRow
                     isCopy:isCopy];
        } else {
            [self setNeedsDisplay:YES];
        }
    } else {
        [super mouseUp:evt];
    }
    self->isMoving_ = NO;

    return;
}


//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    isRightDown_ : ܥ󲡤(instance ѿ)
//
-(void)rightMouseDown:(NSEvent *)evt
{
    self->isRightDown_ = YES;

    return;
}


//
// ܥ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    isRightDown_ : ܥ󲡤(instance ѿ)
//
-(void)rightMouseUp:(NSEvent *)evt
{
    self->isRightDown_ = NO;

    return;
}


//
// 
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ڡ٥(keyDown)
    if ([evt keyCode] == kVK_Space) {
        if (!([evt isARepeat])) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoSpaceKeyEvent
                              object:[NSNumber numberWithBool:YES]];
        }
    } else {
        // super class ز
        [super keyDown:evt];
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ڡ٥(keyUp)
    if ([evt keyCode] == kVK_Space) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoSpaceKeyEvent
                          object:[NSNumber numberWithBool:NO]];
    } else {
        // super class ز
        [super keyUp:evt];
    }

    return;
}

@end
