//
//	Pelistina on Cocoa - PoCo -
//	쥤䡼ɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoLayerWindow.h"

#import <Carbon/Carbon.h>

#import "PoCoAppController.h"
#import "PoCoLayerTableView.h"
#import "PoCoLayerOperate.h"

// 
#if 0
static const NSSize RESIZE_INC = (NSSize){1.0, 52.0};
#endif  // 0

// ============================================================================
@implementation PoCoLayerWindow

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//    docCntl_ : document controller(instance ѿ)
//
-(id)init
{
    // supler class ν
    self = [super initWithWindowNibName:@"PoCoLayerWindow"];

    // Ȥν
    if (self != nil) {
        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];

        // ¸
        [self setWindowFrameAutosaveName:@"LayerWindowPos"];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_ : document controller(instance ѿ)
//
-(void)dealloc
{
    // 񸻤β
    [self->docCntl_ release];
    self->docCntl_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ɥɤ߹ޤ줿
//
//  Call
//    scroller_ : scroller(outlet) 
//
//  Return
//    None
//
-(void)windowDidLoad
{
#if 0
    [[self window] setResizeIncrements:RESIZE_INC];
#endif  // 0

    // scrollbar ɽˤ
    [self->scroller_ setScrollerStyle:NSScrollerStyleLegacy];

    return;
}


//
// ɥĤ(delegate method)
//
//  Call
//    note : (api ѿ)
//
//  Return
//    None
//
-(void)windowWillClose:(NSNotification *)note
{
    [(PoCoAppController *)([NSApp delegate]) closedLayerWindow];

    return;
}


//  
// äΰϤ
//
//  Call
//    sender   : ɥ(api ѿ)
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    function : ä
//
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender
{
    return [[self->docCntl_ currentDocument] undoManager];
}


// ------------------------------------------- instance - public - ˥塼Ϣ
//
// 쥤䡼
//
//  Call
//    sender          : о
//    layerTableView_ : 쥤䡼ơ֥(outlet)
//
//  Return
//    None
//
-(void)newBitmapLayer:(id)sender
{
    [(PoCoLayerOperate *)([self->layerTableView_ delegate]) newBitmapLayer:sender];

    return;
}


//
// ʸ쥤䡼
//
//  Call
//    sender          : о
//    layerTableView_ : 쥤䡼ơ֥(outlet)
//
//  Return
//    None
//
-(void)newStringLayer:(id)sender
{
    [(PoCoLayerOperate *)([self->layerTableView_ delegate]) newStringLayer:sender];

    return;
}


//
// 쥤䡼
//
//  Call
//    sender          : о
//    layerTableView_ : 쥤䡼ơ֥(outlet)
//
//  Return
//    None
//
-(void)deleteLayer:(id)sender
{
    [(PoCoLayerOperate *)([self->layerTableView_ delegate]) deleteLayer:sender];

    return;
}


//
// ɽ쥤䡼
//
//  Call
//    sender          : о
//    layerTableView_ : 쥤䡼ơ֥(outlet)
//
//  Return
//    None
//
-(void)unificateLayer:(id)sender
{
    [(PoCoLayerOperate *)([self->layerTableView_ delegate]) unificateLayer:sender];

    return;
}


// ----------------------------------------- instance - public - ٥Ȥμ
//
// 
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ڡ٥(keyDown)
    if ([evt keyCode] == kVK_Space) {
        if (!([evt isARepeat])) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoSpaceKeyEvent
                              object:[NSNumber numberWithBool:YES]];
        }
    } else {
        // super class ز
        [super keyDown:evt];
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ڡ٥(keyUp)
    if ([evt keyCode] == kVK_Space) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoSpaceKeyEvent
                          object:[NSNumber numberWithBool:NO]];
    } else {
        // super class ز
        [super keyUp:evt];
    }

    return;
}

@end
