//
//	Pelistina on Cocoa - PoCo -
//	ѥåȾܺپ
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoPaletteInfoView.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

#import "PoCoControllerFactory.h"
#import "PoCoControllerPaletteIncrementer.h"
#import "PoCoControllerPaletteDecrementer.h"
#import "PoCoControllerPaletteAttributeSetter.h"


// 
static  unsigned int H_SIZE = 18;       // 1Ǥ(dot ñ)(ȴޤ)
static  unsigned int V_SIZE = 64;       // 1Ǥι⤵(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)
static  unsigned int SMPL_H = 16;       // ܤι⤵(dot ñ̡
static  unsigned int ELMT_H = 10;       // ͤι⤵(dot ñ)
static  unsigned int ATTR_H = 6;        // °ι⤵(dot ñ)
static  unsigned int SMPL_ELMT_H = 16 + (10 * 3);

typedef enum {                          // ֹּ̼
    PT_UNKNOWN,                         // 
    PT_SAMPLE,                          // 
    PT_R_ELEMENT_H,                     // Ǿ
    PT_R_ELEMENT_L,                     // ǲ
    PT_G_ELEMENT_H,                     // Ǿ
    PT_G_ELEMENT_L,                     // ǲ
    PT_B_ELEMENT_H,                     // Ǿ
    PT_B_ELEMENT_L,                     // ǲ
    PT_ATTR_MASK,                       // °(ɤػ)
    PT_ATTR_DROPPER,                    // °(ۤػ)
    PT_ATTR_TRANS                       // °(Ʃ)
} POS_TYPE;


// ޥ
#define DEF_POSINF  (POS_INF){-1, -1, PT_UNKNOWN}


// 
typedef struct _positionInfo {          // ־
    int num;                            // ΰֹ(bias ̤ȿ)
    int cnum;                           // ֹ(bias ȿǺѤ)
    POS_TYPE type;                      // ֹ
} POS_INF;

// ============================================================================
@implementation PoCoPaletteInfoView

// --------------------------------------------------------- instance - private
//
// observer Ͽ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)registObserver
{
    NSNotificationCenter *nc;

    nc = [NSNotificationCenter defaultCenter];
    if (nc != nil) {
        // Խоѹ
        [nc addObserver:self
               selector:@selector(changePicture:)
                   name:PoCoChangePicture
                 object:nil];

        // ѹ
        [nc addObserver:self
               selector:@selector(changeColor:)
                   name:PoCoChangeColor
                 object:nil];

         // ѥåѹ
        [nc addObserver:self
               selector:@selector(changePalette:)
                   name:PoCoChangePalette
                 object:nil];

         // ѥå°ѹ
        [nc addObserver:self
               selector:@selector(changePaletteAttr:)
                   name:PoCoChangePaletteAttr
                 object:nil];
    }

    return;
}


//
// ֹ椫ΰѴ
//  ֹȤꡢǤɽֹ(0 - 31 )
//
//  Call
//    num  : ֹ(0 - 31)
//    bias : view νļΥ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
          withBias:(float)bias
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * H_SIZE);
    r.origin.y = ((float)((num / H_MAX) * V_SIZE) + bias);
    r.size.width = (float)(H_SIZE);
    r.size.height = (float)(V_SIZE);

    return r;
}


//
// ɸ鿧ֹѴ
//
//  Call
//    p    : ɸ(view ѴѤ)
//    bias : view νļΥ
//
//  Return
//    function : ־
//
-(POS_INF)pointToNum:(NSPoint)p
            withBias:(float)bias
{
    POS_INF inf = DEF_POSINF;
    NSRect r;

    // ֹλ
    p = [PoCoPoint corrNSPoint:p];
    inf.num = (((int)(p.x) / H_SIZE) + (((int)(p.y - bias) / V_SIZE) * H_MAX));
    inf.cnum = (inf.num + ((int)(bias) * H_MAX));

    // ̤Ƚ
    r = [self numToRect:inf.num withBias:bias];
    if (p.y < (r.origin.y + (float)(SMPL_H))) {
        inf.type = PT_SAMPLE;
    } else if (p.y < (r.origin.y + (float)(SMPL_H + ELMT_H * 1))) {
        inf.type = (p.x < (r.origin.x + (float)(H_SIZE >> 1))) ?
                       PT_R_ELEMENT_H : PT_R_ELEMENT_L;
    } else if (p.y < (r.origin.y + (float)(SMPL_H + ELMT_H * 2))) {
        inf.type = (p.x < (r.origin.x + (float)(H_SIZE >> 1))) ?
                       PT_G_ELEMENT_H : PT_G_ELEMENT_L;
    } else if (p.y < (r.origin.y + (float)(SMPL_H + ELMT_H * 3))) {
        inf.type = (p.x < (r.origin.x + (float)(H_SIZE >> 1))) ?
                       PT_B_ELEMENT_H : PT_B_ELEMENT_L;
    } else if (p.y < (r.origin.y + (float)(SMPL_ELMT_H + ATTR_H * 1))) {
        inf.type = PT_ATTR_MASK;
    } else if (p.y < (r.origin.y + (float)(SMPL_ELMT_H + ATTR_H * 2))) {
        inf.type = PT_ATTR_DROPPER;
    } else if (p.y < (r.origin.y + (float)(SMPL_ELMT_H + ATTR_H * 3))) {
        inf.type = PT_ATTR_TRANS;
    }

    return inf;
}


//
// ʬΰǤκ򸡾
//
//  Call
//    dr   : ΰ跲()
//    cnt  : ΰ(dr )
//    num  : Ǥֹ
//    bias : ΰνļΥ
//
//  Return
//    function : YES : 򤬤
//
-(BOOL)isSectrect:(const NSRect *)dr
            count:(int)cnt
           number:(int)num
         withBias:(float)bias
{
    BOOL  result;
    int l;
    const NSRect r = [self numToRect:num withBias:bias];

    result = NO;

    for (l = 0; l < cnt; (l)++) {
        if (NSIntersectsRect(dr[l], r)) {
            result = YES;
            break;
        }
    }

    return result;
}


//
// Ȥ
//
//  Call
//    r    : ΰ
//    push : YES : 
//           NO  : 
//
//  Return
//    function : Ȥ򤵤äԤΰ
//
-(NSRect)frameRect:(NSRect)r
            isPush:(BOOL)push
{
    if (push) {
        [[NSColor blackColor] set];
    } else {
        [[NSColor whiteColor] set];
    }
    [NSBezierPath fillRect:r];

    (r.origin.x)++;
    (r.origin.y)++;
    (r.size.width)--;
    (r.size.height)--;

    if (push) {
        [[NSColor whiteColor] set];
    } else {
        [[NSColor blackColor] set];
    }
    [NSBezierPath fillRect:r];

    (r.size.width)--;
    (r.size.height)--;

    return r;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    rect : ΰ(api )
//
//  Return
//    function     : 
//    attrType_    : °Ϥоֹ(instance ѿ)
//    beforeTop_   : ɽ(instance ѿ)
//    docCntl_     : document controller(instance ѿ)
//    lockImage_   : ԽԲ(instance ѿ)
//    unlockImage_ : Խ(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect
{
    DPRINT((@"[PoCoPaletteInfoView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->attrType_ = -1;
        self->beforeTop_ = (float)(-1.0);
        self->docCntl_ = nil;
        self->lockImage_ = nil;
        self->unlockImage_ = nil;

        // observer Ͽ
        [self registObserver];

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_     : document controller(instance ѿ)
//    lockImage_   : ԽԲ(instance ѿ)
//    unlockImage_ : Խ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoPaletteIntoView dealloc]\n"));
    
    // observer Ͽ
    [[NSNotificationCenter defaultCenter] removeObserver:self];

    // 񸻤β
    [self->docCntl_ release];
    [self->lockImage_ release];
    [self->unlockImage_ release];
    self->docCntl_ = nil;
    self->lockImage_ = nil;
    self->unlockImage_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return
//    function : YES
//
-(BOOL)isFlipped
{
    return YES;                         //  YES
}


//
// ΰ clipping
//
//  Call
//    None
//
//  Return
//    function : NO
//
-(BOOL)wantsDefaultClipping
{
    return NO;                          //  NO
}


//
// ֤
//
//  Call
//    lock_ : Խ(outlet)
//
//  Return
//    lockImage_   : ԽԲ(instance ѿ)
//    unlockImage_ : Խ(instance ѿ)
//
-(void)setFirstState
{
    // 
    self->lockImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"palettelock" ofType:@"tiff"]];
    self->unlockImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"paletteunlock" ofType:@"tiff"]];

    // ѡĤξ
    if ([[(PoCoAppController *)([NSApp delegate]) editInfo] lockPalette]) {
        [self->lock_ setIntValue:1];
        [self->lock_ setImage:self->lockImage_];
    } else {
        [self->lock_ setIntValue:0];
        [self->lock_ setImage:self->unlockImage_];
    }
    [[self enclosingScrollView] setLineScroll:(float)(1.0)];

    return;
}


//
// ɽ׵
//
//  Call
//    rect       : ɽΰ(api )
//    beforeTop_ : ɽ(instance ѿ)
//
//  Return
//    beforeTop_ : ɽ(instance ѿ)
//
-(void)drawRect:(NSRect)rect
{
    int l;                              // (loop counter)
    NSInteger cnt;                      // ʬΰĿ
    int snum;                           // ֹ
    int cnum;                           // 迧ֹ
    const NSRect *dr;                   // ʬΰ
    const NSRect vr = [self visibleRect];
    PoCoSelColor *scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];

//    DPRINT((@"[PoCoPaletteInfoView drawRect:{%f, %f, %f, %f}\n", rect.origin.x, rect.origin.y, rect.size.width, rect.size.height));

    // ʬΰ
    [self getRectsBeingDrawn:&(dr)
                       count:&(cnt)];

    // 򿧤
    snum = ((([scol isUnder]) || ([scol isPattern])) ? -1 : [scol num]);

    // Ƥɽ
    cnum = (vr.origin.y * H_MAX);
    if (self->beforeTop_ != vr.origin.y) {
        for (l = 0; l < 32; (l)++, (cnum)++) {
            [self drawColor:l
                   withBias:vr.origin.y
                   isSelect:(cnum == snum)];
        }
    } else {
        self->beforeTop_ = vr.origin.y;
        for (l = 0; l < 32; (l)++, (cnum)++) {
            if ([self isSectrect:dr
                           count:(int)(cnt)
                          number:l
                        withBias:vr.origin.y]) {
                [self drawColor:l
                       withBias:vr.origin.y
                       isSelect:(cnum == snum)];
            }
        }
    }

    return;
}


//
// 1ʬɽ
//
//  Call
//    num       : ֹ(bias * 16 ­Τֹ)
//    bias      : view νļΥ
//    sel       : 򤷤Ƥ뿧
//    docCntl_  : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        withBias:(float)bias
        isSelect:(BOOL)sel
{
    int i;                              // Ǥ(͡
    NSRect er = [self numToRect:num     // 1Τΰ
                       withBias:bias];
    NSRect r;                           // 1ΰδ
    NSRect fr;                          // Ǥ(ΰ)
    BOOL isHLS = ([[(PoCoAppController *)([NSApp delegate]) editInfo] colorMode] == PoCoColorMode_HLS);
    int cnum = (num + ((int)(bias) * H_MAX));
    PoCoColor *col = [[[[self->docCntl_ currentDocument] picture] palette] palette:cnum];
    NSEnumerator *iter;
    NSColor *c;
    NSMutableDictionary *charAttr;      // ʸ°

    charAttr = nil;

    // طʤöõ
#if (MACOSX_DEPLOYMENT_TARGET >= MAC_OS_X_VERSION_10_14)
    iter = [[NSColor alternatingContentBackgroundColors] objectEnumerator];
#else   // (MACOSX_DEPLOYMENT_TARGET >= MAC_OS_X_VERSION_10_14)
    iter = [[NSColor controlAlternatingRowBackgroundColors] objectEnumerator];
#endif  // (MACOSX_DEPLOYMENT_TARGET >= MAC_OS_X_VERSION_10_14)
    c = [iter nextObject];
    [c set];
    if (num & 1) {
        c = [iter nextObject];
        [c set];
    }
    [NSBezierPath fillRect:er];

    if (col != nil) {
        // ʸ°
        charAttr = [[NSMutableDictionary alloc] init];
        if (charAttr != nil) {
            [charAttr setObject:[NSFont systemFontOfSize:8]
                         forKey:NSFontAttributeName];
            [charAttr setObject:[NSColor controlTextColor]
                         forKey:NSForegroundColorAttributeName];
        }

        // ܤ
        r = er;
        r.size.height = (float)(SMPL_H);
        fr = ((sel) ? [self frameRect:r isPush:NO] : r);
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:fr];
        r.origin.y += r.size.height;

        // red/hue Ǥ
        r.size.height = (float)(ELMT_H);
        i = ((isHLS) ? [col hue] : [col red]);
        [[NSString stringWithFormat:@"%X", (i / 0x10)]
                        drawAtPoint:NSMakePoint(r.origin.x + 3, r.origin.y)
                     withAttributes:charAttr];
        [[NSString stringWithFormat:@"%X", (i % 0x10)]
                        drawAtPoint:NSMakePoint(r.origin.x + 11, r.origin.y)
                     withAttributes:charAttr];
        r.origin.y += r.size.height;

        // green/lightness Ǥ
        i = ((isHLS) ? [col lightness] : [col green]);
        [[NSString stringWithFormat:@"%X", (i / 0x10)]
                        drawAtPoint:NSMakePoint(r.origin.x + 3, r.origin.y)
                     withAttributes:charAttr];
        [[NSString stringWithFormat:@"%X", (i % 0x10)]
                        drawAtPoint:NSMakePoint(r.origin.x + 11, r.origin.y)
                     withAttributes:charAttr];
        r.origin.y += r.size.height;

        // blue/saturation Ǥ
        i = ((isHLS) ? [col saturation] : [col blue]);
        [[NSString stringWithFormat:@"%X", (i / 0x10)]
                        drawAtPoint:NSMakePoint(r.origin.x + 3, r.origin.y)
                     withAttributes:charAttr];
        [[NSString stringWithFormat:@"%X", (i % 0x10)]
                        drawAtPoint:NSMakePoint(r.origin.x + 11, r.origin.y)
                     withAttributes:charAttr];
        r.origin.y += r.size.height;

        // 񤭶ػߤɽ
        r.size.height = (float)(ATTR_H);
        fr = [self frameRect:r isPush:[col isMask]];
        [[NSColor colorWithCalibratedRed:0.0
                                   green:1.0
                                    blue:0.0
                                   alpha:0.3] set];
        [NSBezierPath fillRect:fr];
        r.origin.y += r.size.height;

        // ۤػߤɽ
        fr = [self frameRect:r isPush:[col noDropper]];
        [[NSColor colorWithCalibratedRed:1.0
                                   green:1.0
                                    blue:0.0
                                   alpha:0.3] set];
        [NSBezierPath fillRect:fr];
        r.origin.y += r.size.height;

        // Ʃɽ
        fr = [self frameRect:r isPush:[col isTrans]];
        [[NSColor colorWithCalibratedRed:1.0
                                   green:0.0
                                    blue:0.0
                                   alpha:0.3] set];
        [NSBezierPath fillRect:fr];
        r.origin.y += r.size.height;
    }

    [charAttr release];
    return;
}


// -------------------------------------------- instance - public - observer 
//
// ɽڤؤ()
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePicture:(NSNotification *)note
{
    // ñ
    [self setNeedsDisplay:YES];

    return;
}


//
// 򿧤ڤؤ()
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changeColor:(NSNotification *)note
{
    int num;
    int onum;
    PoCoSelColor *scol;                 // 򿧾
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];
    NSRect vr = [self visibleRect];

    // 
    scol = [editInfo oldColor];
    if ([scol isColor]) {
        onum = [scol num];
        num = ([scol num] - (vr.origin.y * H_MAX));
        [self setNeedsDisplayInRect:[self numToRect:num
                                           withBias:vr.origin.y]];
    } else {
        onum = -1;
    }

    // ߤ
    scol = [editInfo selColor];
    if ([scol isColor]) {
        // 
        if (onum != [scol num]) {
            num = ([scol num] - (vr.origin.y * H_MAX));
            [self setNeedsDisplayInRect:[self numToRect:num
                                               withBias:vr.origin.y]];
        }

        // ɽ֤򿧤˥
        if ([editInfo syncPalette]) {
            num = ([scol num] / H_MAX);
            if ((num < (int)(vr.origin.y)) || (num > ((int)(vr.origin.y) + 1))){
                vr.origin.y = num;
                if (vr.origin.y < 0.0) {
                    vr.origin.y = 0.0;
                } else if (vr.origin.y > 14.0) {
                    vr.origin.y = 14.0;
                }
                if ([self scrollRectToVisible:vr]) {
                    [self setNeedsDisplay:YES];
                }
            }
        }
    }

    return;
}


//
// ѥåѹ()
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePalette:(NSNotification *)note
{
    int i;
    const NSRect vr = [self visibleRect];

    if ([note object] == nil) {
        [self setNeedsDisplay:YES];
    } else {
        i = ([[note object] intValue] - (vr.origin.y * H_MAX));
        if ((i >= 0) && (i <= 31)) {
            [self setNeedsDisplayInRect:[self numToRect:i
                                               withBias:vr.origin.y]];
       }
    }

    return;
}


//
// ѥå°ѹ()
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePaletteAttr:(NSNotification *)note
{
    int i;
    const NSRect vr = [self visibleRect];

    if ([note object] == nil) {
        [self setNeedsDisplay:YES];
    } else {
        i = ([[note object] intValue] & 0x0000ffff);
        if (i == 0x0000ffff) {
            [self setNeedsDisplay:YES];
        } else {
            i -= (vr.origin.y * H_MAX);
            if ((i >= 0) && (i <= 31)) {
                [self setNeedsDisplayInRect:[self numToRect:i
                                                   withBias:vr.origin.y]];
            }
        }
    }

    return;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ󥤥٥Ȥμ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    function : 
//
-(BOOL)acceptsFirstMouse:(NSEvent *)evt
{
    // Ƚ̵
    ;

    return YES;
}


//
// ܥ
//
//  Call
//    evt      : ȯ٥(api ѿ)
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    attrType_ : °Ϥоֹ(instance ѿ)
//    attrSet_  : °Ϥ(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    const NSRect vr = [self visibleRect];
    const POS_INF inf = [self pointToNum:[self convertPoint:[evt locationInWindow]
                                                   fromView:nil]
                                withBias:vr.origin.y];
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];
    PoCoColor *col;

    if ((inf.num >= 0) && (inf.num < 32)) {
        if ((inf.type == PT_ATTR_MASK) ||
            (inf.type == PT_ATTR_DROPPER) ||
            (inf.type == PT_ATTR_TRANS)) {
            // °ϤϥɥåμФ
            self->attrType_ = inf.type;
            col = [[[[self->docCntl_ currentDocument] picture] palette] palette:inf.cnum];
            self->attrSet_ = ((inf.type == PT_ATTR_MASK)    ? [col isMask] :
                              (inf.type == PT_ATTR_DROPPER) ? [col noDropper] :
                                                              [col isTrans]) ? NO : YES;
            [self mouseDragged:evt];
        } else if ([editInfo lockPalette]) {
            // lock ƤϿȤ(ΤϥɥåѤ)
            [self mouseDragged:evt];
        } else if ([editInfo colorMode] == PoCoColorMode_RGB) {
            // controller 
            switch (inf.type) {
                case PT_SAMPLE:
                    [[(PoCoAppController *)([NSApp delegate]) factory]
                        createPaletteIncrementer:YES
                                             num:inf.cnum
                                             red:YES
                                           green:YES
                                            blue:YES
                                            step:16];
                    break;
                case PT_R_ELEMENT_H:
                case PT_R_ELEMENT_L:
                    [[(PoCoAppController *)([NSApp delegate]) factory]
                        createPaletteIncrementer:YES
                                             num:inf.cnum
                                             red:YES
                                           green:NO
                                            blue:NO
                                            step:((inf.type == PT_R_ELEMENT_H) ? 16 : 1)];
                    break;
                case PT_G_ELEMENT_H:
                case PT_G_ELEMENT_L:
                    [[(PoCoAppController *)([NSApp delegate]) factory]
                        createPaletteIncrementer:YES
                                             num:inf.cnum
                                             red:NO
                                           green:YES
                                            blue:NO
                                            step:((inf.type == PT_G_ELEMENT_H) ? 16 : 1)];
                    break;
                case PT_B_ELEMENT_H:
                case PT_B_ELEMENT_L:
                    [[(PoCoAppController *)([NSApp delegate]) factory]
                        createPaletteIncrementer:YES
                                             num:inf.cnum
                                             red:NO
                                           green:NO
                                            blue:YES
                                            step:((inf.type == PT_B_ELEMENT_H) ? 16 : 1)];
                    break;
                default:
                    ;
                    break;
            }
        }
    }

    return;
}


//
// ɥå
//
//  Call
//    evt       : ȯ٥(api ѿ)
//    attrType_ : °Ϥоֹ(instance ѿ)
//    attrSet_  : °Ϥ(instance ѿ)
//    docCntl_  : document controller (instance ѿ)
//
//  Return
//    None
//
-(void)mouseDragged:(NSEvent *)evt
{
    const NSRect vr = [self visibleRect];
    const POS_INF inf = [self pointToNum:[self convertPoint:[evt locationInWindow]
                                                   fromView:nil]
                                withBias:vr.origin.y];
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];

    if ((inf.num >= 0) && (inf.num < 32)) {
        if (self->attrType_ == inf.type) {
            // °Խ
            [[(PoCoAppController *)([NSApp delegate]) factory]
                createPaletteAttributeSetter:YES
                                         num:inf.cnum
                                     setType:self->attrSet_
                                        mask:(inf.type == PT_ATTR_MASK)
                                     dropper:(inf.type == PT_ATTR_DROPPER)
                                       trans:(inf.type == PT_ATTR_TRANS)];
        } else if ((self->attrType_ == -1) &&
                   ([editInfo lockPalette]) &&
                   ([editInfo colorMode] == PoCoColorMode_RGB)) {
            // RGB ⡼ɤ lock ƤϿȤ
            if (([[editInfo selColor] isPattern]) ||
                ([[editInfo selColor] num] != inf.cnum)) {
                // ڤؤ
                [editInfo setSelColor:inf.cnum];

                // ڤؤ(Ȥ)
                [[NSNotificationCenter defaultCenter]
                    postNotificationName:PoCoChangeColor
                                  object:nil];
            }
        }
    }

    return;
}


//
// ܥ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    attrType_ : °Ϥоֹ(instance ѿ)
//
-(void)mouseUp:(NSEvent *)evt
{
    // оݤ˺
    self->attrType_ = -1;

    return;
}


//
// ܥ󥤥٥
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)rightMouseDown:(NSEvent *)evt
{
    const NSRect vr = [self visibleRect];
    const POS_INF inf = [self pointToNum:[self convertPoint:[evt locationInWindow]
                                                   fromView:nil]
                                withBias:vr.origin.y];
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];

    if ((!([editInfo lockPalette])) &&
        ([editInfo colorMode] == PoCoColorMode_RGB) &&
        ((inf.num >= 0) && (inf.num < 32))) {
        // controller 
        switch (inf.type) {
            case PT_SAMPLE:
                [[(PoCoAppController *)([NSApp delegate]) factory]
                    createPaletteDecrementer:YES
                                         num:inf.cnum
                                         red:YES
                                       green:YES
                                        blue:YES
                                        step:16];
                break;
            case PT_R_ELEMENT_H:
            case PT_R_ELEMENT_L:
                [[(PoCoAppController *)([NSApp delegate]) factory]
                    createPaletteDecrementer:YES
                                         num:inf.cnum
                                         red:YES
                                       green:NO
                                        blue:NO
                                        step:((inf.type == PT_R_ELEMENT_H) ? 16 : 1)];
                break;
            case PT_G_ELEMENT_H:
            case PT_G_ELEMENT_L:
                [[(PoCoAppController *)([NSApp delegate]) factory]
                    createPaletteDecrementer:YES
                                         num:inf.cnum
                                         red:NO
                                       green:YES
                                        blue:NO
                                        step:((inf.type == PT_G_ELEMENT_H) ? 16 : 1)];
                break;
            case PT_B_ELEMENT_H:
            case PT_B_ELEMENT_L:
                [[(PoCoAppController *)([NSApp delegate]) factory]
                    createPaletteDecrementer:YES
                                         num:inf.cnum
                                         red:NO
                                       green:NO
                                        blue:YES
                                        step:((inf.type == PT_B_ELEMENT_H) ? 16 : 1)];
                break;
            default:
                ;
                break;
        }
    }

    return;
}


//
// Wheel ž
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)scrollWheel:(NSEvent *)evt
{
    // ػ
    if ([evt phase] != NSEventPhaseNone) {
        [super scrollWheel:evt];
        [self setNeedsDisplay:YES];
    }

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// Խ
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    lock_        : Խ(outlet)
//    lockImage_   : ԽԲ(instance ѿ)
//    unlockImage_ : Խ(instance ѿ)
//
-(IBAction)lockPalette:(id)sender
{
    PoCoEditInfo *editInfo = [(PoCoAppController *)([NSApp delegate]) editInfo];

    [editInfo setLockPalette:(([editInfo lockPalette]) ? NO : YES)];
    if ([editInfo lockPalette]) {
        [self->lock_ setIntValue:1];
        [self->lock_ setImage:self->lockImage_];
    } else {
        [self->lock_ setIntValue:0];
        [self->lock_ setImage:self->unlockImage_];
    }

    return;
}


//
// 
//  window Ǥ keyDown ¹Ԥƺ褹ȤɤˤѤˤʤΤ
//  window  setNeedsDisplay 뤳ȤˤϤ(ä 10.14 ʹߤξ)
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)scrollUp:(id)sender
{
    NSRect r;

    r = [self visibleRect];
    r.origin.y -= 1.0;
    if (r.origin.y < 0.0) {
        r.origin.y = 0.0;
    }
    if ([self scrollRectToVisible:r]) {
        // keyDown ξ nil ǸƤ(keyDown ξ caller ؼ)
        if (sender != nil) {
            [self setNeedsDisplay:YES];
        }
    }

    return;
}


//
// 
//  window Ǥ keyDown ¹Ԥƺ褹ȤɤˤѤˤʤΤ
//  window  setNeedsDisplay 뤳ȤˤϤ(ä 10.14 ʹߤξ)
//
//  Call
//    sender : о(api ѿ)
//
//  Return
//    None
//
-(IBAction)scrollDown:(id)sender
{
    NSRect r;

    r = [self visibleRect];
    r.origin.y += 1.0;
    if (r.origin.y > 14.0) {
        r.origin.y = 14.0;
    }
    if ([self scrollRectToVisible:r]) {
        // keyDown ξ nil ǸƤ(keyDown ξ caller ؼ)
        if (sender != nil) {
            [self setNeedsDisplay:YES];
        }
    }

    return;
}

@end
