//
//	Pelistina on Cocoa - PoCo -
//	ɽ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoPaletteSelectColorView.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

// ============================================================================
@implementation PoCoPaletteSelectColorView

// --------------------------------------------------------- instance - private
//
// observer Ͽ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)registObserver
{
    NSNotificationCenter *nc;

    nc = [NSNotificationCenter defaultCenter];
    if (nc != nil) {
        // Խоѹ
        [nc addObserver:self
               selector:@selector(updateView:)
                   name:PoCoChangePicture
                 object:nil];

        // ѹ
        [nc addObserver:self
               selector:@selector(updateView:)
                   name:PoCoChangeColor
                 object:nil];

        // ѥåѹ
        [nc addObserver:self
               selector:@selector(updateView:)
                   name:PoCoChangePalette
                 object:nil];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frameRect : ΰ(api ѿ)
//
//  Return
//    function : 
//    docCntl_ : document controller(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect
{
    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        // observer Ͽ
        [self registObserver];

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_ : document controller(instance ѿ)
//
-(void)dealloc
{
    // observer Ͽ
    [[NSNotificationCenter defaultCenter] removeObserver:self];

    // 񸻤
    [self->docCntl_ release];
    self->docCntl_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ɽ
//  Τˤ
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)updateView:(NSNotification *)note
{
    // ñ
    [self setNeedsDisplay:YES];

    return;
}


//
// ׵
//
//  Call
//    rect     : ɽΰ(api ѿ)
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    NSRect r = [self bounds];
    PoCoSelColor *scol;
    PoCoColor *col;

    // Ȥ(ɸϤ Cocoa ɸΤޤ)
    [[NSColor blackColor] set];
    [NSBezierPath fillRect:r];
    (r.origin.x)++;
    (r.size.width)--;
    (r.size.height)--;
    [[NSColor whiteColor] set];
    [NSBezierPath fillRect:r];
    (r.origin.y)++;
    (r.size.width)--;
    (r.size.height)--;

    // 򿧤
    scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];
    if (([scol isUnder]) || ([scol isPattern])) {
        [[NSColor windowBackgroundColor] set];
    } else {
        col = [[[[self->docCntl_ currentDocument] picture] palette] palette:[scol num]];
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
    }
    [NSBezierPath fillRect:r];

    return;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ󥤥٥Ȥμ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    function : 
//
-(BOOL)acceptsFirstMouse:(NSEvent *)evt
{
    // Ƚ̵
    ;

    return YES;
}


//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)mouseDown:(NSEvent *)evt
{
    // ȿž
    [[(PoCoAppController *)([NSApp delegate]) editInfo] toggleUseUnderPattern];

    // ڤؤ(Ȥ)
    [[NSNotificationCenter defaultCenter] postNotificationName:PoCoChangeColor
                                                        object:nil];

    return;
}

@end
