//
//	Pelistina on Cocoa - PoCo -
//	ѥåɽ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoPaletteView.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"
#import "PoCoControllerFactory.h"
#import "PoCoControllerPaletteSingleSetter.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoPaletteView

// --------------------------------------------------------- instance - private
//
// observer Ͽ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)registObserver
{
    NSNotificationCenter *nc;

    nc = [NSNotificationCenter defaultCenter];
    if (nc != nil) {
        // Խоѹ
        [nc addObserver:self
               selector:@selector(changePicture:)
                   name:PoCoChangePicture
                 object:nil];

        // ѹ
        [nc addObserver:self
               selector:@selector(changeColor:)
                   name:PoCoChangeColor
                 object:nil];

        // ѥåѹ
        [nc addObserver:self
               selector:@selector(changePalette:)
                   name:PoCoChangePalette
                 object:nil];
        [nc addObserver:self
               selector:@selector(changePalette:)
                   name:PoCoChangePaletteAttr
                 object:nil];
    }

    return;
}


//
// 줿ɸѴ
//
//  Call
//    p  : ºɸ(̾)
//    rb : YES : 
//         NO  : 
//
//  Return
//    function : ѥåʿ̰
//
-(PoCoPoint *)toNormalPos:(PoCoPoint *)p
               isRightBot:(BOOL)rb
{
    PoCoPoint *np = [[PoCoPoint alloc] initX:([p x] / SEL_SIZE)
                                       initY:([p y] / SEL_SIZE)];
    if (rb) {
        [np moveX:-1 moveY:-1];
    }

    return np;
}


//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// ܺ٥ƥȤɽ
//
//  Call
//    number_               : ֹ(outlet)
//    elementR_             : (R)(outlet)
//    elementG_             : (G)(outlet)
//    elementB_             : (B)(outlet)
//    elementH_             : (H)(outlet)
//    elementL_             : (L)(outlet)
//    elementS_             : (S)(outlet)
//    attributeMask_        : ޥ(outlet)
//    attributeDropper_     : ۤػ(outlet)
//    attributeTransparent_ : Ʃ(outlet)
//    docCntl_              : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)showInfoText
{
    PoCoSelColor *scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];
    PoCoColor *col;

    if ([scol isColor]) {
        col = [[[[self->docCntl_ currentDocument] picture] palette] palette:[scol num]];

        // ɽ
        [self->number_ setStringValue:[NSString stringWithFormat:@"%03d", [scol num]]];
        [self->elementR_ setStringValue:[NSString stringWithFormat:@"0x%02X", [col red]]];
        [self->elementG_ setStringValue:[NSString stringWithFormat:@"0x%02X", [col green]]];
        [self->elementB_ setStringValue:[NSString stringWithFormat:@"0x%02X", [col blue]]];
        [self->elementH_ setStringValue:[NSString stringWithFormat:@"%03d", [col hue]]];
        [self->elementL_ setStringValue:[NSString stringWithFormat:@"%03d", [col lightness]]];
        [self->elementS_ setStringValue:[NSString stringWithFormat:@"%03d", [col saturation]]];
        [self->attributeMask_ setState:(([col isMask]) ? 1 : 0)];
        [self->attributeDropper_ setState:(([col noDropper]) ? 1 : 0)];
        [self->attributeTransparent_ setState:(([col isTrans]) ? 1 : 0)];

        // ° enable ˤ
        [self->attributeMask_ setEnabled:YES];
        [self->attributeDropper_ setEnabled:YES];
        [self->attributeTransparent_ setEnabled:YES];
    } else {
        // ɽ
        [self->number_ setStringValue:@"---"];
        [self->elementR_ setStringValue:@"----"];
        [self->elementG_ setStringValue:@"----"];
        [self->elementB_ setStringValue:@"----"];
        [self->elementH_ setStringValue:@"---"];
        [self->elementL_ setStringValue:@"---"];
        [self->elementS_ setStringValue:@"---"];
        [self->attributeMask_ setState:0];
        [self->attributeDropper_ setState:0];
        [self->attributeTransparent_ setState:0];

        // ° disable ˤ
        [self->attributeMask_ setEnabled:NO];
        [self->attributeDropper_ setEnabled:NO];
        [self->attributeTransparent_ setEnabled:NO];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frameRect : ΰ(api ѿ)
//
//  Return
//    function : 
//    docCntl_ : document controller(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect
{
    DPRINT((@"[PoCoPaletteView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        // observer Ͽ
        [self registObserver];

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_ : document controller(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoPaletteView dealloc]\n"));

    // observer Ͽ
    [[NSNotificationCenter defaultCenter] removeObserver:self];

    // 񸻤
    [self->docCntl_ release];
    self->docCntl_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// nib ɤ߹ޤ줿
//
//  Call
//    attributeMask_        : ޥ(outlet)
//    attributeDropper_     : ۤػ(outlet)
//    attributeTransparent_ : Ʃ(outlet)
//
//  Return
//    attributesRect_[] : °ν(instance ѿ)
//
-(void)awakeFromNib
{
    // ֤򵭲
    self->attributesRect_[0] = [self->attributeMask_ frame];
    self->attributesRect_[1] = [self->attributeDropper_ frame];
    self->attributesRect_[2] = [self->attributeTransparent_ frame];

    return;
}


//
// ɽڤؤ
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePicture:(NSNotification *)note
{
    // ñ
    [self setNeedsDisplay:YES];

    // ܺ٥ƥȤɽ
    [self showInfoText];

    return;
}


//
// 򿧤ڤؤ
//  祦ɥ
//  Ȥ press ˤڤؤ
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changeColor:(NSNotification *)note
{
    int onum;
    PoCoSelColor *scol;

    // 
    scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] oldColor];
    if ([scol isColor]) {
        onum = [scol num];
        [self setNeedsDisplayInRect:[self numToRect:onum]];
    } else {
        onum = -1;
    }

    // ߤ
    scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];
    if (([scol isColor]) && (onum != [scol num])) {
        [self setNeedsDisplayInRect:[self numToRect:[scol num]]];
    }

    // ܺ٥ƥȤɽ
    [self showInfoText];

    return;
}


//
// ѥåȤѹ(Խ)
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePalette:(NSNotification *)note
{
    if ([note object] == nil) {
        [self setNeedsDisplay:YES];
    } else {
        [self setNeedsDisplayInRect:[self numToRect:[[note object] intValue]]];
    }

    // ܺ٥ƥȤɽ
    [self showInfoText];

    return;
}


//
// ɽ׵
//
//  Call
//    rect : ɽΰ(api ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int i;
    int x;
    int y;
    int snum;
    PoCoRect *r;
    PoCoPoint *lt;
    PoCoPoint *rb;
    PoCoSelColor *scol;

//    DPRINT((@"[PoCoPaletteView drawRect]\n"));

    // 򿧾
    scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];
    snum = ((([scol isUnder]) || ([scol isPattern])) ? -1 : [scol num]);

    // ϰϤλ
    r = [[PoCoRect alloc] initNSRect:rect];
    lt = [self toNormalPos:[r lefttop]
                isRightBot:NO];
    rb = [self toNormalPos:[r rightbot]
                isRightBot:YES];
    if ((r == nil) || (lt == nil) || (rb == nil)) {
        ;
    } else {
        // ɽ
        if (([lt x] == [rb x]) && ([lt y] == [rb y])) {
            i = (([lt y] * H_MAX) + [lt x]);
            [self drawColor:i
                   isSelect:(i == snum)];
        } else if ([lt x] == [rb x]) {
            i = (([lt y] * H_MAX) + [lt x]);
            for (y = [lt y]; y <= [rb y]; (y)++, i += H_MAX) {
                [self drawColor:i
                       isSelect:(i == snum)];
            }
        } else if ([lt y] == [rb y]) {
            i = (([lt y] * H_MAX) + [lt x]);
            for (x = [lt x]; x <= [rb x]; (x)++, (i)++) {
                [self drawColor:i
                       isSelect:(i == snum)];
            }
        } else {
            for (y = [lt y]; y <= [rb y]; (y)++) {
                i = ((y * H_MAX) + [lt x]);
                for (x = [lt x]; x <= [rb x]; (x)++, (i)++) {
                    [self drawColor:i
                           isSelect:(i == snum)];
                }
            }
        }
    }
    [r release];
    [lt release];
    [rb release];

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return  
//    function : YES
// 
-(BOOL)isFlipped
{
    return YES;
}


//
// 1ʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : ɽ
//               NO  : ɽ
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        isSelect:(BOOL)sel
{
    NSRect  r;
    PoCoColor *col = [[[[self->docCntl_ currentDocument] picture] palette] palette:num];

    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            [[NSColor whiteColor] set];
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            [[NSColor blackColor] set];
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


//
// ɥȽ
//
//  Call
//    state             : Ƚ̾
//                        YES : ̾ɽ
//                        NO  : ɽ
//    attributesRect_[] : °ν(instance ѿ)
//
//  Return
//    titleR_               : ̾(R)(outlet)
//    titleG_               : ̾(G)(outlet)
//    titleB_               : ̾(B)(outlet)
//    titleH_               : ̾(H)(outlet)
//    titleL_               : ̾(L)(outlet)
//    titleS_               : ̾(S)(outlet)
//    number_               : ֹ(outlet)
//    elementR_             : (R)(outlet)
//    elementG_             : (G)(outlet)
//    elementB_             : (B)(outlet)
//    elementH_             : (H)(outlet)
//    elementL_             : (L)(outlet)
//    elementS_             : (S)(outlet)
//    attributeMask_        : ޥ(outlet)
//    attributeDropper_     : ۤػ(outlet)
//    attributeTransparent_ : Ʃ(outlet)
//
-(void)setDisclosed:(BOOL)state
{
    NSRect r;

    if (state) {
        // ̾ɽǤϱ
        [self->number_ setHidden:YES];
        [self->titleR_ setHidden:YES];
        [self->elementR_ setHidden:YES];
        [self->titleG_ setHidden:YES];
        [self->elementG_ setHidden:YES];
        [self->titleB_ setHidden:YES];
        [self->elementB_ setHidden:YES];
        [self->titleH_ setHidden:YES];
        [self->elementH_ setHidden:YES];
        [self->titleL_ setHidden:YES];
        [self->elementL_ setHidden:YES];
        [self->titleS_ setHidden:YES];
        [self->elementS_ setHidden:YES];

        // °ΰ֤򤺤餹
        r = self->attributesRect_[0];
        r.origin.x = -3.0;
        [self->attributeMask_ setFrame:r];
        r.origin.x += (self->attributesRect_[0].size.width - 2.0);
        [self->attributeDropper_ setFrame:r];
        r.origin.x += (self->attributesRect_[1].size.width - 2.0);
        [self->attributeTransparent_ setFrame:r];
    } else {
        // °ΰ֤᤹
        [self->attributeMask_ setFrame:self->attributesRect_[0]];
        [self->attributeDropper_ setFrame:self->attributesRect_[1]];
        [self->attributeTransparent_ setFrame:self->attributesRect_[2]];

        // ɽǤϸ
        [self->number_ setHidden:NO];
        [self->titleR_ setHidden:NO];
        [self->elementR_ setHidden:NO];
        [self->titleG_ setHidden:NO];
        [self->elementG_ setHidden:NO];
        [self->titleB_ setHidden:NO];
        [self->elementB_ setHidden:NO];
        [self->titleH_ setHidden:NO];
        [self->elementH_ setHidden:NO];
        [self->titleL_ setHidden:NO];
        [self->elementL_ setHidden:NO];
        [self->titleS_ setHidden:NO];
        [self->elementS_ setHidden:NO];
    }

    return;
}


// -------------------------- PoCoPaletteView  instance ؿ - ٥Ƚ
//
// ܥ󥤥٥Ȥμ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    function : 
//
-(BOOL)acceptsFirstMouse:(NSEvent *)evt
{
    // Ƚ̵
    ;

    return YES;
}


//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    selNumber_ : Խοֹ(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    int num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];
    PoCoSelColor *oldColor = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];

    num = -1;

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = (int)(p.x) / SEL_SIZE + ((int)(p.y) / SEL_SIZE) * H_MAX;
        if (([oldColor isPattern]) || ([oldColor num] != num)) {
            // ڤؤ
            [[(PoCoAppController *)([NSApp delegate]) editInfo] setSelColor:num];

            // ڤؤ(Ȥ)
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoChangeColor
                              object:nil];
        }
    }

    // double click ʾξϾܺ
    if (((num >= 0) && (num < COLOR_MAX)) && ([evt clickCount] >= 2)) {
          self->selNumber_ = num;
          [self raiseColorInfoSheet];
    }

    return;
}


//
// ɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)mouseDragged:(NSEvent *)evt
{
    // ܥƱˤ
    [self mouseDown:evt];

    return;
}


// ----------------------------------- instance - public - ܺꥷȴϢ
//
// ܺꥷȤ򳫤
//
//  Call
//    accessoryView_ : °(outlet)
//    selNumber_     : Խοֹ(instance ѿ)
//
//  Return
//    infoSheet_            : ܺꥷ(instance ѿ)
//    accessoryMask_        : ɤػ(outlet)
//    accessoryDropper_     : ۤػ(outlet)
//    accessoryTransparent_ : Ʃ(outlet)
//
-(void)raiseColorInfoSheet
{
    PoCoColor *col;

    // 
    col = [[[[self->docCntl_ currentDocument] picture] palette] palette:self->selNumber_];

    // ѥͥ
    [NSColorPanel setPickerMask:(NSColorPanelRGBModeMask           |
                                 NSColorPanelHSBModeMask           |
                                 NSColorPanelCMYKModeMask          |
                                 NSColorPanelCustomPaletteModeMask |
                                 NSColorPanelColorListModeMask     |
                                 NSColorPanelWheelModeMask         |
                                 NSColorPanelCrayonModeMask)];
    self->infoSheet_ = [NSColorPanel sharedColorPanel];
    [self->infoSheet_ setShowsAlpha:NO];

    // Ϳ
    [self->infoSheet_ setColor:[NSColor colorWithCalibratedRed:[col floatRed]
                                                         green:[col floatGreen]
                                                          blue:[col floatBlue]
                                                         alpha:(float)(1.0)]];

    // ɲþ
    [self->infoSheet_ setAccessoryView:self->accessoryView_];
    [self->accessoryMask_ setState:([col isMask]) ? 1 : 0];
    [self->accessoryDropper_ setState:([col noDropper]) ? 1 : 0];
    [self->accessoryTransparent_ setState:([col isTrans]) ? 1 : 0];

    // Ȥ򳫤
    [NSApp beginSheet:self->infoSheet_
       modalForWindow:[self window]
        modalDelegate:self
       didEndSelector:@selector(colorInfoSheetDidEnd:returnCode:contextInfo:)
          contextInfo:nil];

    return;
}


//
// ܺꥷȤĤ
//  ° [cancel] [set] button  action
//
//  Call
//    sender     : ¹о(api ѿ)
//    infoSheet_ : ܺꥷ(instance ѿ)
//
//  Return
//    None
//
-(IBAction)endColorInfoSheet:(id)sender
{
    // °ꥷȤĤ
    [self->infoSheet_ orderOut:sender];
    [NSApp endSheet:self->infoSheet_
         returnCode:[sender tag]];

    return;
}


//
// ܺꥷȤĤ줿
//
//  Call
//    sheet                 : Ĥsheet (api ѿ)
//    returnCode            : λ֤(api ѿ)
//    contextInfo           : (api ѿ)
//    accessoryMask_        : ɤػ(outlet)
//    accessoryDropper_     : ۤػ(outlet)
//    accessoryTransparent_ : Ʃ(outlet)
//    infoSheet_            : ܺꥷ(instance ѿ)
//    selNumber_            : Խοֹ(instance ѿ)
//
//  Return
//    None
//
-(void)colorInfoSheetDidEnd:(NSWindow *)sheet
                 returnCode:(int)returnCode
                contextInfo:(void *)contextInfo
{
    CGFloat red;
    CGFloat green;
    CGFloat blue;

    // [set] ȴƤ顢ȿ
    if (returnCode == 0) {
        // 
        [[self->infoSheet_ color] getRed:&(red)
                                   green:&(green)
                                    blue:&(blue)
                                   alpha:NULL];

        // ͤ
        [[(PoCoAppController *)([NSApp delegate]) factory]
            createPaletteSingleSetter:YES
                                  num:self->selNumber_
                                  red:(unsigned char)(red * 255.0)
                                green:(unsigned char)(green * 255.0)
                                 blue:(unsigned char)(blue * 255.0)
                               isMask:([self->accessoryMask_ state] != 0)
                               noDrop:([self->accessoryDropper_ state] != 0)
                              isTrans:([self->accessoryTransparent_ state] != 0)
                                 name:[[NSBundle mainBundle]
                                          localizedStringForKey:@"SinglePaletteElementSet"
                                                          value:@"edit single palette"
                                                          table:nil]];
    }

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// ޥ
//
//  Call
//    sender            : о(api ѿ)
//    attributeMask_    : ޥ(outlet)
//    attributesRect_[] : °ν(instance ѿ)
//
//  Return
//    None
//
-(IBAction)attributeMask:(id)sender
{
    PoCoSelColor *scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];
    PoCoColor *col;

    if ([scol isColor]) {
        col = [[[[self->docCntl_ currentDocument] picture] palette] palette:[scol num]];

        // ȿž
        [[(PoCoAppController *)([NSApp delegate]) factory]
            createPaletteAttributeSetter:YES
                                     num:[scol num]
                                 setType:(([col isMask]) ? NO : YES)
                                    mask:YES
                                 dropper:NO
                                   trans:NO];

        // ɽȿ
        [self->attributeMask_ setState:(([col isMask]) ? 1 : 0)];
    }

    // ׵ȯƤ(֤֤Τ)
    if ([self->attributeMask_ frame].origin.x != self->attributesRect_[0].origin.x) {
        [self setNeedsDisplay:YES];
    }

    return;
}


//
// ۤػ
//
//  Call
//    sender            : о(api ѿ)
//    attributeDropper_ : ۤػ(outlet)
//    attributesRect_[] : °ν(instance ѿ)
//
//  Return
//    None
//
-(IBAction)attributeDropper:(id)sender
{
    PoCoSelColor *scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];
    PoCoColor *col;

    if ([scol isColor]) {
        col = [[[[self->docCntl_ currentDocument] picture] palette] palette:[scol num]];

        // ȿž
        [[(PoCoAppController *)([NSApp delegate]) factory]
            createPaletteAttributeSetter:YES
                                     num:[scol num]
                                 setType:(([col noDropper]) ? NO : YES)
                                    mask:NO
                                 dropper:YES
                                   trans:NO];

        // ɽȿ
        [self->attributeDropper_ setState:(([col noDropper]) ? 1 : 0)];
    }

    // ׵ȯƤ(֤֤Τ)
    if ([self->attributeDropper_ frame].origin.x != self->attributesRect_[1].origin.x) {
        [self setNeedsDisplay:YES];
    }

    return;
}


//
// Ʃ
//
//  Call
//    sender                : о(api ѿ)
//    attributeTransparent_ : Ʃ(outlet)
//    attributesRect_[]     : °ν(instance ѿ)
//
//  Return
//    None
//
-(IBAction)attributeTransparent:(id)sender
{
    PoCoSelColor *scol = [[(PoCoAppController *)([NSApp delegate]) editInfo] selColor];
    PoCoColor *col;

    if ([scol isColor]) {
        col = [[[[self->docCntl_ currentDocument] picture] palette] palette:[scol num]];

        // ȿž
        [[(PoCoAppController *)([NSApp delegate]) factory]
            createPaletteAttributeSetter:YES
                                     num:[scol num]
                                 setType:(([col isTrans]) ? NO : YES)
                                    mask:NO
                                 dropper:NO
                                   trans:YES];

        // ɽȿ
        [self->attributeTransparent_ setState:(([col isTrans]) ? 1 : 0)];
    }

    // ׵ȯƤ(֤֤Τ)
    if ([self->attributeTransparent_ frame].origin.x != self->attributesRect_[2].origin.x) {
        [self setNeedsDisplay:YES];
    }

    return;
}

@end
