//
//	Pelistina on Cocoa - PoCo -
//	ѥå°ΰ
//
//	Copyright (C) 2005-2017 KAENRYUU Koutoku.
//

#import "PoCoPaletteAttributeView.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"
#import "PoCoPaletteWindow.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoPaletteAttributeView

// --------------------------------------------------------- instance - private
//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// 1ʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : ɽ
//               NO  : ɽ
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        isSelect:(BOOL)sel
{
    NSRect  r;
    const PoCoPalette *plt = [[[self->docCntl_ currentDocument] picture] palette];
    const PoCoColor *col = [plt palette:num];

    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            [[NSColor whiteColor] set];
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            [[NSColor blackColor] set];
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frameRect : ΰ(api ѿ)
//     
//  Return
//    function  : 
//    isOn_[]   : (instance ѿ)
//    setValue_ : (instance ѿ)
//    docCntl_  : document controller(instance ѿ)
//    range_    : Ϣ³(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect;
{
    int l;

    DPRINT((@"[PoCoPaletteAttributeView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        for (l = 0; l < COLOR_MAX; l++) {
            self->isOn_[l] = NO;
        }
        self->setValue_ = NO;
        self->range_ = 1;

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    docCntl_ : document controller(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoPaletteAttributeView dealloc]\n"));

    // 񸻤
    [self->docCntl_ release];
    self->docCntl_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ɽ׵
//
//  Call
//    rect    : ɽΰ(api ѿ)
//    isOn_[] : (instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int l;

    DPRINT((@"[PoCoPaletteAttributeView drawRect]\n"));

    for (l = 0; l < COLOR_MAX; (l)++) {
        if (NSIntersectsRect(rect, [self numToRect:l])) {
            [self drawColor:l
                   isSelect:self->isOn_[l]];
        }
    }

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return  
//    function : YES
// 
-(BOOL)isFlipped
{
    return YES;
}


//
// 
//
//  Call
//    isOn_[] : (instance ѿ)
//
//  Return
//    function : 
//
-(const BOOL *)attribute
{
    return (const BOOL *)(&(self->isOn_[0]));
}


//
// Ϣ³
//
//  Call
//    val : 
//
//  Return
//    range_ : Ϣ³(instance ѿ)
//
-(void)setRange:(int)val
{
    if (val != 0) {
       self->range_ = val;
    }

    return;
}


//
// 
//
//  Call
//    on    : 
//    index : о
//
//  Return
//    isOn_[] : (instance ѿ)
//
-(void)setAttribute:(BOOL)on
              index:(int)index
{
    self->isOn_[index] = on;

    return;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt          : ȯ٥(api ѿ)
//    ownerWindow_ : ƥɥ(outlet)
//    isOn_[]      : (instance ѿ)
//
//  Return
//    setValue_ : (instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    int num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    [(PoCoPaletteWindow *)(self->ownerWindow_) invokeUpdateAllRange];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = ((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX);

        // ͤȽ
        self->setValue_ = (self->isOn_[num]) ? NO : YES;

        // ɥåƱˤ
        [self mouseDragged:evt];
    }

    return;
}


//
// ɥå
//
//  Call
//    evt       : ȯ٥(api ѿ)
//    setValue_ : (instance ѿ)
//    range_    : Ϣ³(instance ѿ)
//
//  Return
//    isOn_[] : (instance ѿ)
//
-(void)mouseDragged:(NSEvent *)evt
{
    int num;
    int l;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = ((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX);

        // ͤȿ
        if ((self->range_ == 1) || (self->range_ == -1)) {
            // 1Ĥ
            if (self->setValue_ != self->isOn_[num]) {
                [self setAttribute:self->setValue_
                             index:num];

                // 
                [self setNeedsDisplayInRect:[self numToRect:num]];
            }
        } else if (self->range_ > 0) {
            // ʣ
            for (l = num; l < (num + self->range_); (l)++) {
                if ((l >= 0) && (l < COLOR_MAX)) {
                    [self setAttribute:self->setValue_
                                 index:l];
                } else {
                    break;
                }
            }

            // 
            [self setNeedsDisplay:YES];
        } else if (self->range_ < 0) {
            // ʣ
            for (l = num; l > (num + self->range_); (l)--) {
                if ((l >= 0) && (l < COLOR_MAX)) {
                    [self setAttribute:self->setValue_
                                 index:l];
                } else {
                    break;
                }
            }

            // 
            [self setNeedsDisplay:YES];
        }
    }

    return;
}

@end
