//
//	Pelistina on Cocoa - PoCo -
//	ѥåؤΰ
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoPaletteExchangeView.h"

#import "PoCoAppController.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"
#import "PoCoPalette.h"

// 
static  unsigned int SEL_SIZE = 8;      // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 16;        // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoPaletteExchangePair

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    s : Ѵοֹ
//    d : Ѵοֹ
//
//  Return
//    function : 
//    src_     : Ѵοֹ(instance ѿ)
//    dst_     : Ѵοֹ(instance ѿ)
//
-(id)initWithSrc:(int)s withDst:(int)d
{
    // super class ν
    self = [super init];

    // Ȥν
    if (self != nil) {
        self->src_ = s;
        self->dst_ = d;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class 
    [super dealloc];

    return;
}


//
// (Ѵοֹ)
//
//  Call
//    src_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : 
//
-(int)src
{
    return self->src_;
}


//
// (Ѵοֹ)
//
//  Call
//    dst_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : 
//
-(int)dst
{
    return self->dst_;
}


//
// Ѵɽʸμ
//
//  Call
//    src_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)srcString
{
    PoCoColor *col = [[[[[NSDocumentController sharedDocumentController] currentDocument] picture] palette] palette:self->src_];

    return [NSString stringWithFormat:@"%3d:%02X-%02X-%02X", self->src_, [col red], [col green], [col blue]];
}


//
// Ѵɽʸμ
//
//  Call
//    dst_ : Ѵοֹ(instance ѿ)
//
//  Return
//    function : ʸ
//
-(NSString *)dstString
{
    PoCoColor *col = [[[[[NSDocumentController sharedDocumentController] currentDocument] picture] palette] palette:self->dst_];

    return [NSString stringWithFormat:@"%3d:%02X-%02X-%02X", self->dst_, [col red], [col green], [col blue]];
}

@end




// ============================================================================
@implementation PoCoPaletteExchangeView

// --------------------------------------------------------- instance - private
//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : оݶΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// ι
//
//  Call
//    num : ֹ
//    evt : ٥
//
//  Return
//    function : ֹ
//
-(int)selColor:(int)num
         event:(NSEvent *)evt
{
    const int oldNum = num;
    const NSPoint p = [PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]];

    if ([self mouse:p inRect:[self bounds]]) {
        // ֹ
        num = ((int)(p.x) / SEL_SIZE) + (((int)(p.y) / SEL_SIZE) * H_MAX);

        // ڤؤϺȯ
        if (oldNum != num) {
            [self setNeedsDisplayInRect:[self numToRect:oldNum]];
            [self setNeedsDisplayInRect:[self numToRect:num]];
        }
    }

    return num;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//   
//  Call
//    frameRect : ΰ(api ѿ)
//     
//  Return
//    function       : 
//    leftNum_       : ܥǤ(instanceѿ)
//    rightNum_      : ܥǤ(instanceѿ)
//    exchangeTable_ : 򴹥ǡ(instanceѿ)
//    docCntl_       : document controller(instanceѿ)
//
-(id)initWithFrame:(NSRect)frameRect;
{
    DPRINT((@"[PoCoPaletteExchangeView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->leftNum_ = 0;
        self->rightNum_ = 0;
        self->exchangeTable_ = nil;
        self->docCntl_ = nil;

        // ꥹȤ
        self->exchangeTable_ = [[NSMutableArray alloc] init];
        if (self->exchangeTable_ == nil) {
            DPRINT((@"can't alloc exchangeTable.\n"));
            [self release];
            self = nil;
            goto EXIT;
        }

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];
    }

EXIT:
    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    exchangeTable_ : 򴹥ǡ(instance ѿ)
//    docCntl_       : document controller(instanceѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoPaletteExchangeView dealloc]\n"));

    // о˴
    [self->exchangeTable_ removeAllObjects];

    // 񸻤
    [self->exchangeTable_ release];
    [self->docCntl_ release];
    self->exchangeTable_ = nil;
    self->docCntl_ = nil;

    // super class 
    [super dealloc];

    return;
}


//
// ɽ׵
//
//  Call
//    rect      : ɽΰ(api ѿ)
//    leftNum_  : ܥǤ(instance ѿ)
//    rightNum_ : ܥǤ(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    int l;

    DPRINT((@"[PoCoPaletteExchangeView drawRect]\n"));

    for (l = 0; l < COLOR_MAX; (l)++) {
        if (NSIntersectsRect(rect, [self numToRect:l])) {
            [self drawColor:l
                   isSelect:((l == self->leftNum_) || (l == self->rightNum_))
                     isDown:(l == self->rightNum_)];
        }
    }

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return  
//    function : YES
// 
-(BOOL)isFlipped
{
    return YES;
}


//
// 
//
//  Call
//    colorList_     : ɽ(outlet)
//    exchangeTable_ : 򴹥ǡ(instance ѿ)
//
//  Return
//    exchangeTable_ : 򴹥ǡ(instance ѿ)
//
-(void)setUp
{
    // о˴
    [self->exchangeTable_ removeAllObjects];

    // ɽ
    [self->colorList_ reloadData];

    return;
}


//
// ɽμ
//
//  Call
//    exchangeTable_ : 򴹥ǡ(instance ѿ)
//
//  Return
//    function : ǡ
//
-(NSMutableArray *)exchangeTable
{
    return self->exchangeTable_;
}


//
// 1ʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : ɽ
//               NO  : ɽ
//    down     : YES : ɽ
//               NO  : 夬ɽ
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawColor:(int)num
        isSelect:(BOOL)sel
          isDown:(BOOL)down
{
    NSRect  r;
    const PoCoPalette *plt = [[[self->docCntl_ currentDocument] picture] palette];
    const PoCoColor *col = [plt palette:num];

    if (col != nil) {
        // ɸ򻻽
        r = [self numToRect:num];

        // ʤȤĤ
        if (sel) {
            if (down) {
                [[NSColor blackColor] set];
            } else {
                [[NSColor whiteColor] set];
            }
            [NSBezierPath fillRect:r];
            (r.origin.x)++;
            (r.origin.y)++;
            (r.size.width)--;
            (r.size.height)--;
            if (down) {
                [[NSColor whiteColor] set];
            } else {
                [[NSColor blackColor] set];
            }
            [NSBezierPath fillRect:r];
            (r.size.width)--;
            (r.size.height)--;
        }

        // 
        [[NSColor colorWithCalibratedRed:[col floatRed]
                                   green:[col floatGreen]
                                    blue:[col floatBlue]
                                   alpha:(float)(1.0)] set];
        [NSBezierPath fillRect:r];
    }

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// ɲ
//
//  Call
//    sender     : о(api ѿ)
//    colorList_ : ɽ(outlet)
//    leftNum_   : ܥǤ(instance ѿ)
//    rightNum_  : ܥǤ(instance ѿ)
//
//  Return
//    exchangeTable : 򴹥ǡ(instance ѿ)
//
-(IBAction)addColor:(id)sender
{
    PoCoPaletteExchangePair *pair;

    // о
    pair = [[PoCoPaletteExchangePair alloc] initWithSrc:self->leftNum_
                                                withDst:self->rightNum_];
    if (pair == nil) {
        DPRINT((@"can't alloc PoCoPaletteExchangePair.\n"));
    } else {
        // ǡɲ
        [self->exchangeTable_ addObject:pair];
        [pair release];

        // ɽ򹹿
        [self->colorList_ reloadData];
    }

    return;
}


// ----------------------------------- instance - public - ǡ᥽å
//
// Կμ
//
//  Call
//    table          : о(api ѿ)
//    exchangeTable_ : 򴹥ǡ(instance ѿ)
//
//  Return
//    function : Կ
//
-(int)numberOfRowsInTableView:(NSTableView *)table
{
    DPRINT((@"[PoCoPaletteExchangeView numberOfRowsInTableView]\n"));

    return (int)([self->exchangeTable_ count]);
}


//
// ɽ
//
//  Call
//    table  : о(api ѿ)
//    column : оݷ(api ѿ)
//    row    : оݹ(api ѿ)
//
//  Return
//    function : ɽ
//
-(id)tableView:(NSTableView *)table
objectValueForTableColumn:(NSTableColumn *)column
                      row:(int)row
{
    NSString *identifier;
    PoCoPaletteExchangePair *pair;

    DPRINT((@"[PoCoPaletteExchangeView tableView: objectValueForTableColumn: row]\n"));

    // ̻Ҥμ
    identifier = [column identifier];

    // оݹԤƤμ
    pair = [self->exchangeTable_ objectAtIndex:row];

    return [pair valueForKey:identifier];
}


//
// Խ
//    ԽԲĤʤΤǲ⤷ʤ
//
//  Call
//    table  : о(api ѿ)
//    object : Խ(api ѿ)
//    column : оݷ(api ѿ)
//    row    : оݹ(api ѿ)
//
//  Return
//    None
//
-(void)tableView:(NSTableView *)table
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)column
             row:(int)row
{
    DPRINT((@"[PoCoPaletteExchangeView tableView: setObjectValue: ForTableColumn: row]\n"));

    // ⤷ʤ
    ;

    return;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    leftNum_ : ܥǤ(instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    self->leftNum_ = [self selColor:self->leftNum_
                              event:evt];

    return;
}


//
// ɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    leftNum_ : ܥǤ(instance ѿ)
//
-(void)mouseDragged:(NSEvent *)evt
{
    self->leftNum_ = [self selColor:self->leftNum_
                              event:evt];

    return;
}


//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    rightNum_ : ܥǤ(instance ѿ)
//
-(void)rightMouseDown:(NSEvent *)evt
{
    self->rightNum_ = [self selColor:self->rightNum_
                               event:evt];

    return;
}


//
// ܥɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    rightNum_ : ܥǤ(instance ѿ)
//
-(void)rightMouseDragged:(NSEvent *)evt
{
    self->rightNum_ = [self selColor:self->rightNum_
                               event:evt];

    return;
}

@end
