//
//	Pelistina on Cocoa - PoCo -
//	2ͥѥɽ - 
//
//	Copyright (C) 2005-2015 KAENRYUU Koutoku.
//

#import "PoCoMonochromePatternView.h"

#import "PoCoMonochromePattern.h"
#import "PoCoPenStyle.h"
#import "PoCoTilePattern.h"

// 
static  unsigned int SEL_SIZE = 18;     // 1Ǥ礭(dot ñ)(ȴޤ)
static  unsigned int H_MAX = 8;         // ʿǿ(Ŀ)

// ============================================================================
@implementation PoCoMonochromePatternView

// --------------------------------- PoCoMonochromePatternView  instance ؿ
//
// initialize
//
//  Call
//    frameRect : ΰ(api ѿ)
//    pat       : Ͽѥ
//
//  Return
//    function : 
//    pattern_ : ѥ(instanceѿ)
//
-(id)initWithFrame:(NSRect)frameRect
        setPattern:(id)pat
{
    DPRINT((@"[PoCoMonochromePatternView initWithFrame: setPattern:]\n"));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->pattern_ = pat;
        [self->pattern_ retain];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    pattern_ : ѥ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoMonochromePatternView dealloc]\n"));

    // 񸻤β
    [self->pattern_ release];
    self->pattern_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return
//    function : YES
//
-(BOOL)isFlipped
{
    return YES;
}


//
// ѥ򹹿
//  Ǥϲ⤷ʤ
//
//  Call
//    pat : ѥ
//
//  Return
//    None
//
-(void)updatePattern:(PoCoMonochromePattern *)pat
{
    return;
}


//
// 1ѥʬ
//
//  Call
//    num      : ֹ
//    sel      : YES : ֹ
//               NO  : ɽ
//    pattern_ : ѥ(instance ѿ)
//
//  Return
//    None
//
-(void)drawPattern:(int)num
          isSelect:(BOOL)sel
{
    NSRect r;
    NSBitmapImageRep *img;
    PoCoMonochromePattern *pat;

    pat = [self->pattern_ pattern:num];
    if (pat != nil) {
        // Ȥ
        r = [self numToRect:num];
        if (sel) {
           [[NSColor whiteColor] set];
        } else {
           [[NSColor blackColor] set];
        }
        [NSBezierPath fillRect:r];
        (r.origin.x)++;
        (r.origin.y)++;
        (r.size.width)--;
        (r.size.height)--;
        if (sel) {
           [[NSColor blackColor] set];
        } else {
           [[NSColor whiteColor] set];
        }
        [NSBezierPath fillRect:r];
        (r.size.width)--;
        (r.size.height)--;

        // Ƥ
        img = [pat getImage];
        if (img != nil) {
            [img drawAtPoint:r.origin];
            [img release];
        }
    }

    return;
}


//
// ֹ椫ΰѴ
//
//  Call
//    num : ֹ
//
//  Return
//    function : ΰ
//
-(NSRect)numToRect:(int)num
{
    NSRect r;

    r.origin.x = (float)((num % H_MAX) * SEL_SIZE);
    r.origin.y = (float)((num / H_MAX) * SEL_SIZE);
    r.size.width = (float)(SEL_SIZE);
    r.size.height = (float)(SEL_SIZE);

    return r;
}


//
// ɸֹѴ
//
//  Call
//    pos : ɸ
//
//  Return
//    function : ֹ
//
-(unsigned int)pointToNum:(NSPoint)pos
{
    return ((int)(pos.x) / SEL_SIZE) + (((int)(pos.y) / SEL_SIZE) * H_MAX);
}


//
// 
//  Ǥϲ⤷ʤ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)nextSelection
{
    return;
}


//
// 
//  Ǥϲ⤷ʤ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)prevSelection
{
    return;
}

@end
