//
//	Pelistina on Cocoa - PoCo -
//	ڥɽ
//
//	Copyright (C) 2005-2016 KAENRYUU Koutoku.
//

#import "PoCoPenStyleView.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoPenStyle.h"
#import "PoCoPenStyleWindow.h"

// ============================================================================
@implementation PoCoPenStyleView

// --------------------------------------------------------- instance - private
//
// ڤؤ
//
//  Call
//    num : ֹ(ڤؤ)
//
//  Return
//    None
//
-(void)setSelection:(unsigned int)num
{
    const unsigned int sel = [[(PoCoAppController *)([NSApp delegate]) editInfo] penNumber];

    if (num != sel) {
        [[(PoCoAppController *)([NSApp delegate]) editInfo] setPenNumber:num];
        [self setNeedsDisplayInRect:[super numToRect:num]];
        [self setNeedsDisplayInRect:[super numToRect:sel]];
    }

    return;
}


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frame : ΰ
//
//  Return
//    function : 
//
-(id)initWithFrame:(NSRect)frame
{
    DPRINT((@"[PoCoPenStyleView initWithFrame]\n"));

    // super class ν
    self = [super initWithFrame:frame
                     setPattern:[(PoCoAppController *)([NSApp delegate]) penStyle]];

    // Ȥν
    if (self != nil) {
        ;
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class β
    [super dealloc];

    return;
}


//
// ѥ򹹿
//
//  Call
//    pat : ѥ
//
//  Return
//    None
//
-(void)updatePattern:(PoCoMonochromePattern *)pat
{
    const unsigned int sel = [[(PoCoAppController *)([NSApp delegate]) editInfo] penNumber];

    [[(PoCoAppController *)([NSApp delegate]) penStyle] setPattern:pat atIndex:sel];
    [self setNeedsDisplayInRect:[super numToRect:sel]];

    return;
}


//
// ɽ׵
//
//  Call
//    rect : ɽΰ(api )
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    unsigned int l;
    const unsigned int sel = [[(PoCoAppController *)([NSApp delegate]) editInfo] penNumber];

    [[NSGraphicsContext currentContext] setImageInterpolation:NSImageInterpolationNone];
    for (l = 0; l < PEN_STYLE_NUM; (l)++) {
        if (NSIntersectsRect(rect, [super numToRect:l])) {
            [super drawPattern:l isSelect:(l == sel)];
        }
    }

    return;
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ󥤥٥Ȥμ
//
//  Call
//    evt : ȯ٥(api ѿ)
// 
//  Return
//    function : 
//
-(BOOL)acceptsFirstMouse:(NSEvent *)evt
{
    // Ƚ̵
    ;

    return YES;
}


//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)mouseDown:(NSEvent *)evt
{
    const NSPoint p = [self convertPoint:[evt locationInWindow]
                                fromView:nil];
    PoCoPenStyleWindow *wnd;

    // ڤؤ
    if ([self mouse:p inRect:[self bounds]]) {
        [self setSelection:[super pointToNum:p]];
    }

    // double click ʾξԽ
    if ([evt clickCount] >= 2) {
        wnd = (PoCoPenStyleWindow *)([[self window] delegate]);
        [wnd raisePatternSheet:self
                       pattern:[[(PoCoAppController *)([NSApp delegate]) penStyle] pattern:[[(PoCoAppController *)([NSApp delegate]) editInfo] penNumber]]];
    }

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    None
//
-(void)nextSelection
{
    unsigned int num = [[(PoCoAppController *)([NSApp delegate]) editInfo] penNumber];

    if (num >= 15) {
        num = 0;
    } else {
        (num)++;
    }
    [self setSelection:num];

    return;
}


//
// 
//
//  Call
//    None
//
//  Return
//    None
//
-(void)prevSelection
{
    unsigned int num = [[(PoCoAppController *)([NSApp delegate]) editInfo] penNumber];

    if (num <= 0) {
        num = 15;
    } else {
        (num)--;
    }
    [self setSelection:num];

    return;
}

@end
