//
//	Pelistina on Cocoa - PoCo -
//	ڥ襦ɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoPenStyleWindow.h"

#import <Carbon/Carbon.h>

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMonochromePattern.h"
#import "PoCoMonochromePatternView.h"
#import "PoCoMonochromePatternEditView.h"

// ============================================================================
@implementation PoCoPenStyleWindow

// ---------------------------------------- PoCoPenStyleWindow  instance ؿ
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//
-(id)init
{
    // super class 
    self = [super initWithWindowNibName:@"PoCoPenStyleWindow"];

    // Ȥ
    if (self != nil) {
        // ¸
        [self setWindowFrameAutosaveName:@"PenStyleWindowPos"];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class β
    [super dealloc];

    return;
}


//
// ɥɤ߹ޤ줿
//
//  Call
//    penSizeSlider_ : ڥ礭(outlet)
//    densitySlider_ : ǻ(outlet)
//
//  Return
//    None
//
-(void)windowDidLoad
{
    PoCoEditInfo *info = [(PoCoAppController *)([NSApp delegate]) editInfo];

    [self->penSizeSlider_ setIntValue:[info penSize]];
    [self->densitySlider_ setFloatValue:((float)([info density]) / 100.0)];

    return;
}


//
// ɥĤ(delegate method)
//
//  Call
//    note : (api ѿ)
//
//  Return
//    None
//
-(void)windowWillClose:(NSNotification *)note
{
    [(PoCoAppController *)([NSApp delegate]) closedPenStyleWindow];

    return;
}


//  
// äΰϤ
//
//  Call
//    sender : ɥ(api ѿ)
//
//  Return
//    function : ä
//
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] undoManager];
}


// -------------------------------------------- instance - public - IBAction 
//
// ڥ
//
//  Call
//    sender : о
//
//  Return
//    None
//
-(IBAction)penSizeSet:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setPenSize:[sender intValue]];

    return;
}


//
// ǻٻ
//
//  Call
//    sender : о
//
//  Return
//    None
//
-(IBAction)densitySet:(id)sender
{
    [[(PoCoAppController *)([NSApp delegate]) editInfo] setDensity:(int)(floor([sender floatValue] * 100.0))];

    return;
}


// ----------------------------------------- instance - public - ٥Ȥμ
//
// 
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ڡ٥(keyDown)
    if ([evt keyCode] == kVK_Space) {
        if (!([evt isARepeat])) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoSpaceKeyEvent
                              object:[NSNumber numberWithBool:YES]];
        }
    } else {
        // super class ز
        [super keyDown:evt];
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ڡ٥(keyUp)
    if ([evt keyCode] == kVK_Space) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoSpaceKeyEvent
                          object:[NSNumber numberWithBool:NO]];
    } else {
        // super class ز
        [super keyUp:evt];
    }

    return;
}


// --------------------------------- instance - public - ѥꥷȴϢ
//
// ѥꥷȤ򳫤
//
//  Call
//    sender           : 
//    pat              : ѥ
//    patternSheet_    : ꥷ(outlet)
//    patternEditView_ : ΰ(outlet)
//
//  Return
//    None
//
-(void)raisePatternSheet:(id)sender pattern:(PoCoMonochromePattern *)pat
{
    DPRINT((@"open patternSheet\n"));

    // 
    [self->patternEditView_ setPattern:pat];

    // ѥåؤȤ򳫤
    [self->patternEditView_ setNeedsDisplay:YES];
    [NSApp beginSheet:self->patternSheet_
       modalForWindow:[self window]
        modalDelegate:self
       didEndSelector:@selector(patternSheetDidEnd:returnCode:contextInfo:)
          contextInfo:(void *)(sender)];

    return;
}


//
// ѥꥷȤĤ
//
//  Call
//    sender        : ¹о(api ѿ)
//    patternSheet_ : ꥷ(outlet)
//
//  Return
//    None
//
-(IBAction)endPatternSheet:(id)sender
{
    DPRINT((@"will close patternSheet\n"));

    // ѥꥷȤĤ
    [self->patternSheet_ orderOut:sender];
    [NSApp endSheet:self->patternSheet_
         returnCode:[sender tag]];

    return;
}


//
// ѥꥷȤĤ줿
//
//  Call
//    sheet            : Ĥsheet(api ѿ)
//    returnCode       : λ֤(api ѿ)
//    contextInfo      : (api ѿ
//    patternEditView_ : ΰ(outlet)
//
//  Return
//    None
//
-(void)patternSheetDidEnd:(NSWindow *)sheet
               returnCode:(int)returnCode
              contextInfo:(void *)contextInfo
{
    PoCoMonochromePatternView *view = (PoCoMonochromePatternView *)(contextInfo);

    DPRINT((@"did close patternSheet\n"));

    if (returnCode != 0) {
        goto EXIT;
    }

    // ѥ򹹿
    [view updatePattern:[self->patternEditView_ pattern]];

EXIT:
    return;
}


// -------------------------- instance - public - ѥ/饤ڤؤ
//
// Υڥ
//
//  Call
//    penStyleView_ : ڥ(outlet)
//
//  Return
//    None
//
-(void)nextPenStyle
{
    [self->penStyleView_ nextSelection];

    return;
}


//
// Υڥ
//
//  Call
//    penStyleView_ : ڥ(outlet)
//
//  Return
//    None
//
-(void)prevPenStyle
{
    [self->penStyleView_ prevSelection];

    return;
}


//
// ڥΥ饤򼡤ͤ
//
//  Call
//    None
//
//  Return
//    penSizeSlider_ : ڥ礭(outlet)
//
-(void)nextPenSize
{
    PoCoEditInfo *info = [(PoCoAppController *)([NSApp delegate]) editInfo];

    if ([info penSize] < PEN_STYLE_SIZE) {
        [info setPenSize:([info penSize] + 1)];
        [self->penSizeSlider_ setIntValue:[info penSize]];
    }

    return;
}


//
// ڥΥ饤ͤ
//
//  Call
//    None
//
//  Return
//    penSizeSlider_ : ڥ礭(outlet)
//
-(void)prevPenSize
{
    PoCoEditInfo *info = [(PoCoAppController *)([NSApp delegate]) editInfo];

    if ([info penSize] > 1) {
        [info setPenSize:([info penSize] - 1)];
        [self->penSizeSlider_ setIntValue:[info penSize]];
    }

    return;
}


//
// Υѥ
//
//  Call
//    tilePatternView_ : ѥ(outlet)
//
//  Return
//    None
//
-(void)nextTilePattern
{
    [self->tilePatternView_ nextSelection];

    return;
}


//
// Υѥ
//
//  Call
//    tilePatternView_ : ѥ(outlet)
//
//  Return
//    None
//
-(void)prevTilePattern
{
    [self->tilePatternView_ prevSelection];

    return;
}


//
// ǻ٤Υ饤ѹ
//
//  Call
//    val : (0.1% ñ)
//
//  Return
//    densitySlider_ : ǻ(outlet)
//
-(void)addDensity:(int)val
{
    PoCoEditInfo *info = [(PoCoAppController *)([NSApp delegate]) editInfo];
    int den;

    den = ((int)([info density]) + val);
    if (den < 0) {
        den = 0;
    } else if (den > (100 * 10)) {
        den = (100 * 10);
    }
    [info setDensity:(unsigned int)(den)];
    [self->densitySlider_ setFloatValue:((float)([info density]) / 100.0)];

    return;
}

@end
