//
//	Pelistina on Cocoa - PoCo -
//	PoCoSubView class
//
//	Copyright (C) 2005-2019 KAENRYUU Koutoku.
//

#import "PoCoSubView.h"

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"
#import "PoCoMyDocument.h"
#import "PoCoPicture.h"


// ѿ
static const int ZOOM_FACTOR[] = {      // ɽΨơ֥(0.1%ñ)
     10,   20,   25,   50,  100,  200,  250,  300,   400,   500,   600,    700,   750,   800,   900,
    1000,
    2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000, 10000, 11000, 12000, 13000, 14000, 15000, 16000
};

static const NSRect EMPTY_RECT = {{0.0, 0.0}, {0.0, 0.0}}; // ΰ

// ============================================================================
@implementation PoCoSubView

// --------------------------------------------------------- instance - private
//
// observer Ͽ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)registObserver
{
    NSNotificationCenter *nc;

    nc = [NSNotificationCenter defaultCenter];
    if (nc != nil) {
        // layer resize 
        [nc addObserver:self            // Խоѹ
               selector:@selector(changePicture:)
                   name:PoCoChangePicture
                 object:nil];
        [nc addObserver:self            // ѹ
               selector:@selector(changePicture:)
                   name:PoCoCanvasResize
                 object:nil];
        [nc addObserver:self            // ڤȴ
               selector:@selector(changePicture:)
                   name:PoCoImageClip
                 object:nil];

        // palette ѹ
        [nc addObserver:self
               selector:@selector(changePaletteElm:)
                   name:PoCoChangePalette
                 object:nil];

        // 쥤䡼¤ѹ
        [nc addObserver:self
               selector:@selector(editLayer:)
                   name:PoCoEditLayer
                 object:nil];

        // ѥå°
        [nc addObserver:self
               selector:@selector(changePaletteAttr:)
                   name:PoCoChangePaletteAttr
                 object:nil];

        // Խμ
        [nc addObserver:self
               selector:@selector(editPicture:)
                   name:PoCoEditPicture
                 object:nil];

        // ȯԤμ
        [nc addObserver:self
               selector:@selector(editPicture:)
                   name:PoCoRedrawPicture
                 object:nil];

        // ԽΤμ
        [nc addObserver:self
               selector:@selector(execDrawing:)
                   name:PoCoExecDrawing
                 object:nil];
    }

    return;
}


//
// κɸѴ
//  ƤӽФ֤ͤμΤ release 뤳
//
//  Call
//    p        : ɥΰ
//    zfact    : ɽΨ
//    orgRect_ : ɽμ¿ΰ(instance ѿ)
//
//  Return
//    function : 
//
-(PoCoPoint *)calcSrcPoint:(NSPoint)p
                     zfact:(int)zfact
{
    int x;
    int y;
    PoCoRect *r;

    // 
    if (zfact == 1000) {
        x = (int)(p.x);
        y = (int)(p.y);
    } else {
        x = ((((int)(p.x)) * 1000) / zfact);
        y = ((((int)(p.y)) * 1000) / zfact);
    }

    // ϰ˼
    r = [[PoCoRect alloc] initNSRect:self->orgRect_];
    if (x < [r left]) {
        x = [r left];
    } else if (x >= [r right]) {
        x = ([r right] - 1);
    }
    if (y < [r top]) {
        y = [r top];
    } else if (y >= [r bottom]) {
        y = ([r bottom] - 1);
    }
    [r release];

    return [[PoCoPoint alloc] initX:x initY:y];
}


//      
// ǤϰϤμ
//  ƤӽФ֤ͤμΤ release 뤳
//
//  Call
//    rect  : ΰ(׵ΰ)
//    zfact : ɽΨ
//
//  Return
//    function : Ǥκɸ
//
-(PoCoRect *)calcSrcRect:(NSRect)rect
                   zfact:(int)zfact
{
    PoCoRect *r;

    // ɽΰ/ΰ򻻽
    r = [[PoCoRect alloc] initNSRect:rect];
    if (zfact != 1000) {
        // /̾(üФʤΤǶ)
        [r   setLeft:(((rect.origin.x) * 1000) / zfact)];
        [r    setTop:(((rect.origin.y) * 1000) / zfact)];
        [r  setRight:(((rect.origin.x +  rect.size.width) * 1000) / zfact)];
        [r setBottom:(((rect.origin.y + rect.size.height) * 1000) / zfact)];
        if (((int)((rect.origin.x + rect.size.width) * 1000) % zfact) != 0) {
            [r setRight:([r right] + 1)];
        }
        if (((int)((rect.origin.y + rect.size.height) * 1000) % zfact) != 0) {
            [r setBottom:([r bottom] + 1)];
        }
    }

    return r;
}
    
    
//
// ΰ褫饦ɥΰѴ
//
//  Call
//    r         : ɸ
//    zfactNum_ : ɽΨֹ(instance ѿ)
//
//  Return
//    function : ΰ
//
-(NSRect)toDispRect:(PoCoRect *)r
{
    NSRect dr;
    const int zfact = ZOOM_FACTOR[self->zfactNum_];

    if (zfact == 1000) {
        // 
        dr.origin.x = (float)([r left]);
        dr.origin.y = (float)([r top]);
        dr.size.width = (float)([r width]);
        dr.size.height = (float)([r height]);
    } else {
        // /̾(üФʤΤǶ)
        dr.origin.x = (float)((([r left] * zfact) / 1000));
        dr.origin.y = (float)((([r top] * zfact) / 1000));
        dr.size.width = (float)(([r width] * zfact) / 1000);
        dr.size.height = (float)(([r height] * zfact) / 1000);
    }

    return dr;
}


//
// ɽΨѹ
//
//  Call
//    num        : ѹͽΨֹ
//    zfactNum_  : ɽΨֹ(instance ѿ)
//    lastPoint_ : ǽ PD (instance ѿ)
//    orgRect_   : ɽμ¿ΰ(instance ѿ)
//
//  Return
//    zfactNum_ : ɽΨֹ(instance ѿ)
//
-(void)changeZoom:(int)num
{
    int zchg;
    PoCoRect *r;
    PoCoRect *or = [[PoCoRect alloc] initNSRect:self->orgRect_];

    if (self->zfactNum_ != num) {
        // ߤɽϰϤ
        r = [self calcSrcRect:[self visibleRect]
                        zfact:ZOOM_FACTOR[self->zfactNum_]];
        zchg = (((ZOOM_FACTOR[num] - ZOOM_FACTOR[self->zfactNum_]) * 1000) / ZOOM_FACTOR[num]);
        [r shiftX:((([self->lastPoint_ x] - [r left]) * zchg) / 1000)];
        [r shiftY:((([self->lastPoint_ y] - [r top ]) * zchg) / 1000)];
        if ([r left] < 0) {
            [r setLeft:0];
        }
        if ([r top] < 0) {
            [r setTop:0];
        }
        if ([r right] >= [or right]) {
            [r setRight:[or right]];
        }
        if ([r bottom] >= [or bottom]) {
            [r setBottom:[or bottom]];
        }

        // 
        self->zfactNum_ = num;

        // view ϰϤ򹹿
        [self updateFrame:NO];

        // ɽ֤Ĵƺ׵ȯ
        if (!([self scrollRectToVisible:[self toDispRect:r]])) {
            [self setNeedsDisplay:YES];
        }
        [r release];
    }
    [or release];

    return;
}


//
// 濴ɽ
//
//  Call
//    None
//
//  Return
//    None
//
-(void)centering
{
    NSRect fr = [self frame];
    NSRect vr = [self visibleRect];

    vr.origin.x = ((fr.size.width - vr.size.width) / 2);
    vr.origin.y = ((fr.size.height - vr.size.height) / 2);
    [self scrollRectToVisible:vr];

    return;
}


#if (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_9)
// ------------------------------------------------------------- class - public
//
// responsive scroll
//
//  Call
//    None
//
//  Return
//    function :  YES
//
+(BOOL)isCompatibleWithResponsiveScrolling
{
    return YES;
}
#endif  // (MAC_OS_X_VERSION_MAX_ALLOWED >= MAC_OS_X_VERSION_10_9)


// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    frameRect : (api )
//
//  Return
//    function   : 
//    zfactNum_  : ɽΨֹ (instance ѿ)
//    orgRect_   : ɽμ¿ΰ (instance ѿ)
//    lastPoint_ : ǽ PD (instance ѿ)
//    docCntl_   : document controller(instance ѿ)
//
-(id)initWithFrame:(NSRect)frameRect
{
    DPRINT((@"[PoCoSubView initWithFrame:{%f, %f, %f, %f}]\n", frameRect.origin.x, frameRect.origin.y, frameRect.size.width, frameRect.size.height));

    // super class ν
    self = [super initWithFrame:frameRect];

    // Ȥν
    if (self != nil) {
        self->zfactNum_ = 15;
        self->lastPoint_ = nil;

        // document controller 
        self->docCntl_ = [NSDocumentController sharedDocumentController];
        [self->docCntl_ retain];

        // ΰν
        [self setFrame:EMPTY_RECT];
        if ([NSApp mainWindow] == nil) {
            // 祦ɥʤж
            self->orgRect_ = EMPTY_RECT;
        } else {
            self->orgRect_ = [[[self->docCntl_ currentDocument] picture] bitmapRect];
            [self updateFrame:NO];

            // 濴ɽ
            [self centering];
            self->lastPoint_ = [[PoCoPoint alloc] initX:(int)(self->orgRect_.size.width / 2)
                                                  initY:(int)(self->orgRect_.size.height / 2)];
        }

        // observer Ͽ
        [self registObserver];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    lastPoint_ : ǽ PD (instance ѿ)
//    docCntl_   : document controller(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoSubView dealloc]\n"));

    // 񸻤β
    [self->lastPoint_ release];
    [self->docCntl_ release];
    self->lastPoint_ = nil;
    self->docCntl_ = nil;

    // observer Ͽ
    [[NSNotificationCenter defaultCenter] removeObserver:self];

    // super class β
    [super dealloc];

    return;
}


//
// ɽڤؤ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    orgRect_   : ɽμ¿ΰ(instance ѿ)
//    lastPoint_ : ǽ PD (instance ѿ)
//
-(void)changePicture:(NSNotification *)note
{
    PoCoPicture *picture = [[self->docCntl_ currentDocument] picture];

    if (picture != nil) {
        // view ΰ򹹿
        self->orgRect_ = [picture bitmapRect];
        [self updateFrame:YES];

        // 濴ɽ
        [self centering];
        [self->lastPoint_ release];
        self->lastPoint_ = [[PoCoPoint alloc] initX:(int)(self->orgRect_.size.width / 2)
                                              initY:(int)(self->orgRect_.size.height / 2)];
    }

    return;
}


//
// ѥåѹ
//
//  Call
//    note     : 
//    docCntl_ : document controller(instance ѿ)
//
//  Return
//    orgRect_   : ɽμ¿ΰ(instance ѿ)
//    lastPoint_ : ǽ PD (instance ѿ)
//
-(void)changePaletteElm:(NSNotification *)note
{
    PoCoPicture *picture = [[self->docCntl_ currentDocument] picture];

    if (picture != nil) {
        // view ΰ򹹿
        self->orgRect_ = [picture bitmapRect];
        [self updateFrame:YES];
    }

    return;
}


//
// 쥤䡼¤ѹ
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)editLayer:(NSNotification *)note
{
    // 
    [self setNeedsDisplay:YES];

    return;
}


//
// ѥå°
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)changePaletteAttr:(NSNotification *)note
{
    int i;

    if ([note object] == nil) {
        [self setNeedsDisplay:YES];
    } else {
        i = [[note object] intValue];
        if (i & 0x00040000) {
            [self setNeedsDisplay:YES];
        }
    }

    return;
}


//
// Խ()
//
//  Call
//    note : 
//
//  Return
//    None
//
-(void)editPicture:(NSNotification *)note
{
    PoCoEditPictureNotification *obj;

    obj = [note object];
    if (obj != nil) {
        // μ¹
        [self setNeedsDisplayInRect:[self toDispRect:[obj rect]]];
    } else {
        // 
        [self setNeedsDisplay:YES];
    }

    return;
}


//
// Խ()
//  祦ɥ mouseDown/mouseDragged/mouseUp ȯ
//  ɽ֤ƱŪ
//
//  Call
//    note       : 
//    lastPoint_ : ǽ PD (instance ѿ)
//
//  Return
//    lastPoint_ : ǽ PD (instance ѿ)
//
-(void)execDrawing:(NSNotification *)note
{
    NSPoint p1;
    NSPoint p2;
    NSRect vr;
    PoCoPoint *dp;
    PoCoRect *dr;
    const int zfact = ZOOM_FACTOR[self->zfactNum_];

    dp = [[(PoCoAppController *)([NSApp delegate]) editInfo] pdPos];
    vr = [self visibleRect];
    dr = [self calcSrcRect:vr
                     zfact:zfact];

    // ɽ֤򻻽
    if (zfact == 1000) {
        // 
        p1.x = (float)([dp x]);
        p1.y = (float)([dp y]);
    } else {
        // /̾(üФʤΤǶ)
        p1.x = (float)((([dp x] * zfact) / 1000));
        p1.y = (float)((([dp y] * zfact) / 1000));
    }

    // ֤򻻽
    p2 = vr.origin;
    if ((p1.x < vr.origin.x) ||
        (p1.x > (vr.origin.x + vr.size.width))) {
        p2.x = (p1.x - (float)(((([self->lastPoint_ x] - [dr left]) * zfact) / 1000)));
    }
    if ((p1.y < vr.origin.y) ||
        (p1.y > (vr.origin.y + vr.size.height))) {
        p2.y = (p1.y - (float)(((([self->lastPoint_ y] - [dr top]) * zfact) / 1000)));
    }

    // ¹
    if ((p2.x != vr.origin.x) || (p2.y != vr.origin.y)) {
        [self scrollPoint:p2];
    }

    // ǽ PD ֤򹹿(˻Фɽ֤ PD ֤˸ΩƤ)
    [self->lastPoint_ release];
    self->lastPoint_ = [self calcSrcPoint:p1
                                    zfact:zfact];

    [dr release];
    return;
}


//
// View ˳ΨȿǤΰ
//
//  Call
//    sendRedraw : YES : ׵ȯԤ
//                 NO  : ׵ȯԤʤ
//    zfactNum_  : ɽΨֹ(instance ѿ)
//    orgRect_   : ɽμ¿ΰ(instance ѿ)
//
//  Return
//    None
//
-(void)updateFrame:(BOOL)sendRedraw
{
    NSRect r;

    r.origin.x = 0;
    r.origin.y = 0;
    r.size.width = ((self->orgRect_.size.width * ZOOM_FACTOR[self->zfactNum_]) / 1000);
    r.size.height = ((self->orgRect_.size.height * ZOOM_FACTOR[self->zfactNum_]) / 1000);
    [self setFrame:r];

    // ׵ȯ
    if (sendRedraw) {
        [self setNeedsDisplay:YES];
    }

    return;
}


//
// 
//
//  Call
//    rect      : ΰ(api )
//    zfactNum_ : ɽΨֹ(instance ѿ)
//    docCntl_  : document controller(instance ѿ)
//
//  Return
//    None
//
-(void)drawRect:(NSRect)rect
{
    NSRect dr;                          // ɽΰ
    PoCoRect *sr;                       // ΰ
    NSBitmapImageRep *img;              // ɽ
    const PoCoPicture *picture = [[self->docCntl_ currentDocument] picture];
    const int zfact = ZOOM_FACTOR[self->zfactNum_];

    // ɽΰ/ΰ򻻽
    sr = [self calcSrcRect:rect
                     zfact:zfact];
    dr = rect;
    if (zfact == 1000) {
        // 
        [[NSGraphicsContext currentContext] setImageInterpolation:NSImageInterpolationNone];
        img = [picture getMainImage:sr
                          withScale:1000
                     withSupplement:nil];
        [img drawAtPoint:dr.origin];
    } else if (zfact > 1000) {
        // 
        dr.origin.x = (([sr left] * zfact) / 1000);
        dr.origin.y = (([sr  top] * zfact) / 1000);
        [[NSGraphicsContext currentContext] setImageInterpolation:NSImageInterpolationNone];
        img = [picture getMainImage:sr
                          withScale:zfact
                     withSupplement:nil];
        [img drawAtPoint:dr.origin];
    } else {
        // ̾
        [[NSGraphicsContext currentContext] setImageInterpolation:NSImageInterpolationHigh];
        img = [picture getMainImage:sr
                          withScale:1000
                     withSupplement:nil];
        [img drawInRect:rect];
    }
    [sr release];

    // ɽ release
    [img release];

    return;
}


//
// ɸϤȿž
//
//  Call
//    None
//
//  Return
//    function : YES
//
-(BOOL)isFlipped
{
    return YES;                         //  YES
}


// ----------------------------------------- instance - public - ٥Ƚ
//
// ܥ󥤥٥Ȥμ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    function : 
//
-(BOOL)acceptsFirstMouse:(NSEvent *)evt
{
    // Ƚ̵
    ;

    return YES;
}


//
// ܥ
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    lastPoint_ : ǽ PD (instance ѿ)
//
-(void)mouseDown:(NSEvent *)evt
{
    // ǽ PD ֤򹹿
    [self->lastPoint_ release];
    self->lastPoint_ = [self calcSrcPoint:[PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]]
                                    zfact:ZOOM_FACTOR[self->zfactNum_]];

    // ֥륯åξΤȡ
    if ([evt clickCount] > 1) {
        [[NSNotificationCenter defaultCenter] postNotificationName:PoCoDClickOnSubView
                                                            object:self->lastPoint_];
    }

    return;
}


//
// ɥå
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    lastPoint_ : ǽ PD (instance ѿ)
//
-(void)mouseDragged:(NSEvent *)evt
{
    NSRect r = [self visibleRect];
    const float dx = [evt deltaX];
    const float dy = [evt deltaY];

#if 0
    // Ƥư
    if ((dx != 0.0) || (dy != 0.0)) {
        r.origin.x -= dx;
        r.origin.y -= dy;
        [self scrollRectToVisible:r];
    }
#else   // 0
    // ʿ
    if (dx != 0.0) {
        r.origin.x -= dx;
        [self scrollRectToVisible:r];
    }

    // ľ
    if (dy != 0.0) {
        r.origin.y -= dy;
        [self scrollRectToVisible:r];
    }
#endif  // 0

    // ǽ PD ֤򹹿
    [self->lastPoint_ release];
    self->lastPoint_ = [self calcSrcPoint:[PoCoPoint corrNSPoint:[self convertPoint:[evt locationInWindow] fromView:nil]]
                                    zfact:ZOOM_FACTOR[self->zfactNum_]];

    return;
}


//
// wheel ž
//
//  Call
//    evt       : ȯ٥(api ѿ)
//    slider_   : Ψ slider(outlet)
//    zfactNum_ : ɽΨֹ(instance ѿ)
//
//  Return
//    None
//      
-(void)scrollWheel:(NSEvent *)evt
{
    int num;

    if ([evt modifierFlags] & NSControlKeyMask) {
        // ɽΨѹ   
        if (((int)([evt deltaX]) < 0) || ((int)([evt deltaY]) < 0)) {
            num = (self->zfactNum_ - 1);
        } else {
            num = (self->zfactNum_ + 1);
        }
        
        // ɽȿ
        if ((num >= (int)([self->slider_ minValue])) &&
            (num <= (int)([self->slider_ maxValue]))) {
            [self->slider_ setFloatValue:(float)(num)];
            [self changeZoom:num];
        }
    } else {
        // ̾ wheel ž
        [super scrollWheel:evt];
    }
            
    return; 
}


//
// magnify 
//
//  Call
//    evt       : ȯ٥(api ѿ)
//    slider_   : Ψ slider(outlet)
//    zfactNum_ : ɽΨֹ(instance ѿ)
//
//  Return
//    None
//
-(void)magnifyWithEvent:(NSEvent *)evt
{
    int num = self->zfactNum_;

    // ɽΨѹ   
    if ([evt magnification] < -0.02) {
        (num)--;
    } else if ([evt magnification] >= 0.02) {
        (num)++;
    }
        
    // ɽȿ
    if ((num != self->zfactNum_) &&
        (num >= (int)([self->slider_ minValue])) &&
        (num <= (int)([self->slider_ maxValue]))) {
        [self->slider_ setFloatValue:(float)(num)];
        [self changeZoom:num];
    }

    return; 
}


// -------------------------------------------- instance - public - IBAction 
//
// Ψ slider δ
//
//  Call
//    sender : Ƥ slider(api )
//
//  Return
//    None
//
-(IBAction)zoomFactor:(id)sender
{
    [self changeZoom:(int)(floor([sender floatValue]))];

    return;
}

@end
