//
//	Pelistina on Cocoa - PoCo -
//	ȥɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoSubViewWindow.h"

#import <Carbon/Carbon.h>

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"

// ============================================================================
@implementation PoCoSubViewWindow

// ---------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function : 
//
-(id)init
{
    // super class ν
    self = [super initWithWindowNibName:@"PoCoSubViewWindow"];

    // Ȥν
    if (self != nil) {
        // ¸
        [self setWindowFrameAutosaveName:@"SubViewWindowPos"];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    None
//
-(void)dealloc
{
    // super class β
    [super dealloc];

    return;
}


//
// ɥɤ߹ޤ줿
//
//  Call
//    scroller_ : scroller(outlet)
//
//  Return
//    None
//
-(void)windowDidLoad
{
    // scrollbar ɽˡ
    switch ([[(PoCoAppController *)([NSApp delegate]) editInfo] showScrollerView]) {
        default:
        case PoCoScrollerType_default:
            // OS ˰¸
            ;
            break;
        case PoCoScrollerType_always:
            // 
            [self->scroller_ setScrollerStyle:NSScrollerStyleLegacy];
            break;
        case PoCoScrollerType_overlay:
            // Ŭ
            [self->scroller_ setScrollerStyle:NSScrollerStyleOverlay];
            break;
    }

    return;
}


//
// ɥĤ(delegate method)
//
//  Call
//    note : (api ѿ)
//
//  Return
//    None
//
-(void)windowWillClose:(NSNotification *)note
{
    [(PoCoAppController *)([NSApp delegate]) closedSubViewWindow];

    return;
}


//
// äΰϤ
//
//  Call
//    sender  : ɥ(api ѿ)
//  
//  Return
//    function : ä
//
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] undoManager];
}


// ----------------------------------------- instance - public - ٥Ȥμ
//
// 
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ڡ٥(keyDown)
    if ([evt keyCode] == kVK_Space) {
        if (!([evt isARepeat])) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoSpaceKeyEvent
                              object:[NSNumber numberWithBool:YES]];
        }
    } else {
        // super class ز
        [super keyDown:evt];
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ڡ٥(keyUp)
    if ([evt keyCode] == kVK_Space) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoSpaceKeyEvent
                          object:[NSNumber numberWithBool:NO]];
    } else {
        // super class ز
        [super keyUp:evt];
    }

    return;
}

@end
