//
//	Pelistina on Cocoa - PoCo -
//	ġСɥ
//
//	Copyright (C) 2005-2018 KAENRYUU Koutoku.
//

#import "PoCoToolbarWindow.h"

#import <Carbon/Carbon.h>

#import "PoCoAppController.h"
#import "PoCoEditInfo.h"

// ============================================================================
@implementation PoCoToolbarWindow

// --------------------------------------------------------- instance - public
//
// initialize
//
//  Call
//    None
//
//  Return
//    function        : 
//    info_           : Խ(instance ѿ)
//    continueImage_  : Ϣ³(instance ѿ)
//    discreteImage_  : Ϣ³(instance ѿ)
//    handleImage_    : ϥɥ뤢(instance ѿ)
//    nohandleImage_  : ϥɥʤ(instance ѿ)
//    selectImage_    : (instance ѿ)
//    anyselectImage_ : Ǥΰ(instance ѿ)
//
-(id)init
{
    DPRINT((@"[PoCoToolbarWindow init]\n"));

    // super class 
    self = [super initWithWindowNibName:@"PoCoToolbarWindow"];

    // Ȥ
    if (self != nil) {
        self->continueImage_ = nil;
        self->discreteImage_ = nil;
        self->handleImage_ = nil;
        self->nohandleImage_ = nil;
        self->selectImage_ = nil;
        self->anyselectImage_ = nil;

        // Խμ
        self->info_ = [(PoCoAppController *)([NSApp delegate]) editInfo];
        [self->info_ retain];

        // ¸
        [self setWindowFrameAutosaveName:@"ToolbarWindowPos"];
    }

    return self;
}


//
// deallocate
//
//  Call
//    None
//
//  Return
//    info_           : Խ(instance ѿ)
//    continueImage_  : Ϣ³(instance ѿ)
//    discreteImage_  : Ϣ³(instance ѿ)
//    handleImage_    : ϥɥ뤢(instance ѿ)
//    nohandleImage_  : ϥɥʤ(instance ѿ)
//    selectImage_    : (instance ѿ)
//    anyselectImage_ : Ǥΰ(instance ѿ)
//
-(void)dealloc
{
    DPRINT((@"[PoCoToolbarWindow dealloc]\n"));

    // 񸻤β
    [self->info_ release];
    [self->continueImage_ release];
    [self->discreteImage_ release];
    [self->handleImage_ release];
    [self->nohandleImage_ release];
    [self->selectImage_ release];
    [self->anyselectImage_ release];
    self->info_ = nil;
    self->continueImage_ = nil;
    self->discreteImage_ = nil;
    self->handleImage_ = nil;
    self->nohandleImage_ = nil;
    self->selectImage_ = nil;
    self->anyselectImage_ = nil;

    // super class β
    [super dealloc];

    return;
}


//
// nib ɤ߹ޤ줿
//
//  Call
//    freeLine_            : ͳ(outlet)
//    line_                : ľ(outlet)
//    box_                 : (outlet)
//    ellipse_             : /ʱ(outlet)
//    parallelogram_       : ʿԻշ(outlet)
//    boxFill_             : ɤĤ֤(outlet)
//    ellipseFill_         : ɤĤ֤/ʱ(outlet)
//    parallelogramFill_   : ɤĤ֤ʿԻշ(outlet)
//    paint_               : ɤĤ֤(outlet)
//    propotionalFreeLine_ : ɮ㼫ͳ(outlet)
//    selection_           : (outlet)
//    drogMove_            : ꤺ(outlet)
//    normal_              : ̾(outlet)
//    atomizer_            : ̸᤭(outlet)
//    random_              : Ȼ(outlet)
//    density_             : ǻ(outlet)
//    gradation_           : ǡ(outlet)
//    uniformedDensity_    : ñǻ(outlet)
//    waterDrop_           : ܤ(outlet)
//    pointHold_           : (outlet)
//    pointMove_           : ư(outlet)
//    identicalShape_      : (outlet)
//    sizeRelation_        : ɮ()(outlet)
//    sizeHold_            : ɮ()(outlet)
//    sizeWithPattern_     : ѥ()(outlet)
//    densityRelation_     : ɮ(ǻ)(outlet)
//    densityHold_         : ɮ(ǻ)(outlet)
//    densityWithPattern_  : ѥ(ǻ)(outlet)
//    skipAlways_          : ˰ư(outlet)
//    skipBinary_          : ʤ(outlet)
//    skipHold_            : ݻ(outlet)
//    continueImage_       : Ϣ³(instance ѿ)
//    discreteImage_       : Ϣ³(instance ѿ)
//    handleImage_         : ϥɥ뤢(instance ѿ)
//    nohandleImage_       : ϥɥʤ(instance ѿ)
//    selectImage_         : (instance ѿ)
//    anyselectImage_      : Ǥΰ(instance ѿ)
//
//  Return
//    drawMode_[]     : 赡ǽϥѡķ(instance ѿ)
//    penStyle_[]     : ڥϥѡķ(instance ѿ)
//    pointMode_[]    : ϥѡķ(instance ѿ)
//    penSizeProp_[]  : ϥѡķ(instance ѿ)
//    densityProp_[]  : ǻٻϥѡķ(instance ѿ)
//    atomizerSkip_[] : ̸᤭ưϥѡķ(instance ѿ)
//
-(void)awakeFromNib
{
    DPRINT((@"[PoCoToolbarWindow awakeFromNib]\n"));

    // ȥݥ󥿤ʣ(retain Ϥʤ)
    self->drawMode_[PoCoDrawModeType_FreeLine] = self->freeLine_;
    self->drawMode_[PoCoDrawModeType_Line] = self->line_;
    self->drawMode_[PoCoDrawModeType_Box] = self->box_;
    self->drawMode_[PoCoDrawModeType_Ellipse] = self->ellipse_;
    self->drawMode_[PoCoDrawModeType_Parallelogram] = self->parallelogram_;
    self->drawMode_[PoCoDrawModeType_BoxFill] = self->boxFill_;
    self->drawMode_[PoCoDrawModeType_EllipseFill] = self->ellipseFill_;
    self->drawMode_[PoCoDrawModeType_ParallelogramFill] = self->parallelogramFill_;
    self->drawMode_[PoCoDrawModeType_Paint] = self->paint_;
    self->drawMode_[PoCoDrawModeType_ProportionalFreeLine] = self->propotionalFreeLine_;
    self->drawMode_[PoCoDrawModeType_Selection] = self->selection_;
    self->drawMode_[PoCoDrawModeType_DragMove] = self->drogMove_;

    self->pointMode_[PoCoPointModeType_PointHold] = self->pointHold_;
    self->pointMode_[PoCoPointModeType_PointMove] = self->pointMove_;
    self->pointMode_[PoCoPointModeType_IdenticalShape] = self->identicalShape_;

    self->penStyle_[PoCoPenStyleType_Normal] = self->normal_;
    self->penStyle_[PoCoPenStyleType_Atomizer] = self->atomizer_;
    self->penStyle_[PoCoPenStyleType_Random] = self->random_;
    self->penStyle_[PoCoPenStyleType_Density] = self->density_;
    self->penStyle_[PoCoPenStyleType_Gradation] = self->gradation_;
    self->penStyle_[PoCoPenStyleType_UniformedDensity] = self->uniformedDensity_;
    self->penStyle_[PoCoPenStyleType_WaterDrop] = self->waterDrop_;
    self->penSizeProp_[PoCoProportionalType_Relation] = self->sizeRelation_;
    self->penSizeProp_[PoCoProportionalType_Hold] = self->sizeHold_;
    self->penSizeProp_[PoCoProportionalType_Pattern] = self->sizeWithPattern_;
    self->densityProp_[PoCoProportionalType_Relation] = self->densityRelation_;
    self->densityProp_[PoCoProportionalType_Hold] = self->densityHold_;
    self->densityProp_[PoCoProportionalType_Pattern] = self->densityWithPattern_;
    self->atomizerSkip_[PoCoAtomizerSkipType_Always] = self->skipAlways_;
    self->atomizerSkip_[PoCoAtomizerSkipType_Binary] = self->skipBinary_;
    self->atomizerSkip_[PoCoAtomizerSkipType_Pattern] = self->skipHold_;

    // 
    self->continueImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"continue" ofType:@"tiff"]];
    self->discreteImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"discrete" ofType:@"tiff"]];
    self->handleImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"handle" ofType:@"tiff"]];
    self->nohandleImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"nohandle" ofType:@"tiff"]];
    self->selectImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"select" ofType:@"tiff"]];
    self->anyselectImage_ = [[NSImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"anyselect" ofType:@"tiff"]];

    return;
}


//
// ɥɤ߹ޤ줿
//
//  Call
//    selection_      : (outlet)
//    continuation_   : Ϣ³(outlet)
//    flip_           : ǻȿž(outlet)
//    handle_         : ϥɥ̵ͭ(outlet)
//    normalTone_     : ̾(outlet)
//    halfTone_       : Ⱦ(outlet)
//    info_           : Խ(instance ѿ)
//    drawMode_[]     : 赡ǽϥѡķ(instance ѿ)
//    penStyle_[]     : ڥϥѡķ(instance ѿ)
//    pointMode_[]    : ϥѡķ(instance ѿ)
//    penSizeProp_[]  : ϥѡķ(instance ѿ)
//    densityProp_[]  : ǻٻϥѡķ(instance ѿ)
//    atomizerSkip_[] : ̸᤭ưϥѡķ(instance ѿ)
//    continueImage_  : Ϣ³(instance ѿ)
//    discreteImage_  : Ϣ³(instance ѿ)
//    handleImage_    : ϥɥ뤢(instance ѿ)
//    nohandleImage_  : ϥɥʤ(instance ѿ)
//    selectImage_    : (instance ѿ)
//    anyselectImage_ : Ǥΰ(instance ѿ)
//
//  Return
//    None
//
-(void)windowDidLoad
{
    unsigned int l;
    unsigned int sel;

    DPRINT((@"[PoCoToolbarWindow windowDidLoad]\n"));

    // ԽǽϥѡĤξֽ
    sel = (unsigned int)([self->info_ drawModeType]);
    for (l = 0; l < PoCoDrawModeType_MAX; (l)++) {
        [self->drawMode_[l] setIntValue:((sel == l) ? 1 : 0)];
    }

    // ڥϥѡĤξֽ
    sel = (unsigned int)([self->info_ penStyleType]);
    for (l = 0; l < PoCoPenStyleType_MAX; (l)++) {
        [self->penStyle_[l] setIntValue:((sel == l) ? 1 : 0)];
    }

    // Ϣ³ѡĤξֽ
    if ([self->info_ continuationType]) {
        [self->continuation_ setIntValue:1];
        [self->continuation_ setImage:self->continueImage_];
        [self->selection_ setImage:self->anyselectImage_];
    } else {
        [self->continuation_ setIntValue:0];
        [self->continuation_ setImage:self->discreteImage_];
        [self->selection_ setImage:self->selectImage_];
    }

    // ǻȿžѡĤξֽ
    [self->flip_ setIntValue:([self->info_ flipType] ? 1 : 0)];

    // ϥɥ̵ͭѡĤξֽ
    if ([self->info_ useHandle]) {
        [self->handle_ setIntValue:1];
        [self->handle_ setImage:self->handleImage_];
    } else {
        [self->handle_ setIntValue:0];
        [self->handle_ setImage:self->nohandleImage_];
    }

    // ϥѡĤξֽ
    sel = (unsigned int)([self->info_ pointModeType]);
    for (l = 0; l < PoCoPointModeType_MAX; (l)++) {
        [self->pointMode_[l] setIntValue:((sel == l) ? 1 : 0)];
    }

    // ϥѡĤξֽ
    sel = (unsigned int)([self->info_ sizePropType]);
    for (l = 0; l < PoCoProportionalType_MAX; (l)++) {
        [self->penSizeProp_[l] setIntValue:((sel == l) ? 1 : 0)];
    }

    // ǻٻϥѡĤξֽ
    sel = (unsigned int)([self->info_ densityPropType]);
    for (l = 0; l < PoCoProportionalType_MAX; (l)++) {
        [self->densityProp_[l] setIntValue:((sel == l) ? 1 : 0)];
    }

    // ̸᤭ưϥѡĤξֽ
    sel = (unsigned int)([self->info_ atomizerSkip]);
    for (l = 0; l < PoCoAtomizerSkipType_MAX; (l)++) {
        [self->atomizerSkip_[l] setIntValue:((sel == l) ? 1 : 0)];
    }

    // ̸᤭ưϥѡĤξֽ
    [self->normalTone_ setIntValue:(([self->info_ atomizerType]) ? 0 : 1)];
    [self->halfTone_ setIntValue:(([self->info_ atomizerType]) ? 1 : 0)];

    return;
}


//
// ɥĤ(delegate method)
//
//  Call
//    note : (api ѿ)
//
//  Return
//    None
//
-(void)windowWillClose:(NSNotification *)note
{
    [(PoCoAppController *)([NSApp delegate]) closedToolbarWindow];

    return;
}


//
// äΰϤ
//
//  Call
//    sender : ɥ(api ѿ)
//  
//  Return
//    function : ä
//
-(NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)sender
{
    return [[[NSDocumentController sharedDocumentController] currentDocument] undoManager];
}


//
// 赡ǽڤؤ(ֹ)
//
//  Call
//    type        : ֹ(Խǽֹ)
//    drawMode_[] : 赡ǽϥѡķ(instance ѿ)
//
//  Return
//    None
//
-(void)setDrawModeAtType:(PoCoDrawModeType)type
{
    // ϰֹʤڤؤ
    if (type < PoCoDrawModeType_MAX) {
        [self->drawMode_[type] setIntValue:1];
        [self drawMode:self->drawMode_[type]];
    }

    return;
}


// -------------------------------------------- instance - public - IBAction 
//
// 赡ǽ
//  ͳľȡ/ʱߡʿԻշɤĤ֤ȡ
//  ɤĤ֤/ʱߡɤĤ֤ʿԻշɤĤ֤
//  ɮ㼫ͳ򡢤ꤺ
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    info_       : Խ(instance ѿ)
//    drawMode_[] : 赡ǽϥѡķ(instance ѿ)
//
-(IBAction)drawMode:(id)sender
{
    const unsigned int sel = (int)([sender tag]);
    const unsigned int old = (unsigned int)([self->info_ drawModeType]);

    if (old != sel) { 
        [self->drawMode_[old] setIntValue:0];
        [self->drawMode_[sel] setIntValue:1];
        [self->info_ setDrawModeType:(PoCoDrawModeType)(sel)];

        // ڤؤ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangeDrawTool
                          object:nil];
    } else {
        [self->drawMode_[old] setIntValue:1];
    }

    return;
}


//
// ڥ
//  ̾̸᤭ȻǻٳȻǡñǻ١ܤ
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    info_       : Խ(instance ѿ)
//    penStyle_[] : ڥϥѡķ(instance ѿ)
//
-(IBAction)penStyle:(id)sender
{
    const unsigned int sel = (unsigned int)([sender tag]);
    const unsigned int old = (unsigned int)([self->info_ penStyleType]);

    if (old != sel) { 
        [self->penStyle_[old] setIntValue:0];
        [self->penStyle_[sel] setIntValue:1];
        [self->info_ setPenStyleType:(PoCoPenStyleType)(sel)];

        // ڤؤ
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoChangeDrawTool
                          object:nil];
    } else {
        [self->penStyle_[old] setIntValue:1];
    }

    return;
}


//
// Ϣ³
//  Ϣ³(°)
//
//  Call
//    sender          : о
//    info_           : Խ(instance ѿ)
//    continueImage_  : Ϣ³(instance ѿ)
//    discreteImage_  : Ϣ³(instance ѿ)
//    selectImage_    : (instance ѿ)
//    anyselectImage_ : Ǥΰ(instance ѿ)
//
//  Return
//    selection_    : (outlet)
//    continuation_ : Ϣ³(outlet)
//    info_         : Խ(instance ѿ)
//
-(IBAction)continuation:(id)sender
{
    // ȿž
    [self->info_ setContinuationType:(([self->info_ continuationType]) ? NO : YES)];

    // ɽȿ
    if ([self->info_ continuationType]) {
        [self->continuation_ setIntValue:1];
        [self->continuation_ setImage:self->continueImage_];
        [self->selection_ setImage:self->anyselectImage_];
    } else {
        [self->continuation_ setIntValue:0];
        [self->continuation_ setImage:self->discreteImage_];
        [self->selection_ setImage:self->selectImage_];
    }

#if 0   // DrawTool ڤؤȤϤʤΤΤʤ
    // ڤؤ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoChangeDrawTool
                      object:nil];
#endif  // 0

    return;
}


//
// ȿž
//  ǻȿž(°)
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    flip_ : ȿž(outlet)
//    info_ : Խ(instance ѿ)
//
-(IBAction)flip:(id)sender
{
    // ȿž
    [self->info_ setFlipType:(([self->info_ flipType]) ? NO : YES)];

    // ɽȿ
    [self->flip_ setIntValue:([self->info_ flipType] ? 1 : 0)];

    return;
}


//
// ϥɥ̵ͭ
//
//  Call
//    sender         : о
//    info_          : Խ(instance ѿ)
//    handleImage_   : ϥɥ뤢(instance ѿ)
//    nohandleImage_ : ϥɥʤ(instance ѿ)
//
//  Return
//    handle_ : ϥɥ̵ͭ(outlet)
//    info_   : Խ(instance ѿ)
//
-(IBAction)handle:(id)sender
{
    // ɥ饤õ
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    // ȿž
    [self->info_ setUseHandle:(([self->info_ useHandle]) ? NO : YES)];

    // ɽȿ
    if ([self->info_ useHandle]) {
        [self->handle_ setIntValue:1];
        [self->handle_ setImage:self->handleImage_];
    } else {
        [self->handle_ setIntValue:0];
        [self->handle_ setImage:self->nohandleImage_];
    }

    // ɥ饤
    [[NSNotificationCenter defaultCenter]
        postNotificationName:PoCoRedrawGuideLine
                      object:nil];

    return;
}


//
// 
//  ꡢư
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    info_        : Խ(instance ѿ)
//    pointMode_[] : ϥѡķ(instance ѿ)
//
//
-(IBAction)pointMode:(id)sender
{
    const unsigned int sel = (unsigned int)([sender tag]);
    const unsigned int old = (unsigned int)([self->info_ pointModeType]);

    if (old != sel) { 
        [self->pointMode_[old] setIntValue:0];
        [self->pointMode_[sel] setIntValue:1];
        [self->info_ setPointModeType:(PoCoPointModeType)(sel)];
    } else {
        [self->pointMode_[old] setIntValue:1];
    }

    return;
}


//
// ɮ()
//  ɮ㡢ɮꡢѥ
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    info_      : Խ(instance ѿ)
//    penSizeProp_[] : ϥѡķ(instance ѿ)
//
-(IBAction)penSize:(id)sender
{
    const unsigned int sel = (unsigned int)([sender tag]);
    const unsigned int old = (unsigned int)([self->info_ sizePropType]);

    if (old != sel) { 
        [self->penSizeProp_[old] setIntValue:0];
        [self->penSizeProp_[sel] setIntValue:1];
        [self->info_ setSizePropType:(PoCoProportionalType)(sel)];
    } else {
        [self->penSizeProp_[old] setIntValue:1];
    }

    return;
}


//
// ɮ(ǻ)
//  ɮ㡢ɮꡢѥ
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    info_          : Խ(instance ѿ)
//    densityProp_[] : ǻٻϥѡķ(instance ѿ)
//
-(IBAction)density:(id)sender
{
    const unsigned int sel = (unsigned int)([sender tag]);
    const unsigned int old = (unsigned int)([self->info_ densityPropType]);

    if (old != sel) { 
        [self->densityProp_[old] setIntValue:0];
        [self->densityProp_[sel] setIntValue:1];
        [self->info_ setDensityPropType:(PoCoProportionalType)(sel)];
    } else {
        [self->densityProp_[old] setIntValue:1];
    }

    return;
}


//
// ̸̾᤭
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    None
//    normalTone_ : ̾(outlet)
//    halfTone_   : Ⱦ(outlet)
//    info_       : Խ(instance ѿ)
//
-(IBAction)normalTone:(id)sender
{
    // 
    [self->info_ setAtomizerType:NO];

    // ɽȿ
    [self->normalTone_ setIntValue:YES];
    [self->halfTone_ setIntValue:NO];

    return;
}


//
// Ⱦ̸᤭
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    halfTone_ : Ⱦ(outlet)
//    info_     : Խ(instance ѿ)
//
-(IBAction)halfTone:(id)sender
{
    // 
    [self->info_ setAtomizerType:YES];

    // ɽȿ
    [self->normalTone_ setIntValue:NO];
    [self->halfTone_ setIntValue:YES];

    return;
}


//
// ̸᤭ư
//  ˡ͡
//
//  Call
//    sender : о
//    info_  : Խ(instance ѿ)
//
//  Return
//    info_           : Խ(instance ѿ)
//    atomizerSkip_[] : ̸᤭ưϥѡķ(instance ѿ)
//
-(IBAction)atomizerSkip:(id)sender
{
    const unsigned int sel = (unsigned int)([sender tag]);
    const unsigned int old = (unsigned int)([self->info_ atomizerSkip]);

    if (old != sel) { 
        [self->atomizerSkip_[old] setIntValue:0];
        [self->atomizerSkip_[sel] setIntValue:1];
        [self->info_ setAtomizerSkip:(PoCoAtomizerSkipType)(sel)];
    } else {
        [self->atomizerSkip_[old] setIntValue:1];
    }

    return;
}


// ----------------------------------------- instance - public - ٥Ȥμ
//
// 
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyDown:(NSEvent *)evt
{
    // ڡ٥(keyDown)
    if ([evt keyCode] == kVK_Space) {
        if (!([evt isARepeat])) {
            [[NSNotificationCenter defaultCenter]
                postNotificationName:PoCoSpaceKeyEvent
                              object:[NSNumber numberWithBool:YES]];
        }
    } else {
        // super class ز
        [super keyDown:evt];
    }

    return;
}


//
// ꡼
//
//  Call
//    evt : ȯ٥(api ѿ)
//
//  Return
//    None
//
-(void)keyUp:(NSEvent *)evt
{
    // ڡ٥(keyUp)
    if ([evt keyCode] == kVK_Space) {
        [[NSNotificationCenter defaultCenter]
            postNotificationName:PoCoSpaceKeyEvent
                          object:[NSNumber numberWithBool:NO]];
    } else {
        // super class ز
        [super keyUp:evt];
    }

    return;
}

@end
